
require "MainValue"
require "MainStatus"


local Application = class("Application", function()
    return cc.Scene:create();
end);

Application.APP_ENTER_BACKGROUND_EVENT = "APP_ENTER_BACKGROUND_EVENT"
Application.APP_ENTER_FOREGROUND_EVENT = "APP_ENTER_FOREGROUND_EVENT"

function Application:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize();
    self.origin = cc.Director:getInstance():getVisibleOrigin();
    self.schedulerID = nil;
    self.m_isRuning = true
    cclog("[Application]--ctor()!!!!!!");
    
end

function Application.create()
    local scene = Application.new();
    
    return scene;
end

function Application:init() 

    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
    local customListenerBg = cc.EventListenerCustom:create(Application.APP_ENTER_BACKGROUND_EVENT,
        handler(self, self.onEnterBackground))
    eventDispatcher:addEventListenerWithFixedPriority(customListenerBg, 1)
    local customListenerFg = cc.EventListenerCustom:create(Application.APP_ENTER_FOREGROUND_EVENT,
        handler(self, self.onEnterForeground))
    eventDispatcher:addEventListenerWithFixedPriority(customListenerFg, 1)
    
    MainValue:init();
    MainStatus:init();
    print("[Application] -- init()!!!!!!!!!!!!!!LUA!!!!!!!!!!!!!!!");
    
    self:addChild(MainValue.mxGameManager.layer);
    self:addChild(MainValue.mxUIManager.layer);
    self:addChild(MainValue.mxEffectManager.layer);
    self:addChild(MainValue.mxFTUEManager.layer);
    self:addChild(MainValue.mxSplashManager.layer);
    self:addChild(MainValue.mxLoadingManager.layer);
    self:addChild(MainValue.mxTipsManager.layer);
    self:addChild(MainValue.mxAlertManager.layer);
    print("[Application] -- init()!!!!!!!!!!!!!!LUA!!!!!!!!!!!!!!!");
    
--    MainStatus:onEnterMap();
    MainStatus:onEnterSplash(); 
end


function Application:onEnterBackground()
    if not self.m_isRuning then return end
    self.m_isRuning = false
    
    MainValue.mxUIManager:onEnterBackground();
    
    if MainValue.notifyManager ~= nil then MainValue.notifyManager:localNotify(); end
end

function Application:onEnterForeground()
    if self.m_isRuning then return end
    self.m_isRuning = true
    
    MainValue.mxUIManager:onEnterForeground();
    MainValue.platformManager:LNregisterNotify();
    MainValue.platformManager:LNcancelAllScheduled();
    if MainValue.dataManager.expandManager:getBgMusice()== false then
        MainValue.soundManager:stopMusic();
    end
    
end

return Application