----------------游戏总状态机----------------------------------
MainStatus = class("MainStatus");

function MainStatus:init()
    self.managers = 
        {
            MainValue.mxSplashManager,
            MainValue.mxGameManager,
            MainValue.mxUIManager,
            MainValue.mxEffectManager,
            MainValue.mxFTUEManager,
            MainValue.mxLoadingManager,
            MainValue.mxTipsManager,
            MainValue.mxAlertManager,
        };

end


--进入游戏开始界面
function MainStatus:onEnterSplash()
    print("onEnterSplash")
    for round, manager in ipairs(self.managers) do
        manager:onEnterSplash();
    end
end

--退出游戏开始界面
function MainStatus:onExitSplash()
    print("[MainStatus]--onExitSplash() --onExitSplash")
    for round, manager in ipairs(self.managers) do
        manager:onExitSplash();
    end
end 

--进入地图
function MainStatus:onEnterMap()
    
    print("[MainStatus]--onEnterMap() --onEnterMap")
--    判断外部加载是否已经加载完成，未完成加载，已完成直接刷新状态
   function loadComp()        
        for round, manager in ipairs(self.managers) do
            manager:onEnterMap();
        end
   end
   
    if not MainValue.OUT_LOAD_COMPLETE then
        MainValue.mxLoadingManager:loadRes(loadComp,true)
    else
        loadComp()
    end
    
end 

--退出地图
function MainStatus:onExitMap()
    print("[MainStatus]--onExitMap() --onExitMap")
    for round, manager in ipairs(self.managers) do
        manager:onExitMap();
    end
end

--进入游戏
function MainStatus:onEnterGame()
    print("[MainStatus]-- onEnterGame() --onEnterGame")
    for round, manager in ipairs(self.managers) do
        manager:onEnterGame();
    end
end
--onEnteredGame

--退出游戏
function MainStatus:onExitGame()
    print("[MainStatus]-- onExitGame() --onExitGame")
    for round, manager in ipairs(self.managers) do
        manager:onExitGame();
    end
end

--回退键功能 
function MainStatus:backPack()
    for round, manager in ipairs(self.managers) do
        if manager:backPack() == true then
            return;
        end;
    end
    
    if MainValue.mxGameManager ~= nil and MainValue.mxGameManager:getState() == 1 then
        if MainValue.mxGameManager:getCanClickGameUI() == false then
            return
        end
--        local inGameExitPopupClz = require("ui/inGame/InGameExitPanel")
--        local inGameExitPopup = inGameExitPopupClz.create();
--        inGameExitPopup:appear();
        
        local SettingPanelCls = require("ui.setting.SettingPanel");
        local settingPanel = SettingPanelCls.create(true);
        settingPanel:appearAlone();
    end


    
end