
require "game.GameValue"
--[[
mx前缀为固定内含Layer显示层管理器 一般不可添加
不带mx管理器为常规管理器
例如MapManger仍可添加但不可加mx前缀，其本身被加载至UIManger.layer上
]]--
MainValue = class("MainValue");

--------------------最高管理器集（层级）---------------------------


MainValue.mxGameManager = nil;
--ui layer
MainValue.mxUIManager = nil;
--Effect layer
MainValue.mxEffectManager = nil;
--ftue layer
MainValue.mxFTUEManager = nil;
--Splash->menu
MainValue.mxSplashManager = nil;
--loading layer
MainValue.mxLoadingManager = nil;
--tips layer
MainValue.mxTipsManager = nil;
--alert layer
MainValue.mxAlertManager = nil;

--------------------管理器集---------------------------

MainValue.dbManager = nil;
--@module src.DataManager
MainValue.dataManager = nil;
-- 通讯管理器
MainValue.httpManager = nil;
-- 动作管理器
MainValue.actionManager = nil;
-- config manager
MainValue.infosManager = nil;

MainValue.levelConfig = nil;
-- 屏幕大小
MainValue.winSize = nil;

--音乐音效
MainValue.soundManager = nil;

--平台相关管理器
MainValue.platformManager = nil;
MainValue.fbManager = nil;
MainValue.adsManager = nil;
MainValue.iapEnManager = nil;
--统计
MainValue.notifyManager = nil;

MainValue.statisticsManager = nil;
--OG
MainValue.statisticsManagerOG = nil;



MainValue.eventDispatcher = nil;

-------------------global value----------------------
-- 选择关卡
MainValue.SELECTED_LEVEL = nil;
--外部加载是否已经完成
MainValue.OUT_LOAD_COMPLETE = false;

function MainValue:init()
    self.winSize = cc.Director:getInstance():getWinSize();

	require("config.config")
    --require("config.dataConfig");
   -- DataConfig.init();
    
    require("font.FacFont");
    FacFont:init();
    
    local event = require("engine.event.EventDispatcher");
    self.eventDispatcher = event.create();
    
  
    local platform = require("platform.PlatformManager");
    self.platformManager = platform.create();
    
    
    local fb = require("platform.FBManager");
    self.fbManager = fb.create();
    
--    local ads = require("platform.AdsManager");
--    self.adsManager = ads.create();

    local notify = require("platform.NotifyManager");
    self.notifyManager = notify.create();
    
    require("statistics/StatisticsManager");
    --统计  请在platform之后
    self.statisticsManager = StatisticsManager:new();
    
    require("statistics/StatisticsManagerOG");
    --OG
    self.statisticsManagerOG = StatisticsManagerOG:new();

    --数据管理器--
    local db = require("data.DBManager")
    self.dbManager = db.create();
    
    local http = require("engine.net.HttpManager")
    self.httpManager = http.create();
    
    local data = require("data.DataManager")
    self.dataManager = data.create();
    self.dataManager:init();
    
    local sound = require("sound.SoundManager")
    self.soundManager = sound.create();
    
    -- 广告系统初始化
    require("config.adConfig")
    advertising:init()
    
    --层级--
    local game = require("game.GameManager"); 
    self.mxGameManager = game.create();
    
    local ui = require("ui.UIManager");  
    self.mxUIManager = ui.create();
        
    local effect = require("effect.EffectManager");  
    self.mxEffectManager = effect.create();
    
    local ftue = require("ftue.FTUEManager");  
    self.mxFTUEManager = ftue.create();
    
    local splash = require("splash.SplashManager");  
    self.mxSplashManager = splash.create();
    
    local load = require("load.LoadingManager");  
    self.mxLoadingManager = load.create();
    
    local tips = require("tips.TipsManager")
    self.mxTipsManager = tips.create();
    
    local alert = require("alert.AlertManager");  
    self.mxAlertManager = alert.create();
    
    --其他功能管理器--
    local action =  require("engine.action.ActionManager");  
    self.actionManager = action.create();
    --2014-10-31
    local infos = require("data.InfosMananger");
    self.infosManager = infos.create();
    
    local lvConfig = require("lvConfig.LevelConfig");
    self.levelConfig = lvConfig.create();
    
    local iap = require("platform.IAPEnManager")
    self.iapEnManager = iap.create();
end


function MainValue:onWorldTimerRunHandler(spendTime)
    GameValue:onWorldTimerRunHandler(spendTime)
end;
