
local DataManager = class("DataManager");

--各数据管理器
DataManager.userManager = nil;
DataManager.levelManager = nil;
DataManager.blockManager = nil;
DataManager.expandManager = nil;
DataManager.friendManager = nil;
DataManager.goodsManager = nil;
DataManager.storeManager = nil;
DataManager.dailyManager = nil;
--DataManager.updateManager = nil;
DataManager.adManager = nil;
DataManager.taskManager = nil;

function DataManager:ctor()
    
    self.state = true;
    
    local temp_user = require("data.control.UserManager");
    self.userManager = temp_user.create();
    
    local temp_level = require("data.control.LevelManager");
    self.levelManager = temp_level.create();
    
    local temp_expand = require("data.control.ExpandManager");
    self.expandManager = temp_expand.create();
    
    local temp_goods = require("data.control.GoodsManager");
    self.goodsManager = temp_goods.create();
    
    local temp_friend = require("data.control.FriendManager");
    self.friendManager = temp_friend.create();
    
    local temp_store = require("data.control.StoreManager");
    self.storeManager = temp_store.create();
    
    local temp_daily = require("data.control.DailyManager");
    self.dailyManager = temp_daily.create();
    
--    local temp_update = require("data.update.UpdateManager");
--    self.updateManager = temp_update.create();
    
    local temp_ad = require("data.control.ADManager");
    self.adManager = temp_ad.create();
    
    local temp_task = require("data.control.TaskDataManager");
    self.taskManager = temp_task.create();
    
    self:reset();
end

function DataManager:init()
    if self.state 
    then 
        self.state = false; 
    else 
        return ;
    end
    
    MainValue.fbManager:FBinit();
    local loc_isPfLogin = MainValue.fbManager:FBisLogin();
    
    MainValue.fbManager:setIsLogin(loc_isPfLogin);
    
    if loc_isPfLogin 
    then 
        MainValue.fbManager:FBgetMe();
    else 
        MainValue.httpManager:login();
    end
    
    --MainValue.notifyManager:localNotify();
end

function DataManager:onLoginResult(result)
    if result == 1
    then
        MainValue.fbManager:FBgetMe();
        self.expandManager:setFirstLoginPlatform();
    end
end

function DataManager:onGetMeResult(meData)
    
    local loc_pid = meData["id"];
    local loc_old_pid = self.userManager:getPID();
    
    if loc_pid ~= nil and loc_pid ~= "" and loc_old_pid ~= "" and loc_old_pid ~= nil
    then
        if loc_pid ~= loc_old_pid then MainValue.dbManager:reset(); end
    end
    
    self.userManager:setPlatformInfo(meData);
    
    MainValue.fbManager:FBgetInviteFriend();
    MainValue.fbManager:FBgetFriends();
end

function DataManager:onGetFriendsResult(friendsData)
    self.friendManager:setPlatformFriendsInfo(friendsData);
    local acctok = MainValue.fbManager:FBgetToken();
    MainValue.httpManager:login(acctok);
end

function DataManager:onGetInfosResult(params)
    self.expandManager:synchronousData(params['udata']);
    self.levelManager:synchronousBox(params['boxData']);
    self.levelManager:synchronousLevel(params['lvData']);
    self.friendManager:synchronousInbox(params['inboxData']);
    self.friendManager:synchronousFriends(params['fdData']);
    self.dailyManager:setdaily(params['dailyData']);
    self.adManager:synchronousData(params['adData']);
end

--重置每日数据(非玩家数据)
function DataManager:reset()
    local baseDay = self.expandManager:getResetDay();
    local currentDay = os.date("%Y/%m/%d", os.time())

    baseDay = tostring(baseDay);
    currentDay = tostring(currentDay);

    if baseDay ~= currentDay
    then
        self.adManager:reset();
        self.friendManager:reset();
        self.expandManager:setResetDay(currentDay);
    end
end

function DataManager.create()
    local temp = DataManager.new()
    return temp
end

return DataManager;