local ADManager = class("ADManager");

ADManager.data = nil;

function ADManager:ctor()
    self.data = MainValue.dbManager.ad;
    
    self.ImageAD = "img";
    self.VideoAD = "video";
    
--    self:setFirstTime();
    
    --监听广告播放送奖励
    local function showADReward(rewards)
        if rewards ~= nil then
            local adRewardsPanelCls = require("ui/advertisement/ADRewardsPanel");
            local adRewardsPanel = adRewardsPanelCls.create(rewards);
            adRewardsPanel:appearAlone();

            self:setPopCount(self.VideoAD);
        end
    end
    MainValue.eventDispatcher:addEventListener("AD_GOT_REWARD", showADReward);
end

--弹出广告
function ADManager:popAdvertisement(showPos)
--    self:setIntervalTime();

    local state = advertising:showForPlacement(showPos)
    
    if state == "NOT_AVAILIABLE_FOR_LEVEL" then
        local adLoadingPanelCls = require("ui/advertisement/ADLoadingPanel");
        local adLoadingPanel = adLoadingPanelCls.create();
        adLoadingPanel:appearAlone();
    end
end

----获取游戏初始化多少次
--function ADManager:getSession()
--    local session = self.data:getSession();
--    if session == nil then
--        session = 0;
--    end;
--    return session;
--end
--
--function ADManager:setSession()
--    local session = self.data:getSession();
--    
--    self.data:setSession(session);
--end

----获取上次弹出广告的时间
--function ADManager:getIntervalTime()
--    local current_time = os.time();
--    local base_time = self.data:getIntervalTime();
--    
--    if base_time ~= nil  
--    then
--        local interval_time = current_time - base_time;
--        return interval_time;
--    else
--        return 0;
--    end
--end

--function ADManager:setIntervalTime()
--    local time = os.time();
--
--    self.data:setIntervalTime(time);
--end

--获取广告已经弹出多少次
function ADManager:getPopCount(type)
    local count = nil;
    
    if type == self.ImageAD then
        count = self.data:getImageAdPopCount();
    elseif type == self.VideoAD then
        count = self.data:getVideoADPopCount();
    end
    
    if count == nil
    then
        return 0;
    else
        return tonumber(count);
    end
end

function ADManager:setPopCount(type)
    local popcount = self:getPopCount(type);
    
    if popcount == nil 
    then
        popcount = 1;
    else
        popcount = tonumber(popcount);
        popcount = popcount + 1;
    end
    
    if type == self.ImageAD then
        self.data:setImageAdPopCount(popcount);
    elseif type == self.VideoAD then
        self.data:setVideoADPopCount(popcount);
    end
    
    if popcount >= advertising.maxShowCount then
        MainValue.mxUIManager.mapUI:removeADIcon();
    end
end

----获取玩家第一次玩我们游戏的时间与配制中playTime相关
--function ADManager:getFirstTime()
--    return self.data:getFirstTime();
--end
--
--function ADManager:setFirstTime()
--    local baseTime = self.data:getFirstTime();
--    
--    if baseTime == nil
--    then
--        local time = os.time();
--        self.data:setFirstTime(time);
--    end
--end
--
----获取配制表
--function ADManager:getConfig()
--    return self.data:getConfig();
--end

--重置数据
function ADManager:reset()
    self.data:setImageAdPopCount(0);
    self.data:setVideoADPopCount(0);
    self.data:setStoreShow(0);
    self.data:setBuyHeartShow(0);
end

--function ADManager:getVideoCountByID(id)
--    if id == nil then return 99999 end;
--    id = tostring(id);
--    local loc_config = self.data:getConfig();
--    if loc_config == nil then return 99999; end
--    
--    local loc_videoAD = loc_config["videoAd"];
--    if loc_videoAD == nil then return 99999; end
--    
--    local loc_adData = loc_videoAD["data"];
--    if loc_adData == nil then return 0; end
--    
--    if loc_adData[id] == nil then return 0; end
--    
--    local loc_count = loc_adData[id]["count"];
--    if loc_count == nil then return 0; end
--    loc_count = tonumber(loc_count);
--    
--    return loc_count;
--end
--
--function ADManager:addVideoCountByID(id)
--    if id == nil then return end;
--    id = tostring(id);
--    local baseCount = self:getVideoCountByID(id);
--    
--    if baseCount ~= 99999 then
--        local loc_config = self.data:getConfig();
--        local loc_videoAD = loc_config["videoAd"];
--        
--        if loc_videoAD["data"] == nil then loc_videoAD["data"] = {} end
--        loc_videoAD["data"][id] = {count = baseCount + 1};
--        
--        self.data:setConfig(loc_config);
--        
--        MainValue.httpManager:sendVideoADCountByID(id);
--    end
--end
--
--获取配制表
function ADManager:synchronousData(data)
    if data == nil or type(data) ~= "table" then return; end
    self.data:setConfig(data);
end

--保存在关闭商店时显示过广告
function ADManager:setStoreShow()
    self.data:setStoreShow(1);
end

--是否在关闭商店时显示过广告
function ADManager:getStoreShow()
    return self.data:getStoreShow();
end


--保存在关闭买心时显示过广告
function ADManager:setBuyHeartShow()
    self.data:setBuyHeartShow(1);
end

--是否在关闭买心时显示过广告
function ADManager:getBuyHeartShow()
    return self.data:getBuyHeartShow();
end

--保存胜利次数，胜利次数大于五次显示一次广告
function ADManager:setWinCountForAD()
  self.data:setWinCountForAD();
end

function ADManager:getWinCountForAD()
   return self.data:getWinCountForAD();
end

function ADManager.create()
    local temp = ADManager.new();
    return temp;
end

return ADManager;