require("config.storeConfig")

local StoreManager = class("StoreManager");

StoreManager.storeCash = nil;

function StoreManager.create()
    local temp = StoreManager.new();
    temp.storeCash = storeConfig.cash;
    return temp;
end


function StoreManager:getCashList()
	return self.storeCash;
end

--得到单个商品数据（通过商品平台     storeID = “com.swaves.sundaesmash.gp.1”..id）
function StoreManager:getStoreObjectByStoreID(storeID)
    local localID = self:convertStoreIdToLocalId(storeID);
    for i in pairs(self.storeCash) do
        if tonumber(self.storeCash[i].id) == localID then
            return self.storeCash[i]
        end;
    end
    return nil;
end;

function StoreManager:getStartPackageObjectByID(storeID)
      return  storeConfig.startpackage    
end


function StoreManager:buyStoreObjectSuccess(storeID)
    local cashObject = self:getStoreObjectByStoreID(storeID);
    if(tonumber(cashObject.cash)) > 0 then
        
        MainValue.statisticsManager:shopBuy("cash"..cashObject.id,cashObject.dollar,MainValue.platformManager:getCountry(),0,cashObject.cash,
        MainValue.SELECTED_LEVEL,MainValue.dataManager.userManager:getHeart(), 0, MainValue.dataManager.userManager:getCash());
        
        -- 2015-6-18 暂时注释 
        MainValue.statisticsManagerOG:Purchase(storeID, cashObject.dollar, MainValue.platformManager:getCountry())
        MainValue.dataManager.userManager:addCash(tonumber(cashObject.cash));
        
        MainValue.dataManager.expandManager:setIsPay();
        
    end;
end;

function StoreManager:convertStoreIdToLocalId(storeID)

    local splitStr = "s"
    local targetPlatform = cc.Application:getInstance():getTargetPlatform()
    if targetPlatform == cc.PLATFORM_OS_IPHONE or targetPlatform == cc.PLATFORM_OS_IPAD  then
        --splitStr = ".";
    elseif targetPlatform == cc.PLATFORM_OS_ANDROID then
        --splitStr= "s";
    end;
    local strArr = lua_string_split(storeID,splitStr);
    local length = table.maxn(strArr);
    return tonumber(strArr[length]);
end;

return StoreManager;