local DataAD = class("DataAD");

function DataAD:ctor()
    self.KEY = 
    {
        SESSION = "session",
        INTERVAL_TIME = "interval_time",
        POP_COUNT = "count",
        FIRST_TIME = "first_time",
        RESET_DAY = "reset_day",
        
        --关闭商店显示广告，每天一次
        STORE_SHOW = "store_show",
        --关闭买心显示广告，每天一次
        BUY_HEART_SHOW = "buy_heart_show",
        --七关以后，每胜利五次显示一次广告
        WIN_COUNT_FOR_AD = "win_count_for_ad"
    }
    
    self.ImageAD = "img";
    self.VideoAD = "video";
    
    self.data = {};
    self.dataConfig = nil;
end

-- ----------------------------------------------------------LEVEL

function DataAD:getAllAD()
    return self.data;
end

--获取游戏初始化多少次
function DataAD:getSession()
    return self.data[self.ImageAD][self.KEY.SESSION];
end

function DataAD:setSession(pdata)
    self.data[self.ImageAD][self.KEY.SESSION] = pdata;
end

--获取上次弹出广告的时间
function DataAD:getIntervalTime()
    return self.data[self.ImageAD][self.KEY.INTERVAL_TIME];
end

function DataAD:setIntervalTime(pdata)
    self.data[self.ImageAD][self.KEY.INTERVAL_TIME] = pdata;
end

--获取图片广告已经弹出多少次
function DataAD:getImageAdPopCount()
    return self.data[self.ImageAD][self.KEY.POP_COUNT];
end

function DataAD:setImageAdPopCount(pdata)
    self.data[self.ImageAD][self.KEY.POP_COUNT] = pdata;
end

--获取视频广告已经弹出多少次
function DataAD:getVideoADPopCount()
    return self.data[self.VideoAD][self.KEY.POP_COUNT];
end

function DataAD:setVideoADPopCount(pdata)
    self.data[self.VideoAD][self.KEY.POP_COUNT] = pdata;
end

--获取玩家第一次玩我们游戏的时间与配制中playTime相关
function DataAD:getFirstTime()
    return self.data[self.ImageAD][self.KEY.FIRST_TIME];
end

function DataAD:setFirstTime(pdata)
    self.data[self.ImageAD][self.KEY.FIRST_TIME] = pdata;
end

--获取配制表，配制表也将存储，服务器下次发送消息时会同步
function DataAD:getConfig()
    return self.dataConfig;
end

function DataAD:setConfig(pdata)
    self.dataConfig = pdata;
end

function DataAD:getStoreShow()
    return self.data[self.KEY.STORE_SHOW];
end

function DataAD:setStoreShow(state)
    self.data[self.KEY.STORE_SHOW] = state;
    MainValue.dbManager:flush();
end

function DataAD:getBuyHeartShow()
    return self.data[self.KEY.BUY_HEART_SHOW];
end

function DataAD:setBuyHeartShow(state)
    self.data[self.KEY.BUY_HEART_SHOW] = state;
    MainValue.dbManager:flush();
end

function DataAD:setWinCountForAD()
    local curCount = self:getWinCountForAD();
    
    if curCount == nil or curCount == 0 then
        curCount = 1;
    else
        curCount = curCount + 1;
    end
    
    if curCount > 5 then
        curCount = curCount - 5;
    end
    
    self.data[self.KEY.WIN_COUNT_FOR_AD] = curCount;
    MainValue.dbManager:flush();
end

function DataAD:getWinCountForAD()
    return self.data[self.KEY.WIN_COUNT_FOR_AD];
end

-- ---------------------------------------------------------

function DataAD:setData(pdata)
    self.data = pdata;
    
    if(self.data[self.ImageAD] == nil) then self.data[self.ImageAD] = {} end
    if(self.data[self.VideoAD] == nil) then self.data[self.VideoAD] = {} end
end

function DataAD:getData()
    return self.data;
end

function DataAD.create()
    local temp = DataAD.new();
    return temp;
end

return DataAD;