local DataDaily = class("DataDaily");

--此类数据不缓存本地
function DataDaily:ctor()
    self.data = {};
    
    self.KEY = 
    {
        DAILY = "daily",
        SINGNIN = "signin",
        GACHA = "gacha"
    }
end

-- ----------------------------------------------------------daily

--[[--
--@return #table
--#table[days] 连续登录天数
]]
function DataDaily:getDaily()
    return self.data[self.KEY.DAILY];
end

function DataDaily:setDaily(pdata)
    self.data[self.KEY.DAILY] = pdata;
end

-- ----------------------------------------------------------Sign in

---[[--
--@return #table 每日签到数据
--#table[date] 年月日 Ymd
--#table[goods_list] 累计礼包配置列表 
--#table[state] 今天是否签到
--#table[d] = int 累加签到天数
--]]
function DataDaily:getSignIn()
    return self.data[self.KEY.SINGNIN];
end

function DataDaily:setSignIn(pdata)
    self.data[self.KEY.SINGNIN] = pdata;
end

-- ----------------------------------------------------------gacha

--[[--
--获取扭蛋的相关信息
--@return #table
--#table["card"] 每日抽取的8张牌
--#table["num"] 每日抽取的次数(注：此值有时会没有，为nil)
--#table["pos"] 抽取过的礼包ID及位置 = table('礼包ID' = '位置') 当位置标记为1000时，代表这个位置是随机的非固定位置(注：此值有时会没有，为nil)
--#table["goods"] 物品配制表
--#table["rand_cash"] 购买扭蛋的cash
--]]
function DataDaily:getGacha()
    return self.data[self.KEY.GACHA];
end

function DataDaily:setGacha(pdata)
    self.data[self.KEY.GACHA] = pdata;
end

-- ----------------------------------------------------------create
function DataDaily.create()
    local temp = DataDaily.new();
    return temp;
end

return DataDaily;