local DataExpand = class("DataExpand");

function DataExpand:ctor()

    self.KEY = 
        {
            --背包数数
            GOODS = "goodsData",
            --背景音乐
            OPTION = "optionData",
            --解锁前置道具列表
            UNLOCK = "unLockData",
            --每日邮箱送好友心(每天一次)
            INOBX_SEND = "inboxSend"
        }
        
    self.data = {};
end

-- ----------------------------------------------------------GOODS

function DataExpand:getAllGoods()
    return self.data[self.KEY.GOODS];
end

function DataExpand:getGoods(id)
    return self.data[self.KEY.GOODS][tostring(id)];
end

function DataExpand:setGoods(id, pdata)
    self.data[self.KEY.GOODS][tostring(id)] = pdata;
    MainValue.dbManager:flush();
end

-- ----------------------------------------------------------unlock

function DataExpand:getUnLockGoods()
    return self.data[self.KEY.UNLOCK];
end

function DataExpand:setUnLockGoods(pdata)
    self.data[self.KEY.UNLOCK] = pdata;
    MainValue.dbManager:flush();
end

-- ----------------------------------------------------------OPTION

function DataExpand:getBgMusice()
    return self.data[self.KEY.OPTION]["bgMusic"];
end

function DataExpand:setBgMusice(pdata)
    self.data[self.KEY.OPTION]["bgMusic"] = pdata;
    MainValue.dbManager:flush();
end

function DataExpand:getEfMusice()
    return self.data[self.KEY.OPTION]["efMusic"];
end

function DataExpand:setEfMusice(pdata)
    self.data[self.KEY.OPTION]["efMusic"] = pdata;
    MainValue.dbManager:flush();
end

function DataExpand:getFTUE()
    return self.data[self.KEY.OPTION]["ftue"];
end

function DataExpand:setFTUE(pdata)
    self.data[self.KEY.OPTION]["ftue"] = pdata;
    MainValue.dbManager:flush();
end

function DataExpand:getEnergyTime()
    return self.data[self.KEY.OPTION]["energy_time"];
end

function DataExpand:setEnergyTime(pdata)
    self.data[self.KEY.OPTION]["energy_time"] = pdata;
    MainValue.dbManager:flush();
end

function DataExpand:getFirstLoginPlatform()
    return self.data[self.KEY.OPTION]["first"];
end

function DataExpand:setFirstLoginPlatform(pdata)
    self.data[self.KEY.OPTION]["first"] = pdata;
    MainValue.dbManager:flush();
end

function DataExpand:getHasBuyStartPackage()
    return self.data[self.KEY.OPTION]["package"];
end

function DataExpand:setHasBuyStartPackage(pdata)
    self.data[self.KEY.OPTION]["package"] = pdata;
    MainValue.dbManager:flush();
end

function DataExpand:getNotifyIOS()
    return self.data[self.KEY.OPTION]["notify_ios"];
end

--[[
--设置IOS通知授权状态
--@param pdata table 授权信息
--pdata["date"] 五天后时间戳
--pdata["mystate"] 自己仿照IOS的授权框的状态 , 0未授权(maybe later) 1己授权(yes)
--pdata["iosstate"] IOS的授权框的状态 , 0未授权(maybe later) 1己授权(yes)
]]
function DataExpand:setNotifyIOS(pdata)
    self.data[self.KEY.OPTION]["notify_ios"] = pdata;
    MainValue.dbManager:flush();
end

--获取app评价状态
function DataExpand:getComments()
    return self.data[self.KEY.OPTION]["comments"];
end

function DataExpand:setComments(pdata)
    self.data[self.KEY.OPTION]["comments"] = pdata;
    MainValue.dbManager:flush();
end

--是否付费
function DataExpand:setIsPay(pdata)
    self.data[self.KEY.OPTION]["is_pay"] = pdata;
    MainValue.dbManager:flush();
end

function DataExpand:getIsPay()
    return self.data[self.KEY.OPTION]["is_pay"];
end

--是否提示大版本更新
function DataExpand:setNewVersionStatus(pdata)
    self.data[self.KEY.OPTION]["new_ver"] = pdata;
    MainValue.dbManager:flush();
end

function DataExpand:getNewVersionStatus()
    return self.data[self.KEY.OPTION]["new_ver"];
end

--获取上一次重置日期
function DataExpand:getResetDay()
    return self.data[self.KEY.OPTION]['reset_date'];
end

function DataExpand:setResetDay(pdata)
    self.data[self.KEY.OPTION]['reset_date'] = pdata;
    MainValue.dbManager:flush();
end

--进入关卡的状态
function DataExpand:getStartGameState()
    return self.data[self.KEY.OPTION]['sgames'];
end

function DataExpand:setStartGameState(pdata)
    self.data[self.KEY.OPTION]['sgames'] = pdata;
    MainValue.dbManager:flush();
end

function DataExpand:getInboxSendHearts()
    return self.data[self.KEY.INOBX_SEND];
end

function DataExpand:setInboxSendHearts(hasSend)
    self.data[self.KEY.INOBX_SEND] = hasSend;
    MainValue.dbManager:flush();
end

-- -------------------------------------------------------------

function DataExpand:setData(pdata)
    self.data = pdata;
    
    if(self.data[self.KEY.GOODS] == nil) then self.data[self.KEY.GOODS] = {} end
    if(self.data[self.KEY.OPTION] == nil) then self.data[self.KEY.OPTION] = {} end
end

function DataExpand:getData()
    return self.data;
end


function DataExpand.create()
    local temp = DataExpand.new();
    return temp;
end

return DataExpand;