local EffectManager = class("EffectManager");

function EffectManager:ctor()
    --getmetatable(self)
    self.layer = cc.Layer:create();
    
end

function EffectManager.create()
    local temp = EffectManager.new();
    return temp;
end

--处理五彩球和power 交换全部变成powerUp的时候调用
function EffectManager:showFlyFaSheToAim(sPstX,sPstY,tPstX,tPstY)
    if self.faSheSprite == nil then
        self.faSheSprite = cc.Sprite:create()
        self.faSheSprite:setAnchorPoint(0,0)    
        self.layer:addChild(self.faSheSprite)
    end
    local playTimer = 0.5
    self.faSheEmitter = cc.ParticleSystemQuad:create("armature/inGameArmature/effect/fashe.plist")
    self.faSheEmitter:setAnchorPoint(0,0)
    self.faSheEmitter:setPosition(sPstX, sPstY + 40)
    self.faSheEmitter:setSpeed(10)

    self.faSheEmitter:setDuration(playTimer)            
    self.faSheEmitter:setLife(playTimer)
    
    local callFunEnd = function()
        self.faSheEmitter:removeFromParent(true)
        self.faSheEmitter = nil    
        self.faSheSprite:removeFromParent(true)
        self.faSheSprite = nil
    end
    
    local act1 = cc.Sequence:create(cc.MoveTo:create(playTimer-0.1,cc.p(tPstX,tPstY+40)),cc.CallFunc:create(callFunEnd))
    
    self.faSheEmitter:runAction(act1)
    
    self.faSheSprite:addChild(self.faSheEmitter) 
end




function EffectManager:showFlyStarToAim(sPstX,sPstY,tPstX,tPstY,callBackFun)

--   if self.emitterSprite~=nil then
--        return
--   end
  
   local playTimer = 0.8
    local emitterSprite = cc.Sprite:create()
    emitterSprite:setAnchorPoint(0,0)    
    self.layer:addChild(emitterSprite)
    
    local armatureCollectStar = ccs.Armature:create("shoujixingxing")    
    armatureCollectStar:setPosition(sPstX-10,sPstY-10)
    armatureCollectStar:retain()
    emitterSprite:addChild(armatureCollectStar)  
    -- 设置位置
    --    armatureCollectStar:setPosition(cc.p(94,60))
    -- 播放动画, 播放指定动作
    armatureCollectStar:getAnimation():play("1")
    
        
    local callFunEnd = function()
        armatureCollectStar:getAnimation():stop()
        armatureCollectStar:removeFromParent(true)
        armatureCollectStar:release()
        armatureCollectStar = nil         
        self.emitter:removeFromParent(true)
        self.emitter = nil    
        emitterSprite:removeFromParent(true)
        emitterSprite = nil
        callBackFun()
    end
        
        
    local callFun = function()    
    
        armatureCollectStar:getAnimation():play("3",0.2,0)
        local act1 = cc.Sequence:create(cc.DelayTime:create(0.2),cc.CallFunc:create(callFunEnd))
        armatureCollectStar:runAction(act1)
    end
    
    
     local callFunPlayTwoFrames = function()
        armatureCollectStar:getAnimation():play("2")     
        
        
        self.emitter = cc.ParticleSystemQuad:create("armature/inGameArmature/effect/star.plist")
        self.emitter:setAnchorPoint(0,0)
        self.emitter:setPosition(sPstX, sPstY)
        self.emitter:setSpeed(10)
        
        self.emitter:setDuration(playTimer)            
        self.emitter:setLife(playTimer - 0.3)
         
        local acti2 = cc.MoveTo:create(playTimer - 0.3,cc.p(tPstX,tPstY))
        local acti3 = cc.ScaleTo:create(playTimer - 0.3,0.5,0.5)

--        offsetX = tonumber(self.drawRectX) - 684 * 0.5  --如果是以中间为参照
--        offsetY = tonumber(self.drawRectY) - 1024 * 0.5   

--        pstX = VisibleRect:center().x + offsetX + xRate * 80 * 0.5
--        pstY = VisibleRect:center().y + offsetY + yRate * 80 * 0.5

 

        local offsetX = sPstX - MainValue.winSize.width * 0.5
        local offsetY = sPstY - MainValue.winSize.height *0.5
        
        
        local staX = VisibleRect:center().x + offsetX
        local staY = VisibleRect:center().y + offsetY
        
        local offsetXE = tPstX - MainValue.winSize.width * 0.5
        local offsetYE = tPstY - MainValue.winSize.height *0.5
        
        
        local etaX = VisibleRect:center().x + offsetXE
        local etaY = VisibleRect:center().y + offsetYE
        
        
        local bezier = {
--            cc.p(0, size.height / 2),
--            cc.p(300, - size.height / 2),
--            cc.p(300, 100),
            cc.p(staX, staX),
            cc.p(staX, staX),
            cc.p(etaX, etaY),
        }
--        local bezierForward = cc.BezierBy:create(3, bezier)
        
--        local bezierTo2 = cc.BezierTo:create(2, bezier2)
        
        local acti4 = cc.BezierTo:create(playTimer - 0.3,bezier) 
        
        local acti5 = cc.BezierTo:create(playTimer - 0.3,bezier) 
        
        
        local actScale = cc.Sequence:create(acti3,cc.CallFunc:create(callFun))
--        sPstX sPstY

        

--        local acti = cc.BezierBy:create(playTimer - 0.3,{cc.p(sPstX - 300,sPstY),cc.p((sPstX + tPstX)*0.5,tPstY),cc.p(tPstX,tPstY)}) 
        
        local acti = cc.MoveTo:create(playTimer - 0.3,cc.p(tPstX,tPstY))
        
--        config.endPosition = to;
--        config.controlPoint_1 = Point( from.x - 300 , from.y );
--        config.controlPoint_2 = Point( ( from.x + to.x ) / 2 , to.y );
--        float collectflyTime = 0.8;
--        object->setScale(0.8);
--        
--        ActionInterval* action = bezierTo( collectflyTime , config ).easeIn( 0.9f ) + callFunc( [this , object , func]()
        
       
--        local acti = cc.BezierBy:create(0.8,{cc.p(-40,-160),cc.p(-200,-190),cc.p(-460,600)})  
        --{波谷偏向值,波峰偏小值,动作终点位置)}
--        armatureCollectStar:runAction(acti3)
        armatureCollectStar:runAction(acti4)
        armatureCollectStar:runAction(actScale)                
        --    local actions = cc.Sequence:create(actScale,acti)
--        self.emitter:runAction(acti)
        self.emitter:runAction(acti5)
        emitterSprite:addChild(self.emitter) 
        
     end    
     
    local ac1 = cc.Sequence:create(cc.MoveTo:create(playTimer - 0.3,cc.p(armatureCollectStar:getPositionX(),armatureCollectStar:getPositionY())),cc.CallFunc:create(callFunPlayTwoFrames))
    armatureCollectStar:runAction(ac1)
end

function EffectManager:showTxtFly(str, fontType, postion_x,postion_y)
    local text = FacFont:getFontsBmp(fontType, str)
    
    text:setPosition(cc.p(postion_x,postion_y));
    self.layer:addChild(text);


    local callFun = function()
        if text ~= nil then
            text:removeFromParent(true);
        end;
    end;

    local ac1 = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.8,cc.p(0, 40)),0.4),cc.CallFunc:create(callFun));
    local ac2 = cc.Sequence:create(cc.FadeOut:create(1))

    text:runAction(ac1);
    text:runAction(ac2);
end



-------------------------------------------------------------------------------------------------
--进入游戏开始界面
function EffectManager:onEnterSplash()
end

--退出游戏开始界面
function EffectManager:onExitSplash()
end 

--进入地图
function EffectManager:onEnterMap()
end 

--退出地图
function EffectManager:onExitMap()
end

--进入游戏
function EffectManager:onEnterGame()
end
--onEnteredGame

--退出游戏
function EffectManager:onExitGame()
end

function EffectManager:backPack()

    return false; 
end

return EffectManager;