function checkEmail(string)
    if not string then
        return false
    end

    if (string:match("[A-Za-z0-9%.%%%+%-]+@[A-Za-z0-9%.%%%+%-]+%.%w%w%w?%w?")) then
        return true
    else
        return false
    end
end

function class(...)
    local function search(k, plist)
        for i = 1,#plist do
            local v = plist[i][k]
            if v then return v end
        end
    end
    local c = {}
    local parents = {...}
    -- 设置类的元表
    setmetatable(c, {__index = function(t, k) return search(k, parents) end})
    -- 给类新增一个new函数，用于创建对象
    function c:new(o)
        o = o or {}
        setmetatable(o, c)
        c.__index = c
        return o
    end
    -- 返回这个继承了多个类的子类
    return c
end


-- 参数:待分割的字符串,分割字符  
-- 返回:子串表.(含有空串)  
function lua_string_split(str, split_char)      
    local sub_str_tab = {};
    while (true) do
        local pos = string.find(str, split_char,1,true);
        if (not pos) then
            sub_str_tab[#sub_str_tab + 1] = str;
            break;
        end
        local sub_str = string.sub(str, 1, pos - 1);
        sub_str_tab[#sub_str_tab + 1] = sub_str;
        str = string.sub(str, pos + 1, #str);
    end
    return sub_str_tab;  
end 