local HttpManager = class("HttpManager");


HttpManager.tok = nil;
HttpManager.ttp = nil;
HttpManager.state = nil;

function HttpManager:ctor()
    self.state = false;
end

local function debug(...)
    print(string.format(...))
end

---发送post请求
--@param self
--@param requestData 要发送的json格式数据
--@param callBack 注册当前的回调函数

local function sendReuqest(self,requestData)
    local loc_uid = MainValue.dataManager.userManager:getUID();
    local loc_pid = MainValue.dataManager.userManager:getPID();
    
    requestData["uid"] = loc_uid;
    requestData["pid"] = loc_pid;
    requestData["ttp"] = self.ttp;
    requestData["tok"] = self.tok;
    
    requestData = json.encode(requestData);
    --cc.XmlHttpRequest:
    local request = cc.XMLHttpRequest:new()-- 新建一个XMLHttpRequest对象
    request.responseType = cc.XMLHTTPREQUEST_RESPONSE_JSON--返回数据为json格式
    request:open(DataConfig.serverMethod, DataConfig.serverHost)
    -- response回调函数  
    local function response()  
        if request.readyState == 4 and (request.status >= 200 and request.status < 207) then
            local response   = request.response
            debug("[HttpManager]--Debug server response:"..response)
            if response == -1 then
                debug("[HttpManager]--server error!")
            elseif response == "nil" then
                debug("[HttpManager]--server success!")
                --self:responseMsgHandler("success");
            else
                --服务器抛错,中止处理
                if string.find(response,"Fatal error") ~= nil
                    or string.find(response,".php") ~= nil
                then
                    debug("[HttpManager]--[***Server***] Fatal error.");
                    self.state = false;
                    return;
                end
                
                --local output = json.decode(response,1);
                local output = json.decode(response);
                self:responseMsgHandler(output);
            end
        else
            print("[HttpManager]--xhr.readyState is:", request.readyState, "xhr.status is: ",request.status)
        end
    end  

    -- 注册脚本方法回调
    request:registerScriptHandler(response);
    
    request:send(requestData)-- 发送
    
    debug("[HttpManager]--Debug requestData:"..requestData)
end

--登录服务器
function HttpManager:login(acctok)
    local loc_uuid = MainValue.platformManager:getUUID();
    local loc_platform = DataConfig.os;
    local requestData = {cmd = "login", acctok = acctok, uuid = loc_uuid, platform = loc_platform};
    sendReuqest(self,requestData);
end

function HttpManager:responseMsgHandler(params)
   if params == nil or type(params) == "number" then
     print("[HttpManager]--responseMsgHandler() accept value is nil or number")
     return
   end
    
    local cmd = params['cmd'];
    
    if cmd == "login" then
    
        self.tok = params['tok'];
        self.ttp = params['ttp'];
        local uid = params['uid'];
        local pid = params['pid'];
        local ret = MainValue.dbManager:login(uid, pid);
        
        if ret and self.tok ~= nil and self.ttp ~= nil then self:getInfos(); end
        
    elseif cmd == "getInfos" then
        self.state = true;
        MainValue.dataManager:onGetInfosResult(params);
        
    --elseif cmd == "mob" then
        --MainValue.dataManager.dailyManager:dailyCallBack(params);
    end
end

--初始化游戏数据
function HttpManager:getInfos()
    local loc_lvData = MainValue.dataManager.levelManager:getAllLevel();
    local loc_boxData = MainValue.dataManager.levelManager:getAllBox();
    local loc_fids = MainValue.dataManager.friendManager:getFriendsIds();
    
    local requestData = 
          {
            cmd     = "getInfos",
            lvData  = loc_lvData,
            fids    = loc_fids,
            boxData = loc_boxData
          }
    
    sendReuqest(self,requestData);
end

--[[--
--保存BLOCK数据到服务器
--@param bid int block前面的关卡ID 即大关数*10
--@param fids array 帮助BLOCK的朋友ID，花钱买时ID为1000
]]
function HttpManager:saveBlockToServer(bid,fids)
    if self.state == false then return end
    
    local requestData = 
          {
            cmd     = "expand",
            _cmd    = "mob_blocker",
            lv      = bid,
            ids     = fids
          }
          
    sendReuqest(self, requestData);
end

--[[--
--保存level数据到服务器
--@param lv int 关卡
--@param rt int 游戏结果
--@param score int 分数
--@param stars int 星数
]]
function HttpManager:saveLevelToServer(lv, rt, score, stars)
    if self.state == false then return end
    
    local requestData = 
        {
            cmd         = "game",
            _cmd        = "result",
            lv          = lv,
            rt          = rt,
            score       = score,
            stars       = stars
        }

    sendReuqest(self, requestData);
end

--[[--
--与服务器强行同步关卡数据
--@param lvData table 所有关卡数据
]]
function HttpManager:synchronousLevelToServer(lvData)
    if self.state == false then return end
    
    local requestData = 
          {
            cmd     ="game",
            _cmd    ="sync_level_data",
            lvData  =lvData
          }
    
    sendReuqest(self, requestData);
end

--签到
function HttpManager:dailySignInToServer()
    if self.state == false then return end
    local requestData = {cmd = "daily",_cmd = "sign_in"};
    sendReuqest(self, requestData);
end

--向服务器发送领取第一次登录平台奖励
function HttpManager:firstLoginPlatformToServer()
    if self.state == false then return end
    local requestData = {cmd = "expand",_cmd = "firstPlm"};
    sendReuqest(self, requestData);
end

function HttpManager:openBoxGiftToServer(id)
    if id == nil then return end
    if self.state == false then return end
    local requestData = {cmd = "expand",_cmd = "openbox", id = id};
    sendReuqest(self, requestData);
end

function HttpManager:sendVideoADCountByID(id)
    if id == nil then return end
    if self.state == false then return end
    
    local requestData = {cmd = "expand",_cmd = "adVCount", id = id};
    sendReuqest(self, requestData);
end

--保存首充礼包已经购买
function HttpManager:startPackageHasBuyToServer()
    if self.state == false then return end
    
    local requestData = {cmd = "expand",_cmd = "startpackage", startpackageid = '1'};
    sendReuqest(self, requestData);
end
-- -----------------------------------------------------------------------gacha(目前作废)

function HttpManager:gachaFreeToServer(pos)
    if self.state == false then return end

    local requestData = {
            cmd     = "mob",
            _cmd    = "free_gacha",
            pos     = pos
        }

    sendReuqest(self, requestData);
end

function HttpManager:gachaBuyToServer(pos)
    if self.state == false then return end

    local requestData = {
            cmd     = "mob",
            _cmd    = "buy_gacha",
            pos     = pos
        }

    sendReuqest(self, requestData);
end

function HttpManager:gachaOpenAllToServer()
    if self.state == false then return end
    local requestData = {cmd = "mob",_cmd = "all_gacha"};
    sendReuqest(self, requestData);
end

function HttpManager:deleteInboxToServer(id)
    if self.state == false then return end
    local requestData = {cmd = "expand",_cmd = "del_message", id = id};
    sendReuqest(self, requestData);
end

function HttpManager.create()
    local temp = HttpManager.new();
    return temp;
end

return HttpManager;