-- 九宫格工具


SpecialGridTools = class("SpecialGridTools",function ()
    return cc.Layer:create();
end)

function SpecialGridTools:ctor(imgUrl,w,h,cellSize)
    self.endPic= cc.Layer:create();


    --    根据路径先得到原图
    self.srcimg = cc.Sprite:createWithSpriteFrameName(imgUrl)
    
    local signX = self.srcimg:getTextureRect().x --实际代表大图中的 x方向坐标 
    local signY = self.srcimg:getTextureRect().y --实际代表大图中的y方向 坐标
    
    self.srcImgWidth=self.srcimg:getContentSize().width
    self.srcImgHeight=self.srcimg:getContentSize().height

    --    同时用
    --    self.srcimg:setScaleY(2)
    --    self.srcimg:setContentSize(70, 90)

    --定义中间横向重复单元的个数
    self.hNum= math.floor((w-2*cellSize)/cellSize)
    --定义中间纵向重复单元的个数
    self.vNum = math.floor((h-2*cellSize)/cellSize)
    --得到中间部分的宽和高
    self.midCenterWidth = self.hNum * cellSize
    self.midCenterHeight= self.vNum * cellSize

    --    print("self.hNum"..self.midCenterWidth,"---",self.vNum)




    self.srcImgTextures=self.srcimg:getTexture()

    --1
    self.topLeftImg=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX,signY,cellSize,cellSize))
    --2
    self.topCenterImg=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX + cellSize,signY,self.srcImgWidth-2*cellSize,cellSize))
    --3
    self.topRightImg=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX + self.srcImgWidth-cellSize,signY,cellSize,cellSize))
    --4
    self.midLeftImg = cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX,cellSize+signY,cellSize,self.srcImgHeight-2*cellSize))
    --5
    self.midCenterImg= cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX + cellSize,cellSize + signY,self.srcImgWidth-2*cellSize,self.srcImgHeight-2*cellSize))
    self.midCenterImg:setScaleX(self.hNum)
    self.midCenterImg:setScaleY(self.vNum)
    --6
    self.midRightImg =  cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX + self.srcImgWidth-cellSize,cellSize + signY,cellSize,self.srcImgHeight-2*cellSize))

    --7
    self.bottomLeftImg =  cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX,self.srcImgHeight-cellSize + signY,cellSize,cellSize))
    --8
    self.bottomCenterImg=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX + cellSize,self.srcImgHeight-cellSize + signY,self.srcImgWidth-2*cellSize,cellSize))

    --9
    self.bottomRightImg=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX + self.srcImgWidth-cellSize,self.srcImgHeight-cellSize + signY,cellSize,cellSize))



    --1 2 3
    --4 5 6
    --7 8 9

    --    其实坐标  x为0的应该是   cellSize/2  才是完整的0 0左下角 位置
    local hReal= cellSize + self.midCenterHeight + cellSize --真实的总体高度    
    --1
    local topLeftImgX = cellSize/2
    local topLeftImgY =cellSize/2+ hReal-cellSize/2
    self.topLeftImg:setPosition(cc.p(topLeftImgX,topLeftImgY))
    self.endPic:addChild(self.topLeftImg)
    --2 添加顶部中间的循环单元
    for i = 1, self.hNum do
        local topCenterImgReal=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX + cellSize, signY,self.srcImgWidth-2*cellSize,cellSize))
        local tarPosX = cellSize/2+i * cellSize
        local tarPosY =cellSize/2+ hReal - cellSize / 2
        topCenterImgReal:setPosition(tarPosX,tarPosY)        
        self.endPic:addChild(topCenterImgReal)

    end
    --3
    local topRightImgX= cellSize/2+cellSize + self.midCenterWidth
    local topRightImgY= cellSize/2+ hReal-cellSize/2
    self.topRightImg:setPosition(cc.p(topRightImgX,topRightImgY))
    self.endPic:addChild(self.topRightImg)

    --4 左侧中间循环单元添加
    for i = 1, self.vNum do
        local midLeftImgReal=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX ,cellSize + signY,cellSize,self.srcImgHeight-2*cellSize))
        local tarPosX = cellSize/2 --i * cellSize
        local tarPosY =cellSize/2+ hReal - cellSize / 2 - i * cellSize
        midLeftImgReal:setPosition(tarPosX,tarPosY)        
        self.endPic:addChild(midLeftImgReal)
    end
    --5 正中间部分

    local midCenterImgX = cellSize/2+cellSize/2 +(self.midCenterWidth)/2  

    local midCenterImgY =cellSize/2+ hReal-(self.midCenterHeight)/2-cellSize

    self.midCenterImg:setPosition(cc.p(midCenterImgX,midCenterImgY))
    self.endPic:addChild(self.midCenterImg)
    --6 右侧中间重复单元
    for i = 1, self.vNum do
        local midRightImgReal=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX + self.srcImgWidth-cellSize,cellSize +signY,cellSize,self.srcImgHeight-2*cellSize))
        local tarPosX = cellSize/2+cellSize + self.midCenterWidth
        local tarPosY = cellSize/2+hReal - cellSize / 2 - i * cellSize
        midRightImgReal:setPosition(tarPosX,tarPosY)        
        self.endPic:addChild(midRightImgReal)
    end
    --7 左下角
    local bottomLeftImgX = cellSize/2
    local bottomLeftImgY = cellSize/2+cellSize/2
    self.bottomLeftImg:setPosition(cc.p(bottomLeftImgX,bottomLeftImgY))
    self.endPic:addChild(self.bottomLeftImg)
    --8 底部中间重复单元
    for i = 1, self.hNum do
        local bottomCenterImgReal=cc.Sprite:createWithTexture(self.srcImgTextures,cc.rect(signX + cellSize,signY + self.srcImgHeight-cellSize,self.srcImgWidth-2*cellSize,cellSize))
        local tarPosX = cellSize/2+i * cellSize
        local tarPosY =cellSize/2+ cellSize/2
        bottomCenterImgReal:setPosition(tarPosX,tarPosY)        
        self.endPic:addChild(bottomCenterImgReal)
    end
    --9 右下角单元
    local bottomRightImgX= cellSize/2+cellSize + self.midCenterWidth
    local bottomRightImgY=cellSize/2+ cellSize/2
    self.bottomRightImg:setPosition(cc.p(bottomRightImgX,bottomRightImgY))
    self.endPic:addChild(self.bottomRightImg)


    self.endPic:setPosition(-(self.midCenterWidth+ 2 * cellSize)/2,-(self.midCenterHeight+2 * cellSize)/2)

    self:addChild(self.endPic)

    self.srcImgTextures:release()
    self.srcImgTextures:retain()


    return self
end

function SpecialGridTools.create(imgUrl,w,h,cellSize)
    local endImg = SpecialGridTools.new(imgUrl,w,h,cellSize)    
    return endImg
end