
local FTUEManager = class("FTUEManager");

function FTUEManager:ctor()
    self.layer = cc.Layer:create();
    self.ftuet = nil
    self.ftueIdData = {};
end

function FTUEManager.create()
    local temp = FTUEManager.new();    
    return temp;
end


function FTUEManager:showFtueById(idPar)
    
    if self.ftuet == nil then
        self:setTargetConfig(0,0);
    end

    local tmpFtueData = MainValue.infosManager:getObjFtueById(idPar);
    if tmpFtueData ==nil then return end
    
    local out = tmpFtueData["out"];--out为1  在游戏外面  
    if out == "1" then
        if MainValue.dataManager.expandManager:existFtueById(idPar) == true  then
--            return;
        end
    else
        if MainValue.SELECTED_LEVEL ~= MainValue.dataManager.levelManager:getMaxLevel()then
--            return;
        end
    end
   
    self:addFtue()
    MainValue.dataManager.expandManager:setFtueById(idPar);

    table.insert(self.ftueIdData,idPar);
--    print(table.concat(self.ftueIdData,", "));

    if self.ftuet~=nil then
        self.ftuet:showFtueById(idPar)
    end
    
end

function FTUEManager:addFtue()
    if self.ftuet~=nil and self.ftuet:getParent()==nil then
       self.layer:addChild(self.ftuet)
    end
end

function FTUEManager:removeFtue()    
    
    if self.ftuet~=nil and self.ftuet:getParent()~=nil then  
        self.layer:removeChild(self.ftuet)      
        return self.ftuet:removeFtue()
    end
    
--   return self.ftuet:removeFtue()
end

--@param swapPstAry 根据当前交换的坐标来判断是否允许交换
function FTUEManager:isAllowSwapByFtue(swapPstAry)
    return self.ftuet:isAllowSwapByFtue(swapPstAry)
end
--isSucess为true说明成功  false说明失败
--function FTUEManager:saveFtueData(isSucess)
--   if  isSucess == false then
--        
--        for k = 1,#(self.ftueIdData) do
--           self:existFid(self.ftueIdData[k][k]);
--        end
--        
--   end
--   for i,v in ipairs(self.ftueIdData) do
--        table.remove(self.ftueIdData,v);
--   end
--
--end
--
--function FTUEManager:existFid(sId)
--    local ary = MainValue.dataManager.expandManager:getFtue();
--    for i = 1,#(ary) do
--        if sId == ary[i] then
--            table.remove(ary,sId);
--        end
--    end
--end

--设定当前关卡的行数和列数
function FTUEManager:setTargetConfig(rowNum,colNum)
    if  self.ftuet == nil then
        local ftue = require("ftue.ftue.Ftue")
        self.ftuet = ftue.new()
        self.ftuet:setFtueData()
        self.ftuet:retain()
        self.layer:addChild(self.ftuet)
    end
    self.ftuet:setTargetConfig(rowNum,colNum)
end

function FTUEManager:getFtuet()
    return self.ftuet
end

function FTUEManager:hasFtue()
    return self.ftuet~=nil and self.ftuet:hasFtue()
end
--进入游戏开始界面
function FTUEManager:onEnterSplash()

end

--退出游戏开始界面
function FTUEManager:onExitSplash()

end 

--进入地图
function FTUEManager:onEnterMap()

end 

--退出地图
function FTUEManager:onExitMap()

end

--进入游戏
function FTUEManager:onEnterGame()
    
end
--onEnteredGame

--退出游戏
function FTUEManager:onExitGame()

end

--回退键功能 
function FTUEManager:backPack()
     if self ~= nil then
            if self:hasFtue() == true then
              --  self:removeFtue();
                return true; 
            end
     end
     return false; 
end
return FTUEManager;