
BlurShaderCreate = class("BlurShaderCreate")

function BlurShaderCreate:ctor()


end


function BlurShaderCreate:setBlurShader(shaderSpr)

    local vertDefaultSource = "\n"..
        "attribute vec4 a_position; \n" ..
        "attribute vec2 a_texCoord; \n" ..
        "attribute vec4 a_color; \n"..                                                    
        "#ifdef GL_ES  \n"..
        "varying lowp vec4 v_fragmentColor;\n"..
        "varying mediump vec2 v_texCoord;\n"..
        "#else                      \n" ..
        "varying vec4 v_fragmentColor; \n" ..
        "varying vec2 v_texCoord;  \n"..
        "#endif    \n"..
        "void main() \n"..
        "{\n" ..
        "gl_Position = CC_PMatrix * a_position; \n"..
        "v_fragmentColor = a_color;\n"..
        "v_texCoord = a_texCoord;\n"..
        "}"



local fsFsh ="\n"..
        "#ifdef GL_ES\n"..
        "precision mediump float;\n"..
        "#endif\n"..

        "varying vec4 v_fragmentColor;\n"..
        "varying vec2 v_texCoord;\n"..

        "uniform vec2 resolution;\n"..

        "float blur( vec2 );\n"..

        "void main( void )\n"..
        "{"..
        "float alpha = blur( v_texCoord );\n"..
        "alpha = 0.86 - alpha;\n"..
        "gl_FragColor = vec4( 0, 0 , 0 , alpha ) * alpha;\n"..
        "}\n"..

        "float blur( vec2 p )\n"..
        "{\n"..
        "vec4 col = vec4(0.0);\n"..
        "vec2 unit = 1.0 / resolution.xy;\n"..
            
        "col += texture2D(CC_Texture0, p - 8.0 * unit) * 0.05;\n"..
        "col += texture2D(CC_Texture0, p - 6.0 * unit) * 0.09;\n"..
        "col += texture2D(CC_Texture0, p - 4.0 * unit) * 0.12;\n"..
            "col += texture2D(CC_Texture0, p - 2.0 * unit) * 0.15;\n"..
            "col += texture2D(CC_Texture0, p                ) * 0.16;\n"..
            "col += texture2D(CC_Texture0, p + 2.0 * unit) * 0.15;\n"..
            "col += texture2D(CC_Texture0, p + 4.0 * unit) * 0.12;\n"..
            "col += texture2D(CC_Texture0, p + 6.0 * unit) * 0.09;\n"..
            "col += texture2D(CC_Texture0, p + 8.0 * unit) * 0.05;\n"..
            
            "unit.x *= -1.0;\n"..
            "col += texture2D(CC_Texture0, p - 8.0 * unit) * 0.05;\n"..
            "col += texture2D(CC_Texture0, p - 6.0 * unit) * 0.09;\n"..
            "col += texture2D(CC_Texture0, p - 4.0 * unit) * 0.12;\n"..
            "col += texture2D(CC_Texture0, p - 2.0 * unit) * 0.15;\n"..
            "col += texture2D(CC_Texture0, p                ) * 0.16;\n"..
            "col += texture2D(CC_Texture0, p + 2.0 * unit) * 0.15;\n"..
            "col += texture2D(CC_Texture0, p + 4.0 * unit) * 0.12;\n"..
            "col += texture2D(CC_Texture0, p + 6.0 * unit) * 0.09;\n"..
            "col += texture2D(CC_Texture0, p + 8.0 * unit) * 0.05;\n"..
            
            "float tempX = unit.x * -1.0;\n"..
            "unit.x *= 0.0;\n"..
            "col += texture2D(CC_Texture0, p - 8.0 * unit) * 0.05;\n"..
            "col += texture2D(CC_Texture0, p - 6.0 * unit) * 0.09;\n"..
            "col += texture2D(CC_Texture0, p - 4.0 * unit) * 0.12;\n"..
            "col += texture2D(CC_Texture0, p - 2.0 * unit) * 0.15;\n"..
            "col += texture2D(CC_Texture0, p                ) * 0.16;\n"..
            "col += texture2D(CC_Texture0, p + 2.0 * unit) * 0.15;\n"..
            "col += texture2D(CC_Texture0, p + 4.0 * unit) * 0.12;\n"..
            "col += texture2D(CC_Texture0, p + 6.0 * unit) * 0.09;\n"..
            "col += texture2D(CC_Texture0, p + 8.0 * unit) * 0.05;\n"..

            "unit.x = tempX;\n"..
            "unit.y *= 0.0;\n"..
            "col += texture2D(CC_Texture0, p - 8.0 * unit) * 0.05;\n"..
            "col += texture2D(CC_Texture0, p - 6.0 * unit) * 0.09;\n"..
            "col += texture2D(CC_Texture0, p - 4.0 * unit) * 0.12;\n"..
            "col += texture2D(CC_Texture0, p - 2.0 * unit) * 0.15;\n"..
            "col += texture2D(CC_Texture0, p                ) * 0.16;\n"..
            "col += texture2D(CC_Texture0, p + 2.0 * unit) * 0.15;\n"..
            "col += texture2D(CC_Texture0, p + 4.0 * unit) * 0.12;\n"..
            "col += texture2D(CC_Texture0, p + 6.0 * unit) * 0.09;\n"..
            "col += texture2D(CC_Texture0, p + 8.0 * unit) * 0.05;\n"..

        "return col.a / 4.0;\n"..
        "}" 
        
    local glProgram = cc.GLProgram:createWithByteArrays(vertDefaultSource,fsFsh)
--   "gl_FragColor = vec4( 0.0196 , 0.2901 , 0.4274 , alpha ) * alpha;\n"..
    local glProgramState= cc.GLProgramState:getOrCreateWithGLProgram(glProgram)
    shaderSpr:setGLProgramState(glProgramState)
     
    local v2 = cc.p(shaderSpr:getContentSize().width,shaderSpr:getContentSize().height)
    local pos = glProgram:getUniform("resolution").location
    glProgramState:setUniformVec2(pos,v2)
    
end


return BlurShaderCreate