

require "engine.uigridtools.NineGridTools"
require "ftue.ftue.ftuefactory.FtueItem"

local currentFtue=nil--:FtueItem;


local spanLeft = 20--; //距离左侧的距离
local spanUp = 20--; //距离上边缘的距离
local spanRight = 20--; //距离右侧的距离
local spanDown = 30--; //距离下侧的距离
local minWidth = 310--;


local DIR_NO=0
local DIR_RIGHT=1
local DIR_DOWN=2
local DIR_LEFT=3
local DIR_UP=4

--//对话框上头像显示方式
local AVA_Hide = 0
local AVA_LEFT=1
local AVA_RIGHT=2


local switchArrow = nil
local isDelay = false
local delayCounter = 0
local moveDelay = 1.2
local maxMoveDis2 = 60
local arrowSpeed2 = 55
local isPlaySwitchArrow = false;

FtueDialogue = class("FtueDialogue",function ()
    
    return cc.Layer:create()
end)



function FtueDialogue:ctor()
    
    self:setTouchEnabled(false)
    
    self.switchArrowLayer = cc.Layer:create()
    self:addChild(self.switchArrowLayer,1)
    self.switchArrowLayer:setTouchEnabled(false)
    self.isPlayArrow = false;
    isPlaySwitchArrow = false;

    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/ftue/FTUE_arrow0.png", "armature/ftue/FTUE_arrow0.plist" , "armature/ftue/FTUE_arrow.ExportJson" )
    self.arrow = ccs.Armature:create("FTUE_arrow")     
    -- 设置位置
--    self.arrow:setPosition(VisibleRect:center())
    self.arrow:retain()
    -- 播放动画, 播放指定动作
    --    self.arrow:getAnimation():play("1")
        
        
        
--    self.arrow = cc.Sprite:create("ui/ftue/FTUE_arrow.png")--  
--    self.arrow:retain()
    
    switchArrow = cc.Sprite:create("ui/ftue/FTUE_switch.png")
    
    switchArrow:retain()
                       
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/ftue/shou0.png", "armature/ftue/shou0.plist" , "armature/ftue/shou.ExportJson" )
    self.mouseClick = ccs.Armature:create("shou")    
    self.mouseClick:retain()
   
    self.mouseClick:setScale(0.3)           
                           
end


local function onWorldTimerHandler(spendsTimes)
    --//小箭头 动画延迟
    if isDelay then
        delayCounter = delayCounter + spendsTimes
        switchArrow:setCascadeOpacityEnabled(true)
        switchArrow:setOpacity(255 * (1.0 - delayCounter / moveDelay))--//渐隐

        if delayCounter >= moveDelay then

            local tmpAsPect = tonumber(currentFtue:getSwitchArrow():getAspect())
            local pstX,pstY = switchArrow:getPosition()

           
            local switchArrowRunX = VisibleRect:center().x + currentFtue:getSwitchArrow():getX()
            local switchArrowRunY = VisibleRect:center().y + currentFtue:getSwitchArrow():getY()

            




            if tmpAsPect == DIR_DOWN then
                switchArrow:setPosition(cc.p(pstX,pstY + maxMoveDis2))
                --                switchArrow.y = -maxMoveDis2;
            elseif tmpAsPect == DIR_LEFT then
                --                switchArrow.x = maxMoveDis2;
                switchArrow:setPosition(cc.p(switchArrowRunX,switchArrowRunY))
            elseif tmpAsPect == DIR_RIGHT then
                --                switchArrow.x = -maxMoveDis2;
                switchArrow:setPosition(cc.p(pstX-maxMoveDis2,pstY))
            elseif tmpAsPect == DIR_UP then
                --                switchArrow.y = maxMoveDis2;
                switchArrow:setPosition(cc.p(pstX,maxMoveDis2))
            end

            switchArrow:setOpacity(255 * 1.0 )      --
            isDelay = false;
            delayCounter = 0;
        end

        return;
    end


    --    //小箭头 动画
    if isPlaySwitchArrow then
        local tmpAsPect = tonumber(currentFtue:getSwitchArrow():getAspect())
        local pstX,pstY = switchArrow:getPosition()
      
        local switchArrowRunX = VisibleRect:center().x + currentFtue:getSwitchArrow():getX()
        local switchArrowRunY = VisibleRect:center().y + currentFtue:getSwitchArrow():getY()
        

        if tmpAsPect == DIR_DOWN then
            if (switchArrowRunY - pstY) > maxMoveDis2 then
                isDelay = true;
            end
            switchArrow:setPosition(cc.p(pstX,pstY - arrowSpeed2 * spendsTimes))
            return
        elseif tmpAsPect== DIR_LEFT then
            if  pstX - switchArrowRunX <= -maxMoveDis2 then
                isDelay = true;
            end
            switchArrow:setPosition(cc.p(pstX-arrowSpeed2 * spendsTimes,pstY))
            return
        elseif tmpAsPect== DIR_RIGHT then
            if pstX - switchArrowRunX >= maxMoveDis2 then
                isDelay = true;
            end
            switchArrow:setPosition(cc.p(pstX+arrowSpeed2 * spendsTimes,pstY))
            return
        elseif tmpAsPect== DIR_UP then
            if switchArrowRunY - pstY > -maxMoveDis2 then
                isDelay = true;
            end
            switchArrow:setPosition(cc.p(pstX,pstY+arrowSpeed2 * spendsTimes))
            
            return
        end
    end
end


function FtueDialogue:setDialogue(data)--data:FtueItem
    currentFtue = data;
    self:clear()
    
           
    if  currentFtue:getDialogue():getIsShow() == true then
        --//word
        
        self.talkWord = FacFont:getFontsBmp(FontType.FontYellowNoSide,currentFtue:getDialogue():getText()) 
        local textFieldW = self.talkWord:getContentSize().width
        local textFieldH = 0
        
        local isMulti = false
        
        if textFieldW > 500 then            
            textFieldW = 500
            isMulti = true
            self.talkWord = FacFont:getFontsBmp(FontType.FontYellowNoSide, currentFtue:getDialogue():getText(), textFieldW, "C");
        end
        
       print(self.talkWord:getAnchorPoint())
        
        local bgW = minWidth     
           
        if (textFieldW + spanLeft + spanRight) >= minWidth then
             bgW = textFieldW + spanLeft + spanRight                
        end
        
        
      
        local bgX = VisibleRect:center().x + currentFtue:getDialogue():getX()
        local bgY = VisibleRect:center().y + currentFtue:getDialogue():getY()
        
        
        
        local bgH = self.talkWord:getContentSize().height + spanUp + spanDown;
        
        
        self.bg = NineGridTools.create("ui/ui/bgTips.png" , bgW , bgH , 32)
        
        
                   
        self.bg:setPosition(cc.p(bgX + bgW * 0.5, bgY + bgH * 0.5))
                
        local bgTmpX,bgTmpY = self.bg:getPosition()
        
        textFieldH = self.talkWord:getContentSize().height
        
        if isMulti then
            self.talkWord:setPosition(cc.p(bgX + bgW  * 0.5 ,bgY + bgH*0.5 + 16 )) 
        else
            self.talkWord:setPosition(cc.p(bgX + bgW  * 0.5 ,bgY + bgH*0.5 + 22 )) 
        end
        
           -- - spanUp )) -- + (bgH- textFieldH)* 0.5)
                
        self.talkWord:setCascadeOpacityEnabled(true)
        
        self.talkWord:setOpacity(255 * 0.7)--透明度        
        
--      mouse Armature 处理鼠标动画的显示与否
        
        
        
        
        local petType = tonumber(currentFtue:getDialogue():getPetTypePar())
        
        if petType ~= AVA_Hide then
            if self.talker ~= nil then
                self.talker:removeFromParent();
            end
            
            self.talker = cc.Sprite:create("ui/ftue/" .. tostring(currentFtue:getDialogue():getPetName()) .. ".png")
        end
        
        if petType == AVA_Hide then
        
        elseif petType == AVA_LEFT then
            local bgx , bgy = self.bg:getPosition()
            
            local petX = bgx - bgW * 0.5 + self.talker:getContentSize().width * 0.5
            local petY = bgy  + bgH * 0.5 + self.talker:getContentSize().height * 0.5
                                             
            self.talker:setPosition(cc.p(petX,petY))
            self:addChild(self.talker)
            
        elseif petType== AVA_RIGHT then
            local bgx , bgy = self.bg:getPosition()

            local petX = bgx + bgW * 0.5 - self.talker:getContentSize().width * 0.5
            local petY = bgy  + bgH * 0.5 + self.talker:getContentSize().height * 0.5

            self.talker:setPosition(cc.p(petX,petY))
            self:addChild(self.talker)
        end
        
        self:addChild(self.bg)
        self:addChild(self.talkWord);
        
        
        
        if not data.trigger then

            local bgx , bgy = self.bg:getPosition()
            
            local mouseClickX = bgx + bgW * 0.5 - 50 * MainValue.winSize.width/684
            local mouseClickY = bgy - bgH * 0.5 +  50 * MainValue.winSize.height/1024
 
            self.mouseClick:setPosition(cc.p(mouseClickX+25,mouseClickY-15))
            self:addChild(self.mouseClick);
            self.mouseClick:getAnimation():play("1",3,1) 
        end
        
    end
           
            
--            //arrow
            
    if (currentFtue:getArrow()~=nil) and currentFtue:getArrow():getIsShow() then 
        self.isPlayArrow = true;                
        local arrowAspect = tonumber(currentFtue:getArrow():getAspect())
        
        local offsetX = 0
        local offsetY = 0
        
        
        if arrowAspect == DIR_DOWN then
            self.arrow:setRotation(math.deg(-math.pi/2))  --.rotation = -Math.PI / 2;  是以箭头自身的中心点为中心旋转 角度转化成弧度
            offsetY = -self.arrow:getContentSize().height
        elseif arrowAspect == DIR_LEFT then
--            offsetX = -self.arrow:getContentSize().width *0.5
        elseif arrowAspect == DIR_RIGHT then
            self.arrow:setRotation(math.deg(math.pi))
            offsetX = -self.arrow:getContentSize().width
            offsetY = -self.arrow:getContentSize().height
        elseif arrowAspect == DIR_UP then
            self.arrow:setRotation(math.deg(math.pi/2))
            offsetX = self.arrow:getContentSize().width
        end  
        local arrowX = VisibleRect:left().x + currentFtue:getArrow():getX() 
        local arrowY = VisibleRect:bottom().y + currentFtue:getArrow():getY()
        
        
         
        
        self.arrow:getAnimation():play("1")    
        self.arrow:setPosition(cc.p(arrowX+offsetX,arrowY+offsetY))
        
        self:addChild(self.arrow)
    end
            

    if  currentFtue:getSwitchArrow()~=nil and currentFtue:getSwitchArrow():getIsShow() then
        isPlaySwitchArrow = true 
        --往下 52px 修正值        
        

        local switchArrowX = VisibleRect:center().x + currentFtue:getSwitchArrow():getX()
        local switchArrowY = VisibleRect:center().y + currentFtue:getSwitchArrow():getY()
        
        
        
           -- 实际的  游戏中 左下角 00点的坐标  y值 还没有加上自身高度的一般 ？？？？？
        switchArrow:setPosition(cc.p(switchArrowX,switchArrowY))
--        self:addChild(switchArrow)
        self.switchArrowLayer:addChild(switchArrow)
        self.switchArrowLayer:setTouchEnabled(false)
     end
     if self.schedulerName == nil then
        self.schedulerName = cc.Director:getInstance():getScheduler():scheduleScriptFunc(onWorldTimerHandler, 0, false)
    end
end









function FtueDialogue:clear()
   
    if self.schedulerName ~= nil then
        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.schedulerName)
        self.schedulerName = nil
    end
    
    if self.talker ~= nil then
        if self.talker:getParent() ~= nil then
            self.talker:getParent():removeChild(self.talker)
            self.talker = nil
        end
    end
    
    if self.talkWord ~= nil then
        if self.talkWord:getParent() ~= nil then
            self.talkWord:getParent():removeChild(self.talkWord)
            self.talkWord = nil
        end
    end
    if self.bg ~= nil then
        if self.bg:getParent() ~= nil then
            self.bg:getParent():removeChild(self.bg)
            self.bg = nil
        end
    end
    
     if self.mouseClick ~= nil then
        if self.mouseClick:getParent() ~= nil then
            self.mouseClick:getParent():removeChild(self.mouseClick)
        end
    end
    
    if self.arrow ~= nil then
        if self.arrow:getParent() ~= nil then
            self.arrow:getParent():removeChild(self.arrow)
            self.arrow:getAnimation():stop()
        end
    end
    
    if switchArrow ~= nil then
        if switchArrow:getParent() ~= nil then
            switchArrow:getParent():removeChild(switchArrow)            
        end
    end
    
    isDelay = false
    delayCounter = 0
    self.isPlayArrow = false;
    isPlaySwitchArrow = false;
end


return FtueDialogue