require("ftue.ftue.ftuefactory.DrawCell")
FtueDigHoleCreate = class("FtueDigHoleCreate")

-- 外框的尺寸和内框的尺寸
function FtueDigHoleCreate:ctor()
    self.otherData = nil
    
    self.drawGridW = 0 --绘制other图形宽
    
    self.drawGridH = 0 --绘制other图形高
    
    self.blackTexture = MainValue.mxFTUEManager:getFtuet():getFtueAssets():getFtueTextureFrame("black")  
    
    self.digHoleRectAry = {}
end

local function debug(...)
    print(string.format(...))
end

function FtueDigHoleCreate:createDrawDigHole(otherDataPar,rowNumPar,colNumPar,otherStartIndexXPar,otherStartIndexYPar,operateOtherData)
    self.rowNum = rowNumPar
    self.colNum = colNumPar
    self.otherStartIndexX = otherStartIndexXPar
    self.otherStartIndexY = otherStartIndexYPar
    
    self.otherData = otherDataPar
    self.drawGridH = table.maxn(otherDataPar)-2    
    self.drawGridW = table.maxn(otherDataPar[1])-2
    self.digHoleCoordinaAry = {}

    for roundY = 1 , self.drawGridH do
        for roundX = 1 , self.drawGridW do
            if not otherDataPar[roundY+1][roundX+1] then
--                self:setDrawAttribute(roundY,roundX) --只是挖空的坐标    false 是空
                local digHoleDrawCell = DrawCell.new(roundX,roundY,false)
                   if not operateOtherData[roundY+1][roundX+1] then
                        digHoleDrawCell:setCanOperate()
                   end
                table.insert(self.digHoleCoordinaAry,digHoleDrawCell)
            end            
        end
    end
    
  
end

function FtueDigHoleCreate:drawOtherShap()
    self.endShape = cc.Sprite:create()
    self.gridCellW = 80;
    self.gridCellH = 80;
    
    --绘制单元格的 包含的图形 {1 2 3 4 5 6 7 8  } 1左上角  2上边线  3右上角   4右边线     5右下角     6下边线   7左下角   8左边线
    self.shapeTotalW =  self.drawGridW * self.gridCellW
    self.shapeTotalH =  self.drawGridH * self.gridCellH   
    
--    self.color4B = cc.c4b(153,153,153,100)  -- ccDrawColor4B(255,0,0,0)        100 可以设置透明度 灰色
--    self.shapeArea = cc.LayerColor:create(self.color4B,self.shapeTotalW,self.shapeTotalH) --TODO 挖洞实际占用总面积
    
--    self.shapeArea:setPosition(self.shapeTotalW * 0.5,self.shapeTotalH * 0.5)
    
--    print(self.digHoleCoordinaAry)
--    endShape:addChild(self.shapeArea)

    if self.digHoleRectAry~=nil then
        self.digHoleRectAry = nil
        self.digHoleRectAry = {}
    end

    
    for i = 1,#(self.digHoleCoordinaAry) do
    
        local drawCell = self.digHoleCoordinaAry[i]    
        local tarIndexX = drawCell:getIndexX() 
        local tarIndexY = drawCell:getIndexY()
        
        local tmpBackTexture = cc.Sprite:createWithTexture(self.blackTexture)            
        local tmpBackTextureX = (tarIndexX-1) * self.gridCellW + 40  --注册点是中心 
        local tmpBackTextureY = self.shapeTotalH - (tarIndexY-1) * self.gridCellW - 40
        tmpBackTexture:setPosition(tmpBackTextureX,tmpBackTextureY)        
        self.endShape:addChild(tmpBackTexture)
        
        --        根据 tarIndexY  tarIndexX 来和 self.digHoleCoordinaAry 中的对比除了自身 看看周围那个方向可以挖洞 做 没有间隙的操作区域挖洞
        if drawCell:getCanOperate()==true then
            -- 1上  2右  3下   4左 ！！！！！！！！！  但是如果只有一格呢！！
            local operateDir = self:getDigHoleCanOperateDir(tarIndexX,tarIndexY)
--            if operateDir == 1 then--当前扣洞位置 上面可以扣洞
--                table.insert(self.digHoleRectAry,cc.rect(tmpBackTextureX - 30,tmpBackTextureY - 30,60,70)) --处理可以操作区域的挖洞区域 2014-12-2
--            elseif operateDir == 2 then --当前扣洞位置 右面可以操作
--                table.insert(self.digHoleRectAry,cc.rect(tmpBackTextureX - 30,tmpBackTextureY - 30 ,70,60)) --处理可以操作区域的挖洞区域 2014-12-2
--            elseif operateDir == 3 then --当前扣洞位置 下面可以操作
--                table.insert(self.digHoleRectAry,cc.rect(tmpBackTextureX - 30 ,tmpBackTextureY - 40,60,70)) --处理可以操作区域的挖洞区域 2014-12-2
--            elseif operateDir == 4 then --当前扣洞位置 左面可以操作
--                table.insert(self.digHoleRectAry,cc.rect(tmpBackTextureX - 40, tmpBackTextureY -30,70,60)) --处理可以操作区域的挖洞区域 2014-12-2
--            elseif operateDir == 0 then --当前扣洞位置 左面可以操作  但是如果只有一格呢！！
--                table.insert(self.digHoleRectAry,cc.rect(tmpBackTextureX - 30,tmpBackTextureY -30,70,70))  --处理可以操作区域的挖洞区域 2014-12-12
--            end
            
            -- 上面是 2015 - 1 - 12 第一版 
            
            if operateDir == 1 then--当前扣洞位置 上面可以扣洞
                table.insert(self.digHoleRectAry,cc.rect(tmpBackTextureX - 40,tmpBackTextureY - 40,80,80)) --处理可以操作区域的挖洞区域 2014-12-2
            elseif operateDir == 2 then --当前扣洞位置 右面可以操作
                table.insert(self.digHoleRectAry,cc.rect(tmpBackTextureX - 40,tmpBackTextureY - 40 ,80,80)) --处理可以操作区域的挖洞区域 2014-12-2
            elseif operateDir == 3 then --当前扣洞位置 下面可以操作
                table.insert(self.digHoleRectAry,cc.rect(tmpBackTextureX - 40 ,tmpBackTextureY - 40,80,80)) --处理可以操作区域的挖洞区域 2014-12-2
            elseif operateDir == 4 then --当前扣洞位置 左面可以操作
                table.insert(self.digHoleRectAry,cc.rect(tmpBackTextureX - 40, tmpBackTextureY -40,80,80)) --处理可以操作区域的挖洞区域 2014-12-2
            elseif operateDir == 0 then --当前扣洞位置 左面可以操作  但是如果只有一格呢！！
                table.insert(self.digHoleRectAry,cc.rect(tmpBackTextureX - 40,tmpBackTextureY -40,80,80))  --处理可以操作区域的挖洞区域 2014-12-12
            end           
                       
        end
                
--        table.insert(self.digHoleRectAry,cc.rect(tmpBackTextureX,tmpBackTextureY,80,80)) --处理可以操作区域的挖洞区域 2014-12-2
                     
     end    
    self.endShape:setContentSize(MainValue.winSize.width,MainValue.winSize.height)
    self.endShape:setAnchorPoint(0.5,0.5)
    
--    self.rowNum
--    self.colNum

    self.endX = MainValue.winSize.width-- 此时刚好是挖洞点在屏幕中心点
    self.endY = MainValue.winSize.height-- 此时刚好是挖洞点在屏幕中心点
    
--    print("实际画的宽：："..self.drawGridW) 2  
--    print("实际画的高：："..self.drawGridH) 3

    self.endX = self.endX - (self.colNum/2 -(self.otherStartIndexX -1 )) * 82  
    self.endY = self.endY- self.shapeTotalH - 52 + (self.rowNum / 2 - self.otherStartIndexY + 1) * 82  -- 52修正值  和huangqihui 的同样移动

--     print("实际画indexX::"..self.otherStartIndexX)  3
--     print("实际画indexY::"..self.otherStartIndexY)  3    
    self.endShape:setPosition(self.endX,self.endY) --定义坐标的处理        
    return self.endShape
    
end

function FtueDigHoleCreate:getCanOperatorRectAry()



--    self.drawGridH 
--    self.drawGridW
--     
--    cc.p(self.endX,self.endY)
--    self.digHoleRectAry
    
end


function FtueDigHoleCreate:getDigHoleCanOperateDir(indexX,indexY)
    local neighborSign = 0  --0 周边都不挖洞     1上  2右  3下   4左     
    for i = 1,#(self.digHoleCoordinaAry) do
        local tmpDrawCell = self.digHoleCoordinaAry[i]
        if tmpDrawCell:getCanOperate()==true then
            if tmpDrawCell:getIndexX()==indexX and tmpDrawCell:getIndexY()~=indexY then
                if tmpDrawCell:getIndexY() > indexY then
                    neighborSign = 3
                else
                    neighborSign = 1
                end
            elseif tmpDrawCell:getIndexX()~=indexX and tmpDrawCell:getIndexY()==indexY then
                if tmpDrawCell:getIndexX() > indexX then
                 neighborSign = 2
                else
                 neighborSign = 4
                end
            end
        end        
    end
    
    return neighborSign
end



function FtueDigHoleCreate:getDigHoleOtherAry()
    
    return self.digHoleRectAry
end

function FtueDigHoleCreate:getEndShapePos()
    return cc.p(self.endX,self.endY)
end

return FtueDigHoleCreate