require "sound.ConstEffects"
require("ftue.ftue.ftuefactory.FtueDigHoleCreate")
require("ftue.ftue.ftuefactory.BlurShaderCreate")
require("ftue.ftue.ftuefactory.FtueDigRectCreate")
require "config.mapConfig"
require "game.GameValue"

local GameManager = class("GameManager");


local GAME_RESULT_WIN = 1;
local GAME_RESULT_LOST = 0;
local GAME_RESULT_QUIT = -1;

local itemBottomBar = nil;

local collectAimUI= nil
local uiLayer
local state = nil;
local shaderBg = nil;
local frameTextureOuterContourSprEndReal = nil;
function GameManager:ctor()
    self.layer = cc.Layer:create();
    
   
    
    self.inGameStartPanel = nil; --开始goals面板
    self.failedPanel = nil; --失败百叶窗面板
    
    local gameStatusManagercls = require("game.GameStatusManager")
    self.gameStatusManager = gameStatusManagercls.create()
    
    self = self:initGameResultData();
end

function GameManager:initGameResultData()
    self.inGameInit = false;--是否进入过游戏
    self.winScore = nil; --胜利分数
    self.bestScore = nil; --历史最好得分
    self.starData = nil; --当前关卡星星配置数据
    self.loseData = nil; --失败原因数据
    self.exitType = nil; --退出类型（win or lose）
    self.targetData = nil; --收集目标数据
    self.panelCount = 0; --胜利面板后需要显示面板数量
    self.loadingPanel = nil; --连接FB的loading面板
    
    
    self.loseCount = 0;
end;


--[[保存胜利数据]]
function GameManager:setWin(scores, starData)
    
   
    
    self.oldScore,self.oldStarNum  = MainValue.dataManager.levelManager:getLevel(MainValue.SELECTED_LEVEL);
    
    self.winScore = scores;
    self.starData = starData;
    

    self.exitType = GAME_RESULT_WIN;
end

--[[保存失败数据]]
function GameManager:setLose(loseData)
    MainValue.dataManager.userManager:subHeart(1);--失败扣心

    self.loseData = loseData;

    self.exitType = GAME_RESULT_LOST;
end

--[[退出游戏，进入地图]]
function GameManager:onQuitMatchGame()
    if self.exitType == nil then
        return ;
    end

    if self.exitType == GAME_RESULT_WIN then
        MainValue.mxUIManager:showWinPanel(self.winScore, self.starData,self.oldScore,self.oldStarNum);

    elseif self.exitType == GAME_RESULT_LOST then
        self.loseCount = self.loseCount + 1;
        MainValue.mxUIManager:showOverPanel(self.loseData);
    else 
        self.loseCount = self.loseCount + 1;
    end

    self.exitType = nil;
end

--[[判断胜利面板后续面板是否显示完毕]]--
function GameManager:setShowPanelCount(count, isPlus)
    isPlus = isPlus or false;

    if isPlus then
        self.panelCount = self.panelCount + count;
    else
        self.panelCount = self.panelCount - count;

        if self.panelCount <= 0 then --后续面板显示完毕，头像开始走蚂蚁线
            self:hasNewLevel();
            self.panelCount = 0;
        end
    end
end

--显示连接FB的loading
function GameManager:showConnectFBLoading()
    if MainValue.mxUIManager.state == 1 then
        local FBConnectCls = require("ui/FBConnect/FBConnectPanel")
        self.loadingPanel = FBConnectCls.create();
        self.loadingPanel:appearAlone();
    end
end

--关闭loading显示成功
function GameManager:showConnectFBSuccess(isSuccesss)
    if self.loadingPanel ~= nil then
        self.loadingPanel:disapperAlone(isSuccesss);
    end
end

--打开宝箱面板
function GameManager:openChests()
    if MainValue.SELECTED_LEVEL % 10 == 0 then
        local pbcInfo = mapConfig.box[MainValue.SELECTED_LEVEL/10];
        local blockerLockcls = require("ui/boxLock/BoxLockPanel");
        local blockerLock = blockerLockcls.create(pbcInfo,1);
        blockerLock:appear();
    end
end
--[[游戏内提示道具]]--
function GameManager:onPropsPrompt(goodId)
--    itemBottomBar:onPropsPrompt(goodId);
end;
--[[检验下一关]]
function GameManager:hasNewLevel()
    --    if MainValue.SELECTED_LEVEL % 10 == 0 and not MainValue.mxUIManager.mapManager:isSuccesBlocker(MainValue.SELECTED_LEVEL) then
    --        return;
    --    end

    --    if MainValue.SELECTED_LEVEL ~= MainValue.dataManager.levelManager:getMaxLevel() and  MainValue.SELECTED_LEVEL < MainValue.mxUIManager.mapManager:getMaxLevel() then
    --        MainValue.mxUIManager.mapManager:upDateMission(MainValue.SELECTED_LEVEL);
    --    end
    MainValue.mxUIManager.mapManager:upDateMission(MainValue.SELECTED_LEVEL);
end

--[[开启下一关面板]]
function GameManager:openNewLevel()

    --弹出5星评论
    local newLevel = MainValue.dataManager.levelManager:getMaxLevel();

    if newLevel > MainValue.mxUIManager.mapManager:getMaxLevel() then
        return;
    end


    if newLevel == 11 then
        MainValue.statisticsManager:CustomTutorialComplete();
    -- 2015-6-18 暂时注释 
    MainValue.statisticsManagerOG:CustomTutorialComplete();
    end; 

    print("[GameManager.lua] newLevelNum ：：：",newLevel)
    --已经是新的关卡 判断是否有要解锁的道具 如果有就显示解锁道具面板  2015-1-8    
    local isUnlockingProp = MainValue.dataManager.goodsManager:havePropIsUnlockingByLv(newLevel)
    if isUnlockingProp ~= nil then
    --        填出解锁道具面板 2015-1-29 临时取消
    --        local UnlockItemClz = require("ui/UnlockItemPanel")
    --        local unlockItem = UnlockItemClz.new()
    --        unlockItem:initData(isUnlockingProp)
    --        unlockItem:appear();
    end


    local playGamePanel = PlayGamePanel.create(newLevel);
    playGamePanel:appear();
end

function GameManager.create()
    --obj = loadstring("return "..obj)();
    GameValue:init();
    
    local temp = GameManager.new();
    temp.layer:addChild(GameValue.mxGameLayer)
   -- SetGameLayer(GameValue.mxGameLayer)
    uiLayer = GameValue.mxGameLayer:getUILayer();
    
    return temp;
end

function GameManager:getGameLoseCount()
    return self.loseCount;
end

-----------------------------------------调游戏核心接口---------------------------------------------------------------

--主动退出游戏
function GameManager:gameExitGame()
    MainValue.dataManager.userManager:subHeart(1);--失败扣心
    
    MainValue.outBuyAry = nil
    MainValue.outBuyAry = {}
    
    state = 0; 
    self.exitType = GAME_RESULT_QUIT;
    GameValue.mxGameControler:gameEnd();
    --统计
    MainValue.statisticsManager:play("[-1,-4]",0,MainValue.SELECTED_LEVEL,0,0,"");
end

--游戏退出
function GameManager:exitGame()
    MainStatus:onExitGame();
    MainStatus:onEnterMap();
    MainValue.soundManager:playMusic(0,true);
end


function GameManager:initUI()
    MainValue.mxLoadingManager:recessiveLoad() --隐性加载游戏外资源
    
    local collectAimUIrsc = require("ui.collectaimui.CollectAimUI")
    collectAimUI = collectAimUIrsc.new();
    collectAimUI:setPosition(cc.p( VisibleRect:center().x,  VisibleRect:center().y + 490));
    uiLayer:addChild(collectAimUI); 

    self.addItemBottomBar();
end


function GameManager:addItemBottomBar()
    local itemBar = require("ui.inGame.ItemBottomBar");
    itemBottomBar = itemBar.create()
   -- itemBottomBar:setPosition(VisibleRect:bottom().x - 60,VisibleRect:bottom().y + 6);
    itemBottomBar:setPosition(VisibleRect:left().x,VisibleRect:leftBottom().y + 6);
    uiLayer:addChild(itemBottomBar); 

end
function GameManager:resetItemBottomBar()
    if itemBottomBar ~= nil then
        itemBottomBar:setPosition(VisibleRect:left().x ,VisibleRect:leftBottom().y + 6);
    end
end

function GameManager:appearItemBottomBar()
   if itemBottomBar ~= nil then
        local ac = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.3,cc.p(0, -200)), 0.15));
        itemBottomBar:runAction(ac);
   end
end

function GameManager:disappearItemBottomBar()
    if itemBottomBar ~= nil then
        local ac = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.3,cc.p(0, 200)), 0.15));
        itemBottomBar:runAction(ac);
    end
end


function GameManager:useItemAni(goodId)

    if shaderBg == nil then
        shaderBg = GameValue.mxGameLayer:getGameBackBoxBorder();

        frameTextureOuterContourSprEndReal = cc.RenderTexture:create(MainValue.winSize.width,MainValue.winSize.height)
        self.frameTextureOuterContourSprEnd = cc.RenderTexture:create(MainValue.winSize.width,MainValue.winSize.height)

        self.frameTextureOuterContourSprEnd:begin()    
        shaderBg:visit() --要截屏的场景    
        self.frameTextureOuterContourSprEnd:endToLua()

        local blurShaderCreate = BlurShaderCreate.new()     
        blurShaderCreate:setBlurShader(self.frameTextureOuterContourSprEnd:getSprite())

        self.frameTextureOuterContourSprEnd:getSprite():setPosition(VisibleRect:center()) 


        frameTextureOuterContourSprEndReal:begin()  
        self.frameTextureOuterContourSprEnd:getSprite():visit() --要截屏的场景    
        frameTextureOuterContourSprEndReal:endToLua()


        frameTextureOuterContourSprEndReal:getSprite():setPosition(VisibleRect:center())

        if frameTextureOuterContourSprEndReal:getSprite():getParent() ~= nil then
            frameTextureOuterContourSprEndReal:getSprite():getParent():removeChild(frameTextureOuterContourSprEndReal:getSprite())
        end
        frameTextureOuterContourSprEndReal:retain()
        uiLayer:addChild(frameTextureOuterContourSprEndReal:getSprite());
        
        
       
        local name = string.format("goods%d",goodId);
        self.armature = ccs.Armature:create(name);
        self.armature:setName("animation");
        self.armature:getAnimation():playWithIndex(1);
        uiLayer:addChild(self.armature);
     --   self.armature:setPosition(VisibleRect:rightBottom().x - self.armature:getContentSize().width-15,VisibleRect:rightBottom().y + self.armature:getContentSize().height + 20);
        local xx = VisibleRect:rightBottom().x;
        local w= self.armature:getContentSize().width
        local yy = shaderBg:getPositionY()/2 + 10;
        self.armature:setPosition(xx - w-15,yy);
       
        self.good = MainValue.infosManager:getObjGoodsById(goodId);
        local x1 = xx- 2*w - 15;
        self.goodsText = FacFont:getFontsBmp(FontType.FontWhite,self.good.des,x1,"C",-10);
        uiLayer:addChild(self.goodsText);  
        local x0 = VisibleRect:bottom().x - 40;
        self.goodsText:setPosition(x0,yy);
        
        self.goodsDes = FacFont:getFontsBmp(FontType.FontWhite,self.good.des2,x1,"C",-10);
        uiLayer:addChild(self.goodsDes);  
        local y0 = yy - self.goodsText:getContentSize().height/1.2;
        self.goodsDes:setPosition(x0,y0);
        
    end
end

function GameManager:removeItemAni()


    if frameTextureOuterContourSprEndReal~=nil and frameTextureOuterContourSprEndReal:getSprite() ~= nil and frameTextureOuterContourSprEndReal:getSprite():getParent() then
        frameTextureOuterContourSprEndReal:getSprite():getParent():removeChild(frameTextureOuterContourSprEndReal:getSprite())
        frameTextureOuterContourSprEndReal = nil
    end
   if shaderBg ~= nil then
       shaderBg:removeFromParent(true);
       shaderBg = nil;
   end
   if self.armature ~= nil then
      self.armature:removeFromParent(true);
      self.armature = nil;
   end
    if self.goodsText ~= nil then
       self.goodsText:removeFromParent(true);
       self.goodsText = nil;
   end
   
    if self.goodsDes ~= nil then
        self.goodsDes:removeFromParent(true);
        self.goodsDes = nil;
    end
   
end

function GameManager:buyInGamePropsSuc(id)
    itemBottomBar:useItem(id);
end;


--[[设置步数]]--
function GameManager:setUIStep(limitStepNum)
    
    collectAimUI:setUIStep(limitStepNum)
    
--    if self.propAry~=nil then
--        self.tarTotalStepNum = limitStepNum
--        for index = 1,table.maxn(self.propAry) do
--            if tonumber(self.propAry[index]) == 101 then            
--                --collectAimUI:setUIStep(self.tarTotalStepNum - 2)            
--            end
--        end       
--    end

end

--[[设置分数]]--
function GameManager:setUIScores(scores)
    collectAimUI:setUIScores(scores)
end

--设定当前关卡的行数和列数
function GameManager:setTargetConfig(rowNum,colNum)
--    cclog("GameManager:setTargetConfig()");
    self.rowNum = rowNum;
    MainValue.mxFTUEManager:setTargetConfig(rowNum,colNum)    
end



--[[设置过关分数 和 当前关卡级别  {100,2000,12000}   2  --]]
function GameManager:setInitCollectAimData(scoresAry,tarLv)

    local scoreArr = {scoresAry[1].score,scoresAry[2].score,scoresAry[3].score};
    
    collectAimUI:setInitCollectAimData(scoreArr,tarLv);

    
end
function GameManager:showAddTwoStepAni()
    collectAimUI:showAddTwoStepAni()
end;

function GameManager:getState()
   return state;
end

function GameManager:showFtueByLv(tarLv)
    
    MainValue.mxFTUEManager:setTargetConfig(GameValue.mxMissionManager.m_maxRow,GameValue.mxMissionManager.m_maxCol);


    
--    print("self.propAry"..self.propAry)
    
    
    
    --    ftue的显示处理
--    MainValue.mxLoadingManager:addLoading()
    if tarLv == 1 then
        MainValue.mxFTUEManager:showFtueById(11)
    elseif tarLv == 2 then
        MainValue.mxFTUEManager:showFtueById(21)
    elseif tarLv == 3 then
        MainValue.mxFTUEManager:showFtueById(31)
    elseif tarLv == 4 then
        MainValue.mxFTUEManager:showFtueById(41)
    elseif tarLv == 5 then
        MainValue.mxFTUEManager:showFtueById(52)
    elseif tarLv == 6 then
        MainValue.mxFTUEManager:showFtueById(62)
    elseif tarLv == 7 then
        MainValue.mxFTUEManager:showFtueById(71)
    elseif tarLv == 9 then
        MainValue.mxFTUEManager:showFtueById(91)
    elseif tarLv == 10 then
        MainValue.mxFTUEManager:showFtueById(101)
    elseif tarLv == 11 then
        MainValue.mxFTUEManager:showFtueById(112)
    elseif tarLv == 12 then
        MainValue.mxFTUEManager:showFtueById(122)
    elseif tarLv == 13 then
        MainValue.mxFTUEManager:showFtueById(131)
    elseif tarLv == 14 then
        MainValue.mxFTUEManager:showFtueById(141)    
    elseif tarLv == 16 then
        MainValue.mxFTUEManager:showFtueById(161)
    elseif tarLv == 17 then
        MainValue.mxFTUEManager:showFtueById(171)
    elseif tarLv == 18 then
        MainValue.mxFTUEManager:showFtueById(181)
    elseif tarLv == 19 then
        MainValue.mxFTUEManager:showFtueById(191)
    elseif tarLv == 20 then
        MainValue.mxFTUEManager:showFtueById(202)
--    elseif tarLv == 10 then
--        MainValue.mxFTUEManager:showFtueById(101)
--    elseif tarLv == 12 then
--        MainValue.mxFTUEManager:showFtueById(121)
--    elseif tarLv == 14 then
--        MainValue.mxFTUEManager:showFtueById(141)
    else
    self:removeFtue()
--    elseif tarLv == 4 then
--        MainValue.mxFTUEManager:showFtueById(41)
--    elseif tarLv == 5 then
--        MainValue.mxFTUEManager:showFtueById(51)
--    elseif tarLv == 6 then
--        MainValue.mxFTUEManager:showFtueById(61)
--	elseif tarLv == 7 then
--	    MainValue.mxFTUEManager:showFtueById(71)
--    elseif tarLv == 8 then
--        MainValue.mxFTUEManager:showFtueById(81)
--    elseif tarLv == 9 then
--        MainValue.mxFTUEManager:showFtueById(91)
--    elseif tarLv == 12 then
--        MainValue.mxFTUEManager:showFtueById(121)
--    elseif tarLv == 16 then
--        MainValue.mxFTUEManager:showFtueById(161)
--    elseif tarLv == 21 then
--        MainValue.mxFTUEManager:showFtueById(211)
    end
end
--@param ftueIdPar 供给游戏内调用指定id 的ftue
function GameManager:showFtueById(ftueIdPar)
    MainValue.mxFTUEManager:showFtueById(ftueIdPar) -- 163
end
function GameManager:removeFtue()
    MainValue.mxFTUEManager:removeFtue()
end
function GameManager:getTargetFtueIdIsPassed(ftueIdPar)
    return true 
    --TODO:::根据传进来的id 判断此ftue是否已经出现过    
end

--调用游戏内消除组的坐标位置 供给点亮星星的特效用
function GameManager:getFlyToPst()
    return GameValue.mxDataControler:getCurrentClearPostion(); 
end

function GameManager:getCanClickGameUI()
    return GameValue.mxGameControler:getIsCanClickUI();
end;


--[[设置过关目标 string id, int num, int sum]]--
function GameManager:setUITarget(id, num, sum)
    collectAimUI:setUITarget(id, num, sum)  
    collectAimUI:getTarPstByTypeId(id)   
end

function GameManager:isGameIn()
    return GameValue.mxGameControler.m_ingame
end



--[[通知游戏使用道具]]--
function GameManager:useBuyPros(goodId)
    --GameUseBuyProp(goodId)   
    GameValue.mxGameControler:useBuyProp(goodId);     
    cclog("GameManager:useBuyPros = "..goodId);
end

--[[通知游戏取消道具]]--
function GameManager:cancelBuyProp(goodId)
    --GameCancelBuyProp(goodId) 
    
    GameValue.mxGameControler:cancelBuyProp();
    cclog("GameManager:cancelBuyProp = "..goodId);
end

--[[游戏内确定使用了道具]]--
function GameManager:useBooster(goodId)
    cclog("GameManager:useBooster = "..goodId);
    local isUsed = true;
    MainValue.dataManager.taskManager:setUsePorp(goodId);
    itemBottomBar:cancelProp(goodId,isUsed);
end 

--[[游戏内取消了正在使用的道具]]--
function GameManager:cancelProps(goodId)
    local isUsed = false;
    itemBottomBar:cancelProp(goodId,isUsed);
    cclog("GameManager:cancelProps ！");
end 

--[[前置道具初始化]]-------
function GameManager:setProps(item1,item2,item3,item4,item5,item6)
    cclog("GameManager:setProps ！");
    itemBottomBar:setProps(item1,item2,item3,item4,item5,item6);
end 

--[[前置道具是否可以使用]]-------
function  GameManager:setCanUseProps(canUse)
    cclog("GameManager:setProps ！"..canUse);
end

--[[步数为0 并且没有过关]]--
function GameManager:showNoStepUI(scores, obj)
    cclog("GameManager:showNoStepUI ！");
--    MainValue.mxUIManager:showOverAlarmPanel(obj);

    if BuyFlowValue.buyStepsAry == nil or table.maxn(BuyFlowValue.buyStepsAry) == 0 then
        BuyFlowValue.buyStepsAry = {}

        local tmpBuyLifeData = BuyFlowData.new(BuyFlowValue.buyStepsUI) 
        tmpBuyLifeData:setFailData(3, obj)           
        BuyFlowValue.buyStepsAry[1] = tmpBuyLifeData                                            
    end

    local notReachClz = require("ui/inGame/InGameFailedPanel")
    self.failedPanel = notReachClz.create();
    self.failedPanel:setData(3, obj);
    self.failedPanel:appear();
end 

--[[失败结算界面]]--
function GameManager:showLoseUI(scores, obj)
    cclog("GameManager:showLoseUI ！");
    self:setLose(obj);
end

--[[游戏进入某状态]]--
function GameManager:enterGameStatus(status)
    cclog("GameManager:enterGameStatus = "..status);
    collectAimUI:setGameStatus(status) 
end

--[[购买步数]]--
function GameManager:buySteps(sum)
   
    
    GameValue.mxGameControler:buySteps(sum);
    cclog("GameManager:buySteps = "..sum);
end

--[[取消购买步数]]--
function GameManager:cancelBuySteps()
    
    GameValue.mxGameControler:cancelbuySteps();
     
    cclog("GameManager:cancelBuySteps");
end

--[[胜利界面结算]]--
function GameManager:showWinUI(scores, stars)
    cclog("GameManager:showWinUI !");
    self:setWin(scores, stars);
    MainValue.dataManager.levelManager:saveLevel(MainValue.SELECTED_LEVEL,stars,scores,1)
    
    
   
end 

--[[获取星星信息]]--
function GameManager:getStarsStatus()
   -- cclog("GameManager:getStarsStatus() !");
    --local tempStr = GameGetStarsStatus();
   -- tempStr = loadstring("return "..tempStr)();
    
    return "";
end




--[[bossId]]--
function GameManager:getBossId()
    --local tempNum = GameGetBossId();
    return nil;
end


function GameManager:palyGameSetFrontProps(propAryPar)
    self.propAry = propAryPar
    
    
    GameValue.mxDataControler:setFrontBooster(propAryPar);
end


---------------------------------------------------------------------------------------------------------------
--进入游戏开始界面
function GameManager:onEnterSplash()
end

--退出游戏开始界面
function GameManager:onExitSplash()
end 

--进入地图
function GameManager:onEnterMap()
    self:onQuitMatchGame();
    self.propAry = nil
end 

--退出地图
function GameManager:onExitMap()
end

--进入游戏
function GameManager:onEnterGame()
     if self.inGameInit == false then
        self:initUI();
        self.inGameInit = true;
    end
    
    collectAimUI:elephantAniInitUI()
    state = 1;
   
    GameValue:start(MainValue.SELECTED_LEVEL);
    
    local mapId = math.ceil(MainValue.SELECTED_LEVEL/10);
    local musicId = mapConfig.gameMusic[mapId];
    MainValue.soundManager:playMusic(tonumber(musicId) ,true);
end
--onEnteredGame

--退出游戏
function GameManager:onExitGame()
    collectAimUI:GC()
    itemBottomBar:removeAnimate();
    BuyFlowValue.innerBuyAry = nil
--    collectAimUI:removeFromParent(true)
end

--@param swapPstAry 根据当前交换的坐标来判断是否允许交换
function GameManager:isAllowSwapByFtue(swapPstAry)
    return MainValue.mxFTUEManager:isAllowSwapByFtue(swapPstAry)
end


function GameManager:playSoundEffect(name)
    MainValue.soundManager:playEffect(name);
end;

function GameManager:backPack()
    return false; 
end
return GameManager;