require "game.Config"
require "game.GameSoundEffectId"
require "game.model.Coordina";
require "game.model.MissionGrid"
require "game.model.CommingGrid"
require "game.model.StatusLogic"
require "game.model.GameStatus"
require "game.model.ClearMode"
require "game.data.CollectTargetType"
require "game.data.ScoreValue"
require "game.util.Util"
require "game.model.BoosterID"




GameValue = class("GamValue");

--工厂类
GameValue.mxGridFactroy = nil;


GameValue.mxMissionManager = nil;


GameValue.mxDataControler = nil;
GameValue.mxGameControler = nil;

--显示管理器
GameValue.mxGameLayer = nil;
GameValue.mxGridContainer = nil;
GameValue.mxGameEFT = nil;


GameValue.mxGameTimeTween = nil;
GameValue.mxStatusLogic = nil;

function GameValue:init()

    local gridFactroy = require("game.view.GridFactroy");
    GameValue.mxGridFactroy = gridFactroy.create();

    
    local mission = require("game.model.MissionManager");
    GameValue.mxMissionManager = mission.create();
    
    local dataControler = require("game.control.DataControler")
    GameValue.mxDataControler = dataControler.create();
    
    local gameControler = require("game.control.GameControler")
    GameValue.mxGameControler = gameControler.create();
    --显示管理器
    local gameLayer = require("game.view.GameLayer");
    GameValue.mxGameLayer = gameLayer.create();
    
    local gridContainer = require("game.view.GridContainer");
    GameValue.mxGridContainer = gridContainer.create();
    
    local gameEFT = require("game.view.eft.GameEffectManager");
    GameValue.mxGameEFT = gameEFT.create();

    local gameTimeTween = require("game.util.GameTimeTween");
    GameValue.mxGameTimeTween = gameTimeTween.create();
    
    local statucLogic = require("game.model.StatusLogic");
    GameValue.mxStatusLogic = statucLogic.create();
    
    
    GameValue.mxGameLayer:init();
--    self.mxMissionManager:fillBrickMatrix(TestMission.Bricks);
--    self.mxMissionManager:fillMissionMatrix(TestMission.Items);  
end


function GameValue:onWorldTimerRunHandler(spendTime)
    if GameValue.mxGameControler~=nil then
        GameValue.mxGameControler:onWorldTimerRunHandler(spendTime);
    end
end

function GameValue:initLvMap(level)
    GameValue.mxGameControler:initLvMap(level)
end

function GameValue:start(level)
    GameValue.mxGameControler:onEnterGame(level);  
end;

function GameValue:gameEnd()
end;