local DataControler = class("DataControler");


function DataControler:ctor()
    --当前关卡
    self.m_currentlevel = -1;

    --剩余步数
    self.m_limitStepNum = 0;
    --已经使用的步数
    self.m_usedStepNum = 0;
    --/*BOSS ID */
    self.m_bossId = 0;

    --/*BOSS位置数组*/
    self.m_bossPstList = {};

    --/*总分*/
    self.m_totalScore = 0;

    --/*过关目标*/
    self.m_target = nil;
    --/*过关目标完成度*/
    self.m_degree = nil;
    --/*关卡道具*/
    self.m_useItem = nil;

    --/*关卡中所有的颜色*/
    self.m_commonColorTypeList = nil;
    --/*关卡中所有的颜色乱序后的链表*/
    self.m_commonColorTypeRandomList = nil;


    --/*关卡任务是否完成*/
    self.m_isMissionComplete = false;
   
    --/*概率数据*/
    self.m_addDatas = nil;
    --/*已经生成颜色总数*/
    self.m_hasCreatColorSumMap = {};

    self.m_paidHeart = 0;

    self.m_usedPropsCount = 0;

    self.m_gameStartTime = 0;
    
    self.targetPositions = {};
    
    self.m_targetConditionKeyList = {};
    
    self.m_frontBooster = {};
    
end

function DataControler.create()
    local dataControler = DataControler.new();
    return dataControler;
end;

function DataControler:initLvMap(level)
    self.petId = nil
    self.levelObj = Util:deepcopy(MainValue.levelConfig:getLevelConfig(level));
end

function DataControler:getPetId()
    if self.petId==nil then
        local pets = self.levelObj.petId
         
        if pets~=nil then
            local len = #pets
            if len > 1 then
                self.petId = pets[math.floor(math.random(1,len))]
            else
                self.petId = pets[1]
            end
        end
    end
    return self.petId
end


function DataControler:init(level)
--    local filename = string.format("mission/%d.json",level)
--    local content = cc.FileUtils:getInstance():getStringFromFile(filename);
--    local value = json.decode(content);    
--    if type(value) ~= "table" then
--        printError("Load file Level "..level..".json - invalid data");
--    else
--        levelObj = value;
--    end
    self.m_currentlevel = level;
    
    
    GameValue.mxMissionManager:fillBrickMatrix(self.levelObj.Bricks);
   
    self.m_target = Util:deepcopy(self.levelObj.target);
    self.m_degree = Util:deepcopy(self.levelObj.target);
    self.m_real = Util:deepcopy(self.levelObj.target);
    
    local tcSize = #self.m_target.conditions;
    
    for index=1, tcSize do
    	if self.m_target.conditions[index].id ~= nil then
	        self.m_target.conditions[index].type = CollectTargetType.Item;
            self.m_degree.conditions[index].type = CollectTargetType.Item;
            self.m_real.conditions[index].type = CollectTargetType.Item;
            self.m_target.conditions[index].id2 = 0;
            self.m_degree.conditions[index].id2 = 0;
            self.m_real.conditions[index].id2 = 0;
    	elseif self.m_target.conditions[index].back ~= nil then
            self.m_target.conditions[index].id = self.m_target.conditions[index].back;
            self.m_degree.conditions[index].id = self.m_target.conditions[index].back;
            self.m_real.conditions[index].id = self.m_target.conditions[index].back;
            self.m_target.conditions[index].type = CollectTargetType.Back;
            self.m_degree.conditions[index].type = CollectTargetType.Back;
            self.m_real.conditions[index].type = CollectTargetType.Back;
            
            self.m_target.conditions[index].id2 = 0;
            self.m_degree.conditions[index].id2 = 0;
            self.m_real.conditions[index].id2 = 0;
    	end
    end
    
    
    
    
    self.m_stars = self.levelObj.stars;
    self.m_useItem = self.levelObj.useitem;
    self.m_paidHeart = self.levelObj.paidheart;
    self.m_addDatas = self.levelObj.addDatas;
    self.m_limitStepNum = self.levelObj.step;
    
    self.m_usedStepNum = 0;
    self.m_isMissionComplete = false;
    self.m_hasCreatColorSumMap = {};
    
    self.m_bossPstList = {};
    if self.levelObj.bosses ~= nil then
    else
        self.m_bossId = 0;  
    end;
    
    local addDataIdList = {};
    for index = 1,#self.m_addDatas do
        table.insert(self.m_hasCreatColorSumMap,#self.m_hasCreatColorSumMap + 1,{self.m_addDatas[index].id,0})
        table.insert(addDataIdList,#addDataIdList+1,self.m_addDatas[index].id)
    end
    
    self.m_commonColorTypeList = {};
    self.m_commonColorTypeRandomList = {};
    self.m_commonColorTypeList = self:getColorListByConfig(self.levelObj.Items);
    
    local tempItems = {};
    while true do
        tempItems = Util:deepcopy(self.levelObj.Items);
        self:fillRandomMissionMatrix(tempItems);
        
        
        GameValue.mxMissionManager:fillMissionMatrix(tempItems);
        
        for roundY = 1,#tempItems do 
            local str = "";
            for roundX = 1,#tempItems[1] do
                str = str.."  "..tempItems[roundY][roundX]
            end
            
        end
        if GameValue.mxMissionManager:checkMissionClear() == false and GameValue.mxMissionManager:checkEliminate() ~=nil and #GameValue.mxMissionManager:checkEliminate() > 0 then
            break;
        end
    end
    self:randomMissionMatrix(tempItems);
    GameValue.mxMissionManager:fillMissionMatrix(tempItems);
    self:replaceVictoryConditions();
    
    self.m_targetConditionKeyList = {};
    self.m_totalScore = 0;
    self.m_usedPropsCount = 0; 
    
    
    if self.m_frontBooster ~= nil and #self.m_frontBooster > 0 then
        --self:initfrontBooster();
        self.m_hasFrontBooster = true;
    end;
    
   
    self:gameUIinit();
end


function DataControler:gameUIinit()

    self.m_targetConditionKeyList = {};
    local conditionIds = {};
    local conditionNums = {};

    local tcSize = #self.m_target.conditions;

    for  index = 1, tcSize do
    
        local tempCondition = self.m_target.conditions[index];
        local tempStr = "";
        
        if tempCondition.type == CollectTargetType.Item then
            tempStr = string.format("%d", tempCondition.id)
        elseif tempCondition.type == CollectTargetType.Item2 then
            tempStr = string.format("%d_%d", tempCondition.id,(tempCondition.id2 % 100))
        elseif tempCondition.type == CollectTargetType.Back then
            tempStr = string.format("%d", tempCondition.back)
        end
        table.insert(self.m_targetConditionKeyList,tempStr)
        table.insert(conditionIds,tempStr)
        table.insert(conditionNums,tempCondition.amount)
      
        MainValue.mxGameManager:setUITarget(tempStr, 0, tempCondition.amount);
        
    end

   
    if #self.targetPositions ~= tcSize then
    
        self.targetPositions = {};
        
        if tcSize == 1 then
            table.insert(self.targetPositions,cc.p(VisibleRect:center().x + 205, VisibleRect:center().y + 365))
        elseif tcSize == 2 then
            table.insert(self.targetPositions,cc.p(VisibleRect:center().x + 160, VisibleRect:center().y + 365))
            table.insert(self.targetPositions,cc.p(VisibleRect:center().x + 250, VisibleRect:center().y + 365))
        elseif tcSize == 3 then
            table.insert(self.targetPositions,cc.p(VisibleRect:center().x + 140, VisibleRect:center().y + 365))
            table.insert(self.targetPositions,cc.p(VisibleRect:center().x + 205, VisibleRect:center().y + 365))
            table.insert(self.targetPositions,cc.p(VisibleRect:center().x + 270, VisibleRect:center().y + 365))
        end
    end


    self.m_gameStartTime = os.clock();    
   
    MainValue.mxGameManager:setProps(self.m_useItem.item1, self.m_useItem.item2, self.m_useItem.item3, self.m_useItem.item4, self.m_useItem.item5, self.m_useItem.item6)
    MainValue.mxGameManager:setInitCollectAimData(self.m_stars, self.m_currentlevel)
    MainValue.mxGameManager:setUIStep(self.m_limitStepNum)
    MainValue.mxGameManager:setUIScores(0)
   

end

function DataControler:setUITarget(id,  num,  sum)
    
    local tempId = id;
    local tempnum = num;
    local tempsum = sum;
    
    --0.8是UI飞行时间
   -- GameValue.mxGameTimeTween:delayedCall(0.8 ,function()
        MainValue.mxGameManager:setUITarget(tempId, tempnum, tempsum);
    --end
   -- )
    
   
end




function DataControler:subLimitStep()
    if self.m_limitStepNum > 0 then
        self.m_limitStepNum = self.m_limitStepNum - 1;
        self.m_usedStepNum = self.m_usedStepNum  + 1;
        MainValue.mxGameManager:setUIStep(self.m_limitStepNum)
    end
    
    return self.m_limitStepNum;
end;

function DataControler:getLimitStep()
	return self.m_limitStepNum;
end

function DataControler:addLimitStep(step)
    self.m_limitStepNum = self.m_limitStepNum + step;
    MainValue.mxGameManager:setUIStep(self.m_limitStepNum)
    return self.m_limitStepNum; 
end


function DataControler:addScore(score)
    self.m_totalScore = self.m_totalScore + score;
    
    MainValue.mxGameManager:setUIScores(self.m_totalScore)
end


function DataControler:statRealCollectGrid(tempGridType)
    local tempColorType = GameValue.mxMissionManager:getColorByType(tempGridType) * 100;
    local tempSingleBit = tempGridType % 100;
    local tcSize = #self.m_target.conditions;
    for index=1, tcSize do
        local targetCondition = self.m_target.conditions[index];
        local degreeCondition = self.m_real.conditions[index];
        if targetCondition.type == CollectTargetType.Item or targetCondition.type == CollectTargetType.Item2 then
            self:statRealCollectGridId(tempGridType, tempColorType, tempSingleBit, targetCondition, degreeCondition, index);
        end
    end
end;


function DataControler:statCollectGrid(tempGridType)
    local tempColorType = GameValue.mxMissionManager:getColorByType(tempGridType) * 100;
    local tempSingleBit = tempGridType % 100;
    local tcSize = #self.m_target.conditions;
    for index=1, tcSize do
    	local targetCondition = self.m_target.conditions[index];
        local degreeCondition = self.m_degree.conditions[index];
        if targetCondition.type == CollectTargetType.Item or targetCondition.type == CollectTargetType.Item2 then
            self:statCollectGridId(tempGridType, tempColorType, tempSingleBit, targetCondition, degreeCondition, index);
        end
    end
end;

function DataControler:statCollectBrick(brickType)
   
    local tcSize = #self.m_target.conditions;
    for index=1, tcSize do
        local targetCondition = self.m_target.conditions[index];
        local degreeCondition = self.m_degree.conditions[index];
        if targetCondition.type == CollectTargetType.Back then
            
            if targetCondition.back == brickType then
                if degreeCondition.amount < targetCondition.amount then
                    degreeCondition.amount = degreeCondition.amount + 1;
                    self:setUITarget(self.m_targetConditionKeyList[index], degreeCondition.amount, targetCondition.amount);
                end
            end
            
        end
    end
end;

function DataControler:statRealCollectBrick(brickType)

    local tcSize = #self.m_target.conditions;
    for index=1, tcSize do
        local targetCondition = self.m_target.conditions[index];
        local degreeCondition = self.m_real.conditions[index];
        if targetCondition.type == CollectTargetType.Back then

            if targetCondition.back == brickType then
                if degreeCondition.amount < targetCondition.amount then
                    degreeCondition.amount = degreeCondition.amount + 1;
                   
                end
            end

        end
    end
end;

function DataControler:getMissionComplete()
    if self.m_isMissionComplete == true then
        return true
    end;
    local tcSize = #self.m_target.conditions;
    for index=1, tcSize do
        local targetCondition = self.m_target.conditions[index];
        local degreeCondition = self.m_real.conditions[index];
        if degreeCondition.amount < targetCondition.amount then
            return false;
        end
    end
    
    self.m_isMissionComplete = true;
    return self.m_isMissionComplete;
end

function DataControler:getScoreComplete()

    return self.m_totalScore >= self.m_stars[1].score ;
end
--
function DataControler:addScoreToOneStar()

    self:addScore(self.m_stars[1].score - self.m_totalScore);
end

function DataControler:getTotalScore()
   return self.m_totalScore;
end

function DataControler:getPaidHeart()
   return self.m_paidHeart;
end


function DataControler:getFrontBoosterDataList()

   return self.m_frontBooster;
end


function DataControler:getCurrentSelectLevel()

    return self.m_currentlevel;
end


function DataControler:getBossPstList()
    return self.m_bossPstList;
end

function DataControler:getBossId()

    return self.m_bossId;
end

--/**
--* 返回未完成信息
--* @return
--*/
function DataControler:getUncompletedStatus()

    
    local tempStr = "{";
    local tcSize = #self.m_target.conditions;
    for index = 1,tcSize do
    

        local targetCondition = self.m_target.conditions[index];
        local degreeCondition = self.m_degree.conditions[index];
        local unCompleteCount = targetCondition.amount - degreeCondition.amount;
        if unCompleteCount > 0 then
        
            tempStr = tempStr +  string.format("{%d,%d}", targetCondition.id, unCompleteCount);
        end

        if index < tcSize then 
            tempStr =tempStr.. ",";
        end
    end
    tempStr = tempStr.."}";
    return tempStr;
end

function DataControler:getTargetStatus()

    local tempStr = {};
    local tcSize = #self.m_target.conditions;
    for index = 1,tcSize do
        local targetCondition = self.m_target.conditions[index];
        local degreeCondition = self.m_degree.conditions[index];
        
       
        tempStr[index] = {};
        tempStr[index].id = degreeCondition.id;
        tempStr[index].id2 = degreeCondition.id2;
        tempStr[index].n = degreeCondition.amount;
        tempStr[index].s = targetCondition.amount;
        
    end
    
    return tempStr;
end

function DataControler:addActiveMatchListScore(keyCoordina, coordinateXList)
    local totalScore = 0;
    local scoreBase = self:getCommonScoreBaseByClearListSize(#coordinateXList);
    local colorType =  GameValue.mxMissionManager:getColorByPst(coordinateXList[1].x, coordinateXList[1].y);

    --如果有饼干板子 把分数累加进去
    local brickScore = self:getBrickScore(coordinateXList); --考虑到没有彻底清除的问题
    local sugarScore = self:getSugaeScore(coordinateXList);
    local chocolateScore = self:getChocolateScore(coordinateXList);

    local totleScore = chocolateScore + sugarScore + brickScore + scoreBase * #coordinateXList;
    self.m_currentClearPostion = GameValue.mxGridContainer:transformGridCoordinaToRootPst(keyCoordina.x, keyCoordina.y);
    self:addScore(totleScore);
   
end
--
function DataControler:addItemScore(keyCoordina,  score)

   self.m_currentClearPostion = GameValue.mxGridContainer:transformGridCoordinaToRootPst(keyCoordina.x, keyCoordina.y);
   self:addScore(score);
end
function DataControler:addPowerUpDestoryListScore(coordinateXList)

    local scoreBase  = self:getPowerUpScoreBase();
    local len = #coordinateXList;
    if len == 0 then return; end
    local totleScore = 0;
    for round  = 1, len do
    
        local tmpGridType =  GameValue.mxMissionManager:getMissionMatrix(coordinateXList[round].x, coordinateXList[round].y);
        if MissionGrid.INTERVAL_COMMON:includeValue(tmpGridType) or MissionGrid.INTERVAL_POWER_UP:includeValue(tmpGridType) then
        
            if  GameValue.mxMissionManager:getBrickMatrix(coordinateXList[round].x, coordinateXList[round].y) == MissionGrid.BRICK_11 then
            
                totleScore = totleScore + scoreBase + ScoreValue.SCORE_PD_COOKIE;

                --GameValue.mxGridContainer:showScoreEft(coordinateXList[round],  GameValue.mxMissionManager:getColorByPst(coordinateXList[round].x, coordinateXList[round].y), scoreBase + ScoreValue.SCORE_PD_COOKIE);
            
            else
            
                totleScore = totleScore + scoreBase;
               -- GameValue.mxGridContainer:showScoreEft(coordinateXList[round],  GameValue.mxMissionManager:getColorByPst(coordinateXList[round].x, coordinateXList[round].y), scoreBase);
            end

            
        end
    end

    self.m_currentClearPostion = GameValue.mxGridContainer:transformGridCoordinaToRootPst(coordinateXList[len].x, coordinateXList[len].y);

    self:addScore(totleScore);
end

function DataControler:addFinalPowerUpScore( index, tmpCooddina)

    local tempIndex = index 
    if tempIndex > 9 then tempIndex = 9 end;
    local tempScore = tempIndex * 100 + 100;
    self:addScore(tempScore);
      
   -- GameValue.mxGridContainer:showScoreEft(tmpCooddina,  GameValue.mxMissionManager:getColorByPst(tmpCooddina.x, tmpCooddina.y), tempScore);
end

--/**
--*
--* 被powerUp消除的分数基数处理 + powerDown 累加基数 硬糖块 +40    那就是 60
--* @param    eliLen
--* @return
--*/
function DataControler:getPowerUpScoreBase()

    local baseSocre = 0;

    baseSocre = ScoreValue.SCORE_COMMON_THREE_ELI + ScoreValue.SCORE_POWER_UP_ELI;
    if GameValue.mxGameControler:getGameStatus() == GameStatus.GAME_GRAND_FINAL_ING then
    
        baseSocre = baseSocre + 30;
    end
    return baseSocre;
end

function DataControler:getCommonScoreBaseByClearListSize(listSize)

    local baseSocre = 0;

    if listSize <= 3 then
    
        baseSocre = ScoreValue.SCORE_COMMON_THREE_ELI;
    
    elseif listSize == 4 then
    
        baseSocre = ScoreValue.SCORE_COMMON_FOUR_ELI;

    
    elseif listSize >= 5 then
    
        baseSocre = ScoreValue.SCORE_COMMON_MORE_FIVE_ELI;
    end
    if GameValue.mxGameControler:getGameStatus() == GameStatus.GAME_GRAND_FINAL_ING then

        baseSocre = baseSocre + 30;
    end

    return baseSocre;
end

function DataControler:getBrickScore(coordinateXList)

    local totalScore  = 0;

    for round  = 1,#coordinateXList do
    
        local brickType =  GameValue.mxMissionManager:getBrickMatrix(coordinateXList[round].x, coordinateXList[round].y);
        if brickType == MissionGrid.BRICK_11 then
        
            totalScore = totalScore + ScoreValue.SCORE_PD_COOKIE;
        end
    end
    return totalScore;
end
--
function DataControler:getSugaeScore(coordinateXList)

    local totalScore = 0;
    for round = 1,  #coordinateXList do
    
        local tmpGridType =  GameValue.mxMissionManager:getMissionMatrix(coordinateXList[round].x, coordinateXList[round].y);
        if MissionGrid.INTERVAL_COMMON:includeValue(tmpGridType) and MissionGrid.isSugar(tmpGridType) then
        
            totalScore = totalScore + ScoreValue.SCORE_PD_SUGAR_EFT;
        end
    end
    return totalScore;
end

function DataControler:getChocolateScore(coordinateXList)

    local totalScore = 0;
    for round = 1,  #coordinateXList do
        local tmpGridType =  GameValue.mxMissionManager:getMissionMatrix(coordinateXList[round].x, coordinateXList[round].y);
        if MissionGrid.INTERVAL_COMMON:includeValue(tmpGridType) and MissionGrid.isChocolate(tmpGridType) then
        
            totalScore = totalScore + ScoreValue.SCORE_PD_CHOCOLATE_EFT;
        end
    end
    return totalScore;
end

function DataControler:getNewRandomItemId(eliNum)

    local randomId = 0;

    local tcSize = #self.m_addDatas;
    local tempAddDatas = {};
    local totalRateValue = 0;

    for index = 1,tcSize do
    
        local tempData = self.m_addDatas[index];
        if tempData.condition == 1 then
        
            if tempData.value == self.m_usedStepNum and self:checkCanCreatIdBy(tempData, tempAddDatas) then
            
                totalRateValue = totalRateValue + tempData.rate;
                table.insert(tempAddDatas,#tempAddDatas+1,tempData)
                table.insert(tempAddDatas,#tempAddDatas+1,tempData)
            end
        
        elseif tempData.condition == 2 then
        
            if tempData.value == self.m_limitStepNum and self:checkCanCreatIdBy(tempData, tempAddDatas) then
            
                totalRateValue = totalRateValue + tempData.rate;
                table.insert(tempAddDatas,#tempAddDatas+1,tempData)
            end
        
        elseif tempData.condition == 3 then
        
            if GameValue.mxMissionManager:getFullAmountById(tempData.id) < tempData.value and self:checkCanCreatIdBy(tempData, tempAddDatas) then
            
                totalRateValue = totalRateValue + tempData.rate;
                table.insert(tempAddDatas,#tempAddDatas+1,tempData)
            end
        
        elseif tempData.condition == 7 then
        
            if self.m_usedStepNum ~= tempData.value and self:checkCanCreatIdBy(tempData, tempAddDatas) then
            
                totalRateValue = totalRateValue + tempData.rate;
                table.insert(tempAddDatas,#tempAddDatas+1,tempData)
            end
        
        else
        
            if self:checkCanCreatIdBy(tempData, tempAddDatas) then
            
                totalRateValue = totalRateValue + tempData.rate;
                table.insert(tempAddDatas,#tempAddDatas+1,tempData)
            end
            
        end
    end

    local randomCount = math.random(0, math.floor(totalRateValue * 1000));

    local realRate = randomCount * 0.001;
    local tempRate = 0;
    for index = 1, #tempAddDatas do
    
        tempRate = tempRate + tempAddDatas[index].rate;
        if realRate <= tempRate then
        
            randomId = tempAddDatas[index].id;
            self:creatColorCell(randomId)
          
            break;
        end
    end

    local color =  GameValue.mxMissionManager:getColorByType(randomId);
    local bits = randomId % 100;
   
     if Util:contain(self.m_commonColorTypeRandomList, color) then
        local srcIndex = Util:indexOf(self.m_commonColorTypeList, color)
        local randomedColor = self.m_commonColorTypeRandomList[srcIndex]
        randomId = randomedColor * 100 + bits
    end
    return randomId

   
end

function DataControler:randomMissionMatrix(tempItems)

    local maxRow = #tempItems;
    local maxCol = #tempItems[1];
    
    --local seed = os.clock();

    if #self.m_commonColorTypeList == 0 then 
        return;
    end

    self.m_commonColorTypeRandomList = Util:deepcopy(self.m_commonColorTypeList);    --拷贝数据
    
   -- Util:shuffle(self.m_commonColorTypeRandomList); --乱序排列


    for  roundY = 1, maxRow do
    
        for roundX = 1, maxCol do
        
            local tmpGridType = tempItems[roundY][roundX];
            local typeId = tmpGridType % 10;
            if MissionGrid.INTERVAL_COMMON:includeValue(tmpGridType) then
            
                local color = GameValue.mxMissionManager:getColorByType(tmpGridType);
                if color > 0 then
                
                    tempItems[roundY][roundX] = self.m_commonColorTypeRandomList[Util:indexOf(self.m_commonColorTypeList, color)] * 100 + typeId;
                end
            
            elseif MissionGrid.INTERVAL_POWER_UP:includeValue(tmpGridType) then
            
                local color = GameValue.mxMissionManager:getColorByType(tmpGridType);
                if color > 0 then          
                    tempItems[roundY][roundX] = math.floor((tmpGridType/1000))* 1000 + self.m_commonColorTypeRandomList[Util:indexOf(self.m_commonColorTypeList, color)] * 100 + typeId;
                end
            end
        end
    end
    
    
end

function DataControler:replaceVictoryConditionChild(targetId, addBits)

    local color = 0;
    if MissionGrid.INTERVAL_COMMON:includeValue(targetId) then
    
        color =  GameValue.mxMissionManager:getColorByType(targetId);
        local bits = 0;
        if addBits ==true then
            bits = targetId%100;
        end
       
        if Util:contain(self.m_commonColorTypeRandomList, color) then
        
            local srcIndex = Util:indexOf(self.m_commonColorTypeList, color);
            local randomedColor = self.m_commonColorTypeRandomList[srcIndex];
            targetId = randomedColor * 100 + bits;
        end
    end
    
    return targetId;
end
--
function DataControler:replaceVictoryConditions()

    --胜利条件替换(概率替换)
    local tcSize = #self.m_target.conditions;
    for index = 1, tcSize do
    
        local tempCondition = self.m_target.conditions[index];
       
        local tempTargetDegreeCondition = self.m_degree.conditions[index];
        
        local tempRealCondition = self.m_real.conditions[index];
        
        tempTargetDegreeCondition.amount = 0;
        tempRealCondition.amount = 0;
        
        local id = tempCondition.id;
        
        if tempCondition.type == CollectTargetType.Item then
            tempCondition.id = self:replaceVictoryConditionChild(id,true);
            tempTargetDegreeCondition.id = tempCondition.id;
            tempRealCondition.id = tempCondition.id;
           
        elseif tempCondition.type == CollectTargetType.Item2 then
            local id2 = tempCondition.id2;
            
            tempCondition.id = self:replaceVictoryConditionChild(id,false);
            tempCondition.id2 = self:replaceVictoryConditionChild(id2,true);
            
            tempTargetDegreeCondition.id = tempCondition.id;
            tempTargetDegreeCondition.id2 = tempCondition.id2;
            
            tempRealCondition.id = tempCondition.id;
            tempRealCondition.id2 = tempCondition.id2;
        end       
    end
    
    
end

function DataControler:fillRandomMissionMatrix(tempItems)

    local maxRow = #tempItems;
    local maxCol = #tempItems[1];
    
    local addDataIdList = {};
    for index = 1,#self.m_addDatas do
    
        table.insert(addDataIdList,self.m_addDatas[index].id)
        
    end

    local temp_commonColorTypeList = self:getAddColorList(addDataIdList);
    for roundY = 1, maxRow do
    
        for roundX = 1, maxCol do
        
            local value = tempItems[roundY][roundX];
            if MissionGrid.INTERVAL_COMMON:includeValue(value) then
            
                local color =  GameValue.mxMissionManager:getColorByType(value);
                if color ==  GameValue.mxMissionManager:getColorByType(MissionGrid.ICE_CREAM_9) then
                
                    value = temp_commonColorTypeList[math.random(1, #temp_commonColorTypeList)] * 100 + (value % 10);
                    tempItems[roundY][roundX] = value;
                end
            end
            
        end
    end
end

function DataControler:getColorListByConfig(tempItems)

    local tempColorList = {};

     local maxRow = #tempItems;
    local maxCol = #tempItems[1];

    for roundY = 1, maxRow do
    
        for roundX = 1, maxCol do
            local value = tempItems[roundY][roundX];
            
            if MissionGrid.INTERVAL_COMMON:includeValue(value) then
            
                local tempcolor = GameValue.mxMissionManager:getColorByType(value);
                if Util:contain(tempColorList, tempcolor)== false and tempcolor ~= GameValue.mxMissionManager:getColorByType(MissionGrid.ICE_CREAM_9) then
                    table.insert(tempColorList,tempcolor)  
                end
            end
        end
    end

    -- 颜色全放进来
    for  color = 1, 6 do
    
        if Util:contain(tempColorList, color) == false then
            table.insert(tempColorList,color)  
        end
    end

    return tempColorList;
end
--
function DataControler:getAddColorList(tempIds)

    local tempColorList = {};

    local length = #tempIds;
    for round = 1, length do
    
        local value = tempIds[round];
        if MissionGrid.INTERVAL_COMMON:includeValue(value) then
        
            local color = GameValue.mxMissionManager:getColorByType(value);
            if Util:contain(tempColorList, color) == false and color ~= GameValue.mxMissionManager:getColorByType(MissionGrid.ICE_CREAM_9) then
            
                
                table.insert(tempColorList,color)  
            end
        end
    end
    return tempColorList;
end
--
function DataControler:getCanCollectGridList( tempGridType)

    local tempList = {};
    
    local tempColorType =  GameValue.mxMissionManager:getColorByType(tempGridType) * 100;
    local tempSingleBit = tempGridType % 100;
    
    local tcSize = #self.m_target.conditions;
    for index = 1,tcSize do
    
        local targetCondition = self.m_target.conditions[index];
        local degreeCondition = self.m_degree.conditions[index];
        local gridId = self:getCollectGridId(tempGridType, tempColorType, tempSingleBit, targetCondition, degreeCondition);
        
        
        if targetCondition.type == CollectTargetType.Item or targetCondition.type == CollectTargetType.Item then
            if gridId > 0 then
                
                local temp = {gridId,index};
                table.insert(tempList,temp);
                
             end
        end
       
    end
    return tempList;
end

function DataControler:getCollectGridId( tempGridType,  tempColorType,  tempSingleBit, targetCondition, degreeCondition)

    local colectValue = -1;
    if targetCondition.id == MissionGrid.CM_KEY_4_SUGAR then
    
        if tempSingleBit == MissionGrid.CM_KEY_4_SUGAR then
        
            if degreeCondition.amount < targetCondition.amount then
                colectValue = tempSingleBit;
            end
        end
    

    elseif MissionGrid.isCandy(targetCondition.id) then
    
        if tempGridType == targetCondition.id then
        
            if degreeCondition.amount < targetCondition.amount then
                colectValue = tempGridType;
            end
            
        
        end

    elseif targetCondition.id == MissionGrid.PD_FRUIT_BERRIES then
    
        if tempGridType == MissionGrid.PD_FRUIT_BERRIES then
            if degreeCondition.amount < targetCondition.amount then
                colectValue = tempGridType;
            end
        end
    

    elseif targetCondition.id == MissionGrid.PD_POPCORN then
    
        if tempGridType == MissionGrid.PD_POPCORN then
        
            if degreeCondition.amount < targetCondition.amount then
                colectValue = tempGridType;
            end
        end
    

    elseif targetCondition.id >= MissionGrid.ICE_CREAM_1 and targetCondition.id < MissionGrid.ICE_CREAM_9 then
    
        if tempGridType == targetCondition.id or tempGridType == targetCondition.id2 then
        
            if degreeCondition.amount < targetCondition.amount then
                colectValue = tempGridType;
            end
        
        elseif tempSingleBit == MissionGrid.CM_KEY_4_SUGAR and tempColorType == targetCondition.id then
        
            if degreeCondition.amount < targetCondition.amount then
            
               -- //colectValue = tempColorType;
            end
        end
    
    elseif targetCondition.id >= MissionGrid.ICE_CREAM_9 and targetCondition.id < MissionGrid.PU_RAINBOW then
    

        if targetCondition.id2 ~= 0 then
        
            if tempSingleBit ~= 0 and targetCondition.id2 % 100 == tempSingleBit then
            
                if degreeCondition.amount < targetCondition.amount then
                    colectValue = tempGridType;
                end
            
            elseif tempSingleBit == 0 then
            
                if degreeCondition.amount < targetCondition.amount then
                    colectValue = tempGridType;
                end
            end
        
        elseif targetCondition.id % 100 ~= 0 then
        
            if tempSingleBit == targetCondition.id % 100 then
            
                if degreeCondition.amount < targetCondition.amount then
                    colectValue = tempGridType;
                end
            end
        
        else
        
            if tempSingleBit == 0 or tempSingleBit == MissionGrid.CM_KEY_4_SUGAR then
            
                if degreeCondition.amount < targetCondition.amount then
                    colectValue = tempGridType;
                end
            end
        end


      
    end
    return colectValue;
end
--
--
--
function DataControler:getTargetRootPositionByIndex( index)

    return self.targetPositions[index];
end


function DataControler:statRealCollectGridId(tempGridType,  tempColorType,  tempSingleBit,targetCondition,degreeCondition,  round)

    if targetCondition.id == MissionGrid.CM_KEY_4_SUGAR then

        if tempSingleBit == MissionGrid.CM_KEY_4_SUGAR then

            if degreeCondition.amount < targetCondition.amount then

                degreeCondition.amount = degreeCondition.amount + 1;

                
            end
        end


    elseif MissionGrid.isCandy(targetCondition.id) then

        if tempGridType == targetCondition.id then

            degreeCondition.amount = degreeCondition.amount + 1;
            
        end

    elseif targetCondition.id == MissionGrid.PD_FRUIT_BERRIES then

        if tempGridType == MissionGrid.PD_FRUIT_BERRIES then

            degreeCondition.amount = degreeCondition.amount + 1;
            
        end


    elseif targetCondition.id == MissionGrid.PD_POPCORN then

        if tempGridType == MissionGrid.PD_POPCORN then

            degreeCondition.amount = degreeCondition.amount + 1;
            
        end

    elseif targetCondition.id >= MissionGrid.ICE_CREAM_1 and targetCondition.id < MissionGrid.ICE_CREAM_9 then


        if tempGridType == targetCondition.id or tempGridType == targetCondition.id2 then

            if degreeCondition.amount < targetCondition.amount then

                degreeCondition.amount = degreeCondition.amount + 1;

                
            end

        elseif tempSingleBit == MissionGrid.CM_KEY_4_SUGAR and tempColorType == targetCondition.id then

            if degreeCondition.amount < targetCondition.amount then

                degreeCondition.amount = degreeCondition.amount + 1;

                
            end
        end

    elseif targetCondition.id >= MissionGrid.ICE_CREAM_9 and targetCondition.id < MissionGrid.PU_RAINBOW then

        if targetCondition.id2 ~= 0 then--收集两种东西

            if tempSingleBit ~= 0 and (targetCondition.id2 % 100) == tempSingleBit then

                if degreeCondition.amount < targetCondition.amount then

                    degreeCondition.amount = degreeCondition.amount + 1;
                    
                end

        elseif tempSingleBit == 0 then

            if degreeCondition.amount < targetCondition.amount then

                degreeCondition.amount = degreeCondition.amount + 1;
                
            end

        end
        elseif targetCondition.id % 100 ~= 0 then --收集特殊的东西

            if tempSingleBit == targetCondition.id % 100 then

                if degreeCondition.amount < targetCondition.amount then

                    degreeCondition.amount = degreeCondition.amount + 1;
                end
        end

        else--收集所有普通的

            if tempSingleBit == 0 or tempSingleBit == MissionGrid.CM_KEY_4_SUGAR then

                if degreeCondition.amount < targetCondition.amount then

                    degreeCondition.amount = degreeCondition.amount + 1;
                    
                end
            end
        end



    end
end

--
--
function DataControler:statCollectGridId(tempGridType,  tempColorType,  tempSingleBit,targetCondition,degreeCondition,  round)

    if targetCondition.id == MissionGrid.CM_KEY_4_SUGAR then
    
        if tempSingleBit == MissionGrid.CM_KEY_4_SUGAR then
        
            if degreeCondition.amount < targetCondition.amount then
            
                degreeCondition.amount = degreeCondition.amount + 1;
                
                self:setUITarget(self.m_targetConditionKeyList[round], degreeCondition.amount, targetCondition.amount);
            end
        end
    

    elseif MissionGrid.isCandy(targetCondition.id) then
    
        if tempGridType == targetCondition.id then
        
            degreeCondition.amount = degreeCondition.amount + 1;
            self:setUITarget(self.m_targetConditionKeyList[round], degreeCondition.amount, targetCondition.amount);
        end
    
    elseif targetCondition.id == MissionGrid.PD_FRUIT_BERRIES then
    
        if tempGridType == MissionGrid.PD_FRUIT_BERRIES then
        
            degreeCondition.amount = degreeCondition.amount + 1;
            self:setUITarget(self.m_targetConditionKeyList[round], degreeCondition.amount, targetCondition.amount);
        end
        
    
    elseif targetCondition.id == MissionGrid.PD_POPCORN then
    
        if tempGridType == MissionGrid.PD_POPCORN then
        
            degreeCondition.amount = degreeCondition.amount + 1;
            self:setUITarget(self.m_targetConditionKeyList[round], degreeCondition.amount, targetCondition.amount);
        end
    
    elseif targetCondition.id >= MissionGrid.ICE_CREAM_1 and targetCondition.id < MissionGrid.ICE_CREAM_9 then
    

        if tempGridType == targetCondition.id or tempGridType == targetCondition.id2 then
        
            if degreeCondition.amount < targetCondition.amount then
            
                degreeCondition.amount = degreeCondition.amount + 1;
                
                self:setUITarget(self.m_targetConditionKeyList[round], degreeCondition.amount, targetCondition.amount);
            end
        
        elseif tempSingleBit == MissionGrid.CM_KEY_4_SUGAR and tempColorType == targetCondition.id then
        
            if degreeCondition.amount < targetCondition.amount then
            
                degreeCondition.amount = degreeCondition.amount + 1;
                
                self:setUITarget(self.m_targetConditionKeyList[round], degreeCondition.amount, targetCondition.amount);
            end
        end
    
    elseif targetCondition.id >= MissionGrid.ICE_CREAM_9 and targetCondition.id < MissionGrid.PU_RAINBOW then

        if targetCondition.id2 ~= 0 then--收集两种东西
        
            if tempSingleBit ~= 0 and (targetCondition.id2 % 100) == tempSingleBit then
            
                if degreeCondition.amount < targetCondition.amount then
                
                    degreeCondition.amount = degreeCondition.amount + 1;
                    self:setUITarget(self.m_targetConditionKeyList[round], degreeCondition.amount, targetCondition.amount);
                end
            
            elseif tempSingleBit == 0 then
            
                if degreeCondition.amount < targetCondition.amount then
                
                    degreeCondition.amount = degreeCondition.amount + 1;
                    self:setUITarget(self.m_targetConditionKeyList[round], degreeCondition.amount, targetCondition.amount);
                end
            
            end
        elseif targetCondition.id % 100 ~= 0 then --收集特殊的东西
        
            if tempSingleBit == targetCondition.id % 100 then
            
                if degreeCondition.amount < targetCondition.amount then
                
                    degreeCondition.amount = degreeCondition.amount + 1;
                    self:setUITarget(self.m_targetConditionKeyList[round], degreeCondition.amount, targetCondition.amount);
                end
            end
        
        else--收集所有普通的
        
            if tempSingleBit == 0 or tempSingleBit == MissionGrid.CM_KEY_4_SUGAR then
            
                if degreeCondition.amount < targetCondition.amount then
                
                    degreeCondition.amount = degreeCondition.amount + 1;
                    self:setUITarget(self.m_targetConditionKeyList[round], degreeCondition.amount, targetCondition.amount);
                end
            end
        end


       
    end
end
--
--
function DataControler:getCanCollectBrickGridId( gridType)

    local tempList = {};
    local tcSize = #self.m_target.conditions;
    for  index = 1,tcSize do
    
        local targetCondition = self.m_target.conditions[index];
        local degreeCondition = self.m_degree.conditions[index];
        if targetCondition.type == CollectTargetType.Back then
        
            if targetCondition.back == gridType then
            
                if degreeCondition.amount < targetCondition.amount then
                    tempList = {gridType,index}
                  
                    break;
                end
            end
        end
    end
    return tempList;
end

--
function DataControler:checkCanCreatIdBy(tempData, tempAddDatas)

    if tempData.amont == -1 then return true; end
   
    if Util.index(self.m_hasCreatColorSumMap,tempData.id) == -1 then 
        return false;
    end

    local length = #tempAddDatas;
    local tempAdd = 0;
    for i = 1,length do
    
        if tempAddDatas[i].id == tempData.id then
        
            tempAdd = tempAdd + 1;
            if tempAdd >= tempData.amont then
                return false;
            end
        end
    end

   

    return true;
end

function DataControler:getCurrentClearPostion()

    return self.m_currentClearPostion;
end

function DataControler:useProps()

    self.m_usedPropsCount = self.m_usedPropsCount + 1;
end

function DataControler:getUsedPropsCount()

    return self.m_usedPropsCount;
end

function DataControler:getStars()

    if self.m_totalScore >= self.m_stars[3].score then
    
        return 3;
    
    elseif self.m_totalScore >= self.m_stars[2].score then
    
        return 2;
    
    elseif self.m_totalScore >= self.m_stars[1].score then
    
        return 1;
    
    else 
        return 0;
    end
end

function DataControler:setFrontBooster(ids)

    self.m_frontBooster = ids;

end

--function DataControler:initfrontBooster()
--    
--    local ids = Util:deepcopy(self.m_frontBooster);
--    
--    for index = 1,#ids do
--        
--        
--        if ids[index] == "101" then
--        
--            self.m_limitStepNum = self.m_limitStepNum + 2;
--        
--        elseif ids[index] == "102" then
--        
--
--            local coordiaList = GameValue.mxMissionManager:getChangeToPowerUpCoordinaList(1);
--
--            local tempSwapDir = MissionGrid.EliminateType.DIR_H;
--            if math.random(0,1) == 1 then
--                 tempSwapDir = MissionGrid.EliminateType.DIR_V;
--            end
--            local color = GameValue.mxMissionManager:getColorByPst(coordiaList[1].x, coordiaList[1].y);
--            local powerUpType = GameValue.mxMissionManager:getRandomPowerUpType(ClearMode.MODE_L_T, color, tempSwapDir);
--            GameValue.mxMissionManager:setMissionMatrix(coordiaList[1].x,coordiaList[1].y, powerUpType);
--        
--        elseif ids[index] == "103" then
--        
--            local coordiaList = GameValue.mxMissionManager:getChangeToPowerUpCoordinaList(1);
--
--            local tempSwapDir = MissionGrid.EliminateType.DIR_H;
--            if math.random(0,1) == 1 then
--                 tempSwapDir = MissionGrid.EliminateType.DIR_V;
--            end
--            local color = GameValue.mxMissionManager:getColorByPst(coordiaList[1].x, coordiaList[1].y);
--            local powerUpType = GameValue.mxMissionManager:getRandomPowerUpType(ClearMode.MODE_4_HORIZONTAL, color, tempSwapDir);
--            GameValue.mxMissionManager:setMissionMatrix(coordiaList[1].x,coordiaList[1].y, powerUpType);
--
--        end
--        
--    end
--
--    self.m_frontBooster = {}
--end

function DataControler:checkFrontStep()
    if self.m_frontBooster ~= nil and #self.m_frontBooster > 0 then
        local ids = Util:deepcopy(self.m_frontBooster);
        for index = 1,#ids do
            if ids[index] == "101" then
                return true;
            end
        end
    end;
    return false;
end;

function DataControler:checkFrontBoom()
    if self.m_frontBooster ~= nil and #self.m_frontBooster > 0 then
        local ids = Util:deepcopy(self.m_frontBooster);
        for index = 1,#ids do
            if ids[index] == "102" then
            
                local coordiaList = GameValue.mxMissionManager:getChangeToPowerUpCoordinaList(1);
                local tempSwapDir = MissionGrid.EliminateType.DIR_H;
                if math.random(0,1) == 1 then
                     tempSwapDir = MissionGrid.EliminateType.DIR_V;
                end
                local color = GameValue.mxMissionManager:getColorByPst(coordiaList[1].x, coordiaList[1].y);
                local powerUpType = GameValue.mxMissionManager:getRandomPowerUpType(ClearMode.MODE_L_T, color, tempSwapDir);
               
                return true,coordiaList[1].x,coordiaList[1].y,powerUpType;
            end
        end
    end;
    
    return false;
end;

function DataControler:checkFrontRocket()
    if self.m_frontBooster ~= nil and #self.m_frontBooster > 0 then
        local ids = Util:deepcopy(self.m_frontBooster);
        for index = 1,#ids do
            if ids[index] == "103" then
                local coordiaList = GameValue.mxMissionManager:getChangeToPowerUpCoordinaList(1);
                local tempSwapDir = MissionGrid.EliminateType.DIR_H;
                if math.random(0,1) == 1 then
                     tempSwapDir = MissionGrid.EliminateType.DIR_V;
                end
                local color = GameValue.mxMissionManager:getColorByPst(coordiaList[1].x, coordiaList[1].y);
                local powerUpType = GameValue.mxMissionManager:getRandomPowerUpType(ClearMode.MODE_4_HORIZONTAL, color, tempSwapDir);
               
                return true,coordiaList[1].x,coordiaList[1].y,powerUpType;
                
            end
        end
    end;
    
    return false;
end;


function DataControler:updateCheckPropsPrompt()
    local id  = -1;
    
    local needPrompt = false;
    local tcSize = #self.m_target.conditions;
    for  index = 1, tcSize do
        local targetCondition = self.m_target.conditions[index];
        local degreeCondition = self.m_degree.conditions[index];
        local unCompleteCount = targetCondition.amount - degreeCondition.amount;
        if unCompleteCount ~= 1 then
            id = -1;
            
            return false;
           -- break;
        end
        
        if MissionGrid.isCandy(targetCondition.id) or targetCondition.type == CollectTargetType.Back then
            return true
        end
    end
    return false;
end;

--
--int DataControler::checkPlayAlmost()
--{
--    
--    size_t tcSize = m_target.conditions.size();
--    for (size_t index = 0; index < tcSize; index++)
--    {
--        LevelConfig::Target::Condition& targetCondition = m_target.conditions[index];
--        LevelConfig::Target::Condition& degreeCondition = m_degree.conditions[index];
--        int unCompleteCount = targetCondition.amount - degreeCondition.amount;
--
--        int targetC = 1;
--
--        if (targetCondition.type == CollectTargetType::Back)
--        {
--            targetC = targetCondition.amount*0.1 >= 1 ? targetCondition.amount*0.1 : 1;
--            if (unCompleteCount > targetC)
--            {
--                return 0;
--            }
--        }
--
--        if (targetCondition.id == MissionGrid.CM_KEY_4_SUGAR)
--        {
--            if (unCompleteCount > targetC)
--            {
--                return 0;
--            }
--        }
--
--        elseif (MissionGrid.isCandy(targetCondition.id))
--        {
--            if (unCompleteCount > targetC)
--            {
--                return 0;
--            }
--        }
--
--        elseif (targetCondition.id == MissionGrid.PD_FRUIT_BERRIES)
--        {
--            if (unCompleteCount > targetC)
--            {
--                return 0;
--            }
--        }
--
--        elseif (targetCondition.id == MissionGrid.PD_POPCORN)
--        {
--            targetC = targetCondition.amount*0.1 >= 1 ? targetCondition.amount*0.1 : 1;
--            if (unCompleteCount > targetC)
--            {
--                return 0;
--            }
--        }
--
--        elseif (targetCondition.id >= MissionGrid.ICE_CREAM_1 and targetCondition.id < MissionGrid.ICE_CREAM_9)
--        {
--            targetC = targetCondition.amount*0.05 >= 1 ? targetCondition.amount*0.05 : 1;
--            if (unCompleteCount > targetC)
--            {
--                return 0;
--            }
--        }
--        elseif (targetCondition.id >= MissionGrid.ICE_CREAM_9 and targetCondition.id < MissionGrid.PU_RAINBOW)
--        {
--            targetC = targetCondition.amount*0.05 >= 1 ? targetCondition.amount*0.05 : 1;
--            if (unCompleteCount > targetC)
--            {
--                return 0;
--            }
--        }
--    
--        
--    }
--    
--    return 1;
--
--}
--
--/**
--* 返回玩游戏的时间
--* @return
--*/
--int DataControler::getPlayGameTime()
--{
--    
--    time_t now_time = time(NULL); 
--    return now_time - m_gameStartTime;
--}
--
--bool DataControler::getHasFrontBooster()
--{
--    return m_hasFrontBooster;
--}

function DataControler:gameStart(level)
    self:init(level)
end;



function DataControler:exitGame()
    --当前关卡
    self.m_currentlevel = -1;

    --剩余步数
    self.m_limitStepNum = 0;
    --已经使用的步数
    self.m_usedStepNum = 0;
    --/*BOSS ID */
    self.m_bossId = 0;

    --/*BOSS位置数组*/
    self.m_bossPstList = {};

    --/*总分*/
    self.m_totalScore = 0;

    --/*过关目标*/
    self.m_target = nil;
    --/*过关目标完成度*/
    self.m_degree = nil;
    --/*关卡道具*/
    self.m_useItem = nil;

    --/*关卡中所有的颜色*/
    self.m_commonColorTypeList = nil;
    --/*关卡中所有的颜色乱序后的链表*/
    self.m_commonColorTypeRandomList = nil;


    --/*关卡任务是否完成*/
    self.m_isMissionComplete = false;

    --/*概率数据*/
    self.m_addDatas = nil;
    --/*已经生成颜色总数*/
    self.m_hasCreatColorSumMap = {};

    self.m_paidHeart = 0;

    self.m_usedPropsCount = 0;

    self.m_gameStartTime = 0;

    self.targetPositions = {};

    self.m_targetConditionKeyList = {};

    self.m_frontBooster = {};

    self.m_needRandom = false;
end;

function DataControler:creatColorCell(id)
    local len = #self.m_hasCreatColorSumMap;
    for index=1, len do
    	if tonumber(self.m_hasCreatColorSumMap[index][0]) == tonumber(id) then
    	   self.m_hasCreatColorSumMap[index][1] = self.m_hasCreatColorSumMap[index][1] + 1;
    	end
    	
    end
end;
	


return DataControler;