
local GameControler = class("GameControler");


function GameControler:ctor()
        --最大高Y
    self.m_maxRow = 0;
    --最大宽X
    self.m_maxCol = 0;
    --是否全盘待机
    self.m_wait = true;
    --提示时间累计
    self.m_eliminateTime = 0;
    --刷新状态总时间间隔
    self.UPDATE_G_S_TIME = 0.5;
    --刷新状态时间累计
    self.m_updateGameStatusTime = self.UPDATE_G_S_TIME;
    --已选中的点   began
    self.m_radioCoordina = Coordina.new();
    --已选中的点   end
    self.m_selectCoordina = Coordina.new();
    --购买物品ID
    self.m_buyPropId = 0;
    --飞行中的道具数量
    self.m_flyingCollectItemSum = 0;
    --存在物品增强前置道具
    self.m_hasEnhanceGoods = false;
    --活动列表
    self.m_activePowerUpList = {};
    --/**连续消除次数 普通的 */
    self.m_totalEliNumCommon = 0;
    --/**连续消除次数 powerUp */
    self.m_totalEliNumPowerUp = 0;
    --/**连续combo消除次数*/
    self.m_totalEliNumCombo = 0;
    --/*BOSS ID */
    self.m_bossId = 0;
    --/*当前游戏状态*/
    self.m_gameStatus = 0;
    --/*手套已选中的物品*/
    self.m_gloveCoordina = Coordina.new();
    --游戏中
    self.m_ingame = false;
    self.m_fiveStepLeftPlayed = false;
    
    local powerUpControler= require("game.control.PowerUpAssemControler")
    
    self.powerUpAssemControler = powerUpControler.create();
    

    self.inGameStartPanel = nil; --开始goals面板
end;

function GameControler.create()
    local controler = GameControler.new();
    return controler;
end;

function GameControler:initLvMap(level)
    GameValue.mxDataControler:initLvMap(level)
end


function GameControler:onEnterGame(level)

    GameValue.mxDataControler:gameStart(level);
    GameValue.mxGameLayer:gameStart(); 
   
    
    
    self.m_gameStatus = GameStatus.GAME_READY;

    --self.m_bossId = GameValue.mxDataControler:getBossId();
    
    self.m_maxRow = GameValue.mxMissionManager:getMaxRow();
    self.m_maxCol = GameValue.mxMissionManager:getMaxCol();

    self.m_wait = true;  --不自动的
    self.m_eliminateTime = 0;

    self.m_activePowerUpList = {};
    self.m_buyPropId = 0;
    
    self.m_updateGameStatusTime = self.UPDATE_G_S_TIME;
    self.m_hasEnhanceGoods = false;
    
   
    self.m_radioCoordina.x = -1;
    self.m_radioCoordina.y = -1;


    self.m_selectCoordina.x = -1;
    self.m_selectCoordina.y = -1;

    self.m_gloveCoordina.x = -1;
    self.m_gloveCoordina.y = -1;

    --切入游戏场景
    self.m_ingame = true;

    self.m_fiveStepLeftPlayed = false;

    local function delayC()
        local hasFrontStep = GameValue.mxDataControler:checkFrontStep();
        local hasFrontBoom,frontBoomX,frontBoomY,frontBoomId = GameValue.mxDataControler:checkFrontBoom();
        local hasFrontRocket,frontRocketX,frontRocketY,frontRocketId = GameValue.mxDataControler:checkFrontRocket();
        if hasFrontStep == true then
            MainValue.mxGameManager:showAddTwoStepAni();-- TODO
            GameValue.mxGameTimeTween:delayedCall(0.5,function()
                GameValue.mxDataControler:addLimitStep(2);
            end
            )
        end;
        if hasFrontBoom == true then
            
            local boomCoordina = Coordina.new();
            boomCoordina.x = frontBoomX;
            boomCoordina.y = frontBoomY;
            
            self:transformToPowerUpByFrontBoost(boomCoordina,frontBoomId);
            
        end;
        if hasFrontRocket == true then
            local rocketCoordina = Coordina.new();
            rocketCoordina.x = frontRocketX;
            rocketCoordina.y = frontRocketY;
            
            self:transformToPowerUpByFrontBoost(rocketCoordina,frontRocketId);
        end;
       
       if hasFrontStep or hasFrontBoom or hasFrontRocket then
            GameValue.mxGameTimeTween:delayedCall(0.5,function()
                self.m_gameStatus = GameStatus.GAMING;
            end
            )
       else
            self.m_gameStatus = GameStatus.GAMING;
            
--            if level == MainValue.dataManager.levelManager:getMaxLevel() then
--                MainValue.mxGameManager:showFtueByLv(level,self.m_maxRow,self.m_maxCol);
--            end
       end;
        
        
    end
    
    local goalsData = GameValue.mxDataControler:getTargetStatus();
    
    local goalsPanel = require("ui.inGame.InGameStartPanel");
    self.inGameStartPanel = goalsPanel.create(); 
    self.inGameStartPanel:setData(goalsData);
    self.inGameStartPanel:appear(); 
    
    GameValue.mxGameTimeTween:delayedCall(2,delayC)
   
end




function GameControler:onTouchBegan(nodePoint)
    if self.m_gameStatus ~= GameStatus.GAMING or self.m_wait == false then 
        return false;
    end;
    
    if GameValue.mxMissionManager:getStatusIsStatic() == false then
        return false;
    end
    
    local indexX = math.floor(nodePoint.x / Config.tiledWidth) + 1;
    local indexY = math.floor(nodePoint.y / Config.tiledHeight) + 1;

    local typeGrid = GameValue.mxMissionManager:getMissionMatrix(indexX, indexY);
    local gridCell = GameValue.mxGridContainer:getCellMatrix(indexX, indexY);

    if gridCell == nil then return false end;
    
    if self.m_buyPropId ~= 0 then
        self:triggerPowerActionByBuyProp(self.m_buyPropId, indexX, indexY);
        self.m_selectCoordina.x = -1;
        self.m_selectCoordina.y = -1;
        return false
    end  
    if GameValue.mxStatusLogic:getSwapEnable(typeGrid)==false then
    	return false
    end
    if GameValue.mxStatusLogic:getMoveEnable(typeGrid)==false then
        return false
    end



    self.m_radioCoordina.x = indexX;
    self.m_radioCoordina.y = indexY;
    
    gridCell:play2SelectMotion();
    
    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.BLOCK_CLICK);
    
    return true;
end;
function GameControler:onTouchBeganOut()
    if self.m_buyPropId > 0 then
        MainValue.mxGameManager:cancelProps(self.m_buyPropId)
    end
end;
function GameControler:onTouchMoved(nodePoint)

    if self.m_radioCoordina:equalsXY(-1, -1) then 
        return;
    end;
    if self.m_gameStatus ~= GameStatus.GAMING or self.m_wait == false then 
        return ;
    end;

    if GameValue.mxMissionManager:getStatusIsStatic() == false then
        return ;
    end
    
    local indexX = math.floor(nodePoint.x / Config.tiledWidth) + 1;
    local indexY = math.floor(nodePoint.y / Config.tiledHeight) + 1;
    if self.m_radioCoordina:equalsXY(indexX, indexY) then 
        return;
    end;
    
    local targetCoordina = Coordina.new();
    if math.abs(indexX - self.m_radioCoordina.x) >= math.abs(indexY - self.m_radioCoordina.y) then
        if indexX > self.m_radioCoordina.x then 
            targetCoordina.x = self.m_radioCoordina.x + 1;
            targetCoordina.y = self.m_radioCoordina.y;
        else
            targetCoordina.x = self.m_radioCoordina.x - 1;
            targetCoordina.y = self.m_radioCoordina.y;
        end
    else
        if  indexY > self.m_radioCoordina.y then
        
            targetCoordina.x = self.m_radioCoordina.x;
            targetCoordina.y = self.m_radioCoordina.y + 1;
        
        else
        
            targetCoordina.x = self.m_radioCoordina.x;
            targetCoordina.y = self.m_radioCoordina.y - 1;
        end
    end;

    if targetCoordina.x <= 0 or targetCoordina.x > self.m_maxCol or targetCoordina.y <= 0 or targetCoordina.y > self.m_maxRow then
        return;
    end
    
    if GameValue.mxMissionManager:getStatusMatrix(targetCoordina.x, targetCoordina.y) ~= MissionStatus.OPEN then
        return;
    end

    local typeGrid = GameValue.mxMissionManager:getMissionMatrix(targetCoordina.x, targetCoordina.y);
    local gridCell = GameValue.mxGridContainer:getCellMatrix(targetCoordina.x, targetCoordina.y);
    if GameValue.mxStatusLogic:getSwapEnable(typeGrid)==false then
        return 
    end
    if GameValue.mxStatusLogic:getMoveEnable(typeGrid)==false then
        return 
    end
    if gridCell == nil then 
        return
    end

    local radioItemCell = GameValue.mxGridContainer:getCellMatrix(self.m_radioCoordina.x,self.m_radioCoordina.y);
    radioItemCell:play1RestMotion();
   

    GameValue.mxMissionManager:setStatusMatrix(self.m_radioCoordina.x, self.m_radioCoordina.y, MissionStatus.SWAP);
    GameValue.mxMissionManager:setStatusMatrix(targetCoordina.x, targetCoordina.y, MissionStatus.SWAP);

    local radioTypeGrid = GameValue.mxMissionManager:getMissionMatrix(self.m_radioCoordina.x, self.m_radioCoordina.y);
    local targetTypeGrid = GameValue.mxMissionManager:getMissionMatrix(targetCoordina.x, targetCoordina.y);


  
    --都是道具
    if MissionGrid.INTERVAL_POWER_UP:includeValue(radioTypeGrid) == true and MissionGrid.INTERVAL_POWER_UP:includeValue(targetTypeGrid) then
        --self.m_wait = false;
        radioItemCell:swapMoveTo(targetCoordina.x,targetCoordina.y);
        local c_targetCoordina = Coordina.new();
        c_targetCoordina.x = targetCoordina.x;
        c_targetCoordina.y = targetCoordina.y;

        local c_startCoordina = Coordina.new();
        c_startCoordina.x = self.m_radioCoordina.x;
        c_startCoordina.y = self.m_radioCoordina.y;

       
        GameValue.mxGameTimeTween:delayedCall(Config.swapDuration,function()
            self.powerUpAssemControler:bothPowerUpAndPowerUp(self.m_radioCoordina,c_targetCoordina);
            self:checkSubStepWhenActiveSwap(self.m_radioCoordina,c_targetCoordina,false);
            MainValue.mxGameManager:removeFtue();
            MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.COMBINE);
            
        end
        );
        
    else
        GameValue.mxGridContainer:swapPlaces(self.m_radioCoordina, targetCoordina, true);
        self.m_radioCoordina.x = -1;
        self.m_radioCoordina.y = -1;

        self.m_selectCoordina.x = -1;
        self.m_selectCoordina.y = -1;
    end

    
end;
function GameControler:onTouchMovedOut()
end;
function GameControler:onTouchEnded(nodePoint)

    local indexX = math.floor(nodePoint.x / Config.tiledWidth) + 1;
    local indexY = math.floor(nodePoint.y / Config.tiledHeight) + 1;

    local typeGrid = GameValue.mxMissionManager:getMissionMatrix(indexX, indexY);
    local gridCell = GameValue.mxGridContainer:getCellMatrix(indexX, indexY);
    if gridCell == nil then return end;
    gridCell:play1RestMotion();

    print("[GameContorler]----onTouchEnded()",indexX,indexY,typeGrid)
end;
function GameControler:onTouchEndedOut()
end;


function GameControler:onSwapEndHandler(startPoint, targetCoordina, isPlayer)


    local startType = GameValue.mxMissionManager:getMissionMatrix(startPoint.x, startPoint.y);
    local targetType = GameValue.mxMissionManager:getMissionMatrix(targetCoordina.x, targetCoordina.y);

    GameValue.mxMissionManager:setMissionMatrix(startPoint.x, startPoint.y, targetType);
    GameValue.mxMissionManager:setMissionMatrix(targetCoordina.x, targetCoordina.y, startType);

    GameValue.mxMissionManager:setStatusMatrix(startPoint.x, startPoint.y, MissionStatus.OPEN);
    GameValue.mxMissionManager:setStatusMatrix(targetCoordina.x, targetCoordina.y, MissionStatus.OPEN);
    

    self.m_totalEliNumCombo = 0;
    self.m_totalEliNumCommon = 0;
    self.m_totalEliNumPowerUp = 0;

    if isPlayer == true then
        self.m_eliminateTime = 0;
        
        MainValue.mxGameManager:removeFtue();
        
        if startType == MissionGrid.PU_RAINBOW or targetType == MissionGrid.PU_RAINBOW then
            
            if (startType == MissionGrid.PU_RAINBOW and MissionGrid.isCommonCell(targetType)) or (targetType == MissionGrid.PU_RAINBOW and MissionGrid.isCommonCell(startType)) then
                self.m_wait = false;
                self:checkSubStepWhenActiveSwap(startPoint, targetCoordina);
                self.powerUpAssemControler:executeRainbowAndCommon(startPoint,targetCoordina);
            else
                GameValue.mxMissionManager:setStatusMatrix(startPoint.x, startPoint.y, MissionStatus.SWAP);
                GameValue.mxMissionManager:setStatusMatrix(targetCoordina.x, targetCoordina.y, MissionStatus.SWAP);
                GameValue.mxGridContainer:swapPlaces(startPoint, targetCoordina, false);

                MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.BLOCK_SWITCH);
            end
            return;
        end
        
        
        if self:checkClear(startPoint, targetCoordina) == true then
            --普通消除成功                    
           
            local tempCoordina = GameValue.mxGridContainer:checkTransport(startPoint, targetCoordina);-- 检测是否有水果可以收集
            if tempCoordina.x ~= -1 and tempCoordina.y ~= -1 then
            
                self:clearPowerDownCell(tempCoordina);
            end
            self:checkSubStepWhenActiveSwap(startPoint, targetCoordina,false);
        
        else
        
           
          
            --普通消除失败回弹
            
            GameValue.mxMissionManager:setStatusMatrix(startPoint.x, startPoint.y, MissionStatus.SWAP);
            GameValue.mxMissionManager:setStatusMatrix(targetCoordina.x, targetCoordina.y, MissionStatus.SWAP);
            GameValue.mxGridContainer:swapPlaces(startPoint, targetCoordina, false);

            MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.BLOCK_SWITCH);
        end

        
    
    else
        self:checkDrop();
    end
end



;





function GameControler:checkClear(m_startPoint, m_targetCoordina)
    local startPoint = nil;
    local targetCoordina = nil;
    if m_startPoint ~= nil then
        startPoint = Coordina.new();
        startPoint.x = m_startPoint.x
        startPoint.y = m_startPoint.y;
    end;
    
    if m_targetCoordina ~= nil then
        targetCoordina = Coordina.new();
        targetCoordina.x = m_targetCoordina.x
        targetCoordina.y = m_targetCoordina.y;
    end;
    
    if GameValue.mxMissionManager:checkMissionClear() == true then --检测并消除       startPoint, targetCoordina//添加这两个参数意在处理 判断是不是当前主动 活动的单元 
    
        local delayPromptlyCheckDrop = Config.clearDuration;
        --self.m_wait = false;

        local clearViewList = GameValue.mxMissionManager:getClearView();
        GameValue.mxMissionManager:resetReferMatrix();

        local coordinateXList = {};
        local keyCoordina = Coordina.new();
        local antherCoordina = Coordina.new();

        local isActive = false;
        local swapDir = 0;

        if startPoint ~= nil and targetCoordina ~= nil then
        
            local startPointIndex = -1;
            local targetPointIndex = -1;

            isActive = true;
            local bossRecordColor = self:getBossRecordMatchColor();
            for roundY = 1,#clearViewList do
            
                coordinateXList = clearViewList[roundY];
                if startPointIndex == -1 then
                    startPointIndex = startPoint:indexOf(coordinateXList);
                end;
                
                if targetPointIndex == -1 then
                    targetPointIndex = targetCoordina:indexOf(coordinateXList);
                end
            end

            if  startPoint.x ~= targetCoordina.x then
                swapDir = MissionGrid.EliminateType.DIR_H;
            else
                swapDir = MissionGrid.EliminateType.DIR_V;
            end
            

            if startPointIndex == -1 and targetPointIndex ~= -1 then
            
                keyCoordina.x = targetCoordina.x;
                keyCoordina.y = targetCoordina.y;
            
            elseif startPointIndex ~= -1 and targetPointIndex == -1 then
                keyCoordina.x = startPoint.x;
                keyCoordina.y = startPoint.y;
               
            
            elseif startPointIndex ~= -1 and targetPointIndex ~= -1 then
            
                if bossRecordColor == -1 then
                
                    keyCoordina.x = targetCoordina.x;
                    keyCoordina.y = targetCoordina.y;
                   
                    
                    antherCoordina.x = startPoint.x;
                    antherCoordina.y = startPoint.y;
                
                else
                
                    if GameValue.mxMissionManager:getColorByPst(startPoint.x, startPoint.y) == bossRecordColor then
                    
                        keyCoordina.x = startPoint.x;
                        keyCoordina.y = startPoint.y;
                        
                        antherCoordina.x = targetCoordina.x;
                        antherCoordina.y = targetCoordina.y;
                    
                    else
                    
                        keyCoordina.x = targetCoordina.x;
                        keyCoordina.y = targetCoordina.y;

                        antherCoordina.x = startPoint.x;
                        antherCoordina.y = startPoint.y;

                      
                    end
                end
            end
            local ativeColor = GameValue.mxMissionManager:getColorByPst(keyCoordina.x, keyCoordina.y);
            if bossRecordColor ~= -1 and ativeColor == bossRecordColor then           
                --self:setBossHaveSameMatchColor();
            else            
               -- self:setBossRecordMatchColor(ativeColor);
            end
        end

        local tempKeyCoordina = Coordina.new();
        local tempSwapDir = 2;
        for roundY = 1, #clearViewList do
            
            
            MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.NORMALCLEAR);
            
            coordinateXList = clearViewList[roundY];
            if isActive == true then
            
                if keyCoordina:indexOf(coordinateXList) ~= -1 then
                
                    tempKeyCoordina.x = keyCoordina.x;
                    tempKeyCoordina.y = keyCoordina.y;
                
                elseif antherCoordina ~=nil and antherCoordina.x ~= -1 and antherCoordina.y ~= -1 and  antherCoordina:indexOf(coordinateXList) ~= -1 then
                
                    tempKeyCoordina.x = antherCoordina.x;
                    tempKeyCoordina.y = antherCoordina.y;
                end

            else
            
                tempKeyCoordina = GameValue.mxMissionManager:getTarCoordina(coordinateXList);
                
            end

            if #coordinateXList > 3 then
                if coordinateXList[1].x ~= coordinateXList[2].x and coordinateXList[1].x ~= coordinateXList[3].x and coordinateXList[2].x ~= coordinateXList[3].x then
                    tempSwapDir = MissionGrid.EliminateType.DIR_V;
                else
                    tempSwapDir = MissionGrid.EliminateType.DIR_H;
                end
                
            end
            --积分管理 
            GameValue.mxDataControler:addActiveMatchListScore(tempKeyCoordina, coordinateXList);

            --返回消除的类型   
            local clearMode = GameValue.mxMissionManager:getClearModeByClearList(coordinateXList, tempKeyCoordina);
            

            local destoryListLen = #coordinateXList;
            local hasPowerUp = false;
            for sI = 1, destoryListLen do
                   
                local tmpGridType = GameValue.mxMissionManager:getMissionMatrix(coordinateXList[sI].x, coordinateXList[sI].y);
                if MissionGrid.INTERVAL_POWER_UP:includeValue(tmpGridType) then
                    hasPowerUp = true;
                end
                
                GameValue.mxMissionManager:setStatusMatrix(coordinateXList[sI].x, coordinateXList[sI].y, MissionStatus.CLOSED);
            end
            
            
           
            if self.m_gameStatus > GameStatus.GAMING then
            

                for  tI = 1, destoryListLen do 
                
                    if hasPowerUp == true then
                    
                        self:clearMatchTempCell(coordinateXList[tI], tI, false, { -1, -1 }, Config.clearPowerUpDuration);
                        delayPromptlyCheckDrop = Config.clearPowerUpDuration;
                    
                    else
                    
                        self:clearMatchTempCell(coordinateXList[tI], tI, false);
                    end
                end
                
               
            end


            
            if self.m_gameStatus <= GameStatus.GAMING then

                if clearMode == MissionGrid.ClearMode.MODE_3_VERTICAL or clearMode == MissionGrid.ClearMode.MODE_3_HORIZONTAL then --普通三消
                
                    
                    
                    tempKeyCoordina.x = -1;
                    tempKeyCoordina.y = -1;
                    self.m_totalEliNumCommon = self.m_totalEliNumCommon + 1;
    
                    
    
                    for  tI = 1, destoryListLen do 
                    
                        
                        if hasPowerUp == true then
                        
                            self:clearMatchTempCell(coordinateXList[tI], tI, false, { -1, -1 }, Config.clearPowerUpDuration);
                            delayPromptlyCheckDrop = Config.clearPowerUpDuration;
                        
                        else
                        
                            self:clearMatchTempCell(coordinateXList[tI], tI, false);
                        end
                        
                        
                    end
                    
                
                elseif clearMode > MissionGrid.ClearMode.MODE_3_VERTICAL and tempKeyCoordina:equalsXY(-1, -1) == false then
                
                    if hasPowerUp == true then
                        delayPromptlyCheckDrop = Config.swapDuration + Config.clearDuration;
                    else
                        delayPromptlyCheckDrop = Config.swapDuration + Config.clearPowerUpDuration;
                    end
                    for tI = 1, destoryListLen do 
                    
                        
                        local targetX = tempKeyCoordina.x;
                        local targetY = tempKeyCoordina.y;
                        local tempColor = GameValue.mxMissionManager:getColorByPst(targetX, targetY);
                        local tempCell = GameValue.mxGridContainer:getCellMatrix(coordinateXList[tI].x,coordinateXList[tI].y);
                        local tmpGridType = GameValue.mxMissionManager:getMissionMatrix(coordinateXList[tI].x, coordinateXList[tI].y);

                        if tempKeyCoordina:equalsXY(-1, -1) == false and tempKeyCoordina.x == coordinateXList[tI].x and tempKeyCoordina.y == coordinateXList[tI].y then
                        
                           
                            local c_coordina = Coordina.new();
                            c_coordina.x = coordinateXList[tI].x;
                            c_coordina.y = coordinateXList[tI].y;
                           
                            local c_tI = tI;
                            GameValue.mxGameTimeTween:delayedCall(Config.swapDuration, function()
                            
                                    if hasPowerUp then
                                    
                                        self:clearMatchTempCell(c_coordina, c_tI, false, { -1, -1 }, Config.clearPowerUpDuration);
                                    
                                    else
                                    
                                      
                                        self:clearMatchTempCell(c_coordina, c_tI, false);
                                    end
                                
                                end
                            );
                            
                            
                            local c_clearMode = clearMode;
                            local c_tempSwapDir = tempSwapDir;
                            local c_targetX = targetX;
                            local c_targetY = targetY;
                            local c_tempColor = tempColor
                            GameValue.mxGameTimeTween:delayedCall(Config.swapDuration, function()
                                                         
                                    --GameValue.mxGridContainer:playEffect("PowerUpAppearEft", "1", tempKeyCoordina);
                                    if hasPowerUp == true then
                                    
                                        
                                         GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration, function()                                      
                                            self:creatPropItem(c_clearMode, c_tempSwapDir, c_targetX, c_targetY, c_tempColor,true);
                                            
                                               
                                                
                                          end
                                        );
                                        
                                    
                                    else
                                    
                                         GameValue.mxGameTimeTween:delayedCall(Config.clearDuration, function()
                                        
                                             
                                            self:creatPropItem(c_clearMode, c_tempSwapDir, c_targetX, c_targetY, c_tempColor,true);
                                          end
                                        );
                                    end
                                end
                            );
                        
                        else
                        
                           if MissionGrid.INTERVAL_POWER_UP:includeValue(tmpGridType) == false then 
                                tempCell:swapMoveTo(tempKeyCoordina.x,tempKeyCoordina.y);
                           end
                           
                           local delayC = function(parma)
                                if parma[1] == true then

                                    self:clearMatchTempCell(parma[2], parma[3], true, parma[4], Config.clearPowerUpDuration);

                                else
                                   
                                    self:clearMatchTempCell(parma[2], parma[3], true, parma[4]);
                                end
                           end
                           local coordinate = Coordina.new();
                           coordinate.x = coordinateXList[tI].x;
                           coordinate.y= coordinateXList[tI].y;
                            GameValue.mxGameTimeTween:delayedCall(Config.swapDuration, delayC,{hasPowerUp,coordinate,tI,tempKeyCoordina}
                            );

                        end
                        
                        
                    end
    
                
                else
                
                    for tI = 1,destoryListLen do
                    
    
                        if hasPowerUp == true then
                        
                            self:clearMatchTempCell(coordinateXList[tI], tI, false, { -1, -1 }, Config.clearPowerUpDuration);
                        
                        else
                        
                            self:clearMatchTempCell(coordinateXList[tI], tI, false);
                        end
    
                    end
    
                end
            end

        end

        
        GameValue.mxGameTimeTween:delayedCall(delayPromptlyCheckDrop + 0.2, function()
            self.m_wait = false;
            self:promptlyCheckDrop();
         end
        );
        return true;
    end
    
    return false;
end

function GameControler:promptlyCheckDrop()

    if self:checkDrop() == false then
    
        if GameValue.mxMissionManager:getStatusIsStatic() then
        
 
            if #self.m_activePowerUpList > 0 then
            
            else
            
                self.m_wait = true;
            end
         end  
        
    end
end

function GameControler:checkDrop()



    local droped = false; 
    GameValue.mxMissionManager:setAllStatusWaitingToOpen();
    
    local newItemCellList = {0,0,0,0,0,0,0,0,0};
    local tempItemCell = nil;

    for  roundY = self.m_maxRow, 1,-1 do
        for roundX = 1, self.m_maxCol do
        
            local gridType = GameValue.mxMissionManager:getMissionMatrix(roundX, roundY);

            if gridType == MissionGrid.NONE then--产生一个一个掉落现象
            

                local tempCommingGrid = GameValue.mxMissionManager:findCommingGrid(roundX, roundY);

                if tempCommingGrid.needNew == true or tempCommingGrid.x ~= -1 or tempCommingGrid.y~= -1 then

                    if tempCommingGrid.needNew == true then
                    
                        droped = true;
                        newItemCellList[roundX] = newItemCellList[roundX] + 1;
    
                        tempItemCell = GameValue.mxGridContainer:addNewItemCellBy(GameValue.mxDataControler:getNewRandomItemId(self.m_totalEliNumCommon), roundX, -newItemCellList[roundX] + 1);
    
                        tempItemCell:setCoordina(roundX, -newItemCellList[roundX] + 1);
    
                        GameValue.mxMissionManager:setDropingGridStatus(-newItemCellList[roundX] + 1, roundY, roundX, MissionStatus.DROPING, MissionStatus.DROPING_MARK_LAST);
    
                        tempItemCell:downTo(roundX, roundY);
    
                        GameValue.mxGridContainer:setCellMatrix(tempItemCell, roundX, roundY);
    
                        GameValue.mxMissionManager:setMissionMatrix(roundX, roundY, tempItemCell:getGridType());
                       

                    else
                    
                        droped = true;
                        if tempCommingGrid.gridStatus == MissionStatus.DROPING then
                        
                            GameValue.mxMissionManager:setDropingGridStatus(tempCommingGrid.y, roundY, roundX, MissionStatus.DROPING, MissionStatus.DROPING_MARK_LAST);
                        
                        elseif tempCommingGrid.gridStatus == MissionStatus.INCLINE then
                        
                            GameValue.mxMissionManager:setStatusMatrix(tempCommingGrid.x, tempCommingGrid.y, MissionStatus.OPEN);
                            GameValue.mxMissionManager:setStatusMatrix(roundX, roundY, MissionStatus.INCLINE);
                        
                        else 
                            return false;
                        end
    
                        tempItemCell = GameValue.mxGridContainer:getCellMatrix(tempCommingGrid.x, tempCommingGrid.y);
    
                        GameValue.mxGridContainer:setCellMatrix(nil, tempCommingGrid.x, tempCommingGrid.y);
                        GameValue.mxMissionManager:setMissionMatrix(tempCommingGrid.x, tempCommingGrid.y, MissionGrid.NONE);
                        tempItemCell:downTo(roundX, roundY);
    
                        GameValue.mxGridContainer:setCellMatrix(tempItemCell, roundX, roundY);
    
                        GameValue.mxMissionManager:setMissionMatrix(roundX, roundY, tempItemCell:getGridType());
                        
                    end
                end
            end
        end
    end
    

    --self:checkDropOut();
    self.m_eliminateTime = 0;

    return droped;
end

function GameControler:onDropCompleteHandler(tempCell)
    local tempDropStatus = tempCell:getDropStatus();
    tempCell:play4DropDownMotion();
    GameValue.mxMissionManager:setStatusMatrix(tempCell:getCoordina().x,tempCell:getCoordina().y, MissionStatus.WAITING);
   
    
    
    

   
    if tempDropStatus == MissionGrid.DropStatus.MOVE then
    
        local fromX = tempCell:getCoordina().x;
        local fromY = tempCell:getCoordina().y - 1;

        for  yRound = fromY,1,-1 do
        
            local tempGridType = GameValue.mxMissionManager:getMissionMatrix(fromX, yRound);

            if tempGridType ~= MissionGrid.NONE and tempGridType ~= MissionGrid.BLANK and tempGridType ~= MissionGrid.BORDER then  
                break; 
            end;

            local tempGridStatus = GameValue.mxMissionManager:getStatusMatrix(fromX, yRound);

            if tempGridStatus == MissionStatus.DROPING_MARK_LAST then  
                break;
                
            end;

            GameValue.mxMissionManager:setStatusMatrix(fromX, yRound, MissionStatus.WAITING);
        end
    end
    tempCell:setArrive(false);
    tempCell:setDropStatus(MissionGrid.DropStatus.REST);
    
    
    local tempCoordina = GameValue.mxGridContainer:checkTransport(tempCell:getCoordina(), tempCell:getCoordina());-- 检测是否有水果可以收集
    if tempCoordina.x ~= -1 and tempCoordina.y ~= -1 then

        self:clearPowerDownCell(tempCoordina);
    end
end;

function GameControler:setWait(b)
    self.m_wait = b;
end;

--/**
--* 交换主动减步数
--*/
function GameControler:checkSubStepWhenActiveSwap( startPoint, targetCoordina,  isReset)


    if isReset == false then
       GameValue.mxDataControler:subLimitStep();
       
     end 
    
  
    
   
    return false;

end

function GameControler:clearMatchTempCell(targetCoordina,  round,  hasCreat, creatPostionCoordina, clearDuration)

    if clearDuration == nil then clearDuration = Config.clearDuration end;
    if creatPostionCoordina == nil then creatPostionCoordina = Coordina.new(); end

    local tmpGridType = GameValue.mxMissionManager:getMissionMatrix(targetCoordina.x, targetCoordina.y);

    self:clearNeighborMathchCell(targetCoordina);

    if MissionGrid.INTERVAL_COMMON:includeValue(tmpGridType) then
    
        if hasCreat == false then
        
            self:collectCommonCell(targetCoordina, round);
            self:clearCommonCell(targetCoordina, clearDuration);
            
        
        else
        
            self:collectCommonCell(targetCoordina, round, creatPostionCoordina);
            self:clearCommonCellWithNoEFT(targetCoordina, clearDuration);
        end
    elseif MissionGrid.INTERVAL_POWER_UP:includeValue(tmpGridType) then
        self:clearPowerUpCell(targetCoordina);--TODO
    elseif MissionGrid.INTERVAL_BOSS:includeValue(tmpGridType) then
        self:clearBossCell(targetCoordina);--TODO
    end
end

function GameControler:clearNeighborMathchCell(coordina)

    local neighborMathchVector = GameValue.mxMissionManager:getNeighborMathchList(coordina.x, coordina.y);

    if #neighborMathchVector > 0 then
    
        for nI = 1,#neighborMathchVector do
        
            local tempGrid = GameValue.mxMissionManager:getMissionMatrix(neighborMathchVector[nI].x, neighborMathchVector[nI].y);
            if MissionGrid.INTERVAL_COMMON:includeValue(tempGrid) then
            
                if tempGrid % 10 == 9 then
                    self:clearBossCell(neighborMathchVector[nI]);
                end
            
            elseif MissionGrid.INTERVAL_POWER_DOWN:includeValue(tempGrid) then
            
                self:clearPowerDownCell(neighborMathchVector[nI]);
            
            elseif MissionGrid.INTERVAL_BOSS:includeValue(tempGrid) then
            
                self:clearBossCell(neighborMathchVector[nI]);
            end
        end
    end

end



--TODO
function GameControler:clearCommonCell(coordina,  clearDuration,flyStartCoordina)

    if clearDuration == nil then
        clearDuration = Config.clearDuration;
    end;
    local gridCell = GameValue.mxGridContainer:getCellMatrix(coordina.x, coordina.y);
    if gridCell ~= nil then 
        gridCell:play6CleartMotion();
    end;
    self:clearBrickCell(coordina);
    GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.CLEARING);
    GameValue.mxGridContainer:setCellMatrix(nil, coordina.x, coordina.y);
    
    if flyStartCoordina==nil then
    
        GameValue.mxGridContainer:playClearEffect(GameValue.mxMissionManager:getMissionMatrix(coordina.x, coordina.y),coordina)
    end
    

    local function clearComplete(m_coordina)
        GameValue.mxMissionManager:setMissionMatrix(m_coordina.x, m_coordina.y, MissionGrid.NONE);
        GameValue.mxMissionManager:setStatusMatrix(m_coordina.x, m_coordina.y, MissionStatus.OPEN);

    end

    local c_coordina = Coordina.new();
    c_coordina.x = coordina.x;
    c_coordina.y = coordina.y;
    GameValue.mxGameTimeTween:delayedCall(clearDuration,clearComplete,c_coordina)
 
end

function GameControler:clearCommonCellWithNothing(coordina)

    local tempCell = GameValue.mxGridContainer:getCellMatrix(coordina.x, coordina.y);
    if tempCell == nil then
        return;
    end;
    tempCell:play6CleartMotion();
    self:clearBrickCell(coordina);
    
    GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.CLEARING);
    GameValue.mxGridContainer:setCellMatrix(nil, coordina.x, coordina.y);
end

function GameControler:clearCommonCellWithNoEFT(coordina,  clearDuration)
    
    local tempCoordina = Coordina.new();
    tempCoordina.x = coordina.x;
    tempCoordina.y = coordina.y
    local tempCell = GameValue.mxGridContainer:getCellMatrix(tempCoordina.x, tempCoordina.y);
    if tempCell == nil then
        return;
    end;
    tempCell:destroy();
    self:clearBrickCell(tempCoordina);
    
    GameValue.mxMissionManager:setStatusMatrix(tempCoordina.x, tempCoordina.y, MissionStatus.CLEARING);
    GameValue.mxGridContainer:setCellMatrix(nil, tempCoordina.x, tempCoordina.y);

     GameValue.mxGameTimeTween:delayedCall(clearDuration,function()
    
        
            GameValue.mxMissionManager:setMissionMatrix(tempCoordina.x, tempCoordina.y, MissionGrid.NONE);
            GameValue.mxMissionManager:setStatusMatrix(tempCoordina.x, tempCoordina.y, MissionStatus.WAITING);
     end
    );
end



function GameControler:clearPowerUpCell(m_coordina)

    local coordina = Coordina.new();
    coordina.x = m_coordina.x;
    coordina.y = m_coordina.y;
    local tempCell = GameValue.mxGridContainer:getCellMatrix(coordina.x, coordina.y);
    if tempCell == nil then
        return;
    end;
    tempCell:play6CleartMotion();

    self.m_totalEliNumPowerUp = self.m_totalEliNumPowerUp +  1;

    self:clearBrickCell(coordina);

    local powerUpGridTpye = GameValue.mxMissionManager:getMissionMatrix(coordina.x, coordina.y);
    
    if MissionGrid.isBombo(powerUpGridTpye) then
    

        self.powerUpAssemControler:executeBombClear(coordina);
    
    
    elseif MissionGrid.isEliH(powerUpGridTpye) or MissionGrid.isEliV(powerUpGridTpye) then
    
        self.powerUpAssemControler:executeRocketClear(coordina);
    
    
    elseif powerUpGridTpye == MissionGrid.PU_RAINBOW then
    
        --随即消除场景中一种颜色的冰激凌消除
        local eliGridColor = GameValue.mxMissionManager:getTarSceneRandomColor();
        if eliGridColor ~= 0 then
            self.powerUpAssemControler:executeRainbowRandom(coordina, eliGridColor);     
        end
        
    end
end



function GameControler:clearPowerDownCell(coordina)

    local tempCell = GameValue.mxGridContainer:getCellMatrix(coordina.x, coordina.y);
    if tempCell == nil then 
        return; 
    end



    local powerDownGridTpye = GameValue.mxMissionManager:getMissionMatrix(coordina.x, coordina.y);

    local isClear = true;

    if MissionGrid.isCandy(powerDownGridTpye) then
    
        local candyGridType = tempCell:getGridType();
        if candyGridType > MissionGrid.PD_CANDY_0 then
        
            candyGridType = candyGridType - 1;
            if candyGridType > MissionGrid.PD_CANDY_0 then
            
                self:collectPowerDown(coordina);
                isClear = false;
                GameValue.mxMissionManager:setMissionMatrix(coordina.x, coordina.y, candyGridType);
                GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.OPEN);
                tempCell:play6CleartMotion();
                tempCell:setGridType(candyGridType);

            
            else
            
                GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.CLEARING);
                tempCell:play6CleartMotion();
            end
        end

        GameValue.mxDataControler:addItemScore(coordina, ScoreValue.SCORE_PD_CANDY);

    
    elseif MissionGrid.isPopcorn(powerDownGridTpye) then
    
        GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.CLEARING);
        tempCell:play6CleartMotion();
        GameValue.mxDataControler:addItemScore(coordina, ScoreValue.SCORE_PD_POPCORN);
    
    elseif MissionGrid.isCake(powerDownGridTpye) then
    
        GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.CLEARING);
        tempCell:play6CleartMotion();

        GameValue.mxDataControler:addItemScore(coordina, ScoreValue.SCORE_PD_CAKE);
        MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.PD_CAKE);
   
    elseif MissionGrid.isFruit(powerDownGridTpye) then
    
        tempCell:play6CleartMotion();
        GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.CLOSED);
        
    end

    if isClear == true then
        
        if MissionGrid.isCandy(powerDownGridTpye) == false then
            self:clearBrickCell(coordina);
        end
        GameValue.mxGridContainer:setCellMatrix(nil, coordina.x, coordina.y);

        if MissionGrid.isFruit(powerDownGridTpye) then--水果动画长
        

            GameValue.mxGameTimeTween:delayedCall(1.0, function() 
           
                self:collectPowerDown(coordina);
            end
            );
                

            GameValue.mxGameTimeTween:delayedCall(1.0, function()
            
                
                GameValue.mxMissionManager:setMissionMatrix(coordina.x, coordina.y, MissionGrid.NONE);
                GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.WAITING);

                self.m_wait = false;

                self:promptlyCheckDrop();
            end
            );

            
        
        else
        

            self:collectPowerDown(coordina);

            GameValue.mxGameTimeTween:delayedCall(Config.clearDuration, function()
            
                GameValue.mxMissionManager:setMissionMatrix(coordina.x, coordina.y, MissionGrid.NONE);
                GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.WAITING);
            end
            );

        end

        
    end
end




function GameControler:clearBossCell(coordina)

    --GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.OPEN);

    --doBossHurt(coordina);
end

function GameControler:clearPowerUpCellAsCommonCell(coordina)

    local tempCell = GameValue.mxGridContainer:getCellMatrix(coordina.x, coordina.y);
    if tempCell == nil then
        return;
    end
    tempCell:play6CleartMotion();

    self:clearBrickCell(coordina);

    GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.CLEARING);
    GameValue.mxGridContainer:setCellMatrix(nil, coordina.x, coordina.y);

    local c_coordina = Coordina.new();
    c_coordina.x = coordina.x;
    c_coordina.y = coordina.y;
    GameValue.mxGameTimeTween:delayedCall(Config.clearDuration, function()
    
            GameValue.mxMissionManager:setMissionMatrix(c_coordina.x, c_coordina.y, MissionGrid.NONE);
            GameValue.mxMissionManager:setStatusMatrix(c_coordina.x, c_coordina.y, MissionStatus.WAITING);
        end
    );
end


function GameControler:clearBrickCell(coordina)

    local brickCell = GameValue.mxGridContainer:getBrickMatrix(coordina.x, coordina.y);
    if brickCell == nil then
        return;
    end

    if brickCell:getGridType() == MissionGrid.TYPE_FRUIT_PLATE then 
        return;
    end
    self:collectBrickCell(coordina);
    brickCell:play3ClearMotion();
    GameValue.mxGridContainer:setBrickMatrix(nil, coordina.x, coordina.y);
    GameValue.mxMissionManager:setBrickMatrix(coordina.x, coordina.y, MissionGrid.NONE);
end

function GameControler:collectCommonCell(coordina,  round, targetPostionCoordina,flyStartCoordina )
    
    if targetPostionCoordina == nil then
        targetPostionCoordina = Coordina.new()
    end
    if round == 0 then
        local tempGridType = GameValue.mxMissionManager:getMissionMatrix(coordina.x, coordina.y);

        local tempTargetPostionCoordina = Coordina.new();
        if targetPostionCoordina:equalsXY(-1,-1) == false then
        
            tempTargetPostionCoordina.x = targetPostionCoordina.x;
            tempTargetPostionCoordina.y = targetPostionCoordina.y;
        
        else
        
            tempTargetPostionCoordina.x = coordina.x;
            tempTargetPostionCoordina.y = coordina.y;
        end
        

        if tempGridType == MissionGrid.NONE then
            return;
        end
        
        local tempList = GameValue.mxDataControler:getCanCollectGridList(tempGridType);
        
       
        
        for round = 1,#tempList do
        
            local tmpType = tempList[round][1];
            self.m_flyingCollectItemSum = self.m_flyingCollectItemSum + 1;
            MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.GETOBJECTS)
            GameValue.mxDataControler:statRealCollectGrid(tmpType);
            
            if flyStartCoordina~=nil then
                coordina = flyStartCoordina
            end
            
            GameValue.mxGridContainer:playCollectGridEft(tmpType, coordina, GameValue.mxDataControler:getTargetRootPositionByIndex(tempList[round][2]), 
                function()


                    self:onGridFlyEndHandler(tmpType);
                    self.m_flyingCollectItemSum = self.m_flyingCollectItemSum - 1;

                    if self.m_flyingCollectItemSum < 0 then
                        self.m_flyingCollectItemSum = 0;
                    end
                end
            );
        end
    
    else
        
        local c_coordina = Coordina.new();
        c_coordina.x = coordina.x;
        c_coordina.y = coordina.y;
        
        local c_targetPostionCoordina = Coordina.new();
        c_targetPostionCoordina.x = targetPostionCoordina.x;
        c_targetPostionCoordina.y = targetPostionCoordina.y;
         GameValue.mxGameTimeTween:delayedCall(0.015 * round, function()
        
                self:collectCommonCell(c_coordina, 0, c_targetPostionCoordina,flyStartCoordina);
            end
        );
    end
end

function GameControler:collectBrickCell(coordina)

    local tempGridType = GameValue.mxMissionManager:getBrickMatrix(coordina.x, coordina.y);
    if tempGridType == MissionGrid.NONE then
        return;
    end
    local tempList = GameValue.mxDataControler:getCanCollectBrickGridId(tempGridType);
    if #tempList== 0 then
        return;
    end
    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.GETOBJECTS)
    local tmpCoordina = Coordina.new();
    tmpCoordina.x = coordina.x;
    tmpCoordina.y = coordina.y;
    GameValue.mxGameTimeTween:delayedCall(0.05, function()
    
        local tmpType = tempList[1];

        self.m_flyingCollectItemSum = self.m_flyingCollectItemSum + 1;

        GameValue.mxDataControler:statRealCollectBrick(tmpType);
            GameValue.mxGridContainer:playCollectGridEft(tmpType, coordina, GameValue.mxDataControler:getTargetRootPositionByIndex(tempList[2]), 
        function()
        
            
            self:onBrickFlyEndHandler(tmpType);
            self.m_flyingCollectItemSum = self.m_flyingCollectItemSum - 1;

            if self.m_flyingCollectItemSum < 0 then
                self.m_flyingCollectItemSum = 0;
            end
        end
        );

   
    end
    );
end




function GameControler:collectPowerDown( coordina)

    local tempGridType = GameValue.mxMissionManager:getMissionMatrix(coordina.x, coordina.y);
    if tempGridType == MissionGrid.NONE then return end
    local tarItemcellList = GameValue.mxDataControler:getCanCollectGridList(tempGridType);
    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.GETOBJECTS)
    for  round = 1, #tarItemcellList do
    
        local tmpType = tarItemcellList[round][1];

        self.m_flyingCollectItemSum = self.m_flyingCollectItemSum + 1;
        GameValue.mxDataControler:statRealCollectGrid(tmpType);
        GameValue.mxGridContainer:playCollectGridEft(tmpType, coordina, GameValue.mxDataControler:getTargetRootPositionByIndex(tarItemcellList[round][2]), function()
        
            
                self:onGridFlyEndHandler(tmpType);
                self.m_flyingCollectItemSum = self.m_flyingCollectItemSum - 1;

                if self.m_flyingCollectItemSum < 0 then
                    self.m_flyingCollectItemSum = 0;
                end
        end
        );

       
    end

end


function GameControler:onGridFlyEndHandler( gridType)

    GameValue.mxDataControler:statCollectGrid(gridType);
    if GameValue.mxDataControler:getLimitStep() ==1 and GameValue.mxDataControler:updateCheckPropsPrompt() == true   then
        MainValue.mxGameManager:onPropsPrompt(1);
    end;

    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.GETOBJECTSDONE);
end

function GameControler:onBrickFlyEndHandler( gridType)

    GameValue.mxDataControler:statCollectBrick(gridType);
    if GameValue.mxDataControler:getLimitStep() ==1 and GameValue.mxDataControler:updateCheckPropsPrompt() == true   then
        MainValue.mxGameManager:onPropsPrompt(1);
    end;
--
    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.GETOBJECTSDONE);
end


function GameControler:destroyClearList(destoryList,flyStartCoordina)

    if #destoryList == 0 then 
        return;
    end

    local destoryListLen = #destoryList;
    
    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.NORMALCLEAR);

    for round = 1,destoryListLen do
    

        local tmpGridType = GameValue.mxMissionManager:getMissionMatrix(destoryList[round].x, destoryList[round].y);
        GameValue.mxMissionManager:setStatusMatrix(destoryList[round].x, destoryList[round].y, MissionStatus.CLEARING);
        if MissionGrid.INTERVAL_COMMON:includeValue(tmpGridType) then
        
           
        
            if tmpGridType % 10 == MissionGrid.BOSS9_UFO then
            
                self:clearBossCell(destoryList[round]);
            
            else
             
                self:collectCommonCell(destoryList[round], round,nil,flyStartCoordina);
                
                self:clearCommonCell(destoryList[round],nil,flyStartCoordina);
                                
            end
        
        elseif MissionGrid.INTERVAL_POWER_UP:includeValue(tmpGridType) then
        
            self:clearPowerUpCell(destoryList[round]);
        
        elseif MissionGrid.INTERVAL_POWER_DOWN:includeValue(tmpGridType) then
        
            self:clearPowerDownCell(destoryList[round]);
        
        elseif MissionGrid.INTERVAL_BOSS:includeValue(tmpGridType) then
        
            self:clearBossCell(destoryList[round]);
        end
    end
    

    
end

function GameControler:pushToActivePowerUpList(coordina)

    local powerCell = GameValue.mxGridContainer:getCellMatrix(coordina.x, coordina.y);

    local newGridType = GameValue.mxMissionManager:getMissionMatrix(coordina.x, coordina.y) + 10;
    powerCell:playActiveEft();
    powerCell:setGridType(newGridType);
    GameValue.mxMissionManager:setMissionMatrix(coordina.x, coordina.y, newGridType);
    GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.OPEN);
    table.insert(self.m_activePowerUpList,powerCell)
    
end

function GameControler:doTempActivePowerUpAction()

    local gameAllPowerUpList = GameValue.mxMissionManager:getTarGameAllPowerUpList();
    if #gameAllPowerUpList > 0 then
    
        self:clearPowerUpCell(gameAllPowerUpList[1]);
        return true;
    end
    return false;
end


function GameControler:doActivePowerUpListAction()
    
    
    if #self.m_activePowerUpList > 0 then
       
        
        if GameValue.mxMissionManager:getStatusIsStatic() == true then
        
            local tempPowerUp = self.m_activePowerUpList[1];
            table.remove(self.m_activePowerUpList,1)
            self:clearPowerUpCell(tempPowerUp:getCoordina());
            
            
        end
        return true;
    end
   
    return false;
end

function GameControler:transformToPowerUpByFrontBoost(coordina,powerUpId)
 
    local tempCell = GameValue.mxGridContainer:getCellMatrix(coordina.x, coordina.y);
    if tempCell == nil then
        return;
    end;
    tempCell:destroy();
    GameValue.mxMissionManager:setMissionMatrix(coordina.x, coordina.y, powerUpId);
--    GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.CLEARING);
    GameValue.mxGridContainer:setCellMatrix(nil, coordina.x, coordina.y);
    
    local tempItemCell = GameValue.mxGridContainer:addNewItemCellBy(GameValue.mxMissionManager:getMissionMatrix(coordina.x,coordina.y), coordina.x, coordina.y);
    GameValue.mxGridContainer:setCellMatrix(tempItemCell, coordina.x,coordina.y);

    tempItemCell:setCoordina(coordina.x,coordina.y);
    tempItemCell:playAppearMotion();
end
function GameControler:creatPropItem( clearMode,  swapDir,  tempX,  tempY,  color,  isCompose)

    local powerUpType = GameValue.mxMissionManager:getRandomPowerUpType(clearMode, color, swapDir);
    
   
    local tempItemCell = GameValue.mxGridContainer:addNewItemCellBy(powerUpType, tempX, tempY);

    GameValue.mxGridContainer:setCellMatrix(tempItemCell, tempX, tempY);

    tempItemCell:setCoordina(tempX, tempY);
    if isCompose == false then
        tempItemCell:playAppearEft();
    end
    
    GameValue.mxMissionManager:setMissionMatrix(tempX, tempY, powerUpType);
    GameValue.mxMissionManager:setStatusMatrix(tempX, tempY, MissionStatus.OPEN);

    if powerUpType % 10 == 2 or powerUpType % 10 == 3 then
    
        MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.CREATE_PU_CROSS);
    elseif powerUpType % 10 == 1 then
        MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.CREATE_PU_BOMB);
    
    elseif powerUpType == MissionGrid.PU_RAINBOW then
        MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.CREATE_PU_COLORREMOVE);
    else
        MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.COMBINE);
    end
    
    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.CREATE_PU_CROSS);
end

function GameControler:doUsePowerUpItemAction(destoryList)

    for round = 1, #destoryList do
    
        local tmpGridType = GameValue.mxMissionManager:getMissionMatrix(destoryList[round].x, destoryList[round].y);

        if MissionGrid.INTERVAL_COMMON:includeValue(tmpGridType) then
        
            if tmpGridType % 10 == MissionGrid.BOSS9_UFO then
            
                self:clearBossCell(destoryList[round]);
            
            else
                
                self:collectCommonCell(destoryList[round], round);
                self:clearCommonCell(destoryList[round]);
            end
        
        elseif MissionGrid.INTERVAL_POWER_UP:includeValue(tmpGridType) then
        
            self:pushToActivePowerUpList(destoryList[round]);
        
        elseif MissionGrid.INTERVAL_POWER_DOWN:includeValue(tmpGridType) then
        
            self:clearPowerDownCell(destoryList[round]);
        
        elseif MissionGrid.INTERVAL_BOSS:includeValue(tmpGridType) then
        
            self:clearBossCell(destoryList[round]);
        end

    end
end


function GameControler:updateCheckEliminate(spendTime)

    

    if self.m_gameStatus ~= GameStatus.GAMING or GameValue.mxDataControler:getLimitStep() <= 0 then
    
        self.m_eliminateTime = 0;
        return;
    end
    
    self.m_eliminateTime = self.m_eliminateTime + spendTime;

    if self.m_eliminateTime >= Config.promptGap then
    
        --todo 
        if self.m_wait == false then return end;
       
        
        
        local potentialShares = self:checkNoMatch();
        if #potentialShares == 0 then
        
            self.m_eliminateTime = 0;
            return;
        end
            
        for i = 1, #potentialShares do
        
            local tempCoordina = potentialShares[i];
            local tempItemCell = GameValue.mxGridContainer:getCellMatrix(tempCoordina.x,tempCoordina.y);
            if tempItemCell ~= nil then
            
                tempItemCell:play5PromptMotion();
                
                local delayC = function(pramarm)
                    local itemCell = GameValue.mxGridContainer:getCellMatrix(pramarm[1],pramarm[2]);
                    if itemCell ~= nil then
                        itemCell:play5PromptMotion();
                    end
                end;
                
                GameValue.mxGameTimeTween:delayedCall(0.5, delayC,{tempCoordina.x,tempCoordina.y});
            end
        end

        self.m_eliminateTime = Config.promptGap - 3;
    end
end


function GameControler:checkNoMatch()

    local potentialShares = {};
    if self.m_gameStatus >= GameStatus.GAME_END or self.m_gameStatus == GameStatus.GAME_NOMATCH then
    
        return potentialShares;
    end

    potentialShares = GameValue.mxMissionManager:checkEliminate();

    if #potentialShares == 0 then     

        if self:onNoMatchAction() == true then            
            self. m_gameStatus = GameStatus.GAME_NOMATCH;            
            potentialShares = {};  
            GameValue.mxGameEFT:playNoMatchMotion();
            GameValue.mxGameTimeTween:delayedCall(0.8,function()
                self:noMatchAndRefreshGridAction();
            end
            )          
           
        else         
            potentialShares = {};
            self.m_gameStatus = GameStatus.GAME_FAIL;         
        end
    end
    return potentialShares;
    
end


function GameControler:onNoMatchAction()

    
    
    local enable = false;
    local count = 500;
    local itemList = {};
    local itemSizeList = {};
    local potentialShares = {};

    for  yRound = 1, self.m_maxRow do
    
        for  xRound = 1, self.m_maxCol do
        
            local tempGridType = GameValue.mxMissionManager:getMissionMatrix(xRound, yRound);
            --洗牌新的位置处理 
            if GameValue.mxStatusLogic:getMathchEnable(tempGridType) and GameValue.mxStatusLogic:getMoveEnable(tempGridType) and MissionGrid.INTERVAL_POWER_UP:includeValue(tempGridType) == false and MissionGrid.INTERVAL_POWER_DOWN:includeValue(tempGridType) == false  then --2015 03 19 策划要求洗牌不洗powerUp
            

                local tempItem = GameValue.mxGridContainer:getCellMatrix(xRound, yRound);
              
                table.insert(itemList,tempItem)
                table.insert(itemSizeList,#itemList)
                            
            end
        end
    end

    
    while count > 0 do
    
        count = count -1;
        for round = 1, #itemList do
        
            local tempCoordina = Coordina.new();
            tempCoordina.x = itemList[round]:getCoordina().x;
            tempCoordina.y = itemList[round]:getCoordina().y;
            GameValue.mxMissionManager:setStatusMatrix(tempCoordina.x, tempCoordina.y, MissionStatus.CLOSED);
            GameValue.mxGridContainer:setCellMatrix(nil, tempCoordina.x, tempCoordina.y);

        end

        local tempItemSizeList = {};
        
        tempItemSizeList = Util:deepcopy(itemSizeList);
       
        
        for  yRound = 1, self.m_maxRow do
        
            for xRound = 1, self.m_maxCol do
            
                local tempGridType = GameValue.mxMissionManager:getStatusMatrix(xRound, yRound);

                if tempGridType == MissionStatus.CLOSED and #tempItemSizeList > 0 then
                
                    local index = math.random(1, #tempItemSizeList);
                    
                    if tempItemSizeList[index]~=nil and itemList[tempItemSizeList[index]]~=nil then
           
                        GameValue.mxMissionManager:setMissionMatrix(xRound, yRound, itemList[tempItemSizeList[index]]:getGridType());
                        
                        GameValue.mxMissionManager:setStatusMatrix(xRound, yRound, MissionStatus.OPEN);
                        GameValue.mxGridContainer:setCellMatrix(itemList[tempItemSizeList[index]], xRound, yRound);
                      
                        
                        table.remove(tempItemSizeList,index)
                    end
                end
            end
        end
        if GameValue.mxMissionManager:checkMissionClear() then
        
            GameValue.mxMissionManager:resetReferMatrix(); 
        
        else
        
            potentialShares = {};
            potentialShares = GameValue.mxMissionManager:checkEliminate();
            if #potentialShares >= 3 then
            
                enable = true;
                break;
            end
        end
    end


    return enable;
end

function GameControler:noMatchAndRefreshGridAction()


    self.m_eliminateTime = 0;
    self.m_wait = false;
    
    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.REFRESH);
    for  yRound = 1,self.m_maxRow do
    
        for xRound = 1,self.m_maxCol do
        
            local tempGridType = GameValue.mxMissionManager:getMissionMatrix(xRound, yRound);
            
            
            if GameValue.mxStatusLogic:getMathchEnable(tempGridType) and GameValue.mxStatusLogic:getMoveEnable(tempGridType) then      
                local tempItem = GameValue.mxGridContainer:getCellMatrix(xRound, yRound);
                tempItem:setCoordina(xRound, yRound);
                GameValue.mxGridContainer:washCellPst(tempItem);

            end
        end
    end

    GameValue.mxGameTimeTween:delayedCall(0.4, function()   
        self.m_wait = true;
        self.m_gameStatus = GameStatus.GAMING;     
    end
    );

    
end

function GameControler:updateGameStatus(spendTimes)

    self.m_updateGameStatusTime = self.m_updateGameStatusTime - spendTimes;
    if self.m_updateGameStatusTime <= 0 then
    
        self.m_updateGameStatusTime = self.UPDATE_G_S_TIME;
    
    else 
        return;
    end

    if self.m_flyingCollectItemSum == 0 and #self.m_activePowerUpList == 0 and GameValue.mxMissionManager:getStatusIsStatic() then
    
        self:refreshGameStatus();
    end
end

function GameControler:refreshGameStatus()
   
    if self.m_gameStatus == GameStatus.GAMING then
    
        local taskSuccess = GameValue.mxDataControler:getMissionComplete();
        if taskSuccess == true then
        

            if self.m_buyPropId > 0 then
                self:useBuyPropEnd(false);
            end

            local gameAllPowerUpList = GameValue.mxMissionManager:getTarGameAllPowerUpList();
            if #gameAllPowerUpList > 0 then           
                self.m_gameStatus = GameStatus.GAME_END;
                self:refreshGameStatus();
            else
                self.m_gameStatus = GameStatus.GAME_GRAND_FINAL_ANIMATION;
                self:refreshGameStatus();
            end
        
        else
        
            if GameValue.mxDataControler:getLimitStep() == 0 then
                self.m_gameStatus = GameStatus.GAME_FAIL_READY;
                GameValue.mxGameTimeTween:delayedCall(0.5,
                function()
                    MainValue.mxGameManager:showNoStepUI(GameValue.mxDataControler:getTotalScore(), GameValue.mxDataControler:getTargetStatus())
                end
                )
--                local delay = GameValue.mxGridContainer:showNoStepEffect();
--                GameValue.mxGameTimeTween:delayedCall(delay, [this]{LuaEngine::getInstance():executeString(Util::cFormat("MainValue.mxGameManager:showNoStepUI(%d, %s)", GameValue.mxDataControler:getTotalScore(), GameValue.mxDataControler:getTargetStatus().c_str()).c_str());
--                });

            end
        end
    
    elseif self.m_gameStatus == GameStatus.GAME_END then
    
        local gameAllPowerUpList = GameValue.mxMissionManager:getTarGameAllPowerUpList();
        if #gameAllPowerUpList == 0 then
        
            self.m_gameStatus = GameStatus.GAME_GRAND_FINAL_ANIMATION;
            self:refreshGameStatus();
        
        else
        
            if self:doTempActivePowerUpAction() == true then
            
                self.m_wait = false;
                
--                GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration + 0.1, [this]
--                {
--                    //promptlyCheckDrop();
--                });
                
            end
        end
    
    elseif self.m_gameStatus == GameStatus.GAME_GRAND_FINAL_ANIMATION then
    
        if GameValue.mxDataControler:getLimitStep() > 0 then
        
            self.m_gameStatus = GameStatus.GAME_GRAND_FINAL_ANIMATIONING;
            GameValue.mxGameEFT:playSweetFinalMotion();
            
            MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.FINAL_WORD);
            MainValue.mxGameManager:enterGameStatus(self.m_gameStatus)
            GameValue.mxGameTimeTween:delayedCall(2, function()
            
                self.m_gameStatus = GameStatus.GAME_GRAND_FINAL_READY;
                self:refreshGameStatus();
            end
            );


        
        else
        
            self.m_gameStatus = GameStatus.GAME_GRAND_FINAL_COMPLETE;
            self:refreshGameStatus();
        end
    
    elseif self.m_gameStatus == GameStatus.GAME_GRAND_FINAL_READY then
    
        local allCanChangeToPowerSum = GameValue.mxMissionManager:getChangeToPowerUpSum();

        local tarChangeToPowerSum = 0;

        if GameValue.mxDataControler:getLimitStep() <= allCanChangeToPowerSum then
        
            tarChangeToPowerSum = GameValue.mxDataControler:getLimitStep();
        
        else
        
            tarChangeToPowerSum = math.floor(GameValue.mxDataControler:getLimitStep() / 2);

            if tarChangeToPowerSum > allCanChangeToPowerSum then
            
                tarChangeToPowerSum = allCanChangeToPowerSum;
            end
        end

        

        local  createPowerUpCoordinaList = GameValue.mxMissionManager:getChangeToPowerUpCoordinaList(tarChangeToPowerSum);

        for round = 1, tarChangeToPowerSum do
        
            local tmpCooddina = Coordina.new();
            tmpCooddina.x = createPowerUpCoordinaList[round].x;
            tmpCooddina.y = createPowerUpCoordinaList[round].y;

            local color = GameValue.mxMissionManager:getColorByPst(tmpCooddina.x, tmpCooddina.y);

            local clearMode = ClearMode.MODE_NONE;

            local random = math.random(1, 3);

            if random == 1 then clearMode = ClearMode.MODE_L_T;
            elseif random == 2 then clearMode = ClearMode.MODE_4_HORIZONTAL;
            elseif random == 3 then clearMode = ClearMode.MODE_4_VERTICAL;
            end
            local direction = MissionGrid.EliminateType.DIR_H;
            if math.random(0, 1) == 1 then
                direction = MissionGrid.EliminateType.DIR_V;
            else
            
            end
            
          
            
            
            local delayC = function(parameters)
            
                local c_tmpCooddina = Coordina.new();
                c_tmpCooddina.x = parameters[1].x;
                c_tmpCooddina.y = parameters[1].y;
                
                local c_clearMode = parameters[2];
                
                local c_direction = parameters[3];
                
                local c_color = parameters[4];
                local c_round = parameters[5];
                
            	GameValue.mxDataControler:subLimitStep(); 
                GameValue.mxGridContainer:playStepChangeIntoPowerUpEft(c_tmpCooddina, 0.4, function()
                    self:clearCommonCellWithNothing(c_tmpCooddina);
                    self:creatPropItem(c_clearMode, c_direction, c_tmpCooddina.x, c_tmpCooddina.y, c_color);
                    GameValue.mxDataControler:addFinalPowerUpScore((c_round + 1), c_tmpCooddina);  
                end
                );
            end
            
    
            GameValue.mxGameTimeTween:delayedCall(round * 0.2, delayC,{tmpCooddina, clearMode, direction, color, round});

        end


        GameValue.mxGameTimeTween:delayedCall(0.2 * tarChangeToPowerSum + Config.clearDuration + 1,function()
        
            
            self.m_gameStatus = GameStatus.GAME_GRAND_FINAL_ING;
            
            if self:doTempActivePowerUpAction() == true then
            
                self.m_wait = false;
                
--                GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration + 0.1, [this]
--                {
--                    //promptlyCheckDrop();
--                });
            
            end
        end    
        ); 
        self.m_gameStatus = GameStatus.GAME_GRAND_FINAL_START;
    
    elseif  self.m_gameStatus == GameStatus.GAME_GRAND_FINAL_ING then
    
        local gameAllPowerUpList = GameValue.mxMissionManager:getTarGameAllPowerUpList();
        if #gameAllPowerUpList == 0 then
        
            if GameValue.mxDataControler:getLimitStep() > 0 then
            
                self.m_gameStatus = GameStatus.GAME_GRAND_FINAL_READY;
                self:refreshGameStatus();
            
            else
            
                self.m_gameStatus = GameStatus.GAME_GRAND_FINAL_COMPLETE;
                self:refreshGameStatus();
            end
        end

    
    elseif self.m_gameStatus == GameStatus.GAME_GRAND_FINAL_COMPLETE then
    
        if GameValue.mxDataControler:getScoreComplete() then
        
            self.m_gameStatus = GameStatus.GAME_SUCCESS;
            self:refreshGameStatus();
            
        
        else
        
            GameValue.mxDataControler:addScoreToOneStar();
            self.m_gameStatus = GameStatus.GAME_SUCCESS;
            self:refreshGameStatus();
            
        end
 
    
    elseif self.m_gameStatus == GameStatus.GAME_SUCCESS then
    
        self.m_gameStatus = GameStatus.GAME_OUT;
        GameValue.mxGameTimeTween:delayedCall(0.2, function()
            GameValue.mxGameEFT:playWinMotion()      
           

            MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.PUZZLES);
        end
        );
        
        
        self.m_gameResult = 1;
        --CallLuaFunction::getInstance():gameWin(GameValue.mxDataControler:getTotalScore(), GameValue.mxDataControler:getStarsStatus());
        --CallLuaFunction::getInstance():statisticsWin(GameValue.mxDataControler:getUsedPropsCount(), GameValue.mxDataControler:getCurrentSelectLevel(), GameValue.mxDataControler:getStars(), GameValue.mxDataControler:getPlayGameTime());
        
        GameValue.mxGameTimeTween:delayedCall(2.4, function()
        
            self:gameEnd();
        end   
        );
       
    
    elseif self.m_gameStatus == GameStatus.GAME_FAIL then
    
        self.m_gameStatus = GameStatus.GAME_OUT;
        
        self.m_gameResult = 0;
       -- CallLuaFunction::getInstance():gameLose(GameValue.mxDataControler:getTotalScore(), GameValue.mxDataControler:getTargetStatus());
      --  CallLuaFunction::getInstance():statisticsLose(GameValue.mxDataControler:getUncompletedReason(), GameValue.mxDataControler:getUsedPropsCount(), GameValue.mxDataControler:getCurrentSelectLevel(), GameValue.mxDataControler:getStars(), GameValue.mxDataControler:getPlayGameTime(), GameValue.mxDataControler:getUncompletedStatus());
--        //if (GameValue.mxDataControler:getUsedPropsCount() == 0 and !GameValue.mxDataControler:getHasFrontBooster())
--        //{
--            CallLuaFunction::getInstance():statisticsPlayAlmost(GameValue.mxDataControler:getCurrentSelectLevel(), GameValue.mxDataControler:checkPlayAlmost());
--    //  }
        GameValue.mxGameTimeTween:delayedCall(0.2, function()
            GameValue.mxGameEFT:playLoseMotion()  
            MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.PUZZLEF);
        end
        );

--        
        GameValue.mxGameTimeTween:delayedCall(2.4, function()          
            self:gameEnd();
        end
        );
        
       
    end
end

function GameControler:getGameStatus()

    return self.m_gameStatus;
end

function GameControler:onWorldTimerRunHandler(spendTime)
    
   
    if self.m_ingame == false then
        return;
    end
    self:updateCheckEliminate(spendTime);
    
    GameValue.mxGameTimeTween:onWorldTimerRunHandler(spendTime);

    self:updateGameStatus(spendTime);
    
    if self.m_wait == true then
        return;
    end
    
    local needCheckDrop = GameValue.mxGridContainer:getNeedDropAndUpdateCellPostion(spendTime);
    
    if needCheckDrop == true then
    
    
        self:checkDrop();
        
        if GameValue.mxMissionManager:getStatusIsStatic() == false then
            return;
        end
        
        
        
        if self:checkClear(nil, nil) == false then

            --if GameValue.mxMissionManager:getStatusIsStatic()== true then
            
                --if self.m_flyingCollectItemSum == 0 and #self.m_activePowerUpList == 0 then
                if  #self.m_activePowerUpList == 0 then
                
                    self.m_updateGameStatusTime = self.UPDATE_G_S_TIME;
                    self:refreshGameStatus();
                end
                
                if self.m_gameStatus == GameStatus.GAMING then
                    self.m_eliminateTime = 0;
                    if self:doActivePowerUpListAction() == true then
                        self.m_wait = false;
                    else
                        if GameValue.mxDataControler:getMissionComplete() == false then
                            
                            if #self:checkNoMatch() ~= 0 then                            
                                if GameValue.mxDataControler:getLimitStep() == 5 and self.m_hasPlayFiveStepEft == false then
                                    GameValue.mxGameEFT:playFiveStepEft();
                                    self.m_hasPlayFiveStepEft = true
                                    --self.m_gameStatus = GameStatus.GAME_FIVESTEP_PLAYING;
                                else
                                    self:checkSurperEft(self.m_totalEliNumCommon, self.m_totalEliNumPowerUp);
                                end;                              
                            end;
                            
                           
                            
                            --if GameValue.mxDataControler:getLimitStep() ==1 and GameValue.mxDataControler:updateCheckPropsPrompt() == true   then
                            --     MainValue.mxGameManager:onPropsPrompt(1);
                            --end;
                            
                            
                          
                        end
                        
                        self.m_totalEliNumCommon = 0;
                        self.m_totalEliNumPowerUp = 0;
                    
                        
                        
                        
                        self.m_wait = true;
                        
                        
                    end
                elseif self.m_gameStatus == GameStatus.GAME_GRAND_FINAL_ING then
                     
                    if self:doTempActivePowerUpAction() == true then
                    
                        self.m_wait = false;

                   
                    else
                    
                    
                        self.m_wait = true;
                    end
                elseif self.m_gameStatus == GameStatus.GAME_END then
                else
                     self.m_wait = true;
                end
               
            --end
        end
    
    else
    
        if self:doActivePowerUpListAction() == true then
        
            self.m_wait = false;
        end
    end
    
    
    

end;




function GameControler:triggerPowerActionByBuyProp( goodsId,  xRound,  yRound)
    
     self.m_totalEliNumCombo = 0;
    self.m_totalEliNumCommon = 0;
    self.m_totalEliNumPowerUp = 0;
    
    if self.m_gameStatus > GameStatus.GAMING then
    
        if self.m_buyPropId > 0 then
             self:useBuyPropEnd(false);
        end
        return;
    end

    local tmpGridType = GameValue.mxMissionManager:getMissionMatrix(xRound, yRound);
    


    if GameValue.mxMissionManager:getStatusMatrix(xRound, yRound) ~= MissionStatus.OPEN then
        return;
    end;

   

    
    local coordina = Coordina.new();
    coordina.x = xRound;
    coordina.y = yRound;

    



    local destoryList = {};

    

    local tempCanUse = true;
    
    if goodsId == BoosterID.PROP_HAMMER then--锤子
    
        if GameValue.mxStatusLogic:getDestroyEnable(tmpGridType) or tmpGridType == MissionGrid.PU_RAINBOW then
        
            MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.I_HAMMER);
            local gridType = GameValue.mxMissionManager:getMissionMatrix(xRound, yRound);
            if gridType == MissionGrid.PU_RAINBOW then 
                
                table.insert(destoryList,coordina)    
            else      
                destoryList = GameValue.mxMissionManager:getClipDestroyList(xRound, yRound)
            end

            if #destoryList > 0 then
            

                GameValue.mxGameTimeTween:delayedCall(0.2, function()
                
                    self.m_wait = false;

                    GameValue.mxDataControler:addActiveMatchListScore(destoryList[1], destoryList);
                    self:destroyClearList(destoryList);

                end
                );


                GameValue.mxGameTimeTween:delayedCall(Config.clearDuration + 0.3, function()
                
                    self:promptlyCheckDrop();
                end
                );
            end

            GameValue.mxGridContainer:playPropUse(goodsId, coordina);
        
        else 
            tempCanUse = false;
        end
    
    elseif goodsId == BoosterID.PROP_BOMBO then--TODO 炸弹    
    
    elseif goodsId == BoosterID.PROP_ELI_H or goodsId == BoosterID.PROP_ELI_V then --横竖火箭
    
        local gridTpye = GameValue.mxMissionManager:getMissionMatrix(coordina.x, coordina.y);
        if MissionGrid.INTERVAL_POWER_UP:includeValue(gridTpye) then--如果是powerUp        
            self.powerUpAssemControler:execurePowerUpByProps(coordina, goodsId);        
        else     
            local eftId = 2200 + MissionGrid.PU_KEY_ROCKET_H;
           
            if goodsId == BoosterID.PROP_ELI_H then
                eftId = 2200 + MissionGrid.PU_KEY_ROCKET_H;
                destoryList = GameValue.mxMissionManager:getRocketDestroyH1List(xRound, yRound);
            else
                eftId = 2200 + MissionGrid.PU_KEY_ROCKET_V;
                destoryList = GameValue.mxMissionManager:getRocketDestroyV1List(xRound, yRound);
            end
            GameValue.mxGridContainer:playClearEffect(eftId, coordina);
            
          
            MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.PU_CROSS);          
           
            if #destoryList > 0 then          
                GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration - Config.clearDuration, function()               
                    GameValue.mxDataControler:addPowerUpDestoryListScore(destoryList);                   
                    self:doUsePowerUpItemAction(destoryList);  
                end
                );
                GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration + 0.2, function()
                    self.m_wait = false;
                    self:promptlyCheckDrop();
                end
                );
               

            end

        end
        GameValue.mxGridContainer:playPropUse(goodsId, coordina);
          
    

    elseif goodsId == BoosterID.PROP_COLOR_REMOVE then --TODO 同色消除
   
       
    
    elseif goodsId == BoosterID.PROP_GLOVE then --交换手套
    
        if GameValue.mxStatusLogic:getSwapEnable(tmpGridType) == true then
        
            
            if self.m_gloveCoordina:equalsXY(-1, -1) == true then
            
                self.m_gloveCoordina.x = xRound;
                self.m_gloveCoordina.y = yRound;
                tempCanUse = false;
                
                GameValue.mxGridContainer:playGloveUse(coordina,1);
            
            else
            
                
                if self.m_gloveCoordina:equalsXY(xRound, yRound) == false and GameValue.mxMissionManager:isNeighbor(self.m_gloveCoordina, coordina) then
                    GameValue.mxGridContainer:cancelPlayGloveUse(1);
                    local function checkDir()
                        if self.m_gloveCoordina.x + 1 == xRound then
                            return 4
                        elseif self.m_gloveCoordina.x - 1 == xRound then
                            return 5
                        elseif self.m_gloveCoordina.y -1 == yRound then
                            return 6
                        else 
                            return 7
                        end
                    end
                    GameValue.mxGridContainer:playGloveUse(self.m_gloveCoordina, 2, checkDir());
                    GameValue.mxMissionManager:setStatusMatrix(self.m_gloveCoordina.x, self.m_gloveCoordina.y, MissionStatus.CLEARING);
                    GameValue.mxMissionManager:setStatusMatrix(xRound, yRound, MissionStatus.CLEARING);
                         
                    local selectedCoordina = Coordina.new();
                    selectedCoordina.x = self.m_gloveCoordina.x;
                    selectedCoordina.y = self.m_gloveCoordina.y;
                    
                    self.m_gloveCoordina.x = -1;
                    self.m_gloveCoordina.y = -1;
                    
                    GameValue.mxGameTimeTween:delayedCall(0.1, function()
                    

                        GameValue.mxGridContainer:cancelPlayGloveUse(1);
                        GameValue.mxGridContainer:cancelPlayGloveUse(2);


                        local tempItem = GameValue.mxGridContainer:getCellMatrix(coordina.x, coordina.y);
                        local selectedItem = GameValue.mxGridContainer:getCellMatrix(selectedCoordina.x, selectedCoordina.y);
                      
 
                        local scaleAction = cc.Sequence:create(cc.ScaleTo:create(0.4 * 0.5, 1.2), cc.ScaleTo:create(0.4 * 0.5, 0.1), cc.ScaleTo:create(0.4 * 0.5, 1.2), cc.ScaleTo:create(0.4 * 0.5, 1));
                        tempItem:stopAllActions();
                        tempItem:runAction(scaleAction);

                        local scaleActionS = cc.Sequence:create(cc.ScaleTo:create(0.4 * 0.5, 1.2), cc.ScaleTo:create(0.4 * 0.5, 0.1), cc.ScaleTo:create(0.4 * 0.5, 1.2), cc.ScaleTo:create(0.4 * 0.5, 1));
                        selectedItem:stopAllActions();
                        selectedItem:runAction(scaleActionS);

                        GameValue.mxGameTimeTween:delayedCall(0.4, function()
                            local selectedGridType = GameValue.mxMissionManager:getMissionMatrix(selectedCoordina.x, selectedCoordina.y);
                            GameValue.mxMissionManager:setMissionMatrix(coordina.x, coordina.y, selectedGridType);
                            GameValue.mxMissionManager:setMissionMatrix(selectedCoordina.x, selectedCoordina.y, tmpGridType);

                            local tempItem = GameValue.mxGridContainer:getCellMatrix(coordina.x, coordina.y);
                            local selectedItem = GameValue.mxGridContainer:getCellMatrix(selectedCoordina.x, selectedCoordina.y);

                            local tempPstX,tempPstY = tempItem:getPosition();
                            local selectedPstX,selectedPstY = selectedItem:getPosition();
                            tempItem:setPosition(selectedPstX,selectedPstY);
                            selectedItem:setPosition(tempPstX,tempPstY);
                            
                            
                            
                            GameValue.mxGridContainer:setCellMatrix(nil, selectedCoordina.x, selectedCoordina.y);
                            GameValue.mxGridContainer:setCellMatrix(nil, coordina.x, coordina.y);
                            
                            GameValue.mxGridContainer:setCellMatrix(tempItem, selectedCoordina.x, selectedCoordina.y);
                            GameValue.mxGridContainer:setCellMatrix(selectedItem, coordina.x, coordina.y);

                            selectedItem:setCoordina(coordina.x,coordina.y);
                                tempItem:setCoordina(selectedCoordina.x,selectedCoordina.y);


                            GameValue.mxGameTimeTween:delayedCall(0.2, function()
                            
                                GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.OPEN);
                                GameValue.mxMissionManager:setStatusMatrix(selectedCoordina.x, selectedCoordina.y, MissionStatus.OPEN);
                                local tempCoordina = GameValue.mxGridContainer:checkTransport(coordina, selectedCoordina); -- 检测是否有水果可以收集
                                if tempCoordina.x ~= -1 and tempCoordina.y ~= -1 then
                                
                                    self:clearPowerDownCell(tempCoordina);
                                end
                                
                                self:checkClear(nil, nil);
                                
                                
                            end
                            );

                        end
                        );
                    
                    end
                    
                    );
                    tempCanUse = true;
                
                elseif self.m_gloveCoordina:equalsXY(xRound, yRound) == false then
                
                    GameValue.mxGridContainer:cancelPlayGloveUse(1);

                    self.m_gloveCoordina.x = xRound;
                    self.m_gloveCoordina.y = yRound;
                    GameValue.mxGridContainer:playGloveUse(coordina, 1);

                    tempCanUse = false;
                
                else
                
                    GameValue.mxGridContainer:cancelPlayGloveUse(1);
                    self.m_gloveCoordina.x = -1;
                    self.m_gloveCoordina.y = -1;
                    tempCanUse = false;
                end
                
            end
        else 
            return;
        end
        
    end

    if tempCanUse == true then
        self:useBuyPropEnd(true);
    end
end



--ui层 调用
function GameControler:useBuyProp(goodsId)
    self.m_buyPropId = goodsId;
end;

function GameControler:cancelBuyProp(goodsId)
    if self.m_gloveCoordina:equalsXY(-1,-1) == false then
    
        --GRID_CONTAINER->playGloveUse(m_gloveCoordina,1,-1);
        self.m_gloveCoordina.x = -1;
        self.m_gloveCoordina.y = -1;
    end
    self.m_buyPropId = 0;
end;

function GameControler:buySteps( sum)

    if self.m_gameStatus == GameStatus.GAME_FAIL_READY then
    
        self.m_gameStatus = GameStatus.GAMING;
        
        GameValue.mxDataControler:addLimitStep(sum);
        
        MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.I_5MOVES);
    end
end

function GameControler:cancelbuySteps()

    if self.m_gameStatus == GameStatus.GAME_FAIL_READY then
    
        self.m_gameStatus = GameStatus.GAME_FAIL;
        self:refreshGameStatus();
    end
end

function GameControler:useBuyPropEnd(success)
    if self.m_buyPropId <= 0 then
        return;
    end;
    if success == true then
        MainValue.mxGameManager:useBooster(self.m_buyPropId)
      --  DATAER->useProps();
    else
        MainValue.mxGameManager:cancelProps(self.m_buyPropId)
    end

end;

function GameControler:getIsCanClickUI()

    if self.m_gameStatus == GameStatus.GAMING and GameValue.mxDataControler:getMissionComplete()== false and GameValue.mxDataControler:getLimitStep() > 0 and self.m_wait == true then
        return true;
    end

    return false;
end

function GameControler:gameEnd()
    
    
     if GameValue.mxMissionManager:getStatusIsStatic() == true then
    
        self.m_ingame = false;
        self.m_gameStatus = GameStatus.GAME_OUT;
        self.m_activePowerUpList = {};
        
        GameValue.mxGameTimeTween:clear();
        GameValue.mxGameLayer:exitGame();
        
        
        if self.m_gameResult == 1 then
            MainValue.mxGameManager:showWinUI(GameValue.mxDataControler:getTotalScore(), GameValue.mxDataControler:getStars())
        elseif self.m_gameResult == 0 then
          --  MainValue.mxGameManager:showLoseUI(GameValue.mxDataControler:getTotalScore(), GameValue.mxDataControler:getTargetStatus())
            MainValue.mxGameManager:showLoseUI(GameValue.mxDataControler:getTotalScore(), GameValue.mxDataControler:getTargetStatus())
        end
        
        self.m_gameResult = -1;
        MainValue.mxGameManager:exitGame();
        
        
        GameValue.mxDataControler:exitGame();
    else
        GameValue.mxGameTimeTween:delayedCall(0.5,function()
            self:gameEnd();
        end
        )
    end
    
end;

--连续消除等特效
-- eft_type 1 = 3次连消-- - Smashing
--  2 = 5次连消----Yummy
--  3 = 连消行为中引爆3个Power - up----Super
--  4 = 连消行为中引爆7次Power - up----Amazing
--  5 = 最后的疯狂----Awesome

function GameControler:checkSurperEft(totalEliNumCommon, totalEliNumPowerUp)
    
    
    
    
    if self.m_gameStatus ~= GameStatus.GAMING or true then --暂时屏蔽连击效果
        return;
    end
    local soundID = " ";
    local eft_type = "";
    if totalEliNumCommon == 3 then--Yummy
    
        eft_type = "Yummy";
        soundID = GameSoundEffectId.MALE_YAMIA;
    
    elseif totalEliNumCommon == 4 then --Super
    
        eft_type = "Super";
        soundID = GameSoundEffectId.MALE_SUPERA;
    
    elseif totalEliNumCommon == 5 then--Smashing
    
        eft_type = "Smashing";
        soundID = GameSoundEffectId.MALE_SMASHINGA;
    
    elseif totalEliNumCommon == 6 then--Awesome
    
        eft_type = "Awesome";
        soundID = GameSoundEffectId.MALE_AWESOMEA;
    
    elseif totalEliNumCommon == 7 then--Amazing
    
        eft_type = "Amazing";
        soundID = GameSoundEffectId.MALE_AMAZINGA;
    
    end

    print(totalEliNumCommon,"-------------",totalEliNumPowerUp)
    
    if eft_type ~= "" then
        GameValue.mxGameEFT:showFontEft(eft_type);
    end
    if soundID ~= "" then
        
        MainValue.mxGameManager:playSoundEffect(soundID);
    end
end









---------------------------------boss-----------------------------------------------------------
--
function GameControler:setBossHaveSameMatchColor()
end

function GameControler:getBossRecordMatchColor()

    return -1;
end

function GameControler:setBossRecordMatchColor( color)
end

return GameControler;