local PowerUpAssemControler = class("PowerUpAssemControler");

function PowerUpAssemControler.create()
    local powerUpAssemControler = PowerUpAssemControler.new()
    return powerUpAssemControler;
end;


function PowerUpAssemControler:executeRainbowClear(startCoordina,targetCoordina)
    local startType  = GameValue.mxMissionManager:getMissionMatrix(startCoordina.x, startCoordina.y);
    local targetType = GameValue.mxMissionManager:getMissionMatrix(targetCoordina.x, targetCoordina.y);
    
   
    
    if startType == MissionGrid.PU_RAINBOW and targetType == MissionGrid.PU_RAINBOW then
        self:executeRainbowAndRainbow();
    else 
        
        
        
        
    end;
     
end

--彩虹球 除外
function PowerUpAssemControler:bothPowerUpAndPowerUp(startCoordina,targetCoordina)
    local startType  = GameValue.mxMissionManager:getMissionMatrix(startCoordina.x, startCoordina.y);
    local targetType = GameValue.mxMissionManager:getMissionMatrix(targetCoordina.x, targetCoordina.y);

    if MissionGrid.isBombo(startType) and MissionGrid.isBombo(targetType) then 
        self:executeBomboAndBombo(startCoordina,targetCoordina);
    elseif MissionGrid.isBombo(startType) and MissionGrid.isEli(targetType) then
        self:executeBomboAndEli(startCoordina,targetCoordina,targetCoordina);
    elseif MissionGrid.isEli(startType) and MissionGrid.isBombo(targetType) then
        self:executeBomboAndEli(targetCoordina,startCoordina,targetCoordina);
    elseif MissionGrid.isEli(startType) and MissionGrid.isEli(targetType) then
        self:executeEliAndEli(startCoordina,targetCoordina);
    elseif startType == MissionGrid.PU_RAINBOW and targetType == MissionGrid.PU_RAINBOW then -- 都是彩虹球
        self:executeRainbowAndRainbow(startCoordina,targetCoordina);
    elseif (startType == MissionGrid.PU_RAINBOW and targetType ~= MissionGrid.PU_RAINBOW) or (startType ~= MissionGrid.PU_RAINBOW and targetType == MissionGrid.PU_RAINBOW) then
        self:executeRainbowAndPowerUp(startCoordina,targetCoordina);
    end
end;

function PowerUpAssemControler:executeBomboAndBombo(startBomboCoordina,targetBomboCoordina)
    
    local targetCoordinate = Coordina.new();
    targetCoordinate.x = targetBomboCoordina.x;
    targetCoordinate.y = targetBomboCoordina.y;
    
    local startGridType = GameValue.mxMissionManager:getMissionMatrix(startBomboCoordina.x, startBomboCoordina.y);
    local targetGridType = GameValue.mxMissionManager:getMissionMatrix(targetBomboCoordina.x, targetBomboCoordina.y);
    local startCell = GameValue.mxGridContainer:getCellMatrix(startBomboCoordina.x, startBomboCoordina.y);
    local targetCell = GameValue.mxGridContainer:getCellMatrix(targetBomboCoordina.x, targetBomboCoordina.y);
    startCell:play6CleartMotion();

    
    local eftId = 2000  + MissionGrid.PU_KEY_BOMBO;
    GameValue.mxGridContainer:playClearEffect(eftId, targetBomboCoordina);
    
    
    GameValue.mxMissionManager:setStatusMatrix(startBomboCoordina.x, startBomboCoordina.y, MissionStatus.CLEARING);
    
    GameValue.mxMissionManager:setStatusMatrix(targetBomboCoordina.x, targetBomboCoordina.y, MissionStatus.CLOSED);


    local coordinateXList = GameValue.mxMissionManager:getBombDestoryList(targetCoordinate.x, targetCoordinate.y);

    GameValue.mxDataControler:addPowerUpDestoryListScore(coordinateXList);
    GameValue.mxGameControler:destroyClearList(coordinateXList);

    local function delayC(prama)
    	
        local c_startCoordina = prama[1];
        local c_targetCoordina = prama[2];
        GameValue.mxMissionManager:setMissionMatrix(c_startCoordina.x, c_startCoordina.y, MissionGrid.NONE);
        GameValue.mxMissionManager:setStatusMatrix(c_startCoordina.x, c_startCoordina.y, MissionStatus.OPEN);
        GameValue.mxGridContainer:setCellMatrix(nil, c_startCoordina.x, c_startCoordina.y);
        
        GameValue.mxGameControler:pushToActivePowerUpList(c_targetCoordina);
    	
    end

    GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration,delayC,{startBomboCoordina,targetBomboCoordina})


    local function delayC2()
        GameValue.mxGameControler:setWait(false);
    	GameValue.mxGameControler:promptlyCheckDrop();
    end

    GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration + 0.2, delayC2)

    
end;

function PowerUpAssemControler:executeBomboAndEli(bomboCoordina,eliCoordina,targetCoordina)
    local missionGrid = GameValue.mxMissionManager:getMissionMatrix(eliCoordina.x,eliCoordina.y);
    GameValue.mxGameControler:clearPowerUpCellAsCommonCell(bomboCoordina);
    GameValue.mxGameControler:clearPowerUpCellAsCommonCell(eliCoordina);
    
    
    local clearRocketList ={};
    
    if MissionGrid.isEliV(missionGrid) then
    
        clearRocketList = GameValue.mxMissionManager:getRocketDestroyV3List(targetCoordina.x, targetCoordina.y);
        GameValue.mxGridContainer:playClearRocket3Eft(missionGrid, targetCoordina, MissionGrid.PU_KEY_ROCKET_V);
    elseif MissionGrid.isEliH(missionGrid) then
    
        clearRocketList = GameValue.mxMissionManager:getRocketDestroyH3List(targetCoordina.x, targetCoordina.y);
        GameValue.mxGridContainer:playClearRocket3Eft(missionGrid, targetCoordina, MissionGrid.PU_KEY_ROCKET_H);
    end



    for round = 1, #clearRocketList do
        GameValue.mxMissionManager:setStatusMatrix(clearRocketList[round].x,clearRocketList[round].y, MissionStatus.CLOSED);
    end
    GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration - Config.clearDuration, function()
    
        GameValue.mxDataControler:addPowerUpDestoryListScore(clearRocketList);
        GameValue.mxGameControler:destroyClearList(clearRocketList);
    end
    );
    
    GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration + 0.2, function()
        GameValue.mxGameControler:setWait(false);
        GameValue.mxGameControler:promptlyCheckDrop();
    end
    );
    
    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.I_3LINES);
end;



function PowerUpAssemControler:executeEliAndEli(startEliCoordina,targetEliCoordina)
    local tempGrid = GameValue.mxMissionManager:getMissionMatrix(startEliCoordina.x,startEliCoordina.y);
    if MissionGrid.isEliH(tempGrid) then
    
        GameValue.mxGridContainer:playClearEffect(tempGrid, targetEliCoordina);
        GameValue.mxGridContainer:playClearEffect(tempGrid + 1, targetEliCoordina);
    
    else
    
        GameValue.mxGridContainer:playClearEffect(tempGrid - 1, targetEliCoordina);
        GameValue.mxGridContainer:playClearEffect(tempGrid , targetEliCoordina);
    end

    GameValue.mxGameControler:clearPowerUpCellAsCommonCell(startEliCoordina);
    GameValue.mxGameControler:clearPowerUpCellAsCommonCell(targetEliCoordina);

    local clearRocketList = GameValue.mxMissionManager:getRocketDestroyHVList(targetEliCoordina.x, targetEliCoordina.y);
    GameValue.mxDataControler:addPowerUpDestoryListScore(clearRocketList);
    GameValue.mxGameControler:destroyClearList(clearRocketList);

    local function delayC()
        GameValue.mxGameControler:setWait(false);
    	GameValue.mxGameControler:promptlyCheckDrop();
    end
    GameValue.mxGameTimeTween:delayedCall(Config.clearDuration + 0.2, delayC)
   
    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.PU_CROSS);
end;



function PowerUpAssemControler:executeRainbowAndRainbow(startCoordina,targetCoordina)
    if startCoordina~=nil then GameValue.mxGameControler:clearPowerUpCellAsCommonCell(startCoordina); end
    if targetCoordina~=nil then GameValue.mxGameControler:clearPowerUpCellAsCommonCell(targetCoordina); end
    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.PU_COLORREMOVE2);
    local clearViewListSameColor = GameValue.mxMissionManager:getAllRainbowClearList();

    for yRound = 1, #clearViewListSameColor do
    
        for xRound = 1, #clearViewListSameColor[yRound] do
        
            GameValue.mxMissionManager:setStatusMatrix(clearViewListSameColor[yRound][xRound].x, clearViewListSameColor[yRound][xRound].y, MissionStatus.CLEARING);
        
        end
    end

   
    --GameValue.mxGridContainer:playRainbowBallMotion();
   -- self:destroyRainbowAndRainbowClearList(clearViewListSameColor[0]);

    if #clearViewListSameColor > 1 then
    
        for cI1 = 1, #clearViewListSameColor do
        
            local tempList = clearViewListSameColor[cI1];
            GameValue.mxGameTimeTween:delayedCall(0.1 * cI1, function()
                    self:destroyRainbowAndRainbowClearList(tempList);
                end
            );
        end
    end

    GameValue.mxGameTimeTween:delayedCall(0.1 * #clearViewListSameColor, function()
            GameValue.mxGameControler:setWait(false);
            GameValue.mxGameControler:promptlyCheckDrop();
        end
    );
    
    
end

function PowerUpAssemControler:executeRainbowAndPowerUp(startCoordina,targetCoordina)

    local startType  = GameValue.mxMissionManager:getMissionMatrix(startCoordina.x, startCoordina.y);
    
    local rainbowCoordina = Coordina.new();
    local powerUpCoordina = Coordina.new();
    if startType == MissionGrid.PU_RAINBOW then
        rainbowCoordina.x = startCoordina.x;
        rainbowCoordina.y = startCoordina.y;
        powerUpCoordina.x = targetCoordina.x;
        powerUpCoordina.y = targetCoordina.y;
    else
        rainbowCoordina.x = targetCoordina.x;
        rainbowCoordina.y = targetCoordina.y;
        powerUpCoordina.x = startCoordina.x;
        powerUpCoordina.y = startCoordina.y;
    end;
    
    local powerUpType = GameValue.mxMissionManager:getMissionMatrix(powerUpCoordina.x, powerUpCoordina.y);    
    local powerUpColor = GameValue.mxMissionManager:getColorByPst(powerUpCoordina.x, powerUpCoordina.y);
    
    
    
   
    
    
    
    GameValue.mxGameControler:clearPowerUpCellAsCommonCell(rainbowCoordina);
    GameValue.mxGameControler:clearPowerUpCellAsCommonCell(powerUpCoordina);
    
    local clearViewListSameColorList = GameValue.mxMissionManager:getSameColorCommonClearList(powerUpColor);
    for index = 1, #clearViewListSameColorList do
        
        GameValue.mxGridContainer:showFlyFaSheToAim(rainbowCoordina,clearViewListSameColorList[index])
       
        GameValue.mxMissionManager:setStatusMatrix(clearViewListSameColorList[index].x, clearViewListSameColorList[index].y, MissionStatus.CLOSED);
    end
    GameValue.mxGridContainer:playClearEffect(MissionGrid.PU_RAINBOW, targetCoordina);
    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.PU_COLORREMOVE);
    GameValue.mxGameTimeTween:delayedCall(0.2, function()
        for round = 1, #clearViewListSameColorList do
            local clearCoordina = Coordina.new();
            clearCoordina.x =  clearViewListSameColorList[round].x;
            clearCoordina.y =  clearViewListSameColorList[round].y;
            GameValue.mxGameTimeTween:delayedCall(0.01*round, function()
            
                --GameValue.mxGridContainer:playRainbowFly(targetCoordina, clearCoordina);
            end
            );
        end
    end
    );
    
    GameValue.mxGameTimeTween:delayedCall(0.4, function()
    
        for sI = 1, #clearViewListSameColorList do
            local clearCoordina = Coordina.new();
            clearCoordina.x =  clearViewListSameColorList[sI].x;
            clearCoordina.y =  clearViewListSameColorList[sI].y;
            
            local delayC = function (parameters)
            	GameValue.mxGameControler:collectCommonCell(parameters[1], 0);
                GameValue.mxMissionManager:setMissionMatrix(parameters[1].x, parameters[1].y, parameters[2]);
                self:transformToPowerUpFromCommonGrid(parameters[1]);
            end
            
            GameValue.mxGameTimeTween:delayedCall(0.01*sI, delayC,{clearCoordina,powerUpType});
        end
    end
    );
    
    GameValue.mxGameTimeTween:delayedCall(1.1, function()
        for clearIndex = 1, #clearViewListSameColorList do
            local tempClearList = {};
            local tempCoordina = Coordina.new();
            tempCoordina.x = clearViewListSameColorList[clearIndex].x;
            tempCoordina.y = clearViewListSameColorList[clearIndex].y;
            table.insert(tempClearList,tempCoordina)

            GameValue.mxGameTimeTween:delayedCall(0.05*clearIndex, function()
            
                GameValue.mxDataControler:addPowerUpDestoryListScore(tempClearList);
                GameValue.mxGameControler:destroyClearList(tempClearList);
            end
            );
        
        end

        
       
    end
    );
    
    GameValue.mxGameTimeTween:delayedCall(1.1 + Config.clearPowerUpDuration + 0.2 + #clearViewListSameColorList*0.05, function()
        GameValue.mxGameControler:setWait(false);
        GameValue.mxGameControler:promptlyCheckDrop();
    end
    );
end




function PowerUpAssemControler:destroyRainbowAndRainbowClearList(destoryList)

    if #destoryList== 0 then return end;

    local destoryListLen = #destoryList;

    GameValue.mxDataControler:addPowerUpDestoryListScore(destoryList);


    for round = 1, destoryListLen do
    
        local tmpGridType = GameValue.mxMissionManager:getMissionMatrix(destoryList[round].x, destoryList[round].y);

        if MissionGrid.INTERVAL_COMMON:includeValue(tmpGridType) then
        
            GameValue.mxGameControler:collectCommonCell(destoryList[round], round);
            GameValue.mxGameControler:clearCommonCellWithNoEFT(destoryList[round],Config.clearDuration);
            
            
        
        elseif MissionGrid.INTERVAL_POWER_UP:includeValue(tmpGridType) then
        
            if tmpGridType == MissionGrid.PU_RAINBOW then
            
                GameValue.mxMissionManager:setStatusMatrix(destoryList[round].x, destoryList[round].y, MissionStatus.OPEN);
            
            else 
                GameValue.mxGameControler:clearPowerUpCellAsCommonCell(destoryList[round]);
            end
        
        elseif MissionGrid.INTERVAL_POWER_DOWN:includeValue(tmpGridType) then
        
            GameValue.mxGameControler:clearPowerDownCell(destoryList[round]);
        
        elseif MissionGrid.INTERVAL_BOSS:includeValue(tmpGridType) then
        
            GameValue.mxGameControler:clearBossCell(destoryList[round]);
        end
    end
end

function PowerUpAssemControler:transformToPowerUpFromCommonGrid(coordina)

    --GameValue.mxGridContainer:playEffect("PowerUpAppearEft", "1", coordina);
    
    GameValue.mxGameControler:clearCommonCellWithNothing(coordina);
    local tempItemCell = GameValue.mxGridContainer:addNewItemCellBy(GameValue.mxMissionManager:getMissionMatrix(coordina.x,coordina.y), coordina.x, coordina.y);
    GameValue.mxGridContainer:setCellMatrix(tempItemCell, coordina.x,coordina.y);

    tempItemCell:setCoordina(coordina.x,coordina.y);
    tempItemCell:playAppearMotion();
end



-------------------------单个自动消除----------------------------------------------
function PowerUpAssemControler:executeRocketClear(coordina)


    GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.CLEARING);
    GameValue.mxGridContainer:setCellMatrix(nil, coordina.x, coordina.y);

    local powerUpGridTpye = GameValue.mxMissionManager:getMissionMatrix(coordina.x, coordina.y);
    local tempClearList = {};
    if MissionGrid.isEliH(powerUpGridTpye) then
    
        local eftId = 2000 + GameValue.mxMissionManager:getColorByType(powerUpGridTpye) * 100 + MissionGrid.PU_KEY_ROCKET_H;
       
        tempClearList = GameValue.mxMissionManager:getRocketDestroyH1List(coordina.x, coordina.y);
      
        GameValue.mxGridContainer:playClearEffect(eftId, coordina);

        for  sI = 1,#tempClearList do
        
            GameValue.mxMissionManager:setStatusMatrix(tempClearList[sI].x, tempClearList[sI].y, MissionStatus.CLEARING);
        end
        

       GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration - Config.clearDuration, function()
                GameValue.mxDataControler:addPowerUpDestoryListScore(tempClearList);
                GameValue.mxGameControler:destroyClearList(tempClearList);
            end
        );


       
    
    elseif MissionGrid.isEliV(powerUpGridTpye) then
    
        local eftId = 2000 + GameValue.mxMissionManager:getColorByType(powerUpGridTpye) * 100 + MissionGrid.PU_KEY_ROCKET_V;
        
  
        tempClearList = GameValue.mxMissionManager:getRocketDestroyV1List(coordina.x, coordina.y);
        GameValue.mxGridContainer:playClearEffect(eftId, coordina);
        
        


        for  sI = 1,#tempClearList do
        
            GameValue.mxMissionManager:setStatusMatrix(tempClearList[sI].x, tempClearList[sI].y, MissionStatus.CLEARING);
        end
        

       GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration - Config.clearDuration, function()
                GameValue.mxDataControler:addPowerUpDestoryListScore(tempClearList);
                GameValue.mxGameControler:destroyClearList(tempClearList);
            end
        );

    
    else
    
        --return;
    end

   GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration, function()
        GameValue.mxMissionManager:setMissionMatrix(coordina.x, coordina.y, MissionGrid.NONE);
        GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.WAITING);
    end
    );

   GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration + 0.2, function()
    
            GameValue.mxGameControler:promptlyCheckDrop();
    end
    );

    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.PU_CROSS);

end

function PowerUpAssemControler:executeBombClear(coordina)


    GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.CLEARING);
    GameValue.mxGridContainer:setCellMatrix(nil, coordina.x, coordina.y);

    local powerUpGridTpye = GameValue.mxMissionManager:getMissionMatrix(coordina.x, coordina.y);


    local eftId = 2000 + GameValue.mxMissionManager:getColorByType(powerUpGridTpye) * 100 + MissionGrid.PU_KEY_BOMBO;
    GameValue.mxGridContainer:playClearEffect(eftId, coordina);

    local tempClearList = {};
   
    
    if MissionGrid.isBigBomb(powerUpGridTpye) == true then
        tempClearList = GameValue.mxMissionManager:getBigBombDestoryList(coordina.x, coordina.y);
    else
        tempClearList = GameValue.mxMissionManager:getBombDestoryList(coordina.x, coordina.y);
    end

    
    for sI = 1,#tempClearList do
    
        GameValue.mxMissionManager:setStatusMatrix(tempClearList[sI].x, tempClearList[sI].y, MissionStatus.CLEARING);
    end

    GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration - Config.clearDuration, function()
        GameValue.mxDataControler:addPowerUpDestoryListScore(tempClearList);
        GameValue.mxGameControler:destroyClearList(tempClearList);
        end
    );



    GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration, function()
        GameValue.mxMissionManager:setMissionMatrix(coordina.x, coordina.y, MissionGrid.NONE);
        GameValue.mxMissionManager:setStatusMatrix(coordina.x, coordina.y, MissionStatus.WAITING);
        end
    );

    GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration + 0.2, function()
    
            GameValue.mxGameControler:promptlyCheckDrop();
        end
    );

    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.PU_BOMB);
end

-- 自动随机消除的Rainbow
function PowerUpAssemControler:executeRainbowRandom(coordina,color)

--    final自动随机消除的 颜色球球需要发射 粒子效果

	GameValue.mxGameControler:clearPowerUpCellAsCommonCell(coordina);

    local clearViewListSameColor = GameValue.mxMissionManager:getSameColorClearList(color);

    GameValue.mxGridContainer:playClearEffect(MissionGrid.PU_RAINBOW, coordina);
    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.PU_COLORREMOVE);
    local targetCoordina = Coordina.new();
    targetCoordina.x = coordina.x;
    targetCoordina.y = coordina.y;
    GameValue.mxGameTimeTween:delayedCall(0.2, function()
    
            for round =1,#clearViewListSameColor do
               -- GameValue.mxGridContainer:playRainbowFly(targetCoordina, clearViewListSameColor[round]);

                GameValue.mxGridContainer:showFlyFaSheToAim(targetCoordina,clearViewListSameColor[round])
               
            end
        end
    );

    for sI = 1, #clearViewListSameColor do
    
        GameValue.mxMissionManager:setStatusMatrix(clearViewListSameColor[sI].x, clearViewListSameColor[sI].y, MissionStatus.CLEARING);
    end

    local aimPoint = GameValue.mxGridContainer:transformGridCoordinaToNodePst(targetCoordina.x, targetCoordina.y);
   
    GameValue.mxGameTimeTween:delayedCall(0.4 + Config.clearDuration, function()
    
           GameValue.mxDataControler:addPowerUpDestoryListScore(clearViewListSameColor);
           GameValue.mxGameControler:destroyClearList(clearViewListSameColor);
       end
       
    );
    
     GameValue.mxGameTimeTween:delayedCall(0.4 + Config.clearDuration + Config.clearDuration + 0.2, function()
        
           GameValue.mxGameControler:promptlyCheckDrop();
        end
     );
end

function PowerUpAssemControler:executeRainbowAndCommon(startCoordina,targetCoordina)
    local startType  = GameValue.mxMissionManager:getMissionMatrix(startCoordina.x, startCoordina.y);
    local targetType = GameValue.mxMissionManager:getMissionMatrix(targetCoordina.x, targetCoordina.y);
    
    local rainbowCoordina = Coordina.new();
    local color = 1;
    
    if startType == MissionGrid.PU_RAINBOW then
        rainbowCoordina.x = startCoordina.x
        rainbowCoordina.y = startCoordina.y
        color = GameValue.mxMissionManager:getColorByPst(targetCoordina.x, targetCoordina.y)
    else
        rainbowCoordina.x = targetCoordina.x
        rainbowCoordina.y = targetCoordina.y
        color = GameValue.mxMissionManager:getColorByPst(startCoordina.x, startCoordina.y)
    end
    
--    self:executeRainbowRandom(rainbowCoordina,color);
--    先去的所有的可以消除的坐标用于动画处理，注意状态为clearing
    
    local tempCell = GameValue.mxGridContainer:getCellMatrix(rainbowCoordina.x, rainbowCoordina.y);
    if tempCell ~= nil then
        tempCell:play3DropingMotion()
    end
    
   
    local clearViewListSameColor = GameValue.mxMissionManager:getSameColorClearList(color);
    GameValue.mxGridContainer:playClearEffect(MissionGrid.PU_RAINBOW, rainbowCoordina);
    local targetCoordina = Coordina.new();
    targetCoordina.x = rainbowCoordina.x;
    targetCoordina.y = rainbowCoordina.y;
--    local aimPoint = GameValue.mxGridContainer:transformGridCoordinaToNodePst(targetCoordina.x, targetCoordina.y);      
--    GameValue.mxGameTimeTween:delayedCall(0.2, function()
--            for round =1,#clearViewListSameColor do
--               -- GameValue.mxGridContainer:playRainbowFly(targetCoordina, clearViewListSameColor[round]);
--            end
--        end
--    );
    for sI = 1, #clearViewListSameColor do
        GameValue.mxMissionManager:setStatusMatrix(clearViewListSameColor[sI].x, clearViewListSameColor[sI].y, MissionStatus.CLEARING);
        
    end
    
     GameValue.mxGameTimeTween:delayedCall(0.5, function()
        
        for sI = 1, #clearViewListSameColor do
                GameValue.mxGridContainer:setCellVisibleFalse(clearViewListSameColor[sI].x, clearViewListSameColor[sI].y)
            local gridType = GameValue.mxMissionManager:getMissionMatrix(clearViewListSameColor[sI].x, clearViewListSameColor[sI].y)
            GameValue.mxGridContainer:playEliFlyUp(gridType, clearViewListSameColor[sI]);
        end  
    end)
         
    
    GameValue.mxGameTimeTween:delayedCall(Config.flyUpStayTime+0.5, function()
            GameValue.mxGridContainer:playEliFlyDown(targetCoordina)
    end)
    
    
    GameValue.mxGameTimeTween:delayedCall(0.1 +0.5+ Config.clearDuration + Config.flyUpTime + Config.flyUpStayTime + Config.flyDownTime, function()
           GameValue.mxGameControler:clearPowerUpCellAsCommonCell(rainbowCoordina);
           GameValue.mxDataControler:addPowerUpDestoryListScore(clearViewListSameColor);
           GameValue.mxGameControler:destroyClearList(clearViewListSameColor,targetCoordina);
       end
    );
    
    GameValue.mxGameTimeTween:delayedCall(0.4 +0.5+ Config.clearDuration + Config.clearDuration + 0.1 +Config.flyUpTime + Config.flyUpStayTime + Config.flyDownTime, function()
           GameValue.mxGameControler:promptlyCheckDrop();
        end
     );
    
end




function PowerUpAssemControler:execurePowerUpByProps(coordina, propsId)
    local targetCoordinate = Coordina.new();
    targetCoordinate.x = coordina.x;
    targetCoordinate.y = coordina.y;
    local gridTpye = GameValue.mxMissionManager:getMissionMatrix(targetCoordinate.x, targetCoordinate.y);

    GameValue.mxGameControler:clearPowerUpCellAsCommonCell(targetCoordinate);
    local  clearRocketList = {};
    if propsId == BoosterID.PROP_ELI_H then
    
        if MissionGrid.isBombo(gridTpye) then
        
            MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.I_3LINES);
            clearRocketList = GameValue.mxMissionManager:getRocketDestroyH3List(targetCoordinate.x, targetCoordinate.y);
            GameValue.mxGridContainer:playClearRocket3Eft(2402, targetCoordinate, MissionGrid.PU_KEY_ROCKET_H);
        
        elseif MissionGrid.isEliH(gridTpye) or MissionGrid.isEliV(gridTpye) then
        
            GameValue.mxGridContainer:playClearEffect(2402, targetCoordinate);
            GameValue.mxGridContainer:playClearEffect(2403, targetCoordinate);
            clearRocketList = GameValue.mxMissionManager:getRocketDestroyHVList(targetCoordinate.x, targetCoordinate.y);
        
        elseif gridTpye == MissionGrid.PU_RAINBOW  then
        
            self:executeRainbomAndByProps(targetCoordinate, propsId);
            return;
        end
    
    elseif propsId == BoosterID.PROP_ELI_V then
    

        if MissionGrid.isBombo(gridTpye) then
        
            MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.I_3LINES);
            clearRocketList = GameValue.mxMissionManager:getRocketDestroyV3List(targetCoordinate.x, targetCoordinate.y);
            GameValue.mxGridContainer:playClearRocket3Eft(2403, targetCoordinate, MissionGrid.PU_KEY_ROCKET_V);
            
        elseif MissionGrid.isEliH(gridTpye) or MissionGrid.isEliV(gridTpye) then
        
            GameValue.mxGridContainer:playClearEffect(2402, targetCoordinate);
            GameValue.mxGridContainer:playClearEffect(2403, targetCoordinate);
            clearRocketList = GameValue.mxMissionManager:getRocketDestroyHVList(targetCoordinate.x, targetCoordinate.y);
        
        elseif  gridTpye == MissionGrid.PU_RAINBOW  then
        
            self:executeRainbomAndByProps(targetCoordinate, propsId);
            return;
        end
    end
    
    for round = 1,#clearRocketList do
        GameValue.mxMissionManager:setStatusMatrix(clearRocketList[round].x,clearRocketList[round].y, MissionStatus.CLOSED);
    end
    GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration - Config.clearDuration, function()
    
        GameValue.mxDataControler:addPowerUpDestoryListScore(clearRocketList);
        GameValue.mxGameControler:destroyClearList(clearRocketList);
    end
    );

    GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration + 0.2, function()
    
        GameValue.mxGameControler:setWait(false);
        GameValue.mxGameControler:promptlyCheckDrop();
    end
    );
    
end


function PowerUpAssemControler:executeRainbomAndByProps(targetCoordina, propsId)

    local eliGridColor = GameValue.mxMissionManager:getTarSceneRandomColor();
    local clearViewListSameColorList = GameValue.mxMissionManager:getSameColorCommonClearList(eliGridColor);
    for index = 1,#clearViewListSameColorList do
    
        GameValue.mxMissionManager:setStatusMatrix(clearViewListSameColorList[index].x, clearViewListSameColorList[index].y, MissionStatus.CLOSED);
    end

    GameValue.mxGridContainer:playClearEffect(MissionGrid.PU_RAINBOW, targetCoordina);
    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.PU_COLORREMOVE);
    GameValue.mxGameTimeTween:delayedCall(0.2, function()
    
        for round = 1, #clearViewListSameColorList do 
            local tempFrom = Coordina.new();
            tempFrom.x = targetCoordina.x;
            tempFrom.y = targetCoordina.y;
            
            local tempTarget = Coordina.new();
            tempTarget.x = clearViewListSameColorList[round].x;
            tempTarget.y = clearViewListSameColorList[round].y;
            local delayC = function (parameters)
            	GameValue.mxGridContainer:playRainbowFly(parameters[1], parameters[2]);
            end
            GameValue.mxGameTimeTween:delayedCall(0.01*round, delayC,{tempFrom,tempTarget});

        end
    end
    );

    
    GameValue.mxGameTimeTween:delayedCall(0.4, function()
    
        for  sI = 1, #clearViewListSameColorList do
        
            local tempTarget = Coordina.new();
                tempTarget.x = clearViewListSameColorList[sI].x;
                tempTarget.y = clearViewListSameColorList[sI].y;
            
            local delayC = function (parameters)
            	GameValue.mxGameControler:collectCommonCell(parameters[1], 0);
                local rocketId = 0;
                if propsId == BoosterID.PROP_ELI_H then
                    rocketId = 2000 + parameters[2] * 100 + MissionGrid.PU_KEY_ROCKET_H;
                else
                    rocketId = 2000 + parameters[2] * 100 +  MissionGrid.PU_KEY_ROCKET_V;
                end
                
                GameValue.mxMissionManager:setMissionMatrix(parameters[1].x, parameters[1].y, rocketId);
                self:transformToPowerUpFromCommonGrid(parameters[1]);
            end
             
            GameValue.mxGameTimeTween:delayedCall(0.01*sI, delayC,{tempTarget,eliGridColor});


        end
    end
    );

    GameValue.mxGameTimeTween:delayedCall(1.1, function()
    
        for clearIndex = 1, #clearViewListSameColorList do
        
            local tempClearList = {};
            
            table.insert(tempClearList,clearViewListSameColorList[clearIndex])
            

            GameValue.mxGameTimeTween:delayedCall(0.05*clearIndex, function()
            
                GameValue.mxDataControler:addPowerUpDestoryListScore(tempClearList);
                GameValue.mxGameControler:destroyClearList(tempClearList);
            end
            );

        end

        GameValue.mxGameTimeTween:delayedCall(Config.clearPowerUpDuration + 0.2 + #clearViewListSameColorList*0.05, function()
        
            GameValue.mxGameControler:setWait(false);
            GameValue.mxGameControler:promptlyCheckDrop();
        
        end
        );
    end
    );

end

function PowerUpAssemControler:executePowerUpByPropsRainbow(targetCoordina)

   
   
    local powerUpCoordina = Coordina.new();
  
    powerUpCoordina.x = targetCoordina.x;
    powerUpCoordina.y = targetCoordina.y;
  

    local powerUpType = GameValue.mxMissionManager:getMissionMatrix(powerUpCoordina.x, powerUpCoordina.y);

    if powerUpType == MissionGrid.PU_RAINBOW then
        
        self:executeRainbowAndRainbow(nil,targetCoordina)
        return;
    end
    
    local powerUpColor = GameValue.mxMissionManager:getColorByPst(powerUpCoordina.x, powerUpCoordina.y);

   
    GameValue.mxGameControler:clearPowerUpCellAsCommonCell(powerUpCoordina);

    local clearViewListSameColorList = GameValue.mxMissionManager:getSameColorCommonClearList(powerUpColor);
    for index = 1, #clearViewListSameColorList do
        GameValue.mxMissionManager:setStatusMatrix(clearViewListSameColorList[index].x, clearViewListSameColorList[index].y, MissionStatus.CLOSED);
    end
    GameValue.mxGridContainer:playClearEffect(MissionGrid.PU_RAINBOW, targetCoordina);
    MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.PU_COLORREMOVE);
    GameValue.mxGameTimeTween:delayedCall(0.2, function()
        for round = 1, #clearViewListSameColorList do
            local clearCoordina = Coordina.new();
            clearCoordina.x =  clearViewListSameColorList[round].x;
            clearCoordina.y =  clearViewListSameColorList[round].y;
            GameValue.mxGameTimeTween:delayedCall(0.01*round, function()

                    GameValue.mxGridContainer:playRainbowFly(targetCoordina, clearCoordina);
                end
            );
        end
    end
    );

    GameValue.mxGameTimeTween:delayedCall(0.4, function()

            for sI = 1, #clearViewListSameColorList do
                local clearCoordina = Coordina.new();
                clearCoordina.x =  clearViewListSameColorList[sI].x;
                clearCoordina.y =  clearViewListSameColorList[sI].y;

                local delayC = function (parameters)
                    GameValue.mxGameControler:collectCommonCell(parameters[1], 0);
                    GameValue.mxMissionManager:setMissionMatrix(parameters[1].x, parameters[1].y, parameters[2]);
                    self:transformToPowerUpFromCommonGrid(parameters[1]);
                end

                GameValue.mxGameTimeTween:delayedCall(0.01*sI, delayC,{clearCoordina,powerUpType});
            end
    end
    );

    GameValue.mxGameTimeTween:delayedCall(1.1, function()
        for clearIndex = 1, #clearViewListSameColorList do
            local tempClearList = {};
            local tempCoordina = Coordina.new();
            tempCoordina.x = clearViewListSameColorList[clearIndex].x;
            tempCoordina.y = clearViewListSameColorList[clearIndex].y;
            table.insert(tempClearList,tempCoordina)

            GameValue.mxGameTimeTween:delayedCall(0.05*clearIndex, function()

                    GameValue.mxDataControler:addPowerUpDestoryListScore(tempClearList);
                    GameValue.mxGameControler:destroyClearList(tempClearList);
            end
            );

        end



    end
    );

    GameValue.mxGameTimeTween:delayedCall(1.1 + Config.clearPowerUpDuration + 0.2 + #clearViewListSameColorList*0.05, function()
        GameValue.mxGameControler:setWait(false);
        GameValue.mxGameControler:promptlyCheckDrop();
    end
    );
end




return PowerUpAssemControler;