local MissionManager = class("MissionManager",function()
    local m_super = require("game.model.MissionBase")
    return m_super;
end)

function MissionManager.create()
    local missionManager = MissionManager.new();
    return missionManager;
end;

function MissionManager:fillBrickMatrix(bricks)
    self:initBrick(bricks)
    
end

function MissionManager:fillMissionMatrix(items)
    self:initMission(items)

end

function MissionManager:checkMissionClear()
    
    local time = os.clock();
    local enable = false;
    if enable == false then
        --return false;
    end
    local count = 0;
    
    for yRound = 1,self.m_maxRow do
        count = 0
        local realRoundX = 0;
        for xRound = 1,self.m_maxCol do
            local gridType = self:getMissionMatrix(xRound, yRound);
            if realRoundX < xRound and self:getStatusMatrix(xRound, yRound) == MissionStatus.OPEN and GameValue.mxStatusLogic:getMathchEnable(gridType) == true then
                local gridColor = self:getColorByType(gridType);
                count = 1;
                for tempRound = xRound + 1,self.m_maxCol do 
                    if self:getStatusMatrix(tempRound, yRound) ~= MissionStatus.OPEN then 
                        break ;
                    end;
                    local tempGridType = self:getMissionMatrix(tempRound, yRound);
                    local tempGridColor = self:getColorByType(tempGridType);
                    if GameValue.mxStatusLogic:getMathchEnable(tempGridType) == false then
                        break;
                    end;
                 
                    if gridColor == tempGridColor then
                        count = count + 1;
                    else
                        break;
                    end;      
                end;
                
                if count >= 3 then
                    for tempRound = 0,  count-1 do
                        self:setReferMatrix(xRound + tempRound, yRound, gridColor);
                    end
                    realRoundX = xRound +  count - 1;
                    if enable == false then
                        enable = true;
                    end
                end;
                
            end; 
        end;
        

    end;
    
    for xRound = 1,self.m_maxCol do
        count = 0;
        local realRoundY = 0;
        for yRound = 1,self.m_maxRow do
            local gridType = self:getMissionMatrix(xRound, yRound);
            if realRoundY < yRound and self:getStatusMatrix(xRound, yRound) == MissionStatus.OPEN and GameValue.mxStatusLogic:getMathchEnable(gridType) == true then
                local gridColor = self:getColorByType(gridType);
                count = 1;
                for tempRound = yRound + 1, self.m_maxRow do
                    if self:getStatusMatrix(xRound, tempRound) ~= MissionStatus.OPEN then 
                        break ;
                    end;
                    
                    local tempGridType = self:getMissionMatrix(xRound, tempRound);
                    local tempGridColor = self:getColorByType(tempGridType); 
                    if GameValue.mxStatusLogic:getMathchEnable(tempGridType)==false then
                        break;
                    end;
                    if gridColor == tempGridColor then                   
                        count = count+1;
                    else
                        break;
                    end
                end
                
                if count>= 3 then
                    for tempRound = 0,  count-1 do
                      self:setReferMatrix(xRound, yRound + tempRound, gridColor);
                    end
                    realRoundY = yRound +  count - 1;
                    if enable == false then
                        enable = true;
                    end
                end;
                
            end;
        end
    end
    
    return enable;
end

function MissionManager:getClearView()
    
    local clearCoordinateList = {};

    local canClearCoordinateList = {};
    
    for yRound=1, self.m_maxRow do
        for xRound=1, self.m_maxCol do
            local refer = self:getReferMatrix(xRound, yRound);
            if refer > 0 then
            	local coordinate = Coordina.new();
            	coordinate.x = xRound;
                coordinate.y = yRound;
                table.insert(canClearCoordinateList,#canClearCoordinateList + 1,coordinate);
                local coordinateList = {};
                while #canClearCoordinateList>0 do
                	local tempCoordinate = Coordina.new();
                	tempCoordinate.x = canClearCoordinateList[#canClearCoordinateList].x;
                	tempCoordinate.y = canClearCoordinateList[#canClearCoordinateList].y;
                	table.remove(canClearCoordinateList,#canClearCoordinateList)
                	local gridType = self:getReferMatrix(tempCoordinate.x, tempCoordinate.y);
                    self:setReferMatrix(tempCoordinate.x, tempCoordinate.y, 0);
                    if gridType ~= 0 then          
                        table.insert(coordinateList,#coordinateList + 1,tempCoordinate);
                        if tempCoordinate.x - 1 > 0 then
                            local left = Coordina.new();
                            left.x = tempCoordinate.x - 1;
                            left.y = tempCoordinate.y;
                            if self:getReferMatrix(left.x, left.y) == gridType then
                                table.insert(canClearCoordinateList,#canClearCoordinateList + 1,left);                   
                            end                           
                        end
                        
                         if tempCoordinate.y + 1  <= self.m_maxRow then
                            local down = Coordina.new();
                            down.x = tempCoordinate.x;
                            down.y = tempCoordinate.y + 1;
                            if self:getReferMatrix(down.x, down.y) == gridType then
                                table.insert(canClearCoordinateList,#canClearCoordinateList + 1,down);                   
                            end                           
                        end
                        
                         if tempCoordinate.x + 1 <= self.m_maxCol then
                            local right = Coordina.new();
                            right.x = tempCoordinate.x + 1;
                            right.y = tempCoordinate.y;
                            if self:getReferMatrix(right.x, right.y) == gridType then
                                table.insert(canClearCoordinateList,#canClearCoordinateList + 1,right);                   
                            end                           
                        end
                        
                         if tempCoordinate.y - 1 > 0 then
                            local up = Coordina.new();
                            up.x = tempCoordinate.x ;
                            up.y = tempCoordinate.y - 1;
                            if self:getReferMatrix(up.x, up.y) == gridType then
                                table.insert(canClearCoordinateList,#canClearCoordinateList + 1,up);                   
                            end                           
                        end
                    end;
                    

                end
                table.insert(clearCoordinateList,#clearCoordinateList + 1,coordinateList)
            end
        
        end
    	
    end

    return clearCoordinateList;
end

function MissionManager:setAllStatusWaitingToOpen() 

    for yRound=1, self.m_maxRow do
        for xRound=1, self.m_maxCol do
            if self:getStatusMatrix(xRound, yRound) == MissionStatus.WAITING then
                self:setStatusMatrix(xRound, yRound, MissionStatus.OPEN);
            end
        end
    end
end

function MissionManager:resetReferMatrix()

     for yRound=1, self.m_maxRow do
        for xRound=1, self.m_maxCol do
            self.m_referMatrix[yRound][xRound] = 0;
        end
    end
   
end

function MissionManager:findCommingGrid( indexX,  indexY)

    local tempPoint = CommingGrid.new();
    tempPoint.needNew = false;
    tempPoint.gridStatus = -1;
    tempPoint.x = -1;
    tempPoint.y = -1;
    local needCheckX = false;
    
    for yRound = indexY-1, 1,-1 do
        local gridType = self:getMissionMatrix(indexX, yRound);
        if GameValue.mxStatusLogic:getCrossEnable(gridType) == false then
            
            if GameValue.mxStatusLogic:getMoveEnable(gridType) then
                local gridStatus = self:getStatusMatrix(indexX, yRound);
                if gridStatus == MissionStatus.OPEN or gridStatus == MissionStatus.DROPING then
                    tempPoint.x = indexX;
                    tempPoint.y = yRound;
                    tempPoint.gridStatus = MissionStatus.DROPING;
                    return tempPoint;
                
                else 
                    return tempPoint;
                end
            else
                needCheckX = true;
                break;
            end;
        end;
    end
    
    if needCheckX == true then
        local gridStatus = self:getStatusMatrix(indexX, indexY);
        if gridStatus~= MissionStatus.OPEN then
            return tempPoint;
        end;
        
        local needCheckR = true;
        if indexX - 1 > 0 then
            local gridType = self:getMissionMatrix(indexX - 1, indexY - 1);
            if GameValue.mxStatusLogic:getCrossEnable(gridType) == false then            
                if GameValue.mxStatusLogic:getMoveEnable(gridType) == true then                
                    local gridStatus = self:getStatusMatrix(indexX - 1, indexY - 1);
                    if gridStatus == MissionStatus.OPEN then                   
                        needCheckR = false;
                        tempPoint.x = indexX - 1;
                        tempPoint.y = indexY - 1;
                        tempPoint.gridStatus = MissionStatus.INCLINE;
                    end
                end
            end
        end;
        
        if needCheckR == true then
            if indexX+1 <= self.m_maxCol then
                local gridType = self:getMissionMatrix(indexX + 1, indexY - 1);
                
                if GameValue.mxStatusLogic:getCrossEnable(gridType) == false then            
                    if GameValue.mxStatusLogic:getMoveEnable(gridType) == true then     
                        local gridStatus = self:getStatusMatrix(indexX + 1, indexY - 1);
                        if gridStatus == MissionStatus.OPEN then
                    
                            tempPoint.x = indexX + 1;
                            tempPoint.y = indexY - 1;
                            tempPoint.gridStatus = MissionStatus.INCLINE;
                           
                        end
                    end
                end
            end;
        end; 
        
    else
        tempPoint.needNew = true;   
    end;
    
    return tempPoint;
end

function MissionManager:getStatusIsStatic()

    for yRound=1, self.m_maxRow do
        for xRound=1, self.m_maxCol do
        	if self:getStatusMatrix(xRound, yRound) ~= MissionStatus.OPEN then
        	   return false;
        	end;
        end
    	
    end 
    return true
end

function MissionManager:getNeighborMathchList( indexX,  indexY)

    local tempDestroyList = {};

    
    --LEFT          
    if self:checkActiveNeighborMathchPoint(indexX - 1, indexY) == true then
        local tempCoordina = Coordina.new();
        tempCoordina.x = indexX - 1;
        tempCoordina.y = indexY;
        table.insert(tempDestroyList,#tempDestroyList  +1,tempCoordina)
        
    end

    --RIGHT
    if self:checkActiveNeighborMathchPoint(indexX + 1, indexY) == true then
        local tempCoordina = Coordina.new();
        tempCoordina.x = indexX + 1;
        tempCoordina.y = indexY;
        table.insert(tempDestroyList,#tempDestroyList  +1,tempCoordina)
    end

    --TOP
    if self:checkActiveNeighborMathchPoint(indexX, indexY - 1) == true then
        local tempCoordina = Coordina.new();
        tempCoordina.x = indexX;
        tempCoordina.y = indexY - 1;
        table.insert(tempDestroyList,#tempDestroyList  +1,tempCoordina)
    end

    --DOWN
    if self:checkActiveNeighborMathchPoint(indexX, indexY + 1) == true then
        local tempCoordina = Coordina.new();
        tempCoordina.x = indexX;
        tempCoordina.y = indexY + 1;
        table.insert(tempDestroyList,#tempDestroyList  +1,tempCoordina)
    end

    return tempDestroyList;
end


-- 检测邻居是否是可以匹配的
-- @param    tempCoordina
-- @return
function MissionManager:checkActiveNeighborMathchPoint(indexX, indexY)

    if indexX <= 0 or indexX > self.m_maxCol then 
        return false;
    end;
    if indexY <= 0 or indexY > self.m_maxRow then
        return false;
    end;

    local tempGridType = self:getMissionMatrix(indexX, indexY);
    local gridStatus = self:getStatusMatrix(indexX, indexY);

    if gridStatus ~= MissionStatus.OPEN then
        return false;
    end
    return GameValue.mxStatusLogic:getNeighborMathchEnable(tempGridType);   
end

function MissionManager:getSameColorList(eliGridColor)

    local sameColorList = {};

    if eliGridColor <= 0 then
        return sameColorList;
    end;
 
    for yRound=1, self.m_maxRow do
    	for xRound=1, self.m_maxCol do
    	   local missionType =  self:getMissionMatrix(xRound, yRound);
    	   if self:getStatusMatrix(xRound, yRound) == MissionStatus.OPEN or GameValue.mxStatusLogic:getMathchEnable(missionType) == true then
    	        if self:getColorByType(missionType) == eliGridColor then
            
                    local tempCoordina = Coordina.new();
                    tempCoordina.x = xRound;
                    tempCoordina.y = yRound;         
                    table.insert(sameColorList,#sameColorList  + 1,tempCoordina)
                end
    	   end
    	end
    end


    return sameColorList;
end

function MissionManager:getAllColorList()
    local allColoeList = {};
    for yRound=1, self.m_maxRow do
    	local tempList = {};
    	for xRound=1, self.m_maxCol do
    		local missionType = self:getMissionMatrix(xRound, yRound);
    		if self:getStatusMatrix(xRound, yRound) == MissionStatus.OPEN or GameValue.mxStatusLogic:getMathchEnable(missionType) == true then
                
                local tempCoordina = Coordina.new();
                tempCoordina.x = xRound;
                tempCoordina.y = yRound;         
                table.insert(tempList,#tempList+1,tempCoordina)
                
           end
    	end
    	
    	if #tempList > 0 then
            table.insert(allColoeList,#allColoeList  + 1,tempList)
           
        end
    end 
    return allColoeList;
end


function MissionManager:getClearModeByClearList(coordinateList, keyCoordinate)

    local tempMpde = ClearMode.MODE_NONE;

    local leng = #coordinateList;

    if keyCoordinate == nil then
        print("keyCoordinate  --- nil")
    end


    local leftSum = 0;
    local righeSum = 0;
    local upSum = 0;
    local downSum = 0;

    for round =1,leng do
    	if coordinateList[round].x ~= keyCoordinate.x or coordinateList[round].y ~= keyCoordinate.y then
    	    if coordinateList[round].x == keyCoordinate.x then
                if coordinateList[round].y > keyCoordinate.y then
                    downSum = downSum + 1;
                else 
                    upSum = upSum + 1;
                end

            elseif coordinateList[round].y == keyCoordinate.y then
            
                if coordinateList[round].x > keyCoordinate.x then
                    righeSum = righeSum + 1;
                else 
                    leftSum = leftSum + 1;
                end
            else
                
            end
    	end
    end
  
    --2014-3-25 start start start start start start 生成道具（powerUp）类型  处理

    local hSize = leftSum + righeSum + 1;

    local vSize = upSum + downSum + 1;

    if leng == 3 then
    
        if hSize >= vSize then
            return ClearMode.MODE_3_HORIZONTAL;
        else 
            return ClearMode.MODE_3_VERTICAL;
         end
    end

    if hSize >= vSize then
        if hSize > 4 then
        
            tempMpde = ClearMode.MODE_5_HORIZONTAL;
        
        else
        
            if hSize >= 3 then            
                if vSize >= 3 then                
                    tempMpde = ClearMode.MODE_L_T;    
                elseif hSize == 4 then
                    tempMpde = ClearMode.MODE_4_HORIZONTAL;
                else
                end
            end
        end
    
    else
    
        if vSize > 4 then
        
            tempMpde = ClearMode.MODE_5_VERTICAL;
        
        else
        
            if vSize >= 3 then       
                if hSize >= 3 then       
                    tempMpde = ClearMode.MODE_L_T;
                elseif vSize == 4 then
                
                    tempMpde = ClearMode.MODE_4_VERTICAL;
                end
            end
        end
    end

    --2013-3-25 新增加 L 或者 T 型判断

    if tempMpde == ClearMode.MODE_NONE then
    
        if (leftSum + righeSum + upSum + downSum + 1) == 5 then
        
            tempMpde = ClearMode.MODE_L_T;
        end
    
    end
    if leng == 5 and tempMpde == 0 then
        return ClearMode.MODE_L_T;
    end

    if leng > 5 and tempMpde == 0 then
        return ClearMode.MODE_L_T;
    end
    return tempMpde;
end

function  MissionManager:getBigBombDestoryList( indexX,  indexY)

   local tempDestroyList = self:getBombRectHitList(indexX, indexY, 1);

    
    
    --LEFT
    if self:checkActiveDestroyMissonPoint(indexX - 2, indexY) == true then
        local tempCoordina = Coordina.new();
        tempCoordina.x = indexX - 2;
        tempCoordina.y = indexY;
        
        table.insert(tempDestroyList,#tempCoordina + 1,tempCoordina)
    end

    --RIGHT
    if self:checkActiveDestroyMissonPoint(indexX + 2, indexY) ==true then 
        local tempCoordina = Coordina.new();
        tempCoordina.x = indexX + 2;
        tempCoordina.y = indexY;
        table.insert(tempDestroyList,#tempCoordina + 1,tempCoordina)
    
    end
    --TOP
    if self:checkActiveDestroyMissonPoint(indexX, indexY - 2)==true then 
        local tempCoordina = Coordina.new();
        tempCoordina.x = indexX;
        tempCoordina.y = indexY - 2;
        table.insert(tempDestroyList,#tempCoordina + 1,tempCoordina)
    end

    --DOWN
    if self:checkActiveDestroyMissonPoint(indexX, indexY + 2)==true then 
        local tempCoordina = Coordina.new();
        tempCoordina.x = indexX;
        tempCoordina.y = indexY + 2;
        table.insert(tempDestroyList,#tempCoordina + 1,tempCoordina)
    end

    return tempDestroyList;
end


function MissionManager:getBombDestoryList(indexX, indexY)

    return self:getBombRectHitList(indexX, indexY, 1);
end

function MissionManager:getRocketDestroyH1List( indexX,  indexY)

    return self:getRocketDestroyList(indexX, indexY, MissionGrid.LINE_H);
end

function MissionManager:getRocketDestroyV1List( indexX,  indexY)

    return self:getRocketDestroyList(indexX, indexY, MissionGrid.LINE_V);
end

function MissionManager:getRocketDestroyHVList( indexX,  indexY)

    local tempDestroyList = self:getRocketDestroyList(indexX, indexY, MissionGrid.LINE_H);
    local tempArr = self:getRocketDestroyList(indexX, indexY, MissionGrid.LINE_V);
    for round=1, #tempArr do
    	table.insert(tempDestroyList,#tempDestroyList + 1,tempArr[round])
    end
   
    return tempDestroyList;
end

function MissionManager:getRocketDestroyH3List( indexX,  indexY)

    local tempDestroyList = self:getRocketDestroyList(indexX, indexY, MissionGrid.LINE_H);

    local tempArr = self:getRocketDestroyList(indexX, indexY - 1, MissionGrid.LINE_H);

    
    for round=1, #tempArr do
        table.insert(tempDestroyList,#tempDestroyList + 1,tempArr[round])
    end
    

    local tempArr2 = self:getRocketDestroyList(indexX, indexY + 1, MissionGrid.LINE_H);
    
    for round=1, #tempArr2 do
        table.insert(tempDestroyList,#tempDestroyList + 1,tempArr2[round])
    end
    return tempDestroyList;
end

function MissionManager:getRocketDestroyV3List( indexX,  indexY)

    local tempDestroyList = self:getRocketDestroyList(indexX, indexY, MissionGrid.LINE_V);

    local tempArr = self:getRocketDestroyList(indexX - 1, indexY, MissionGrid.LINE_V);
    for round=1, #tempArr do
        table.insert(tempDestroyList,#tempDestroyList + 1,tempArr[round])
    end

    local tempArr2 = self:getRocketDestroyList(indexX + 1, indexY, MissionGrid.LINE_V);
    for round=1, #tempArr2 do
        table.insert(tempDestroyList,#tempDestroyList + 1,tempArr2[round])
    end
    return tempDestroyList;
end

function MissionManager:getAllRainbowClearList()

    local  clearCoordinateSameColoeList = {};

    for yRound = 1,self.m_maxRow do
    
        local tempList = {};
        for xRound = 1,  self.m_maxCol do
        

            local tmpGridType = self:getMissionMatrix(xRound, yRound);
            if MissionGrid.INTERVAL_COMMON:includeValue(tmpGridType) or MissionGrid.INTERVAL_POWER_DOWN:includeValue(tmpGridType) or MissionGrid.INTERVAL_POWER_UP:includeValue(tmpGridType) then
            
                if self:getStatusMatrix(xRound, yRound) == MissionStatus.OPEN and GameValue.mxStatusLogic:getDestroyEnable(tmpGridType) then
                
                    local tempCoordina = Coordina.new();
                    tempCoordina.x = xRound;
                    tempCoordina.y = yRound;
                   
                    table.insert(tempList,tempCoordina)
                end
            end
        end
        if #tempList > 0 then
            table.insert(clearCoordinateSameColoeList,#clearCoordinateSameColoeList + 1,tempList)
        end;
    end

    return clearCoordinateSameColoeList;
end

function MissionManager:getSameColorClearList( eliGridColor)

    local  clearCoordinateSameColoeList = {};

    for yRound=1, self.m_maxRow do
    	for xRound=1, self.m_maxCol do
            local tmpGridType = self:getMissionMatrix(xRound, yRound);
            if GameValue.mxStatusLogic:getMathchEnable(tmpGridType) == true and self:getStatusMatrix(xRound, yRound) == MissionStatus.OPEN then
    
        
                local tempColor = self:getColorByPst(xRound, yRound);
    
                if eliGridColor ~= 0 and tempColor == eliGridColor then
                
                    local tempCoordina = Coordina.new();
                    tempCoordina.x = xRound;
                    tempCoordina.y = yRound;
                    table.insert(clearCoordinateSameColoeList,#clearCoordinateSameColoeList+1,tempCoordina)
                    
                end
            end;
        end
    end
    

    return clearCoordinateSameColoeList;
end

function MissionManager:getSameColorCommonClearList( eliGridColor)

    local  clearCoordinateSameColoeList = {};

    for yRound=1, self.m_maxRow do
        for xRound=1, self.m_maxCol do
            local tmpGridType = self:getMissionMatrix(xRound, yRound);
            if GameValue.mxStatusLogic:getMathchEnable(tmpGridType)== true and MissionGrid.INTERVAL_POWER_UP:includeValue(tmpGridType) == false and
            self:getStatusMatrix(xRound, yRound) == MissionStatus.OPEN then
         
            local tempColor = self:getColorByPst(xRound, yRound);

                if eliGridColor ~= 0 and tempColor == eliGridColor then
                
                    local tempCoordina = Coordina.new();
                    tempCoordina.x = xRound;
                    tempCoordina.y = yRound;
                    table.insert(clearCoordinateSameColoeList,#clearCoordinateSameColoeList+1,tempCoordina)
                   
                end
            end
        end
    end
    

    return clearCoordinateSameColoeList;
end
-------------------------------------------------private-----------------------------------------------------------------------------
function  MissionManager:getRocketDestroyList( indexX,  indexY,  lineClearMode)

    local tempDestroyList = {};
    if indexX < 1 or indexX > self.m_maxCol or indexY < 1 or indexY > self.m_maxRow then 
        return tempDestroyList;
    end

    if lineClearMode == MissionGrid.LINE_H then
    
        for  roundX = 1,self.m_maxCol do
        
            local tempGridType = self:getMissionMatrix(roundX, indexY);
           
            
            if tempGridType~=MissionGrid.NONE and tempGridType ~= MissionGrid.BLANK and  self:getStatusMatrix(roundX, indexY) == MissionStatus.OPEN and 
            GameValue.mxStatusLogic:getDestroyEnable(tempGridType) then
                local tempCoordina = Coordina.new();
                tempCoordina.x = roundX;
                tempCoordina.y = indexY;
                table.insert(tempDestroyList,#tempDestroyList+1,tempCoordina);
            end
        end
    
    elseif lineClearMode == MissionGrid.LINE_V then
    
        for  roundY = 1, self.m_maxRow do
        
            local tempGridType = self:getMissionMatrix(indexX, roundY);
            if tempGridType~=MissionGrid.NONE and tempGridType ~= MissionGrid.BLANK and  self:getStatusMatrix(indexX, roundY) == MissionStatus.OPEN and 
            GameValue.mxStatusLogic:getDestroyEnable(tempGridType) then
                local tempCoordina = Coordina.new();
                tempCoordina.x = indexX;
                tempCoordina.y = roundY;
                table.insert(tempDestroyList,#tempDestroyList+1,tempCoordina);
            end
        end
    end

    return tempDestroyList;
end


function  MissionManager:getBombRectHitList( indexX,  indexY,  radius)

    local tempDestroyList = {};

    local tempGridType = MissionGrid.BLANK;
    local tempStatus = MissionStatus.DROPING;
    local startRoundY = (indexY - radius);
    if startRoundY < 1 then 
        startRoundY = 1 
    end;
    local startRoundX = (indexX - radius);
    if startRoundX < 1 then
        startRoundX = 1;
    end;
    local endRoundX = indexX + radius;
    if endRoundX > self.m_maxCol then
        endRoundX = self.m_maxCol;
    end
    local endRoundY = indexY + radius;
    if endRoundY > self.m_maxRow then
        endRoundY = self.m_maxRow;
    end
    
    for roundY= startRoundY,endRoundY do
        for roundX= startRoundX,endRoundX do
            tempGridType = self:getMissionMatrix(roundX, roundY);
            if tempGridType~=MissionGrid.NONE and tempGridType~= MissionGrid.BLANK then
                tempStatus = self:getStatusMatrix(roundX, roundY);
                
                if tempStatus == MissionStatus.OPEN and GameValue.mxStatusLogic:getDestroyEnable(tempGridType) then
                    local tempCoordina = Coordina.new();
                    tempCoordina.x = roundX;
                    tempCoordina.y = roundY;
                    table.insert(tempDestroyList,#tempDestroyList + 1,tempCoordina)
                    
                end
                
            end;
        end
    end

  

    return tempDestroyList;
end

function MissionManager:checkActiveDestroyMissonPoint( indexX,  indexY)

    if indexX < 1 or indexX > self.m_maxCol or indexY < 1 or indexY > self.m_maxRow then
        return false;
    end
    

    if self:getStatusMatrix(indexX, indexY) ~= MissionStatus.OPEN then
        return false;
    end;

    local tempGridType = self:getMissionMatrix(indexX, indexY);

    if tempGridType == MissionGrid.NONE or tempGridType == MissionGrid.BLANK then
        return false;
    end

    return GameValue.mxStatusLogic:getDestroyEnable(tempGridType);
end

function MissionManager:setDropingGridStatus( fromY,  toY,  xIndex,  status,  endStatus)

    for yRound=fromY, toY-1 do
    	if yRound > 0 then
    	   self:setStatusMatrix(xIndex, yRound, status);
    	end
    end
   

    self:setStatusMatrix(xIndex, toY, endStatus);
end

function MissionManager:getTarSceneRandomColor()

    local randomAry = {};

    for roundY = 1,  self.m_maxRow do
    
        for roundX = 1, self.m_maxCol do
        
            local tempGridType = self:getColorByPst(roundX, roundY);
            if tempGridType ~= -1 and tempGridType ~= 0 then
                local needPush =  true;
                for index = 1, #randomAry do
                	if randomAry[index] == tempGridType then
                	   needPush = false
                	   break;
                	end
                end
               
                if needPush == true then
                    table.insert(randomAry,#randomAry + 1,tempGridType)
                    
                end
            end
        end
    end
    
    
    local index = math.random(1,#randomAry )
   
    return randomAry[index];
end

function MissionManager:getColorByPst( xRound,  yRound)

    return self:getColorByType(self:getMissionMatrix(xRound, yRound));
end

function MissionManager:getColorByType( gridType)

    if MissionGrid.INTERVAL_POWER_UP:includeValue(gridType) or MissionGrid.INTERVAL_COMMON:includeValue(gridType) then
    
      
        return math.floor((gridType % 1000) / 100);
    end
    return -1;
end


function MissionManager:getTarCoordina(tempCoordinateXList)

    local coordinateXList = {};

    for round = 1,  #tempCoordinateXList do
    
        local tempGridType = self:getMissionMatrix(tempCoordinateXList[round].x,tempCoordinateXList[round].y);
        if MissionGrid.INTERVAL_COMMON:includeValue(tempGridType)== false or GameValue.mxStatusLogic:getMoveEnable(tempGridType)== true then
            table.insert(coordinateXList,#coordinateXList,tempCoordinateXList[round])
        end
        
    end


    local dicNeiNumIndex = {};

    for cI  = 1, #coordinateXList do
    
        dicNeiNumIndex[cI] = self:getNeiNum(coordinateXList[cI], coordinateXList);  --邻居数量
    end
    local neiMaxNumIndex  = 0;
    local neiNum = 0;
    for key = 1,#dicNeiNumIndex do
    
        if neiNum < dicNeiNumIndex[key] then
        
            neiNum = dicNeiNumIndex[key];
            neiMaxNumIndex = key;
        end
    end
    
    local tarCoordina = Coordina.new();
    
    if coordinateXList[neiMaxNumIndex]~=nil then
        tarCoordina.x = coordinateXList[neiMaxNumIndex].x;
        tarCoordina.y = coordinateXList[neiMaxNumIndex].y;
    end
    
    return tarCoordina;
end

function MissionManager:getRandomPowerUpType( clearMode,  color,  swapDir)

    --确定生成PowerUp 道具类型和颜色处理         
    local tempType = 2000;
    tempType = tempType + color * 100;
    
    if clearMode == ClearMode.MODE_4_HORIZONTAL then
        tempType = tempType + swapDir;
    elseif clearMode == ClearMode.MODE_4_VERTICAL then
        tempType = tempType + swapDir;
    elseif clearMode == ClearMode.MODE_5_HORIZONTAL or clearMode == ClearMode.MODE_5_VERTICAL then
        tempType = MissionGrid.PU_RAINBOW;--1000
    elseif clearMode == ClearMode.MODE_L_T then
        tempType = tempType  + 1;
    end
    
    
    return tempType;
end


function MissionManager:getRandomUFOCoordina()

    local tempCoordinaList = {};

    for roundY = 1, m_maxRow - 1 do
    
        for roundX = 1, m_maxCol - 1 do
        
            if self:checkActiveUFOPst(roundX, roundY) == true then
            
                local tempCoordina = Coordina.new();
                tempCoordina.x = roundX;
                tempCoordina.y = roundY;
                table.insert(tempCoordinaList,#tempCoordina + 1,tempCoordina)
                
            end
        end
    end
    if #tempCoordinaList == 0 then
    
        local tempCoordina = Coordina.new();
        tempCoordina.x = -1;
        tempCoordina.y = -1;
        return tempCoordina;
    
    else
    
        return tempCoordinaList[math.random(1, #tempCoordinaList)];
    end
end


function MissionManager:getSpreadCoordinaListChnageToPopCorn( sum)

    local tempList = {};
    local changeToPowerDownCoordinaList = self:getChangeToPowerUpCoordinaMethod();    
    if #changeToPowerDownCoordinaList > 0 then
        if sum >= #changeToPowerDownCoordinaList then
            tempList = changeToPowerDownCoordinaList;
        else
            while sum > 0 do
            	local randomCount = math.random(1, #changeToPowerDownCoordinaList );
                table.insert(tempList,#tempList + 1,changeToPowerDownCoordinaList[randomCount])           
                table.remove(changeToPowerDownCoordinaList,randomCount)
                sum = sum - 1;
            end
        end
    end;
    return tempList;
end


function MissionManager:getRandomEmptyBrickList( sum)

    local tempList = {};

    local emptyCoordinaList = self:getAllEmptyBrickList();
    if #emptyCoordinaList > 0 then
        if sum >= #emptyCoordinaList then
            tempList = emptyCoordinaList;
        else
            while sum > 0 do
                local randomCount = math.random(1, #emptyCoordinaList );
                table.insert(tempList,#tempList + 1,emptyCoordinaList[randomCount])           
                table.remove(emptyCoordinaList,randomCount)
                sum = sum - 1;
            end
        end
    end;

    return tempList; 
end

function MissionManager:getClipDestroyList( indexX,  indexY)

    local tempDestroyList = {};
    if self:checkActiveDestroyMissonPoint(indexX, indexY) == true then
    
        local tempGridType = self:getMissionMatrix(indexX, indexY);
        if GameValue.mxStatusLogic:getDestroyEnable(tempGridType) then
        
            local tempCoordina = Coordina.new();
            tempCoordina.x = indexX;
            tempCoordina.y = indexY;
            table.insert(tempDestroyList,#tempDestroyList + 1,tempCoordina)
            
        end
    end
    return tempDestroyList;
end

function MissionManager:getHammerDestroyList( indexX,  indexY)

    local tempDestroyList = {};

    if self:checkActiveDestroyMissonPoint(indexX, indexY) == true then
    
        local tempGridType = self:getMissionMatrix(indexX, indexY);
        if  GameValue.mxStatusLogic:getMoveEnable(tempGridType) == false then
        
            local tempCoordina = Coordina.new();
            tempCoordina.x = indexX;
            tempCoordina.y = indexY;
            table.insert(tempDestroyList,#tempDestroyList + 1,tempCoordina)
        end
    end
    return tempDestroyList;
end

function MissionManager:getTarGameAllPowerUpList()

    local tempTarGameAllPowerUpList = {};

    for  yRound = 1,self.m_maxRow do
    
        for  xRound = 1, self.m_maxCol do
        
            local tmpGridType = self:getMissionMatrix(xRound, yRound);
            if self:getStatusMatrix(xRound, yRound) == MissionStatus.OPEN and MissionGrid.INTERVAL_POWER_UP:includeValue(tmpGridType) then
                local tempCoordina = Coordina.new();
                tempCoordina.x = xRound;
                tempCoordina.y = yRound;
                table.insert(tempTarGameAllPowerUpList,tempCoordina)
               
            end
        end
    end
    return tempTarGameAllPowerUpList;
end

function MissionManager:getChangeToPowerUpSum()

    local sum = 0;
    for yRound = 1, self.m_maxRow do
    
        for xRound = 1, self.m_maxCol do
        
            if self:checkCommonBasePoint(xRound, yRound) == true then
            
                sum = sum + 1;
            end
        end
    end

    return sum;
end

function MissionManager:getChangeToPowerUpCoordinaList( sum)

    local changeToPowerCoordinaList = self:getChangeToPowerUpCoordinaMethod();
    
    local powerUpListSize = #changeToPowerCoordinaList;
    if powerUpListSize > 0 then
    
        if sum >= powerUpListSize then
            return changeToPowerCoordinaList;
        end

        local tempList = {};
        local randomCount = -1;
        while sum > 0 do
        
            powerUpListSize = #changeToPowerCoordinaList;

            randomCount = math.random(1,powerUpListSize)
            
            
            local tempCoordina = Coordina.new();
            tempCoordina.x = changeToPowerCoordinaList[randomCount].x;
            tempCoordina.y = changeToPowerCoordinaList[randomCount].y;
            table.insert(tempList,tempCoordina)
           
            table.remove(changeToPowerCoordinaList,randomCount)
            
            sum = sum - 1;
        end



        if #tempList > 1 then
        
            local tmpCoordinaMin = Coordina.new();
            local minIndex = 0;
            
            for round1= 1, #tempList - 1 do
            	tmpCoordinaMin = tempList[round1];
                minIndex = round1;
                
                for round2=round1+1, #tempList do
                	
                	if tempList[round2].x < tmpCoordinaMin.x then
                	    tmpCoordinaMin = tempList[round2];
                        minIndex = round2;
                	elseif tempList[round2].x == tmpCoordinaMin.x then
                	   if tempList[round2].y < tmpCoordinaMin.y then
                	        tmpCoordinaMin = tempList[round2];
                            minIndex = round2;
                	   end
                	end
                end
                
                if round1 < minIndex then
                    local tempC = Coordina.new();
                    
                    tempC.x = tempList[round1].x;
                    tempC.y = tempList[round1].y;
                    tempList[round1] = tempList[minIndex];
                    tempList[minIndex] = tempC;
                end
                
            end
           
        end


        return tempList;
    end
    changeToPowerCoordinaList = {};
    return changeToPowerCoordinaList;
end

function MissionManager:getBossCommonBaseNeighborList(bossVolumeList)

    local tempCommonNeighborList = {};
    local indexX = 0;
    local indexY = 0;
    
    
    for round=0, #bossVolumeList do
    	indexX = bossVolumeList[round].x;
        indexY = bossVolumeList[round].y;
        
        --LEFT 
        if self:checkCommonBasePoint(indexX - 1, indexY) then
            local tempCoordina = Coordina.new();
            tempCoordina.x = indexX - 1;
            tempCoordina.y = indexY;
            if tempCoordina:indexOfOf(tempCommonNeighborList) == -1 then
            
                table.insert(tempCommonNeighborList,#tempCommonNeighborList,tempCoordina)
                
            end
        end
        
          --LEFT TOP
        if self:checkCommonBasePoint(indexX - 1, indexY-1) then
            local tempCoordina = Coordina.new();
            tempCoordina.x = indexX - 1;
            tempCoordina.y = indexY - 1;
            if tempCoordina:indexOfOf(tempCommonNeighborList) == -1 then
            
                table.insert(tempCommonNeighborList,#tempCommonNeighborList,tempCoordina)
                
            end
        end

        --TOP
        if self:checkCommonBasePoint(indexX, indexY-1) then
            local tempCoordina = Coordina.new();
            tempCoordina.x = indexX;
            tempCoordina.y = indexY-1;
            if tempCoordina:indexOfOf(tempCommonNeighborList) == -1 then
            
                table.insert(tempCommonNeighborList,#tempCommonNeighborList,tempCoordina)
                
            end
        end

        --RIGHT TOP
        if self:checkCommonBasePoint(indexX + 1, indexY-1) then
            local tempCoordina = Coordina.new();
            tempCoordina.x = indexX + 1;
            tempCoordina.y = indexY-1;
            if tempCoordina:indexOfOf(tempCommonNeighborList) == -1 then
            
                table.insert(tempCommonNeighborList,#tempCommonNeighborList,tempCoordina)
                
            end
        end

        --RIGHT              
       if self:checkCommonBasePoint(indexX + 1, indexY) then
            local tempCoordina = Coordina.new();
            tempCoordina.x = indexX + 1;
            tempCoordina.y = indexY;
            if tempCoordina:indexOfOf(tempCommonNeighborList) == -1 then
            
                table.insert(tempCommonNeighborList,#tempCommonNeighborList,tempCoordina)
                
            end
        end

        --RIGHT DOWN
         if self:checkCommonBasePoint(indexX + 1, indexY + 1) then
            local tempCoordina = Coordina.new();
            tempCoordina.x = indexX + 1;
            tempCoordina.y = indexY + 1;
            if tempCoordina:indexOfOf(tempCommonNeighborList) == -1 then
            
                table.insert(tempCommonNeighborList,#tempCommonNeighborList,tempCoordina)
                
            end
        end


        --DOWN
        if self:checkCommonBasePoint(indexX , indexY + 1) then
            local tempCoordina = Coordina.new();
            tempCoordina.x = indexX ;
            tempCoordina.y = indexY + 1;
            if tempCoordina:indexOfOf(tempCommonNeighborList) == -1 then
            
                table.insert(tempCommonNeighborList,#tempCommonNeighborList,tempCoordina)
                
            end
        end

        --LEFT DOWN
         if self:checkCommonBasePoint(indexX -1, indexY + 1) then
            local tempCoordina = Coordina.new();
            tempCoordina.x = indexX - 1;
            tempCoordina.y = indexY + 1;
            if tempCoordina:indexOfOf(tempCommonNeighborList) == -1 then
            
                table.insert(tempCommonNeighborList,#tempCommonNeighborList,tempCoordina)
                
            end
        end
    end
    

    return tempCommonNeighborList;
end


function  MissionManager:getNeiNum(tarPoint, coordinateXList)

    local neiNum  = 0;
    local isH  = false;
    local isV  = false;
    
    for cI=0, #coordinateXList do
    	 --是邻居
        if coordinateXList[cI].x == tarPoint.x and math.abs(coordinateXList[cI].y - tarPoint.y) == 1 then
            isV = true;
            neiNum = neiNum + 1;
        
        elseif coordinateXList[cI].y == tarPoint.y and math.abs(coordinateXList[cI].x - tarPoint.x) == 1 then
        
           isH = true;
           neiNum = neiNum + 1;
        end
    end
    
  

    if isH and isV and (neiNum >= 2) then
    

    
    else 
        neiNum = 0;
    end
    return neiNum;
end

function MissionManager:checkActiveUFOPst(indexX, indexY)

    local tmpGridType = self:getMissionMatrix(indexX, indexY);
    if (MissionGrid.INTERVAL_COMMON:includeValue(tmpGridType) and tmpGridType % 10 == 0) == false then 
        return false;
    end
    tmpGridType = self:getMissionMatrix(indexX + 1, indexY);
    
    
    if (MissionGrid.INTERVAL_COMMON:includeValue(tmpGridType) and tmpGridType % 10 == 0) == false then
        return false;
    end
    tmpGridType = self:getMissionMatrix(indexX, indexY + 1);
    if (MissionGrid.INTERVAL_COMMON:includeValue(tmpGridType) and tmpGridType % 10 == 0) == false then
        return false;
    end
    tmpGridType = self:getMissionMatrix(indexX + 1, indexY + 1);
    if (MissionGrid.INTERVAL_COMMON:includeValue(tmpGridType) and tmpGridType % 10 == 0) == false then
        return false;
    end

    return true;
end

function MissionManager:checkCommonBasePoint(indexX, indexY)

    if indexX < 1 or indexX > self.m_maxCol then 
        return false;
    end;
    if indexY < 1 or indexY > self.m_maxRow then
        return false;
    end;

    local tempGridType = self:getMissionMatrix(indexX, indexY);

    if MissionGrid.INTERVAL_COMMON:includeValue(tempGridType)== false then 
        return false;
    end;

    if self:getStatusMatrix(indexX, indexY) ~= MissionStatus.OPEN then
        return false;
    end

    return (tempGridType % 100) == 0;
end



function MissionManager:getChangeToPowerUpCoordinaMethod()

    local changeToPowerCoordinaList = {};

    for yRound=1, self.m_maxRow do
    	for xRound=1, self.m_maxCol do
            if self:checkCommonBasePoint(xRound, yRound) then
            
                local tempCoordina = Coordina.new();
                tempCoordina.x = xRound;
                tempCoordina.y = yRound;
                table.insert(changeToPowerCoordinaList,#tempCoordina + 1,tempCoordina)
                
            end
        end
    end
   

    return changeToPowerCoordinaList;
end

function MissionManager:getAllEmptyBrickList()

    local emptyCoordinaList = {};
    for yRound=1, self.m_maxRow do
        for xRound=1, self.m_maxCol do
            if self:getBrickMatrix(xRound, yRound) == MissionBrick.NONE and 
                MissionGrid.INTERVAL_BOSS:includeValue(self:getMissionMatrix(xRound, yRound)) == false then
            
                local tempCoordina = Coordina.new();
                tempCoordina.x = xRound;
                tempCoordina.y = yRound;
                table.insert(emptyCoordinaList,#emptyCoordinaList + 1,tempCoordina)
               
            end
        end
    end
    

    return emptyCoordinaList;
end





function MissionManager:getFullAmountById( gridType)

    local totalAmount  = 0;
    for yRound = 1,self.m_maxRow do
    
        for xRound = 1,self.m_maxCol do
        
            if self:getMissionMatrix(xRound, yRound) == gridType then
                totalAmount = totalAmount+ 1;
            end
        end
    end
    return totalAmount;
end

function MissionManager:checkEliminateActive( xRound,  yRound)

    if xRound < 1 or xRound > self.m_maxCol then
        return false;
    end
    if yRound < 1 or yRound > self.m_maxRow then
        return false;
    end
    local tempGridType = self:getMissionMatrix(xRound, yRound);
    return GameValue.mxStatusLogic:getSwapEnable(tempGridType);
end

function MissionManager:checkEliminateTargetCoodina( xRound,  yRound,  oldColor)

    if self:checkEliminateActive(xRound, yRound) == false then
        return false;
    end
    local tempGridType = self:getMissionMatrix(xRound, yRound);
    return GameValue.mxStatusLogic:getMathchEnable(tempGridType) and self:getColorByType(tempGridType) == oldColor;
end


function MissionManager:isNeighbor(coordinaOne,coordinaTwo)

    local isNeighbor  = false;
    if coordinaOne.x == coordinaTwo.x then
    
        if math.abs(coordinaOne.y - coordinaTwo.y) == 1 then
        
            isNeighbor = true;
        end
    end
    if coordinaOne.y == coordinaTwo.y then
    
        if math.abs(coordinaOne.x - coordinaTwo.x) == 1 then
        
            isNeighbor = true;
        end
    end
    return isNeighbor;
end

function MissionManager:checkBrickCanCollectFruit( roundX,  roundY)

    local brickType = self:getBrickMatrix(roundX, roundY);
    if  brickType == MissionGrid.TYPE_FRUIT_PLATE then
    
        return true;
    end
    return false;
end



function MissionManager:checkEliminate()

    local canClearn = {};
    local gridColor = -1; 
    local enable = false;
    for yRound = 1, self.m_maxRow do
        gridColor = -1;
        for xRound = 1, self.m_maxCol do
        
            local tempGridType = self:getMissionMatrix(xRound, yRound);
            if GameValue.mxStatusLogic:getMathchEnable(tempGridType) == false then
            
                gridColor = -1;
                canClearn = {};
            end
            
            if GameValue.mxStatusLogic:getMathchEnable(tempGridType) ==true then
            
                if #canClearn == 0 then
                
                    local tempCoordina = Coordina.new();
                    tempCoordina.x = xRound;
                    tempCoordina.y = yRound;
                    gridColor = self:getColorByType(tempGridType);
                    table.insert(canClearn,#canClearn + 1,tempCoordina)
                
                else
                    local needContinue = false; --注意用的地方
                    enable = false;
                    local contType = 0;
                    local tempColor = self:getColorByType(tempGridType);
                    if gridColor == tempColor then
                    
                        local tempCoordina = Coordina.new();
                        tempCoordina.x = xRound;
                        tempCoordina.y = yRound;
                        table.insert(canClearn,#canClearn + 1,tempCoordina)
                        
                        if  self:checkEliminateActive(xRound + 1, yRound) == true then
                        
                            if self:checkEliminateTargetCoodina(xRound + 1, yRound - 1, gridColor)== true then
                            
                                enable = true;
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound + 1;
                                tempCoordina.y = yRound - 1;
                                table.insert(canClearn,#canClearn + 1,tempCoordina)
                                contType = 1;
                            
                            elseif self:checkEliminateTargetCoodina(xRound + 1, yRound + 1, gridColor) == true then
                            
                                enable = true;
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound + 1;
                                tempCoordina.y = yRound + 1;
                                table.insert(canClearn,#canClearn + 1,tempCoordina)
                                contType = 1;
                            
                            elseif self:checkEliminateTargetCoodina(xRound + 2, yRound, gridColor)== true then
                            
                                enable = true;
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound + 2;
                                tempCoordina.y = yRound;
                                table.insert(canClearn,#canClearn + 1,tempCoordina)
                                contType = 2;
                            end
                        end
                        --右面如果有不存在消除可能 则检测左方
                        if enable==false and self:checkEliminateActive(xRound - 2, yRound)== true then
                        
    
                            if self:checkEliminateTargetCoodina(xRound - 2, yRound - 1, gridColor)== true then
                            
                                enable = true;
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound - 2;
                                tempCoordina.y = yRound - 1;
                                table.insert(canClearn, 1,tempCoordina)
                                contType = -1;
                            
                            elseif self:checkEliminateTargetCoodina(xRound - 2, yRound + 1, gridColor) == true then
                            
                                enable = true;
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound - 2;
                                tempCoordina.y = yRound + 1;
                                 table.insert(canClearn, 1,tempCoordina)
                                contType = -1;
                            
                            elseif self:checkEliminateTargetCoodina(xRound - 3, yRound, gridColor)== true then
                            
                                enable = true;
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound - 3;
                                tempCoordina.y = yRound;
                                table.insert(canClearn, 1,tempCoordina)
                                contType = -2;
                            end
                        end
                   
                    else
                    
                        if xRound  < self.m_maxCol then
                        
                            local tempGridType = self:getMissionMatrix(xRound + 1, yRound);
                            if GameValue.mxStatusLogic:getMathchEnable(tempGridType) == false then
            
                                gridColor = -1;
                                canClearn = {};
                                needContinue = true
                            end
                            
                            if GameValue.mxStatusLogic:getMathchEnable(tempGridType) == true then
                            
                                if gridColor == self:getColorByType(tempGridType) then
                                
                                    local tempCoordina = Coordina.new();
                                    tempCoordina.x = xRound + 1;
                                    tempCoordina.y = yRound;
                                    table.insert(canClearn,#canClearn + 1,tempCoordina)
        
                                    if self:checkEliminateActive(xRound, yRound) == true then
                                    
                                        if self:checkEliminateTargetCoodina(xRound, yRound - 1, gridColor) == true then
                                        
                                            enable = true;
                                            local tempCoordina = Coordina.new();
                                            tempCoordina.x = xRound;
                                            tempCoordina.y = yRound - 1;
                                            table.insert(canClearn, 1 + 1,tempCoordina)
                                            
                                        
                                        elseif self:checkEliminateTargetCoodina(xRound, yRound + 1, gridColor) then
                                        
                                            enable = true;
                                            local tempCoordina = Coordina.new();
                                            tempCoordina.x = xRound;
                                            tempCoordina.y = yRound + 1;
                                            table.insert(canClearn, 1 + 1,tempCoordina)
                                            
                                        end
                                    end
                                end
                            end
                        end
                    end
    
                    if needContinue == false then
                    
                        if enable == false then
                        
                            canClearn = {};
                            local tempCoordina = Coordina.new();
                            tempCoordina.x = xRound;
                            tempCoordina.y = yRound;
                            table.insert(canClearn, #canClearn + 1,tempCoordina)
                            gridColor = tempColor;
                            
                        else
                            if enable == true then
                            
                                if math.abs(contType) == 2 then
                                     return canClearn;
                                end
                                if contType == 1 or contType == 0 then
                                
                                    for round = canClearn[2].x + 1, self.m_maxCol do
                                    
                                        local lastCoodina = Coordina.new();
                                        lastCoodina.y = canClearn[1].y;
                                        lastCoodina.x = round;
                                        if self:getColorByPst(lastCoodina.x, lastCoodina.y) == gridColor then                                    
                                            table.insert(canClearn, #canClearn + 1,lastCoodina)                                                                       
                                        else
                                        
                                            return canClearn;
                                        end
                                    end
                                end
                                return canClearn;
                            
                            else
                            
                                gridColor = -1;
                                canClearn.resize(0);
                            end
                        end
                    end
                end
            end
        end
    end


    --Y轴方向检测
    for xRound  = 1,self.m_maxCol do
    
        gridColor = -1;
        for yRound = self.m_maxRow, 1,-1 do
        
            local tempGridType = self:getMissionMatrix(xRound, yRound);

            if GameValue.mxStatusLogic:getMathchEnable(tempGridType) == false then
            
                gridColor = -1;
                canClearn = {};
               
            end
            
            if GameValue.mxStatusLogic:getMathchEnable(tempGridType) ==  true then
                if #canClearn == 0 then
                
                    local tempCoordina = Coordina.new();
                    tempCoordina.x = xRound;
                    tempCoordina.y = yRound;
                    gridColor = self:getColorByType(tempGridType);
                   
                    table.insert(canClearn,#canClearn + 1,tempCoordina)
                
                else
                    local needContinue = false; --注意用的地方
                    enable = false;
                    local contType = 0;-- >= 0正循环 < 0 负循环
                    local tempColor = self:getColorByType(tempGridType);
    
                    if gridColor == tempColor then
                    
                        local tempCoordina = Coordina.new();
                        tempCoordina.x = xRound;
                        tempCoordina.y = yRound;
                        table.insert(canClearn,#canClearn + 1,tempCoordina)
    
                        if self:checkEliminateActive(xRound, yRound - 1) == true then
                        
    
                            if self:checkEliminateTargetCoodina(xRound + 1, yRound - 1, gridColor) == true then
                            
                                enable = true;
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound + 1;
                                tempCoordina.y = yRound - 1;
                                table.insert(canClearn,#canClearn + 1,tempCoordina)
                                contType = 1;
                            
                            elseif self:checkEliminateTargetCoodina(xRound - 1, yRound - 1, gridColor) == true then
                            
                                enable = true;
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound - 1;
                                tempCoordina.y = yRound - 1;
                                table.insert(canClearn,#canClearn + 1,tempCoordina)
                                contType = 1;
                            
                            elseif self:checkEliminateTargetCoodina(xRound, yRound - 2, gridColor)== true then
                            
                                enable = true;
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound;
                                tempCoordina.y = yRound - 2;
                                table.insert(canClearn,#canClearn + 1,tempCoordina)
                                contType = 2;
                            end
                        end
    
                        --上面如果有不存在消除可能 则检测下方
                        if  enable == false and self:checkEliminateActive(xRound, yRound + 2) == true then
                        
    
                            if self:checkEliminateTargetCoodina(xRound + 1, yRound + 2, gridColor) then
                            
                                enable = true;
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound + 1;
                                tempCoordina.y = yRound + 2;
                                table.insert(canClearn, 1,tempCoordina)
                                contType = -1;
                            
                            --  ■    
                            --  ■
                            --□※
                            elseif self:checkEliminateTargetCoodina(xRound - 1, yRound + 2, gridColor) then
                            
                                enable = true;
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound - 1;
                                tempCoordina.y = yRound + 2;
                                table.insert(canClearn, 1,tempCoordina)
                                contType = -1;
                            
                            --  ■    
                            --  ■
                            --  ※
                            --  □
                            elseif self:checkEliminateTargetCoodina(xRound, yRound + 3, gridColor) then
                            
                                enable = true;
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound;
                                tempCoordina.y = yRound + 3;
                                table.insert(canClearn, 1,tempCoordina)
                                contType = -2;
                            end
                        end
                    
                    else
                    
                        --  ■
                        --□※□
                        --  ■
                        if yRound - 1 >= 1 then
                        
                            local tempGridType = self:getMissionMatrix(xRound, yRound - 1);
    
                            if GameValue.mxStatusLogic:getMathchEnable(tempGridType) == false then
                            
                                gridColor = -1;
                                canClearn = {};
                                needContinue = true;
                            
                            else
                                if gridColor == self:getColorByType(tempGridType) then
                                
                                    local tempCoordina = Coordina.new();
                                    tempCoordina.x = xRound;
                                    tempCoordina.y = yRound - 1;
                                   
                                    table.insert(canClearn, #canClearn + 1,tempCoordina)
        
                                    if self:checkEliminateActive(xRound, yRound) == true then
                                    
                                        if self:checkEliminateTargetCoodina(xRound + 1, yRound, gridColor) == true then
                                        
                                            enable = true;
                                            local tempCoordina = Coordina.new();
                                            tempCoordina.x = xRound + 1;
                                            tempCoordina.y = yRound;
                                            table.insert(canClearn,  1+ 1,tempCoordina)
                                        
                                        elseif self:checkEliminateTargetCoodina(xRound - 1, yRound, gridColor)== true then
                                        
                                            enable = true;
                                            local tempCoordina = Coordina.new();
                                            tempCoordina.x = xRound - 1;
                                            tempCoordina.y = yRound;
                                            table.insert(canClearn,  1 + 1,tempCoordina)
                                        end
                                    end
                                end
                            end
                        end
                    end
                    
                    if needContinue == false then
                        if  enable == false then
                        
                            canClearn =  {};
                            local tempCoordina = Coordina.new();
                            tempCoordina.x = xRound;
                            tempCoordina.y = yRound;
                            table.insert(canClearn,  #canClearn + 1,tempCoordina)
                            gridColor = tempColor;
                           
                        else
        
                            if enable == true then
                            
                                if math.abs(contType) == 2 then
                                    return canClearn;
                                end
                                
                                
                                if contType == 1 or contType == 0 then
                                
                                    
                                    for round = canClearn[2].y - 1, 1,-1 do
                                    
                                        local lastCoodina = Coordina.new();
                                        lastCoodina.x = canClearn[1].x;
                                        lastCoodina.y = round;
                                        if self:getColorByPst(lastCoodina.x, lastCoodina.y) == gridColor then
                                        
                                            table.insert(canClearn,  #canClearn + 1,lastCoodina)
                                            
                                        
                                        else
                                        
                                            return canClearn;
                                        end
                                    end
                                end
                                return canClearn;
                            
                            else
                            
                                gridColor = -1;
                                canClearn = {};
                            end
                        end
                    end
                end
            end
        end
    end
    
    if #canClearn < 3 then
    
        --检测彩虹球 和周边 powerUpPoweUp 任意一个可以被match的球球 2014-8-13 -----------------------------------------------------------------------------------
        canClearn = {};

        for yRound = self.m_maxRow,1,-1 do
        
            gridColor = -1;

            for xRound = 1, self.m_maxCol do
            
                local tempGridType = self:getMissionMatrix(xRound, yRound);
                local needContinue = false;

                if (GameValue.mxStatusLogic:getMathchEnable(tempGridType) == false or MissionGrid.INTERVAL_POWER_UP:includeValue(tempGridType) == false) and self:checkEliminateActive(xRound, yRound) == true then 
                
                    if #canClearn == 0 then
                    
                        tempGridType = self:getMissionMatrix(xRound, yRound);
                        if tempGridType == MissionGrid.PU_RAINBOW then
                        
                            enable = false;              
                            local tempCoordina = Coordina.new();
                            tempCoordina.x = xRound;
                            tempCoordina.y = yRound;
                            table.insert(canClearn,  #canClearn + 1,tempCoordina)
                            --检测左侧  
                            tempGridType = self:getMissionMatrix(xRound - 1, yRound);
                            if enable== false and GameValue.mxStatusLogic:getMathchEnable(tempGridType) then
                            
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound - 1;
                                tempCoordina.y = yRound;
                                table.insert(canClearn,  #canClearn + 1,tempCoordina)
                                enable = true;
                            end


                            --检测上侧  
                            tempGridType = self:getMissionMatrix(xRound, yRound - 1);
                            if enable== false and GameValue.mxStatusLogic:getMathchEnable(tempGridType) then
                            
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound;
                                tempCoordina.y = yRound - 1;
                                table.insert(canClearn,  #canClearn + 1,tempCoordina)
                                enable = true;
                            end

                            --检测右侧  
                            tempGridType = self:getMissionMatrix(xRound + 1, yRound);
                            if enable== false and GameValue.mxStatusLogic:getMathchEnable(tempGridType) then
                            
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound + 1;
                                tempCoordina.y = yRound;
                                table.insert(canClearn,  #canClearn + 1,tempCoordina)
                                enable = true;
                            end
                            --检测下侧  
                            tempGridType = self:getMissionMatrix(xRound, yRound + 1);
                            if enable == false and GameValue.mxStatusLogic:getMathchEnable(tempGridType) then
                            
                                local tempCoordina = Coordina.new();
                                tempCoordina.x = xRound;
                                tempCoordina.y = yRound + 1;
                                table.insert(canClearn,  #canClearn + 1,tempCoordina)
                                enable = true;
                            end

                            if enable == false then
                            
                                canClearn = {};
                                needContinue = true
                            
                            else
                            
                                if #canClearn< 2 then 
                                   -- canClearn = {};
                                    return canClearn;
                                end
                                break;
                            end
                        end

                    end
                    needContinue = true
                end
                if needContinue == false then
                    if #canClearn == 0 then
                    
                        local tempCoordina = Coordina.new();
                        tempCoordina.x = xRound;
                        tempCoordina.y = yRound;
                        local tempGridType = self:getMissionMatrix(xRound, yRound);
                        if GameValue.mxStatusLogic:getMathchEnable(tempGridType) and MissionGrid.INTERVAL_POWER_UP:includeValue(tempGridType) then
                        
                            table.insert(canClearn,  #canClearn + 1,tempCoordina)
                        end
                    
                    else
                    
                        local needContinue = false;
                        enable = false;
                        local tempCoordina = Coordina.new();
                        tempCoordina.x = xRound;
                        tempCoordina.y = yRound;
                        local tempGridType = self:getMissionMatrix(xRound, yRound);
                        
                        if enable == false and GameValue.mxStatusLogic:getMathchEnable(tempGridType) and MissionGrid.INTERVAL_POWER_UP:includeValue(tempGridType)
                            and tempCoordina:indexOf(canClearn) == -1 and self:isNeighbor(canClearn[1], tempCoordina) then
                       
    
                            table.insert(canClearn,  #canClearn + 1,tempCoordina)
                            enable = true;
                        end
    
    
                        --检测左侧      
                        local tempCoordina = Coordina.new();
                        tempCoordina.x = xRound - 1;
                        tempCoordina.y = yRound;
                        tempGridType = self:getMissionMatrix(xRound - 1, yRound);
    
                        if enable == false and GameValue.mxStatusLogic:getMathchEnable(tempGridType) and MissionGrid.INTERVAL_POWER_UP:includeValue(tempGridType)
                            and tempCoordina:indexOf(canClearn) == -1 and self:isNeighbor(canClearn[1], tempCoordina) then
                       
    
                            table.insert(canClearn,  #canClearn + 1,tempCoordina)
                            enable = true;
                        end
    
    
                        --检测上侧  
                        local tempCoordina = Coordina.new();
                        tempCoordina.x = xRound;
                        tempCoordina.y = yRound - 1;
                        tempGridType = self:getMissionMatrix(xRound, yRound - 1);
                        if enable == false and GameValue.mxStatusLogic:getMathchEnable(tempGridType) and MissionGrid.INTERVAL_POWER_UP:includeValue(tempGridType)
                            and tempCoordina:indexOf(canClearn) == -1 and self:isNeighbor(canClearn[1], tempCoordina) then
                       
    
                            table.insert(canClearn,  #canClearn + 1,tempCoordina)
                            enable = true;
                        end
    
    
                        --检测右侧  
                        local tempCoordina = Coordina.new();
                        tempCoordina.x = xRound + 1;
                        tempCoordina.y = yRound;
                        tempGridType = self:getMissionMatrix(xRound + 1, yRound);
                        if enable == false and GameValue.mxStatusLogic:getMathchEnable(tempGridType) and MissionGrid.INTERVAL_POWER_UP:includeValue(tempGridType)
                            and tempCoordina:indexOf(canClearn) == -1 and self:isNeighbor(canClearn[1], tempCoordina) then
                       
    
                            table.insert(canClearn,  #canClearn + 1,tempCoordina)
                            enable = true;
                        end
    
                        --检测下侧  
                        local tempCoordina = Coordina.new();
                        tempCoordina.x = xRound;
                        tempCoordina.y = yRound + 1;
                        tempGridType = self:getMissionMatrix(xRound, yRound + 1);
    
                        if enable == false and GameValue.mxStatusLogic:getMathchEnable(tempGridType) and MissionGrid.INTERVAL_POWER_UP:includeValue(tempGridType)
                            and tempCoordina:indexOf(canClearn) == -1 and self:isNeighbor(canClearn[1], tempCoordina) then
                       
    
                            table.insert(canClearn,  #canClearn + 1,tempCoordina)
                            enable = true;
                        end
    
                        if enable == false then
                        
                            canClearn={};
                            needContinue = true;
                        
                        else
                        
                            if #canClearn< 2 then
                                --canClearn = {};
                                return canClearn;
                            end
                            break;
                        end
                    end
                end
            end
        end
        --检测彩虹球 和周边 powerUpPoweUp 任意一个可以被match的球球 2014-8-13 -----------------------------------------------------------------------------------
    end
    if #canClearn< 2 then
         canClearn = {};
    end
    return canClearn;
end


return MissionManager;