--require "game.model.MissionGrid"
Interval = class("Interval")
function Interval:ctor(minVPar,maxVPar)
    self.minV = minVPar
    self.maxV = maxVPar
    return self
end

function Interval:includeValue(mapV)
    return (self.minV<= mapV and mapV<self.maxV)
end


function Interval:isBombo(mapV)
    return (mapV % 10 == MissionGrid.PU_KEY_BOMBO)
end

--/**
-- * 判断是否是大炸弹
-- * @param mapV （必须为POWERUP 区间的值）
-- * @return   bool 
-- */
function Interval:isBigBombo(mapV)
    return self:isBombo(mapV) and (math.floor((mapV % 100) / 10) == MissionGrid.PU_KEY_BOMBO)
end

--/**
-- * 是否是水平火箭
-- * @param mapV 
-- * @return   bool 
-- */
function Interval:isEliH(mapV)
    return (mapV % 10 == MissionGrid.PU_KEY_ROCKET_H and (mapV % 1000 > 6))
end

function Interval:isMagicCube(mapV)
    return (mapV-1000 >= 1 and mapV-1000 <=6)
end

---------------------------
--是否是竖直火箭
--@param mapV
--@return bool
function Interval:isEliV(mapV)
    return (mapV % 10 == MissionGrid.PU_KEY_ROCKET_V and (mapV % 1000 > 6))
end

--
--function Interval:isCandy(int mapV)
--{
--    return int(mapV / 10) % 10 == 1;
--}
--
--function Interval:isPopcorn(int mapV)
--{
--    return int(mapV / 10) % 10 == 2;
--}
--
--function Interval:isCake(int mapV)
--{
--    return int(mapV / 10) % 10 == 3;
--}
--
--function Interval:isFruit(int mapV)
--{
--    return int(mapV / 10) % 10 == 4;
--}