GameTimeDelay = {};

function GameTimeDelay:new(delay,onComplete,onCompleteParams)
    local timeDelay = {}  
    setmetatable(timeDelay,{__index=self}); -- 继承 self     
    timeDelay.m_delay = delay;
    timeDelay.m_onComplete = onComplete; 
    timeDelay.m_onCompleteParams = onCompleteParams; 
    
    timeDelay.m_done = false;
    return timeDelay;
    
end;

function GameTimeDelay:onWorldTimerRunHandler(spendTime)
    self.m_delay = self.m_delay - spendTime;
    if self.m_delay <= 0 then
    
        if self.m_onComplete ~= nil then
            
            self.m_onComplete(self.m_onCompleteParams);
           self.m_onComplete = nil;
        end
        
        self.m_done = true;
    end;
end;

function GameTimeDelay:clear()

    self.m_delay = nil;
    self.m_onComplete = nil; 
    self.m_onCompleteParams = nil; 
    self.m_done = false;
    
end


function GameTimeDelay:isComplete()
    return self.m_done;
end;