require "game/util/GameTimeDelay.lua"

GameTimeTween = class("GameTimeTween")

function GameTimeTween.create()
    local timeTween = GameTimeTween.new();
    timeTween.m_timeDelayList = {};
    
    return timeTween;
end;

function GameTimeTween:delayedCall(delay, onComplete,pamram)

    if onComplete == nil then return end;

    if  delay <= 0 then
        onComplete(pamram);
    else
        table.insert(self.m_timeDelayList,#self.m_timeDelayList+1,GameTimeDelay:new(delay,onComplete,pamram))
    end
    
    
   -- print("#self.m_timeDelayList-------------------",#self.m_timeDelayList)
    
end

function GameTimeTween:clear()

    local length = #self.m_timeDelayList;
    for round = 1,length do
        if self.m_timeDelayList[round] ~= nil then
            self.m_timeDelayList[round]:clear();
        end;
    end;
    self.m_timeDelayList = {};
end

function GameTimeTween:onWorldTimerRunHandler(spendTime)
    
    local length = #self.m_timeDelayList;
    
    
    if length > 0 then 
        
        local hasNull = false;
        
        for round = 1,length do
            local gameTimeDelay = self.m_timeDelayList[round];
            if gameTimeDelay ~= nil then 
                gameTimeDelay:onWorldTimerRunHandler(spendTime);
                if gameTimeDelay:isComplete() == true then
                   
                	if hasNull == false then hasNull = true end;
                end
            end
        end;
        
        
        if hasNull == true then
--            local count = 0;
--            for round = 0,length do
--                if self.m_timeDelayList[round] ~= nil then
--                    count = count+1;
--                else
--                    
--                    for index = round + 1,length do 
--                        if self.m_timeDelayList[index] ~= nil then
--                            count = count+1;
--                            self.m_timeDelayList[round] = self.m_timeDelayList[index];
--                            self.m_timeDelayList[index] = nil;
--                            break;
--                        end;
--                    
--                    end;
--                    
--                    if self.m_timeDelayList[round] == nil then 
--                        break;
--                    end;
--                end;
--            end;
            
            
           self.m_timeDelayList = self:resizeList();
        end;
    end
end

function GameTimeTween:resizeList()
    local tempList = {};
    local length = #self.m_timeDelayList;
    for round = 1,length do
        if self.m_timeDelayList[round]:isComplete() == false then
            table.insert(tempList,#tempList+1,self.m_timeDelayList[round]);
        end;
    end;
    return tempList;
end;

return GameTimeTween;