
local GameLayer = class("GameLayer", function()
    return cc.Layer:create();
end);




function GameLayer.create()
    local layer = GameLayer.new();
    return layer;
end


function GameLayer:init()
    
    
    self.m_backGround = cc.Node:create()
    self:addChild(self.m_backGround,0)
    self.m_backGround:setPosition(VisibleRect:center())


 
    
    
    
    self:addChild(GameValue.mxGridContainer,2);
    
--    self.m_topBoxBorder = BackBoxBorder.create( "tile/out.png",  "tile/in.png",  "tile/bg1.png",  "tile/bg2.png", true);
--    self.m_topBoxBorder:setAnchorPoint(0,0);
--    self:addChild(self.m_topBoxBorder);
    
    
    self.uiLayer = cc.Node:create();
    self:addChild(self.uiLayer,3)
    
    self:addChild(GameValue.mxGameEFT,4);
    
    self:initListener();
end;

function GameLayer:getUILayer()
    return self.uiLayer;
end;

function GameLayer:initListener()

    local touchBeginPoint = nil
    local function onTouchBegan(touch, event)
        local nodePoint = GameValue.mxGridContainer:convertTouchToNodeSpace(touch);
        if nodePoint.x >= 0 and nodePoint.x <= GameValue.mxGridContainer:getContentSize().width and nodePoint.y >= 0 and nodePoint.y <= GameValue.mxGridContainer:getContentSize().height then
        
            nodePoint = GameValue.mxGridContainer:transformNodePstToCartesianPst(nodePoint);
            return GameValue.mxGameControler:onTouchBegan(nodePoint);
            
       
        else
            
            GameValue.mxGameControler:onTouchBeganOut();
            return false;
        end
        return false;
     
       
    end

    local function onTouchMoved(touch, event)
        local nodePoint = GameValue.mxGridContainer:convertTouchToNodeSpace(touch);
        if nodePoint.x >= 0 and nodePoint.x <= GameValue.mxGridContainer:getContentSize().width and nodePoint.y >= 0 and nodePoint.y <= GameValue.mxGridContainer:getContentSize().height then
        
            nodePoint = GameValue.mxGridContainer:transformNodePstToCartesianPst(nodePoint);
            GameValue.mxGameControler:onTouchMoved(nodePoint);
        
        else
        
            GameValue.mxGameControler:onTouchMovedOut();
        end
    end

    local function onTouchEnded(touch, event)
        local nodePoint = GameValue.mxGridContainer:convertTouchToNodeSpace(touch);
        if nodePoint.x >= 0 and nodePoint.x <= GameValue.mxGridContainer:getContentSize().width and nodePoint.y >= 0 and nodePoint.y <= GameValue.mxGridContainer:getContentSize().height then
        
            nodePoint = GameValue.mxGridContainer:transformNodePstToCartesianPst(nodePoint);
            GameValue.mxGameControler:onTouchEnded(nodePoint);
        
        else
        
            GameValue.mxGameControler:onTouchEndedOut();
        end
    end

    local listener = cc.EventListenerTouchOneByOne:create()
    listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN )
    listener:registerScriptHandler(onTouchMoved,cc.Handler.EVENT_TOUCH_MOVED )
    listener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED )
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener, self)
end;




function GameLayer:gameStart()

    GameValue.mxGridContainer:gameStart();
    
    if self.m_backImage == nil then
        self.m_backImage = cc.Sprite:create("ui/ingame/gameBackground.jpg")
        self.m_backGround:addChild(self.m_backImage)
    end
    
    if self.m_backBoxBorder== nil then
        local backbox = require ("game.view.extensions.BackBoxBorder")
        self.m_backBoxBorder = backbox.create( "tile/out.png",  "tile/in.png",  "tile/bg1.png",  "tile/bg2.png", true);
        self:addChild(self.m_backBoxBorder,1); 
        self.m_backBoxBorder:setAnchorPoint(0,0);     
    end
    
    
   
   
    
    self.m_backBoxBorder:clear()
    self.m_backBoxBorder:refresh(GameValue.mxMissionManager:getBrickList())
    self.m_backBoxBorder:setPosition(GameValue.mxGridContainer:getPositionX()  - Config.rimW , GameValue.mxGridContainer:getPositionY()  - Config.rimH )

    self:setVisible(true);

end;


function GameLayer:getGameBackBoxBorder()
    if self.m_backBoxBorderMask == nil then
        local backbox = require ("game.view.extensions.BackBoxBorder")
        self.m_backBoxBorderMask = backbox.create( "tile/out.png",  "tile/in.png",  "tile/bg1.png",  "tile/bg2.png", true);
        self.m_backBoxBorderMask:retain();   
        self.m_backBoxBorderMask:refresh(GameValue.mxMissionManager:getBrickList())
        self.m_backBoxBorderMask:setPosition(GameValue.mxGridContainer:getPositionX() - Config.rimW, GameValue.mxGridContainer:getPositionY()- Config.rimH)   
    end
    
   
    
    return self.m_backBoxBorderMask;
end


function GameLayer:getGameBackBoxBorderForGridContainer()
    if self.m_backMask == nil then
        local backbox = require ("game.view.extensions.BackBoxBorder")
        self.m_backMask = backbox.create( "tile/out.png",  "tile/in.png",  "tile/bg1.png",  "tile/bg2.png", true, true);
        self.m_backMask:retain();   
        self.m_backMask:refresh(GameValue.mxMissionManager:getBrickList())
        self.m_backMask:setAnchorPoint(0,0);
        self.m_backMask:setPosition(-10,-8); 
    end

    return self.m_backMask;
end

function GameLayer:exitGame()
    self.m_backBoxBorder:clear();
    
    if self.m_backBoxBorderMask~=nil then
        self.m_backBoxBorderMask:clear();
        self.m_backBoxBorderMask:release();
        
        self.m_backBoxBorderMask = nil;
    end
    
    if self.m_backMask~= nil then
        
        self.m_backMask:clear();
        self.m_backMask:release();
        self.m_backMask = nil;
    end;
    GameValue.mxGridContainer:exitGame();
    
    self:setVisible(false);
   
end;


return GameLayer;