local GridContainer = class("GridContainer",function()
	return cc.Node:create();
end)


function GridContainer:ctor()
    
    
    
end;

function GridContainer.create()
    local container = GridContainer.new();
  
    return container;
end;


function GridContainer:gameStart()
    self.m_maxCol = GameValue.mxMissionManager:getMaxCol();
    self.m_maxRow = GameValue.mxMissionManager:getMaxRow();
    self.contentWidth = Config.rimW + self.m_maxCol * Config.tiledWidth + Config.rimW;
    self.contentHeight = Config.rimH + self.m_maxRow * Config.tiledHeight + Config.rimH;
    
    
    self:setContentSize(self.contentWidth,self.contentHeight);
    self:setAnchorPoint(0,0);

    local size  = cc.Director:getInstance():getOpenGLView()
   
    self:setPosition((size:getVisibleSize().width - self.contentWidth)* 0.5, (size:getVisibleSize().height - self.contentHeight)* 0.5 - 48);
    
    
    self:brickInit()
    self:gridInit()
    
end


function GridContainer:brickInit()

    self.m_brickBox = cc.Node:create();
    self:addChild(self.m_brickBox);
    
    local  grid = nil;
    self.m_brickMap = {};
   
     for yRound = 1,self.m_maxRow do 
        self.m_brickBox[yRound] = {};
        for xRound = 1,self.m_maxCol do
            self.m_brickBox[yRound][xRound] = nil;
            local brickType = GameValue.mxMissionManager:getBrickMatrix(xRound, yRound);
            if brickType > 0 then 
                local tempGrid = self:addNewBrickCellBy(brickType, xRound, yRound);
                tempGrid:setCoordina(xRound, yRound);
                self:setBrickMatrix(tempGrid, xRound, yRound);
                
                
            end;

        end;
    end;

end;


function GridContainer:gridInit()
    
    self.m_gridBox = cc.ClippingNode:create()
    self:addChild(self.m_gridBox);
   
    
    
    self.m_gridBox:setContentSize(GameValue.mxGameLayer:getGameBackBoxBorderForGridContainer():getContentSize());
    self.m_gridBox:setStencil(GameValue.mxGameLayer:getGameBackBoxBorderForGridContainer());
    self.m_gridBox:setInverted(false);
    self.m_gridBox:setAlphaThreshold(0);
    
    self.m_gridMap = {};
    for yRound = 1,self.m_maxRow do 
        self.m_gridMap[yRound] = {};
        for xRound = 1,self.m_maxCol do
            self.m_gridMap[yRound][xRound] = nil;
            local gridType = GameValue.mxMissionManager:getMissionMatrix(xRound, yRound);
            if gridType ~= MissionGrid.BLANK and gridType ~= MissionGrid.NONE and gridType ~= MissionGrid.BORDER then 
                local tempGrid = self:addNewItemCellBy(gridType, xRound, yRound);
                tempGrid:setCoordina(xRound, yRound);
                self:setCellMatrix(tempGrid, xRound, yRound);
                
                
            end;
            -- if (MissionGrid::INTERVAL_BOSS:includeValue(gridType))continue;
            
           
        end;
    end;
    
 
 
end

function GridContainer:setBrickMatrix(brick,  roundX,  roundY)
    
    if self.m_brickMap[roundY] == nil then self.m_brickMap[roundY] = {} end;
   
    self.m_brickMap[roundY][roundX] = brick;
end



function GridContainer:getBrickMatrix( roundX,  roundY)

    if roundY == nil or roundY == nil then
        print("string")
        
    end
    if roundY < 1 or roundX < 1 or roundY > self.m_maxRow or roundX > self.m_maxCol then 
        return nil 
    end;
    if self.m_brickMap[roundY] == nil then
        return nil;
    end
    
    
    return self.m_brickMap[roundY][roundX];
end


function GridContainer:setCellMatrix( grid,  roundX,  roundY)
     if roundY < 1 or roundX < 1 or roundY > self.m_maxRow or roundX > self.m_maxCol then 
        return nil 
    end;
    if self.m_gridMap[roundY] == nil  then self.m_gridMap[roundY] = {} end;
    
    if grid == nil then grid = 0 end;
    
    if self.m_gridMap[roundY][roundX] ~= 0 and self.m_gridMap[roundY][roundX] ~= nil and  grid ~= 0 then
    
        self.m_gridMap[roundY][roundX]:setVisible(false);
	print("[GridContainer]-- 有问题")
       -- PlatformLuaShowNativePopDialog("roundY="..roundY,"roundX="..roundX,"ok","");
        
    end;
    
    self.m_gridMap[roundY][roundX] = grid;
end

function GridContainer:getCellMatrix( roundX,  roundY)


    if roundY < 1 or roundX < 1 or roundY > self.m_maxRow or roundX > self.m_maxCol then 
        return nil 
    end;
  
    if self.m_gridMap[roundY][roundX] == 0 then
    
        return nil;
    end;
    return self.m_gridMap[roundY][roundX];
end


function GridContainer:checkTransport(oldPst, newPst)


    local targetCoordina = Coordina.new();
    targetCoordina.x = -1;
    targetCoordina.y = -1;
    local firstTempCell = self:getCellMatrix(oldPst.x,oldPst.y);
    if firstTempCell ~= nil then
        
        if GameValue.mxMissionManager:checkBrickCanCollectFruit(oldPst.x, oldPst.y) and MissionGrid.isFruit(firstTempCell:getGridType()) then
        
            
            targetCoordina.x = oldPst.x;
            targetCoordina.y = oldPst.y;
            return targetCoordina;
        end
    end

    local secondTempCell = self:getCellMatrix(newPst.x,newPst.y);
    if secondTempCell~= nil then
    
        if GameValue.mxMissionManager:checkBrickCanCollectFruit(newPst.x, newPst.y) and MissionGrid.isFruit(secondTempCell:getGridType()) then
            targetCoordina.x = newPst.x;
            targetCoordina.y = newPst.y;
            
            return targetCoordina;
        end
    end

    return targetCoordina;
    
end


function GridContainer:addNewItemCellBy( gridType,  fromX,  fromY)

    local grid = GameValue.mxGridFactroy:creatItemGrid(gridType);

    if grid ~= nil then
    
        grid:setPosition(self:transformGridCoordinaToNodePst(fromX, fromY).x,self:transformGridCoordinaToNodePst(fromX, fromY).y);
        self.m_gridBox:addChild(grid);
        grid:playAppearMotion();
    end
    return grid;
end

function GridContainer:addNewBrickCellBy(brickType,  fromX,  fromY)

   local brickCell = GameValue.mxGridFactroy:creatBrickCell(brickType);

    if brickCell ~= nil then
        brickCell:setPosition(self:transformGridCoordinaToNodePst(fromX, fromY).x,self:transformGridCoordinaToNodePst(fromX, fromY).y);
        self.m_brickBox:addChild(brickCell);
        brickCell:play1AppearMotion();
    end
    return brickCell;
end

function GridContainer:getNeedDropAndUpdateCellPostion(spendTime)
    local needCheckDrop = false;
    local tempCell = nil;
    
    for yRound = 1,self.m_maxRow do 
        
        for xRound = 1,self.m_maxCol do
            tempCell = self.m_gridMap[yRound][xRound];
            if tempCell~= nil and tempCell ~= 0 then
                
                tempCell:onWorldTimerRunHandler(spendTime);   -- attempt to call method 'onWorldTimerRunHandler' (a nil value) 2015-5-27 可能报错
                if tempCell:getArrive() then
                    if needCheckDrop == false then needCheckDrop = true end;
                    if tempCell:getDropOut() then 

                    else
                
                        GameValue.mxGameControler:onDropCompleteHandler(tempCell);
                    end
                
                end;
            end;
        end
        
    end
    if needCheckDrop == true then
        MainValue.mxGameManager:playSoundEffect(GameSoundEffectId.BLOCK_STOP);
    end
    return needCheckDrop;
   
    
end

function GridContainer:swapPlaces( m_oldPst,  m_newPst,  m_isPlayer)
    
    local oldPst = Coordina.new();
    oldPst.x = m_oldPst.x;
    oldPst.y = m_oldPst.y;
    
    local newPst = Coordina.new();
    newPst.x = m_newPst.x;
    newPst.y = m_newPst.y;
    
    local isPlayer = m_isPlayer
    
   
    local startItemCell = self:getCellMatrix(oldPst.x,oldPst.y);
    local targetItemCell = self:getCellMatrix(newPst.x,newPst.y);

    if startItemCell == nil or targetItemCell == nil then
        return;
    end

    startItemCell:swapMoveTo(newPst.x,newPst.y);
    targetItemCell:swapMoveTo(oldPst.x,oldPst.y);
    
    local function delayC()
    	startItemCell:setCoordina(newPst.x,newPst.y);
        targetItemCell:setCoordina(oldPst.x,oldPst.y);

       
        self.m_gridMap[newPst.y][newPst.x] = startItemCell;
        self.m_gridMap[oldPst.y][oldPst.x] = targetItemCell;
        
        GameValue.mxGameTimeTween:delayedCall(0.01,function()
            GameValue.mxGameControler:onSwapEndHandler(oldPst, newPst, isPlayer);
        end
        )
    
       
    end
    
    GameValue.mxGameTimeTween:delayedCall(Config.swapDuration,delayC,{startItemCell, targetItemCell, oldPst, newPst, isPlayer})

    
end


function GridContainer:setCellVisibleFalse(indexX,indexY)
    if indexY < 1 or indexX < 1 or indexY > self.m_maxRow or indexX > self.m_maxCol then 
        return 
    end
    if self.m_gridMap[indexY]~=nil and self.m_gridMap[indexY][indexX]~=nil then
        self.m_gridMap[indexY][indexX]:setVisible(false)
    end
    
end
	


function GridContainer:washCellPst(itemGrid)

    
    local deleyTime = Config.swapDuration;

    local toPst = self:transformGridCoordinaToNodePst(itemGrid:getCoordina().x, itemGrid:getCoordina().y);
    
    local scaleAction = cc.Sequence:create(cc.ScaleTo:create(deleyTime * 0.5, 1.2), cc.ScaleTo:create(deleyTime * 0.5, 1));
    local moveAction = cc.MoveTo:create(deleyTime, cc.p(toPst.x,toPst.y));
  
    itemGrid:stopAllActions();
    itemGrid:runAction(scaleAction); 
    itemGrid:runAction(moveAction); 

   
  
end




function GridContainer:playClearEffect(id, coordina)

    GameValue.mxGameEFT:playClearEffect(id,self:transformGridCoordinaToRootPst(coordina.x,coordina.y));
end;

function GridContainer:playClearRocket3Eft( id, coordina,  rocketDir)

    local tempPoint = self:transformGridCoordinaToRootPst(coordina.x, coordina.y);

    if rocketDir == MissionGrid.PU_KEY_ROCKET_H then
    
        tempPoint.y = tempPoint.y - Config.tiledHeight;
        GameValue.mxGameEFT:playClearEffect(id, tempPoint);
        tempPoint.y = Config.tiledHeight +  tempPoint.y;
        GameValue.mxGameEFT:playClearEffect(id, tempPoint);
        tempPoint.y = Config.tiledHeight +  tempPoint.y;
        GameValue.mxGameEFT:playClearEffect(id, tempPoint);
    
    elseif rocketDir == MissionGrid.PU_KEY_ROCKET_V then
    
        tempPoint.x = tempPoint.x - Config.tiledWidth;
        GameValue.mxGameEFT:playClearEffect(id, tempPoint);
        tempPoint.x = Config.tiledWidth + tempPoint.x;
        GameValue.mxGameEFT:playClearEffect(id, tempPoint);
        tempPoint.x = Config.tiledWidth +  tempPoint.x;
        GameValue.mxGameEFT:playClearEffect(id, tempPoint);
    end

end

function GridContainer:showFlyFaSheToAim(rainBowCoordina,aimCoordina)
    local startPoint = self:transformGridCoordinaToRootPst(rainBowCoordina.x, rainBowCoordina.y);
    local endPoint = self:transformGridCoordinaToRootPst(aimCoordina.x, aimCoordina.y);
    MainValue.mxEffectManager:showFlyFaSheToAim(startPoint.x,startPoint.y,endPoint.x,endPoint.y)
end

function GridContainer:playCollectGridEft( gridType, coordina,  pst, onComplete)

   
    local iconName = string.format("ui/target/%d.png", gridType);
    local icon = cc.Sprite:create(iconName)
    
    local from = self:transformGridCoordinaToRootPst(coordina.x, coordina.y);
    
    if gridType == MissionGrid.PD_FRUIT_BERRIES then
    
        
        GameValue.mxGameEFT:colletFruitEft(gridType, from);
        from.y = from.y - 30;
        GameValue.mxGameEFT:collectFly(icon, from, pst, onComplete);
    
    else
    
        GameValue.mxGameEFT:collectFly(icon, from, pst, onComplete);
    end 
    
end


function GridContainer:playEliFlyUp(gridType, coordina)
    GameValue.mxGameEFT:playEliFlyUp(gridType,self:transformGridCoordinaToRootPst(coordina.x,coordina.y));
end;

function GridContainer:playEliFlyDown(to)
    GameValue.mxGameEFT:playEliFlyDown(self:transformGridCoordinaToRootPst(to.x,to.y))
end

function GridContainer:playStepChangeIntoPowerUpEft(toCoordina, duration, onComplete)

    local from = cc.p( VisibleRect:center().x,  VisibleRect:center().y + 430)
    local target = self:transformGridCoordinaToRootPst(toCoordina.x, toCoordina.y);
    GameValue.mxGameEFT:changeMovesToPowerUp(from, target, duration, onComplete);
end

function GridContainer:playRainbowFly(fromCoordina, toCoordina)

    local from = self:transformGridCoordinaToRootPst(fromCoordina.x, fromCoordina.y);
    local target = self:transformGridCoordinaToRootPst(toCoordina.x, toCoordina.y);
   -- GameValue.mxGameEFT:playRainbowFly(from, target, 0.2);
end

function GridContainer:playPropUse( id,coordina)

    local positon = self:transformGridCoordinaToRootPst(coordina.x, coordina.y);
    
    GameValue.mxGameEFT:playPropUse(id, positon);
end

--手套选择
function GridContainer:playGloveUse(coordina,index,dir)
    local positon = self:transformGridCoordinaToRootPst(coordina.x, coordina.y);
    GameValue.mxGameEFT:playGloveUse(positon,index, dir);
end

--取消手套选择
function GridContainer:cancelPlayGloveUse(index)
    GameValue.mxGameEFT:cancelPlayGloveUse(index);
end;


function GridContainer:transformGridCoordinaToNodePst(oldx,oldy)
    local x = oldx-1;
    local y = oldy-1;
    return {x=Config.gridOffsetX + x*Config.tiledWidth, y=self:getContentSize().height - (y*Config.tiledHeight + Config.gridOffsetY)};

end;

function GridContainer:transformNodePstToCartesianPst(point)
    return {x = point.x - Config.rimW , y = self:getContentSize().height - point.y - Config.rimH};
end

function GridContainer:transformGridCoordinaToRootPst(oldx,oldy)

    local x = oldx-1;
    local y = oldy-1;
    return {x= self:getPositionX() + Config.gridOffsetX + x*Config.tiledWidth, y =self:getPositionY() + self:getContentSize().height - (y*Config.tiledHeight + Config.gridOffsetY)};
end


function GridContainer:transformBossCoordinaToNodePst(oldx,oldy)

    local x = oldx-1;
    local y = oldy-1;
    return {x = Config.gridOffsetX + (x + 0.5)*Config.tiledWidth, y =self:getContentSize().height - ((y + 0.5)*Config.tiledHeight + Config.gridOffsetY)};
end

function GridContainer:exitGame()
    self:removeAllChildren();
    self:stopAllActions();
    self.m_brickMap = {};
    self.m_brickMap = {};
end;

return GridContainer;