local BrickCell = class("BrickCell",function()
    return cc.Node:create();
end)


function BrickCell:ctor()


end;

function BrickCell.create()
    local cell = BrickCell.new()
    return cell;
end

function BrickCell:init(itemType,anm)


    self.m_gridType = itemType;
    self.m_armature = anm;

    self:addChild(self.m_armature);

 
    self.m_coordina = Coordina.new();
    self.m_coordina.x = 0;
    self.m_coordina.y = 0;
    
    self.m_volumeCoordinaList = {};
   
    self.m_injured = true;

    local function m_animationEvent(armatureBack,movementType,movementID)


        self:animationEvent(armatureBack,movementType,movementID)
    end
    self.m_armature:getAnimation():setMovementEventCallFunc(m_animationEvent);

end

function BrickCell:play1AppearMotion()

    self.m_armature:getAnimation():play("1", -1, 0);

end
function BrickCell:play2RestMotion()

    self.m_armature:getAnimation():play("2", -1, -1);

end
function BrickCell:play3ClearMotion()

    self:destroy();
end

function BrickCell:destroy()

    if self.m_armature ~= nil then 
        self.m_armature:getAnimation():stop();
        self.m_armature:removeFromParent(false);
    end;

    self:stopAllActions();

    self:removeFromParent(false)
end

function BrickCell:getGridType()
    return self.m_gridType;
end;

function BrickCell:setCoordina(xPst,yPst)

    self.m_coordina.x = xPst;
    self.m_coordina.y = yPst;

    self.m_volumeCoordinaList = {};
    for yRound = yPst,  yPst + 1 do
    
        for xRound = xPst, xPst + 1 do
               
            local tempCoordina = Coordina.new();
            tempCoordina.x = xRound;
            tempCoordina.y = yRound;
            
            table.insert(self.m_volumeCoordinaList,tempCoordina)
           
        end
    end
end

function BrickCell:getCoordina()
    
    return self.m_coordina;
end

function BrickCell:animationEvent(armatureBack,movementType,movementID)

    if movementType == ccs.MovementEventType.complete then
        if movementID == "1" then
            self:play2RestMotion();
        end
        if movementID == "3" then
            self:destroy();
        end
    end
end;

return BrickCell