require "engine.core.VisibleRect"
local GameEffectManager = class("GameEffectManager",function()
    return cc.Node:create();
end)

function GameEffectManager.create()
    local gameEffectManager = GameEffectManager.new();
    return gameEffectManager;
end;


function GameEffectManager:colletFruitEft()

end;

function GameEffectManager:playClearEffect(id,position)
    
    if MissionGrid.INTERVAL_POWER_UP:includeValue(id) == true then
    
        if MissionGrid.isEli(id) then
        
            return self:playRocketFly(id, position);
        
        elseif MissionGrid.isBombo(id) then
            local realId = id;
            if realId == 2001 then
            
                realId = 2401;
            end
            self:playEft(realId, position);
            self:playParticle(id, position, 0.3);
            return nil;
        end
    
    else
        id = 200
        return self:playEft(id, position):setRotation(math.random(0,360));
    end
    
end

function GameEffectManager:playParticle(  id , position ,  delayTime )

    if delayTime~=nil and delayTime > 0 then
    
        local particleId = id
        local particleP = {x = position.x, y = position.y}
        GameValue.mxGameTimeTween:delayedCall(delayTime,function()
           self:internalPlayParticle( particleId , particleP );
        end
        )           
       
    else
    
        self:internalPlayParticle( id , position );
    end
end

function GameEffectManager:internalPlayParticle(  id ,  position )

   
    local particle = cc.ParticleSystemQuad:create(string.format("armature/inGameArmature/effect/particle%d.plist",id))
    particle:setPosition(position.x,position.y)
   
    self:addChild( particle );

    return particle;
end

function GameEffectManager:playRocketFly(id, position,callBack, delay)

    local armatureName,animationName = self:getRocketFlyArmature(id);
    
    local left = self:internalPlay(armatureName, animationName, position, nil, 0.1);
    local right = self:internalPlay(armatureName, animationName, position, nil, 0.1);

    local realId = math.floor(id / 100) * 100 + 1;
--    if realId == 2002 or realId == 2003 then
--        realId = id + 400;
--    end
    
    local armature = self:playEft(realId, position);
 
    if MissionGrid.isEliH( id ) then
    
        if right ~= nil then
        
            right:setRotation( 180 );
        end
    
    elseif MissionGrid.isEliV( id ) then
    
        if left~= nil then
        
            left:setRotation( 90 );
        end
        if right ~= nil then
        
            right:setRotation( -90 );
        end
    end

    
end



function GameEffectManager:playEft(id, position,callBack, delay)
    local armatureName,animationName = self:getArmature(id);
    return self:internalPlay(armatureName, animationName, position, callBack, delay);
end


function GameEffectManager:internalPlay(armatureName, animationName, position, callBack, delay)
    
    if armatureName~=nil and  animationName ~= nil then 
               
        local armature = ccs.Armature:create(armatureName);
            
        self:addChild( armature );
        armature:setPosition(position.x,position.y);
        
        if delay ~= nil and delay > 0 then
            
            local tempAnimationName = animationName
            GameValue.mxGameTimeTween:delayedCall(delay,function()
            
                armature:getAnimation():play(tempAnimationName, -1, 0);
            end
            )           
        else
        
            armature:getAnimation():play(animationName, -1, 0);
        end
        
        
        
        local function m_animationEvent(armatureBack,movementType,movementID)
            if movementType == ccs.MovementEventType.complete then
                if callBack~=nil then
                    callBack()
                end
                
                if armature ~= nil then              
                    armature:getAnimation():stop();
                    armature:removeFromParent(false);
                    armature = nil; 
                end
            end
        end
        
        armature:getAnimation():setMovementEventCallFunc(m_animationEvent);

       return armature;
    end
    
end

function GameEffectManager:playRainbowFly( position ,target ,  duration )

    local armature = ccs.Armature:create( "eft1000_1_5" );
    
    self:addChild( armature );
    armature:setPosition( position.x, position.y);
    armature:getAnimation():play("1", -1, -1);
    
    local function m_animationEvent(armatureBack,movementType,movementID)
        if movementType == ccs.MovementEventType.complete then
            if movementID == "1" then
                armature:getAnimation():play("2", -1, -1);
            elseif movementID == "2" then
               -- armature:remove
            end
            
            
        end
    end
    
    armature:getAnimation():setMovementEventCallFunc(m_animationEvent);

  

--    Action* move = moveTo( duration , target )+callFunc( [this , armature]()
--    {
--        ParticleSystemQuad* particle = ParticleSystemQuad::create( "armature/inGameArmature/effect/Particle1000.plist" );
--        armature->addChild( particle );
--    } );
--
--    Action* action = move + callFunc( [this , armature , target]()
--    {
--        CCLOG( "callFunc" );
--        internalPlay( "eft1000_2" , "1" , target , nullptr );
--        crazy( armature ).play( "3" ).removeSelfOnPlayEnd();
--    } );
--
--
--    
--    armature->runAction( action );
end

function GameEffectManager:playPropUse( id, position)

    local armatureName,animationName = self:getPropUseArmature(id);
    return self:internalPlay(armatureName, animationName, position);
end


function GameEffectManager:playEliFlyUp(gridType,from)
    if self.colorIcons == nil then
        self.colorIcons = {}
    end
    local iconName = string.format("ui/target/%d.png", gridType);
    local icon = cc.Sprite:create(iconName)
    if icon ==nil then
        print("[GameEffectManager]--playEliFlyUp()icon is nil ")
        return
    end
    local toPst = Util:deepcopy(from)
    toPst.y = from.y + 280
    icon:setPosition(from)
    self:addChild(icon)
    table.insert(self.colorIcons,icon)
    local spawnAction = cc.Spawn:create(
     cc.EaseIn:create(cc.MoveTo:create(Config.flyUpTime,cc.p(toPst.x,toPst.y)),0.2)
    ,cc.EaseIn:create(cc.ScaleTo:create(Config.flyUpTime, 1.2,1.2),0.2)
    )
--    local moveAction = cc.Sequence:create()
    icon:runAction(spawnAction)
end

function GameEffectManager:playEliFlyDown(toPst)
    if self.colorIcons~=nil and table.maxn(self.colorIcons) >0 then
        local len = table.maxn(self.colorIcons)
                
        for index = 1, len do
            local tarIcon =  self.colorIcons[index]
            local spawnAction = cc.Spawn:create(cc.MoveTo:create(Config.flyDownTime,cc.p(toPst.x,toPst.y)),cc.ScaleTo:create(Config.flyDownTime, 0,0))
            tarIcon:runAction(spawnAction)
        end
        
        GameValue.mxGameTimeTween:delayedCall(Config.flyDownTime + 0.2,function()
            for index = 1, len do
                local object =  self.colorIcons[index]
                if object~= nil then
                    object:stopAllActions()
                    object:removeFromParent(false)
                    object = nil
                end
            end
            self.colorIcons = nil
        end)
    end
end

function GameEffectManager:collectFly( object , from , to,onComplete) 

    object:setPosition( from );
    self:addChild( object );
    local duration = Config.flyTimeForCollectAim;
    local bezier = {       
        cc.p(from.x - 300 , from.y),
        cc.p(( from.x + to.x ) / 2 , to.y),
       
    }

    local callFun = function()
        if onComplete~= nil then
            onComplete();
        end;
        
        if object~= nil then
            object:stopAllActions();
            object:removeFromParent(false);
            object = nil
        end;
        
        
    end;
    
    --local bezierAction = cc.BezierTo:create(duration,bezier) 
    
   
    local moveAction = cc.Sequence:create(cc.MoveTo:create(duration,cc.p(to.x,to.y)),cc.CallFunc:create(callFun))
   
    local scaleAction = cc.Sequence:create(cc.ScaleTo:create(0.2 * 0.5, 1.2), cc.ScaleTo:create(0.2 * 0.5, 1));
    
    
    local spawn = cc.Spawn:create(moveAction, scaleAction)  
    

    --object:runAction(bezierAction)
--    object:runAction(moveAction)                
--    object:runAction(scaleAction)  
    object:runAction(spawn)      
  
 
end



function GameEffectManager:changeMovesToPowerUp(from, target,  duration,  func)

    local armature = ccs.Armature:create("eft_final2");
    self:addChild(armature);

--    float len_y = target.y - from.y;
--    float len_x = target.x - from.x;
--
--    float tan_yx  = abs(len_y) / abs(len_x);
--    float m_angle = 0;
--    if (len_y > 0 && len_x < 0) {
--        //m_angle = atan(tan_yx) * 180 / M_PI - 90;
--    }
--    else if (len_y > 0 && len_x > 0) {
--        //m_angle = 90 - atan(tan_yx) * 180 / M_PI;
--    }
--    else if (len_y < 0 && len_x < 0) {
--        //m_angle = -atan(tan_yx) * 180 / M_PI - 90;
--    }
--    else if (len_y < 0 && len_x > 0) {
--        //m_angle = atan(tan_yx) * 180 / M_PI + 90;
--    }
    
    armature:setPosition(from.x,from.y)
    local callFun = function()
        if func~= nil then
            func();
        end;

        if armature~= nil then
            armature:stopAllActions();
            armature:removeFromParent(true);
            armature = nil
        end;


    end;
   
    local moveAction = cc.Sequence:create(cc.MoveTo:create(duration,cc.p(target.x,target.y)),cc.CallFunc:create(callFun))
    armature:runAction(moveAction);
end

--手套选择
function GameEffectManager:playGloveUse(postion,index, dir)
   if index == 1 then
        MainValue.mxGameManager:removeItemAni();
        self.firstGloveUseArm = ccs.Armature:create("goods" .. BoosterID.PROP_GLOVE)
        self:addChild(self.firstGloveUseArm);
        self.firstGloveUseArm:setPosition(postion.x,postion.y);
        self.firstGloveUseArm:getAnimation():play("3", -1, 1);
   elseif index == 2 then

        self.secondGloveUseArm = ccs.Armature:create("goods" .. BoosterID.PROP_GLOVE);
        self:addChild(self.secondGloveUseArm);
        self.secondGloveUseArm:setPosition(postion.x,postion.y);
        local function clean(armature, moveEventType, ...)
            if moveEventType == ccs.MovementEventType.complete then
                armature:getAnimation():stop()
                armature:removeFromParent(true)
            end
        end
        self.secondGloveUseArm:getAnimation():setMovementEventCallFunc(clean)
        print("GameEffectManager-playGloveUse()-dir::"..dir)
        self.secondGloveUseArm:getAnimation():play(dir, -1, 0);
   end;
   
   
end

--取消手套选择
function GameEffectManager:cancelPlayGloveUse(index)
    if index == 1 then
        if self.firstGloveUseArm ~= nil then
            self.firstGloveUseArm:stopAllActions();
            self.firstGloveUseArm:removeFromParent(true);
            self.firstGloveUseArm = nil
        end;
    elseif index == 2 then
--        if self.secondGloveUseArm ~= nil then
--            
--            self.secondGloveUseArm:stopAllActions();
--            self.secondGloveUseArm:removeFromParent(true);
--            self.secondGloveUseArm = nil
--        end;
    end
end;


function GameEffectManager:showFontEft(armatureName)

    


    if armatureName == "" then 
        return;
    end;


    local armatureDataName = "1";

    self:internalPlay(armatureName, armatureDataName, cc.p(VisibleRect:center().x,VisibleRect:center().y + 30));
end



function GameEffectManager:playSweetFinalMotion()
	
    local armature = ccs.Armature:create("sweet_final");        
    self:addChild( armature );
    
    armature:getAnimation():play("1", -1, 0);
    armature:setPosition(VisibleRect:center().x , VisibleRect:center().y);
    local function m_animationEvent(armatureBack,movementType,movementID)
        if movementType == ccs.MovementEventType.complete then
            if armature ~= nil then              
                armature:getAnimation():stop();
                armature:removeFromParent(false); 
                armature = nil;
            end;
        end
    end

    armature:getAnimation():setMovementEventCallFunc(m_animationEvent);
	
end

function GameEffectManager:playNoMatchMotion()
    
    local armature = ccs.Armature:create("nomatch");        
    self:addChild( armature );

    armature:getAnimation():play("1", -1, 0);
    armature:setPosition(VisibleRect:center().x , VisibleRect:center().y);
    local function m_animationEvent(armatureBack,movementType,movementID)
        if movementType == ccs.MovementEventType.complete then
            if armature ~= nil then              
                armature:getAnimation():stop();
                armature:removeFromParent(false); 
                armature = nil;
            end;
        end
    end

    armature:getAnimation():setMovementEventCallFunc(m_animationEvent);
    
end

function GameEffectManager:playWinMotion()
    
    local armature = ccs.Armature:create("win");        
    self:addChild( armature );
    armature:setPosition(VisibleRect:center().x , VisibleRect:center().y);
    armature:getAnimation():play("1", -1, 0);
    local function m_animationEvent(armatureBack,movementType,movementID)
        if movementType == ccs.MovementEventType.complete then
            if armature ~= nil then              
                armature:getAnimation():stop();
                armature:removeFromParent(false); 
                armature = nil;
            end;
        end
    end

    armature:getAnimation():setMovementEventCallFunc(m_animationEvent);
end


function GameEffectManager:playLoseMotion()

    local armature = ccs.Armature:create("lose");        
    self:addChild( armature );
    armature:setPosition(VisibleRect:center().x , VisibleRect:center().y);
    armature:getAnimation():play("1", -1, 0);
    local function m_animationEvent(armatureBack,movementType,movementID)
        if movementType == ccs.MovementEventType.complete then
            if armature ~= nil then              
                armature:getAnimation():stop();
                armature:removeFromParent(false); 
                armature = nil;
            end;
        end
    end

    armature:getAnimation():setMovementEventCallFunc(m_animationEvent);
end

-----------------------------------------------------------------------------
GameEffectManager.EliV_EFT_ID = {2103,2203,2303,2403,2503,2603};




function GameEffectManager:getPropUseArmature(id)
    return "goods"..id, "3";
end;

function GameEffectManager:getArmature(id)
    
    if Util:indexOf(self.EliV_EFT_ID,id) ~= -1 then
        local eftId = tonumber(id) - 1;
        return "eft"..eftId,"1";
    end
    
    return "eft"..id,"1";
end

function GameEffectManager:getRocketFlyArmature(id)
    if Util:indexOf(self.EliV_EFT_ID,id) ~= -1 then
        local eftId = tonumber(id) - 1;
        return "eft"..eftId.."_fly","1";
    end

    return "eft"..id.."_fly","1";
end

return GameEffectManager;