local CellPURocket = class("CellPURocket",function(itemType,anm)
    local CellPowerUp = require("game.view.grid.CellPowerUp");
    return CellPowerUp.create(itemType,anm);
end)

function CellPURocket.create(itemType,anm)
    local commonCell = CellPURocket.new(itemType,anm)
   
    
    if MissionGrid.isEliH(itemType) then
    
        commonCell.m_dir = MissionGrid.LINE_H;
    
    else
    
        commonCell.m_dir = MissionGrid.LINE_V
        commonCell:setRotation(90);
    end
    
    
    return commonCell;
end;

function CellPURocket:play5PromptMotion()

    if self.m_dir == MissionGrid.LINE_H then
    
        self.m_armature:getAnimation():play("3", -1, 0);
    
    else
    
        self.m_armature:getAnimation():play("4", -1, 0);
    end
end

function CellPURocket:play6CleartMotion()

    self.m_armature:getAnimation():play("5", -1, 0);
end

function CellPURocket:animationEvent(armatureBack,movementType,movementID)

    if movementType == ccs.MovementEventType.complete then
        if movementID == "1" then
            self:play1RestMotion();
        elseif movementID == "5" then
            self:destroy();
        end
    end
end;

return CellPURocket