local CellPowerUp = class("CellPowerUp",function(itemType,anm)
    local itemCell = require("game.view.grid.ItemCell");
    return itemCell.create(itemType,anm);
end)

function CellPowerUp.create(itemType,anm)
    local cellPowerUp = CellPowerUp.new(itemType,anm)
    
    if anm == nil then
        print("[CellPowerUp]111111111")
    end;
    
    --cellPowerUp:init(itemType,anm);
    cellPowerUp.m_activeArmature = nil;
    cellPowerUp.m_appearArmature = nil;
    return cellPowerUp;
end;

function CellPowerUp:playAppearMotion()
   self.m_armature:getAnimation():play("1", -1, 0);
   
   print("CellPowerUp -- 特效添加")
    self.eftEmitter = cc.ParticleSystemQuad:create("armature/inGameArmature/effect/powerUP01_4.plist")
--    self.eftEmitter:setAnchorPoint(0,0)
--    self.eftEmitter:setPosition(sPstX, sPstY + 40)
--    self.eftEmitter:setSpeed(10)
--
--    self.eftEmitter:setDuration(100)            
--    self.eftEmitter:setLife(100)
    
    self:addChild(self.eftEmitter)
    
--    local callFunEnd = function()
    --        self.eftEmitter:removeFromParent(true)
    --        self.eftEmitter = nil 
--    end
   
   
end

function CellPowerUp:play1RestMotion()
   self.m_armature:getAnimation():play("2", -1, -1);
end

function CellPowerUp:play2SelectMotion()

    
end

function CellPowerUp:play3DropingMotion()
    self.m_armature:getAnimation():play("3", -1, 0);    
end

function CellPowerUp:play4DropDownMotion()
    self.m_armature:getAnimation():play("2", -1, -1);    
end

function CellPowerUp:play5PromptMotion()

   
end


function CellPowerUp:play6CleartMotion()

   self.m_armature:getAnimation():play("4", -1, 0);

    if self.m_activeArmature ~= nil then
        
        self.m_activeArmature:removeFromParent(false)
        
        self.m_activeArmature = nil;
    end

    if self.m_appearArmature ~= nil then
    
       self.m_appearArmature:removeFromParent(false)
       self.m_appearArmature = nil;
        
    end
end

function CellPowerUp:playActiveEft()

    if self.m_activeArmature == nil then
    
        self.m_activeArmature = ccs.Armature:create("PowerUpActiveEft");
        self.m_activeArmature:getAnimation():play("1", -1, -1);
        self:addChild(self.m_activeArmature);
    end
end

function CellPowerUp:playAppearEft()

    if  self.m_appearArmature == nil then
    
        self.m_appearArmature = ccs.Armature:create("PowerUpAppearEft");
        self.m_appearArmature:getAnimation():play("1", -1, 0);
        self:addChild(self.m_appearArmature);
    end
end

function CellPowerUp:animationEvent(armatureBack,movementType,movementID)

    if movementType == ccs.MovementEventType.complete then
        if movementID == "1"  then
            self:play1RestMotion();
        elseif movementID == "4" then
            self:destroy();
        end
    end
end;

function CellPowerUp:destroy()
    
    if self.m_activeArmature ~= nil then 
        self.m_activeArmature:getAnimation():stop();
        self.m_activeArmature:removeFromParent(false);
    end;
    
    if self.m_appearArmature ~= nil then 
        self.m_appearArmature:getAnimation():stop();
        self.m_appearArmature:removeFromParent(false);
    end;
    
    if self.m_armature ~= nil then 
        self.m_armature:getAnimation():stop();
        self.m_armature:removeFromParent(false);
    end;
    if self.eftEmitter ~= nil then 
        self.eftEmitter:removeFromParent(true)
        self.eftEmitter = nil 
    end
    self:stopAllActions();

    self:removeFromParent(false)
end


return CellPowerUp;