
local ItemCell = class("ItemCell",function()
	return cc.Node:create();
end)


function ItemCell:ctor()

    
end;

function ItemCell.create(itemType,anm)
    local cell = ItemCell.new()
    cell:init(itemType,anm)
    return cell;
end

function ItemCell:init(itemType,anm)
    

    self.m_gridType = itemType;
    self.m_armature = anm;

    self:addChild(self.m_armature);
    
    self.m_direction = MissionGrid.Direction.DirAtWill;
    self.m_clearMode = MissionGrid.ClearMode.MODE_NONE;
    self.m_dropStatus = MissionGrid.DropStatus.REST;
    self.m_downTime = 0;
    self.m_arrive = false;
    self.m_coordina = Coordina.new();
    self.m_coordina.x = 0;
    self.m_coordina.y = 0;
    self.m_dropOut = false;
    self.m_speedX = 0;
    self.m_speedY = 0;
    self.m_acceleratedSpeed = 0;
    self.m_maxSpeed = 0;
    
    local function m_animationEvent(armatureBack,movementType,movementID)
   
        
        self:animationEvent(armatureBack,movementType,movementID)
    end
    self.m_armature:getAnimation():setMovementEventCallFunc(m_animationEvent);
       
end


function ItemCell:setCoordina(x,y)

    self.m_coordina.x = x;
    self.m_coordina.y = y;    
end

function ItemCell:getCoordina()
    
    return self.m_coordina;
end


function ItemCell:downTo(xPst,yPst)
    
    self:play3DropingMotion();
    
    if self.m_dropStatus ~= MissionGrid.DropStatus.REST then
        return;
    end;

    if self:getCoordina().x == xPst then
    
        self.m_dropStatus = MissionGrid.DropStatus.MOVE;
        self.m_speedX = 0;
        self.m_speedY = Config.dropSpeed;     
    
    else
    
        self.m_dropStatus = MissionGrid.DropStatus.MOVE_X;
        if  xPst > self:getCoordina().x then
        
            self.m_speedX = Config.dropTiltSpeed * 0.7;
        
        else
        
            self.m_speedX = -Config.dropTiltSpeed * 0.7;
        end
        self.m_speedY = Config.dropTiltSpeed * 0.7;
    end

    self.m_coordina.x = xPst;
    self.m_coordina.y = yPst;
    
    self.m_dropPostion = GameValue.mxGridContainer:transformGridCoordinaToNodePst(self.m_coordina.x, self.m_coordina.y);
    self.m_acceleratedSpeed = Config.dropGSpeed;
    self.m_maxSpeed = Config.dropMaxSpeed;
    
end;

function ItemCell:swapMoveTo(roundX,roundY)

    local deleyTime = Config.swapDuration;

    local willTarget = GameValue.mxGridContainer:transformGridCoordinaToNodePst(roundX, roundY);
   
    local scaleAction = cc.Sequence:create(cc.ScaleTo:create(deleyTime * 0.5, 1.2), cc.ScaleTo:create(deleyTime * 0.5, 1));
    local moveAction = cc.MoveTo:create(deleyTime, cc.p(willTarget.x,willTarget.y));
  
    self:stopAllActions();
    self:runAction(scaleAction); 
    self:runAction(moveAction); 
end

function ItemCell:swapMoveToDelay(roundX,roundY, deleyTime)

    local willTarget = GameValue.mxGridContainer:transformGridCoordinaToNodePst(roundX, roundY);
    
    
    local scaleAction = cc.Sequence.create(cc.ScaleTo.create(deleyTime * 0.5, 1.2), cc.ScaleTo.create(deleyTime * 0.5, 1));
    local moveAction = cc.MoveTo.create(deleyTime, cc.p(willTarget.x,willTarget.y));
    self:runAction(scaleAction); 
    self:runAction(moveAction); 
end

function ItemCell:onWorldTimerRunHandler(spendTime)

    if self.m_dropStatus == MissionGrid.DropStatus.REST then 
        return 
    end;
    
    local willX = 0;
    local willY = 0;
    if self.m_speedX == 0 then 
    
        willX = self.m_dropPostion.x;
        self.m_speedY = self.m_speedY + self.m_acceleratedSpeed * spendTime;
        if self.m_speedY > self.m_maxSpeed then 
            self.m_speedY = self.m_maxSpeed
        end;
        willY = self:getPositionY() - self.m_speedY * spendTime;
    
    else
    
        willX = self:getPositionX() + self.m_speedX * spendTime;
        willY = self:getPositionY() - self.m_speedY * spendTime;
    end

    if willY <= self.m_dropPostion.y then
    
        self:setPosition(self.m_dropPostion);
        self.m_arrive = true;
        
        
       self:play4DropDownMotion()    
        
        
    else
 
        self:setPosition(willX,willY);
    end;
    
end

function ItemCell:getArrive()
    return self.m_arrive;
end;

function ItemCell:getDropOut()
    return self.m_dropOut;
end;

function ItemCell:getGridType()
    return self.m_gridType;
end;

function ItemCell:setGridType(gridType)
    self.m_gridType = gridType;
end;

function ItemCell:setArrive(b)
    self.m_arrive = b;
end
function ItemCell:setDropStatus(status)
    self.m_dropStatus = status;
end

function ItemCell:getDropStatus()
    return self.m_dropStatus;
end

function ItemCell:playAppearMotion()
end



function ItemCell:play1RestMotion()
end

function ItemCell:play2SelectMotion()
end

function ItemCell:play3DropingMotion()
end

function ItemCell:play4DropDownMotion()
end

function ItemCell:play5PromptMotion()
end

function ItemCell:play6CleartMotion()
end

function ItemCell:animationEvent(armatureBack,movementType,movementID)
    
    if movementType == ccs.MovementEventType.complete then
        if movementID == "6" then
            self:destroy();
        end
    end
end;

function ItemCell:destroy()

    if self.m_armature ~= nil then 
        self.m_armature:getAnimation():stop();
        self.m_armature:removeFromParent(false);
    end;
    
    self:stopAllActions();
  
    self:removeFromParent(false)
end


return ItemCell;


