local HotfixLoading = class("HotfixLoading",function()
	return cc.Layer:create();
end)

function HotfixLoading:ctor()
	self:initBg();
end

function HotfixLoading.create()
    local loading = HotfixLoading.new();
    
    return loading;
end;

function HotfixLoading:initBg()
    self.bgSpr = cc.Sprite:create("ui/homeUIBg.jpg");
    self.bgSpr:setContentSize(768,1214)
    self.bgSpr:setPosition(VisibleRect:center());
    self:addChild(self.bgSpr) 
    
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/Logo/Logo0.png", "armature/Logo/Logo0.plist" , "armature/Logo/Logo.csb" )
    self.logoArm = ccs.Armature:create("Logo")
    self.logoArm:setPosition(VisibleRect:center())
    self.logoArm:getAnimation():play("1", -1, 1)
    self:addChild(self.logoArm)
    
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/loading/loading0.png", "armature/loading/loading0.plist" , "armature/loading/loading.csb" )
    self.loadingArm = ccs.Armature:create("loading")    
    -- 设置位置
    self.loadingArm:setPosition(VisibleRect:center().x,VisibleRect:center().y-300)
    self.loadingArm:getAnimation():play("1",-1,1)
    self:addChild(self.loadingArm)
    
   
end;

--检查更新
--function HotfixLoading:checkUpdate()
--    self.text = FacFont.getFontsBmp(FontType.FontYellowNoSide,"updateing...");
--    self:addChild(self.text)
--end;

function HotfixLoading:startUpdate()
    self:addLoadingBar();
end;

function HotfixLoading:noUpdate()

end;

function HotfixLoading:UpdateComplete()

end

function HotfixLoading:UpdateError()

end;


function HotfixLoading:addLoadingBar()
    local propgressBar = require("hotfix.HotfixProgressBar")
    self.progressBar = propgressBar.create();
    self:addChild(self.progressBar)
    self.progressBar:setPosition(cc.p(VisibleRect:center().x,22))
end;

function HotfixLoading:removeLoadingBar()
    if self.progressBar~= nil then
        self.progressBar:removeFromParent(true);
        self.progressBar = nil;
    end;
    
end;

function HotfixLoading:setLoadingBar(percent)
    if self.progressBar~= nil then
        self.progressBar:setProgress(percent);
    end
end;

return HotfixLoading;