local HotfixManager = class("HotfixManager",function()
    return cc.Layer:create();
end)

function HotfixManager:ctor()

    self:initConfig();
    
    local function  onUpdateStatus(status,...)
        
        if status == "newFramework" then --提示有大版本
            print("[HotfixManager] --ctor()  --提示有大版本")
            
            
            local clickNoFunc = select(1,...);
            
            local function clickFun(isClickCount)
                cclog("clickFun() isClickCount = "..isClickCount)
                if isClickCount == 0 then
                    cclog("clickFun() Yes")
                    clickNoFunc();
                    cclog("OpenUrl(https://play.google.com/store/apps/details?id=com.sixwaves.oz)");
                    --TODO  判断平台
                    --PlatformLuaOpenUrl("https://play.google.com/store/apps/details?id=com.sixwaves.oz");
                elseif isClickCount == 1 then
                    cclog("clickFun() No")
                    clickNoFunc();
                end;
            end;
            
            PlatformLuaShowNativePopDialog("Game Update Available","Oz has an update available","ok","later",clickFun); --大版本更新的提示
            
        elseif status == "checkFileList" then --检查需要更新的文件列表
            print("[HotfixManager] --ctor() --检查需要更新的文件列表")
        elseif status == "downloadPopup" then --资源大于500K询问是否更新
            print("[HotfixManager] --ctor() --资源大于500K询问是否更新")
            --TODO 弹框
            local clickYesFunc = select(1,...);
            local clickNoFunc = select(2,...);
            local diffBytes = math.floor(10*tonumber(select(3,...))/(1024*1024))*0.1;--多少k
            local function clickFun(isClickCount)
                if isClickCount == 0 then
                --TODO
                    clickYesFunc();
                --PlatformLuaOpenUrl("https://play.google.com/store/apps/details?id=com.sixwaves.oz");
                elseif isClickCount == 1 then
                    clickNoFunc();
                end;
            end;
            
            local desStr = "Download and update to the newest version of the game ({numPar}MB)"
            desStr = string.gsub(desStr, "%b{}", diffBytes)
            
            PlatformLuaShowNativePopDialog("Game Update Available",desStr,"ok","later",clickFun);

            
        elseif status == "downloadStart" then --开始下载文件
            print("[HotfixManager] --ctor() --开始下载文件")
            self:addLoadingBar();------添加loading条
            
        elseif status == "complete" then --完成
            print("[HotfixManager] --ctor() --完成")
            
--            if self.removeUpdateLoading~=nil then
            
                self:removeUpdateLoading(); ------移除loading条
            
--            end
        end       
    end
    
    local function onLoadProgress(loadedFile,maxFile)
        if  self.hotfixLoading~= nil then
            self.hotfixLoading:setLoadingBar(loadedFile/maxFile);
        end
    end;
    local loading = require("hotfix.HotfixLoading");
    self.hotfixLoading = loading.create()
    self:addChild(self.hotfixLoading)

    local temp_update = require("hotfix.update.UpdateManager");
    local updateManager = temp_update.create(onUpdateStatus,onLoadProgress);
    updateManager:init();    
end;

function HotfixManager:initConfig()
    require("config.dataConfig");
    --服务器的地址配制
    DataConfig.serverType = DataConfig.serverTypeList.LIVE;
    
    
    
    
    

    if DataConfig.serverType == DataConfig.serverTypeList.LOCAL
    then
        DataConfig.serverHost = DataConfig.serverLocalHost;
        DataConfig.updateHost = DataConfig.updateLocalHost;
    elseif DataConfig.serverType == DataConfig.serverTypeList.DEMO
    then
        DataConfig.serverHost = DataConfig.serverDemoHost;
        DataConfig.updateHost = DataConfig.updateDemoHost;
    elseif DataConfig.serverType == DataConfig.serverTypeList.LIVE
    then
        DataConfig.serverHost = DataConfig.serverLiveHost;
        DataConfig.updateHost = DataConfig.updateLiveHost;
    end
    
    DataConfig.updateHost = DataConfig.updateHost .. DataConfig.frameworkVersion .."/";

    DataConfig.os = "android";
    DataConfig.writablePath = cc.FileUtils:getInstance():getWritablePath();
    DataConfig.tmpPath =DataConfig.writablePath
    local targetPlatform = cc.Application:getInstance():getTargetPlatform();

    if targetPlatform == cc.PLATFORM_OS_IPHONE or targetPlatform == cc.PLATFORM_OS_IPAD  
    then
        DataConfig.os = "ios";
        --ios更新文件不能直接存到可写目录，防止ios系统拒绝写文件，需要把文件存到环境变量HOME提供的下层Library/Cache/文件夹下
        DataConfig.writablePath = os.getenv("HOME").."/Library/Cache/";
        DataConfig.tmpPath = os.getenv("HOME").."/tmp/";
    elseif targetPlatform == cc.PLATFORM_OS_ANDROID
    then
        DataConfig.os = "android";
        DataConfig.writablePath = cc.FileUtils:getInstance():getWritablePath();
        DataConfig.tmpPath = DataConfig.writablePath
    end

    DataConfig.storagePathRes = DataConfig.writablePath..DataConfig.gameName.."/res/";
    DataConfig.storagePathSrc = DataConfig.writablePath..DataConfig.gameName.."/src/";

    local searchPathsList = cc.FileUtils:getInstance():getSearchPaths();

    table.insert(searchPathsList,1,DataConfig.storagePathRes);
    table.insert(searchPathsList,1,DataConfig.storagePathSrc);
    --设置热更新查询目录
    cc.FileUtils:getInstance():setSearchPaths(searchPathsList);
end

function HotfixManager.create(checkComplete)
    local update = HotfixManager.new();
    update.checkComplete = checkComplete;
    return update;
end;


function HotfixManager:addLoadingBar()
    if self.hotfixLoading ~= nil then
        self.hotfixLoading:addLoadingBar();
    end
end;

function HotfixManager:removeUpdateLoading()
    
    if self.checkComplete ~= nil then
        self.checkComplete();
        self.checkComplete = nil;
    end;

    if self.hotfixLoading ~= nil then
        self.hotfixLoading:removeFromParent(true);
        self.hotfixLoading = nil;
    end
end;

return HotfixManager;