
local HotfixProgressBar = class("HotfixProgressBar",function ()
    return cc.Node:create();    
end)

function HotfixProgressBar:ctor()
    self.initPositionX = -768;---VisibleRect:getVisibleRect().width - (768*0.5 - VisibleRect:getVisibleRect().width*0.5);
    self.maxPositionX = 0;--VisibleRect:getVisibleRect().width*0.5 - 768*0.5;

    self:init();
end

function HotfixProgressBar.create()
    local temp = HotfixProgressBar.new();
    return temp;
end;

function HotfixProgressBar:init()
    --  添加背景的处理
    --    遮罩的实现start
    
    self.progressBarBg = cc.Sprite:create("home/loading3.png");
    
    self:addChild(self.progressBarBg)
    
    self.isPlayedStar = {false,false,false} --用于预先判断是否需要点亮一颗星星

    self.isNeedWait = -1 --用于预先判断是否需要点亮一颗星星是否需要等待播放星星点亮动画

    self.clippingNode = cc.ClippingNode:create()
    
    self.stencil = cc.Sprite:create("home/loading2.png"); --遮罩
    self.stencil:retain()
    self.clipSize = self.stencil:getContentSize()    
    self.spark  = cc.Sprite:create("home/loading2.png");  
    self.spark:retain()
    self.clippingNode:setContentSize(self.clipSize)
    self.clippingNode:addChild(self.spark)
    self.clippingNode:retain();


    self.spark:setPositionX(- 768);
    self.clippingNode:setInverted(false)
    self.clippingNode:setAlphaThreshold(0)
    self.clippingNode:setStencil(self.stencil)       
    self:addChild(self.clippingNode)
    --    遮罩的实现end  

end

function HotfixProgressBar:setProgress(percent)

    local targetPostionX = percent*768;

    local endMoveX = self.initPositionX + targetPostionX
    if endMoveX >= self.maxPositionX then
        endMoveX = self.maxPositionX
    end
    if self.spark ~= nil then

        local move_with = math.abs(endMoveX - self.spark:getPositionX());
        local moveAction = cc.MoveTo:create(0.01, cc.p(endMoveX,0));
        self.spark:stopAllActions(); 
        self.spark:runAction(moveAction); 

    end


end


function HotfixProgressBar:GC()


end

return HotfixProgressBar;