require("tools.UtilHelp");
local LoadingManager = class("LoadingManager");

function LoadingManager:ctor()
    self.layer = cc.Layer:create()
    self.loadingArm = nil
    
    
    local inGameResLoaderCLZ = require("load.InGameResLoader");
    self.inGameResLoader = inGameResLoaderCLZ.create();
    
    local outOfGameResLoaderClz = require("load.OutOfGameResLoader");
    self.outOfGameResLoader = outOfGameResLoaderClz.create();
end

function LoadingManager.create()
    local temp = LoadingManager.new();
    return temp;
end

function LoadingManager:addMask()

    if self.layerColor == nil then

        local color4B = cc.c4b(0,0,0,50)           
        self.layerColor =cc.LayerColor:create(color4B , MainValue.winSize.width , MainValue.winSize.height)
        self.layerColor:setAnchorPoint(0,0)
--        self.bgImg = cc.Sprite:create("res/ui/ui/loadingBg.jpg")--
--        self.bgImg:setScale(MainValue.winSize.width/768,MainValue.winSize.height/1024)
--         self.bgImg:setAnchorPoint(0,0)
--        self.bgImg:retain()
        local listener = function(eventType, x, y)

            if eventType == "began" then
                return true           
            end
        end
        
        self.layerColor:registerScriptTouchHandler(listener, false, 0, true)
        self.layerColor:setTouchEnabled(true);
                
--        self.layerColor:setCascadeOpacityEnabled(true)
--        self.layerColor:setOpacity(255)--//渐隐
                
        self.layerColor:retain()
        
     end
     
     self.layer:addChild(self.layerColor)
--     self.layer:addChild(self.bgImg)
end

function LoadingManager:removeMask()
    if self.layerColor then
        self.layerColor:release()
        self.layerColor:removeFromParent(true)
        self.layerColor = nil
    end  
--    if self.bgImg then
--        self.bgImg:release()
--        self.bgImg:removeFromParent(true)
--        self.bgImg = nil
--    end  
    
end


function LoadingManager:addLoading(isFirstPlayEntryMapPar)
        self:addMask()  
    if self.loadingArm == nil then
        ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/loading/loading0.png", "armature/loading/loading0.plist" , "armature/loading/loading.csb" )
        self.loadingArm = ccs.Armature:create("loading")    
        -- 设置位置
        self.loadingArm:setPositionX(VisibleRect:center().x)
        self.loadingArm:setPositionY(VisibleRect:center().y-300)
        self.loadingArm:retain()
        -- 播放动画, 播放指定动作        
       
    end  
--    self.loadingArm:getAnimation():resume()
    self.loadingArm:getAnimation():play("1",-1,1)
    
    
    self.layer:addChild(self.loadingArm)
--    判断是否是 首次play 仅投入地图
    if isFirstPlayEntryMapPar ~=nil then
--    .FadeIn
            self.layerColor:runAction(cc.Sequence:create(cc.FadeOut:create(1),cc.CallFunc:create(function()
    
--         self.layerColor:runAction(cc.Sequence:create(cc.DelayTime:create(0.5),cc.CallFunc:create(function() 
            MainStatus:onExitSplash()
            MainStatus:onEnterMap()
         end)))
    end
    
--    local fdi = cc.FadeIn:create(0.3)
--    self:runAction(fdi)
end

function LoadingManager:removeLoading()

    self:removeMask()
    
    if self.loadingArm ~= nil and self.loadingArm:getParent() then
    
        self.loadingArm:getAnimation():pause()
        self.loadingArm:getParent():removeChild(self.loadingArm)
--        self.loadingArm:release()
--        self.loadingArm = nil
    end
end
--进入游戏开始界面
function LoadingManager:onEnterSplash()
end

--退出游戏开始界面
function LoadingManager:onExitSplash()
    
end 

--进入地图
function LoadingManager:onEnterMap()
    
end 

--退出地图
function LoadingManager:onExitMap()
end

--进入游戏
function LoadingManager:onEnterGame()
    self.inGameResLoader:loadOtherBigArm();
end
--onEnteredGame

--退出游戏
function LoadingManager:onExitGame()
    
    self.inGameResLoader:removeOtherBigArm();
end

function LoadingManager:backPack()

    return false; 
end

function LoadingManager:loadGame(level,callBack)

    self.inGameResLoader:loadGameResource(level,callBack);
   -- cc.Director:getInstance():getTextureCache():addImageAsync(configFilePath,callBack)
  --  ccs.ArmatureDataManager:getInstance():addArmatureFileInfoAsyncCallFunc(str,str,str,callBack)
end;

function LoadingManager:loadRes(callback,firstEntryMap)
    self.outOfGameResLoader:loadGameResource(callback,firstEntryMap);
end

function LoadingManager:recessiveLoad()
    self.outOfGameResLoader:recessiveLoad()
end


return LoadingManager;