OutOfGameResLoader = class("LoadDataManager")


OutOfGameResLoader.armatures = {
        {"map/animation/map.png", "map/animation/map.plist","map/animation/level/level.csb"}, 
        {"map/animation/map.png", "map/animation/map.plist","map/animation/levelStar/levelStar.csb"},
};

OutOfGameResLoader.images = {
    {"ui/ui_ui.png", "ui/ui_ui.plist"},
};

function OutOfGameResLoader:ctor()
     self.arms = nil; 
     self.compCallBack = nil;
end

function OutOfGameResLoader.create()
    local temp = OutOfGameResLoader.new();
    return temp;
end

function OutOfGameResLoader:releaseGameResource()
    cc.Director:getInstance():getTextureCache():removeUnusedTextures();
end;

function OutOfGameResLoader:loadGameResource(callBack,firstEntryMap)

    self.compCallBack = callBack;
    
    if MainValue.dataManager.levelManager:getMaxLevel() == 1 and firstEntryMap == nil then
        self.compCallBack()
        return
    end
    print("[OutOfGameResLoader]加载游戏外资源")
    self.images = OutOfGameResLoader.images;
    self:startLoadImage();
end;

function OutOfGameResLoader:startLoadImage()
    print("[OutOfGameResLoader]加载images start")
    local count = 0;
    local length = table.maxn(self.images);
    
    local function loadComplete()
        print("[OutOfGameResLoader]加载images end---")
        count = count + 1;
        --print(count)
        if count >= length then
            print("[OutOfGameResLoader]加载地图 --start---")
            self:startLoadMapRes()
        end;
    end;
    
    local r = 1
    while r <= length do
        local imageInfo = self.images[r]
        cc.Director:getInstance():getTextureCache():addImageAsync(imageInfo[1],loadComplete)
        r = r + 1;
    end
    
end;

function OutOfGameResLoader:startLoadMapRes()
    self.loadNum = 0;
    self.maxRowCanUse = 32;
    self.maxCol = 3;
--    4*8  32行
    for row = 1, 32 , 1 do
        local setRowNum = -1 
        if row <= self.maxRowCanUse + 1 then
            local tarRowPst = self.maxRowCanUse - (self.maxRowCanUse - row)
            local setRowName = self.maxRowCanUse - (tarRowPst - 1)

            for col = 0, self.maxCol - 1 do
                self.loadNum = self.loadNum + 1;
                self:addImgAsyncFun(row,setRowName-1 , col)  
            end
        else

            local setBs = math.floor((row /(self.maxRowCanUse+1)))
            local setMod = row %(self.maxRowCanUse+1)
            local setRowName
            if setMod ~= 0 then
                setRowName = row -  (self.maxRowCanUse+1) * setBs
                setRowName = self.maxRowCanUse - setRowName + 1
            else
                setRowName = row -  (self.maxRowCanUse+1) * setBs
                if setRowName == 0 then
                    setRowName = 0                    
                else
                    setRowName = self.maxRowCanUse - setRowName
                end
            end
            for col = 0, self.maxCol - 1 do    
                self.loadNum = self.loadNum + 1;                                
                self:addImgAsyncFun(row,setRowName-1, col)
            end
        end        
    end    
   
end

function OutOfGameResLoader:addImgAsyncFun(setPstRowPar , rowPar , colPar)
    
    local callFun = function()
        self.loadNum = self.loadNum - 1
        if self.loadNum == 0 then
            self.loadNum =  -1
            print("[OutOfGameResLoader]加载地图 --end 11---")
            local imgName = "map/coming/comingTop.jpg"
            cc.Director:getInstance():getTextureCache():addImageAsync(imgName,function ()
                imgName = "map/coming/comingUnder.png"
                cc.Director:getInstance():getTextureCache():addImageAsync(imgName,function ()
                    self:startLoadAnimation()
                end);
            end)
        end
    end
    local imgName = string.format("map/background/1_%d_%d"..mapConfig.loadPicType,rowPar ,colPar) 
--    print("OutOfGameResLoader -- 外加载地图块名字"..imgName)
    cc.Director:getInstance():getTextureCache():addImageAsync(imgName,callFun)
end

function OutOfGameResLoader:startLoadAnimation()
    print("[OutOfGameResLoader]--startLoadAnimation---")
    local count = 0;
    local length = table.maxn(self.armatures);
    
    local function loadComplete(percent)
        count = count + 1;
        --print(count)
        
        if count >= length then
            print("[OutOfGameResLoader]--startLoadAnimation---end 11")
            self:startLoadImagePlist();
        end
    end
    
    local r = 1
    while r <= length do
        local armInfo = self.armatures[r];
        ccs.ArmatureDataManager:getInstance():addArmatureFileInfoAsync(armInfo[1],armInfo[2],armInfo[3],loadComplete);
        
        r = r + 1;
    end
    
end

function OutOfGameResLoader:startLoadImagePlist()
    local length = table.maxn(self.images);
    local r = 1
    while r <= length do
        local imageInfo = self.images[r]
        cc.SpriteFrameCache:getInstance():addSpriteFrames(imageInfo[2])        
        r = r + 1;
    end
    print("[OutOfGameResLoader]加载游戏外资源完成-----------------------------")
    if not MainValue.OUT_LOAD_COMPLETE then
        MainValue.mxUIManager.mapManager:mapInit()
    end
    MainValue.OUT_LOAD_COMPLETE = true
    self.compCallBack();
end
--进入游戏后的偷偷加载
function OutOfGameResLoader:recessiveLoad()
	 function loadComp()
        if not MainValue.OUT_LOAD_COMPLETE then
             MainValue.mxUIManager.mapManager:mapInit()
        end
        MainValue.OUT_LOAD_COMPLETE = true
   end
   
    if not MainValue.OUT_LOAD_COMPLETE then
        self:loadGameResource(loadComp,true)
    end	
end
 


return OutOfGameResLoader;