require "config.adConfig"
local AdsManager = class("AdsManager");


AdsManager.Applovin = 1;
AdsManager.Chartboost = 2;
AdsManager.Vungle = 3;




AdsManager.config = nil;



function AdsManager:ctor()
      

end

function AdsManager.create()
    local temp = AdsManager.new();
    return temp

end

-- 预加载广告
function AdsManager:init()
    
    self:AdsHelperCall("cacheInterstitialAd");
    
    self:AdsHelperCall("init",self.videoAdHandler);
    
    self:appsFlyerInit();
end;

function AdsManager.videoAdHandler(action,success)
  
   print("videoAdHandler");
    MainValue.adsManager:videoAdComplete(action,success)
end


function AdsManager:videoAdComplete(action,success) 
    print("videoAdComplete");
    self.success = success;
    self.action = action;
    
    self.showComplete = function (dt)
    
        MainValue.soundManager:resumeMusic();
         if self.timer ~= nil then
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.timer);
            self.timer = nil;
        end;
        if self.success == false then
            return;
        end;
        
        if self.showFromMap == true then
        
            local adsRewardUICR = require("ui/adsUI/AdsRewardUI")
            local adsRewardUI  = adsRewardUICR.create();
            adsRewardUI:setData(self.action);
            adsRewardUI:appear();
            
            MainValue.dataManager.adManager:addVideo2Count();
            return;
        end;
        
        
        
        
        if self.vedioComplete == nil then 
            return;
        end;
       
   

        if self.success == false then
        
        else
            if  self.vedioComplete ~= nil then
                
                self.vedioComplete();
                self.vedioComplete = nil;
            end;

            local videoPaneC = require("ui.videoReward.VideoRewardPanel");
            local videoRewardPanel = videoPaneC.create(self.action);
            videoRewardPanel:appear();
            MainValue.dataManager.adManager:addVideoCountByID(self.action);
            
        end;
        
       

    end;
    
    self.timer = cc.Director:getInstance():getScheduler():scheduleScriptFunc(self.showComplete, 0.5, false)
end

function AdsManager:isVideoSupport(id)
    
    --if 播放次数大于固定数 then
        --return false; 
    --end;
    
    if AdsManager.config == nil then
        AdsManager.config = MainValue.dataManager.adManager:getConfig();
    end;
    if AdsManager.config == nil then
        return false;
    end;
    local showEnable = AdsManager.config["allowAd"];

    if showEnable == false then
        return false;
    end;
    
    local maxLV = MainValue.dataManager.levelManager:getMaxLevel();
    local AdMinLevel = AdsManager.config["videoAd"]["minLevel"];--最小关卡
    
    if maxLV < AdMinLevel then 
        return false;
    end;

    local idData = AdsManager.config["videoAd"][tostring(id)];
    local AdMaxCount = 1;
    if idData ~= nil then
        AdMaxCount = idData["maxCount"];
    end;
    
    --AdsManager.config["videoAd"][tostring(id)]["maxCount"];
    local viewedCount = MainValue.dataManager.adManager:getVideoCountByID(id);
    if viewedCount >= AdMaxCount then
        return false;
    end;
    
    
    local hasCash = PlatformLuaAdsHelperCall("hasCacheVideoAd");
    if hasCash == false then -- 没有广告缓存
       return false;
    end;
    
    
 
    return true;
end;


function AdsManager:showVideoAds(rewardId,onFinish)
   
    print("showVideoAds");
    self.vedioComplete = nil;
    self.vedioComplete = onFinish;
    self.showFromMap = false;
    local isShow = PlatformLuaAdsHelperCall("videoAd",rewardId,0);
    MainValue.soundManager:pauseMusic();
    if isShow == true then
      
        
    else
      -- MainValue.platformManager:showNativePopDialog("","The vedio is not available. Try again later.","Ok");
      -- self.vedioComplete = nil;
    end;

end;

function AdsManager:clickVedioFromMap()
    local hasCache = PlatformLuaAdsHelperCall("hasCacheVideoAd");
    if hasCache == false then -- 没有广告缓存
        PlatformLuaShowNativePopDialog("",MainValue.infosManager:getObjMultilingualByKey("Ads_unavailable"),"ok");
        return;
    end;

    local hasShowCount = tonumber(MainValue.dataManager.adManager:getVideo2Count());
    local maxShowCount = tonumber(adConfig.maxShowCount)
    if hasShowCount >= maxShowCount then                  -- 已经观看了全部次数
        local adsEndCr = require("ui/adsUI/AdsEndUI")
        local adsEndUI  = adsEndCr.create();
        adsEndUI:appear();
        return;
    end;
    
    local adsShowUICr = require("ui/adsUI/AdsShowUI")
    local adsShowUI  = adsShowUICr.create();
    adsShowUI:appear();
    
end;


function AdsManager:showVedioFromMap()
    
    self.showFromMap = true;

    local rewardId = self:getRewardId();
    MainValue.soundManager:pauseMusic();
    PlatformLuaAdsHelperCall("videoAd",tostring(rewardId),0)
    
end

function AdsManager:getRewardId()
    local id = 0;
    
    local rewardIds = adConfig.rewards;
    
    for key = 1, #rewardIds do
        local canShow = self:checkCondition(key)
        if canShow == true then
            id = key;
            break;
        end
    end;
    
    return id;
end;

function AdsManager:checkCondition(id)
    local rewardIds = adConfig.rewards;
    local condition = rewardIds[id];
    local rewardId = condition.rewardId[1];
    
    local localIdNum = 0;
    if rewardId == 301 then
        localIdNum = MainValue.dataManager.userManager:getHeart();
    elseif rewardId == 1000 then
        localIdNum = MainValue.dataManager.userManager:getCash();
    else
        localIdNum = MainValue.dataManager.goodsManager:getGoodsNumber(tonumber(rewardId));
    end
    
    --判断剩心 逻辑
     
    local m_conditionRemainId = condition.conditionRemainId;
    if tonumber(m_conditionRemainId[1]) == 1 and localIdNum <= tonumber(m_conditionRemainId[2]) then
        return false;
    end;
    if tonumber(m_conditionRemainId[1]) == -1 and localIdNum >= tonumber(m_conditionRemainId[2]) then
        return false;
    end;
    

    
    local random = math.random(0,100);
    if random > (condition.random*100) then
        return false
    end;
    
    return true;
end;





function AdsManager:showVideoAdsByCompany(company)
    local isShow = PlatformLuaAdsHelperCall("videoAd","showVideoAdsByCompany",company);
    return isShow;
end;



function AdsManager:appsFlyerInit()
    if MainValue.platformManager:isIOS() == true then
       self:AppsFlyerCall("setDevKey","w6y36ytEm5yNzrGrv5N6qW","833321992");
    else
       self:AppsFlyerCall("setDevKey","w6y36ytEm5yNzrGrv5N6qW","");
    end;
    self:AppsFlyerCall("trackAppLaunch");
    --self:AppsFlyerCall("trackEvent");
end;

function AdsManager:checkShowEnable()
    if AdsManager.config == nil then
        AdsManager.config = MainValue.dataManager.adManager:getConfig();
        --return true;
    end;
    
    if AdsManager.config == nil then
        return false;
    end;
    
    
    local showEnable = AdsManager.config["allowAd"];
    
    if showEnable == false then
        return false;
    end;
    
    
     
    local imageAdMinLevel = AdsManager.config["imageAd"]["minLevel"];--最小关卡
    local imageAdInterval = AdsManager.config["imageAd"]["interval"];--间隔时间
    local imageAdSession = AdsManager.config["imageAd"]["session"];--session  
    
    local imageAdPlayTime = AdsManager.config["imageAd"]["playTime"];
    local imageAdMaxCount = AdsManager.config["imageAd"]["maxCount"];
    
    local session = MainValue.dataManager.adManager:getSession();
    if session == nil then
        session = 0;
    end;
    local playTime = os.time() - MainValue.dataManager.adManager:getFirstTime();
    local intervalTime = MainValue.dataManager.adManager:getIntervalTime();
    local popCount = MainValue.dataManager.adManager:getPopCount();
    if popCount == nil then
        popCount = 0;
    end;
    
    local maxLV = MainValue.dataManager.levelManager:getMaxLevel();
    if popCount > imageAdMaxCount then
        return false;
    end;
    
    if popCount ~=0 and intervalTime < imageAdInterval then
        return false;
    end;
    
    if session < imageAdSession and playTime<imageAdPlayTime and maxLV<imageAdMinLevel then
        return false;
    end;
    
   
    
    if MainValue.dataManager.expandManager:getIsPay() == true then
       return false;
    end;
    
    return true;
       
end; 
function AdsManager:interstitialAd()
    
    if self:checkShowEnable()== false then
        return;
    end;
    
    local imageAdCompanyTable = AdsManager.config["imageAd"]["company"];
    local popCount = MainValue.dataManager.adManager:getPopCount();
    if popCount == nil then
        popCount = 0;
    end;
    popCount = popCount+1;
    local companyLenth = table.maxn(imageAdCompanyTable);
    if companyLenth == 0 then
        return;
    end;
    
    if popCount > companyLenth then
       popCount =  popCount - companyLenth;
     end;
    
    local company = imageAdCompanyTable[popCount];
   
    self:AdsHelperCall("interstitialAd",company);
    
    MainValue.dataManager.adManager:popAdvertisement();
    
end;



function AdsManager:AdsHelperCall(cmd, ...)

    PlatformLuaAdsHelperCall(cmd,...);
--local videoFinishFunc = function()
--请移此函数去别处 仅仅实例 参考 PlatformManager.FBHandler
--end

--共四个子函数
--PlatformLuaAdsHelperCall("init",function videoFinishFunc);
--PlatformLuaAdsHelperCall("interstitialAd",int company);
--PlatformLuaAdsHelperCall("videoAd", string playAction);
--PlatformLuaAdsHelperCall("cacheInterstitialAd"); 

--PlatformLuaAdsHelperCall("hasCacheVideoAd");-返回是否有缓存的广告

end

function AdsManager:AppsFlyerCall(cmd, ...)

    PlatformLuaAppsFlyerCall(cmd,...);
--共七个函数
--PlatformLuaAppsFlyerCall("setAppUserId"， string userId);
--PlatformLuaAppsFlyerCall("setDevKey"， string key,  string appId);
--PlatformLuaAppsFlyerCall("setCurrencyCode"， string code);
--PlatformLuaAppsFlyerCall("setUseHTTPFalback"， bool v);
--PlatformLuaAppsFlyerCall("setDeviceTrackingDisabled"， bool v);
--PlatformLuaAppsFlyerCall("trackAppLaunch");
--PlatformLuaAppsFlyerCall("trackEvent");
end

return AdsManager;