require "platform.FBSharedType"

local FBManager = class("FBManager");

FBManager.callBackMsg = nil;


--获取所有请求信息
FBManager.APPREQUESTS = "me/apprequests";
FBManager.INVITEFRIENDS_REQUESTS = "me/invitable_friends";
FBManager.URL = "https://apps.facebook.com/wizardofozmobile";  -- 要改
FBManager.APPNAME = "Oz!";


function FBManager:ctor()
    self.isLoginValue = false;
    self.callBack = nil;
    self.callBackFriends = nil;

    --手机端接收到的消息要融合成手机版格式
    self.CMD = 
        {
            BLOCK = "block",
            ENERGY = "energy",
            FREE = "free"
        }

    self._CMD = 
        {
            --请求帮助
            HELP = "help",
            --接受请求帮助
            ACCEPT = "accept",
            --主动送能量
            SEND = "send",
            --免费赠送金币
            CASH = "cash",
            --免费赠送能量
            ENERGY = "energy",
            --免费赠送物品
            ITEM = "item"
        }

    --[[--
    SS 网页版inbox消息模式
    主动发消息
    type: ask_help(要心)   type_A=''
    type: help（解锁blocker）,blockerName, blockId  type_T=''
    type: gift（送心）   type_Aonly=''
    回复消息
    type: ask_help(要心)   type_A= "accept_send"/"thanks"
    type: help（解锁blocker）,blockerName, blockId ,type_T="accept_send"/"thanks"
    type: gift（送心）   type_Aonly="BGift"/"acceptonly"
    ]]
    self.CMD_WEB = 
        {
            BLOCK = "help",
            ENERGY = "ask_help",
            GIFT = "gift"
        }

    self._CMD_WEB = 
        {
            --请求帮助
            HELP = "",
            --接受请求帮助
            ACCEPT = "accept_send",
            --谢谢朋友的帮助，手机版暂留
            THANKS = "thanks"
        }

  
end

function FBManager.create()
    local temp = FBManager.new()
    return temp

end

function FBManager:getIsLogin()

    if self:FBisLogin() then
        print("getIsLogin:111111::")
    else
        print("getIsLogin:222222::")
    end

    return self:FBisLogin() --self.isLoginValue
end

function FBManager:setIsLogin(is)

    print("setIsLogin:::"..type(is))

    if is then
        print("setIsLogin:111111::")
    else
        print("setIsLogin:222222::")
    end


    if type(is) == "boolean" then
        --if is == false then return ;end
        self.isLoginValue = is;
    end

    if MainValue.mxUIManager ~= nil and MainValue.mxUIManager.inboxBtn ~= nil then
        MainValue.mxUIManager.inboxBtn:needUpdataNum();
    end
end

function FBManager:isLoginByCallback(callback)
    local loc_isPfLogin = self:FBisLogin();

    if loc_isPfLogin 
    then
        if self.callBackFriends ~= nil then self.callBackFriends = nil; end
        callback();
    else 
        if callback ~= nil and self.callBackFriends == nil
        then self.callBackFriends = callback; end

        self:FBlogin();
    end
end

-- -----------------------------------------------------------------------------------------block


--[[--
--请求帮助blocker
--@param blockID int 当前BLOCK前面的关卡编号
--@param friendIDs table 好友ID表 
--例如  friendIDs = {583896511715508, 583896511715508}
]]---
function FBManager:askBlockHelp(blockID, friendIDs)

    local data = {cmd = self.CMD.BLOCK, _cmd = self._CMD.HELP, blockId = blockID, blockerName = ""};

    self:FBrequestDialog(FBManager.APPNAME,FBRequestMessage.askBlocker, data, friendIDs);
end


--[[--
--回应请求帮助blocker
--@param blockID int 当前BLOCK前面的关卡编号
--@param friendId string 好友ID
]]---
function FBManager:askBlockResp(blockID, friendId)

    local data = {cmd = self.CMD.BLOCK, _cmd = self._CMD.ACCEPT, blockId = blockID, blockerName = ""};

    self:FBrequestDialog(FBManager.APPNAME,FBRequestMessage.askBlockerResp, data, {friendId});
end

-- -----------------------------------------------------------------------------------------heart


--[[--
--主动送能量
--@param friendId string 好友ID
]]---
function FBManager:sendHeart(friendIds)

    local data = {cmd = self.CMD.ENERGY, _cmd = self._CMD.SEND};

    self:FBrequestDialog(FBManager.APPNAME,FBRequestMessage.sendHeart, data, friendIds);
end

-- 暂留
function FBManager:sendHeartSuccess(friendId)

end


--[[--
--要能量
--@param friendIDs table 好友ID表 
--例如  friendIDs = {583896511715508, 583896511715508}
]]---
function FBManager:askHeart(friendIDs)
    local data = {cmd = self.CMD.ENERGY, _cmd = self._CMD.HELP};

    self:FBrequestDialog(FBManager.APPNAME,FBRequestMessage.askHeart, data, friendIDs);
end


--[[--
--回应要能量请求
--@param friendId string 好友ID
]]---
function FBManager:askHeartResp(friendId)

    local data = {cmd = self.CMD.ENERGY, _cmd = self._CMD.ACCEPT};

    self:FBrequestDialog(FBManager.APPNAME,FBRequestMessage.askHeartResp, data, {friendId});
end

-- -----------------------------------------------------------------------------------------inbox

--[[--
--获取INBOX消息
--@param callback function 获取INBOX消息的回调函数
--注：回调只允许有一个参数
--@return #table 
{
[1] = {
["from_id"] = "583896511715508",
["param_id"] = 40,
["request_id"] = "1409104236048533_10203687959535331",
["cmd"] = "block",
["from_username"] = "Zhongbao  Gan",
["_cmd"] = "help",
},
[2] = {
...
}
}
--调用例子：
function CheatManager:getMessage()
MainValue.fbManager:getMessage(self.onMessageHandler);
end

function CheatManager:onMessageHandler(list)
...
end
]]---
function FBManager:getMessage(callback)
    FBManager.callBackMsg = nil;
    print("FBManager:getMessage88888888888888881111111111111111111111111111")
    if FBManager.callBackMsg == nil
    then
        print("FBManager:getMessage8888888888888888")
        FBManager.callBackMsg = callback;

        self:FBrequestGraphReal(FBManager.APPREQUESTS);
    end
end

--[[--
--删除INBOX消息
--@param request_id string 获取INBOX消息中每条记录的request_id
--例子：
--request_id = 1409104236048533_10203687959535331;
]]---
function FBManager:deleteMessage(request_id)
    if type(request_id) ~= "string" then return ;end

    if string.find(request_id,"10000_") ~= nil
    then
        MainValue.dataManager.friendManager:delInbox(request_id);
    else
        self:FBdeleteObject(request_id);
    end
end

function FBManager:FBinviteDialog()
    MainValue.platformManager:FBinviteDialog(FBInviteMessage.title, FBInviteMessage.message);
end

function FBManager:FBgetInviteFriend()
    if self:FBisLogin() then
        FBLuaHandler("inviteFriend",{fields = "picture.width(100).height(100),name,first_name,last_name"});       
    end
end

-- -----------------------------------------------------------------------------------------base ask
--新改动  2015-6-12 start 可变参数
function FBManager:reachNewLevel(fmt,...)
    local id = fmt;
    if self:FBisLogin() then
        local feedData = MainValue.infosManager:getObjFeedById(id);
        local url = FBManager.URL;
        local name = FBManager.APPNAME;
        local description = feedData.desc;
        local picture = feedData.link;
        local caption = feedData.title;
        caption = string.gsub(caption, "{levelNum}", tostring(select(1,...)));
        picture = string.gsub(picture, "{levelNum}", tostring(select(1,...)));
        caption = string.gsub(caption, "{myName}", MainValue.dataManager.userManager:getUserName());

        print("FBManager -- reachNewLevel() 分享shareDialogReal")

        self:FBsharedDialogReal(url, caption, name, description, picture);
    else
        self.callBack = function ()
            self:FBsharedDialogReal(id);
        end
        self:FBlogin();
    end
end

function FBManager:passFriendScore(fmt,...)
    print("FBManager:passFriendScore超过好友分数的分享")
    local id = fmt;
    if self:FBisLogin() then
        local feedData = MainValue.infosManager:getObjFeedById(id);
        local url = FBManager.URL;
        local name = FBManager.APPNAME;
        local description = feedData.desc;
        local picture = feedData.link;
        local caption = feedData.title;
        description = string.gsub(description, "{levelNum}", tostring(select(1,...)));


        caption = string.gsub(caption, "{myName}", MainValue.dataManager.userManager:getUserName());
        self:FBsharedDialogReal(url, caption, name, description, picture);
    else
        self.callBack = function ()
            self:FBsharedDialogReal(id);
        end
        self:FBlogin();
    end
end


function FBManager:unlockItem(fmt,...)
    local id = fmt;
    if self:FBisLogin() then
        local feedData = MainValue.infosManager:getObjFeedById(id);
        local url = FBManager.URL;
        local name = FBManager.APPNAME;
        local description = feedData.desc;
        local picture = feedData.link;
        local caption = feedData.title;
        picture = string.gsub(picture, "{goodsId}", tostring(select(1,...)));
        description = string.gsub(description, "{itemName}", tostring(select(2,...)));
        caption = string.gsub(caption, "{myName}", MainValue.dataManager.userManager:getUserName());
        self:FBsharedDialogReal(url, caption, name, description, picture);
    else
        self.callBack = function ()
            self:FBsharedDialogReal(id);
        end
        self:FBlogin();
    end
end

function FBManager:gachaFree(fmt,...)
    local id = fmt;
    if self:FBisLogin() then
        local feedData = MainValue.infosManager:getObjFeedById(id);
        local url = FBManager.URL;
        local name = FBManager.APPNAME;
        local description = feedData.desc;
        local picture = feedData.link;
        local caption = feedData.title;
        description = string.gsub(description, "{myName}", MainValue.dataManager.userManager:getUserName());
        description = string.gsub(description, "{itemname}", tostring(select(1,...)));

        caption = string.gsub(caption, "{myName}", MainValue.dataManager.userManager:getUserName());
        self:FBsharedDialogReal(url, caption, name, description, picture);
    else
        self.callBack = function ()
            self:FBsharedDialogReal(id);
        end
        self:FBlogin();
    end
end

function FBManager:gachaPay(fmt,...)
    local id = fmt;
    if self:FBisLogin() then
        local feedData = MainValue.infosManager:getObjFeedById(id);
        local url = FBManager.URL;
        local name = FBManager.APPNAME;
        local description = feedData.desc;
        local picture = feedData.link;
        local caption = feedData.title;

        description = string.gsub(description, "{myName}", MainValue.dataManager.userManager:getUserName());        
        caption = string.gsub(caption, "{myName}", MainValue.dataManager.userManager:getUserName());
        self:FBsharedDialogReal(url, caption, name, description, picture);
    else
        self.callBack = function ()
            self:FBsharedDialogReal(id);
        end
        self:FBlogin();
    end
end
--新改动  2015-6-12 end 可变参数

function FBManager:FBsharedDialog(fmt, ...)
    local id = fmt;
    local loc_isPfLogin = self:FBisLogin();

    if loc_isPfLogin then
        local feedData = MainValue.infosManager:getObjFeedById(id);

        local url = FBManager.URL;
        local name = FBManager.APPNAME;
        local description = feedData.desc;
        local picture = feedData.link;
        local caption = feedData.title;

        if id == FBSharedType.REACH_NEW_LEVEL then
            caption = string.gsub(caption, "{levelNum}", tostring(select(1,...)));
        --            picture = string.gsub(picture, "{levelNum}", tostring(select(1,...)));
        elseif id == FBSharedType.MORE_SCORE then

        elseif id == FBSharedType.MORE_STARS then

        elseif id == FBSharedType.PASS_FRIEND_SCORE then
            description = string.gsub(description, "{levelNum}", tostring(select(1,...)));
        elseif id == FBSharedType.PASS_FRIEND_PROGRESS then
            --
            print("FBManager:超过好友进度的分享")

        elseif id == FBSharedType.DAILY_REWARD then

        elseif id == FBSharedType.FINISH_HUNDRED then

        elseif id == FBSharedType.FINISH_FIFTY then

        elseif id == FBSharedType.UNLOCK_ITEM then
            picture = string.gsub(picture, "{goodsId}", tostring(select(1,...)));
            description = string.gsub(description, "{itemName}", tostring(select(2,...)));
        elseif id == FBSharedType.GACHA_FREE then
            description = string.gsub(description, "{myName}", MainValue.dataManager.userManager:getUserName());
            description = string.gsub(description, "{itemname}", tostring(select(1,...)));
        elseif id == FBSharedType.GACHA_PAY then
            description = string.gsub(description, "{myName}", MainValue.dataManager.userManager:getUserName());
        end

        caption = string.gsub(caption, "{myName}", MainValue.dataManager.userManager:getUserName());
        self:FBsharedDialogReal(url, caption, name, description, picture);
    else 
        self.callBack = function ()
            self:FBsharedDialogReal(id);
        end
        self:FBlogin();
    end
end

function FBManager:FBrequestDialog(title, message, data, friendID)

    if type(friendID) == "table" and type(data) == "table"
    then
        friendID = table.concat(friendID,",");
        data = json.encode(data);
    else 
        return false;
    end

    local loc_isPfLogin = self:FBisLogin();

    if loc_isPfLogin 
    then
        self:FBrequestDialogReal(title, message, data, friendID);
    end
end

--请求获取request信息
function FBManager:FBrequestGraph(graphFullPath)
    local loc_isPfLogin = self:FBisLogin();

    if loc_isPfLogin 
    then
        self:FBrequestGraphReal(graphFullPath)
    else 
        self.callBack = 
        function ()
            self:FBrequestGraph(graphFullPath);
        end

        self:FBlogin();
    end
end

-- -----------------------------------------------------------------------------------------base onResultHandler

function FBManager:onLoginResult(result)
    MainValue.dataManager:onLoginResult(result);
    if MainValue.mxSplashManager ~= nil
    then
        MainValue.mxSplashManager:setLogin(result);
    end

    if result == 0 and MainValue.mxGameManager ~= nil then
        MainValue.mxGameManager.gameStatusManager:showConnectFBSuccess(false); --显示连接失败
    end
end

function FBManager:onGetMeResult(idPar,namePar,usernamePar,picturePar)
    local userGraph = {}
    userGraph.id = idPar
    userGraph.name= namePar
    userGraph.username = usernamePar
    userGraph.picture = picturePar

    MainValue.dataManager:onGetMeResult(userGraph);
    if self.callBack ~= nil 
    then 
        self.callBack(); 
        self.callBack=nil;
    end
end

function FBManager:onGetFriendsResult(userGraphListPar)
    local userGraphList = json.decode(userGraphListPar);
    MainValue.dataManager:onGetFriendsResult(userGraphList);

    self:setIsLogin(true);

    MainValue.mxGameManager.gameStatusManager:showConnectFBSuccess(true); --显示连接成功

-- 2015-6-18 暂时注释  
 MainValue.statisticsManagerOG:fbConnect();
end

--确认连接FB成功，执行回调
function FBManager:confirmSuccess()
    if self.callBackFriends ~= nil 
    then 
        self.callBackFriends(); 
        self.callBackFriends = nil;
    else
        print("callBackFriends is nil");
    end
end

function FBManager:onGetFriendsListResult(inviteFriendsList)
    MainValue.dataManager.friendManager:setPlatformInviteFriendsInfo(json.decode(inviteFriendsList));
end

--与WEB服务器的消息融合
local function synchronousWebInbox(self, data)

    local cmd = data.type;

    local result = nil;

    if cmd == self.CMD_WEB.BLOCK then
        local _cmd = data["type_T"];
        local id = data["blockId"];
        local name = data["blockerName"];

        if _cmd == self._CMD_WEB.HELP or _cmd == nil then
            result = {cmd = self.CMD.BLOCK, _cmd = self._CMD.HELP, id = id, name = name};
        elseif _cmd == self._CMD_WEB.ACCEPT then
            result = {cmd = self.CMD.BLOCK, _cmd = self._CMD.ACCEPT, id = id, name = name};
        end

    elseif cmd == self.CMD_WEB.ENERGY then
        local _cmd = data["type_A"];
        if _cmd == self._CMD_WEB.HELP or _cmd == nil then
            result = {cmd = self.CMD.ENERGY, _cmd = self._CMD.HELP};
        elseif _cmd == self._CMD_WEB.ACCEPT then
            result = {cmd = self.CMD.ENERGY, _cmd = self._CMD.ACCEPT};
        end

    elseif cmd == self.CMD_WEB.GIFT then
        local _cmd = data["type_Aonly"];
        if _cmd == self._CMD_WEB.HELP or _cmd == nil then
            result = {cmd = self.CMD.ENERGY, _cmd = self._CMD.SEND};
        end
    end

    return result;
end

function FBManager:onRequestGraphResult(graphPath,result,...)

    print("FBManager:onRequestGraphResult11111111111111111111112569::",graphPath)
    if(graphPath == FBManager.APPREQUESTS) 
    then
        --local ret = json.decode(result);

        print("InboxTotalMes" .. result);
        local ret = json.decode(result);
        local list = {};

        for key, var in ipairs(ret) do
            if(var["data"] ~= nil) 
            then
                --local data = json.decode(var["data"]);
                local data = json.decode(var["data"]);
                --                local type = synchronousWebInbox(self,data);

                --                if type ~= nil
                --                then
                local message = 
                    {
                        cmd             = data.cmd,
                        _cmd            = data._cmd,
                        param_id        = data.id,
                        from_id         = var.from.id,
                        from_username   = var.from.name,
                        request_id      = var.id
                    };

                table.insert(list,message);
            --                end
            end
        end --end for

        if FBManager.callBackMsg ~= nil then 

            self:deleteSameMes(list);
            print("FBManager:onRequestGraphResult 110 list")
            --            print(list)
            print("FBManager:onRequestGraphResult 120 list")

            self:setInboxFreeGoods(list);

            FBManager.callBackMsg(self,list);
        else
            print("self.callBackMsg is nil 9999999999999")
        end
    end-- end if
end


--删除邮箱相同信息
function FBManager:deleteSameMes(dataList)
    local dataLen = #dataList;

    for i = 1, dataLen do
        for j= dataLen, 1, -1 do
            if i ~= j and dataList[i] ~= nil and dataList[j] ~= nil then
                local cmd_i = dataList[i].cmd;
                local cmd_j = dataList[j].cmd;
                local _cmd_i = dataList[i]._cmd;
                local _cmd_j = dataList[j]._cmd;
                local id_i = dataList[i].from_id;
                local id_j = dataList[j].from_id;

                if  cmd_i == cmd_j 
                    and _cmd_i == _cmd_j 
                    and id_i == id_j 
                then
                    self:deleteMessage(dataList[j].request_id);
                    table.remove(dataList,j);
                    dataLen = #dataList;
                end
            end
        end
    end
end

function FBManager:setInboxFreeGoods(list)
    if list == nil then return; end

    local loc_inbox = MainValue.dataManager.friendManager:getInbox();

    --local ret = {};

    for key, var in pairs(loc_inbox) do
        local loc_inboxId = key;
        local loc_inboxData = var;

        --免费赠送的道具ID是从10000_开头的
        if string.find(loc_inboxId,"10000_") ~= nil
        then
            local loc_cmd = loc_inboxData["type"];
            local loc_id = ""
            local loc_num = tonumber(loc_inboxData["num"]);

            if loc_cmd == self._CMD.ITEM
            then
                loc_id = loc_inboxData["id"];
            end

            local message = 
                {
                    cmd             = self.CMD.FREE,
                    _cmd            = loc_cmd,
                    param_id        = loc_id,
                    param_num       = loc_num,
                    from_id         = "10000_",
                    from_username   = "Eva",
                    request_id      = loc_inboxId
                };

            table.insert(list,message);
        end
    end
    --return ret;
end



-- 2015-6-12 start by xueyongjie  faceBook接口整理
function FBManager.FBHandler(...)
--    self:onRequestGraphResult(cmd, params)
end
function FBManager:FBinit()
    print("FBManager:FBinit()", self.FBHandler, type(self.FBHandler))
    FBLuaHandler("init","user_friends,publish_actions",function (...)
        cclog("FBManager.FBHandler----cmf")

        local cmd = tostring(select(1,...))

        cclog("FBManager.FBHandler----cmd::"..cmd)

        if cmd =="onLoginResult" then
            local result = select(2,...)
            if result then
                self:onLoginResult(1)
            else
                self:onLoginResult(0)
            end

        elseif cmd =="onGetMeResult" then
            local id = tostring(select(2,...))
            local name = tostring(select(3,...))
            local username = tostring(select(4,...))
            local picture = tostring(select(5,...))

            --        for i = 1, select('#', ...) do 
            --            local arg = select(i, ...);
            --            print("setUsetPicture", arg);  
            --        end 

            self:onGetMeResult(id,name,username,picture)
        elseif cmd =="onGetFriendsResult" then    

            for i = 1, select('#', ...) do 
                local arg = select(i, ...);
                print("setFriendsData", arg);  
            end 

            self:onGetFriendsResult(tostring(select(2,...)))
        elseif cmd =="onRequestGraphResult" then
            self:onRequestGraphResult(cmd,select(2,...),select(3,...))
        elseif cmd =="onDeleteObjectResult" then

        elseif cmd =="onGetFriendsListResult" then
            self:onGetFriendsListResult(tostring(select(2,...)))
        elseif cmd =="requestDialogResult" then

        elseif cmd =="requestGraphResult" then

            local msg = select(2,...)
            print("getEmailMsg----1")
            self:onRequestGraphResult(FBManager.APPREQUESTS,select(2,...))
            print(msg)        
            print("getEmailMsg----2")

        elseif cmd =="postGraphResult" then


        end
    end)
end

function FBManager:FBisLogin()
    return FBLuaHandler("isLogin")
end

function FBManager:FBlogin()
    MainValue.mxGameManager.gameStatusManager:showConnectFBLoading() --显示连接FB loading
    FBLuaHandler("login")
end

function FBManager:FBlogout()
    cclog("FBManager:FBlogout")
    FBLuaHandler("logout")    
    self:setIsLogin(false)
end
function FBManager:FBgetMe()
    cclog("FBManager:FBgetMe")
    FBLuaHandler("getMe")
end



function FBManager:FBgetFriends()
    cclog("FBManager:FBgetFriends");
    FBLuaHandler("getFriends")
end



function FBManager:FBsharedDialogReal(url, name, caption, description, picture)
    cclog("FBManager:FBsharedDialogReal");
    cclog("url---::"..url)
    cclog("name---::"..name)
    cclog("caption---::"..caption)
    cclog("description---::"..description)
    cclog("picture---::"..picture)


    FBLuaHandler("sharedDialog",url, name, caption, description, picture)   --2015-6-19 分享
end

function FBManager:FBrequestDialogReal(title, message, data, friendID)
    cclog("FBManager:FBrequestDialogReal");    
    FBLuaHandler("requestDialog",title,message,data, friendID)
end

function FBManager:FBrequestGraphReal(graphFullPath)
    --获取邮件信息
    cclog("FBManager:FBrequestGraphReal");
    FBLuaHandler("requestGraph",graphFullPath)

end

function FBManager:FBdeleteObject(graphFullPath)
    cclog("FBManager:FBdeleteObject");
    FBLuaHandler("deleteObject",graphFullPath)
end

function FBManager:FBgetToken()
    return FBLuaHandler("getToken") 
end


function FBManager:FBpostGraph()
    FBLuaHandler("postGraph",{one="a",two = "b",three="c"}) 
end

return FBManager;