local NotifyManager = class("NotifyManager");

function NotifyManager:ctor()
    
end

function NotifyManager.create()
    local temp = NotifyManager.new()
    return temp
end

function NotifyManager:localNotify()
    require("config.notifyConfig");
    --test start IOS做完后删除
    local targetPlatform = cc.Application:getInstance():getTargetPlatform();

    if targetPlatform == cc.PLATFORM_OS_IPHONE or targetPlatform == cc.PLATFORM_OS_IPAD  
    then
        return;
    end
    --test end
    
    local notify = {};
    local current_time = os.time();
    
    --满心通知
    local energyTime = 0;
    if MainValue.mxUIManager.topbar ~= nil then
        energyTime = MainValue.mxUIManager.topbar:getFullTime();
    end
    
    if energyTime > 0
    then
        local energyNotify = {
                                id = 101, 
                                title = LocalNotifyMessage.dialogNotification_title01,
                                text = LocalNotifyMessage.dialogNotification_content01,
                                secondsAfter = energyTime
                             }
    
        table.insert(notify,energyNotify);
    end
    
--daily bonus
    local current_hour = os.date("%H", current_time)
    
    if tonumber(current_hour) < 12
    then
        local dailyNotify = self:getDailyNotify(current_time,0);
        
        if type(dailyNotify) == "table" then table.insert(notify,dailyNotify); end
    end
    
    for addDay=1, 14, 1 do
        local dailyNotify = self:getDailyNotify(current_time,addDay);
        if type(dailyNotify) == "table" then table.insert(notify,dailyNotify); end
    end
    
--2天
    local days2_time = 2*24*60*60;
    local days2Notify = {
        id = 301, 
        title = LocalNotifyMessage.dialogNotification_title04,
        text = LocalNotifyMessage.dialogNotification_content04,
        secondsAfter = days2_time
    }
    table.insert(notify,days2Notify);
--5天
    local days5_time =5*24*60*60;
    local days5Notify = {
        id = 302, 
        title = LocalNotifyMessage.dialogNotification_title05,
        text = LocalNotifyMessage.dialogNotification_content05,
        secondsAfter = days5_time
    }
    table.insert(notify,days5Notify);
--14天
    local days14_time = 14*24*60*60;
    local days14Notify = {
        id = 303, 
        title = LocalNotifyMessage.dialogNotification_title06,
        text = LocalNotifyMessage.dialogNotification_content06,
        secondsAfter = days14_time
    }
    table.insert(notify,days14Notify);
--20天
    local days20_time = 20*24*60*60;
    local days20Notify = {
        id = 304, 
        title = LocalNotifyMessage.dialogNotification_title07,
        text = LocalNotifyMessage.dialogNotification_content07,
        secondsAfter = days20_time
    }
    table.insert(notify,days20Notify);
    
    local function comps(a,b)
        return a.secondsAfter < b.secondsAfter
    end
    
    table.sort(notify,comps);
    
    --[[
    int id 
    std::string title 推送标题
    std::string text 推送信息
    int secondsAfter 延迟多久发送信息
    int iconBadgeNumber 推送信息ICON下标数字
    std::string buttonText 按钮信息
    std::string type 自定义信息
    ]]
    local iconBadgeNumber = 0;
    
    for key, value in pairs(notify) do
        local id = value["id"];
        local title = value["title"];
        local text = value["text"];
        local secondsAfter = value["secondsAfter"];
        
        iconBadgeNumber = iconBadgeNumber + 1;
        --local iconBadgeNumber = id;
        local buttonText = title;
        local dataType = "";
        
        MainValue.platformManager:LNsend(id, 
                                        title, 
                                        text, 
                                        secondsAfter, 
                                        iconBadgeNumber, 
                                        buttonText, 
                                        dataType);
    end
    
end

function NotifyManager:getDailyNotify(time, day)
    local current_time = time;
    local function getTimeByDate(t)
        local time = os.time({year=t.year,month=t.month,day=t.day, hour=t.hour, min=t.min, sec=t.sec});
        return time;
    end
    
    local date = 
        {
            year    = os.date("%Y", current_time),
            month   = os.date("%m", current_time),
            day     = os.date("%d", current_time),
            hour    = "12", 
            min     = "00", 
            sec     = "00"
        }
        
    --local lastDate = date;
    --lastDate.hour = "24";
    
    local daily_time = 0;
    
    if day == 0 
    then
        daily_time = getTimeByDate(date) - current_time; 
    elseif day > 0 
    then 
        local addDate = os.date("*t", getTimeByDate(date) + tonumber(day*24*60*60));
        daily_time = getTimeByDate(addDate) - current_time;
    end
    
    if daily_time > 0 
    then
    
        local dailyNotify = {
            id = (201 + day), 
            title = LocalNotifyMessage.dialogNotification_title02,
            text = LocalNotifyMessage.dialogNotification_content02,
            secondsAfter = daily_time
        }

        return dailyNotify;
    end
    
    return false;
end

function NotifyManager:checkIOSState()
    if MainValue.dataManager ~= nil and MainValue.dataManager.expandManager ~= nil
    then
        local iosNotify = MainValue.dataManager.expandManager:getNotifyIOS();
        
        if type(iosNotify) == "table" and type(iosNotify["iosstate"]) ~= nil
        then
            local iosstate = tonumber(iosNotify["iosstate"]);
            if iosstate == 1 then return true; end
        end
    end
    
    return false;
end

return NotifyManager;