require "sound.ConstEffects"
local SoundManager = class("SoundManager");


function SoundManager:ctor()
    self.layer = cc.Layer:create();
end

---
--返回当前平台能使用的音乐格式
function soundSuffix()
    if device.platform == "android" then
        return "ogg"
    elseif device.platform == "ios" then
        return "caf"
    elseif device.platform == "windows" then
        cc.FileUtils:getInstance():addSearchPath("sound/win32/")
        return "mp3"
    end
    return "mp3"
end

---index =0代表地图上播放  1-5是游戏内播放
function SoundManager:playMusic(index,isLoop)
--    
    print("[SoundManager]:playMusic 播放音乐index::"..index)

    if isLoop then
        print("[SoundManager]:playMusic 播放音乐是循环的")
    else
        print("[SoundManager]:playMusic 播放音乐不循环")
    end


    if MainValue.dataManager.expandManager:getBgMusice() then
        if type(index) ~= "number" or index > 1 then
        	index = 1
        end
        local str = string.format("sound/music/ingame_BGM_%d.%s",index,soundSuffix())
        AudioEngine.playMusic(str,isLoop);
    end
end

--暂停音乐
function SoundManager:pauseMusic()
    AudioEngine.pauseMusic();
end


--关闭音乐
function SoundManager:stopMusic()
    AudioEngine.stopMusic();
end

--继续音乐
function SoundManager:resumeMusic()
	if MainValue.dataManager.expandManager:getBgMusice() then
	    AudioEngine.resumeMusic();
	end
end


--是否在播放
function SoundManager:isMusicPlaying()
   local isPlaying = AudioEngine.isMusicPlaying();
    return isPlaying;
end

--name 音效name 播放音效
function SoundManager:playEffect(name)
    if MainValue.dataManager.expandManager:getEfMusice() == nil or  MainValue.dataManager.expandManager:getEfMusice() == true then
        local str = string.format("sound/effects/%s.%s",name,soundSuffix())
        AudioEngine.playEffect(str);
    end
end



function SoundManager.create()
    local temp = SoundManager.new();
    return temp;
end

return SoundManager