require("statistics/StatisticsManagerBase")

StatisticsManager = {}
setmetatable(StatisticsManager,StatisticsManagerBase)
StatisticsManager.__index = StatisticsManager

function StatisticsManager:new()
	if AppsFlyer then
    	if MainValue.platformManager:isIOS() then
            AppsFlyer.setOption(AppsFlyer.Keys.DEV_KEY, "w6y36ytEm5yNzrGrv5N6qW","1008029159")  
    	else
            AppsFlyer.setOption(AppsFlyer.Keys.DEV_KEY, "w6y36ytEm5yNzrGrv5N6qW","")
    	end
		AppsFlyer.track()
        
	end
    local tempSelf = StatisticsManagerBase:new()
    setmetatable(tempSelf,StatisticsManager)
    
    -- consume type
    tempSelf.buyInGameItem = 1 -- 购买游戏内道具
    tempSelf.buyPreItem    = 2 -- 购买前置道具
    tempSelf.buyStep       = 3 -- 买步数
    tempSelf.buyBlocker    = 4 -- 买blocker
    tempSelf.buyHeart      = 5 -- 买心
    tempSelf.buyBonusCard  = 6 -- 翻牌
    tempSelf.failPackageSave   = 7 -- 失败礼包道具，不包含使用

    -- earn type
    tempSelf.freeGift  = 1 -- 免费礼包
    tempSelf.turnTable = 2 -- 转盘
    tempSelf.firstLogin    = 3 -- 首次登陆
    tempSelf.dailyBonus    = 4 -- 每日奖励
    tempSelf.bonusCard = 5 -- 翻牌奖励
    tempSelf.passLevel = 6 -- 过关
    tempSelf.unlockBlocker = 7 -- 解锁block（实质是 区域奖励跟前三关没block也没区域奖励）
    tempSelf.shareReward   = 8 -- 分享得到的奖励
    tempSelf.chipReward    = 9 -- 花钱买游戏货币就给chip

    -- funnel type
    tempSelf.funnelShop  = "shop"
    tempSelf.funnelPromotions = "promotions"
    tempSelf.funnelInvite     = "invite"
    tempSelf.funnelShare = "share"

    -- funnel action
    tempSelf.actionShow    = 1
    tempSelf.actionClick   = 2
    
    return tempSelf
end

function StatisticsManager:getCustomUrl()
    local fbuid = MainValue.dataManager.userManager:getPID();   -- 如果没有登陆facebook ID，传空值（判断修改）
    local pkg_version = MainValue.platformManager:getAppVersion();   -- Pkg包版本号（发给tango的版本，需手动更新）（修改）
    local open_maxlevel = 1 -- 开放的最大关卡（修改）
    local locate = MainValue.platformManager:getCountry();  -- 地理位置如CN，US...（修改）
    local debug = 1 -- 测试版所带的参数，正式不带
    local max_level = MainValue.dataManager.levelManager:getMaxLevel();
    return self:getURL().."&_log=1&event=custom&fbuid="..fbuid.."&pkg_version="..pkg_version.."&max_level="..max_level.."&local="..locate
end

-- Fire the request when users begin the tutorial. 
-- If the game required download assets before the game play, fire the request after user finished download.
function StatisticsManager:CustomTutorialBegin()
    local url = self:getCustomUrl()
    local resUrl = url.."&event=tutorial&status=b&tc=b";
  --  self:sendRequest( resUrl );
end

-- Fire the request when users completed the tutorial.
function StatisticsManager:CustomTutorialComplete()

    local url = self:getCustomUrl()
    local resUrl = url.."&event=tutorial&status=c&tc=c";
    self:sendRequest( resUrl );
       
   -- self:TutorialComplete()
end

--过关
--param
--      result          1=成功，其他为失败 Failure Reasonsid根据每个游戏的配置定义，如array(-1),array(-1,-2)
--      consumables:int 过关是否使用过道具物品 , 1 使用, 0 未使用
--      level:int           当前过关的关卡level
--      max_level:int       用户最大level
--      star:int            当前局所获得的星星数
--      play_time:int       用户该局用的时间，单位秒
--      items:string        本关卡失败所差收集物和个数，json字符串 ‘[{904：10}，{400：10}，{500：2}]’
function StatisticsManager:play( result, used_consumables, level, star, play_time, items )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=play&result="..result.."&used_consumables="..used_consumables.."&level="..level.."&star="..star.."&play_time="..play_time.."&items="..items
    self:sendRequest( resUrl );
end

function StatisticsManager:lose( result, used_consumables, level, star, play_time, items )
    local resultLength = table.maxn(result);
    local itemsLength = table.maxn(items);
    local tempresult = "[-1,";
    for i in ipairs(result) do
        tempresult = tempresult..result[i]
        if i ~= resultLength then
            tempresult = tempresult..",";
        end;
    end
    tempresult = tempresult.."]";

    local tempitems = "["
    
    for j in ipairs(items) do
        
        tempitems = tempitems.."{".."\""..items[j][1].."\""..":"..items[j][2].."}";
        
        if j ~= itemsLength then
            tempitems = tempitems..",";
        end;
    end
    tempitems = tempitems.."]";
    
    local url = self:getCustomUrl()
    local resUrl = url.."&m=play&result="..tempresult.."&used_consumables="..used_consumables.."&level="..level.."&star="..star.."&play_time="..play_time.."&items="..tempitems
    self:sendRequest( resUrl );
end


function StatisticsManager:win( used_consumables, level, star, play_time )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=play&result=1".."&used_consumables="..used_consumables.."&level="..level.."&star="..star.."&play_time="..play_time
    self:sendRequest( resUrl );
end
--shopBuy充值购买
--param
--     shopId      根据每个游戏的配置定义
--     price:int   充值该物品的价格，传facebook币
--     currency:string  货币类型
--     coins:int       充值时该shop对应的coins
--     cash:int        充值时该shop对应的cash
--     level:int       充值时用户所在的level，如果没有传最大level
--     lives_left:int  充值时用户剩余life值
--     coins_left:int  充值时用户剩余coins值
--     cash_left:int   充值时用户剩余cash值
function StatisticsManager:shopBuy( shopId, price, currency, coins, cash, level, lives_left, coins_left, cash_left )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=buy&shop_id="..shopId.."&price="..price.."&coins="..coins.."&cash="..cash.."&level="..level.."&lives_left="..lives_left.."&coins_left="..coins_left.."&cash_left="..cash_left
    self:sendRequest( resUrl )
	if AppsFlyer then
		AppsFlyer.trackPurchase({id=shopId, price=price, currency=currency})
	end
end

--用户登陆，点击开始游戏时发送
--param
--     ref:String  用户登录来源 ，如 facebook,tango,self_server等等
function StatisticsManager:loginWeb( ref )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=login&ref="..ref
    self:sendRequest( resUrl )
end

--不使用道具，满足将近成功条件的失败，发送此接口
--param
--     level:int  用户所在的level
--     almost:string    值为 1 
function StatisticsManager:playAlmost( level, almost )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=playalmost&level="..level.."&almost="..almost
    self:sendRequest( resUrl )
end

-- ----------------------------- 消耗coins,cash统计 ------------------------------------
--购买游戏内道具
--param
--     itemId:int  item ID
--     itemNum:int item 数量
--     coins:int   该物品对应的coins
--     cash:int    该物品对应的cash
--     level:int   购买物品时用户所在的level，如果没有传最大level
--     lives_left:int  剩余life值
--     coins_left:int  剩余coins值
--     cash_left:int   剩余cash值
--     consume_type:int   值为 1 买道具存储起来，否则发送 -1
function StatisticsManager:consumeBuyInGameItem( itemId, itemNum, coins, cash, level, lives_left, coins_left, cash_left, consume_type )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=consume&type="..self.buyInGameItem.."&itemId="..itemId.."&itemNum="..itemNum.."&coins="..coins.."&cash="..cash.."&level="..level.."&lives_left="..lives_left.."&coins_left="..coins_left.."&cash_left="..cash_left.."&consume_type="..consume_type
    self:sendRequest( resUrl )
end

--前置道具
--param
--     itemId:int  item ID
--     itemNum:int item 数量
--     coins:int   该物品对应的coins
--     cash:int    该物品对应的cash
--     level:int   购买物品时用户所在的level，如果没有传最大level
--     lives_left:int  剩余life值
--     coins_left:int  剩余coins值
--     cash_left:int   剩余cash值
--     consume_type:int   值为 1 买道具存储起来，否则发送 -1
function StatisticsManager:consumeBuyPreItem( itemId, itemNum, coins, cash, level, lives_left, coins_left, cash_left, consume_type )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=consume&type="..self.buyPreItem.."&itemId="..itemId.."&itemNum="..itemNum.."&coins="..coins.."&cash="..cash.."&level="..level.."&lives_left="..lives_left.."&coins_left="..coins_left.."&cash_left="..cash_left.."&consume_type="..consume_type
    self:sendRequest( resUrl )
end

--买步数
--param
--     itemId:int  item ID
--     itemNum:int item 数量
--     coins:int   该物品对应的coins
--     cash:int    该物品对应的cash
--     level:int   购买物品时用户所在的level，如果没有传最大level
--     lives_left:int  剩余life值
--     coins_left:int  剩余coins值
--     cash_left:int   剩余cash值
--     consume_type:int   值为 1 买道具存储起来，否则发送 -1
function StatisticsManager:consumeBuyStep( itemId, itemNum, coins, cash, level, lives_left, coins_left, cash_left, consume_type )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=consume&type="..self.buyStep.."&itemId="..itemId.."&itemNum="..itemNum.."&coins="..coins.."&cash="..cash.."&level="..level.."&lives_left="..lives_left.."&coins_left="..coins_left.."&cash_left="..cash_left.."&consume_type="..consume_type
    self:sendRequest( resUrl )
end

--买blocker
--param
--     itemId:int  item ID
--     itemNum:int item 数量
--     coins:int   该物品对应的coins
--     cash:int    该物品对应的cash
--     level:int   购买物品时用户所在的level，如果没有传最大level
--     lives_left:int  剩余life值
--     coins_left:int  剩余coins值
--     cash_left:int   剩余cash值
--     consume_type:int   值为 1 买道具存储起来，否则发送 -1
function StatisticsManager:consumeBuyBlocker( itemId, itemNum, coins, cash, level, lives_left, coins_left, cash_left, consume_type )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=consume&type="..self.buyBlocker.."&itemId="..itemId.."&itemNum="..itemNum.."&coins="..coins.."&cash="..cash.."&level="..level.."&lives_left="..lives_left.."&coins_left="..coins_left.."&cash_left="..cash_left.."&consume_type="..consume_type
    self:sendRequest( resUrl )
end

--买心
--param
--     itemId:int  item ID
--     itemNum:int item 数量
--     coins:int   该物品对应的coins
--     cash:int    该物品对应的cash
--     level:int   购买物品时用户所在的level，如果没有传最大level
--     lives_left:int  剩余life值
--     coins_left:int  剩余coins值
--     cash_left:int   剩余cash值
--     consume_type:int   值为 1 买道具存储起来，否则发送 -1
function StatisticsManager:consumeBuyHeart( itemId, itemNum, coins, cash, level, lives_left, coins_left, cash_left, consume_type )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=consume&type="..self.buyHeart.."&itemId="..itemId.."&itemNum="..itemNum.."&coins="..coins.."&cash="..cash.."&level="..level.."&lives_left="..lives_left.."&coins_left="..coins_left.."&cash_left="..cash_left.."&consume_type="..consume_type
    self:sendRequest( resUrl )
end

--买翻牌
--param
--     itemId:int  item ID
--     itemNum:int item 数量
--     coins:int   该物品对应的coins
--     cash:int    该物品对应的cash
--     level:int   购买物品时用户所在的level，如果没有传最大level
--     lives_left:int  剩余life值
--     coins_left:int  剩余coins值
--     cash_left:int   剩余cash值
--     consume_type:int   值为 1 买道具存储起来，否则发送 -1
function StatisticsManager:consumeBuyBonusCard( itemId, itemNum, coins, cash, level, lives_left, coins_left, cash_left, consume_type )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=consume&type="..self.buyBonusCard.."&itemId="..itemId.."&itemNum="..itemNum.."&coins="..coins.."&cash="..cash.."&level="..level.."&lives_left="..lives_left.."&coins_left="..coins_left.."&cash_left="..cash_left.."&consume_type="..consume_type
    self:sendRequest( resUrl )
end

--失败提示购买的打包道具，不包含使用
--param
--     itemId:int  item ID
--     itemNum:int item 数量
--     coins:int   该物品对应的coins
--     cash:int    该物品对应的cash
--     level:int   购买物品时用户所在的level，如果没有传最大level
--     lives_left:int  剩余life值
--     coins_left:int  剩余coins值
--     cash_left:int   剩余cash值
--     consume_type:int   值为 1 买道具存储起来，否则发送 -1
function StatisticsManager:consumeFailPackageSave( itemId, itemNum, coins, cash, level, lives_left, coins_left, cash_left, consume_type )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=consume&type="..self.failPackageSave.."&itemId="..itemId.."&itemNum="..itemNum.."&coins="..coins.."&cash="..cash.."&level="..level.."&lives_left="..lives_left.."&coins_left="..coins_left.."&cash_left="..cash_left.."&consume_type="..consume_type
    self:sendRequest( resUrl )
end
-- ----------------------------- 消耗coins,cash统计   end-------------------------------------

-- ----------------------------- 赚取coins,cash,chip统计 ------------------------------------
--免费礼包
--param
--     coins:int   赚取的coins数
--     cash:int    赚取的cash数
function StatisticsManager:earnedFreeGift( coins, cash )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=earned&type="..self.freeGift.."&coins="..coins.."&cash="..cash
    self:sendRequest( resUrl )
end

--转盘
--param
--     coins:int   赚取的coins数
--     cash:int    赚取的cash数
function StatisticsManager:earnedTurnTable( coins, cash )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=earned&type="..self.turnTable.."&coins="..coins.."&cash="..cash
    self:sendRequest( resUrl )
end

--首次登陆
--param
--     coins:int   赚取的coins数
--     cash:int    赚取的cash数
function StatisticsManager:earnedFirstLogin( coins, cash )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=earned&type="..self.firstLogin.."&coins="..coins.."&cash="..cash
    self:sendRequest( resUrl )
end

--每日登陆
--param
--     coins:int   赚取的coins数
--     cash:int    赚取的cash数
function StatisticsManager:earnedDailyBonus( coins, cash,itemId,itemNum)
    local url = self:getCustomUrl()
    local resUrl = url.."&m=earned&type="..self.dailyBonus.."&coins="..coins.."&cash="..cash.."&itemId="..itemId.."&itemNum="..itemNum
    self:sendRequest( resUrl )
end

--翻牌
--param
--     coins:int   赚取的coins数
--     cash:int    赚取的cash数
function StatisticsManager:earnedBonusCard( coins, cash )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=earned&type="..self.bonusCard.."&coins="..coins.."&cash="..cash
    self:sendRequest( resUrl )
end

--过关奖励
--param
--     coins:int   赚取的coins数
--     cash:int    赚取的cash数
function StatisticsManager:earnedPassLevel( coins, cash )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=earned&type="..self.passLevel.."&coins="..coins.."&cash="..cash
    self:sendRequest( resUrl )
end

--解锁blocker
--param
--     coins:int   赚取的coins数
--     cash:int    赚取的cash数
function StatisticsManager:earnedUnlockBlocker( coins, cash )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=earned&type="..self.unlockBlocker.."&coins="..coins.."&cash="..cash
    self:sendRequest( resUrl )
end

--分享的奖励
--param
--     coins:int   赚取的coins数
--     cash:int    赚取的cash数
function StatisticsManager:earnedShareReward( coins, cash )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=earned&type="..self.shareReward.."&coins="..coins.."&cash="..cash
    self:sendRequest( resUrl )
end

--分享的奖励
--param
--     coins:int   赚取的coins数
--     cash:int    赚取的cash数
--     cash:int    赚取的chip数
function StatisticsManager:earnedChipReward( coins, cash, chipnum )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=earned&type="..self.chipReward.."&coins="..coins.."&cash="..cash.."&chipnum="..chipnum
    self:sendRequest( resUrl )
end
-- ----------------------------- 赚取coins,cash,chip统计   end----------------------------------

-- ----------------------------- 用户行为统计 -------------------------------------------------
--弹开shop的信息
--param
--     source:String   弹开shop类型的来源 (itemId(游戏中钱不够时弹出的界面) | addbutton(web界面的按钮) | addcash(cash后面的加号) | addcoin(coins后面的加号))
function StatisticsManager:funnelShopOpen( source )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=funnel&type="..self.funnelShop.."&source="..source.."&action="..self.actionShow
    self:sendRequest( resUrl )
end

--弹开shop 并购买
--param
--     source:String   弹开shop类型的来源 (itemId(游戏中钱不够时弹出的界面) | addbutton(web界面的按钮) | addcash(cash后面的加号) | addcoin(coins后面的加号))
function StatisticsManager:funnelShopBuy( source )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=funnel&type="..self.funnelShop.."&source="..source.."&action="..self.actionClick
    self:sendRequest( resUrl )
end

--弹开促销的信息
--param
--     source:String   弹开promotions漏类型的来源 source=fail3
function StatisticsManager:funnelPromotionsOpen( source )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=funnel&type="..self.funnelPromotions.."&source="..source.."&action="..self.actionShow
    self:sendRequest( resUrl )
end

--弹开促销并购买
--param
--    source:String   弹开promotions漏类型的来源 source=fail3
function StatisticsManager:funnelPromotionsBuy( source )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=funnel&type="..self.funnelPromotions.."&source="..source.."&action="..self.actionClick
    self:sendRequest( resUrl )
end

--弹开邀请
--param
--     source:String   弹开邀请的来源
function StatisticsManager:funnelInviteOpen( source )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=funnel&type="..self.funnelInvite.."&source="..source.."&action="..self.actionShow
    self:sendRequest( resUrl )
end

--弹开邀请并发送
--param
--     source:String   弹开邀请的来源
function StatisticsManager:funnelInviteSend( source )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=funnel&type="..self.funnelInvite.."&source="..source.."&action="..self.actionClick
    self:sendRequest( resUrl )
end

--弹开分享
--param
--     source:String   弹开分享的来源
function StatisticsManager:funnelShareOpen( source )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=funnel&type="..self.funnelShare.."&source="..source.."&action="..self.actionShow
    self:sendRequest( resUrl )
end

--弹开分享并发送
--param
--     source:String   弹开分享的来源
function StatisticsManager:funnelShareSend( source )
    local url = self:getCustomUrl()
    local resUrl = url.."&m=funnel&type="..self.funnelShare.."&source="..source.."&action="..self.actionClick
    self:sendRequest( resUrl )
end
-- ----------------------------- 用户行为统计  end-----------------------------------------------
