require("os")

StatisticsManagerBase = {}
StatisticsManagerBase.__index = StatisticsManagerBase

function StatisticsManagerBase:new()
    local tempSelf = {}
    setmetatable(tempSelf, StatisticsManagerBase)
    
    tempSelf.ANDROID_APPID = "0035581217694ee7"      -- android应用ID
    tempSelf.AppID = "0015581225b7b095" -- apple应用ID
    tempSelf.SixWaveURL = "http://mobile.6waves.com/trk/rest.php?v=1"  -- 发送到香港平台统计的URL
    
    
    
    tempSelf.type = "";
    local targetPlatform = cc.Application:getInstance():getTargetPlatform();
    if targetPlatform == cc.PLATFORM_OS_ANDROID then
        tempSelf.type = "android"
    elseif targetPlatform == cc.PLATFORM_OS_IPHONE then 
        tempSelf.type = "iPhone"
    elseif targetPlatform == cc.PLATFORM_OS_IPAD  then
        tempSelf.type = "iPad"
    else 
        tempSelf.type = "ipod"
    end;
    
    tempSelf.appVersion = MainValue.platformManager:getAppVersion();
    
    tempSelf.android_UUID = MainValue.platformManager:getUUID();
    tempSelf.androidID = MainValue.platformManager:getAndroidID();
    tempSelf.android_Mac = MainValue.platformManager:getMac();
    
    
    tempSelf.android_gudid = MainValue.platformManager:MD5(tempSelf.android_UUID..tempSelf.android_Mac);
    
    return tempSelf
end

function StatisticsManagerBase:getURL()
   
    local url = ""
   
   
    
    -- 组合发送url（修改）
    if self.type== "android" then
        self.type = "android"
        local udid = self.androidID;
        local gudid = self.android_gudid;
        local mac = self.android_Mac;
        
        url = self.SixWaveURL.."&appid="..self.ANDROID_APPID
        url = url.."&app_version="..self.appVersion
        url = url.."&ts="..os.time()
        url = url.."&t="..self.type
        url = url.."&gudid="..gudid
        url = url.."&mac="..mac
        url = url.."&udid="..udid
    else
        local adid = "AirDeviceId"
        local vid = "AirDeviceId"
                
        url = self.SixWaveURL.."&appid="..self.AppID
        url = url.."&app_version="..self.appVersion
        url = url.."&ts="..os.time()
        url = url.."&t="..self.type
        url = url.."&gudid="..vid -- MD5.hash( adid + vid )
        url = url.."&adid="..adid
        url = url.."&vid="..vid
    end
    
    return url
end

function StatisticsManagerBase:sendRequest(url, isOG)
    -- 如果是OG，需要登陆facebook才能发送（修改）
    --if isOG then
       -- if MainValue.fbManager:getIsLogin()== false then
            --return
       -- end;
   -- end
    print("[StatisticsManagerBase]--Statistics------StatisticsManagerBase-"..url)
    local xhr = cc.XMLHttpRequest:new()
    xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_STRING
    xhr:open("POST", url)
    
    local function onReadyStateChange()
        if xhr.readyState == 4 and (xhr.status >= 200 and xhr.status < 207) then
            print("[StatisticsManagerBase]--sendRequest Response: "..xhr.response)
        else
            print("[StatisticsManagerBase]--xhr.readyState is:", xhr.readyState, "xhr.status is: ",xhr.status)
        end
    end
    
    xhr:registerScriptHandler(onReadyStateChange)
    xhr:send()
end
