require("statistics/StatisticsManagerBase")

StatisticsManagerOG = {}
setmetatable(StatisticsManagerOG,StatisticsManagerBase)
StatisticsManagerOG.__index = StatisticsManagerOG

function StatisticsManagerOG:new()
    local tempSelf = {}
    tempSelf = StatisticsManagerBase:new()
    setmetatable(tempSelf,StatisticsManagerOG)
    return tempSelf
end

function StatisticsManagerOG:getOGUrl()
    local fbuid = MainValue.dataManager.userManager:getPID();
    return self:getURL().."&fbuid="..fbuid
end

-- Fire the request when users start to play the game or resume the game from background.
function StatisticsManagerOG:Access()
    local url = self:getOGUrl()
    url = url.."&event=access"
    self:sendRequest( url, true )
end

-- Fire the request when users completed a transaction.
function StatisticsManagerOG:Purchase(id, val, currency)
    local url = self:getOGUrl()
    url = url.."&event=purchase"
    url = url.."&item="..id
    url = url.."&val="..val
    url = url.."&currency="..currency
    self:sendRequest( url, true )
end

-- Fire the request when users begin the tutorial. 
-- If the game required download assets before the game play, fire the request after user finished download.
function StatisticsManagerOG:CustomTutorialBegin()
    local url = self:getOGUrl()
    url = url.."&event=tutorial&status=b&tc=b"
    self:sendRequest( url, true )
end

-- Fire the request when users completed the tutorial.
function StatisticsManagerOG:CustomTutorialComplete()
    local url = self:getOGUrl()
    url = url.."&event=tutorial&status=c&tc=c"
    self:sendRequest( url, true )
end

-- Fire the request when user connected with facebook   已加-----------
function StatisticsManagerOG:fbConnect()
    local url = self:getOGUrl()
    local fbuid = MainValue.dataManager.userManager:getPID(); -- 获取facebook ID（修改）
    local resUrl = url.."&event=fbconnect&fbid="..fbuid;
    self:sendRequest( resUrl, true );
end

-- Fire the request when users start to play the game or resume the game from background. 
function StatisticsManagerOG:levelStart(level_user, level_kingdom, level_guild, level_pvp, level_map)
    local url = self:getOGUrl()
    local resUrl = url.."&event=level";
    resUrl = resUrl.."&level_user="..level_user
    resUrl = resUrl.."&level_kingdom="..level_kingdom
    resUrl = resUrl.."&level_guild="..level_guild
    resUrl = resUrl.."&level_pvp="..level_pvp
    resUrl = resUrl.."&level_map="..level_map
    self:sendRequest( resUrl, true );
end

-- Fire the request when users start to play the game or resume the game from background. 
function StatisticsManagerOG:levelLife(life_balance_1, life_balance_2)
    local url = self:getOGUrl()
    local resUrl = url.."&event=life";
    resUrl = resUrl.."&life_balance_1="..life_balance_1
    resUrl = resUrl.."&life_balance_2="..life_balance_2
    self:sendRequest( resUrl, true );
end

-- Fire the request when users start to play the game or resume the game from background. 
function StatisticsManagerOG:levelCurrency(currency_balance_1, currency_balance_2, currency_balance_3)
    local url = self:getOGUrl()
    local resUrl = url.."&event=currency";
    resUrl = resUrl.."&currency_balance_1="..currency_balance_1
    resUrl = resUrl.."&currency_balance_2="..currency_balance_2
    resUrl = resUrl.."&currency_balance_3="..currency_balance_3
    self:sendRequest( resUrl, true );
end

