local TipsManager = class("TipsManager");

function TipsManager:ctor()
    self.layer = cc.Layer:create();
    
    
    self.tipsLayer = nil; 
    self.tipsBg = nil; --tips背景板
    self.roleIcon = nil; --角色图片
    
    self.bgW = 357;
    self.bgH = 120;
    
    self.DIRECTION_LEFT = "DIRECTION_LEFT";
    self.DIRECTION_RIGHT = "DIRECTION_RIGHT";
    
    self.ROLE_GIRL = 1;
    self.ROLE_LION = 2;
    self.ROLE_IRON = 3;
    self.ROLE_STRAW = 4;
end

function TipsManager.create()
    local temp = TipsManager.new(); 
    temp:init();   
    return temp;
end

function TipsManager:init()

end

---- 显示Tips ----
--
-- tipsStr:tips文本
-- posX:x坐标
-- posY:y坐标
-- dir:方向
-- roleType:角色图标类型
-- 
function TipsManager:showTips(tipsStr, posX, posY, dir, roleType)
    if self.tipsLayer == nil then
        self.tipsLayer = cc.Layer:create();
        self.layer:addChild(self.tipsLayer);

        self.tipsBg = NineGridTools.create("ui/ui/bgTips.png" , self.bgW , self.bgH , 32)
        self.tipsLayer:addChild(self.tipsBg);
        
        self.roleIcon = self:getRoleIcon(roleType);
        self.roleIcon:setScale(0.56);
        self.roleIcon:setPositionX(self.bgW / 2 - self.roleIcon:getContentSize().width * 0.56 / 2);
        self.roleIcon:setPositionY(self.roleIcon:getContentSize().height * 0.56 / 2 - self.bgH / 2 + 20);
        self.tipsLayer:addChild(self.roleIcon);
        
        local labelWidth = self.bgW - self.roleIcon:getContentSize().width * 0.56 + 80;
        self.tipsLabel = FacFont:getFontsBmp(FontType.FontYellowNoSide,tipsStr, labelWidth, "L");
        self.tipsLabel:setScale(0.8)
        self.tipsLabel:setAnchorPoint(0.5, 0.5)
        self.tipsLabel:setPositionX(labelWidth / 2 - self.bgW / 2 - 20);
        self.tipsLabel:setPositionY(self.tipsLabel:getContentSize().height / 2 - self.bgH / 2 + 12);
        self.tipsLayer:addChild(self.tipsLabel);
        
        if dir == self.DIRECTION_LEFT then
            self.tipsLayer:setPosition(posX - (self.bgW / 2 + 60), posY);
        elseif dir == self.DIRECTION_RIGHT then
            self.tipsLayer:setPosition(posX + (self.bgW / 2 + 60), posY);
        end
    end
end

--隐藏Tips
function TipsManager:hideTips()
    if self.tipsLayer ~= nil then
        self.tipsLayer:removeFromParent(true);
         self.tipsLayer = nil;
    end
end

function TipsManager:getRoleIcon(roleType)
    local rolePath = nil;
    if roleType == self.ROLE_GIRL then
        rolePath = "ui/ftue/1.png";
    elseif roleType == self.ROLE_IRON then
        rolePath = "ui/ftue/3.png";
    elseif roleType == self.ROLE_STRAW then
        rolePath = "ui/ftue/4.png";
    elseif roleType == self.ROLE_LION then
        rolePath = "ui/ftue/2.png";
    end
    return cc.Sprite:create(rolePath);
end

--进入游戏开始界面
function TipsManager:onEnterSplash()

end

--退出游戏开始界面
function TipsManager:onExitSplash()

end 

--进入地图
function TipsManager:onEnterMap()

end 

--退出地图
function TipsManager:onExitMap()

end

--进入游戏
function TipsManager:onEnterGame()

end
--onEnteredGame

--退出游戏
function TipsManager:onExitGame()

end

--回退键功能 
function TipsManager:backPack()

end
return TipsManager;