UtilHelp = class("UtilHelp")

function UtilHelp:formatTime(seconds, hour, min)
    if hour == nil then hour = true end;
    if min == nil then min = true end;

    local timeData = "";

    if seconds < 0 then seconds = 0 end;

    if hour then
        local h = math.floor(seconds / 3600);
        if h >= 10 then 
            timeData = timeData .. h .. ":" ;
        else
            timeData = timeData .. "0" .. h .. ":";
        end  
    end

    if min then
        local m = math.floor((seconds / 60) % 60);
        if m >= 10 then
            timeData = timeData .. m .. ":";
        else
            timeData = timeData .. "0" .. m .. ":";
        end
    end
    
    local s = math.floor(seconds % 60);
    if s >= 10 then
        timeData = timeData .. s;
    else
        timeData = timeData .. "0" .. s;
    end
    return timeData;
end

function UtilHelp:copyTab(st)
    local tab = {}
    for k, v in pairs(st or {}) do
        if type(v) ~= "table" then
            tab[k] = v
        else
            tab[k] = self:copyTab(v)
        end
    end
    return tab
end