require "engine.uigridtools.ThreeLMRGridTools"
require "engine.uigridtools.NineGridTools"

local AskForHelp = class("AskForHelp", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/AskForHelp.json");
end)

function AskForHelp:ctor()
    self.titleLab = nil;
    self.selLab = nil;
    self.inviteLab = nil;
    
    self.windowBg = nil;
    self.upBoundBg = nil;
    self.underBoundBg = nil;
    
    self.sendFriIds = nil;--发送请求的好友列表
    
    self.allBtn = nil;
    self.sundaeBtn = nil;
    
    self.allListView = nil;
    self.sundaeListView = nil;
    
    self.curIndex = 1;
end

function AskForHelp.create(helpType)
    local temp = AskForHelp.new();
    temp:init();
    return temp;
end

function AskForHelp:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);
    
--    self.windowBg = NineGridTools.create("ui/ui/rankMeBg.png", 562, 513, 54)
--    self.windowBg:setPositionY(-50)
--    self:addChild(self.windowBg);
    
    self.upBoundBg = ThreeLMRGridTools.create("ui/ui/bgUpBound.png", 478, 33);
    self.upBoundBg:setPositionY(204);
    self:addChild(self.upBoundBg);
    
    self.underBoundBg = ThreeLMRGridTools.create("ui/ui/bgDownBound.png", 478, 33);
    self.underBoundBg:setPositionY(-288);
    self:addChild(self.underBoundBg);

    self.titleLab = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, MainValue.infosManager:getObjMultilingualByKey("AskForHelp_Title"))
    self.titleLab:setPositionY(398);
    self:addChild(self.titleLab);
    
    self.selLab = FacFont:getFontsBmp(FontType.FontRed, MainValue.infosManager:getObjMultilingualByKey("PanelFirst1_2"))
    self.selLab:setScale(0.8)
    self.selLab:setPosition(26, -310);
    self:addChild(self.selLab);
    
    local closebtn = self:getChildByName("BtnClose");
    local function closeTouchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            if self.isAloneShow then
                self:disapperAlone();
            else
                self:disapper();
            end
        end
    end
    closebtn:addTouchEventListener(closeTouchEvent);
    
    self.inviteBtn = self:getChildByName("BtnInvite");
    self.inviteLab = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("Sendlife_btn"))
    self.inviteLab:setPosition(118, 64);
    self.inviteBtn:addChild(self.inviteLab);
    
    local function inviteTouchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            local function cf()
            end
            MainValue.actionManager:createJellyAction():run(sender,40,cf);
            
            self:sendMes();
        end
    end
    self.inviteBtn:addTouchEventListener(inviteTouchEvent);
    
    self.checkBox = self:getChildByName("CheckBoxAll");
    self.checkBox:setSelected(true);
    
    local function selectedEvent(sender, eventType)
        if eventType == ccui.CheckBoxEventType.selected then
            self:setCheckBoxSelect(true);
        elseif eventType == ccui.CheckBoxEventType.unselected then
            self:setCheckBoxSelect(false);
        end
    end
    self.checkBox:addEventListener(selectedEvent) 
    

    local tabButtonClz = require("ui/AskForHelp/TabButton")

    local function btnClickCallBack(index)
        self:changeTab(index)
    end

    self.allBtn = tabButtonClz.create(1, "All Friends", btnClickCallBack)
    self.allBtn:setPosition(-108, 274);
    self.allBtn:setAnchorPoint(0,0);
    self.allBtn:setScale(0.85);
    self:addChild(self.allBtn);

    self.sundaeBtn = tabButtonClz.create(2, "Oz Friends", btnClickCallBack)
    self.sundaeBtn:setPosition(109, 274);
    self.sundaeBtn:setAnchorPoint(0,0);
    self.sundaeBtn:setScale(0.85);
    self:addChild(self.sundaeBtn);
    
    self:changeTab(1)
end

--[[切换分页]]
function AskForHelp:changeTab(index)

    self.curIndex = index;
    
    if index == 1 then
    
        if self.allListView == nil then
            local askHelpWindowClz = require("ui/AskForHelp/AskHelpWindow");

            local function cellClickCallBack()
                self:setSelectState();
            end
            
            self.allListView = askHelpWindowClz.create(cellClickCallBack, 1);
            self.allListView:setPosition(-254, -253)
            self:addChild(self.allListView);
        end
        
        self.allBtn:setSelected(true);
        self.sundaeBtn:setSelected(false);
        
        self.allListView:setVisible(true);
        
        if self.sundaeListView ~= nil then
            self.sundaeListView:setVisible(false);
        end
        
    elseif index == 2 then
    
        if self.sundaeListView == nil then
            local askHelpWindowClz = require("ui/AskForHelp/AskHelpWindow");

            local function cellClickCallBack()
                self:setSelectState();
            end
            
            self.sundaeListView = askHelpWindowClz.create(cellClickCallBack, 2);
            self.sundaeListView:setPosition(-254, -253)
            self:addChild(self.sundaeListView);
        end
        
        self.allBtn:setSelected(false);
        self.sundaeBtn:setSelected(true);
        
        if self.allListView ~= nil then
            self.allListView:setVisible(false);
        end
        self.sundaeListView:setVisible(true);
    end
    
    self:setSelectState();
end

--更新全选状态
function AskForHelp:setSelectState()
    local curWindow = nil;

    if self.curIndex == 1 then
        curWindow = self.allListView;
    elseif self.curIndex == 2 then
        curWindow = self.sundaeListView;
    end
    
    if curWindow:getSelectedState() == 0 then
        self:setBtnBright(false);
        self.checkBox:setSelected(false);

    elseif curWindow:getSelectedState() == 1 then
        self:setBtnBright(true);
        self.checkBox:setSelected(true);

    elseif curWindow:getSelectedState() == 2 then
        self:setBtnBright(true);
        self.checkBox:setSelected(false);
    end
end

function AskForHelp:setCheckBoxSelect(boo)
    if self.curIndex == 1 then
        self.allListView:setSelect(boo);
        self:setBtnBright(boo);
    elseif self.curIndex == 2 then
        self.sundaeListView:setSelect(boo);
        self:setBtnBright(boo);
    end
end

function AskForHelp:setBtnBright(boo)
    self.inviteBtn:setTouchEnabled(boo)
    self.inviteBtn:setBright(boo)
end

--发送请求消息
function AskForHelp:sendMes()
    
    local curWindow = nil;
    if self.curIndex == 1 then
        curWindow = self.allListView;
    elseif self.curIndex == 2 then
        curWindow = self.sundaeListView;
    end
    
    self.sendFriIds = curWindow:getSendFris();
    
    if self.sendFriIds ~= nil and table.maxn(self.sendFriIds) ~= 0 then
        local len = table.maxn(self.sendFriIds);
        
        if len > 50 then  --最多只能同时发送50个好友，做限制
            local sendTeamFifty = {};
            local friCount = 0;
            for i = 1, len do
            
                friCount = friCount + 1;
                
                if friCount <= 50 then
                    table.insert(sendTeamFifty, self.sendFriIds[i]);
                else
                
                    MainValue.fbManager:askHeart(sendTeamFifty);
                    sendTeamFifty = {};
                    friCount = 0;
                    i = i - 1;
                end
            end
            
            if sendTeamFifty ~= nil then
                MainValue.fbManager:askHeart(sendTeamFifty);
            end
        else
            MainValue.fbManager:askHeart(self.sendFriIds);
        end
    end
    
    self:disapperAlone();
end

function AskForHelp:appear()
    self.isAloneShow = false
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disapper);
end

function AskForHelp:appearAlone()
    self.isAloneShow = true
    MainValue.mxUIManager.panelManager:addPanelAlone(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disapperAlone);
end

function AskForHelp:appearComplete()
    self.allListView:showAllCell();
end

function AskForHelp:disapper()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_DOWN , self.disapperComplete)
end

function AskForHelp:disapperAlone()
    MainValue.mxUIManager.panelManager:removePanelAlone(self, PanelDisappearType.LEAVE_DOWN, self.disapperComplete)
end


function AskForHelp:disapperComplete()
    self:removeFromParent(true);
end

return AskForHelp;