require "engine.uigridtools.NineGridTools"

local AskHelpCell = class("AskHelpCell", function()
    return ccui.Button:create();
end)

function AskHelpCell:ctor()
    self.data = nil;
    
    self.nameLab = nil;
    self.headFrame = nil;
    self.headPic = nil;
    self.selectBg = nil;
    self.tickIcon = nil;
    
    self.isSelect = true;
    
    self.callBack = nil;
end

function AskHelpCell.create(friData, callBack)
    local temp = AskHelpCell.new();
    temp.data = friData;
    temp.callBack = callBack;
    temp:init();
    return temp;
end

function AskHelpCell:init()

    local function touchEvent(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            self:setSelect(not self.isSelect);
            
            self.callBack();
        end
    end
    
    self:setTouchEnabled(true)
    self:setScale9Enabled(true)
    self:loadTextures("ui/ui/bgBox.png", "ui/ui/bgBox.png")
    self:setContentSize(cc.size(136, 136))
    self:setOpacity(0);
    self:addTouchEventListener(touchEvent)
    
    local function friHeadFunc(id, url)
        if self.headPic ~= nil then
            self.headPic:release();
        end
    end
    
    self.headPic = cc.Sprite:create();
    self.headPic:setContentSize(105, 105);
    self.headPic:setPosition(73, 89);
    self.headPic:retain();
    self:addChild(self.headPic);
    MainValue.platformManager:FBloadImage(self.data.id, self.data.picture, self.headPic, friHeadFunc);
    
    self.headFrame = NineGridTools.create("ui/ui/bgFrameS.png" , 144 , 144 , 32);
    self.headFrame:setPosition(78, 68);
    self.headFrame:setAnchorPoint(1,1)
    self:addChild(self.headFrame); 
    
    self.nameLab = FacFont:getFontsBmp(FontType.FontYellowWhiteSide, self.data.username)
    self.nameLab:setPosition(75, 172);
    self:addChild(self.nameLab);
    
    self.selectBg = cc.Sprite:createWithSpriteFrameName("ui/ui/checkBox.png")
    self.selectBg:setScale(1.1)
    self.selectBg:setPosition(119, 45);
    self:addChild(self.selectBg);
    
    self.tickIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/iconTickL.png")
    self.tickIcon:setScale(0.7);
    self.tickIcon:setPosition(132, 48);
    self:addChild(self.tickIcon);

    self:setAnchorPoint(0,0);
end

function AskHelpCell:setSelect(boo)
    self.isSelect = boo;
    self.tickIcon:setVisible(self.isSelect);
end

function AskHelpCell:getSelect()
    return self.isSelect;
end

--[[-返回选中的好友id]]
function AskHelpCell:getFriId()
    if self.isSelect then
        print("sendMes")
        return self.data.id;
    else
        return nil;
    end
end

function AskHelpCell:GC()

end

return AskHelpCell;