local TabButton = class("TabButton", function()
    return cc.Layer:create();
end)

function TabButton:ctor()
    self.selectIcon = nil;
    self.unSelectBtn = nil;
    
    self.redLabel = nil;
    self.yellowLabel = nil;
    
    self.index = nil;
    self.btnTxt = nil;
    self.callBackFun = nil;

    self.isSelected = false;
end

function TabButton.create(index, text, callBack)
    local temp = TabButton.new();
    
    temp.index = index;
    temp.btnTxt = text;
    temp.callBackFun = callBack;
    
    temp:init();
    return temp;
end

function TabButton:init()
    self.unSelectBtn = ccui.Button:create();
    self.unSelectBtn:loadTextures("ui/ui/btnTable2.png", "ui/ui/btnTable2.png", nil, 1)
    self:addChild(self.unSelectBtn);
    
    self.yellowLabel = FacFont:getFontsBmp(FontType.FontYellowNoSide, self.btnTxt)
    self.yellowLabel:setPosition(130, 34)
    self.unSelectBtn:addChild(self.yellowLabel);
    
    local function touchEvent(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            self.callBackFun(self.index);
        end
    end
    self.unSelectBtn:addTouchEventListener(touchEvent)
    
    self.selectIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/btnTable1.png")
    self:addChild(self.selectIcon);
    
    self.redLabel = FacFont:getFontsBmp(FontType.FontRed, self.btnTxt)
    self.redLabel:setOpacity(190)
    self.redLabel:setPosition(127, 34)
    self.selectIcon:addChild(self.redLabel);
    
    self:setSelected(false);
end

function TabButton:setSelected(boo)
    self.isSelected = boo;
    
    if boo then
        self.selectIcon:setVisible(true);
    else
        self.selectIcon:setVisible(false);
    end
end

return TabButton;
