require "engine.uigridtools.SpecialGridTools"

local FBConnectPanel = class("FBConnectPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/FBConnectPanel.json");
end)

function FBConnectPanel:ctor()
    self.titleLab = nil;
    self.desLab = nil;
    self.armature = nil;
    self.cartoonPic = nil;
    
    self.closeBtn = nil;
    
    self.isSuccess = nil;
end

function FBConnectPanel.create()
    local temp = FBConnectPanel.new();
    temp:init();
    return temp;
end

function FBConnectPanel:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);
    self:setScale(0);
    
    self.closeBtn = self:getChildByName("BtnClose");
    self.closeBtn:setVisible(false);
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:disapperAlone(false);
        end
    end
    self.closeBtn:addTouchEventListener(touchEvent);
    
--    self.titleLab = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,"Connecting")
    self.titleLab = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,"Connecting")
    self.titleLab:setPosition(3, 266);
    self:addChild(self.titleLab);
    
    self.desLab = FacFont:getFontsBmp(FontType.FontRed,"Connecting to Facebook, Please Wait")
    self.desLab:setPosition(3, -210);
    self.desLab:setScale(0.8)
    self:addChild(self.desLab); 
    
--    local aniPanel = self:getChildByName("PanelAni");
    self.desBg = SpecialGridTools.create("ui/ui/bgCooky.png",464,203,26)
    self.desBg:setPosition(0, 60);
    self:addChild(self.desBg);
    
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/FBConnecting/FBConnecting.ExportJson")

    self.armature = ccs.Armature:create("FBConnecting");
    self.armature:setPosition(5, 70);
    self:addChild(self.armature)
    
    self.cartoonPic = cc.Sprite:create("ui/other/laughingGirl.png");
    self.cartoonPic:setPosition(5, -90);
    self.cartoonPic:setScale(0.8)
    self:addChild(self.cartoonPic)
    
    local function animationEvent(armatureBack,movementType,movementID)
        local id = movementID
        if movementType == ccs.MovementEventType.complete then
            if id == "1" then
                self.armature:getAnimation():playWithIndex(1)
            end
        end
    end

    self.armature:getAnimation():setMovementEventCallFunc( animationEvent)
end

function FBConnectPanel:appearAlone()
    if MainValue.mxUIManager.state == 1 then
        MainValue.mxUIManager.panelManager:addPanelAlone(self, PanelAppearType.POP_UP, self.appearComplete,self.disapperAlone);
    else 
    
        self.closeBtn:setVisible(false);
        
        MainValue.mxSplashManager.layer:addChild(self, 2);
        self:setPosition(VisibleRect:center())
        
        local color4B = cc.c4b(0,0,0,102);
        self.maskBg = cc.LayerColor:create(color4B,MainValue.winSize.width,MainValue.winSize.height);

        local listener = function(eventType, x, y)

            if eventType == "began" then
                return true           
            end
        end

        self.maskBg:registerScriptTouchHandler(listener, false, 0, true)
        self.maskBg:setTouchEnabled(true);
        MainValue.mxSplashManager.layer:addChild(self.maskBg,  1);
        
        local function onComplete()
            self:appearComplete();
        end
        MainValue.actionManager:createPopAction():PopUp(self, onComplete);
    end
end

function FBConnectPanel:appearComplete()
    self.armature:getAnimation():playWithIndex(0)
    
    self:runAction(cc.Sequence:create(cc.DelayTime:create(2),cc.CallFunc:create(function() 
        self.closeBtn:setVisible(true);
    end)))
end

function FBConnectPanel:disapperAlone(isSuccess)
    self.isSuccess = isSuccess;
    
    if MainValue.mxUIManager.state == 1 then
        MainValue.mxUIManager.panelManager:removePanelAlone(self,PanelDisappearType.POP_UNDER , self.disapperComplete)
    else 
        local function onComplete()
            self:disapperComplete();
        end
        MainValue.actionManager:createPopAction():PopUnder(self, onComplete);
    end
end


function FBConnectPanel:disapperComplete()
    MainValue.mxGameManager.gameStatusManager:setNeedCloseFBConnect(false);
    

    if self.isSuccess then
    
        if MainValue.mxUIManager.state == 1 then
            local FBConnectSuccessClz = require("ui.FBConnect.FBConnectSuccessPanel")
            local FBConnectSuccess = FBConnectSuccessClz.create();
            FBConnectSuccess:appearAlone();
        else
            MainValue.mxSplashManager:setFBConnectSuccess();
        end
    else
        local FBDisConnectClz = require("ui.FBConnect.FBDisconnectPanel")
        local FBDisConnect = FBDisConnectClz.create();
        FBDisConnect:appearAlone();
    end
    
    MainValue.mxSplashManager.layer:removeChild(self.maskBg);
    self:removeFromParent(true);
end

return FBConnectPanel;