local FBConnectSuccessPanel = class("FBConnectSuccessPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/FBConnectPanel.json");
end)

function FBConnectSuccessPanel:ctor()
    self.titleLab = nil;
    self.desLab = nil;
    self.armature = nil;
    self.cartoonPic = nil;
end

function FBConnectSuccessPanel.create()
    local temp = FBConnectSuccessPanel.new();
    temp:init();
    return temp;
end

function FBConnectSuccessPanel:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);
    self:setScale(0);
    
    local closebtn = self:getChildByName("BtnClose");

    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:disapperAlone();
        end
    end
    closebtn:addTouchEventListener(touchEvent);
    
    self.titleLab = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,"Success")
    self.titleLab:setPosition(3, 266);
    self:addChild(self.titleLab);

    self.desLab = FacFont:getFontsBmp(FontType.FontRed,"Connecting to facebook done!")
    self.desLab:setPosition(3, -210);
    self:addChild(self.desLab); 

--    local aniPanel = self:getChildByName("PanelAni");
    self.desBg = SpecialGridTools.create("ui/ui/bgCooky.png",464,203,26)
    self.desBg:setPosition(0, 60);
    self:addChild(self.desBg);

    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/FBConnectSuccess/FBConnectSuccess.ExportJson")

    self.armature = ccs.Armature:create("FBConnectSuccess");
    self.armature:setPosition(5, 70);
    self:addChild(self.armature)
    
    self.cartoonPic = cc.Sprite:create("ui/other/laughingGirl.png");
    self.cartoonPic:setPosition(5, -90);
    self.cartoonPic:setScale(0.8)
    self:addChild(self.cartoonPic)

    local function animationEvent(armatureBack,movementType,movementID)
        local id = movementID
        if movementType == ccs.MovementEventType.complete then
            if id == "1" then
                self.armature:getAnimation():playWithIndex(1)
            end
        end
    end

    self.armature:getAnimation():setMovementEventCallFunc( animationEvent)
end

function FBConnectSuccessPanel:appearAlone()
    if MainValue.mxUIManager.state == 1 then
        MainValue.mxUIManager.panelManager:addPanelAlone(self, PanelAppearType.POP_UP, self.appearComplete,self.disapperAlone);
    else 
        MainValue.mxSplashManager.layer:addChild(self, 2);
        self:setPosition(VisibleRect:center())
        
        local color4B = cc.c4b(0,0,0,102);
        self.maskBg = cc.LayerColor:create(color4B,MainValue.winSize.width,MainValue.winSize.height);

        local listener = function(eventType, x, y)

            if eventType == "began" then
                return true           
            end
        end

        self.maskBg:registerScriptTouchHandler(listener, false, 0, true)
        self.maskBg:setTouchEnabled(true);
        MainValue.mxSplashManager.layer:addChild(self.maskBg,  1);

        local function onComplete()
            self:appearComplete();
        end
        MainValue.actionManager:createPopAction():PopUp(self, onComplete);
    end
end

function FBConnectSuccessPanel:appearComplete()
    self.armature:getAnimation():playWithIndex(0)
end

function FBConnectSuccessPanel:disapperAlone()
    if MainValue.mxUIManager.state == 1 then
        MainValue.mxUIManager.panelManager:removePanelAlone(self,PanelDisappearType.POP_UNDER , self.disapperComplete)
    else 

        local function onComplete()
            self:disapperComplete();
        end
        MainValue.actionManager:createPopAction():PopUnder(self, onComplete);
    end
end

function FBConnectSuccessPanel:disapperComplete()
        MainValue.mxSplashManager.layer:removeChild(self.maskBg);
    self:removeFromParent(true);
end

return FBConnectSuccessPanel;