require "engine.uigridtools.SpecialGridTools"

local FBLoginPanel = class("FBLoginPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/FBConnectPanel.json");
end)

function FBLoginPanel:ctor()
    self.titleLab = nil
    self.desLab = nil
    self.desBg = nil
    self.cartoonPic = nil
    self.picDes = nil
    
    self.closeBtn = nil
    self.loginBtn = nil
end

function FBLoginPanel:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2)
    self:setScale(0)
    
    self.closeBtn = self:getChildByName("BtnClose")

    local function onClose( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:disapperAlone(false)
        end
    end
    self.closeBtn:addTouchEventListener(onClose)
    
    self.titleLab = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,"Login Facebook")
    self.titleLab:setScale(0.8)
    self.titleLab:setPosition(-10, 260)
    self:addChild(self.titleLab)

    if self.isGetLives == nil then
        self.cartoonPic = cc.Sprite:create("ui/other/needLifeIcon.png")
    else
        self.cartoonPic = cc.Sprite:create("ui/other/twoCharacters.png")
    end
    self.cartoonPic:setPosition(-5, 75)
    self.cartoonPic:setScale(0.9)
    self:addChild(self.cartoonPic)

    if self.isGetLives == nil then
        self.picDes = cc.Sprite:create("ui/other/needLifeDes.png")
        self.picDes:setPosition(220, 100)
        self.cartoonPic:addChild(self.picDes)
    end
    
    self.desBg = SpecialGridTools.create("ui/ui/bgCooky.png",464,110,26)
    self.desBg:setPosition(0, -90)
    self:addChild(self.desBg)
    
    local desTxt = nil;
    if self.isGetLives == nil then
        desTxt = "Login and get more lives.";
    else
        desTxt = "Login and play with friends.";
    end
    self.desLab = FacFont:getFontsBmp(FontType.FontYellowRedSide, desTxt)
    self.desLab:setPosition(0, 20)
    self.desBg:addChild(self.desLab) 
   
    local function onLogin(send,eventType)
        if eventType == ccui.TouchEventType.ended then
            -------------------------
            self:disapperAlone(true)
        end
    end
    
    self.loginBtn = ccui.Button:create("ui/ui/btnYellow1.png", "ui/ui/btnYellow2.png", "", 1)
    self.loginBtn:setScale9Enabled(true)
    self.loginBtn:setCapInsets(cc.rect(40,55,62,16))
    self.loginBtn:setPosition(0, -200)
    self.loginBtn:setContentSize(244,110)
    self.loginBtn:setScaleY(0.8)
    self:addChild(self.loginBtn)
    self.loginBtn:addTouchEventListener(onLogin)
    local loginTab = FacFont:getFontsBmp(FontType.FontWhite,"Login")
    self.loginBtn:addChild(loginTab)
    loginTab:setPosition(self.loginBtn:getContentSize().width * 0.5 + 5, self.loginBtn:getContentSize().height * 0.5 + 5)
end

function FBLoginPanel:appearAlone()
    MainValue.mxUIManager.panelManager:addPanelAlone(self, PanelAppearType.POP_UP, self.appearComplete,self.disapperAlone)
end

function FBLoginPanel:appearComplete()

end

function FBLoginPanel:disapperAlone(isSuccess)
    self.isSuccess = isSuccess
    MainValue.mxUIManager.panelManager:removePanelAlone(self,PanelDisappearType.POP_UNDER , self.disapperComplete)
end


function FBLoginPanel:disapperComplete()
--    MainValue.mxGameManager.gameStatusManager:setNeedCloseFBConnect(false);
    
    if self.isSuccess then
        MainValue.fbManager:FBlogin()
    end
    
    if self.isGetLives ~= nil then
        MainValue.mxGameManager.gameStatusManager:setShowPanelCount(1);
    end
    
    self:removeFromParent(true)
end

function FBLoginPanel.create(isGetLives)
    local temp = FBLoginPanel:new()
    temp.isGetLives = isGetLives
    temp:init()
    return temp
end

return FBLoginPanel