local NotEnoughLife = class("NotEnoughLife", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/NotEnoughLife.json");
end);

function NotEnoughLife:ctor()
    self.desBg = nil;

    self.fiveLabel = nil;--女孩心上的文本“X5”

    self.nowNumLab = nil;--当前心数量
    self.nowDesLab = nil;--当前数量显示格式
    self.addNumLab = nil;--购买后心数量
    self.addDesLab = nil;--购买后数量显示格式

    self.desPanel = nil;

    self.maxLifeNum = 5;

    self.hasClose = false;

    self.isBuy = false;

    self.FULL_HEART_VALUE = tonumber(MainValue.infosManager:getObjGoodsById("301").cash);
end

function NotEnoughLife.create()
    local temp = NotEnoughLife.new()
    temp:init();
    return temp;
end

function NotEnoughLife:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);
    self:setScale(0);

    local btnClose = self:getChildByName("BtnClose");

    -- touchEvent 触摸事件回调方法
    local function btnCloseHandler( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:disapperAlone();   
        end
    end
    btnClose:addTouchEventListener(btnCloseHandler)

    self.fiveLabel = FacFont:getFontsBmp(FontType.FontWhite,"X5")
    self.fiveLabel:setScale(1.3);
    self.fiveLabel:setPosition(-45, 7)
    self:addChild(self.fiveLabel);

    --title文本替换
    local newTitle = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,MainValue.infosManager:getObjMultilingualByKey("Common_NeedLivesTitle"));
    self:addChild(newTitle);
    newTitle:setPosition(5, 256);

    self.desPanel = self:getChildByName("PanelDes");

    self.desBg = SpecialGridTools.create("ui/ui/bgCooky.png",481, 97,26)
    self.desBg:setPosition(-11, -15);
    self.desPanel:addProtectedChild(self.desBg,-1);

    --des描述替换文字
    --    local newDes = FacFont:getFontsBmp(FontType.FontRed,"You don't have enough lives");
    --    self:addChild(newDes);
    --    newDes:setPosition(12, -153);

    --buy lives
    local buyNowBtn = self:getChildByName("BtnBuy");
    local buys = MainValue.infosManager:getObjMultilingualByKey("Common_NeedLivesBuy")
    buys = string.gsub(buys, "%b{}", self.FULL_HEART_VALUE)
    local buynowText = FacFont:getFontsBmp(FontType.FontWhite, buys);
    buyNowBtn:addChild(buynowText);
    --    buynowText:setScale(0.8);
    buynowText:setPosition(120, 60);

    --askFriends
    local askFriendsBtn = self:getChildByName("BtnAskFriends");
    local askFriends = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("AddLifePanel_2"))
    askFriends:setScale(0.9)
    askFriendsBtn:addChild(askFriends);
    askFriends:setPosition(123, 60);

    local function btnBuyHandler( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(sender,40);

            if tonumber(MainValue.dataManager.userManager:getCash()) >= tonumber(self.FULL_HEART_VALUE) then

                self.isBuy = true;

            else

                if BuyFlowValue.buyLifeAry ~= nil and table.maxn(BuyFlowValue.buyLifeAry) == 2 then
                    --                    BuyFlowValue.buyLifeAry = {}
                    local tmpBuyLifeData = BuyFlowData.new(BuyFlowValue.storeUI)

                    BuyFlowValue.buyLifeAry[3] = tmpBuyLifeData                                            
                end

                if BuyFlowValue.buyLifeTopAry ~= nil and table.maxn(BuyFlowValue.buyLifeTopAry) == 1 then

                    local tmpBuyLifeData = BuyFlowData.new(BuyFlowValue.storeUI)            
                    BuyFlowValue.buyLifeTopAry[2] = tmpBuyLifeData                                            
                end


                local notEnoughCashClz = require("ui.storeUI.StoreUI")
                local notEnoughCash = notEnoughCashClz.create();
                notEnoughCash:appear();
            end


            if self.isAloneShow then
                self:disapperAlone();
            else
                self:disappear();
            end

        end
    end
    buyNowBtn:addTouchEventListener(btnBuyHandler)

    local function btnAskFriendsHandler( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(sender,40);

            local function callBack()
                local askForLiveClz = require("ui/AskForHelp/AskForHelp")
                local askForLive = askForLiveClz.create();
                askForLive:appearAlone();
            end
            MainValue.fbManager:isLoginByCallback(callBack);
        end
    end
    askFriendsBtn:addTouchEventListener(btnAskFriendsHandler)

    self:updataHeart();
end

function NotEnoughLife:updataHeart()
    local nowNum = MainValue.dataManager.userManager:getHeart();

    if self.nowNumLab ~= nil then
        self.nowNumLab:removeFromParent(true);
    end

    self.nowNumLab = FacFont:getFontsBmp(FontType.FontYellowRedSide, tostring(nowNum));
    self.nowNumLab:setScale(0.8);
    self.nowNumLab:setPosition(-199, 5)
    self.desPanel:addChild(self.nowNumLab)

    if self.nowDesLab ~= nil then
        self.nowDesLab:removeFromParent(true);
    end
    self.nowDesLab = FacFont:getFontsBmp(FontType.FontSmallWhiteBrownSide, tostring(nowNum .. "/" .. self.maxLifeNum));
    self.nowDesLab:setPosition(-124, -6)
    self.desPanel:addChild(self.nowDesLab);

    if self.addNumLab ~= nil then
        self.addNumLab:removeFromParent(true);
    end

    self.addNumLab = FacFont:getFontsBmp(FontType.FontYellowRedSide, tostring(nowNum + 5));
    self.addNumLab:setScale(0.8);
    self.addNumLab:setPosition(70, 5)
    self.desPanel:addChild(self.addNumLab);

    if self.addDesLab ~= nil then
        self.addDesLab:removeFromParent(true);
    end
    self.addDesLab = FacFont:getFontsBmp(FontType.FontSmallWhiteBrownSide, tostring((nowNum + 5) .. "/" .. self.maxLifeNum));
    self.addDesLab:setPosition(147, -6)
    self.desPanel:addChild(self.addDesLab);
end

function NotEnoughLife:appear()
    self.isAloneShow = false
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.POP_UP, self.appearComplete,self.disappear);
end

function NotEnoughLife:appearAlone()
    self.isAloneShow = true
    MainValue.mxUIManager.panelManager:addPanelAlone(self, PanelAppearType.POP_UP, self.appearComplete,self.disapperAlone);
end

function NotEnoughLife:appearComplete()
    MainValue.mxUIManager.topbar:setNeedUpdate(true);--是否需要更新心的数量
end

function NotEnoughLife:disappear()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.POP_UNDER , self.disapperComplete)
end

function NotEnoughLife:disapperAlone()
    MainValue.mxUIManager.panelManager:removePanelAlone(self,PanelDisappearType.POP_UNDER , self.disapperComplete)
end


function NotEnoughLife:disapperComplete()
    MainValue.mxUIManager.topbar:setNeedUpdate(false);--是否需要更新心的数量
    self:removeFromParent(true);


    if self.isBuy then
        MainValue.dataManager.userManager:subCash(self.FULL_HEART_VALUE);
        MainValue.dataManager.userManager:addHeart(5);

        ------------统计----------
        local maxLevel = MainValue.dataManager.levelManager:getMaxLevel();
        local leftCash = MainValue.dataManager.userManager:getCash();
        local leftLives = MainValue.dataManager.userManager:getHeart();
        MainValue.statisticsManager:consumeBuyHeart(301, 1, 0, self.FULL_HEART_VALUE, maxLevel, leftLives, 0, leftCash, -1);
        ------------

        self.isBuy = false;

        if BuyFlowValue.buyLifeAry ~= nil and table.maxn(BuyFlowValue.buyLifeAry) == 2 then
            local lvNum = BuyFlowValue.buyLifeAry[1]:getLevelNum();

            local playGamePanelClz = require("ui/playGamePanel/PlayGamePanel")
            local playGamePanel = playGamePanelClz.create(lvNum)
            playGamePanel:appear();                                           
        end

        if BuyFlowValue.buyLifeAry ~= nil and table.maxn(BuyFlowValue.buyLifeAry) > 0 then
            for index = table.maxn(BuyFlowValue.buyLifeAry),0,-1 do
                table.remove(BuyFlowValue.buyLifeAry,index)
            end
        end

        if BuyFlowValue.buyLifeTopAry ~= nil and table.maxn(BuyFlowValue.buyLifeTopAry) > 0 then
            for index = table.maxn(BuyFlowValue.buyLifeTopAry),0,-1 do
                table.remove(BuyFlowValue.buyLifeTopAry,index)
            end                                          
        end
    elseif MainValue.dataManager.adManager:getBuyHeartShow() ~= 1 and  MainValue.dataManager.userManager:getHeart() == 0 then
        MainValue.dataManager.adManager:setBuyHeartShow()

--        MainValue.mxUIManager.mapUI:openADPanel("BuyLifesMent");
        
        local adPanelCls = require("ui/advertisement/ADPanel");
        local adPanel = adPanelCls.create("BuyLifesMent");
        adPanel:appearAlone();
    end

end

return NotEnoughLife