


local layer = nil

local RecommendItemUI = class("RecommendItemUI", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/RecommendItemUI.json")
end)

function RecommendItemUI:disCallBackFun()
    layer:removeFromParent()
end

function RecommendItemUI.create(obj)
    layer = RecommendItemUI.new()
    layer:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5)

    local closeBtn = tolua.cast(layer:getChildByName("CloseBtn"), "ccui.Button")
    local function onClose(sender, eventType)
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createUIAction():UIDisappear(layer,layer.disCallBackFun)
        end
    end
    closeBtn:addTouchEventListener(onClose)
    
    local function onBuy(sender, eventType)
       if eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(sender,40);
                --buy  
            if sender:getTag() == 1 then
                print("[RecommendItemUI]xxxxxxxxxxxx1")
            elseif sender:getTag() == 2 then
                print("[RecommendItemUI]xxxxxxxxxxxx2")
            end         
            MainValue.actionManager:createUIAction():UIDisappear(layer,layer.disCallBackFun)
        end
    end
    
    local label = layer:getChildByName("DesLabel")
    local text = FacFont:getFontsBmp(FontType.FontRed,obj[1]['des'],450)
    text:setPosition(label:getPosition())
    label:removeFromParent()
    layer:addChild(text)
    
    local cell = layer:getChildByName("Cell")
    
    label = cell:getChildByName("CountLabel")
    text = FacFont:getFontsBmp(FontType.FontRed,tostring("X " .. obj[1]['count']))
    cell:addChild(text)
    text:setScaleX(.7)
    text:setScaleY(.7)
    text:setPosition(label:getPosition())
    label = nil
    
    local buyBtn = tolua.cast(cell:getChildByName("BuyBtn"),"ccui.Button")
    label = buyBtn:getChildByName("CostLabel")
    text = FacFont:getFontsBmp(FontType.FontRed,obj[1]['cost'])
    buyBtn:addChild(text)
    text:setPosition(label:getPosition())
    label = nil
    buyBtn:setTag(1)
    buyBtn:addTouchEventListener(onBuy)
   
    local itemImg = cc.Sprite:create("daoju/" .. obj[1]['id'] .. ".png")
    cell:addProtectedChild(itemImg,0)
   
    if obj[2] then
        local cell2 = cell:clone()
        layer:addChild(cell2)
        
        label = cell2:getChildByName("CountLabel")
        text = FacFont:getFontsBmp(FontType.FontRed,tostring("X " .. obj[2]['count']))
        cell2:addChild(text)
        text:setScaleX(.7)
        text:setScaleY(.7)
        text:setPosition(label:getPosition())
        label = nil

        local buyBtn2 = tolua.cast(cell2:getChildByName("BuyBtn"),"ccui.Button")
        label = buyBtn2:getChildByName("CostLabel")
        text = FacFont:getFontsBmp(FontType.FontRed,obj[2]['cost'])
        buyBtn2:addChild(text)
        text:setPosition(label:getPosition())
        label = nil
        buyBtn2:setTag(2)
        buyBtn2:addTouchEventListener(onBuy)
        
        local itemImg2 = cc.Sprite:create("daoju/" .. obj[1]['id'] .. ".png")
        cell2:addProtectedChild(itemImg2,0)
        
        cell:setPositionX(-150)
        cell2:setPositionX(150)
    end
    
    return layer
end

function RecommendItemUI:init()
    MainValue.actionManager:createUIAction():UIAppear(layer)
end

return RecommendItemUI