RequestPanel = class("RequestPanel", function()
    return cc.Node:create();
end);

function RequestPanel:ctor()
    self.bg = nil;
    self.closeBtn = nil;
    self.desList = nil;
end

function RequestPanel.create()
    local temp = RequestPanel.new()
    temp:init();
    return temp;
end

function RequestPanel:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);
    
    self.bg = cc.Sprite:create("ui/panel/panelCommon3.png");
    self:addChild(self.bg);
    
    self.closeBtn = ccui.Button:create("ui/ui/btnClose1.png","ui/ui/btnClose2.png","",1);
    self.closeBtn:setPosition(self.bg:getContentSize().width / 2 - 50, self.bg:getContentSize().height / 2 - 120);
    self:addChild(self.closeBtn);
    
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:disCallBackFun();
        end
    end
    self.closeBtn:addTouchEventListener(touchEvent);
end

function RequestPanel:addMes(mes)
    if self.desList == nil then
        self.desList = {};
    end
    
    local mesLabel = FacFont:getFontsBmp(FontType.FontRed,mes);
    
    if table.getn(self.desList) > 0 then
        local curY = self.desList[table.getn(self.desList)]:getPositionY() - self.desList[table.getn(self.desList)]:getContentSize().height;
        mesLabel:setPositionY(curY - 10);
    else
        mesLabel:setPositionY(120);
    end
    
    self:addChild(mesLabel);
    table.insert(self.desList, mesLabel);
   
   if self:getParent() == nil then
        self:appear();
   end 
end

function RequestPanel:appear()
    MainValue.mxUIManager.layer:addChild(self);
end

function RequestPanel:disCallBackFun()
    MainValue.mxUIManager.layer:removeChild(self);
    
    for i, label in ipairs(self.desList) do
        label:removeFromParent(true);
        label = nil;
    end
    
    self.desList = nil;
end

return RequestPanel;