


local layer = nil

local StarterPackage = class("StarterPackage", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/StarterPackageUI.json")
end)

local function disCallBackFun()
    layer:removeFromParent(true)
end

function StarterPackage.create()
    layer = StarterPackage.new()
    layer:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5)

    local closeBtn = tolua.cast(layer:getChildByName("CloseBtn"), "ccui.Button")
    local function onClose( sender, eventType )
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            local function cf()
                MainValue.actionManager:createUIAction():UIDisappear(layer,disCallBackFun)
            end
            MainValue.actionManager:createJellyAction():run(sender,40,cf);
        end
    end
    closeBtn:addTouchEventListener(onClose)
    
    local buyBtn = tolua.cast(layer:getChildByName("BuyBtn"),"ccui.Button")
    local btnLabel = buyBtn:getChildren()[1]
    local text = FacFont:getFontsBmp(FontType.FontRed,"Get Now")
    buyBtn:addChild(text)
    text:setPosition(btnLabel:getPosition())
    btnLabel:removeFromParent()
    local function onBuy(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            local function cf()
                --buy
                MainValue.actionManager.createUIAction():UIDisappear(layer,disCallBackFun)
            end
            MainValue.actionManager:createJellyAction():run(sender,40,cf);
        end
    end
    buyBtn:addTouchEventListener(onBuy)

    local titleLabel = layer:getChildByName("TitleLabel")
    text = FacFont:getFontsBmp(FontType.FontRed,"Starter Package")
    layer:addChild(text)
    text:setPosition(titleLabel:getPosition())
    titleLabel:removeFromParent()
    
    local desLabel = layer:getChildByName("DesLabel")
    text = FacFont:getFontsBmp(FontType.FontRed,"Get 20 Cash and Power-Ups worth $9.9 for only $1.99!",450) 
    layer:addChild(text)
    text:setPosition(desLabel:getPosition())
    desLabel:removeFromParent()
    
    local elephantImg = layer:getChildByName("ElephantImg")
    desLabel = elephantImg:getChildren()[1]
    text = FacFont:getFontsBmp(FontType.FontRed,"63% off",100)
    elephantImg:addChild(text)
    text:setPosition(desLabel:getPosition())
    desLabel:removeFromParent()
    
    return layer
end

function StarterPackage:init()
    MainValue.actionManager:createUIAction():UIAppear(layer);
end

return StarterPackage