require "ui.panelManager.PanelManager"
require "ui.loseSettlement.LoseSettlementPanel"
require "ui/winSettlement/WinSettlement"

local UIManager = class("UIManager");

function UIManager:ctor()
    self.layer = nil;
    self.mapManager = nil;
    
    if self.mapManager  == nil then
        local mapManagerClz = require("ui.map.MapManager");  
        self.mapManager = mapManagerClz.create();
        self.mapManager:retain()
    end
    
    self.topbar = nil;
    self.inboxBtn = nil;
    self.mapUI = nil;
    self.panelManager = nil;
   

	self.settingBtn = nil;

    self.layer = cc.Layer:create();
    
    self.state = nil;
    
    local panelManagerCLZ = require("ui.panelManager.PanelManager");
    self.panelManager = panelManagerCLZ.create();
    self.layer:addChild(self.panelManager,4);
    
    
end

function UIManager.create()
    local temp = UIManager.new();
    
    return temp;
end

--[[显示进入游戏收集目标面板]]
function UIManager:showTargetPanel(tarData)
    local temp = require "ui.inGame.InGameStartPanel";
    self.inGameStartPanel = temp.create();
    self.inGameStartPanel:setData(tarData);
    self.inGameStartPanel:appear();
end

--[[显示胜利结算面板]]
function UIManager:showWinPanel(scores, stars,oldScore,oldStars)
    self.winSettlement = WinSettlement.create();
    self.winSettlement:setData(MainValue.SELECTED_LEVEL, scores, stars,oldScore,oldStars);
    self.winSettlement:appear();
end

--[[显示失败结算面板]]
function UIManager:showOverPanel(loseData)
    self.loseSettlement = LoseSettlementPanel.create();
    self.loseSettlement:setData(MainValue.SELECTED_LEVEL, loseData);
    self.loseSettlement:appear();
end

--更新inbox消息数量
function UIManager:updataInboxMesNum()
    self.inboxBtn:updataMesNum();
end

--进入游戏开始界面
function UIManager:onEnterSplash()
    
end

--退出游戏开始界面
function UIManager:onExitSplash()

end 

--进入地图
function UIManager:onEnterMap()
    if self.state == nil then
       
        self.layer:addChild(self.mapManager,2);
    
        local topbarclz = require("ui.topbar.TopBar");  
        self.topbar = topbarclz.create();
        self.layer:addChild(self.topbar,2);
    
        local uiListSp = require("ui.uiListHelp.UIListSp")
        local uiNode = uiListSp.create();
        uiNode:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);
        uiNode:init();
        self.layer:addChild(uiNode,2);
    


        if self.settingBtn == nil then
            local settingBtnCls = require("ui.setting.SettingPortal")
            self.settingBtn = settingBtnCls.create();
            self.settingBtn:setPosition(MainValue.winSize.width - 40, 42);
            self.layer:addChild(self.settingBtn, 3)
        end   

        local inboxBtnCls = require("ui.inbox.InboxPortal")
        self.inboxBtn = inboxBtnCls.create();
        self.inboxBtn:setPosition(MainValue.winSize.width - 55, MainValue.winSize.height - 42);
        self.layer:addChild(self.inboxBtn,2);
    
        local mapUIClz = require("ui.mapui.MapUI")
        self.mapUI = mapUIClz.create();
        self.mapUI:retain();
        
       
        
    end

   self.state = 1;
   self.mapManager:onEnterMap(); 
   self.topbar:visible(true);
   self.inboxBtn:setVisible(true);
   
   if self.mapUI:getParent()~=nil then
        self.mapUI:getParent():removeChild(self.mapUI)
   end
   self.layer:addChild(self.mapUI,2);
   
   self.settingBtn:isIngame(false);
end 

function UIManager:resetSettingBar()
    if self.settingBtn ~= nil then
        self.settingBtn:setVisible(true);
    end
end

function UIManager:appearSettingBar()
    if self.settingBtn ~= nil then
        self.settingBtn:setVisible(false);
    end
end

--退出地图
function UIManager:onExitMap()
    self.state = 0;
    self.mapManager:onExitMap();
    self.topbar:visible(false);
    self.inboxBtn:setVisible(false);
    self.mapUI:removeFromParent();
    
    self.settingBtn:isIngame(true);
 
end

--将topbar放置在PanelManager上层
function UIManager:changeTopbarLayer()
    self.topbar:retain();
    self.layer:removeChild(self.topbar);
    self.layer:addChild(self.topbar, 2);
    self.topbar:release();
end

--还原topbar默认层
function UIManager:setDefaultLayer()
    self.topbar:retain();
    self.layer:removeChild(self.topbar);
    self.layer:addChild(self.topbar, 1);
    self.topbar:release();
end

--进入游戏
function UIManager:onEnterGame()
    if self.state == nil then
--        local mapManagerClz = require("ui.map.MapManager");  
--        self.mapManager = mapManagerClz.create();
--        self.mapManager:retain()
        
        if self.settingBtn == nil then
            local settingBtnCls = require("ui.setting.SettingPortal")
            self.settingBtn = settingBtnCls.create();
            self.settingBtn:setPosition(MainValue.winSize.width - 40,  42);
            self.layer:addChild(self.settingBtn, 3)
            
            self.settingBtn:isIngame(true);
        end  
        
        
    end
   
end
--onEnteredGame

--退出游戏
function UIManager:onExitGame()
--清除游戏内UI
end

--游戏进入后台
function UIManager:onEnterBackground()

end

--游戏从后台归位
function UIManager:onEnterForeground()
    if  self.topbar ~= nil then
        self.topbar:gameEnterBack();
        
        -- 2015-6-18 暂时注释  
        MainValue.statisticsManagerOG:Access(); --OG
        -- 2015-6-18 暂时注释 
          MainValue.statisticsManagerOG:levelStart(MainValue.dataManager.levelManager:getMaxLevel(), -1, -1, -1, -1); --OG
        -- 2015-6-18 暂时注释 
         MainValue.statisticsManagerOG:levelLife(MainValue.dataManager.userManager:getHeart(), -1); --OG
    -- 2015-6-18 暂时注释 
     MainValue.statisticsManagerOG:levelCurrency(MainValue.dataManager.userManager:getCash(), -1, -1); --OG
    end
end

--回退键功能 
function UIManager:backPack()
    if self.panelManager ~= nil then
        local b = self.panelManager:backPack();
        if b == false then
            if self.state == 1 then
               -- print("退出地图");
                MainStatus:onExitMap();
                MainStatus:onEnterSplash();

           end
        end
        return b;
    end 
    
    return false;
    
end

return UIManager;