local layer = nil
local UnlockItemPanel = class("UnlockItemPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/UnlockItem.json")
end)

function UnlockItemPanel:ctor()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5)
    
    self.bgLayer = cc.LayerColor:create(cc.c4b(59,229,246,255) ,MainValue.winSize.width,MainValue.winSize.height);
    self.bgLayer:setPosition(- MainValue.winSize.width / 2, - MainValue.winSize.height / 2);
    self:addChild(self.bgLayer, -1);

    local continueBtn = tolua.cast(self:getChildByName("ContinueBtn"), "ccui.Button")
    local btnLabel = continueBtn:getChildren()[1]
    local text = FacFont:getFontsBmp(FontType.FontRed,"Continue")
    continueBtn:addChild(text)
    text:setPosition(btnLabel:getPosition())
    btnLabel:removeFromParent()
    self.checkBox  = self:getChildByName("CheckBox");
    self.checkBox:setSelected(true);
    -- touchEvent 触摸事件回调方法
    local function onContinue(sender, eventType)
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            self:closePanel()
        end
    end
    continueBtn:addTouchEventListener(onContinue)

    local shareLabel = self:getChildByName("ShareLabel")
    text = FacFont:getFontsBmp(FontType.FontRed,"Share 100 coins with your friends!")
    self:addChild(text)
    text:setPosition(shareLabel:getPosition())
    shareLabel:removeFromParent()
    return self
end

--数据初始化用于显示 对应的图标和 说明
 
function UnlockItemPanel:initData(isUnlockingPropPar)
--    print("isUnlockingPropPar")
    self.goodsData = isUnlockingPropPar
end

function UnlockItemPanel:active()
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/UnlockItem/UnlockItem0.png", "armature/UnlockItem/UnlockItem0.plist" , "armature/UnlockItem/UnlockItem.ExportJson" )
    self.ani = ccs.Armature:create("UnlockItem")
   
    local title = FacFont:getFontsBmp(FontType.FontRed, self.goodsData.name)   --FacFont.getFontsBmp(FontType.FontYellowRedSide,self.goodsData.name)
    title:setRotation(-15)
    title:setPosition(6,-14)
    
    local propsUrl = string.format( "ui/prop/big/%s.png",self.goodsData.id)    
    local picIcon = cc.Sprite:create(propsUrl)
    picIcon:setRotation(-8)
    picIcon:setPosition(18,-139) 
    
    
    local dexPlusTwo = FacFont:getFontsBmp(FontType.FontRed, "X2")   --
    dexPlusTwo:setRotation(-10)
    dexPlusTwo:setPosition(70,-170) 
    
  
    local parentBone = self.ani:getBone("TitleLayer") --boneAni中的原有    
    local displayNode = parentBone:getDisplayManager():getDisplayRenderNode()
     
    local titleLayer = cc.Layer:create()    
    titleLayer:setContentSize(displayNode:getContentSize())
    titleLayer:setAnchorPoint(displayNode:getAnchorPoint())
    
    
    titleLayer:addChild(title)
    titleLayer:addChild(picIcon)
    titleLayer:addChild(dexPlusTwo)
    
    
    local childBone = ccs.Bone:create("titleShowBone")
    childBone:addDisplay(titleLayer,0)
    childBone:changeDisplayWithIndex(0,false)
    childBone:setIgnoreMovementBoneData(true)
    childBone:setLocalZOrder(self.ani:getBone("TitleLayer"):getLocalZOrder())
    self.ani:getBone("TitleLayer"):getArmature():addBone(childBone,self.ani:getBone("TitleLayer"):getName())    
    
    
    self.ani:setPosition(cc.p(0,0))-- 设置位置
    self:addChild(self.ani)-- 播放动画, 播放指定动作 先play 再 gotoAndPause 才能跳到指定的帧        
    self.ani:getAnimation():play("1",3,0)    
    self.ani:getAnimation():setSpeedScale(1)--处理帧运动速度
    
--    
--    local function animationEvent(armatureBack,movementType,movementID)           
--        if movementType == ccs.MovementEventType.complete then
----          print("runend")
----          显示标题图片描述和 应用图片
--        end
--    end
--    self.ani:getAnimation():setMovementEventCallFunc( animationEvent)
--    
    
    self.ani:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex )
        if evt == "showDesc" then -- 判断帧事件名称是否为kill
            --    UseLayer 
            local parentUseLayerBone = self.ani:getBone("TitleLayer") --boneAni中的原有    
            local displayNodeUseLayer = parentUseLayerBone:getDisplayManager():getDisplayRenderNode()

            local useLayer = cc.Layer:create()     
            useLayer:setContentSize(displayNodeUseLayer:getContentSize())
            useLayer:setAnchorPoint(displayNodeUseLayer:getAnchorPoint())
            
            local leftPicUrl =  string.format( "daoju/daojudes/%s_1.png",self.goodsData.id)
            local leftPicIcon = cc.Sprite:create(leftPicUrl)
            leftPicIcon:setPosition(-150,5) 

            local midArrowIcon = cc.Sprite:create("daoju/daojudes/jiantou.png")
            midArrowIcon:setPosition(0,5)   

            local rightPicUrl =  string.format( "daoju/daojudes/%s_2.png",self.goodsData.id)   
            local rightPicIcon = cc.Sprite:create(rightPicUrl)
            rightPicIcon:setPosition(150,5) 
            
            
            local desc = FacFont:getFontsBmp(FontType.FontRed, self.goodsData.des)  
            desc:setPosition(0,-98)
            

            useLayer:addChild(leftPicIcon)
            useLayer:addChild(midArrowIcon)
            useLayer:addChild(rightPicIcon)
            useLayer:addChild(desc)

            local customBoneUserLayer = ccs.Bone:create("UseLayerCustom")
            customBoneUserLayer:addDisplay(useLayer,0)
            customBoneUserLayer:changeDisplayWithIndex(0,false)
            customBoneUserLayer:setIgnoreMovementBoneData(true)
            customBoneUserLayer:setLocalZOrder(self.ani:getBone("UseLayer"):getLocalZOrder())
            self.ani:getBone("UseLayer"):getArmature():addBone(customBoneUserLayer,self.ani:getBone("UseLayer"):getName())
        end
    end
    )
    
end
function UnlockItemPanel:closePanel()
    self:disappear();
end

function UnlockItemPanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disappear);
end

function UnlockItemPanel:appearComplete()
    self:active()
--    self.armature:getAnimation():playWithIndex(0)
end

function UnlockItemPanel:disappear()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_DOWN , self.closeComplete)
end

function UnlockItemPanel:closeComplete()
    if self.checkBox:isSelected() then
        MainValue.fbManager:FBsharedDialog(FBSharedType.PASS_FRIEND_PROGRESS);--TODO:::解锁道具的分享需要调整 2015-1-8
    end
    self:removeFromParent(true)
    
    --    MainValue.mxGameManager.gameStatusManager:setShowPanelCount(1);
end

return UnlockItemPanel