local ADPanel = class("ADPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/FBConnectPanel.json");
end)

function ADPanel:ctor()
    self.title = nil;
    self.closeBtn =nil;
    self.bgGirl = nil;
    self.desBg = nil;
    self.desTxt = nil;
    self.tryBtn = nil;
    self.tryTxt = nil;
    
    self.showPos = nil;--打开广告面板的位置、广告的placement
end

function ADPanel.create(showPos)
    local temp = ADPanel.new();
    temp.showPos = showPos;
    temp:init();
    return temp;
end

function ADPanel:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);
    self:setScale(0);
    
    self.title = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,MainValue.infosManager:getObjMultilingualByKey("AD_panel_title"));
    self:addChild(self.title);
    self.title:setPosition(5, 256);
    
    self.closeBtn = self:getChildByName("BtnClose");
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:disapperAlone();
        end
    end
    self.closeBtn:addTouchEventListener(touchEvent);
    
    self.bgGirl = cc.Sprite:create("ui/other/imgAD.png");
    self.bgGirl:setPosition(-3, 65);
    self:addChild(self.bgGirl);
    
    self.desBg = NineGridTools.create("ui/ui/bgCooky.png",451, 95, 15)
    self.desBg:setPosition(-3, -100);
    self:addChild(self.desBg)
    
    local des = self.showPos == "BuyLives" and "AD_panel_des2" or "AD_panel_des1"
    des = MainValue.infosManager:getObjMultilingualByKey(des)
	
    self.desTxt =  FacFont:getFontsBmp(FontType.FontYellowRedSide, des, 392, "L", -20);
    self.desTxt:setPosition(28, 5);
    self.desBg:addChild(self.desTxt);
    
    self.tryBtn = ccui.Button:create("ui/ui/btnYellow1.png","ui/ui/btnYellow2.png", nil ,1);
    self.tryBtn:setScale9Enabled(true)
    self.tryBtn:setContentSize(cc.size(284, 110))
    self.tryBtn:setPosition(0, -200)
    self:addChild(self.tryBtn)
    
    local function onTry( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            MainValue.dataManager.adManager:popAdvertisement(self.showPos);
            self:disapperAlone();
        end
    end
    self.tryBtn:addTouchEventListener(onTry);
    
    self.tryTxt = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("Try_btn"))
    self.tryTxt:setPosition(150, 60);
    self.tryBtn:addChild( self.tryTxt);
end

function ADPanel:appearAlone()
    MainValue.mxUIManager.panelManager:addPanelAlone(self, PanelAppearType.POP_UP, self.appearComplete,self.disapperAlone);
end

function ADPanel:appearComplete()

end

function ADPanel:disapperAlone()
    MainValue.mxUIManager.panelManager:removePanelAlone(self,PanelDisappearType.POP_UNDER , self.disapperComplete)
end

function ADPanel:disapperComplete()

end

return ADPanel
