local ADRewardsPanel = class("ADRewardsPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/FBConnectPanel.json");
end)

function ADRewardsPanel:ctor()
    self.title = nil;
    self.closeBtn =nil;

    self.desBg = nil;
    self.desTxt = nil;

    self.rewardsIcon = nil;
    self.rewardsCount = nil;

    self.getBtn = nil;
    self.getTxt = nil;

    self.rewardsInfo = nil; --奖励配置
    self.rewardsData = nil; --奖励信息
end

function ADRewardsPanel.create(rewardsInfo)
    local temp = ADRewardsPanel.new();

    temp.rewardsInfo = rewardsInfo;

    temp:init();
    return temp;
end

function ADRewardsPanel:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);
    self:setScale(0);


    -----------
    -- 获取奖励信息：
    --1.若心已满则送金币，否则随机
    --2.关闭买心面板后打开广告面板看广告后，只送心
    local listLen = nil;
    if self.rewardsInfo ~= nil then
        listLen = #self.rewardsInfo;

        if listLen == 1 then
            self.rewardsData = self.rewardsInfo[1];
        elseif listLen > 1 then
            if MainValue.dataManager.userManager:getHeart() == 5 then
                self.rewardsData = self.rewardsInfo[1];
            else
                local randomNum = math.random(1, listLen);
                self.rewardsData = self.rewardsInfo[randomNum];
            end 
        end
    end
    ----------



    self.title = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, "Rewards");
    self:addChild(self.title);
    self.title:setPosition(5, 256);

    self.closeBtn = self:getChildByName("BtnClose");
    self.closeBtn:setVisible(false);
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:disapperAlone();
        end
    end
    self.closeBtn:addTouchEventListener(touchEvent);

    self.rewardsIcon = self:getRewardsIcon();
    self:addChild(self.rewardsIcon);

    if self.rewardsData.count > 1 then
        local randomNum = math.random(1,100); --70%概率送1金币，30%概率送2金币
        if randomNum < 70 then
            self.rewardsData.count = 1;
        end
    end

    self.rewardsCount = FacFont:getFontsBmp(FontType.FontYellowWhiteSide, "X" .. self.rewardsData.count, 392, "C", -20);
    self.rewardsCount:setPosition(20, -30);
    self:addChild(self.rewardsCount); 

    self.desTxt =  FacFont:getFontsBmp(FontType.FontYellowRedSide, "Claim your rewards", 392, "C", -20);
    self.desTxt:setPosition(-3, 135);
    self:addChild(self.desTxt);

    self.getBtn = ccui.Button:create("ui/ui/btnYellow1.png","ui/ui/btnYellow2.png", nil ,1);
    self.getBtn:setScale9Enabled(true)
    self.getBtn:setContentSize(cc.size(284, 110))
    self.getBtn:setPosition(0, -200)
    self:addChild(self.getBtn);

    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:getRewards();
        end
    end
    self.getBtn:addTouchEventListener(touchEvent);

    self.getTxt = FacFont:getFontsBmp(FontType.FontWhite, "Claim") --MainValue.infosManager:getObjMultilingualByKey("Try_btn"))
    self.getTxt:setPosition(137, 60);
    self.getBtn:addChild( self.getTxt);
end

function ADRewardsPanel:getRewards()
    if self.rewardsData.type == "heart" then
        MainValue.dataManager.userManager:addHeart(self.rewardsData.count);

    elseif self.rewardsData.type == "cash" then
        MainValue.dataManager.userManager:addCash(self.rewardsData.count);
    end

    self:disapperAlone();
end

--获取奖励图标
function ADRewardsPanel:getRewardsIcon()
    if self.rewardsData.type == "heart" then
        return cc.Sprite:createWithSpriteFrameName("ui/ui/iconHeart2.png");
    elseif self.rewardsData.type == "cash" then
        return cc.Sprite:createWithSpriteFrameName("ui/ui/iconCoin.png");
    end

    return nil;
end

function ADRewardsPanel:appearAlone()
    MainValue.mxUIManager.panelManager:addPanelAlone(self, PanelAppearType.POP_UP, self.appearComplete,self.disapperAlone);
end

function ADRewardsPanel:appearComplete()

end

function ADRewardsPanel:disapperAlone()
    MainValue.mxUIManager.panelManager:removePanelAlone(self,PanelDisappearType.POP_UNDER , self.disapperComplete)
end

function ADRewardsPanel:disapperComplete()

end

return ADRewardsPanel
