require "engine/uigridtools/NineGridTools"
local ExitLoginPanel = class("ExitLoginPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/ExitLoginPanel.json")
end)


function ExitLoginPanel:ctor()
    
    self.bg = nil;
    self.titleDes = nil;
    self.returnText = nil;
    self.exitText = nil;

end

function ExitLoginPanel:disCallBackFun()
    self:removeFromParent(true);
    MainValue.mxAlertManager.isHavePanel = false;
    MainValue.mxAlertManager.exitLogin = nil;
end

function ExitLoginPanel:onClose()
    MainValue.soundManager:playEffect(GameSoundEffectId.CLOSE_D);
    MainValue.actionManager:createUIAction():UIDisappear(self,PanelDisappearType.LEAVE_DOWN,self.disCallBackFun);
    
end




function ExitLoginPanel.create()
    local layer = ExitLoginPanel.new()

    layer:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5)
    layer:initData();
    return  layer;
end

function ExitLoginPanel:initData()
    local bg = self:getChildByName("bg");
    bg:setVisible(false);
    
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);
    self.bg = NineGridTools.create("ui/ui/bgCell2.png" , 536 , 228 , 32)
    self:addProtectedChild(self.bg);  
    
    local itemTitle = self:getChildByName("titleDes");
    if  self.titleDes == nil then
        self.titleDes = FacFont:getFontsBmp(FontType.FontYellowNoSide, MainValue.infosManager:getObjMultilingualByKey("Common_exitMsg"));
        itemTitle:addChild(self.titleDes);
        self.titleDes:setPosition(itemTitle:getPositionX(),itemTitle:getPositionY());
    end
    
    
    local returnBtn  = self:getChildByName("returnBtn");
    local returnLabel = returnBtn:getChildByName("returnText");
    if self.returnText == nil then
        self.returnText = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("Common_cancel"));
       returnBtn:addChild(self.returnText);
       self.returnText:setPosition(returnLabel:getPosition());
    end
    
    local exitBtn  = self:getChildByName("exitBtn");
    local exitText = exitBtn:getChildByName("exitText");
    local closeBtn = self:getChildByName("closeBtn");
    if self.exitText == nil then
        self.exitText = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("Common_settingQuit"));
        exitBtn:addChild(self.exitText);
        self.exitText:setPosition(exitText:getPosition());
    end
    
    local function onReturn(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            MainValue.mxAlertManager:removePanel()
            MainValue.actionManager:createJellyAction():run(sender,40);
        end
    end
    
    local function onQuit(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            cc.Director:getInstance():endToLua();
            MainValue.mxAlertManager:removePanel()
        end
    end
    
    returnBtn:addTouchEventListener(onReturn);
    exitBtn:addTouchEventListener(onQuit);
    closeBtn:addTouchEventListener(onReturn);
    
end

function ExitLoginPanel:init()
    MainValue.actionManager:createUIAction():UIAppear(self);
    MainValue.soundManager:playEffect(GameSoundEffectId.CLOSE_D);
end

return ExitLoginPanel