local BagCell = class("BagCell",function()
    return cc.Node:create();
end)

function BagCell:ctor()
    
    self.backImg = nil;
    self.iconImg = nil;
    self.numText = nil;
    self.goodsId = nil;
    
    self.backImg = ccui.Button:create();--cc.Sprite:createWithSpriteFrameName("ui/ui/BagCell1.png")
    self.backImg:loadTextures("ui/ui/BagCell1.png", "ui/ui/BagCell1.png","",1);
    self.backImg:setAnchorPoint(0,1);
    self:addChild(self.backImg);
    
    local topImg = cc.Sprite:createWithSpriteFrameName("ui/ui/BagCell2.png")
    topImg:setAnchorPoint(0,1);
    self:addChild(topImg,2);
end

function BagCell.create()
    local thisUI = BagCell.new();
    return thisUI;
end

function BagCell:init(gid,parent)
    self.goodsId = gid;
    if self.goodsId ==1 or self.goodsId == 4 or self.goodsId ==5 or self.goodsId == 7 then
        local str = string.format("ui/prop/big/%d.png",self.goodsId);
        self.iconImg =  cc.Sprite:create(str);
        self.iconImg:setPosition(52,-52);
        self.iconImg:setScale(0.6);
        self:addChild(self.iconImg, 1);
        local goodsNum =  MainValue.dataManager.goodsManager:getGoodsNumber(self.goodsId);
        self.numText  = FacFont:getFontsBmp(FontType.FontWhite, goodsNum);
        self:addChild(self.numText,3);
        self.numText:setScale(0.9);
        self.numText:setPosition(84,-83);
        
        
        local function onClick(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local isBuyItem = require("ui/inGame/IsBuyItemPanel");
                local isBuyItemPanel = isBuyItem.create(self.goodsId,1);
                isBuyItemPanel:setCell(parent);                
                isBuyItemPanel:appearAlone();
            end           
        end
        self.backImg:setTouchEnabled(true);
        self.backImg:addTouchEventListener(onClick);
    end
end

function BagCell:updateGoodsNum(num)
    self.numText:setText(num);
end

function BagCell:GC()
    self:removeFromParent(true);
end

return BagCell;