require "config.storeConfig"
require "data/buydata/BuyFlowData" 
require "ui.playGamePanel.PlayGamePanel"
local BagUI = class("BagUI",function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/BagUI.json")
end)

function BagUI:ctor()

    self.cellList = {};
    self.callBackUpdateGoodsNum = nil;
    self.callBackUpdataCash = nil;
  --触发类型 1：道具触发
 -- self.formType = nil;
  --触发类型所带数据
  --self.formData = nil;
  
-- self.isSuc = 0;
-- self.id = 0
    local tempPanel = cc.Node:create();
    tempPanel:setPosition(-212,190);
    self:addChild(tempPanel);
    
    local tempCellCls = require("src.ui.bag.BagCell");
    for round = 0, 11 do
        local tempCell = tempCellCls.create();
        tempCell:setPosition((round%4)*110, - math.floor(round/4)*120);
        tempPanel:addChild(tempCell);
        self.cellList[round+1] = tempCell;
    end
    
    self.cellList[1]:init(1,self);
    self.cellList[2]:init(4,self);
    self.cellList[3]:init(5,self);
    self.cellList[4]:init(7,self);
    
    --更新数量
    local function updateGoodsNum(idpar,num)
        local expid = tonumber(idpar);
        if expid == 1 then
            self.cellList[1]:updateGoodsNum(num);
        elseif expid == 4 then
            self.cellList[2]:updateGoodsNum(num);
        elseif expid == 5 then
            self.cellList[3]:updateGoodsNum(num);
        elseif expid == 7 then
            self.cellList[4]:updateGoodsNum(num);
        end
    end 
    self.callBackUpdateGoodsNum = updateGoodsNum;
    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_GOODS, updateGoodsNum);

end

function BagUI.create(data,type)
    local thisUI = BagUI.new();
    thisUI:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);
    
    thisUI.formType = type;
    thisUI.formData = data;

    local titleLB = thisUI:getChildByName("title")
    local title = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,MainValue.infosManager:getObjMultilingualByKey("Common_BuyGoldTitle"))
    title:setPosition(titleLB:getPositionX(),titleLB:getPositionY()-20)
    thisUI:addChild(title)
    titleLB:removeFromParent(true);
    
    local cashPanel = thisUI:getChildByName("cashBar");
    local cashNumber = cashPanel:getChildByName("cashNumber");
    local cashPic = FacFont:getFontsBmp(FontType.FontSmallWhiteBrownSide,MainValue.dataManager.userManager:getCash());
    cashPic:setScale(0.87)
    cashPic:setPosition(-5, 0)
    cashNumber:addChild(cashPic);
--    local shopDes = thisUI:getChildByName("shopDes");
--    local shopDesc = FacFont:getFontsBmp(FontType.FontRed,"All purchases are in US Dollars");
--    shopDesc:setPosition(shopDes:getPosition())
--    thisUI:addChild(shopDesc)
--    shopDes:removeFromParent(true);

   
    
   
    
    
    
    
   
    
--    local storeCellClz = require("ui.BagUI.StoreCell");
--    for i in pairs(storeConfig.cash) do
--        local cell = storeCellClz.create(thisUI.disapperAlone,thisUI);
--        cell:init(storeConfig.cash[i]);
--        cell:setPosition(0,(cell:getContentSize().height + 17)*(i-1) - 330);
--        thisUI:addChild(cell,1);
--        thisUI.cellList[i] = cell;
--    end

    local closeBtn = tolua.cast(thisUI:getChildByName("CloseBtn"), "ccui.Button")
    closeBtn:getParent():removeChild(closeBtn)
    thisUI:addChild(closeBtn,2)
    
    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            if thisUI.isAloneShow then
                thisUI:disapperAlone();
            else
                thisUI:disapper();
            end
        end
    end

    closeBtn:addTouchEventListener(touchEvent);
    
    
    local function updataCash()
        cashPic:setText(MainValue.dataManager.userManager:getCash());     
    end
    thisUI.callBackUpdataCash = updataCash;
    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_CASH, updataCash);
    
    return thisUI;
end


function BagUI:appear()
    self.isAloneShow = false
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disapper);
    if MainValue.mxUIManager.topbar ~= nil  then
        MainValue.mxUIManager.topbar:visible(false);
    end;
end

function BagUI:appearAlone()
    self.isAloneShow = true
    MainValue.mxUIManager.panelManager:addPanelAlone(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disapperAlone);
    if MainValue.mxUIManager.topbar ~= nil  then
        MainValue.mxUIManager.topbar:visible(false);
    end;
end

function BagUI:appearComplete()

end



function BagUI:disapper()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_DOWN , self.disapperComplete)
     if MainValue.mxUIManager.topbar ~= nil  then
         MainValue.mxUIManager.topbar:visible(true);
    end;
end

function BagUI:disapperAlone()
    MainValue.mxUIManager.panelManager:removePanelAlone(self,PanelDisappearType.LEAVE_DOWN , self.disapperComplete)
     if MainValue.mxUIManager.topbar ~= nil  then
        MainValue.mxUIManager.topbar:visible(true);
    end;
end


function BagUI:disapperComplete()
    MainValue.eventDispatcher:removeEventListener(MainValue.eventDispatcher.eventType.EVENT_CASH, self.callBackUpdataCash);
    MainValue.eventDispatcher:removeEventListener(MainValue.eventDispatcher.eventType.EVENT_GOODS, self.callBackUpdateGoodsNum);
    
    self:clear();
    self:removeFromParent(true);
    
    --MainValue.eventDispatcher:removeEventListener(MainValue.eventDispatcher.eventType.EVENT_GOODS, self.updateGoodsNum);
    --MainValue.eventDispatcher:removeEventListener(MainValue.eventDispatcher.eventType.EVENT_CASH, self.updataCash);
end

function BagUI:clear()
    for i in pairs(self.cellList) do
       self.cellList[i]:GC();
   end
end

return BagUI; 