local blockerLockPanel = nil;
local BlockerLockPanel = class("BlockerLockPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/BlockerLock.json");
end);

function BlockerLockPanel.create(pbcInfo)
    blockerLockPanel = BlockerLockPanel.new()
    blockerLockPanel:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);
    blockerLockPanel:setScale(0);
    
    blockerLockPanel.pbcInfo = pbcInfo;
    blockerLockPanel.blockList = {blockerLockPanel:getChildByName("block1"),blockerLockPanel:getChildByName("block2"),blockerLockPanel:getChildByName("block3")};
    blockerLockPanel.blockPosList = {cc.p(blockerLockPanel.blockList[1]:getPositionX(),blockerLockPanel.blockList[1]:getPositionY()),
                                    cc.p(blockerLockPanel.blockList[2]:getPositionX(),blockerLockPanel.blockList[2]:getPositionY()),
                                    cc.p(blockerLockPanel.blockList[3]:getPositionX(),blockerLockPanel.blockList[3]:getPositionY())};
                                    
    blockerLockPanel.blockHeandList = {};                     
                                 
    
    local closebtn = blockerLockPanel:getChildByName("btnClose");
   -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            blockerLockPanel:disAppear();
        end
    end
    closebtn:addTouchEventListener(touchEvent);
    
    
    --title文本替换
    local newTitle = FacFont:getFontsBmp(FontType.FontRed, MainValue.infosManager:getObjMultilingualByKey("Blockerlock_title"));
    blockerLockPanel:addChild(newTitle);
    newTitle:setPosition(38,211);
    
    --unlock
    local unlockBtn = blockerLockPanel:getChildByName("btnUnlock");
    
    local friendHelpData = MainValue.dataManager.levelManager:getAllBlock();
    local itemblockInfo = friendHelpData[tostring(pbcInfo.act)];
    local friendListlen = nil;
     if itemblockInfo ~= nil and itemblockInfo.ids ~= nil then
        friendListlen = #itemblockInfo.ids;
     else
        friendListlen = 0;
     end
    
    local totalPrice = blockerLockPanel.pbcInfo.ct * blockerLockPanel.pbcInfo.ch - friendListlen * blockerLockPanel.pbcInfo.ch;
    local unlock = FacFont:getFontsBmp(FontType.FontRed,tostring("Unlock      ".. totalPrice));
    unlock:setScale(0.9);
    unlock:setPosition(128,51);
    unlockBtn:addChild(unlock);
    
    local function btnUnlockTouchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(sender,40);
            
            local act = blockerLockPanel.pbcInfo.act;
            local allBlockLength = #MainValue.dataManager.levelManager:getAllBlock();
            local setCount = blockerLockPanel.pbcInfo.ct - allBlockLength;
            local sentTable = {};
            for index=1,setCount do
                sentTable[index] = 1000;
            end

            local allcash = math.ceil(blockerLockPanel.pbcInfo.ch / blockerLockPanel.pbcInfo.ct) * #sentTable;
            if MainValue.dataManager.userManager:getCash() >= allcash then

                --{1000,fbid,1000}
                local succ = MainValue.dataManager.levelManager:setBlockFID(act,sentTable);
                if succ == true then
                    --统计
                    self:addBlockStatistics(tonumber(#sentTable), 
                                            tonumber(blockerLockPanel.pbcInfo.gd), 
                                            tonumber(blockerLockPanel.pbcInfo.ch), 
                                            tonumber(blockerLockPanel.pbcInfo.act))
                    MainValue.dataManager.userManager:subCash(allcash);
                    MainValue.mxUIManager.mapManager:succeedBlocker(blockerLockPanel.pbcInfo.act);
                    blockerLockPanel:disAppear();
                else
                    print("setBlockFID return false!");
                end
            else
                local notEnoughCashClz = require("ui.storeUI.StoreUI")
                local notEnoughCash = notEnoughCashClz.create();
                notEnoughCash:appearAlone();
            end
        end
    end
    unlockBtn:addTouchEventListener(btnUnlockTouchEvent)

    --ask friends
    local askFriendsBtn = blockerLockPanel:getChildByName("btnAskFriends");
    local askFriendsText = FacFont:getFontsBmp(FontType.FontRed,MainValue.infosManager:getObjMultilingualByKey("Blockerlock_btn_2"));
    askFriendsText:setScale(0.9);
    askFriendsBtn:addChild(askFriendsText);
    askFriendsText:setPosition(121,50);
    
    local function askFriendsBtnTouchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(sender,40);
            
            local function callBack()
                local askForLiveClz = require("ui/AskForHelp/AskForHelp")
                local askForLive = askForLiveClz.create(2);
                askForLive:setBlockId(pbcInfo.act);
                askForLive:appear();
            end
            MainValue.fbManager:isLoginByCallback(callBack);

            blockerLockPanel:disAppear();
        end
    end
    askFriendsBtn:addTouchEventListener(askFriendsBtnTouchEvent)
    
    --设置
    blockerLockPanel:setBlockItems();
    
    return blockerLockPanel;
end

function BlockerLockPanel:init()
end
--统计
function BlockerLockPanel:addBlockStatistics(itemNum, coins, cash, level)
    local lives_left = MainValue.dataManager.userManager:getHeart()
    local coins_left = 0;
    local cash_left = MainValue.dataManager.userManager:getCash()
    MainValue.statisticsManager:consumeBuyBlocker(1000, itemNum, coins, cash, level, lives_left, coins_left, cash_left, -1);
end

function BlockerLockPanel:setBlockItems()
    local userHeadFrameClz = require("ui/map/HeadFrame");

    for index=1,3 do
        blockerLockPanel.blockList[index]:setVisible(false);
        blockerLockPanel.blockList[index]:setPosition(blockerLockPanel.blockPosList[index].x,blockerLockPanel.blockPosList[1].y)
        
        blockerLockPanel.blockHeandList[index] = userHeadFrameClz.create();
        blockerLockPanel.blockHeandList[index]:init(2);
        blockerLockPanel.blockHeandList[index]:setPosition(70, 75);
        blockerLockPanel.blockList[index]:addChild(blockerLockPanel.blockHeandList[index]);
    end
     
    if blockerLockPanel.pbcInfo.ct == 1 then
         blockerLockPanel.blockList[2]:setVisible(true);
         self:refreshFriendHead(1,2);
    elseif blockerLockPanel.pbcInfo.ct == 2 then
        blockerLockPanel.blockList[1]:setVisible(true);
        blockerLockPanel.blockList[3]:setVisible(true);
        
        self:refreshFriendHead(1,1);
        self:refreshFriendHead(3,3);
        
        local offX = blockerLockPanel.blockList[1]:getPositionX() + 45;
        blockerLockPanel.blockList[1]:setPositionX(offX);
        
        offX = blockerLockPanel.blockList[3]:getPositionX() - 45;
        blockerLockPanel.blockList[3]:setPositionX(offX);
        
    elseif blockerLockPanel.pbcInfo.ct == 3 then  
        blockerLockPanel.blockList[1]:setVisible(true);
        blockerLockPanel.blockList[2]:setVisible(true);
        blockerLockPanel.blockList[3]:setVisible(true);
        
        self:refreshFriendHead(1,1);
        self:refreshFriendHead(2,2);
        self:refreshFriendHead(3,3);
    end
end
-- 头像
function BlockerLockPanel:refreshFriendHead(index,pos)
    local friendHelpData = MainValue.dataManager.levelManager:getAllBlock();
    local itemblockInfo = friendHelpData[tostring(blockerLockPanel.pbcInfo.act)];
    
    if itemblockInfo ~= nil and itemblockInfo.ids ~= nil then
        local friendList = itemblockInfo.ids;
        
        if friendList[index] ~= nil then
            local fbid = tostring(friendList[index]);
            local friendP =  MainValue.dataManager.friendManager:getPictureById(fbid);
            
            if fbid ~= "1000" and friendP ~= nil and index == pos then
                blockerLockPanel.blockHeandList[pos]:updataHead(fbid,friendP);
            end
        end

    end
end

function BlockerLockPanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.POP_UP, self.appearComplete);
end

function BlockerLockPanel:disAppear()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.POP_UNDER , self.disAppearComplete)
end

function BlockerLockPanel:appearComplete()
end

function BlockerLockPanel:disAppearComplete()
    MainValue.mxGameManager.gameStatusManager:setShowPanelCount(1);
end

return BlockerLockPanel