


local blockerRewardPanel = nil;
local BlockerRewardPanel = class("BlockerRewardPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/BlockerReward.json");
end);

function BlockerRewardPanel:disCallBackFun()
    blockerRewardPanel:removeFromParent(true);
end

function BlockerRewardPanel.create()
    blockerRewardPanel = BlockerRewardPanel.new()

    blockerRewardPanel:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);

    local closebtn = blockerRewardPanel:getChildByName("btnClose");

    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )

        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
          --  blockerRewardPanel:removeFromParent()
            MainValue.actionManager:createUIAction():UIDisappear(blockerRewardPanel,blockerRewardPanel.disCallBackFun);
        end
    end

    closebtn:addTouchEventListener(touchEvent)
    
    --title 设置
    local labelTitle = blockerRewardPanel:getChildByName("title"); 
    local label = FacFont:getFontsBmp(FontType.FontRed,"Blocker Rewards");--TODO
    blockerRewardPanel:addChild(label);
    label:setPosition(labelTitle:getPosition());
    labelTitle:removeFromParent();
    
    --coins 描述 替换文本
    local coinsText = blockerRewardPanel:getChildByName("TxtCoins");
    local coinNew = FacFont:getFontsBmp(FontType.FontRed,MainValue.infosManager:getObjMultilingualByKey("Common_coin"));
    blockerRewardPanel:addChild(coinNew);
    coinNew:setPosition(coinsText:getPosition());
    coinsText:removeFromParent();
    
    --numText替换文本
    local numTex = blockerRewardPanel:getChildByName("TxtCoinNum");
    local newNum = FacFont:getFontsBmp(FontType.FontRed,"X 1000");--TODO
    blockerRewardPanel:addChild(newNum);
    newNum:setPosition(numTex:getPosition());
    numTex:removeFromParent();
    
    --des（congratulations）替换文本
    local des = blockerRewardPanel:getChildByName("TxtNote");
    local newDes = FacFont:getFontsBmp(FontType.FontRed,MainValue.infosManager:getObjMultilingualByKey("Common_congratulation"));
    blockerRewardPanel:addChild(newDes);
    newDes:setPosition(des:getPosition());
    des:removeFromParent();
    
    --btn
    local shareBtn = blockerRewardPanel:getChildByName("btnShare");
    local shareLabel = shareBtn:getChildByName("TxtBtnName");
    local shareText = FacFont:getFontsBmp(FontType.FontRed,MainValue.infosManager:getObjMultilingualByKey("Common_share_coinsNum"));
    shareBtn:addChild(shareText);
    local fbIconImg = cc.Sprite:createWithSpriteFrameName("iconFBR.png");
    fbIconImg:setPosition(30, 60);
   shareBtn:addChild(fbIconImg);
    shareText:setPosition(shareLabel:getPosition());
    shareLabel:removeFromParent();
    
    


    return blockerRewardPanel;
end


function BlockerRewardPanel:init()
    MainValue.actionManager:createUIAction():UIAppear(blockerRewardPanel);
end

return BlockerRewardPanel