require "engine.uigridtools.SpecialGridTools"

local BoxLockPanel = class("BoxLockPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/BoxLock.json");
end);

function BoxLockPanel:ctor()
    self.path = "ui/prop/big/";
    self.isShowBtn = false;
    self.itemNodeList = nil;
    self.flag = nil;
end

function BoxLockPanel.create(pbcInfo,flag_)
    MainValue.soundManager:playEffect("Combine");
    local blockerLockPanel = BoxLockPanel.new()
    blockerLockPanel:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);
    
    blockerLockPanel.flag = flag_;
    blockerLockPanel.pbcInfo = pbcInfo;
    
    local unlockBtn = blockerLockPanel:getChildByName("btnlock");
    unlockBtn:setVisible(false)
        
    local closebtn = blockerLockPanel:getChildByName("btnClose");
   -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
        
            if blockerLockPanel.flag == 1 then
                MainValue.mxUIManager.mapManager:getMap():upDateMission(MainValue.SELECTED_LEVEL)
            end
            blockerLockPanel:disAppear();
        end
    end
    closebtn:addTouchEventListener(touchEvent);
    
    local desBg = SpecialGridTools.create("ui/ui/bgCooky.png",480,240,26)
    desBg:setPosition(2, 23)
    blockerLockPanel:addChild(desBg)
    
    
    --title文本替换
    local newTitle = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, MainValue.infosManager:getObjMultilingualByKey("Common_BoxlockTitle"));
    newTitle:setPosition(0,280);
    blockerLockPanel:addChild(newTitle);
    
    --条
    local loadingBar = blockerLockPanel:getChildByName("pbbg"):getChildByName("Pb")
    loadingBar:setPercent(0)
    loadingBar:setVisible(false)
  
    
    blockerLockPanel.clippingNode = cc.ClippingNode:create()
    blockerLockPanel.clippingNode:setPosition(-43,86)   
    
    blockerLockPanel.stencil = cc.Sprite:createWithSpriteFrameName("ui/ui/collectAimProgessFront.png") --遮罩
    blockerLockPanel.stencil:retain()
    blockerLockPanel.stencil:setScale(1.27,1) 
    
    blockerLockPanel.clipSize = blockerLockPanel.stencil:getContentSize() 
       
    blockerLockPanel.spark  = cc.Sprite:createWithSpriteFrameName("ui/ui/collectAimProgessFront.png")  
    blockerLockPanel.spark:retain()
    blockerLockPanel.spark:setScale(1.27,1) 
    
    blockerLockPanel.clippingNode:setContentSize(blockerLockPanel.clipSize)
    blockerLockPanel.clippingNode:addChild(blockerLockPanel.spark)
    blockerLockPanel.clippingNode:retain()
    
    blockerLockPanel.clippingNode:setInverted(false)
    blockerLockPanel.clippingNode:setAlphaThreshold(0)
    
    blockerLockPanel.clippingNode:setStencil(blockerLockPanel.stencil)       
    blockerLockPanel:addChild(blockerLockPanel.clippingNode,1)
    
    blockerLockPanel.stencil:setPositionX(-330+3)   
    
    local allStar = MainValue.dataManager.levelManager:getMaxStar();
    local cStar = blockerLockPanel.pbcInfo.needStar;
    local count = 10;
    local maxCount = 330;
    local bl = allStar / cStar;
    if bl < 1 then
        maxCount = bl * 100 * 3.3;
    end

    local function update(delta)
        if count < maxCount then
            count = count + 8
            blockerLockPanel.stencil:setPositionX(-330+count)  
        else
            blockerLockPanel:unscheduleUpdate()
            --设置
            blockerLockPanel:setItems();
        end
    end

    blockerLockPanel:scheduleUpdateWithPriorityLua(update,0)
    
    
    --条字
    local barText = FacFont:getFontsBmp(FontType.FontWhite, allStar.."/"..cStar,310,'R');
    barText:setScale(0.6) 
    barText:setPosition(30,84);
    blockerLockPanel:addChild(barText,1);
    
    --unlock
    if maxCount >= 330 then
        blockerLockPanel.isShowBtn = true;
    else
        local bgsp =  NineGridTools.create("ui/ui/btnGray.png",246,110,40)
        bgsp:setPosition(-2,-194);
        blockerLockPanel:addChild(bgsp,1);
    
        local unlock = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("Common_BoxlockBtnlockName"));
        unlock:setPosition(0,-164);
        blockerLockPanel:addChild(unlock,1);
    end
    
    
    return blockerLockPanel;
end

function BoxLockPanel:init()
end

function BoxLockPanel:setItems()
    self.itemNodeList = {};
    local items = self.pbcInfo.items
    local itemsLen = #items
     
    if itemsLen == 1 then
        local item = self:creatItemNode(items[1][1],items[1][2])
        item:setScale(0)
        item:setPosition(0,-10)
        self:addChild(item)
        
        local function callFun()
            MainValue.actionManager:createJellyAction():run(item,40, function()
                if self.isShowBtn then
                    self:addGetBtn()
                end
            end);
        end
        
        MainValue.soundManager:playEffect("b_click_B");
        local ac3 = cc.Sequence:create(cc.EaseOut:create(cc.ScaleTo:create(0.1, 1), 1), cc.CallFunc:create(callFun));
        item:runAction(ac3)
        self.itemNodeList[1] = item;
    elseif itemsLen == 2 then
        local item = self:creatItemNode(items[1][1],items[1][2])
        item:setScale(0)
        item:setPosition(-90,-10)
        self:addChild(item)
        
        local item1 = self:creatItemNode(items[2][1],items[2][2])
        item1:setScale(0)
        item1:setPosition(90,-10)
        self:addChild(item1)
        
        self.itemNodeList[1] = item;
        self.itemNodeList[2] = item1;
        
        local function callFun()
            MainValue.actionManager:createJellyAction():run(item,40);
            
            local function callFun1()
                MainValue.actionManager:createJellyAction():run(item1,40, function()
                    if self.isShowBtn then
                        self:addGetBtn()
                    end
                end);
            end
            
            MainValue.soundManager:playEffect("b_click_B");
            local ac = cc.Sequence:create(cc.EaseOut:create(cc.ScaleTo:create(0.1, 1), 1), cc.CallFunc:create(callFun1));
            item1:runAction(ac)
        end
        MainValue.soundManager:playEffect("b_click_B");
        local ac3 = cc.Sequence:create(cc.EaseOut:create(cc.ScaleTo:create(0.1, 1), 1), cc.CallFunc:create(callFun));
        item:runAction(ac3)
        
    elseif itemsLen == 3 then  
        local item = self:creatItemNode(items[1][1],items[1][2])
        item:setScale(0)
        item:setPosition(-150,-10)
        self:addChild(item)

        local item1 = self:creatItemNode(items[2][1],items[2][2])
        item1:setScale(0)
        item1:setPosition(0,-10)
        self:addChild(item1)
        
        local item2 = self:creatItemNode(items[3][1],items[3][2])
        item2:setScale(0)
        item2:setPosition(150,-10)
        self:addChild(item2)
        
        self.itemNodeList[1] = item;
        self.itemNodeList[2] = item1;
        self.itemNodeList[3] = item2;
        
        local function callFun()
            MainValue.actionManager:createJellyAction():run(item,40);

            local function callFun1()
                MainValue.actionManager:createJellyAction():run(item1,40);
                
                local function callFun2()
                    MainValue.actionManager:createJellyAction():run(item2,40, function()
                        if self.isShowBtn then
                            self:addGetBtn()
                        end
                    end);
                end
                MainValue.soundManager:playEffect("b_click_B");
                local ac2 = cc.Sequence:create(cc.EaseOut:create(cc.ScaleTo:create(0.1, 1), 1), cc.CallFunc:create(callFun2));
                item2:runAction(ac2)
            end
            
            MainValue.soundManager:playEffect("b_click_B");
            local ac = cc.Sequence:create(cc.EaseOut:create(cc.ScaleTo:create(0.1, 1), 1), cc.CallFunc:create(callFun1));
            item1:runAction(ac)
        end
        MainValue.soundManager:playEffect("b_click_B");
        local ac3 = cc.Sequence:create(cc.EaseOut:create(cc.ScaleTo:create(0.1, 1), 1), cc.CallFunc:create(callFun));
        item:runAction(ac3)
    end
end

function BoxLockPanel:creatItemNode(itemId,itemNum)
    local itemNode = cc.Node:create();
    
    --itemIcon
    local itemPath = self.path..itemId..".png";
    local itemIcon = cc.Sprite:create(itemPath);
    itemNode:addChild(itemIcon);
    
    --itemNum
    local itemNumS = itemNum;
    local itemNumTxt = FacFont:getFontsBmp(FontType.FontWhite, itemNumS, 100, "R");
    itemNumTxt:setScale(0.8);
    itemNumTxt:setPosition(20,-35);
    itemNode:addChild(itemNumTxt);
    
    --shadow
--    local shadowImg = cc.Sprite:createWithSpriteFrameName("ui/ui/shadow.png");
--    shadowImg:setPosition(0,-70);
--    itemNode:addChild(shadowImg);
    
    itemNode:setContentSize(itemIcon:getContentSize().width,itemIcon:getContentSize().height);
    
    return itemNode;
end

function BoxLockPanel:addGetBtn()
    local unlockBtn = self:getChildByName("btnlock");

    local unlock = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("Common_BoxlockBtnlockName"));
    --unlock:setScale(0.9);
    unlock:setPosition(122,68);
    unlockBtn:addChild(unlock);
    
    unlockBtn:setVisible(true)

    local function btnUnlockTouchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(unlockBtn,40);
            
            local retS = MainValue.dataManager.levelManager:openBoxById(self.pbcInfo.act);
            
            if retS then
                for var=1, #self.pbcInfo.items do
                    if self.pbcInfo.items[var][1] == 0 then
                        MainValue.dataManager.userManager:addCash(self.pbcInfo.items[var][2]);
                    else
                        MainValue.dataManager.goodsManager:addGoods(self.pbcInfo.items[var][1],self.pbcInfo.items[var][2])
                    end
                end
            end
            
            self:succItem()
        end
    end
    unlockBtn:addTouchEventListener(btnUnlockTouchEvent)
    
    
end

function BoxLockPanel:succItem()
    MainValue.soundManager:playEffect("Create_PU_cross_modify");
    
    for var=1, #self.itemNodeList do
        local duigou = cc.Sprite:createWithSpriteFrameName("ui/ui/iconTickL.png");
        duigou:setAnchorPoint(0.5,0.5);
        duigou:setPosition(30,-35);
        self.itemNodeList[var]:addChild(duigou);
        
        MainValue.actionManager:createJellyAction():run(duigou,30,function()
            if var >= #self.itemNodeList then
                MainValue.mxUIManager.mapManager:succeedBlocker(self.pbcInfo.act);
                
                local function callFun()
                    if self.flag == 1 then
                        MainValue.mxUIManager.mapManager:getMap():upDateMission(MainValue.SELECTED_LEVEL)
                    end
                    self:disAppear();
                end
                
                local ac = cc.Sequence:create(cc.ScaleTo:create(1,1),cc.CallFunc:create(callFun));
                duigou:runAction(ac)
            end
        end);
    end
end

function BoxLockPanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.POP_UP, self.appearComplete);
end

function BoxLockPanel:disAppear()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.POP_UNDER , self.disAppearComplete)
end

function BoxLockPanel:appearComplete()
end

function BoxLockPanel:disAppearComplete()
    self:removeFromParent(true)
end

function BoxLockPanel:darkNode(node)
    local vertDefaultSource = "\n"..
        "attribute vec4 a_position; \n" ..
        "attribute vec2 a_texCoord; \n" ..
        "attribute vec4 a_color; \n"..                                                    
        "#ifdef GL_ES  \n"..
        "varying lowp vec4 v_fragmentColor;\n"..
        "varying mediump vec2 v_texCoord;\n"..
        "#else                      \n" ..
        "varying vec4 v_fragmentColor; \n" ..
        "varying vec2 v_texCoord;  \n"..
        "#endif    \n"..
        "void main() \n"..
        "{\n" ..
        "gl_Position = CC_PMatrix * a_position; \n"..
        "v_fragmentColor = a_color;\n"..
        "v_texCoord = a_texCoord;\n"..
        "}"

    local pszFragSource = "#ifdef GL_ES \n" ..
        "precision mediump float; \n" ..
        "#endif \n" ..
        "varying vec4 v_fragmentColor; \n" ..
        "varying vec2 v_texCoord; \n" ..
        "void main(void) \n" ..
        "{ \n" ..
        "vec4 c = texture2D(CC_Texture0, v_texCoord); \n" ..
        "gl_FragColor.xyz = vec3(0.4*c.r + 0.4*c.g +0.4*c.b); \n"..
        "gl_FragColor.w = c.w; \n"..
        "}"

    local pProgram = cc.GLProgram:createWithByteArrays(vertDefaultSource,pszFragSource)

    pProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_POSITION,cc.VERTEX_ATTRIB_POSITION)
    pProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_COLOR,cc.VERTEX_ATTRIB_COLOR)
    pProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_TEX_COORD,cc.VERTEX_ATTRIB_FLAG_TEX_COORDS)
    pProgram:link()
    pProgram:updateUniforms()
    node:setGLProgram(pProgram)
end

return BoxLockPanel