require("engine/uigridtools/NineGridTools")
local BuyResultUI = class("BuyResultUI", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/BuyResultUI.json");
end);


function BuyResultUI:ctor(sucAfterShowUIFunPar)   

    self.sucAfterShowUIFun = sucAfterShowUIFunPar
  
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);
    self.titleName = FacFont:getFontsBmp(FontType.FontWhite,"Purchase completed")
    --    Purchase cancelled
    self.titleName:setScale(0.9)
    self.titleName:setPosition(8, 256)
    self:addChild(self.titleName)


    self.coinNumDes = FacFont:getFontsBmp(FontType.FontWhite,"+ 3")
    self.coinNumDes:setPosition(50, -55)
--    self.coinNumDes:setScale(0.6)
    self:addChild(self.coinNumDes)

    self.aniPanel = self:getChildByName("bgLayer");
    self.desBgWin = SpecialGridTools.create("ui/ui/bgCooky.png",390,260,26);
    self.desBgWin:setAnchorPoint(0.5,0.5)
    self.desBgWin:setPosition(7,-45)  
    self.aniPanel:addChild(self.desBgWin)
    
    self.desBgFail = SpecialGridTools.create("ui/ui/bgCooky.png",450,150,26);
    self.desBgFail:setAnchorPoint(0.5,0.5)
    self.desBgFail:setPosition(7,-147)  
    self.aniPanel:addChild(self.desBgFail)
    
    
    self.buyFailDes = FacFont:getFontsBmp(FontType.FontWhite,"No money was taken from your account.",276,"C")
    self.buyFailDes:setPosition(29, -134)
    self:addChild(self.buyFailDes)
    
    
    self.iconBgRsc = self:getChildByName("iconBg");
    self.iconBgX,self.iconBgY = self.iconBgRsc:getPosition()
    
    self.shaderSp = cc.Sprite:createWithSpriteFrameName("ui/ui/dailyTouying.png") --背景图片
    self.shaderSp:setPosition(70,36)
    self.iconBgRsc:addChild(self.shaderSp)
    
    
    self.coinIconRsc = self:getChildByName("CoinIcon");
    self.coinIconX,self.coinIconY = self.coinIconRsc:getPosition()
    
    
    
    
    
    self.btnContinue = self:getChildByName("BtnContinue")    
    
    self.btnContinueTxt = FacFont:getFontsBmp(FontType.FontWhite,"Continue")
    self.btnContinueTxt:setScale(0.9)
    self.btnContinueTxt:setPosition(110,46)
    self.btnContinue:addChild(self.btnContinueTxt)
    
    self.duiGou = self:getChildByName("DuiGou")
    
    self.chacha = self:getChildByName("ChaHao")
    
    self.duiGou:setVisible(false)
    self.chacha:setVisible(false)
    self.desBgFail:setVisible(false)
    self.buyFailDes:setVisible(false)
    self.desBgWin:setVisible(false)
    self.btnClose = self:getChildByName("BtnClose")
    
    
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            print("BuyResultUI --- onContinueHandler  FUN ") 
            self:onClose();
        end
    end
    self.btnClose:addTouchEventListener(touchEvent);
    
    local function onContinueHandler( sender, eventType )
        if eventType == ccui.TouchEventType.ended then           
    -- 
            self:onClose();
        print("BuyResultUI --- onContinueHandler  FUN ") 
        end
    end
    self.btnContinue:addTouchEventListener(onContinueHandler)
    
--    self:setScoreData(1)
    return self
end
--@param coinNum  如果0说购买失败了 如果》0 说明购买成功了
function BuyResultUI:setScoreData(coinNumPar)
    self.tarCoinNum = coinNumPar
    if tonumber(self.tarCoinNum) > 0 then    
--    购买成功
        self.titleName:setText("Purchase completed")
        self.duiGou:setVisible(true)
        self.desBgFail:setVisible(false)
        self.desBgWin:setVisible(true)
        self.coinNumDes:setText("+ "..coinNumPar)
        self.coinNumDes:setPosition(50, -55+15)        
        self.iconBgRsc:setPosition(self.iconBgX,self.iconBgY+15)
        self.coinIconRsc:setPosition(self.coinIconX,self.coinIconY+15)

    else
--    购买失败
        self.buyFailDes:setVisible(true)
        self.desBgFail:setVisible(true)
        self.desBgWin:setVisible(false)
        self.titleName:setText("Purchase cancelled")
        self.chacha:setVisible(true)
        self.coinNumDes:setPosition(50, -55 +60) --失败 +0 坐标
        self.iconBgRsc:setPosition(self.iconBgX,self.iconBgY + 60)
        self.coinIconRsc:setPosition(self.coinIconX,self.coinIconY + 60)
    end
    
    
end


function BuyResultUI:onClose()
      self:disapper()
end

function BuyResultUI:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.POP_UP, self.appearComplete,self.disapper);
end

function BuyResultUI:appearComplete()

end

function BuyResultUI:disapper()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.POP_UNDER , self.disapperComplete)
end

function BuyResultUI:disapperComplete()
 if tonumber(self.tarCoinNum) > 0 then
       if self.sucAfterShowUIFun ~= nil then
           self.sucAfterShowUIFun()
       end
 else
--  失败
    if self.sucAfterShowUIFun ~= nil then
        self.sucAfterShowUIFun()
    end

 end
   self:GC()
   
end

function BuyResultUI:GC()

end

return BuyResultUI