local TargetDesCell = class("TargetDesCell",function()
    return cc.Node:create();
end)

function TargetDesCell:ctor()
    self.bg = nil;
    self.itemPic = nil;
    self.targetLabel = nil;
    self.isShowTick = nil;
    self.markIcon = nil;
    self.targetData = nil;
end

function TargetDesCell:create(data, isShowTick, isShowBg)
    local _targetDesCell = TargetDesCell.new();
    _targetDesCell.targetData = data;
    _targetDesCell.isShowTick = isShowTick;
    _targetDesCell.isShowBg = isShowBg;
    _targetDesCell:init();
    return _targetDesCell
end

function TargetDesCell:init()
    if self.isShowBg then
--        self.bg = cc.Sprite:createWithSpriteFrameName(TargetDesCell:getBgType(self.targetData.id))
--        self:addChild(self.bg)
    end
    
    self.itemPic = cc.Sprite:create("ui/target/" .. self.targetData.id .. ".png")
    self.itemPic:setPositionX(-5)
    self:addChild(self.itemPic)
   
    if self.isShowTick then
        if self.targetData.curNum == self.targetData.tarNum then
            self.markIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/iconTickL.png")
        else
            self.markIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/iconCross.png")
        end
        self.markIcon:setPosition(-5,-3);
        self:addChild(self.markIcon)
    end
    
    if self.targetData.curNum ~= self.targetData.tarNum then
        self.targetLabel = FacFont:getFontsBmp(FontType.FontYellowWhiteSide, tostring(self.targetData.tarNum - self.targetData.curNum))
        self.targetLabel:setPosition(34, -28)
       -- self.targetLabel:setScale(0.6, 0.6);
        self:addChild(self.targetLabel)
    end
end 

function TargetDesCell:getBgType(id)
    local result = nil
    local itemId = tostring(id)
    
    if (itemId:sub(1, 1) == "1" and string.len(itemId) == 3) or itemId:sub(1,4) == "100_" then--粉色块
        result = "ui/ui/bgGoalsR.png"
    elseif (itemId:sub(1, 1) == "3" and string.len(itemId) == 3) or itemId:sub(1,4) == "300_" then--红色块
        result = "ui/ui/bgGoalsR.png"
    elseif (itemId:sub(1, 1) == "4" and string.len(itemId) == 3) or itemId:sub(1,4) == "400_" then--黄色块
        result = "ui/ui/bgGoalsY.png"
    elseif (itemId:sub(1, 1) == "5" and string.len(itemId) == 3) or itemId:sub(1,4) == "500_" then--棕色块
        result = "ui/ui/bgGoalsY.png"
    elseif (itemId:sub(1, 1) == "2" and string.len(itemId) == 3) or itemId:sub(1,4) == "200_" then--蓝色块
        result = "ui/ui/bgGoasB.png"
    else--其他块
        result = "ui/ui/bgGoasB.png"
    end
    return result
end

return TargetDesCell