local TargetListView = class("TargetListView",function(targetData, isShowTick)
    return cc.Node:create();
end)

function TargetListView:ctor()
    self.targetData = nil
    self.isShowTick = false
    self.isShowBg = true
    
    self.cellList = nil;
end

function TargetListView:create(targetData, isShowTick, isShowBg)
    local _targetListView = TargetListView.new();
    
    _targetListView.targetData = targetData;
    _targetListView.isShowTick = isShowTick;
    _targetListView.isShowBg = isShowBg;
    
    _targetListView:init();
    return _targetListView;
end

function TargetListView:init()
    local cellCls = require("ui/collectTarget/TargetDesCell")
    
    self.cellList = {};
    local len = #self.targetData;
    for i = 1, len do
        local cell = cellCls:create(self.targetData[i], self.isShowTick, self.isShowBg)
        cell:setPositionX((3 - len) * 95 + 190 * (i - 1))
        self:addChild(cell)
        table.insert(self.cellList, cell)
    end
end

function TargetListView:GC()
    for i, cell in ipairs(self.cellList) do
        cell:removeFromParent(true);
    end
    
    self:removeFromParent(true);
end

return TargetListView;