require "src.ui.collectaimui.CellAim"
require "src.ui.collectaimui.scorestarui.ScoreProgressBar"
require "engine.uigridtools.RepeatXTools"
require "engine.uigridtools.ThreeLMRGridTools"

--local layer = nil

--local panelLeftLayer=nil
local scoreNum = nil
local lvNum = nil

local tarStepNum = nil
local stepNumBmp = nil


local cellAry = nil


local collCellIndex = 1


local armatureColorLight = nil

local scoreProgressBar = nil
local oldScore = 0
local tarlvTotalScore = 300

local eftFinal1 = nil --final 步数转化成道具时步数数字后的动画
local gameStatus = -1 -- 游戏状态

local CollectAimUI = class("CollectAimUI", function()
    return cc.Layer:create()
end);



function CollectAimUI:ctor()

    self.isOnlyLeftFiveStep = false
    self.isfinalCanPlayElephant = true
    
    self:setContentSize(480,320)
    self:setAnchorPoint(0,0)
    
    self.middleBg = cc.Sprite:createWithSpriteFrameName("collectAimMovesBg.png")
    
    self.middleBg:setPosition(0,-55)
    self:addChild(self.middleBg)
        
    
        
    self.bgSpr = RepeatXTools.new("collectAimTitleBg.png",1200)--788
    self.bgSpr:setPosition(-100,-151)
    self:addChild(self.bgSpr)
        
        
    self.isWiting = false    
    
    self.panelLeftLayer = cc.Layer:create()
    self.panelLeftLayer:setContentSize(200,200)
    self.panelLeftLayer:setAnchorPoint(0,0)
    self.panelLeftLayer:setPosition(-294,-176)
    self:addChild(self.panelLeftLayer)
    
--    分数的背景
    self.scoreBg = ThreeLMRGridTools.new("collectAimScoresBg.png",233,15)
    self.scoreBg:setPosition(63,93)
    self.panelLeftLayer:addChild(self.scoreBg)
    
    cellAry = {}  
   
    self.scoreNumTitle = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("ingame_top_score"));
    self.scoreNumTitle:setScale(0.7)
    self.scoreNumTitle:setPosition(cc.p(8, 102))
    self.panelLeftLayer:addChild(self.scoreNumTitle) 
   
    if scoreNum == nil then
        scoreNum = FacFont:getFontsBmp(FontType.FontWhite,"123")   --string  
        scoreNum:setAnchorPoint(1,0.5)  
        scoreNum:setPosition(cc.p(177, 102))
        scoreNum:setScale(0.8)
        self.panelLeftLayer:addChild(scoreNum)
    end
    
    
    
     
    
    scoreProgressBar = ScoreProgressBar.new()
    scoreProgressBar:initUI()
    scoreProgressBar:setPosition(cc.p(45,171))
    self.panelLeftLayer:addChild(scoreProgressBar)  



    if lvNum == nil then
        lvNum = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,"8")   --string    
        lvNum:setPosition(15,150)
        lvNum:setScale(0.45)
        self.panelLeftLayer:addChild(lvNum)
        
        lvNum:setCascadeOpacityEnabled(true)--设置透明度处理
        lvNum:setOpacity(125)--//渐隐
    end          

    self.panelMidLayer = cc.Layer:create()
    self.panelMidLayer:setContentSize(100,100)
    self.panelMidLayer:setAnchorPoint(0,0)
    self.panelMidLayer:setPosition(-97,-201)
    self:addChild(self.panelMidLayer)
    
   
    if stepNumBmp == nil then
        stepNumBmp = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, "56");

        stepNumBmp:setPosition(cc.p(96,178))
        
        self.panelMidLayer:addChild(stepNumBmp)
    end
    self.moves = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("ingame_top_step"))
    self.moves:setPosition(cc.p(98,109))
    self.moves:setScale(0.5)
    self.panelMidLayer:addChild(self.moves)
    
    
    
    self.panelRightLayer = cc.Layer:create()
    self.panelRightLayer:setContentSize(200,100)
    self.panelRightLayer:setAnchorPoint(0,0)
    self.panelRightLayer:setPosition(110,-210)
    self:addChild(self.panelRightLayer)
    
    
    
    self.oneContentSpr = ThreeLMRGridTools.new("collectAimGoalBg.png",160,33)
    self.oneContentSpr:setPosition(95,48)
    self.panelRightLayer:addChild(self.oneContentSpr)
    

    self.twoContentSpr = ThreeLMRGridTools.new("collectAimGoalBg.png",210,33)
    self.twoContentSpr:setPosition(96,48)
    self.panelRightLayer:addChild(self.twoContentSpr)
    

    self.threeContentSpr = ThreeLMRGridTools.new("collectAimGoalBg.png",280,33)
    self.threeContentSpr:setPosition(83,48)
    self.panelRightLayer:addChild(self.threeContentSpr)
    
    
    self.oneContentSpr:setVisible(false)
    self.twoContentSpr:setVisible(false)
    self.threeContentSpr:setVisible(false)
    
    
    

    armatureColorLight = ccs.Armature:create("colorlight")
    -- 设置位置
    armatureColorLight:setPosition(cc.p(98,145))
    -- 播放动画, 播放指定动作
    armatureColorLight:getAnimation():play("5")
    self.panelMidLayer:addChild(armatureColorLight)   
   
       
    return self
end


--加两步动画处理
function CollectAimUI:showAddTwoStepAni()
    if self.stepNumBackAni == nil then
        self.stepNumBackAni = ccs.Armature:create("addTowStepHou")
    end
    -- 设置位置
    self.stepNumBackAni:setPosition(cc.p(98,145))
    -- 播放动画, 播放指定动作
    self.stepNumBackAni:getAnimation():play("1",-1,0)
    self.stepNumBackAni:getAnimation():setSpeedScale(2)--处理帧运动速度
    if self.stepNumBackAni:getParent() == nil then
        self.panelMidLayer:addChild(self.stepNumBackAni)
    end
    
    
    if self.stepNumFrontAni == nil then
        self.stepNumFrontAni = ccs.Armature:create("addTwoStepQian")
    end 
    -- 设置位置
    self.stepNumFrontAni:setPosition(cc.p(98,145))
    -- 播放动画, 播放指定动作
    self.stepNumFrontAni:getAnimation():play("1",-1,0)
    self.stepNumFrontAni:getAnimation():setSpeedScale(2)--处理帧运动速度
    
    if self.stepNumFrontAni:getParent() == nil then
        self.panelMidLayer:addChild(self.stepNumFrontAni)
    end
    
    
       
end

function CollectAimUI:showLeftFiveStepAni(isStart)
    -- 创建动画对象
    self.isOnlyLeftFiveStep = isStart
    if isStart then
        armatureColorLight:setVisible(true)
        armatureColorLight:getAnimation():play(tostring(self.limitStepNum),3,1)        
    else
       self.isOnlyLeftFiveStepOld = true
              
       if armatureColorLight ~= nil then
         armatureColorLight:setVisible(false)
         armatureColorLight:getAnimation():stop()
       end 
    end
end


function CollectAimUI:setUIStep(limitStepNumPar)
    self.limitStepNum = limitStepNumPar   
    stepNumBmp:setText(self.limitStepNum)
    
    if self.limitStepNum <= 5 then
        if gameStatus ~= 6 then 
            stepNumBmp:setVisible(false)
            armatureColorLight:getAnimation():play(tostring(self.limitStepNum),3,1)
            self:showLeftFiveStepAni(true)
      
               
        end

        if self.limitStepNum == 0 then
            if eftFinal1 ~= nil then
                eftFinal1:setVisible(false)
                eftFinal1:getAnimation():stop()
            end
            stepNumBmp:setVisible(true)
            self:showLeftFiveStepAni(false)
        end
    else
        self:showLeftFiveStepAni(false)
        stepNumBmp:setVisible(true)
    end
    
end


function CollectAimUI:setLvNum(lv)
    local levelS = MainValue.infosManager:getObjMultilingualByKey("ingame_top_level")
    levelS = string.gsub(levelS, "%b{}", lv)
    
    lvNum:setText(levelS);
    lvNum:setCascadeOpacityEnabled(true)--设置透明度处理
    lvNum:setOpacity(140)--//渐隐
   
end


function CollectAimUI:setUIScores(scores)

    local function realyUpdateScore()
        scoreProgressBar:setIsNeedWait(-1)
        self.isWiting = false
        
        if oldScore < scores then
            oldScore = scores
        end   
        self:setProcess(oldScore)
        scoreProgressBar:setProgress(scores)
        scoreNum:setText(scores)
    end
    local isPlay = scoreProgressBar:isPlayStarAni(scores)
        
    if isPlay ~= -1 and self.isWiting == false then
--      先飞，飞行完毕再调用这里
        self.isWiting = true        
        local flyToPst = MainValue.mxGameManager:getFlyToPst()
--        飞向的是第几个星星位置

        local pstX = VisibleRect:center().x
        local pstY = VisibleRect:center().y
        local tarStarX = scoreProgressBar:getStarPst(isPlay)
--        print("isPlay----------------------------------------------------------------------------------::",isPlay)        
        MainValue.mxEffectManager:showFlyStarToAim(flyToPst["x"],flyToPst["y"],tarStarX["x"],tarStarX["y"],realyUpdateScore) 
            
    else
        if scoreProgressBar:getIsNeedWait() == -1 then
            realyUpdateScore()
        end
    end
    
    
end

function CollectAimUI:setProcess(oldScore)

    self.index = math.floor((oldScore/tarlvTotalScore)*101)
    if self.index >= 100 then
        self.index = 100
     end
    
      
end

--[[设置过关目标 string id, int num, int sum]]--
function CollectAimUI:setUITarget(id, num, sum)
    
     if id~=nil then     
        if cellAry == nil then
            cellAry = {}
--            print("[CollectAimUI]--创建存储cell数组")
        end        
        
        if not self:isAlreadExit(cellAry,id) then
--                    如果没有当前收集目标
--            print("[CollectAimUI]-120-根据没有创建添加",id)
            local cellAim = CellAim.new(id)    
            cellAim:setSum(sum)
            cellAim:upDate(num)                   
            table.insert(cellAry,cellAim)
            
            
            
            local cellName = nil
            
--            处理位置变更
            local cellAryLen = table.maxn(cellAry)
            
            if cellAryLen == 1 then
                self.oneContentSpr:setVisible(true)
                self.threeContentSpr:setVisible(false)
                self.twoContentSpr:setVisible(false)
                local tarCellAim = cellAry[1]
                for i = 1,#(cellAry) do
                    tarCellAim:setPosition(91,94)           
                end  
                if tarCellAim:getParent()==nil then                 
                    self.panelRightLayer:addChild(tarCellAim)        
                end   
            elseif cellAryLen == 2 then
                self.twoContentSpr:setVisible(true)
                self.oneContentSpr:setVisible(false)
                self.threeContentSpr:setVisible(false)
                for i = 1,#(cellAry) do
                                  
                    local tarCellAim = cellAry[i]
                    if i == 1 then
                        tarCellAim:setPosition(55,94)
                    elseif i == 2 then
                        tarCellAim:setPosition(138,94)
                    end
                    if tarCellAim:getParent()== nil then            
                        self.panelRightLayer:addChild(tarCellAim)
                    end
                end  
            elseif cellAryLen == 3 then
                self.threeContentSpr:setVisible(true)
                self.twoContentSpr:setVisible(false)
                self.oneContentSpr:setVisible(false)
                for i = 1,#(cellAry) do
                    local tarCellAim = cellAry[i]
                    if i == 1 then
                        tarCellAim:setPosition(12,94)
                    elseif i == 2 then
                        tarCellAim:setPosition(84,94)     
                    elseif i == 3 then
                        tarCellAim:setPosition(158,94)     
                    end
                    if tarCellAim:getParent()==nil then            
                        self.panelRightLayer:addChild(tarCellAim)
                    end       
         
                end  
            end 
            
                            
        else
--        如果有当前收集目标则更新
            for i = 1,#(cellAry) do
                if cellAry[i]:getId() == id then
                    cellAry[i]:upDate(num)
                    break;
                end
            end  
        end
        cclog("CollectAimUI:setUITarget("..id.."， "..num..", "..sum..")")
    end    
end



function CollectAimUI:isAlreadExit(parCellAryPar,parId)
	local isHave = false	
        for i = 1,#(parCellAryPar) do
            if parCellAryPar[i]:getId() == parId then
                isHave = true;
                break;
            end
        end       
	return isHave
end

function CollectAimUI:setInitCollectAimData(scoresAry,tarLv)
    tarlvTotalScore=scoresAry[3]
    scoreProgressBar:setScoreData(scoresAry) --要添加的 数据TODO
    self:setLvNum(tarLv);
end

function CollectAimUI:getAryByStrToolsSpecial(tmoStr)

 local endPstAry={} 
 local pointAry={}  
    for i=1,string.len(tmoStr)do
        local tmpChar = string.sub(tmoStr,i,i)
        
        local tmpNum=tostring(tmpChar)
        
        if tmpNum==";" then
            table.insert(pointAry,i)
        elseif tmpNum=="|" then
            table.insert(pointAry,i)
        end   
        
    end
               
    local indexOld = 0    
    local pointAryLen=table.maxn(pointAry)
            
    for index, v in pairs(pointAry) do        
        local tmpPstNum        
        if indexOld==0 then
            tmpPstNum = string.sub(tmoStr,1,v-1)
        else
            tmpPstNum= string.sub(tmoStr,indexOld+1,v-1)
        end   
        table.insert(endPstAry,tmpPstNum)        
        indexOld = v
    end    
    local endnum= string.sub(tmoStr,pointAry[pointAryLen]+1,string.len(tmoStr))
    table.insert(endPstAry,endnum)   
end


function CollectAimUI:getAryByStrTools(tmoStr)
 local endPstAry={} 
 local pointAry={}  
    for i=1,string.len(tmoStr)do
        local tmpChar = string.sub(tmoStr,i,i)
        local tmpNum=tonumber(tmpChar)
        if tmpNum==nil then
            table.insert(pointAry,i)
        end   
    end
               
    local indexOld = 0    
    local pointAryLen=table.maxn(pointAry)
            
    for index, v in pairs(pointAry) do        
        local tmpPstNum        
        if indexOld==0 then
            tmpPstNum = string.sub(tmoStr,1,v-1)
        else
            tmpPstNum= string.sub(tmoStr,indexOld+1,v-1)
        end   
        table.insert(endPstAry,tmpPstNum)        
        indexOld = v
    end    
    local endnum= string.sub(tmoStr,pointAry[pointAryLen]+1,string.len(tmoStr))
    table.insert(endPstAry,endnum)   
    
end

function CollectAimUI:getTarPstByTypeId(id)
   local tmpCellAim=nil
    for i = 1,#(cellAry) do
        if cellAry[i]:getId() == id then
           tmpCellAim= cellAry[i]
            break;
        end
    end
    
    local posX , posY = tmpCellAim:getPosition()    
    local endPos=  tmpCellAim:getParent():convertToWorldSpace(cc.p(posX,posY))
    return endPos
end


function CollectAimUI:GC()
   if cellAry~=nil then
        for i = 1,#(cellAry) do
            cellAry[i]:removeFromParent(true)
        end         
     cellAry=nil
   end
   gameStatus = 0
   self.isOnlyLeftFiveStep = false
   self.isOnlyLeftFiveStepOld = true
--    if lvNum~=nil then
--        lvNum:removeFromParent(true)
--        lvNum = nil
--    end
--    if scoreNum~=nil then
--        scoreNum:removeFromParent(true)
--        scoreNum = nil
--    end    

    -- 播放动画, 播放指定动作

    if self.stepNumBackAni then
        self.stepNumBackAni:getAnimation():stop();
        self.stepNumBackAni:getParent():removeChild(self.stepNumBackAni)
        self.stepNumBackAni =  nil
   end
   if self.stepNumFrontAni then
        self.stepNumFrontAni:getAnimation():stop();
        self.stepNumFrontAni:getParent():removeChild(self.stepNumFrontAni)
        self.stepNumFrontAni =  nil
   end
   
    self.oneContentSpr:setVisible(false)
    self.twoContentSpr:setVisible(false)
    self.threeContentSpr:setVisible(false)
   scoreProgressBar:setProgress(0)
   if self.ani then
        self.ani:getAnimation():stop();
        self.ani:getParent():removeChild(self.ani)
        self.ani =  nil
   end
    self.isfinalCanPlayElephant = true
    
   scoreProgressBar:GC()
   self.index = 1
   
   oldScore = 0
   
   tarlvTotalScore = 0
    
    collCellIndex = 1
end

function CollectAimUI:setGameStatus(gameStatusPar)
    gameStatus = gameStatusPar    
    if gameStatus == 6 then 
        self:showLeftFiveStepAni(false)
        stepNumBmp:setVisible(true)
        if self.isfinalCanPlayElephant then
            self.ani:getAnimation():stop()
            self.isfinalCanPlayElephant = false
            self.ani:getAnimation():play("1",-1,0)
            self.ani:getAnimation():setSpeedScale(1)--处理帧运动速度
        end
        
--        eftFinal1:setVisible(true)
--        eftFinal1:setScale(0.8)
--        eftFinal1:getAnimation():play("1",3,1)     
    end    
end


function CollectAimUI:elephantAniInitUI()
    if self.ani == nil then

    local m_config = mapConfig.position[MainValue.SELECTED_LEVEL];
    if m_config == nil then
        return;
    end;
        local petId = GameValue.mxDataControler:getPetId()
        local armatureName = "";
        
        if petId == 1 then
            armatureName = "Dorothy";
        elseif petId == 2 then
            armatureName = "grassman";
        elseif petId == 3 then
            armatureName = "Robot";
        elseif petId == 4 then
            armatureName = "Lion";
        end
        self.ani = ccs.Armature:create(armatureName)
    self.ani:setPosition(210,-112)
    self:addChild(self.ani,-1)
    self.ani:getAnimation():play("1",3,0)    
    self.ani:getAnimation():setSpeedScale(0.5)--处理帧运动速度
--    默认小象动画播放
    -- onePlayComH  twoPlayComH  threePlayComH  fourPlayComH  fivePlayComH
    
    
    
    
    self.ani:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex )
        
        local tarIndexRate = math.random(1,10)
        local playIndexName = "1"
        if tarIndexRate <= 4 then
            playIndexName = "1"
        elseif tarIndexRate <= 6 then
            playIndexName = "2"
        elseif tarIndexRate <= 8 then
            playIndexName = "3"
        else
            playIndexName = "4"
        end
        
--     如果是小于等于五步了就循环播放第五帧动画
        
        if self.isOnlyLeftFiveStep  and self.isOnlyLeftFiveStepOld then -- 判断帧事件名称  -- 生命值《= 5 的提示动画处理  第5帧
            self.isOnlyLeftFiveStepOld = false
                self.ani:getAnimation():play("5",-1,1)
            self.ani:getAnimation():setSpeedScale(1.5)--处理帧运动速度
            return 
        end
        
        if evt == "onePlayComH" then -- 判断帧事件名称 --概率最大的动画 第1帧
                self.ani:getAnimation():play(playIndexName,-1,0)    
--                self.ani:getAnimation():setSpeedScale(0.1)--处理帧运动速度
        elseif evt == "twoPlayComH" then -- 判断帧事件名称   第2帧
                self.ani:getAnimation():play(playIndexName,-1,0)
--                self.ani:getAnimation():setSpeedScale(0.1)--处理帧运动速度
        elseif evt == "threePlayComH" then -- 判断帧事件名称  第3帧
                self.ani:getAnimation():play(playIndexName,-1,0)
--                self.ani:getAnimation():setSpeedScale(0.1)--处理帧运动速度
        elseif evt == "fourPlayComH" then -- 判断帧事件名称 第4帧
                self.ani:getAnimation():play(playIndexName,-1,0)            
--                self.ani:getAnimation():setSpeedScale(0.1)--处理帧运动速度
        end         
                                                    end
                                                    )
     end
end

return CollectAimUI  