require("ui/collectaimui/scorestarui/CellStar")
ScoreProgressBar = class("ScoreProgressBar",function ()
    return cc.Layer:create();    
end)

function ScoreProgressBar:ctor()
    
    return self
end



function ScoreProgressBar:setScoreData(scoreDate)



--  添加背景的处理
    --    遮罩的实现start
--    collectAimProgessBg.png

    self.progressBarBg = cc.Sprite:createWithSpriteFrameName("progBgBg.png") --遮罩
    self.progressBarBg:setPosition(53,-136)
    self:addChild(self.progressBarBg)

    self.isPlayedStar = {false,false,false} --用于预先判断是否需要点亮一颗星星
    
    self.isNeedWait = -1 --用于预先判断是否需要点亮一颗星星是否需要等待播放星星点亮动画
        
    self.clippingNode = cc.ClippingNode:create()
    self.clippingNode:setPosition(51,-136)        
    self.stencil = cc.Sprite:createWithSpriteFrameName("collectAimProgessFront.png") --遮罩
    self.stencil:retain()
    self.clipSize = self.stencil:getContentSize()    
    self.spark  = cc.Sprite:createWithSpriteFrameName("collectAimProgessFront.png")  
    self.spark:retain()
    self.clippingNode:setContentSize(self.clipSize)
    self.clippingNode:addChild(self.spark)
    self.clippingNode:retain()
    self.spark:setPosition(-263,0)
    
--    self.spark:setPosition(0,0)



    --   设定被遮挡的透明度start
--    spark:setCascadeOpacityEnabled(true)
--    spark:setOpacity(255*0.5)--//渐隐
    --   设定被遮挡的透明度end

    --    stencil:setOpacity(0.6)
    self.clippingNode:setInverted(false)
    self.clippingNode:setAlphaThreshold(0)


    self.clippingNode:setStencil(self.stencil)       
    self:addChild(self.clippingNode)
    --    遮罩的实现end  
    
    self.collectAimProgessBgOver = cc.Sprite:createWithSpriteFrameName("collectAimProgessBgOver.png")
    self.collectAimProgessBgOver:setPosition(53,-139)
    self:addChild(self.collectAimProgessBgOver)
    self.collectAimProgessBgOver:retain()
    
    self.lines = {}
    table.insert(self.lines,cc.Sprite:createWithSpriteFrameName("collectAimProgessLine.png"))
    table.insert(self.lines,cc.Sprite:createWithSpriteFrameName("collectAimProgessLine.png"))
    table.insert(self.lines,cc.Sprite:createWithSpriteFrameName("collectAimProgessLine.png"))
   
    self.lines[1]:retain()
    self.lines[2]:retain()
    self.lines[3]:retain()
    
    self:addChild(self.lines[1])
    self:addChild(self.lines[2])
    self:addChild(self.lines[3])
    
    if self.threeStars == nil then
        self.threeStars = {}
        self.threeScores = {}
        self.targetRatio = 0
        self.starOneScore = 0
        self.starTwoScore = 0
        self.starThreeScore = 0
        self.curScore = 0
        self.isPlaystarOne = false
        self.isPlaystarTwo = false
        self.isPlaystarThree = false
        

        for i = 1,3 do
            local cellStar = CellStar.new(i)
            self.threeStars[i] = cellStar
            self.threeStars[i]:retain()
        end

        self:addChild(self.threeStars[3])

        self:addChild(self.threeStars[2])

        self:addChild(self.threeStars[1])

    end
    self.threeScores = scoreDate --{100,250,300}  
    self.progressBarSignTotalScores = self.threeScores[3] * 100 / 86 
    --从试图角度看三星的分数是总长的 86%  所以算出试图进度条总长代替的总分数最大显示实际代表分数
    

    self.starOneScore = self.threeScores[1]
    self.starTwoScore = self.threeScores[2]
    self.starThreeScore = self.threeScores[3]
    
    self.lines[1]:setPosition(-132 + 54 + (self.threeScores[1]/self.progressBarSignTotalScores)*263,-131)
    self.lines[2]:setPosition(-132 + 54 + (self.threeScores[2]/self.progressBarSignTotalScores)*263,-131)
    self.lines[3]:setPosition(-132 + 54 + (self.threeScores[3]/self.progressBarSignTotalScores)*263,-131)
    
    
    
    local starsOnePstX ,starsOnePstY = self.lines[1]:getPosition()
    self.threeStars[1]:setPosition(cc.p(starsOnePstX,starsOnePstY-8))
    
    local starsTwoPstX ,starsTwoPstY = self.lines[2]:getPosition()
    self.threeStars[2]:setPosition(cc.p(starsTwoPstX,starsTwoPstY-8))
    
    local starsThreePstX ,starsThreePstY = self.lines[3]:getPosition()
    self.threeStars[3]:setPosition(cc.p(starsThreePstX,starsThreePstY-8))

end

--根据初始值初始化星星的位置ui 
function ScoreProgressBar:initUI()
    self.curScore = 0;
    self.targetRatio = -1
    self.isPlaystarOne = false
    self.isPlaystarTwo = false
    self.isPlaystarThree = false   
end

function ScoreProgressBar:setProgress(newScore)
    if self.curScore >= newScore then
        return
    end
    self.curScore = newScore
    
    local tarProX = 263 * self.curScore / self.progressBarSignTotalScores
    local endMoveX = -263 + tarProX
    if endMoveX >= 0 then
        endMoveX = 0
    end
    if self.spark then
        self.spark:setPosition(endMoveX , 0)
    end
    
    
    
    if self.curScore >= self.starOneScore then
        if not self.isPlaystarOne then
            self.threeStars[1]:playStar();
            self.isPlaystarOne = true;
        end
    end     

    if self.curScore >= self.starTwoScore then
        if not self.isPlaystarTwo then
            self.threeStars[2]:playStar();
            self.isPlaystarTwo = true;
        end
    end   

    if self.curScore >= self.starThreeScore then
        if not self.isPlaystarThree then
            self.threeStars[3]:playStar();
            self.isPlaystarThree = true;
        end
    end   
end

function ScoreProgressBar:setIsNeedWait(isNeedWaitPar)
    self.isNeedWait = isNeedWaitPar
end
function ScoreProgressBar:getIsNeedWait()
    return self.isNeedWait
end


--是否需要播放星星动画了 
function ScoreProgressBar:isPlayStarAni(newScore)    
    if newScore >= self.starOneScore then
        if not self.isPlaystarOne then
            if not self.isPlayedStar[1] then
               self.isPlayedStar[1]= true
                self:setIsNeedWait(1)
            end            
        end
    end     

    if newScore >= self.starTwoScore then
        if not self.isPlaystarTwo then
            if not self.isPlayedStar[2] then
            self.isPlayedStar[2] = true
                self:setIsNeedWait(2)
            end 
        end
    end   

    if newScore >= self.starThreeScore then
        if not self.isPlaystarThree then
            if not self.isPlayedStar[3] then
            self.isPlayedStar[3] = true
                self:setIsNeedWait(3)
            end 
        end
    end  
    return self.isNeedWait 
end

function ScoreProgressBar:getStarPst(idPar) 
-- tmpCellAim:getParent():convertToWorldSpace(tmpCellAim:getPosition())
    local posX , posY = self.threeStars[idPar]:getPosition()    
    local endPos=  self.threeStars[idPar]:getParent():convertToWorldSpace(cc.p(posX,posY))
--    return endPos
    return endPos-- self.threeStars[idPar]:setPosition()
end


--function ScoreProgressBar:getPosXByRatio(ratio)
--    local leftH = maxH - ratio * maxH
--    if leftH <= 30 then
--        return maxW -  maxW * (maxH - ratio * maxH) / 30  -- 30是进度条梯形斜角的高度
--    else
--        return 0
--    end
--end

function ScoreProgressBar:GC()
    if self.threeStars ~= nil then
        for i = 1,#(self.threeStars) do
            self.threeStars[i]:resetPlayAni()
            self.threeStars[i]:getParent():removeChild(self.threeStars[i])
            self.threeStars[i]:release()
            self.threeStars[i] = nil
            --            cellAry[i]:GC()           
        end  
        self.threeStars = nil      
    end

    self.targetRatio = 0   
    self.curScore = 0
    self.isPlaystarOne = false
    self.isPlaystarTwo = false
    self.isPlaystarThree = false
    
    if self.lines ~= nil then
        for i = 1,#(self.lines) do
            self.lines[i]:getParent():removeChild(self.lines[i])
            self.lines[i]:release()
            self.lines[i] = nil         
        end  
        self.lines = nil      
    end
    
    
    if self.stencil~=nil then
        self.stencil:release()
        self.stencil = nil
    end
    if self.collectAimProgessBgOver~=nil then
        if self.collectAimProgessBgOver:getParent()~=nil then
            self.collectAimProgessBgOver:getParent():removeChild(self.collectAimProgessBgOver)
        end
        self.collectAimProgessBgOver:release()
        self.collectAimProgessBgOver = nil  
    end
    if self.spark~=nil then
        if self.spark:getParent()~=nil then
            self.spark:getParent():removeChild(self.spark)    
        end
        self.spark:release()
        self.spark = nil
    end
    if self.clippingNode~=nil then  
        if self.clippingNode:getParent()~=nil then  
            self.clippingNode:getParent():removeChild(self.clippingNode)
        end
        self.clippingNode:release()
        self.clippingNode = nil
    end
        self.isPlayedStar =nil
   
end