require "src.ui.dailyBonusMain.DailyCell"


local dailyBonusMainPanel = nil;

local _desLabel = nil;

local cellList = {};

local DailyBonusMainPanel = class("DailyBonusMainPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/DailyBonusMain.json");
end);

function DailyBonusMainPanel:ctor()
    self.state = nil;
    self.days = nil;
    self.goodList = nil;
    self.dataList = nil;
    self.claimBtn = nil;
end

function DailyBonusMainPanel:disCallBackFun()
    dailyBonusMainPanel:removeFromParent(true)
end

function DailyBonusMainPanel.create(dataList_)
    dailyBonusMainPanel = DailyBonusMainPanel.new()
    dailyBonusMainPanel.dataList = dataList_;
    
    dailyBonusMainPanel:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);
    
    local titleLB = dailyBonusMainPanel:getChildByName("title")
    local title = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,"Daily Bonus")
    title:setPosition(titleLB:getPosition())
    dailyBonusMainPanel:addChild(title)
    titleLB:removeFromParent(true);
    
    
    dailyBonusMainPanel:addDailyCell();
    
    dailyBonusMainPanel.claimBtn = dailyBonusMainPanel:getChildByName("claimBtn");
    local claimText = dailyBonusMainPanel:getChildByName("claimText");
    local claimLabel = FacFont:getFontsBmp(FontType.FontWhite,"Claim");
    claimLabel:setPosition(claimText:getPosition());
    dailyBonusMainPanel:addChild(claimLabel);
    claimText:removeFromParent()
    local function onClaim( sender, eventType )

        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            dailyBonusMainPanel.claimBtn:setTouchEnabled(false);
            dailyBonusMainPanel:showAnimation();
            MainValue.dataManager.dailyManager:signin();
            dailyBonusMainPanel:getAwards();
        end
    end
    
    local closebtn = dailyBonusMainPanel:getChildByName("btnClose")
    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )

        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            dailyBonusMainPanel:onClose();
        end
    end

    closebtn:addTouchEventListener(touchEvent)
    dailyBonusMainPanel.claimBtn:addTouchEventListener(onClaim);
    return dailyBonusMainPanel;
end

function DailyBonusMainPanel:showAnimation()
    local function callFunc()
        MainValue.mxUIManager.mapUI:removeDailyIcon();
    end

    local btnActions = cc.Sequence:create(
        {
            cc.ScaleTo:create(0.1, 0.86,0.86),
            cc.Spawn:create(
                cc.ScaleTo:create(0.3,1.25,1.25), 
                cc.FadeOut:create(0.3)
            ),
            cc.CallFunc:create(function(node, value) 
                value.tag:onClose();
            end, {tag=self}),
            cc.CallFunc:create(callFunc)

        });

    self.claimBtn:runAction(btnActions);

    local duigou = cc.Sprite:createWithSpriteFrameName("ui/ui/iconTickL.png");
    duigou:setAnchorPoint(0.5,0.5);
    duigou:setScale(0.36,1.2);
    duigou:setPosition(self.claimBtn:getPosition());
    self.claimBtn:getParent():addChild(duigou);
    duigou:setVisible(false);
    local actions = cc.Sequence:create({
        cc.DelayTime:create(0.1),
        cc.Show:create(),
        cc.ScaleTo:create(0.1,1.763,1.763),
        cc.ScaleTo:create(0.2,0.823,0.823),
        cc.ScaleTo:create(0.2,1,1),
    });
    duigou:runAction(actions);
end

function DailyBonusMainPanel:getAwards()
    --满足条件 奖励
    for i,value in pairs(self.goodList) do       
        local dailyCell = DailyCell.create(i,value,self.state,self.days);
        
        if self.state == 1 and i == self.days then
            if value["cash"] ~= "0" then
                MainValue.dataManager.userManager:addCash(tonumber(value["cash"]));
                MainValue.statisticsManager:earnedDailyBonus("0",value["cash"],0,0);
            end

            if next(value["item"]) ~= nil then
                for i,v in pairs(value["item"]) do
                    MainValue.dataManager.goodsManager:addGoods(i,v);
                    MainValue.statisticsManager:earnedDailyBonus("0","0",i,v);
                end
            end
        end
    end


end
function DailyBonusMainPanel:addDailyCell()
    --local dataList = MainValue.dataManager.dailyManager:getSignInList();
    self.state = self.dataList.state;
    self.days = self.dataList.totalDays;
    self.goodList = self.dataList["list"];


    local row = 0
    local col = 0  
    
    for i,value in pairs(self.goodList) do       
        local dailyCell = DailyCell.create(i,value,self.state,self.days);
        
        if (i-1)%2 == 0 then -- 换行        
            col = 0
            row = row +1
        else
            col = col + 1             
        end
        
        local pstX = (col+1) * 260 -386;
        local pstY = (row-1) * -174   + 230;
                
        dailyCell:setPosition(pstX,pstY);   
        
        if i== 7 then
            dailyCell:setPosition(8,-320);
        end
        cellList[i] = dailyCell;
        self:addChild(dailyCell, i);

    end
    


end

function DailyBonusMainPanel:remove()
   for i=1,#cellList do
        cellList[i]:remove();
   end
end

function DailyBonusMainPanel:onClose()
   
    self:disapper();
end

function DailyBonusMainPanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disapper);
end

function DailyBonusMainPanel:appearComplete()
    print("fsfsdfsdf")
end

function DailyBonusMainPanel:disapper()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_DOWN , self.disapperComplete)
end

function DailyBonusMainPanel:disapperComplete()
    self:remove();
    self:removeFromParent(true);
end

return DailyBonusMainPanel