local DailyRewards = class("DailyRewards", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/DailyRewards.json");
end);
function DailyRewards:ctor()
end
function DailyRewards:create()
    local dailyRewards = DailyRewards.new()
    
    return dailyRewards;
end

function DailyRewards:init()
    self.itemList = {};
    self.capItemList = {};
    
    
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);

    local closebtn = self:getChildByName("btnClose");
    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            self:disAppear();
        end
    end

    closebtn:addTouchEventListener(touchEvent);

    local newTitle = FacFont:getFontsBmp(FontType.FontWhite,MainValue.infosManager:getObjMultilingualByKey("DailyBonus_main_box_title"))
    newTitle:setPosition(-3,492);
    self:addChild(newTitle);


    --购买所有按钮
    self.openAllNode = cc.Node:create();
    self.openAllNode:setPosition(2,-435);
    self.openAllNode:setContentSize(330,106);


    local openAllBtn = self:getChildByName("TextOpenAll");

    local function openAllBtnTouchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
            self.isOpenAllBtnLock = true;
            MainValue.actionManager:createJellyAction():press(self.openAllNode,30);
        elseif eventType == ccui.TouchEventType.moved then
            if openAllBtn:isHighlighted() == false then

                if self.isOpenAllBtnLock then
                    MainValue.actionManager:createJellyAction():run(self.openAllNode,40);
                    self.isOpenAllBtnLock = false;
                end
            elseif openAllBtn:isHighlighted() == true then
                if self.isOpenAllBtnLock == false then
                    MainValue.actionManager:createJellyAction():press(self.openAllNode,30);
                    self.isOpenAllBtnLock = true;
                end
            end

        elseif eventType == ccui.TouchEventType.ended then
            if self.isOpenAllBtnLock then
                local function cf()
                    --购买所有
                    local isSucc = MainValue.dataManager.userManager:subCash(tonumber(self.coinNum));

                    if isSucc then
                        local function updataAllItem()
                            self:updataAllItem();
                        end
                        MainValue.dataManager.dailyManager:openAllGacha(updataAllItem);
                    else
                        local storeUIClz = require("ui.storeUI.StoreUI")
                        local storeUI = storeUIClz.create()
                        storeUI:appearAlone();
                    end
                    
                end
                MainValue.actionManager:createJellyAction():run(self.openAllNode,40,cf);
            end
        end
    end
    openAllBtn:removeFromParent();
    openAllBtn:setPosition(0,0);
    self.openAllNode:addChild(openAllBtn);
    openAllBtn:addTouchEventListener(openAllBtnTouchEvent);
    self:addChild(self.openAllNode);

    local itemInfo = MainValue.dataManager.dailyManager:getGacha();
    local numC = 1;
    if itemInfo.num ~= nil then
        numC = itemInfo.num;
    end
    self.coinNum = itemInfo.cash * (#itemInfo.card - numC);
    if self.coinNum  == 0 then
        self.openAllNode:setVisible(false);
    end
    local openAllString = MainValue.infosManager:getObjMultilingualByKey("DailyBonus_main_box_openAll") .. "         " .. self.coinNum ;
    self.openAllTxt = FacFont:getFontsBmp(FontType.FontWhite,openAllString);
    self.openAllTxt:setScale(0.9)
    self.openAllTxt:setPosition(1,10);
    self.openAllNode:addChild(self.openAllTxt);
    


    local itemClz = require("ui/dailyRewards/DailyRewardsItem");
    local capItemClz = require("ui/dailyRewards/DailyRewardsCap");

    local r1 = 0;
    local r2 = 0;
    
    for index=1,#itemInfo.card do
        local item = itemClz.create();
        local rewardid = itemInfo.card[index];
        --数组位置、奖励id、奖励信息、开启数组
        item:init(index,rewardid,itemInfo.list[tostring(rewardid)],itemInfo.pos);
        item:setPosition(((index-1)*73)-260,380);
        self:addChild(item);
        self.itemList[index] = item;
        
        local isOpen = self:isOpenCapItem(index,rewardid,itemInfo.pos);
        
        if isOpen == false then
            local capItem = capItemClz.create();
            local function setupBuy(pos)
                self:setupBuy(pos);
            end
            --数组位置、开启数组、开启回调
            capItem:init(index,itemInfo,setupBuy);

            local tx = 0;
            local ty = 0;
            if index % 2 ~= 0 then
                tx = -150
                ty = 232-(r1*170);
                r1 = r1 + 1;

                if r1 == 3 then
                    ty = ty - 3;
                elseif r1 == 4 then
                    ty = ty - 10;
                end

                capItem:setPosition(tx,ty);
            else
                tx = 157
                ty = 232-(r2*170);
                r2 = r2 + 1;

                if r2 == 3 then
                    tx = tx - 2;
                    ty = ty - 3;
                elseif r2 == 4 then
                    tx = tx - 2;
                    ty = ty - 10;
                end

                capItem:setPosition(tx,ty);
            end

            self:addChild(capItem);
            self.capItemList[index] = capItem;
        else
            if index % 2 ~= 0 then
                r1 = r1 + 1;
            else
                r2 = r2 + 1;
            end
        end 
    end
end
--是否开启
function DailyRewards:isOpenCapItem(rid_,rewardid_, openList_)
    local ret = false;
    
    if openList_ ~= nil then
        for key, var in pairs(openList_) do
            if (tostring(var) == tostring(rid_) or tostring(var) == "1000") then
        	   ret = true;
        	   break;
        	end
        end
    end
    
    return ret;
end

--设置购买
function DailyRewards:setupBuy(pos)
    local itemInfo = MainValue.dataManager.dailyManager:getGacha();
    local isFree = itemInfo.num;
    
    local function updataItem(value,value1)
        self:updataItem();
        
        --弹出奖励
        local rewardsMaskClz = require("ui/dailyRewards/RewardsMask");
        local rewardsMask = rewardsMaskClz.create();
        --奖励id、奖励信息、开启类型
        local rewardid = value1;--itemInfo.card[value1];
        rewardsMask:init(rewardid,itemInfo.list[tostring(rewardid)],1);
        self:addChild(rewardsMask);
        
    end
    
    if isFree == nil then
        MainValue.dataManager.dailyManager:freeGacha(pos,updataItem);
    else
        MainValue.dataManager.dailyManager:buyGacha(pos,updataItem);
    end
    
    --print("购买位置：" .. pos);
end
--更新数据
function DailyRewards:updataItem()
    local itemInfo = MainValue.dataManager.dailyManager:getGacha();
    
    --更新买所有按钮
    local coinNum = itemInfo.cash * (#itemInfo.card - itemInfo.num);
    if coinNum == 0 then
        self.openAllNode:setVisible(false);
    else
        local openAllString = MainValue.infosManager:getObjMultilingualByKey("DailyBonus_main_box_openAll") .. " " .. coinNum;
        self.openAllTxt:setText(openAllString);
    end
    
    --更新item数组
    for key, var in pairs(self.itemList) do
        var:updata(itemInfo.pos);
        var:addCash(itemInfo.pos);
    end
    --更新capItem数组
    for key, var in pairs(self.capItemList) do
        var:updata(itemInfo.cash);
    end
    
end
--购买所有
function DailyRewards:updataAllItem()
    self.openAllNode:setVisible(false);
    local itemInfo = MainValue.dataManager.dailyManager:getGacha();
    
    --更新item数组
    for key, var in pairs(self.itemList) do
        var:updata(itemInfo.pos);
        var:addCash(itemInfo.pos);
    end
    --更新capItem数组
    for key, var in pairs(self.capItemList) do
        var:buyCapAnimation(false,itemInfo.pos);
    end
    
    --弹出奖励
    local rewardsMaskClz = require("ui/dailyRewards/RewardsMask");
    local rewardsMask = rewardsMaskClz.create();
    --奖励id、奖励信息、开启类型
    rewardsMask:init(-1,itemInfo,2);
    self:addChild(rewardsMask);
    
end

function DailyRewards:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disAppear);
end

function DailyRewards:disAppear()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_DOWN , self.disAppearComplete)
end

function DailyRewards:appearComplete()
end

function DailyRewards:disAppearComplete()
    self:removeFromParent(true);
end

return DailyRewards