local DailyRewardsCap = class("DailyRewardsCap", function ()
    return cc.Node:create();
end);

function DailyRewardsCap:ctor()
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/openLib/openLib0.png", "armature/openLib/openLib0.plist" , "armature/openLib/openLib.ExportJson" );
    
    self.isbuy = false;
end
function DailyRewardsCap.create()
    local temp = DailyRewardsCap.new();
    return temp;
end

function DailyRewardsCap:init(index_,itemInfo_,setupBuy_)
    self.index = index_;
    self.itemInfo = itemInfo_;
    self.setupBuy = setupBuy_;
    self.cash = self.itemInfo.cash;
    
    
    --capAnimation
    self.capAnimation = ccs.Armature:create("openLib");
    self.capAnimation:setPosition(0,0);
    self.capAnimation:getAnimation():play("1",1);
    self:addChild(self.capAnimation,0);
    
    --buyNode
    self.buyNode = cc.Node:create();
    self.buyNode:setPosition(0,15);
    self.buyNode:setContentSize(82,37);
    self:addChild(self.buyNode,1);
    
    --buyBtn
    self.buyBtn = ccui.Button:create()
    self.buyBtn:loadTextures("ui/gacha/btnFree.png","ui/gacha/btnFree.png","", 1)
    self.buyNode:addChild(self.buyBtn);
    local function buyBtnTouchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
            self.btnLock = true;
            MainValue.actionManager:createJellyAction():press(self.buyNode,10);
        elseif eventType == ccui.TouchEventType.moved then
            if  self.buyBtn:isHighlighted() == false then

                if self.btnLock then
                    MainValue.actionManager:createJellyAction():run(self.buyNode,15);
                    self.btnLock = false;
                end
            elseif  self.buyBtn:isHighlighted() == true then
                if self.btnLock == false then
                    MainValue.actionManager:createJellyAction():press(self.buyNode,10);
                    self.btnLock = true;
                end
            end

        elseif eventType == ccui.TouchEventType.ended then
            if self.btnLock then
                local function cf()
                    --购买
                    local isSucc = true;
                    if self.cash ~= "Free" then
                        isSucc = MainValue.dataManager.userManager:subCash(tonumber(self.cash));
                    end
                    
                    if isSucc then
                        self:buyCapAnimation(true);
                        self.isbuy = true;
                    else
                        local storeUIClz = require("ui/storeUI/StoreUI")
                        local storeUI = storeUIClz.create()
                        storeUI:appearAlone()
                    end
                   
                end
                MainValue.actionManager:createJellyAction():run(self.buyNode,15,cf);
            end
        end
    end
    self.buyBtn:addTouchEventListener(buyBtnTouchEvent);
    
    
    
    --coin
    self.iconCoin = cc.Sprite:createWithSpriteFrameName("ui/ui/iconCoin.png");
    self.iconCoin:setScale(0.4)
    self.iconCoin:setPosition(-19,3);
    self.iconCoin:setVisible(true);
    self.buyNode:addChild(self.iconCoin);
    
    --num
    if self.itemInfo.num == nil then
        self.cash = "Free";
        self.iconCoin:setVisible(false);
    end 
    self.itemNumTxt = FacFont:getFontsBmp(FontType.FontWhite, self.cash, 110, "L");
    self.itemNumTxt:setScale(0.7)
    self.itemNumTxt:setPosition(36,2);
    self.buyNode:addChild(self.itemNumTxt);

end
--购买动画
function DailyRewardsCap:buyCapAnimation(isSingle,gainTable_)

    if isSingle then
        local function animationEvent(armatureBack,movementType,movementID)
            local id = movementID
            if movementType == ccs.MovementEventType.complete then
                if id == "2" then
                    local pos = self.index;--self:randomRewardPos();
                    self.setupBuy(pos);
                end
            end
        end

        self.capAnimation:getAnimation():setMovementEventCallFunc(animationEvent);
    else
        for key, var in pairs(gainTable_) do
            if (tostring(var) == tostring(self.index) or tostring(var) == "1000")then
                if self.gain ~= nil then
                    self.gain:setVisible(true);
                end
                
                break;
            end
        end
    end
    
    if self.isbuy == false then
        self.capAnimation:getAnimation():play("2",1);
        self.buyNode:setVisible(false);
    end
end
--更新
function DailyRewardsCap:updata(value_)
    self.cash = value_;
    self.iconCoin:setVisible(true);
    self.itemNumTxt:setText(tostring(value_));
end

return DailyRewardsCap;