local DailyRewardsItem = class("DailyRewardsItem", function ()
    return cc.Node:create();
end);

function DailyRewardsItem:ctor()
    self.path = "ui/prop/big/";
    self.itemId = 0;
    self.itemNum = 0;
end
function DailyRewardsItem.create()
    local temp = DailyRewardsItem.new();
    
    return temp;
end

function DailyRewardsItem:init(pos_,rewardid_,rewardInfo,gainTable_)
    self.pos = pos_;
    self.rewardid = rewardid_;
    self.gainTable = gainTable_;
    
    self.itemId,self.itemNum = self:getRewardID(rewardInfo);
    local itemInfo = MainValue.infosManager:getObjGoodsById(self.itemId);
    
    --itemIcon
    local itemPath = self.path..self.itemId..".png";
    self.itemIcon = cc.Sprite:createWithSpriteFrameName(itemPath);
    self.itemIcon:setScale(0.55)
    self:addChild(self.itemIcon);
    
    --itemNum
    local itemNumS = "x"..self.itemNum;
    local itemNumTxt = FacFont:getFontsBmp(FontType.FontWhite, itemNumS, 120, "R");
    itemNumTxt:setScale(0.8)
    itemNumTxt:setPosition(-10,-20);
    self:addChild(itemNumTxt);
    
    --gain
    self.gain = cc.Sprite:createWithSpriteFrameName("ui/ui/iconTickL.png");
    self.gain:setScale(0.55)
    self.gain:setPosition(-10,-25);
    self.gain:setVisible(false);
    self:addChild(self.gain);
    
    self:updata(self.gainTable);
end
--获取奖励物品id
function DailyRewardsItem:getRewardID(rewardInfoPar)
    local retid = 0;
    local retNum = 0;

    if math.floor(rewardInfoPar.coin) ~= 0 then
        retid = 0;
        retNum = math.floor(rewardInfoPar.coin);
    elseif math.floor(rewardInfoPar.cash) ~= 0 then
        retid = 01;
        retNum = math.floor(rewardInfoPar.cash);
    elseif math.floor(rewardInfoPar.heart) ~= 0 then
        retid = 202;
        retNum = math.floor(rewardInfoPar.heart);
    else
        for key, var in pairs(rewardInfoPar.item) do
            retid = key;
            retNum = var;
            break;
        end
    end
    
    return math.floor(retid),math.floor(retNum)
end
--更新
function DailyRewardsItem:updata(gainTable_)
    self.gainTable = gainTable_;
    local gainTableLeg = 0;
    
    if self.gainTable ~= nil then
        for key, var in pairs(self.gainTable) do
            gainTableLeg = gainTableLeg + 1;
        end
    end
    
    if gainTableLeg > 0 then
        for key, var in pairs(self.gainTable) do
            if tostring(key) == tostring(self.rewardid) or tostring(var) == "1000"then
                self.gain:setVisible(true);
                break;
            end
        end
    else
        self.gain:setVisible(false);
    end
    
end
--可能是cash的奖励
function DailyRewardsItem:addCash(gainTable_)
    self.gainTable = gainTable_;
    local gainTableLeg = 0;
    
    if self.gainTable ~= nil then
        for key, var in pairs(self.gainTable) do
            gainTableLeg = gainTableLeg + 1;
        end
    end

    if gainTableLeg > 0 then
        for key, var in pairs(self.gainTable) do
            if tostring(key) == tostring(self.rewardid) or tostring(var) == "1000"then
                if tonumber(self.itemId) == 0 then
                    MainValue.dataManager.userManager:addCash(tonumber(self.itemNum));
                end
                break;
            end
        end
    end
end

return DailyRewardsItem;