local RewardsMask = class("RewardsMask", function ()
    return cc.Node:create();
end);

function RewardsMask:ctor()
    self.path = "ui/prop/big/";
    self.itemId = 0;
    self.itemNum = 0;
end
function RewardsMask.create()
    local temp = RewardsMask.new();

    return temp;
end

function RewardsMask:bugOne(rewardid_,rewardInfo)
    self.rewardid = rewardid_;

    self.itemId,self.itemNum = self:getRewardID(rewardInfo);
    self.itemInfo = MainValue.infosManager:getObjGoodsById(self.itemId);
    
    --itemIcon
    local itemPath = self.path..self.itemId..".png";
    self.itemIcon = cc.Sprite:createWithSpriteFrameName(itemPath);
    self.itemIcon:setScale(1.3)
    self.itemN:addChild(self.itemIcon);

    --itemName
    if itemInfo ~= nil then
        local itemNameT = itemInfo.name;
        local itemNameTxt = FacFont:getFontsBmp(FontType.FontWhite, itemNameT, 200);
        itemNameTxt:setScale(1)
        itemNameTxt:setPosition(0,100);
        self.itemN:addChild(itemNameTxt);
    end

    --itemNum
    local itemNumS = "x"..self.itemNum;
    local itemNumTxt = FacFont:getFontsBmp(FontType.FontWhite, itemNumS, 120, "R");
    itemNumTxt:setScale(1.3)
    itemNumTxt:setPosition(0,-80);
    self.itemN:addChild(itemNumTxt);

--local ac3 = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.2,cc.p(0, 15)), 0.6));
end

function RewardsMask:bugAll(itemInfo)
    local rewardList = {};
    local rewardListIndex = 1;
    
    for key, var in pairs(itemInfo.pos) do
    	if var == 1000 then
            rewardList[rewardListIndex] = tonumber(key);
            rewardListIndex = rewardListIndex + 1;
    	end
    end
    
    local r1 = 0;
    local r2 = 0;
    local tx = 0;
    local ty = 0;
    
    for index=1,#rewardList do
        local rewardid = rewardList[index];
        
        local rewardInfo = itemInfo.list[tostring(rewardid)];
        local itemId, itemNum = self:getRewardID(rewardInfo);
        local itemInfo = MainValue.infosManager:getObjGoodsById(itemId);
        
        if index % 2 ~= 0 then
            tx = -150
            ty = 200-(r1*140);
            r1 = r1 + 1;
        else
            tx = 157
            ty = 200-(r2*140);
            r2 = r2 + 1;
        end
        
        
        --itemIcon
        local itemPath = self.path..itemId..".png";
        self.itemIcon = cc.Sprite:createWithSpriteFrameName(itemPath);
        self.itemIcon:setPosition(tx,ty)
        self.itemIcon:setScale(0.8)
        self.itemN:addChild(self.itemIcon);
        
        --itemName
        if itemInfo ~= nil then
            local itemNameT = itemInfo.name;
            local itemNameTxt = FacFont:getFontsBmp(FontType.FontWhite, itemNameT, 200);
            itemNameTxt:setPosition(tx,ty+50);
            itemNameTxt:setScale(0.8)
            self.itemN:addChild(itemNameTxt);
        end
        
        --itemNum
        local itemNumS = "x"..itemNum;
        local itemNumTxt = FacFont:getFontsBmp(FontType.FontWhite, itemNumS, 120, "R");
        itemNumTxt:setPosition(tx,ty-40);
        itemNumTxt:setScale(0.8)
        self.itemN:addChild(itemNumTxt);
        
    end
    
end

function RewardsMask:init(rewardid_,rewardInfo,flag)
    
    --遮罩
    local width = MainValue.winSize.width;
    local height = MainValue.winSize.height;
    self.layerColor = cc.LayerColor:create(cc.c4b(0,0,0,65) , width , height)
    self.layerColor:setPosition(-(width/2), -(height/2))
    local listener = function(eventType, x, y)

        if eventType == "began" then
            return true           
        end
    end
    self.layerColor:registerScriptTouchHandler(listener, false, 0, true)
    self.layerColor:setTouchEnabled(true);
    self:addChild(self.layerColor)
    
    --title
    local titleS = "DailyBonus_main_box_a_reward";
    if flag == 1 then 
        titleS = "DailyBonus_main_box_a_reward";
    elseif flag == 2 then 
        titleS = "DailyBonus_main_box_some_reward";
    end
    titleS = MainValue.infosManager:getObjMultilingualByKey(titleS);
    local titleTxt = FacFont:getFontsBmp(FontType.FontWhite, titleS);
    titleTxt:setPosition(0,340);
    self:addChild(titleTxt);
    
    --itemNode
    self.itemN = cc.Node:create();
    self:addChild(self.itemN);

    --.continue按钮
    self.btnN = cc.Node:create();
    self.btnN:setContentSize(226, 90)
    self.btnN:setPosition(150,-340);
    self:addChild(self.btnN);
    
    self.continueBtn = ccui.Button:create()
    self.continueBtn:loadTextures("ui/button/btn2LR1.png","ui/button/btn2LR2.png","",1)
    self.btnN:addChild(self.continueBtn);
    
    local function continueBtnTouchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
            self.isBtnLock = true;
            MainValue.actionManager:createJellyAction():press(self.btnN,30);
        elseif eventType == ccui.TouchEventType.moved then
            if self.continueBtn:isHighlighted() == false then

                if self.isBtnLock then
                    MainValue.actionManager:createJellyAction():run(self.btnN,40);
                    self.isBtnLock = false;
                end
            elseif self.continueBtn:isHighlighted() == true then
                if self.isBtnLock == false then
                    MainValue.actionManager:createJellyAction():press(self.btnN,30);
                    self.isBtnLock = true;
                end
            end

        elseif eventType == ccui.TouchEventType.ended then
            if self.isBtnLock then
                local function cf()
                    self:removeFromParent();
                end
                MainValue.actionManager:createJellyAction():run(self.btnN,40,cf);
            end
        end
    end
    self.continueBtn:addTouchEventListener(continueBtnTouchEvent);
    
    local btnNameTxt = FacFont:getFontsBmp(FontType.FontWhite, "continue", 200);
    self.btnN:addChild(btnNameTxt);
    
    --share按钮
    self.btnN1 = cc.Node:create();
    self.btnN1:setContentSize(226, 90)
    self.btnN1:setPosition(-150,-340);
    self:addChild(self.btnN1);
    
    self.shareBtn = ccui.Button:create()
    self.shareBtn:loadTextures("ui/button/btn2LR1.png","ui/button/btn2LR2.png","",1)
    self.fbIconImg = cc.Sprite:createWithSpriteFrameName("iconFBR.png");
    self.fbIconImg:setPosition(30, 60);
    self.shareBtn:addChild(self.fbIconImg);
    self.btnN1:addChild(self.shareBtn);
    
    local function shareBtnTouchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
            self.isBtnLock1 = true;
            MainValue.actionManager:createJellyAction():press(self.btnN1,30);
        elseif eventType == ccui.TouchEventType.moved then
            if self.shareBtn:isHighlighted() == false then

                if self.isBtnLock1 then
                    MainValue.actionManager:createJellyAction():run(self.btnN1,40);
                    self.isBtnLock1 = false;
                end
            elseif self.continueBtn:isHighlighted() == true then
                if self.isBtnLock1 == false then
                    MainValue.actionManager:createJellyAction():press(self.btnN1,30);
                    self.isBtnLock1 = true;
                end
            end

        elseif eventType == ccui.TouchEventType.ended then
            if self.isBtnLock1 then
                local function cf()
                    if flag == 1 then
                        --单一物品
                        MainValue.fbManager:gachaFree(FBSharedType.GACHA_FREE,self.itemInfo.name);
                    elseif flag == 2 then
                        --全部物品
                        MainValue.fbManager:gachaPay(FBSharedType.GACHA_PAY);
                    end
                    self:removeFromParent();
                end
                MainValue.actionManager:createJellyAction():run(self.btnN1,40,cf);
            end
        end
    end
    self.shareBtn:addTouchEventListener(shareBtnTouchEvent);
    
    local btnNameTxt = FacFont:getFontsBmp(FontType.FontWhite, "share", 200);
    self.btnN1:addChild(btnNameTxt);
    
    if flag == 1 then
        self:bugOne(rewardid_,rewardInfo)
    elseif flag == 2 then
        titleTxt:setScale(0.9)
        self:bugAll(rewardInfo)
    end

end

--获取奖励物品id
function RewardsMask:getRewardID(rewardInfoPar)
    local retid = 0;
    local retNum = 0;

    if math.floor(rewardInfoPar.coin) ~= 0 then
        retid = 0;
        retNum = math.floor(rewardInfoPar.coin);
    elseif math.floor(rewardInfoPar.cash) ~= 0 then
        retid = 01;
        retNum = math.floor(rewardInfoPar.cash);
    elseif math.floor(rewardInfoPar.heart) ~= 0 then
        retid = 202;
        retNum = math.floor(rewardInfoPar.heart);
    else
        for key, var in pairs(rewardInfoPar.item) do
            retid = key;
            retNum = var;
            break;
        end
    end

    return math.floor(retid),math.floor(retNum)
end
return RewardsMask;