require "engine.uigridtools.SpecialGridTools"
require "config/firstPackageConfig"

local FirstPackagePanel = class("FirstPackagePanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/FirstPackage.json");
end);

function FirstPackagePanel:ctor()
    self.path = "ui/prop/big/";
end

function FirstPackagePanel.create()

    local firstPackagePanel = FirstPackagePanel.new()
    firstPackagePanel:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);


    local closebtn = firstPackagePanel:getChildByName("btnClose");
    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then

            if firstPackagePanel.flag == 1 then
                MainValue.mxUIManager.mapManager:getMap():upDateMission(MainValue.SELECTED_LEVEL)
            end
            firstPackagePanel:disAppear();
        end
    end
    closebtn:addTouchEventListener(touchEvent);

    local desBg = SpecialGridTools.create("ui/ui/bgCooky.png",395,263,26)
    desBg:setPosition(0, 150)
    firstPackagePanel:addChild(desBg)


    --title文本替换
    local newTitle = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("Common_firstPackageTitle"));
    newTitle:setPosition(0,360);
    firstPackagePanel:addChild(newTitle);

    --buy
    local buyBtn = firstPackagePanel:getChildByName("btnBuy");
    local unlock = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("Common_firstPackageBuy"));
    unlock:setPosition(0,-324);
    firstPackagePanel:addChild(unlock);
    
    
    local function btnBuyTouchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(buyBtn,40);

           --todo
        end
    end
    buyBtn:addTouchEventListener(btnBuyTouchEvent)
    --道具
    firstPackagePanel:setItems()

    --老价格
    local oldVLable = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("Common_firstPackageOldValue"));
    oldVLable:setPosition(-100,-80);
    oldVLable:setRotation(-15)
    oldVLable:setScale(0.6)
    firstPackagePanel:addChild(oldVLable);

    --新价格
    local newVLable = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("Common_firstPackageNewValue"),85,'C');
    newVLable:setPosition(-100,-188);
    firstPackagePanel:addChild(newVLable);
    
    --node
    local nodeLable = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("Common_firstPackageNode"));
    nodeLable:setPosition(0,-238);
    firstPackagePanel:addChild(nodeLable);
    
    return firstPackagePanel;
end

function FirstPackagePanel:init()
end

function FirstPackagePanel:setItems()
    
    local item = self:creatItemNode(firstPackageConfig.firstPackage[1].id,firstPackageConfig.firstPackage[1].num)
    item:setPosition(-110,210)
    self:addChild(item)

    local item2 = self:creatItemNode(firstPackageConfig.firstPackage[2].id,firstPackageConfig.firstPackage[2].num)
    item2:setPosition(80,210)
    self:addChild(item2)

    local item3 = self:creatItemNode(firstPackageConfig.firstPackage[3].id,firstPackageConfig.firstPackage[3].num)
    item3:setPosition(-110,110)
    self:addChild(item3)

    local item4 = self:creatItemNode(firstPackageConfig.firstPackage[4].id,firstPackageConfig.firstPackage[4].num)
    item4:setPosition(80,110)
    self:addChild(item4)
end

function FirstPackagePanel:creatItemNode(itemId,itemNum)
    local itemNode = cc.Node:create();

    --itemIcon
    local itemPath = self.path..itemId..".png";
    local itemIcon = cc.Sprite:create(itemPath);
    if itemId ~= 0 then
        itemIcon:setScale(0.8)
    end
    itemNode:addChild(itemIcon);

    --itemNum
    local itemNumS = itemNum;
    local itemNumTxt = FacFont:getFontsBmp(FontType.FontWhite, itemNumS, 100, "R");
    itemNumTxt:setScale(0.8);
    itemNumTxt:setPosition(20,-35);
    itemNode:addChild(itemNumTxt);

    itemNode:setContentSize(itemIcon:getContentSize().width,itemIcon:getContentSize().height);

    return itemNode;
end

function FirstPackagePanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.POP_UP, self.appearComplete);
end

function FirstPackagePanel:disAppear()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.POP_UNDER , self.disAppearComplete)
end

function FirstPackagePanel:appearComplete()
end

function FirstPackagePanel:disAppearComplete()
    self:removeFromParent(true)
end

return FirstPackagePanel