require "ui.friendRank.RankCell"
require "engine.uigridtools.NineGridTools"


FriendRankPanel = class("FriendRankPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/FriendRank.json");
end);

function FriendRankPanel:ctor()
    --self.bg = nil;
    self.listView = nil;
    
    self.dataLen = nil;
    self.pageNum = nil;
    
    self.pStartX = nil;
    self.pointIcon = nil;
    
    self.rankData = nil;
    
    self.userId = nil;
    self.userName = nil;
    self.picture = nil;
    
    self.curScore = nil;
    
    self.selfData = nil;--本人信息（临时）
    
    self.isLogin = false;
    
    self.POINT_SPACE = 24;
    self.LISTVIEW_HEIGTH = nil;
end

function FriendRankPanel.create()
    local friendRankPanel = FriendRankPanel.new();
    friendRankPanel:init();
    return friendRankPanel;
end

function FriendRankPanel:init()
    local bg9 = NineGridTools.create("ui/ui/panel1.png",698,258,45)
    self:addChild(bg9)
    

    --self.bg = self:getChildByName("ImgBg");
    self.listView = self:getChildByName("ListView");
    
    self.LISTVIEW_HEIGTH = self.listView:getContentSize().width;
    self.listView:setBounceEnabled(false);
    
--    self.listView:setInertiaScrollEnabled(false); --是否有惯性滑动


    local function scrollViewEvent(a,b)
        self:updataPage(self.listView:getInnerContainer():getPositionX());
    end
    self.listView:addScrollViewEventListener(scrollViewEvent)
    
    self:setPositionY(-MainValue.winSize.height / 2 -200);
end

function FriendRankPanel:setData(curLv)
    print("FriendRankPanel:setData")
    self.isLogin = MainValue.fbManager:getIsLogin();

    if self.isLogin then
    
    
        self.rankData  = MainValue.dataManager.friendManager:getRankFriends(curLv);
        
--        print("self.rankData110")
        
--        print(self.rankData)
        
--        print("self.rankData120")
        
            
    else
        self.rankData  = {{username = MainValue.infosManager:getObjMultilingualByKey("FriendRank_FriName_1"), score = 10000, picture = "head1.png"},
            {username = MainValue.infosManager:getObjMultilingualByKey("FriendRank_FriName_2"), score = 8000, picture = "head3.png"},
            {username = MainValue.infosManager:getObjMultilingualByKey("FriendRank_FriName_3"), score = 5000, picture = "head4.png"},
            {username = MainValue.infosManager:getObjMultilingualByKey("FriendRank_FriName_4"), score = 3000, picture = "head5.png"},
            {username = MainValue.infosManager:getObjMultilingualByKey("FriendRank_FriName_5"), score = 2000, picture = "head6.png"},
            {username = MainValue.infosManager:getObjMultilingualByKey("FriendRank_FriName_7"), score = 1000, picture = "head7.png"}
        }
        
        self.curScore = MainValue.dataManager.levelManager:getLevel(curLv);
        
        local selfId = "-1";
        local selfName = MainValue.infosManager:getObjMultilingualByKey("FriendRank_MyName");
        local selfPicture = "head2.png";
        self.selfData = {userId = selfId, username = selfName, score = self.curScore, picture = selfPicture};

        local len = table.getn(self.rankData);
        for rI = 1, len do 
            if self.curScore > self.rankData[rI].score then
                table.insert(self.rankData, rI, self.selfData);
                break;
            end
        end
    end
    
    local fbData = nil;
    if self.isLogin then
        fbData = {username = "inviteFri"};
        
        local index = 1;
         
        if self.rankData ~= nil and table.maxn(self.rankData) > 0 then --如果好友小于三个，显示在最后，否则显示在第四个
            index = table.maxn(self.rankData) + 1;
            
            if index >= 4 then  
                index = 4;
            end
        end
        table.insert(self.rankData, index, fbData);
    else
        fbData = {username = "connect"};
        table.insert(self.rankData, 4, fbData);
    end
    
    
--    self.rankData = {{
--        ["id"]       = "1508293926112547",
--        ["name"]     = "test1",
--        ["username"] = "test1",
--        ["picture"]  = "https://fbcdn-profile-a.akamaihd.net/hprofile-ak-xfa1/v/t1.0-1/c22.0.100.100/p100x100/10574420_1445441729064434_8819031542387145715" ..
--                       "_n.jpg?oh=ac4277ec999d7c9b7c69a1dade357ad2&oe=5510BAC8&__gda__=1430616702_c4ceaeed368ee8ead67fc1cb70cc9480",
--        ["rankNum"] = 99;
--        ["score"]    = 10000,
--        ["stars"]    = 3
--    }};
    
    self.dataLen = table.getn(self.rankData);
    self.pageNum = math.ceil(self.dataLen / 4);
    
    self.pStartX = -(self.POINT_SPACE / 2) * (self.pageNum - 1);

--    for pI = 0, self.pageNum - 1 do
--        local pointBg = cc.Sprite:createWithSpriteFrameName("ui/ui/pointL.png");
--        pointBg:setPositionX(self.pStartX + pI * self.POINT_SPACE);
--        pointBg:setPositionY(140);
--        self:addChild(pointBg);
--    end

--    self.pointIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/pointYellow.png");
--    self.pointIcon:setPosition(self.pStartX, 140);
--    self:addChild(self.pointIcon);

    for dataI = 1, self.dataLen do
    
        if self.rankData[dataI].username ~= "FB" then
            self.rankData[dataI].rankNum = dataI;
        else
            self.rankData[dataI].rankNum = 0;
        end
        local cell = RankCell.create(self.rankData[dataI]);
        self.listView:pushBackCustomItem(cell);
    end
end

function FriendRankPanel:updataPage(pX)

    local curPage = math.floor(math.abs(pX / self.LISTVIEW_HEIGTH));

--    self.pointIcon:setPositionX(self.pStartX + curPage * self.POINT_SPACE);
end

function FriendRankPanel:appear()
    local ac = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.23 ,cc.p(0, 200)),0.3));
    self:runAction(ac);
end

function FriendRankPanel:disappear()
    local function callFun()
        self:removeFromParent(true);
    end
    
    local ac = cc.Sequence:create(cc.DelayTime:create(0.1), cc.EaseIn:create(cc.MoveBy:create(0.05,cc.p(0, -200)),0.3), cc.CallFunc:create(callFun));
    self:runAction(ac);
end

return FriendRankPanel;