require "engine.uigridtools.NineGridTools"

RankCell = class("RankCell", function()
    return ccui.Layout:create();
end);

function RankCell:ctor()
    self.bg = nil;
    self.bgW = 151;
    self.bgH = 193;
    self.headIcon = nil;

    self.rankLab = nil;
    self.nameLab = nil;
    self.scoreLab = nil;

    self.headBg = nil;
    self.headIcon = nil;
    self.heartIcon = nil;
    
    self.fbIcon = nil;
    self.inviteIcon = nil;

    self.selfID = nil;
    self.selfPicture = nil;
end

function RankCell.create(rankData)
    local cell = RankCell.new();
    cell.rankData = rankData;
    cell:init();
    return cell;
end

function RankCell:init()
    if self.rankData.username == "connect" then
        self.bg = ccui.Button:create();
        self.bg:loadTextures("ui/ui/panel4.png", "ui/ui/panel4.png", "", 1)
        self.bg:setContentSize(self.bgW,self.bgH);
        self.bg:setScale9Enabled(true);
        self.bg:setPositionX(self.bgW / 2)
        self.bg:setPositionY(-50 + self.bgH / 2);
        self:addChild(self.bg);
        
        self.fbIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/iconFB.png");
        self.fbIcon:setPosition(72, 96);
        self:addChild(self.fbIcon);
        
        self.fbLabel = cc.Sprite:createWithSpriteFrameName("ui/ui/txtLogin.png");
        self.fbLabel:setPosition(72, 40);
        self:addChild(self.fbLabel);
        
        local function onConnect(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                MainValue.fbManager:FBlogin(); --连接FB
            end
        end    
        self.bg:addTouchEventListener(onConnect);
        
        self:setContentSize(self.bgW,self.bgH);
        return;
    elseif self.rankData.username == "inviteFri" then
        self.bg = ccui.Button:create();
        self.bg:loadTextures("ui/ui/panel4.png", "ui/ui/panel4.png", "", 1)
        self.bg:setContentSize(self.bgW,self.bgH);
        self.bg:setScale9Enabled(true);
        self.bg:setPositionX(self.bgW / 2)
        self.bg:setPositionY(-50 + self.bgH / 2);
        self:addChild(self.bg);
        
        self.inviteIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/iconInvite.png");
        self.inviteIcon:setPosition(72, 96);
        self:addChild(self.inviteIcon);
        
        self.inviteLabel = cc.Sprite:createWithSpriteFrameName("ui/ui/txtInvite.png");
        self.inviteLabel:setPosition(72, 40);
        self:addChild(self.inviteLabel);
        
        local function onInvite(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local inviteClz = require("ui.inviteFriends.InviteFriendsPanel")
                local inviteFrisPanel = inviteClz.create();
                inviteFrisPanel:appearAlone();
            end
        end    
        self.bg:addTouchEventListener(onInvite);
        
        self:setContentSize(self.bgW,self.bgH);
        return;
    end

    if MainValue.fbManager:getIsLogin() then  --是否连接facebook
        if self.rankData.id == MainValue.dataManager.userManager:getPID() then --是否是自己
            self.bg = ccui.Button:create();
            self.bg:loadTextures("ui/ui/panel2.png", "ui/ui/panel2.png", "", 1)
            self.bg:setContentSize(self.bgW,self.bgH);
            self.bg:setScale9Enabled(true);
            self.bg:setPositionX(self.bgW / 2)
            self.bg:setPositionY(-50 + self.bgH / 2);
            self:addChild(self.bg);
        else
            self.bg = ccui.Button:create();
            self.bg:loadTextures("ui/ui/panel3.png", "ui/ui/panel3.png", "", 1)
            self.bg:setContentSize(self.bgW,self.bgH);
            self.bg:setScale9Enabled(true);
            self.bg:setPositionX(self.bgW / 2)
            self.bg:setPositionY(-50 + self.bgH / 2);
            self:addChild(self.bg);
        end
    
    
        local headIcon = nil;
        local function headFunc(id, url)
            headIcon:release();
        end
        headIcon = cc.Sprite:create();
        headIcon:setContentSize(58, 58);
        headIcon:setPosition(80, 101)
        headIcon:retain();
        self:addChild(headIcon);
        
--        print("加载头像的url"..self.rankData.picture)
        
        MainValue.platformManager:FBloadImage(self.rankData.id, self.rankData.picture, headIcon, headFunc)
    
        self.headBg = cc.Sprite:createWithSpriteFrameName("ui/ui/bgHead2.png")
        self.headBg:setPositionX(self.bgW / 2 + 2);
        self.headBg:setPositionY(101);
        self.headBg:setScale(0.75);
        self:addChild(self.headBg);
        
        if self.rankData.id ~= MainValue.dataManager.userManager:getPID() and self.rankData.energy == 0 then
            self.heartIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/iconHeartPlus.png");
            self.heartIcon:setPosition(120, 111);
            self.heartIcon:setScale(0.8);
            self:addChild(self.heartIcon);
            
            local function onSend(sender,eventType)
                if eventType == ccui.TouchEventType.ended then
                    self:sendLive();
                end
            end    
            self.bg:addTouchEventListener(onSend);
        end

    else	
        if self.rankData.rankNum == 0 then
            self:setContentSize(self.bgW,self.bgH);
            return;
        end

        if self.rankData.userId == "-1" then
            self.bg = ccui.Button:create();
            self.bg:loadTextures("ui/ui/panel2.png", "ui/ui/panel2.png", "", 1)
            self.bg:setContentSize(self.bgW,self.bgH);
            self.bg:setScale9Enabled(true);
            self.bg:setPositionX(self.bgW / 2)
            self.bg:setPositionY(-50 + self.bgH / 2);
            self:addChild(self.bg);
        else
            self.bg = ccui.Button:create();
            self.bg:loadTextures("ui/ui/panel3.png", "ui/ui/panel3.png", "", 1)
            self.bg:setContentSize(self.bgW,self.bgH);
            self.bg:setScale9Enabled(true);
            self.bg:setPositionX(self.bgW / 2)
            self.bg:setPositionY(-50 + self.bgH / 2);
            self:addChild(self.bg);
        end    

        self.headIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/" .. self.rankData.picture);
        self.headIcon:setPositionX(self.bgW / 2);
        self.headIcon:setPositionY(105);
        self:addChild(self.headIcon);
    end

    self.rankLab = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide ,tostring(self.rankData.rankNum));
    self.rankLab:setPosition(24, 120);
    self.rankLab:setScale(0.7, 0.7);
    self:addChild(self.rankLab);

    self.nameLab = FacFont:getFontsBmp(FontType.FontYellowNoSide ,tostring(self.rankData.username));
    self.nameLab:setPositionX(self.bgW / 2);
    self.nameLab:setPositionY(65);
    self:addChild(self.nameLab);

    self.scoreLab = FacFont:getFontsBmp(FontType.FontYellowWhiteSide ,tostring(self.rankData.score));
    self.scoreLab:setPositionX(self.bgW / 2);
    self.scoreLab:setPositionY(40);
    self.scoreLab:setScale(0.9)
    self:addChild(self.scoreLab);
    
    self:setContentSize(self.bgW,self.bgH);
end

--[[送好友体力]]
function RankCell:sendLive()
    if MainValue.platformManager:getNetwork() ~= "none" then
        MainValue.fbManager:sendHeart({self.rankData.id});
        
        MainValue.dataManager.friendManager:setDailyEnergyById(self.rankData.id);

        self.heartIcon:removeFromParent();
        self.bg:setTouchEnabled(false);
    end
end


return RankCell;