


local helpPanel = nil;

local buttonName = {"Power Up","Booster","Boss"};

local HelpPanel = class("HelpPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/Help.json")
end);

function HelpPanel:disCallBackFun()
    helpPanel:removeFromParent(true)
end

function HelpPanel.create()
    helpPanel = HelpPanel.new()

    helpPanel:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);

    local closeBtn = tolua.cast(helpPanel:getChildByName("ButtonClose"), "ccui.Button")
    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )

        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createUIAction():UIDisappear(helpPanel,helpPanel.disCallBackFun)
        end
    end
    closeBtn:addTouchEventListener(touchEvent);
    
    
    local panelView = tolua.cast(helpPanel:getChildByName("PanelView"), "cc.Node");
    
    local panelView_LabelTitle = panelView:getChildByName("LabelTitle");
    local text = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("BlockPanel_3"))
    panelView:addChild(text);
    text:setPosition(panelView_LabelTitle:getPosition());
    panelView_LabelTitle:removeFromParent();
    
    local panelView_LableNote = panelView:getChildByName("LableNote");
    local text = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("BlockPanel_4"), 380, "L");
    panelView:addChild(text);
    text:setPosition(panelView_LableNote:getPosition());
    panelView_LableNote:removeFromParent();
    
    for i=1,3 do  
        local button = helpPanel:getChildByName("Button" .. i);
        
        print(button:getChildrenCount())
        local button_Label = button:getChildren()[1];--button:getChildByName("LableT");
        text = FacFont:getFontsBmp(FontType.FontWhite, buttonName[i]);
        button:addChild(text);
        text:setPosition(button_Label:getPosition());
        button_Label:removeFromParent();
        
    end
    
    local labelPage = helpPanel:getChildByName("LabelPage");
    local text = FacFont:getFontsBmp(FontType.FontWhite, "1/2");
    helpPanel:addChild(text);
    text:setPosition(labelPage:getPosition());
    labelPage:removeFromParent();
    
    return helpPanel;
end

function HelpPanel:init()
    MainValue.actionManager:createUIAction():UIAppear(helpPanel);
end

return HelpPanel