HomeUI = class("HomeUI",function ()
    local tarLayer = cc.Layer:create()
   
    return tarLayer
end)

function HomeUI:ctor()
end

function HomeUI:initUI()

    cc.SpriteFrameCache:getInstance():addSpriteFrames("ui/ui_home.plist");
    
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/loading/loading0.png", "armature/loading/loading0.plist" , "armature/loading/loading.csb" )
    self.loadingArm = ccs.Armature:create("loading")    
    
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/Logo/Logo0.png", "armature/Logo/Logo0.plist" , "armature/Logo/Logo.csb" )
    self.logoArm = ccs.Armature:create("Logo")

    -- 设置位置
    self.loadingArm:retain()
    self.logoArm:retain();
    self.isLogin = false;
    
    self:initUIReal();
    
--   
 MainValue.statisticsManagerOG:Access();
end

function HomeUI:initUIReal()

    self.bgSpr = cc.Sprite:create("ui/homeUIBg.jpg");
    self.bgSpr:setContentSize(768,1214)
    self.bgSpr:setAnchorPoint(0.5,0.5);
    self.bgSpr:setPosition(VisibleRect:center());
    self:addChild(self.bgSpr) 
    
    self.logoArm:setPosition(VisibleRect:center())
    self.logoArm:getAnimation():play("1", -1, 1)
    self:addChild(self.logoArm)
    
    self.playBtn = ccui.Button:create("btnBlue1.png", "btnBlue2.png", nil, 1);
    self.playBtn:setScale9Enabled(true)
    self.playBtn:setContentSize(cc.size(382, 110))
    self.playBtn:setPosition(VisibleRect:center().x, VisibleRect:bottom().y + 180);
    self:addChild(self.playBtn)
    
    self.playNameTxt = cc.Sprite:createWithSpriteFrameName("play.png");
    
    self.playNameTxt:setPosition(cc.p(216,55))
    self.playBtn:addChild(self.playNameTxt)
    
    local function btnPlayHandler( sender, eventType )
        if self.loadingArm:getParent() ~= nil then            
            return
        end
        if eventType == ccui.TouchEventType.began then
            self.isPlayBtnLock = true;
            MainValue.actionManager:createJellyAction():press(sender,30);

        elseif eventType == ccui.TouchEventType.moved then
            if self.playBtn:isHighlighted() == false then

                if self.isPlayBtnLock then
                    MainValue.actionManager:createJellyAction():run(sender,40);
                    self.isPlayBtnLock = false;
                end
            elseif self.playBtn:isHighlighted() == true then
                if self.isPlayBtnLock == false then
                    MainValue.actionManager:createJellyAction():press(sender,30);
                    self.isPlayBtnLock = true;
                end
            end

        elseif eventType == ccui.TouchEventType.ended then

            if self.isPlayBtnLock then               

                self.isLogin = MainValue.fbManager:getIsLogin();
                if self.isLogin then
                    self:addMask();
                    self:addLoading();

                    local function resComCallback()
                        self:clickEnterGame();
                    end

                    MainValue.mxLoadingManager:loadRes(resComCallback);

                else

                    --链接facebook
                    MainValue.fbManager:FBlogin();
                end

                MainValue.actionManager:createJellyAction():run(sender,40);
            end
        end
    end
    self.playBtn:addTouchEventListener(btnPlayHandler)
    
    local function btnGuestHandler(sender, eventType)

        if eventType == ccui.TouchEventType.ended then
            self:addMask();
            self:addLoading();

            if self.playBtn ~= nil then
                self.playBtn:setTouchEnabled(false)   
            end

            if self.guestBtn ~= nil then
                self.guestBtn:setTouchEnabled(false)   
            end

            local function resComCallback()
                self:clickEnterGame();
            end

            MainValue.mxLoadingManager:loadRes(resComCallback);
        end
    end 

    self.isLogin = MainValue.fbManager:getIsLogin();
    if self.isLogin then
        self.playBtn:setPosition(VisibleRect:center().x,VisibleRect:bottom().y + 155);
        self.playNameTxt:setPositionX(196)
    else

        self.fbIconImg = cc.Sprite:createWithSpriteFrameName("iconFBR.png");
        self.fbIconImg:setPosition(80, 60);
        self.playBtn:addChild(self.fbIconImg);

        self.guestBtn = ccui.Button:create("imgGuest.png", "imgGuest.png", "", 1);
        self.guestBtn:setPosition(VisibleRect:center().x,VisibleRect:bottom().y + 90);
        self:addChild(self.guestBtn)

        self.guestBtn:addTouchEventListener(btnGuestHandler);
    end

   
end

function HomeUI:clickEnterGame()
    self:runAction(cc.Sequence:create(cc.DelayTime:create(2.5),cc.CallFunc:create(function() 


            MainStatus:onExitSplash()
            local al = MainValue.dataManager.levelManager:getMaxLevel();
            MainValue.SELECTED_LEVEL = al;
            if al == 1 then
                local function enterGame()
                    self:enterGame()
                end
                MainValue.mxLoadingManager:loadGame(al,enterGame);
            else 
                self:enterMap()
--                MainValue.platformManager:onSixWavesXSell();
            end
    end)))  

    if MainValue.fbManager:getIsLogin()== true then
 -- 2015-6-18 暂时注释 
  MainValue.statisticsManager:loginWeb("facebook"); 
    else
    -- 2015-6-18 暂时注释 
    MainValue.statisticsManager:loginWeb("selfServer"); 
    end
end







function HomeUI:enterGame()

    MainValue.statisticsManager:CustomTutorialBegin();
    MainValue.statisticsManagerOG:CustomTutorialBegin();



    local function animationComplete()  
        self.animation:GC();
        self.animation = nil;

        MainStatus:onExitSplash()                              
        MainValue.mxSplashManager:removeFirstLoading();
        MainStatus:onEnterGame();


    end;

    self:setVisible(false);

    local open = require("ui.openingAnimation.OpeningAnimation");
    self.animation = open.create(animationComplete);
    
    MainValue.mxSplashManager:addOpeningAnimation(self.animation);
    self.animation:setPosition(MainValue.winSize.width*0.5-768*0.5,MainValue.winSize.height*0.5 - 1214*0.5)
    self.animation:play();
end;

function HomeUI:enterMap()
    MainStatus:onExitSplash()        
    MainStatus:onEnterMap()
end;


function HomeUI:addMask()
    local color4B = cc.c4b(0,0,0,102);
    self.maskBg = cc.LayerColor:create(color4B,MainValue.winSize.width,MainValue.winSize.height);
    
    local listener = function(eventType, x, y)

        if eventType == "began" then
            return true           
        end
    end

    self.maskBg:registerScriptTouchHandler(listener, false, 0, true)
    self.maskBg:setTouchEnabled(true);
    self:addChild(self.maskBg);
end

function HomeUI:addLoading()
    if  self.loadingArm~=nil and  self.loadingArm:getParent() == nil then
        self.loadingArm:setPosition(VisibleRect:center().x,VisibleRect:center().y-300)
        self.loadingArm:getAnimation():play("1",-1,1)
        self:addChild(self.loadingArm)
    end
end

function HomeUI:addPanel(type)

    local color4B = cc.c4b(0,0,0,102);
    self.maskBg = cc.LayerColor:create(color4B,MainValue.winSize.width,MainValue.winSize.height);

    local listener = function(eventType, x, y)

        if eventType == "began" then
            return true           
        end
    end

    self.maskBg:registerScriptTouchHandler(listener, false, 0, true)
    self.maskBg:setTouchEnabled(true);
    self:addChild(self.maskBg);

    if type == 1 then
    
        local function openSurport()
            self:addPanel(2);
        end
        local settingPanelClz = require("ui.homeui.LoadingSetPanel");
        local settingPanel = settingPanelClz.create(self.maskBg, openSurport);
        settingPanel:setPosition(VisibleRect:center());
        self:addChild(settingPanel);
        settingPanel:appear();
        
    elseif type == 2 then
        local surportClz = require("ui.homeui.SurportPanel");
        local surportPanel = surportClz.create(self.maskBg);
       -- surportPanel:setPosition(VisibleRect:center());
        self:addChild(surportPanel);
        surportPanel:appear();
    end
end


function HomeUI:disapperComplete()
    MainValue.eventDispatcher:removeEventListener(MainValue.eventDispatcher.eventType.EVENT_FRIENDS, self.callBack);
end





function HomeUI:removeFirstLoading()

    if self ~= nil then

        if  self.loadingArm~=nil and  self.loadingArm:getParent() ~= nil then
            self.loadingArm:getAnimation():stop()
            self.loadingArm:getParent():removeChild(self.loadingArm)
        end

        if self.playBtn~=nil then   
            self.playBtn:setTouchEnabled(true)
        end

    end  
end

function HomeUI:setFBConnectSuccess()
    self:addMask();
    self:addLoading();

    local function resComCallback()
        self:clickEnterGame();
    end

    MainValue.mxLoadingManager:loadRes(resComCallback);
end

function HomeUI:setLogin(result)
    if result == 1 then
        self.playBtn:setPosition(VisibleRect:center().x,VisibleRect:bottom().y + 155);
        self.guestBtn:setVisible(false);
    end
end