require "engine/uigridtools/SpecialGridToolsAlone"

local LoadingSetPanel = class("LoadingSetPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("home/LoadingSetPanel.json");
end)

function LoadingSetPanel:ctor()
    self.closeBtn = nil;
    self.titleLab = nil;
    self.versionLab = nil;--版本号
    
    self.musicBtn = nil;
    self.effectBtn = nil;
    
    self.musicImag = nil;
    self.effectImag = nil;
    
    self.isOpenSuport = false;
    
    self.openSuportFun = nil;
    
    self.callBack = nil;
    
    self.mask = nil;
end

function LoadingSetPanel.create(mask, openSuportFun)
    local temp = LoadingSetPanel.new()
    temp.mask = mask;
    temp.openSuportFun = openSuportFun;
    temp:init();
    return temp
end

function LoadingSetPanel:init()
    self:setScale(0);
    
    self.titleLab = FacFont:getFontsBmp(FontType.FontRed, "Setting")
    self.titleLab:setPosition(3, 256);
    self:addChild(self.titleLab);
    
    local version = MainValue.platformManager:getAppVersion();
    self.versionLab = FacFont:getFontsBmp(FontType.FontRed, version)
    self.versionLab:setPosition(3, -235);
    self:addChild(self.versionLab); 
    
    
    local uid = MainValue.dataManager.userManager:getUID();
    self.uidLab = FacFont:getFontsBmp(FontType.FontRed, uid)
    self.uidLab:setPosition(3, -220);
    self:addChild(self.uidLab); 
    
    local bgPanel = self:getChildByName("PanelDesBg");
    
    local coockyBg = SpecialGridToolsAlone.create("home/bgCooky.png",492,347,26)
    
    bgPanel:addChild(coockyBg)
    
    self.closeBtn = self:getChildByName("BtnClose");
    local function onClose(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            self:disapper();
        end
    end
    self.closeBtn:addTouchEventListener(onClose);
    
    self.musicBtn = self:getChildByName("BtnSound")
    self.effectBtn = self:getChildByName("BtnEffect")
    
    self.musicImag = self:getChildByName("ImgNoSound");
    self.effectImag = self:getChildByName("ImgNoEffect");
    
    self:initMusic(MainValue.dataManager.expandManager:getBgMusice());
    self:initEffect(MainValue.dataManager.expandManager:getEfMusice());
    
    local function onMusic(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local isPlay = MainValue.dataManager.expandManager:getBgMusice();
            self:updataMusic(isPlay);
        end    
    end
    self.musicBtn:addTouchEventListener(onMusic);

    local function onEffect(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local isPlay = MainValue.dataManager.expandManager:getEfMusice();
            self:updataEffect(isPlay);
        end    
    end
    self.effectBtn:addTouchEventListener(onEffect);
    
    local supportBtn = self:getChildByName("BtnSupport")
    local supportLab = FacFont:getFontsBmp(FontType.FontRed,"Support")
    supportLab:setPosition(127, 53);
    supportBtn:addChild(supportLab); 

    local connectBtn = self:getChildByName("BtnConnect")
    local connectLab = FacFont:getFontsBmp(FontType.FontRed,"Connect")
    connectLab:setPosition(179, 53);
    connectBtn:addChild(connectLab);

    local logoutBtn = self:getChildByName("BtnLogout");
    local logoutLab = FacFont:getFontsBmp(FontType.FontRed,"Log out")
    logoutLab:setPosition(147, 53);
    logoutBtn:addChild(logoutLab); 

    if MainValue.fbManager:getIsLogin() then
        connectBtn:setVisible(false);
--        logoutBtn:setVisible(true);
        supportBtn:setPositionY(-145);
    end
    
    local function onSupport(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(sender,40);
            
            self.isOpenSuport = true;
            self:disapper();
        end
    end
    supportBtn:addTouchEventListener(onSupport);
    
    local function onConnect(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(sender,40);
            MainValue.fbManager:FBlogin();

            self:disapper();
        end
    end
    connectBtn:addTouchEventListener(onConnect);
    
    local function onLogout(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(sender,40);
            MainValue.fbManager:FBlogout();

            connectBtn:setVisible(true);
            logoutBtn:setVisible(false);
        end
    end
    logoutBtn:addTouchEventListener(onLogout);

    ----已连接FB
    local function onSuccess()
        connectBtn:setVisible(false);
--        logoutBtn:setVisible(true);
        supportBtn:setPositionY(-145);
    end
    self.callBack = onSuccess;
    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_FRIENDS, onSuccess);
end


function LoadingSetPanel:initMusic(isPlaying)
    if isPlaying == nil or isPlaying == true  then
        self.musicImag:setVisible(false)
      

    else
        self.musicImag:setVisible(true);
       
    end
end

function LoadingSetPanel:initEffect(isPlaying)
    if isPlaying == nil or isPlaying == true then
        self.effectImag:setVisible(false)
    else
        self.effectImag:setVisible(true);
    end
end

function LoadingSetPanel:updataMusic(isPlaying)

    if isPlaying == nil then
        self.musicImag:setVisible(true);
        MainValue.dataManager.expandManager:setBgMusice(false);
        MainValue.soundManager:stopMusic();
        return;
    end

    if isPlaying == true then
        self.musicImag:setVisible(true)
        MainValue.dataManager.expandManager:setBgMusice(false);
        MainValue.soundManager:stopMusic();

    else
        self.musicImag:setVisible(false);
        MainValue.dataManager.expandManager:setBgMusice(true);
        MainValue.soundManager:playMusic(0,true);
    end
end

function LoadingSetPanel:updataEffect(isPlaying)

    if isPlaying == nil then
        self.effectImag:setVisible(true)
        MainValue.dataManager.expandManager:setEfMusice(false);
        return;
    end
    if isPlaying == true then
        self.effectImag:setVisible(true)
        MainValue.dataManager.expandManager:setEfMusice(false);
    else
        self.effectImag:setVisible(false);
        MainValue.dataManager.expandManager:setEfMusice(true);
    end
end

function LoadingSetPanel:appear()
    MainValue.soundManager:playEffect(GameSoundEffectId.OPEN_D)
    
    local function action2(node)
        node:stopAllActions() --After this stop next action not working, if remove this stop everything is working

        local ac3 = cc.Sequence:create(cc.EaseOut:create(cc.ScaleTo:create(0.1, 1), 0.8));
        node:runAction(ac3);
    end

    local ac1 = cc.Sequence:create(cc.EaseIn:create(cc.ScaleTo:create(0.15, 1.1), 0.8), cc.CallFunc:create(action2));
    self:runAction(ac1);end


function LoadingSetPanel:disapper()
    MainValue.soundManager:playEffect(GameSoundEffectId.CLOSE_D)
    
    local function callFun()
        self:disapperComplete();
    end

    self:stopAllActions()
    local ac1 = cc.ScaleTo:create(0.15, 0)
    self:runAction(cc.Sequence:create(ac1, cc.CallFunc:create(callFun)));
end

function LoadingSetPanel:disapperComplete()
    MainValue.eventDispatcher:removeEventListener(MainValue.eventDispatcher.eventType.EVENT_FRIENDS, self.callBack);
    
    self.mask:getParent():removeChild(self.mask);
    
    if self.isOpenSuport then
        self.openSuportFun();
    end
    
    self:removeFromParent(true);
end

return LoadingSetPanel