local SurportPanel = class("SurportPanel", function()
    return cc.Layer:create();
end)

function SurportPanel:ctor()
    self.bg = nil;
    self.closeBtn = nil;
    
    self.desBgUp = nil;
    self.desBgDown = nil;
    
    self.titleTxt = nil;
    self.desTxt = nil;
    
    self.upRTxt = nil;
    self.upYTxt = nil;
    
    self.downRTxt = nil;
    self.downYTxt = nil;
    
    self.pointUp = nil;
    self.pointDown = nil;
    
    self.lineUp = nil;
    self.lineDown = nil;
    
    self.mask = nil;
    
    self.selectedRect = nil;
    
    self.FBUrl = nil;
    self.FAQUrl = nil;
    
    self.cellClickRecAry  = {cc.rect(-251,-149,512,188),cc.rect(-251,-384,512,188)}
end

function SurportPanel.create(mask)
    local temp = SurportPanel.new();
    temp.mask = mask;
    temp:init();
    return temp;
end

function SurportPanel:init()
    self:setPosition(VisibleRect:center().x,MainValue.winSize.height*1.5);
    
    self.bg = cc.Sprite:create("res/home/panelSurport.png");
    self:addChild(self.bg);
    
    self.closeBtn = ccui.Button:create("res/loadingmobile/btn/btnClose1.png","res/loadingmobile/btn/btnClose2.png","",1)
    self.closeBtn:setPosition(291, 321)
    self:addChild(self.closeBtn);
    
    local function onClose( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:disapper();
        end
    end
    self.closeBtn:addTouchEventListener(onClose);
    
    
    self.titleTxt = FacFont:getFontsBmp(FontType.FontRed, "Support")
    self.titleTxt:setPosition(0, 467)
    self:addChild(self.titleTxt)
    
    self.desTxt = FacFont:getFontsBmp(FontType.FontRed, "If you experience any issues with the game, you can reach us by the following methods.", 450, "L")
    self.desTxt:setPosition(0, 181)
    self:addChild(self.desTxt)
    
    self.desBgUp = SpecialGridToolsAlone.create("home/bgCooky.png",533,190,26)
    self.desBgUp:setPosition(0, -65);
    self:addChild(self.desBgUp)
    
    self.desBgDown = SpecialGridToolsAlone.create("home/bgCooky.png",533,190,26)
    self.desBgDown:setPosition(0, -300);
    self:addChild(self.desBgDown)
    
    self.upRTxt = FacFont:getFontsBmp(FontType.FontRed, "Facebook Community")
    self.upRTxt:setPosition(20, -10)
    self:addChild(self.upRTxt)
    
    self.upYTxt = FacFont:getFontsBmp(FontType.FontRed, "Tap here to access our Facebook Fan", 480)
    self.upYTxt:setPosition(0, -85)
    self:addChild(self.upYTxt)
    
    self.downRTxt = FacFont:getFontsBmp(FontType.FontRed, "FAQ")
    self.downRTxt:setPosition(-106, -231)
    self:addChild(self.downRTxt)
    
    self.downYTxt = FacFont:getFontsBmp(FontType.FontRed, "Tap here to access our Knowledge Database", 480, "L", 10)
    self.downYTxt:setPosition(20, -311)
    self:addChild(self.downYTxt)
    
    self.pointUp = cc.Sprite:createWithSpriteFrameName("res/loadingmobile/btn/iconRedPoint.png")
    self.pointUp:setPosition(-165, -23)
    self:addChild(self.pointUp);
    
    self.pointDown = cc.Sprite:createWithSpriteFrameName("res/loadingmobile/btn/iconRedPoint.png")
    self.pointDown:setPosition(-165, -242)
    self:addChild(self.pointDown);
    
    self.lineUp = cc.Sprite:createWithSpriteFrameName("res/loadingmobile/btn/iconUnderline.png")
    self.lineUp:setScaleX(40)
    self.lineUp:setPosition(20, -38)
    self:addChild(self.lineUp);
    
    self.lineDown = cc.Sprite:createWithSpriteFrameName("res/loadingmobile/btn/iconUnderline.png")
    self.lineDown:setScaleX(7.75)
    self.lineDown:setPosition(-104, -258)
    self:addChild(self.lineDown);
    
    local function onTouchBgBegan(touch, event)
        local clickRectContainsPoint = false
        
        local locationInNode = self:convertToNodeSpace(touch:getLocation())
        
        for rectI = 1,#(self.cellClickRecAry) do
            local rect = self.cellClickRecAry[rectI]
            if cc.rectContainsPoint(rect, locationInNode) then
                clickRectContainsPoint = true
                self.selectedRect = rectI
                break;                     
            end
        end
        
        return clickRectContainsPoint;
    end
    
    local function onTouchBgEnded(touch, event)
        if self.selectedRect == 1 or self.selectedRect == 2 then
            self:disapper();
        end
    end
    
    local listener = cc.EventListenerTouchOneByOne:create();
    listener:setSwallowTouches(true);
    listener:registerScriptHandler(onTouchBgBegan,cc.Handler.EVENT_TOUCH_BEGAN );
    listener:registerScriptHandler(onTouchBgEnded,cc.Handler.EVENT_TOUCH_ENDED );

    self.eventDispatcher = self:getEventDispatcher();
    self.eventDispatcher:addEventListenerWithSceneGraphPriority(listener, self);
    
    local targetPlatform = cc.Application:getInstance():getTargetPlatform()
    if targetPlatform == cc.PLATFORM_OS_IPHONE or targetPlatform == cc.PLATFORM_OS_IPAD  then
        self.FBUrl = "https://www.facebook.com/wizardofozmobile";
        self.FAQUrl = "http://bj-insights-demo.6waves.com/tools/admin.php?c=admin&m=faq&game=sundaesmash_android&data=";
    elseif targetPlatform == cc.PLATFORM_OS_ANDROID then
        self.FBUrl = "https://www.facebook.com/wizardofozmobile";
        self.FAQUrl = "http://bj-insights-demo.6waves.com/tools/admin.php?c=admin&m=faq&game=sundaesmash_android&data=";
    end;
end

function SurportPanel:sendUrl(url)
    MainValue.platformManager:OpenUrl(url)
end

function SurportPanel:appear()
    MainValue.soundManager:playEffect(GameSoundEffectId.OPEN_D)

    local winSizeHeight = MainValue.winSize.height;

    local function action2(node)
        node:stopAllActions() --After this stop next action not working, if remove this stop everything is working

        local ac2 = cc.Sequence:create(cc.EaseOut:create(cc.MoveBy:create(0.1,cc.p(0, 10)), 0.3));
        node:runAction(ac2);
    end

    local ac = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.2,cc.p(0, - winSizeHeight - 10)), 0.3), cc.CallFunc:create(action2));
    self:runAction(ac);
end


function SurportPanel:disapper()
    MainValue.soundManager:playEffect(GameSoundEffectId.CLOSE_D)


    local function callFun()
        self:disapperComplete();
    end
    
    local winSizeHeight = MainValue.winSize.height;
    
    local function action2(node)
        node:stopAllActions() --After this stop next action not working, if remove this stop everything is working
        local disAc2 = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.25,cc.p(0, -winSizeHeight - 15)), 0.8),cc.CallFunc:create(callFun));
        node:runAction(disAc2);
    end

    local disAc1 = cc.Sequence:create(cc.EaseOut:create(cc.MoveBy:create(0.15,cc.p(0, 15)), 0.6),cc.CallFunc:create(action2));
    self:runAction(disAc1); 
end

function SurportPanel:disapperComplete()
    self.mask:getParent():removeChild(self.mask);
    
    if self.selectedRect == 1 then
        self:sendUrl(self.FBUrl)
    elseif self.selectedRect == 2 then
        self:sendUrl(self.FAQUrl)
    end

    self:removeFromParent(true);
end

return SurportPanel;