


local InGameExitPanel = class("InGameExitPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/InGameExitPopup.json")
end)

function InGameExitPanel:disCallBackFun()
   -- self:removeFromParent(true)
    self:disappear();
    MainValue.mxGameManager:gameExitGame();
   
end

function InGameExitPanel:closePanel()
   --- self:removeFromParent(true)
    self:disappear();
end

function InGameExitPanel.create()
    local layer = InGameExitPanel.new()

    layer:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2)
    layer:setScale(0);
    
    local replayBtn = layer:getChildByName("ReplayBtn")
    local label = replayBtn:getChildByName("BtnLabel")
    local btnLabel = FacFont:getFontsBmp(FontType.FontWhite, "Return")
    replayBtn:addChild(btnLabel)
    btnLabel:setPosition(label:getPosition())
    label:removeFromParent()
    
    local imgBg = layer:getChildByName("BgImg")
    --imgBg:setScaleY(-1);
    
    local function onReplay(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(sender,40);
            layer:closePanel();
            --do replay
        end
    end
    replayBtn:addTouchEventListener(onReplay)
    
    local quitBtn = layer:getChildByName("QuitBtn")
    label = quitBtn:getChildByName("BtnLabel")
    btnLabel = FacFont:getFontsBmp(FontType.FontWhite, "Quit")
    quitBtn:addChild(btnLabel)
    btnLabel:setPosition(label:getPosition())
    label:removeFromParent()
    
    layer.MusicBtnE =  layer:getChildByName("MusicBtnE");
    layer.EffectBtnE =  layer:getChildByName("EffectBtnE");
    layer.MusicBtnD =  layer:getChildByName("MusicBtnD");
    layer.EffectBtnD =  layer:getChildByName("EffectBtnD");
    
    layer:initMusic(MainValue.dataManager.expandManager:getBgMusice());
    layer:initEffect(MainValue.dataManager.expandManager:getEfMusice());
    
    local function onQuit(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            --do replay
            MainValue.actionManager:createJellyAction():run(sender,40);
            layer:disCallBackFun();
        end
    end
    quitBtn:addTouchEventListener(onQuit)

    local closeBtn = tolua.cast(layer:getChildByName("CloseBtn"), "ccui.Button")
    local function onClose(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            layer:closePanel();
        end
    end
    closeBtn:addTouchEventListener(onClose)
    
    
    local function onMusic(sender,eventType)
         if eventType == ccui.TouchEventType.ended then
            local isPlay = MainValue.dataManager.expandManager:getBgMusice();
            layer:updataMusic(isPlay);
         end
    end
    
    local function onEffect(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            local isPlay = MainValue.dataManager.expandManager:getEfMusice();
            layer:updataEffect(isPlay);
        end
    end
    
    layer.MusicBtnE:addTouchEventListener(onMusic);
    layer.MusicBtnD:addTouchEventListener(onMusic);
    layer.EffectBtnE:addTouchEventListener(onEffect);
    layer.EffectBtnD:addTouchEventListener(onEffect);
    return layer
end

function InGameExitPanel:updataMusic(isPlaying)
    if isPlaying == nil then
        self.MusicBtnE:setVisible(false);
        self.MusicBtnD:setVisible(true);
        MainValue.dataManager.expandManager:setBgMusice(false);
        MainValue.soundManager:stopMusic();
        
        return;
    end
   
    if isPlaying == false then
        self.MusicBtnE:setVisible(true);
        self.MusicBtnD:setVisible(false);
        MainValue.dataManager.expandManager:setBgMusice(true);
        local mapId = math.ceil(MainValue.SELECTED_LEVEL/10);
        local musicId = mapConfig.gameMusic[mapId];
        MainValue.soundManager:playMusic(musicId,true);

    else
        
        self.MusicBtnE:setVisible(false);
        self.MusicBtnD:setVisible(true);
        MainValue.dataManager.expandManager:setBgMusice(false);
        MainValue.soundManager:stopMusic();
    end
end

function InGameExitPanel:updataEffect(isPlaying)
    if isPlaying == nil then
        self.EffectBtnE:setVisible(false);
        self.EffectBtnD:setVisible(true);
        MainValue.dataManager.expandManager:setEfMusice(false);
        return;
    end
    
    if isPlaying == false then
        self.EffectBtnE:setVisible(true);
        self.EffectBtnD:setVisible(false);
        MainValue.dataManager.expandManager:setEfMusice(true);
    else
        self.EffectBtnE:setVisible(false);
        self.EffectBtnD:setVisible(true);
        MainValue.dataManager.expandManager:setEfMusice(false);

    end
end

function InGameExitPanel:initMusic(isPlaying)
    if isPlaying~= nil and isPlaying == false then --可以播放
        self.MusicBtnE:setVisible(false);
        self.MusicBtnD:setVisible(true);
        local mapId = math.ceil(MainValue.SELECTED_LEVEL/10);
        local musicId = mapConfig.gameMusic[mapId];

    else
        self.MusicBtnE:setVisible(true);
        self.MusicBtnD:setVisible(false);
    end
end

function InGameExitPanel:initEffect(isPlaying)
    if isPlaying~= nil and isPlaying == false then
        self.EffectBtnE:setVisible(false);
        self.EffectBtnD:setVisible(true);
    else
        self.EffectBtnE:setVisible(true);
        self.EffectBtnD:setVisible(false);

    end
end

--function InGameExitPanel:init()
--    MainValue.actionManager:createUIAction():UIAppear(self)
--end

function InGameExitPanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.POP_UP, self.appearComplete,self.disappear);
end

function InGameExitPanel:appearComplete()
   -- self.armature:setVisible(true);
   -- self.armature:getAnimation():playWithIndex(0)
end

function InGameExitPanel:disappear()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.POP_UNDER , self.disappearComplete)
end

function InGameExitPanel:disappearComplete()
    self:removeFromParent(true)

end

return InGameExitPanel