local InGameFailedPanel = class("InGameFailedPanel", function()
    return cc.Node:create();
end);

function InGameFailedPanel:ctor()
    self.failType = 0
    self.failData = nil

    self.failedPanel = nil
    self.noScorePanel = nil
    self.noTargetPanel = nil
    
    self.addCashSpr = nil;
    self.addCashBg = nil;
    self.addCashIcon = nil;
    self.addCashNum = nil;
    self.addCasnBtn = nil;
    
    self.callBack = nil;

    self.closeType = 0;-- 0:关闭   1:已购买五步  2:退出游戏
end

function InGameFailedPanel.create()
    local temp = InGameFailedPanel.new();
    temp:init();
    return temp;
end

function InGameFailedPanel:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);
    
    self.addCashSpr = cc.Node:create()
    self.addCashSpr:setPosition(-MainValue.winSize.width / 2 + 120 , MainValue.winSize.height / 2 - 40);
    self:addChild(self.addCashSpr);
    
    self.addCashBg = cc.Sprite:createWithSpriteFrameName("ui/ui/bgTopBar.png");
    self.addCashBg:setPositionY(-3)
    self.addCashSpr:addChild(self.addCashBg);
    
    self.addCashIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/iconCoin.png");
    self.addCashIcon:setPosition(-73, 0)
    self.addCashSpr:addChild(self.addCashIcon);
    
    self.addCasnBtn = ccui.Button:create("ui/ui/btnPlus2_1.png", "ui/ui/btnPlus2_2.png", "", 1)
    self.addCasnBtn:setPosition(76, 0)
    self.addCashSpr:addChild(self.addCasnBtn);
    
    local function addCashHandler( sender, eventType )
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.moved then
        elseif eventType == ccui.TouchEventType.ended then
            local notEnoughCoins = require("ui.storeUI.StoreUI")
            local notEnoughCoin = notEnoughCoins.create()
            notEnoughCoin:appearAlone();
        end
    end
    self.addCasnBtn:addTouchEventListener(addCashHandler)
    
    local function updataCash()
        local labelCashTxt = ccui.Helper:seekWidgetByName(self.layerCash, "LabelTxt")
        if self.addCashNum == nil then
            self.addCashNum = FacFont:getFontsBmp(FontType.FontWhite, MainValue.dataManager.userManager:getCash());
            self.addCashSpr:addChild(self.addCashNum);
        else
            self.addCashNum:setText(MainValue.dataManager.userManager:getCash())  
        end
        self.addCashNum:setScale(0.87)
        self.addCashNum:setPosition(5, 0)
    end
    self.callBack = updataCash;
     
    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_CASH, updataCash);
    
    
    updataCash();
end

--function InGameFailedPanel:initFailedPanel()
--    local failedPanelCls = require("ui/inGame/failedView/FailedView")
--    self.failedPanel = failedPanelCls.create(self, self.onClose)
--    self:addChild(self.failedPanel)
--end

function InGameFailedPanel:initNoScorePanel()
    local noScorePanelCls = require("ui/inGame/failedView/LoseNotEnoughScoreView")
    self.noScorePanel = noScorePanelCls.create(self, self.onClose)
    self:addChild(self.noScorePanel)
end

function InGameFailedPanel:initNoTargetPanel()
    local noTargetPanelCls = require("ui/inGame/failedView/LoseNotReachTargetView")
    self.noTargetPanel = noTargetPanelCls.create(self, self.onClose)
    self:addChild(self.noTargetPanel)
end

function InGameFailedPanel:setData(failType, failData)
    self.failType = failType;
    
    if self.failType == 1 then 
        --not initFailedPanel
    elseif self.failType == 2 then 
        self:initNoScorePanel()
    elseif self.failType == 3 then 
        self:initNoTargetPanel()
    end
    
    if self.failType == 3 then
        if nil ~= failData then
            self.failData = {};
            for i, data in ipairs(failData) do
                local luaData = {};

                if data.id2 > 0 then
                    luaData.id = data.id .. "_" .. data.id2;
                elseif data.id2 == 0 then
                    luaData.id = data.id;
                end

                luaData.curNum = data.n;
                luaData.tarNum = data.s;

                table.insert(self.failData, luaData)
            end
        end
        ---------测试数据-------
        --self.failData = {{id = 101, curNum = 10, tarNum = 12}, {id = 101, curNum = 10, tarNum = 12}, {id = 101, curNum = 10, tarNum = 12}}
        
        self.noTargetPanel:setData(self.failData)
    end
end

function InGameFailedPanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disappear);
end

function InGameFailedPanel:appearComplete()
    if self.failType == 3 then 
        self.noTargetPanel:showBtn()
    end
end

function InGameFailedPanel:onClose(closeType)
    self.closeType = closeType;
    
    self:disappear();
end

function InGameFailedPanel:disappear()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_DOWN , self.disappearComplete)
end

function InGameFailedPanel:disappearComplete()
    MainValue.eventDispatcher:removeEventListener(MainValue.eventDispatcher.eventType.EVENT_CASH, self.callBack);

    if self.failedPanel then
        self.failedPanel:getParent():removeChild(self.failedPanel, true)
        self.failedPanel = nil;
    elseif self.noScorePanel then
        self.noScorePanel:getParent():removeChild(self.noScorePanel, true)
        self.noScorePanel = nil;
    elseif self.noTargetPanel then
        self.noTargetPanel:getParent():removeChild(self.noTargetPanel, true)
        self.noTargetPanel = nil
    end
    self:removeFromParent(true);

    if self.closeType == 2 then
        MainValue.mxGameManager:cancelBuySteps();
        
    elseif self.closeType == 1 then
        local toolsPrice = tonumber(MainValue.infosManager:getObjGoodsById("302").cash);
        MainValue.mxGameManager:buySteps(5);--购买+5步

        MainValue.dataManager.userManager:subCash(toolsPrice);--扣除cash
    end
end

return InGameFailedPanel