require "ui.panelManager.PanelManager"

local InGameStartPanel = class("InGameStartPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/InGameStart.json")
end);

function InGameStartPanel:ctor()
    self.targetView = nil;
    self.targetData = nil;
    
    self.desLabel = nil;
end

function InGameStartPanel.create()
    local inGameStartPanel = InGameStartPanel.new()
    inGameStartPanel:initAni();
    return inGameStartPanel;
end

function InGameStartPanel:initAni()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);
    
--    self.desLabel = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("Common_CollectTarget"), 500, "C", 0, 1);
--    self.desLabel:setPositionY(-20);
--    self:addChild(self.desLabel);
end

function InGameStartPanel:setData(data)
--------测试用数据-----
--    self.targetData = {{id = 101, curNum = 0, tarNum = 12, colorType = 1}, {id = 201, curNum = 0, tarNum = 10, colorType = 1}, {id = 301, curNum = 0, tarNum = 11, colorType = 2}}--{{id = 101, curNum = 10, tarNum = 12, colorType = 1}, {id = 201, curNum = 10, tarNum = 10, colorType = 1}}

    self.targetData = {};
    if nil ~= data then
        self.targetData = {};
        for k, v in pairs(data) do
            local luaData = {};
            
            if v.id2 > 0 then
                luaData.id = v.id .. "_" .. v.id2;
            elseif v.id2 == 0 then
                luaData.id = v.id;
            end
            
            luaData.curNum = 0;
            luaData.tarNum = v.s;
            table.insert(self.targetData, luaData)
        end
    end
    
    local targetViewCls = require("ui.collectTarget.TargetListView")
    self.targetView = targetViewCls:create(self.targetData, false, false)
    self.targetView:setPosition(-183, -21)
    self:addChild(self.targetView)
--    self.targetView:setVisible(false);
end

function InGameStartPanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disappear);
end

function InGameStartPanel:appearComplete()
    self.targetView:setVisible(true);

    local delayTime = 0;
    local function update(dt)
        delayTime =  delayTime + dt;

        if delayTime >= 1 then
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.timerId) 
            self:disappear();
        end
    end

    self.timerId = cc.Director:getInstance():getScheduler():scheduleScriptFunc(update, 0, false)
end

function InGameStartPanel:disappear()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_DOWN , self.disappearComplete)
end

function InGameStartPanel:disappearComplete()
    if self.targetView ~= nil then
        self.targetView:getParent():removeChild(self.targetView,true);
        self.targetView = nil;
    end
    
    self:removeFromParent(true);
    
    
    MainValue.mxGameManager:showFtueByLv(MainValue.SELECTED_LEVEL)
end

return InGameStartPanel