require "ui.playGamePanel.PlayGamePanel"
require("data/buydata/BuyFlowData") 
local IsBuyItemPanel = class("IsBuyItemPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/IsBuyItem.json");
end);

function IsBuyItemPanel:ctor()

  self.priceDes = nil;
  self.goodsText = nil;
  self.goodsNum = 3;
  self.allPrice = nil;
  self.good = nil;
  
  self.buyForIcon = nil;
  self.isOpenShop = false;
  self.buyForBtn = nil;
  self.itemCell = nil;
  self.typeFrontForm = nil --前置道具 
  self.goodId = nil;
end

function IsBuyItemPanel.create(goodsId)
    local temp = IsBuyItemPanel.new();
--    temp.typeFrontForm = fromType;
    temp.goodId = goodsId;
    temp:init(goodsId);
    return temp;
end

function IsBuyItemPanel:setCell(cell)
    self.itemCell  = cell;
end

function IsBuyItemPanel:init(goodId)
    self.good = MainValue.infosManager:getObjGoodsById(goodId);
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);
    
    local aniPanel = self:getChildByName("bg");
    local desBg = SpecialGridTools.create("ui/ui/bgCooky.png",400,300,26);
    desBg:setAnchorPoint(0.5,0.5);
    desBg:setPosition(44,-10)--(350, 258);
    aniPanel:addChild(desBg);
    --goodName
    local itemTitle = self:getChildByName("itemTitle");
    local goodName = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,self.good.name);
    itemTitle:addChild(goodName);

    local goodBg = self:getChildByName("goodBg");
    local str = string.format("ui/prop/big/%d.png",goodId);
    local goodsIcon = cc.Sprite:create(str);
    goodsIcon:setScale(0.8);
--    goodBg:addProtectedChild(goodsIcon,2);
    goodBg:addChild(goodsIcon);
    goodsIcon:setPosition(72,75);
    
    --goodPrice
    self.buyForBtn = self:getChildByName("BuyFor");

    local function updataPrice()
        local priceDes = self.buyForBtn:getChildByName("BuyPrice");
        self.allPrice = self.good.cash*self.goodsNum;
        local priceStr = string.format("%d",self.allPrice)
        if self.priceDes == nil then 
            self.priceDes = FacFont:getFontsBmp(FontType.FontWhite,priceStr);
--            FontType.FontBigYellowLightShadeSide
            self.buyForBtn:addChild(self.priceDes);
            self.priceDes:setAnchorPoint(0.5,0.5)
            
            self.priceDes:setPosition(priceDes:getPosition());
        else 
            self.priceDes:setText(priceStr);
            self.priceDes:setAnchorPoint(0.5,0.5)
            self.priceDes:setPosition(priceDes:getPosition());
        end

    end
    updataPrice();
   
    --goodDES
    local goodDes = self:getChildByName("desText");
    if self.goodsText == nil then
        self.goodsText = FacFont:getFontsBmp(FontType.FontWhite,self.good.des,430,"C",-10);
        self.goodsText:setScale(0.6)
        goodDes:addChild(self.goodsText);
    else 
        self.goodsText:setText(self.good.des);
    end 
    
   --good number
    local addNum = self:getChildByName("addNum");
    local number = FacFont:getFontsBmp(FontType.FontRed,"X3",430,"C",-10);
    addNum:addChild(number);
    
    
    --close
    local btnClose = self:getChildByName("closeBtn");
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:onClose();
        end
    end
    btnClose:addTouchEventListener(touchEvent);
    
    
    --buyBtn
    local function onBuyItem( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            
            local userCash = MainValue.dataManager.userManager:getCash();
            self.allPrice = self.goodsNum * self.good.cash;
            if userCash < self.allPrice then
                 self:onClose();
                 self.isOpenShop = true;
		 if self.itemCell~=nil then
                    --self.itemCell:disapper();
		 end
            else
                --购买成功
                MainValue.dataManager.userManager:subCash(tonumber(self.allPrice));
                MainValue.dataManager.goodsManager:addGoods(goodId,self.goodsNum);
                self.buyForBtn:setTouchEnabled(false);
                self:showAnimation();
                
                local level1 = 0;
                if self.itemCell == nil then
                    level1 = MainValue.SELECTED_LEVEL;
                end
                
                if tonumber(goodId) > 100 then  --前置道具
                    MainValue.statisticsManager:consumeBuyPreItem(goodId, self.goodsNum,"0",self.allPrice, level1, MainValue.dataManager.userManager:getHeart(), "0", MainValue.dataManager.userManager:getCash(), 1 );
                else
                    MainValue.statisticsManager:consumeBuyInGameItem(goodId, self.goodsNum,"0",self.allPrice, level1, MainValue.dataManager.userManager:getHeart(), "0", MainValue.dataManager.userManager:getCash(), 1 );
                end
            end

        end
    end
    self.buyForBtn:addTouchEventListener(onBuyItem);
  
    self.buyForBtn:setCascadeOpacityEnabled(true);
    
    if self.textCashBg == nil then
        self.textCashBg = cc.Sprite:createWithSpriteFrameName("ui/ui/bgTopBar.png")  
        self.textCashBg:setPosition(-150, 150)  
         
    end
    self:addChild(self.textCashBg)
    
    
    
    if self.textCash == nil then
        self.textCash = FacFont:getFontsBmp(FontType.FontWhite, MainValue.dataManager.userManager:getCash())     
    else
        self.textCash:setText(MainValue.dataManager.userManager:getCash())   
    end
    
    if self.IconCoin == nil then
        self.IconCoin = cc.Sprite:createWithSpriteFrameName("ui/ui/iconCoin.png")   
        self.IconCoin:setPosition(-250, 150)  
    end
    
    self:addChild(self.IconCoin)
    
    self.textCash:setScale(0.8)
    self.textCash:setPosition(-150, 156)  
    self:addChild(self.textCash)

end

function IsBuyItemPanel:showAnimation()

    local function callFunc() 
     
        if BuyFlowValue.outBuyAry ~= nil and table.maxn(BuyFlowValue.outBuyAry) > 0 then     
        
        elseif BuyFlowValue.innerBuyAry ~= nil and table.maxn(BuyFlowValue.innerBuyAry)== 1  then    
            
            MainValue.mxGameManager:buyInGamePropsSuc(BuyFlowValue.innerBuyAry[1]:getGoodsId());
            table.remove(BuyFlowValue.innerBuyAry,1)
        end
    end
    
    local btnActions = cc.Sequence:create(
    {
        cc.ScaleTo:create(0.1, 0.86,0.86),
        cc.Spawn:create(
            cc.ScaleTo:create(0.3,1.25,1.25), 
            cc.FadeOut:create(0.3)
        ),
        cc.CallFunc:create(function(node, value) 
            value.tag:onClose();
        end, {tag=self}),       
            cc.CallFunc:create(callFunc)
        
    });

    self.buyForBtn:runAction(btnActions);
    
    local duigou = cc.Sprite:createWithSpriteFrameName("ui/ui/iconTickL.png");
    duigou:setAnchorPoint(0.5,0.5);
    duigou:setScale(0.36,1.2);
    duigou:setPosition(self.buyForBtn:getPosition());
    self.buyForBtn:getParent():addChild(duigou);
    duigou:setVisible(false);
    local actions = cc.Sequence:create({
        cc.DelayTime:create(0.1),
        cc.Show:create(),
        cc.ScaleTo:create(0.1,1.763,1.763),
        cc.ScaleTo:create(0.2,0.823,0.823),
        cc.ScaleTo:create(0.2,1,1),
    });
    duigou:runAction(actions);
end


function IsBuyItemPanel:onClose()
   if self.isAloneShow then
        self:disapperAlone()
   else
        self:disapper()
   end
end

function IsBuyItemPanel:appear()    
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.POP_UP, self.appearComplete,self.disapper);
end

function IsBuyItemPanel:appearComplete()

end

function IsBuyItemPanel:appearAlone()
    self.isAloneShow = true
    MainValue.mxUIManager.panelManager:addPanelAlone(self, PanelAppearType.POP_UP, self.appearComplete,self.disapperAlone);
end

function IsBuyItemPanel:disapperAlone()
    MainValue.mxUIManager.panelManager:removePanelAlone(self,PanelDisappearType.POP_UNDER , self.disapperComplete)
end

function IsBuyItemPanel:disapper()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.POP_UNDER , self.disapperComplete)
end

function IsBuyItemPanel:disapperComplete()
--    self.isAloneShow = false
    self:removeFromParent(true);
  if  self.isOpenShop == true then
        local shop = require("ui.storeUI.StoreUI")
        local shopUI = shop.create(self.good.id)
        
        shopUI:appear(false);
        self.isOpenShop = false;
        
        if BuyFlowValue.outBuyAry~=nil and table.maxn(BuyFlowValue.outBuyAry) == 2 then -- 说明是前置道具的购买流程
            local tmpBuyFlowData = BuyFlowData.new(BuyFlowValue.storeUI)
            tmpBuyFlowData:setGoodsId(self.good.id)
            BuyFlowValue.outBuyAry[3] = tmpBuyFlowData
            
--        elseif BuyFlowValue.outBuyAry~=nil and table.maxn(BuyFlowValue.outBuyAry) == 3 then 
--            if BuyFlowValue.outBuyAry[2].typeId == BuyFlowValue.buyItemPanel then
--                
--                table.remove(BuyFlowValue.outBuyAry,3)               
--                --            print("IsBuyItemPanel::::"..BuyFlowValue.outBuyAry)  
--                
--                local playGamePanel1 = PlayGamePanel.create(MainValue.SELECTED_LEVEL);
--                playGamePanel1:appear();
--            end
        end
        
        -- 没钱购买游戏内道具
        if BuyFlowValue.innerBuyAry ~= nil and table.maxn(BuyFlowValue.innerBuyAry) == 1 then
            local tmpBuyLifeData = BuyFlowData.new(BuyFlowValue.storeUI)
            tmpBuyLifeData:setGoodsId(self.good.id)
            BuyFlowValue.innerBuyAry[2] = tmpBuyLifeData
        end
        
        
   else
   
        if BuyFlowValue.outBuyAry ~= nil and table.maxn(BuyFlowValue.outBuyAry) == 2 then -- 说明是前置道具的购买流程
--          说明购买要成功了
         
            table.remove(BuyFlowValue.outBuyAry,2)
            table.remove(BuyFlowValue.outBuyAry,1)
--            print("IsBuyItemPanel::::"..BuyFlowValue.outBuyAry)  
           
            local playGamePanel1 = PlayGamePanel.create(MainValue.SELECTED_LEVEL);
            playGamePanel1:appear();
        elseif BuyFlowValue.outBuyAry~=nil and table.maxn(BuyFlowValue.outBuyAry) == 1 then 
            if BuyFlowValue.outBuyAry[1].typeId == BuyFlowValue.playGamePanel then
                
                table.remove(BuyFlowValue.outBuyAry,1)
                --            print("IsBuyItemPanel::::"..BuyFlowValue.outBuyAry)  
               
                local playGamePanel1 = PlayGamePanel.create(MainValue.SELECTED_LEVEL);
                playGamePanel1:appear();
            end
                      
        end
        
         if BuyFlowValue.innerBuyAry ~= nil and table.maxn(BuyFlowValue.innerBuyAry) == 1 then -- 说明是内部道具的购买流程
--            购买游戏内道具成功直接用的调用
               
         end
        
        
--    elseif  self.isOpenShop == false and MainValue.isShowPlayGamePanel then  --and self.isAloneShow 
--        self.isAloneShow = false
--        
--        
--        MainValue.isShowPlayGamePanel = false
--        
--        if MainValue.outBuyAry[1]~=nil and MainValue.outBuyAry[1] ==1 then
--    --        消失开始界面

--            local playGamePanel1 = PlayGamePanel.create(MainValue.SELECTED_LEVEL);
--        
--            playGamePanel1:appear();
--        end
  end
   
end
return IsBuyItemPanel