
ItemCell = class("ItemCell",function()
        return cc.Layer:create();
end);

function ItemCell:ctor()
    self.goodsId = nil;
    self.callBack = nil;
    self.state = 0;
end


function ItemCell.create()
    local itemCell = ItemCell.new();
    itemCell:retain();
    itemCell.bg = ccui.Button:create()
    itemCell.bg:loadTextures("itemBg2.png", "itemBg2.png","",1);
    itemCell:setAnchorPoint(0,0);
    itemCell:addChild(itemCell.bg);
    

    local function onClick(sender,eventType)--   
        if eventType == ccui.TouchEventType.ended then
            if MainValue.mxGameManager:getCanClickGameUI() == true then
               itemCell.callBack(itemCell);
            end
        end
   end
   itemCell.bg:setTouchEnabled(true);
   itemCell.bg:addTouchEventListener(onClick);
   return itemCell;

end

function ItemCell:clickSelect()  
     MainValue.mxGameManager:appearItemBottomBar();
     MainValue.mxUIManager:appearSettingBar();
     MainValue.mxGameManager:useItemAni(self.goodsId);
end
function ItemCell:clickFinish()
    MainValue.mxGameManager:disappearItemBottomBar();
    MainValue.mxUIManager:resetSettingBar();
    MainValue.mxGameManager:removeItemAni();
end


--每关进入游戏 加上item动画
function ItemCell:updateAddCell(goodId)


    self.goodsId = goodId;
    local name = string.format("goods%d",goodId);
    local armature = ccs.Armature:create(name);
    armature:setName("animation");
    armature:getAnimation():playWithIndex(0);
    armature:setPosition(-2,1);
    armature:setScale(0.85)
    self:addChild(armature);
    self.armature = armature;
    
    local goodsNum =  MainValue.dataManager.goodsManager:getGoodsNumber(goodId);
    
    self:updateGoodsNum(goodsNum);
end

-- 处理物品数量显示
function ItemCell:updateGoodsNum(goodsNum)
    
    if goodsNum>0 then
        self:removeGoodsNum();
        self.num = FacFont:getFontsBmp(FontType.FontWhite,goodsNum);
        self.num:setScale(0.7);
        self.num:setPosition((self.bg:getContentSize().width/2 - 20),-self.num:getContentSize().height+22);
        self:addChild(self.num);
    else
        self:removeGoodsNum();
    end
end


function ItemCell:setTouchListener(backFun)
    self.callBack = backFun;
end

--取消使用道具  置回原状态
function ItemCell:cancelProp(index,isUsed,isExitGame)

   
   if self.armature ~= nil then
        self.armature:getAnimation():playWithIndex(0);
        --退出
        if isExitGame == true  then
            MainValue.mxGameManager:resetItemBottomBar();
            MainValue.mxUIManager:resetSettingBar();
            MainValue.mxGameManager:removeItemAni();
        else
            self:clickFinish();
        end
   end
    self.state = 0; 
    
    if  MainValue.mxFTUEManager:hasFtue()== false and isUsed == true then
        MainValue.statisticsManager:consumeBuyInGameItem( index, 1, 0, 0, MainValue.SELECTED_LEVEL, MainValue.dataManager.userManager:getHeart(), 0, MainValue.dataManager.userManager:getCash(), -1 )
        MainValue.dataManager.goodsManager:subGoods(index,1);
    end
    
    MainValue.mxGameManager:cancelBuyProp(index);
    if  MainValue.mxFTUEManager:hasFtue()== true then
        MainValue.mxFTUEManager:removeFtue();
        return;
    end
   
    
    
    
end


--使用道具状态
function ItemCell:useProp(index)
    if self.armature ~= nil then
        self.armature:getAnimation():playWithIndex(1);
    end
    MainValue.mxGameManager:useBuyPros(index);
    self.state = 1;
    self:clickSelect();
    
end


--移出道具数量.图片
function ItemCell:removeGoodsNum()
    if self.num ~= nil  then
        self.num:removeFromParent(true);
    end
end

--移出道具动画.图片
function ItemCell:removeAnimate()
      self.armature:removeFromParent(true);
     
      
end

function ItemCell:init()

end