local _failedView = nil;

local _parent = nil;

local FailedView = class("FailedView", function() 
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/InGameFailed.json")
end)

function FailedView.create(parent, callBack)
    _parent = parent;
    _failedView = FailedView.new()
    
    local desLB = _failedView:getChildByName("DesLabel");
    local desLabel = FacFont:getFontsBmp(FontType.FontRed, "No more blocks to match.");
    _failedView:addChild(desLabel);
    desLabel:setPosition(desLB:getPosition());
    desLB:removeFromParent();

    local quitBtn = _failedView:getChildByName("QuitBtn")
    local quitLB = quitBtn:getChildByName("QuitLabel")
    local quitLabel = FacFont:getFontsBmp(FontType.FontRed,"Quit")
    quitBtn:addChild(quitLabel);
    quitLabel:setPosition(quitLB:getPosition());
    quitLB:removeFromParent();

    local carryOnBtn = _failedView:getChildByName("CarryOnBtn")
    local carryOnLB = carryOnBtn:getChildByName("CarryOnLabel")
    local carryOnLabel = FacFont:getFontsBmp(FontType.FontRed,"Carry On")
    carryOnBtn:addChild(carryOnLabel);
    carryOnLabel:setPosition(carryOnLB:getPosition());
    carryOnLB:removeFromParent();
    
    local panelPlate = _failedView:getChildByName("PanelPlate")
    local goodsIcon = cc.Sprite:create("daoju/302.png")
    goodsIcon:setPosition(100,100)
    panelPlate:addChild(goodsIcon)
    
    local costLB = panelPlate:getChildByName("CostLabel")
    local costLabel = FacFont:getFontsBmp(FontType.FontRed,"350")
    panelPlate:addChild(costLabel);
    costLabel:setPosition(costLB:getPosition());
    costLB:removeFromParent(); 
    
    local closeBtn = tolua.cast(_failedView:getChildByName("QuitBtn"), "ccui.Button")
    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            callBack(_parent, true);
        end
    end
    closeBtn:addTouchEventListener(touchEvent)
    
    return _failedView;
end

return FailedView