local LoseNotEnoughScoreView = class("LoseNotEnoughScoreView", function() 
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/LoseNotEnoughScore.json")
end)

function LoseNotEnoughScoreView:ctor()
    self.myParent = nil;
    self.callBack = nil;
    
    self.iconStarBg = nil;
    self.iconStar = nil;
    self.iconCross = nil;
end

function LoseNotEnoughScoreView.create(parent, callBack)
    local temp = LoseNotEnoughScoreView.new()
    temp.myParent = parent;
    temp.callBack = callBack;
    temp:init();
    return temp;
end

function LoseNotEnoughScoreView:init()
    local closeBtn = tolua.cast(self:getChildByName("BtnClose"), "ccui.Button")
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self.callBack(self.myParent, true);
        end
    end
    closeBtn:addTouchEventListener(touchEvent)
    
    self.iconStarBg = cc.Sprite:createWithSpriteFrameName("ui/ui/bgStar.png")
    self.iconStarBg:setScale(0.8, 0.8);
    self:addChild(self.iconStarBg);
    
    self.iconStar = cc.Sprite:createWithSpriteFrameName("ui/ui/iconStarL.png")
    self.iconStar:setScale(0.8, 0.8);
    self.iconStar:setPosition(-2, 4);
    self:addChild(self.iconStar);
    
    self.iconCross = cc.Sprite:createWithSpriteFrameName("ui/ui/iconCross.png")
    self:addChild(self.iconCross)
end

return LoseNotEnoughScoreView