local LoseNotEnoughTargetView = class("LoseNotEnoughTargetView", function() 
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/LoseNotReachTarget.json")
end)

function LoseNotEnoughTargetView:ctor()
    self.myParent = nil;
    self.callBack = nil;
    
    self.carryOnBtn = nil;
end

function LoseNotEnoughTargetView.create(parent, callBack)
    local temp = LoseNotEnoughTargetView.new()
    temp.myParent = parent;
    temp.callBack = callBack;
    temp:init();
    if MainValue.mxFTUEManager ~= nil then
        MainValue.mxFTUEManager:showFtueById(1);
    end
    
    return temp;
end

function LoseNotEnoughTargetView:init()
    local quitBtn = self:getChildByName("BtnClose")
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(sender,40);
            self.callBack(self.myParent, 2);
            
            if BuyFlowValue.buyStepsAry ~= nil and table.maxn(BuyFlowValue.buyStepsAry) > 0 then
                for index = table.maxn(BuyFlowValue.buyStepsAry),0,-1 do
                    table.remove(BuyFlowValue.buyStepsAry,index)
                end                                          
            end
        end
    end
    quitBtn:addTouchEventListener(touchEvent)
    
    self.carryOnBtn = self:getChildByName("CarryOnBtn")
    self.carryOnBtn:setScale(0);
    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )
        MainValue.actionManager:createJellyAction():run(sender,40);
        
        if eventType == ccui.TouchEventType.ended then
            local toolsPrice = tonumber(MainValue.infosManager:getObjGoodsById("302").cash);
            if MainValue.dataManager.userManager:getCash() >= toolsPrice then
--                MainValue.mxGameManager:buySteps(5);--购买+5步

--                MainValue.dataManager.userManager:subCash(toolsPrice);--扣除cash
                
                ------------统计----------
                local leftCash = MainValue.dataManager.userManager:getCash();
                local leftLives = MainValue.dataManager.userManager:getHeart();
                MainValue.statisticsManager:consumeBuyStep(302, 1, 0, toolsPrice, MainValue.SELECTED_LEVEL, leftLives, 0, leftCash, -1);
                ------------

                if BuyFlowValue.buyStepsAry ~= nil and table.maxn(BuyFlowValue.buyStepsAry) > 0 then
                    for index = table.maxn(BuyFlowValue.buyStepsAry),0,-1 do
                        table.remove(BuyFlowValue.buyStepsAry,index)
                    end                                          
                end
                
                local pointBtn = self:convertToWorldSpace(cc.p(self.carryOnBtn:getPosition()));
                MainValue.mxEffectManager:showTxtFly(tostring("-" .. toolsPrice .. "coins"), FontType.FontWhite, pointBtn.x - 20, pointBtn.y + 80);
                
                self.callBack(self.myParent, 1);
            else
                if BuyFlowValue.buyStepsAry ~= nil and table.maxn(BuyFlowValue.buyStepsAry) == 1 then
                    local tmpBuyLifeData = BuyFlowData.new(BuyFlowValue.buyStepsUI)            
                    BuyFlowValue.buyStepsAry[2] = tmpBuyLifeData                                            
                end
                
                local notEnoughCashClz = require("ui/storeUI/StoreUI")
                local notEnoughCash = notEnoughCashClz.create();
                notEnoughCash:appearAlone();
                
                self.callBack(self.myParent, 0);
            end
            
            MainValue.mxFTUEManager:removeFtue();
        end
    end
    self.carryOnBtn:addTouchEventListener(touchEvent)
    
    local goodsIcon = cc.Sprite:create("ui/prop/big/302.png")
    goodsIcon:setPosition(30, 63)
    goodsIcon.currentTag = 0;
    self.carryOnBtn:addChild(goodsIcon)
    
    local conLabel = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, MainValue.infosManager:getObjMultilingualByKey("Common_passfail"));
    conLabel:setPosition(0, 155);
    self:addChild(conLabel);

    local costLabel = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjGoodsById("302").cash)
    costLabel:setPosition(212, 60);
    self.carryOnBtn:addChild(costLabel);
end

function LoseNotEnoughTargetView:setData(failData)
    local targetViewCls = require("ui.collectTarget.TargetListView")
    local targetView = targetViewCls:create(failData, true, false)
    targetView:setPosition(-186, -40)
    self:addChild(targetView)
end

function LoseNotEnoughTargetView:showBtn()
    local ac = cc.Sequence:create(cc.EaseBackOut:create(cc.ScaleTo:create(0.3, 1,1)));
    self.carryOnBtn:runAction(ac);
end

return LoseNotEnoughTargetView