require "engine.uigridtools.NineGridTools"
require "src.platform.FBSharedType"

local InboxCell = class("InboxCell", function()
    return ccui.Layout:create();
end)

function InboxCell:ctor()
    self.bg = nil;
    
    self.headIcon = nil;
    self.headFrame = nil;
    self.bgRound = nil;
    self.typeIcon = nil;
    
    self.friId = nil;
    self.friPicture = nil;
    
    self.nameLabel = nil;
    self.desLabel = nil;
    
    self.checkBox = nil;
    self.isSelected = true;
    
    self.mesData = nil;
    
    self.callBackData = nil;--取消选中回调数据
    
    self.CMD = {ENERGY = "energy", FREE = "free"}
    
    self._CMD = {HELP = "help", ACCEPT = "accept", SEND = "send", CASH = "cash", ENERGY = "energy", ITEM = "item"}
end

function InboxCell.create(mesData, callBackData)
    local temp = InboxCell.new();
    
    temp.mesData = mesData;
    temp.callBackData = callBackData;
    
    temp:init();
    return temp;
end

function InboxCell:init()
    self.bg = ccui.Button:create("ui/ui/bgCell1.png", "ui/ui/bgCell2.png", "", 1);
    self.bg:setScale9Enabled(true);
    self.bg:setContentSize(529, 138);
    self.bg:setPositionX(20);
    self.bg:setAnchorPoint(0, 0);
    self:addChild(self.bg);
    
    local function clickHandler(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            self:replyMessage();
            self.callBackData.updataFun(self.callBackData.selfObj);
        end
    end
    self.bg:addTouchEventListener(clickHandler)
    
    self.nameLabel = FacFont:getFontsBmp(FontType.FontYellowNoSide, self.mesData.from_username .. ":", 260, "L");
    self.nameLabel:setAnchorPoint(0, 0.5);
    self.nameLabel:setPosition(141, 113);
    self:addChild(self.nameLabel);
    
    local mesStr = self:getInboxMes();
    self.desLabel = FacFont:getFontsBmp(FontType.FontYellowNoSide, mesStr , 289, "L", -16);
    self.desLabel:setAnchorPoint(0, 0.5);
    self.desLabel:setPosition(146, 56);
    self:addChild(self.desLabel);
    
    local function selectedEvent(sender,eventType)
        if eventType == ccui.CheckBoxEventType.selected then
            self.isSelected = true;
        elseif eventType == ccui.CheckBoxEventType.unselected then
            self.isSelected = false;
            
            self.callBackData.callFun(self.callBackData.selfObj);
        end
    end  

    self.checkBox = ccui.CheckBox:create()
    self.checkBox:setTouchEnabled(true)
    self.checkBox:setSelected(true);
    self.checkBox:loadTextures("ui/ui/bgBoxL.png",
        "ui/ui/bgBoxL.png",
        "ui/ui/iconTickL.png",
        nil,nil, 1)
    self.checkBox:setPosition(459, 45);
    self.checkBox:setAnchorPoint(0, 0);
    self:addChild(self.checkBox);
    
    self.checkBox:addEventListener(selectedEvent)  
    
    if self.mesData.cmd == "energy" then
        self:initEnergy();
    elseif self.mesData.cmd == "free" then
        self:initCompensation();
    end
    
    self:setContentSize(529, 138);
    self:setAnchorPoint(0, 1);
end

--初始化赠送能量邮件信息
function InboxCell:initEnergy()
    local function friHeadFunc(id, url)
        self.headIcon:release();
    end

    self.friId = self.mesData.from_id;
    self.friPicture = MainValue.dataManager.friendManager:getPictureById(self.friId);

    --------本地测试------
--    self.friId = "1508293926112547" 
--    self.friPicture = "https://fbcdn-profile-a.akamaihd.net/hprofile-ak-xfa1/v/t1.0-1/c22.0.100.100/p100x100/10574420_1445441729064434_8819031542387145715" ..
--        "_n.jpg?oh=ac4277ec999d7c9b7c69a1dade357ad2&oe=5510BAC8&__gda__=1430616702_c4ceaeed368ee8ead67fc1cb70cc9480"

    local spr = cc.Layer:create()
    spr:setContentSize(130, 130)
    spr:setAnchorPoint(0.5, 0.5)
    spr:setPosition(63, 62);
    spr:setRotation(-10);
    self:addChild(spr);

    self.headIcon = cc.Sprite:create();
    self.headIcon:setContentSize(95, 95);
    self.headIcon:setPosition(-3, 20);
    self.headIcon:retain();
    spr:addChild(self.headIcon);

    if self.friPicture ~= nil then
        MainValue.platformManager:FBloadImage(self.friId, self.friPicture, self.headIcon, friHeadFunc);
    end

    self.headFrame = NineGridTools.create("ui/ui/bgFrameS.png" , 130 , 130 , 32);
    --    self.headFrame:setPosition(-18, 105);
    --    self.headFrame:setRotation(-10);
    spr:addChild(self.headFrame); 

    self.bgRound = cc.Sprite:createWithSpriteFrameName("ui/ui/bgInboxIcon.png");
    self.bgRound:setPosition(121, 34);
    self:addChild(self.bgRound);

    self.typeIcon = self:getTypeIcon();
    self.bgRound:addChild(self.typeIcon);
end

--初始化补偿邮件信息
function InboxCell:initCompensation()
    local spr = cc.Layer:create()
    spr:setContentSize(130, 130)
    spr:setAnchorPoint(0.5, 0.5)
    spr:setPosition(63, 62);
    spr:setRotation(-10);
    self:addChild(spr);
    
    self.headIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/head6.png");
    self.headIcon:setContentSize(82, 82);
    self.headIcon:setPosition(-4, 20);
    self.headIcon:setScale(1.5);
    spr:addChild(self.headIcon);

    self.headFrame = NineGridTools.create("ui/ui/bgFrameS.png" , 130 , 130 , 32);
    spr:addChild(self.headFrame); 

    self.typeIcon = self:getTypeIcon();
    self.typeIcon:setPosition(53, -33);
    spr:addChild(self.typeIcon);
end

function InboxCell:replyMessage()
    local function callBack()
        if self.mesData.cmd == self.CMD.ENERGY then
            if self.mesData._cmd == self._CMD.HELP then
                MainValue.fbManager:askHeartResp(self.mesData.from_id); --回应请求心
            elseif self.mesData._cmd == self._CMD.ACCEPT or self.mesData._cmd == self._CMD.SEND then
                MainValue.dataManager.userManager:addHeart(1);
            end
        elseif self.mesData.cmd == self.CMD.FREE then
            if self.mesData._cmd == self._CMD.CASH then
                MainValue.dataManager.userManager:addCash(tonumber(self.mesData.param_num));
            elseif self.mesData._cmd == self._CMD.ENERGY then
                MainValue.dataManager.userManager:addHeart(tonumber(self.mesData.param_num));
            elseif self.mesData._cmd == self._CMD.ITEM then
                MainValue.dataManager.goodsManager:addGoods(self.mesData.param_id, tonumber(self.mesData.param_num))
            end
        end
        MainValue.fbManager:deleteMessage(self.mesData.request_id);
    end
    
    MainValue.fbManager:isLoginByCallback(callBack);
end

function InboxCell:getInboxMes()
    local mesStr = nil;

    if self.mesData.cmd == self.CMD.ENERGY then
        if self.mesData._cmd == self._CMD.HELP then
            mesStr = FBInboxMessage.energy_help;
        elseif self.mesData._cmd == self._CMD.SEND then
            mesStr = FBInboxMessage.energy_send;
        elseif self.mesData._cmd == self._CMD.ACCEPT then
            mesStr = FBInboxMessage.energy_accept;
        end
    elseif self.mesData.cmd == self.CMD.FREE then
        if self.mesData._cmd == self._CMD.CASH then
            mesStr = FBInboxMessage.free_cash;
            mesStr = string.gsub(mesStr, "{cashNum}", tostring(self.mesData.param_num));
        elseif self.mesData._cmd == self._CMD.ENERGY then
            mesStr = FBInboxMessage.free_energy;
            mesStr = string.gsub(mesStr, "{energyNum}", tostring(self.mesData.param_num));
        elseif self.mesData._cmd == self._CMD.ITEM then
            mesStr = FBInboxMessage.free_item;
            mesStr = string.gsub(mesStr, "{itemNum}", tostring(self.mesData.param_num));
            
            local goodsName = MainValue.infosManager:getObjGoodsById(self.mesData.param_id).name;
            mesStr = string.gsub(mesStr, "{itemName}", goodsName);
        end
    end
    return mesStr;
end

function InboxCell:getTypeIcon()
    local iconPic = nil;
    if self.mesData.cmd == self.CMD.ENERGY then
        iconPic = cc.Sprite:createWithSpriteFrameName("ui/ui/iconHeart2.png");
        iconPic:setScale(0.6);
        iconPic:setRotation(25);
        iconPic:setPosition(22, 24)
    elseif self.mesData.cmd == self.CMD.FREE then
        if self.mesData._cmd == self._CMD.ENERGY then
            iconPic = cc.Sprite:createWithSpriteFrameName("ui/ui/iconHeart2.png");
            iconPic:setScale(0.9);
        elseif self.mesData._cmd == self._CMD.CASH then
            iconPic = cc.Sprite:createWithSpriteFrameName("ui/ui/iconCoin.png");
            iconPic:setScale(0.8)
        elseif self.mesData._cmd == self._CMD.ITEM then
            iconPic = cc.Sprite:create("ui/prop/big/".. self.mesData.param_id .. ".png");
            iconPic:setScale(0.5)
        end
    end
    return iconPic;
end

function InboxCell:getData()
    return self.mesData;
end

function InboxCell:setSelect(boo)
    self.isSelected = boo;
    self.checkBox:setSelected(boo);
end

function InboxCell:getSelect()
    return self.isSelected;
end

return InboxCell;