require "engine.uigridtools.NineGridTools"

---------------
-- 送能量邮箱信息
---------------
local InboxEnergyCell = class("InboxEnergyCell", function()
    return ccui.Layout:create();
end)

function InboxEnergyCell:ctor()
	self.bg = nil;
	
	self.heartIcon = nil;
	
	self.receiveBtn = nil;
	
    self.mesData = nil;
    self.callBackData = nil;--取消选中回调数据
end

function InboxEnergyCell.create(mesData, callBackData)
    local temp = InboxEnergyCell.new();

    temp.mesData = mesData;
    temp.callBackData = callBackData;
    
    temp:init();
    return temp;
end

function InboxEnergyCell:init()

    self.bg = NineGridTools.create("ui/ui/bgCell1.png" , 479 , 138 , 30);
    self.bg:setPosition(237, 60);
    self.bg:setAnchorPoint(0, 0);
    self:addChild(self.bg); 
    
    self.heartIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/iconHeart2.png");
    self.heartIcon:setPosition(36, 103);
    self.heartIcon:setScale(0.8);
    self:addChild(self.heartIcon);
    
    local desStr = self:getDesString();
    
    self.desLabel = FacFont:getFontsBmp(FontType.FontYellowNoSide, desStr , 401, "L", -14);
    self.desLabel:setAnchorPoint(0, 0.5);
    self.desLabel:setPosition(74, 106);
    self:addChild(self.desLabel);
    
    if self.mesData[1]._cmd == "help" then
        self.receiveBtn = ccui.Button:create("ui/ui/btnYellow1.png", "ui/ui/btnYellow2.png","" ,1);
        self.receiveBtn:setScaleY(0.5)
        self.receiveBtn:setPosition(381, 47);
        self:addChild(self.receiveBtn);

        self.receiveBtnTxt = FacFont:getFontsBmp(FontType.FontWhite, "Send");
        self.receiveBtnTxt:setScale(0.7)
        self.receiveBtnTxt:setPosition(380, 53);
        self:addChild(self.receiveBtnTxt);
    else
        self.receiveBtn = ccui.Button:create("ui/ui/btnBlue1.png", "ui/ui/btnBlue2.png","" ,1);
        self.receiveBtn:setScaleY(0.5)
        self.receiveBtn:setPosition(381, 47);
        self:addChild(self.receiveBtn);
        
        self.receiveBtnTxt = FacFont:getFontsBmp(FontType.FontWhite, "Accept");
        self.receiveBtnTxt:setScale(0.7)
        self.receiveBtnTxt:setPosition(380, 50);
        self:addChild(self.receiveBtnTxt);
    end
    
    local function clickHandler(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            if self.mesData[1]._cmd == "help" then
                self:replySendMessage();
            else
                self:replyAcceptMessage();
            end
            
            self.callBackData.updataFun(self.callBackData.selfObj);
        end
    end
    self.receiveBtn:addTouchEventListener(clickHandler)
    
    for i = 1, #self.mesData do
        self.friId = self.mesData[i].from_id;
        self.friPicture = MainValue.dataManager.friendManager:getPictureById(self.friId);

        
        --------本地测试------
--        self.friId = "1508293926112547" 
--        self.friPicture = "https://fbcdn-profile-a.akamaihd.net/hprofile-ak-xfa1/v/t1.0-1/c22.0.100.100/p100x100/10574420_1445441729064434_8819031542387145715" ..
--            "_n.jpg?oh=ac4277ec999d7c9b7c69a1dade357ad2&oe=5510BAC8&__gda__=1430616702_c4ceaeed368ee8ead67fc1cb70cc9480"
        
        local headIcon = cc.Sprite:create();
        headIcon:setContentSize(36, 36);
        headIcon:setPosition(28 + i * 50, 50);
        headIcon:retain();
        self:addChild(headIcon);
        
        local function friHeadFunc(id, url)
            headIcon:release();
        end
        
        MainValue.platformManager:FBloadImage(self.friId, self.friPicture, headIcon, friHeadFunc);

        
        local headFrame = cc.Sprite:createWithSpriteFrameName("ui/ui/imgHeadFrame.png");
        headFrame:setPosition(28 + i * 50, 48);
        self:addChild(headFrame); 
    
    end
    
    self:setContentSize(509, 138);
    self:setAnchorPoint(0, 1);
end

function InboxEnergyCell:getDesString()
    local dataLen = #self.mesData;
    local desString = nil;
    
    if self.mesData[1]._cmd == "help" then
        if dataLen > 1 then
            desString = MainValue.infosManager:getObjMultilingualByKey("Inbox_Ask_Hearts");
            desString = string.gsub(desString, "/friCount/", tostring(dataLen - 1));
        else
            desString = MainValue.infosManager:getObjMultilingualByKey("Inbox_Ask_A_Heart");
            
        end
    else
        if dataLen > 1 then
            desString = MainValue.infosManager:getObjMultilingualByKey("Inbox_Send_Hearts");
            desString = string.gsub(desString, "/friCount/", tostring(dataLen - 1));
        else
            desString = MainValue.infosManager:getObjMultilingualByKey("Inbox_Send_A_Heart");
            
        end
    end
    
    desString = string.gsub(desString, "/friName/", tostring(self.mesData[1].from_username));
    
    return desString;
end

function InboxEnergyCell:replySendMessage()
    local function callBack()
        for i = 1, #self.mesData do
            MainValue.fbManager:askHeartResp(self.mesData[i].from_id); --回应请求心
            MainValue.fbManager:deleteMessage(self.mesData[i].request_id);
        end
    end

    MainValue.fbManager:isLoginByCallback(callBack);
end

function InboxEnergyCell:replyAcceptMessage()
    local function callBack()
        for i = 1, #self.mesData do
            if MainValue.dataManager.userManager:getHeart() < 5 then
                MainValue.dataManager.userManager:addHeart(1);--加心
            end
            MainValue.fbManager:deleteMessage(self.mesData[i].request_id);
        end
    end

    MainValue.fbManager:isLoginByCallback(callBack);
end

return InboxEnergyCell;