require "engine.uigridtools.NineGridTools"

---------------
-- 补偿邮箱信息
---------------
local InboxFreeCell = class("InboxFreeCell", function()
    return ccui.Layout:create();
end)

function InboxFreeCell:ctor()
    self.bg = nil;
    
    self.headIcon = nil;
    self.headFrame = nil;
    self.bgRound = nil;
    self.typeIcon = nil;
    
    self.friId = nil;
    self.friPicture = nil;
    
    self.nameLabel = nil;
    self.desLabel = nil;
    
    self.checkBox = nil;
    self.isSelected = true;
    
    self.mesData = nil;
    
    self.callBackData = nil;--取消选中回调数据
    
    
    self.CMD = {ENERGY = "energy", FREE = "free"} -- ENERGY：能量   FREE：补偿
    
    --HELP:好友请求   ACCEPT:好友答应要心请求  SEND：好友主动送心
    self._CMD = {HELP = "help", ACCEPT = "accept", SEND = "send", CASH = "cash", ENERGY = "energy", ITEM = "item"} 
end

function InboxFreeCell.create(mesData, callBackData)
    local temp = InboxFreeCell.new();
    
    temp.mesData = mesData;
    temp.callBackData = callBackData;
    
    temp:init();
    return temp;
end

function InboxFreeCell:init()
    self.bg = NineGridTools.create("ui/ui/bgCell1.png" , 479 , 138 , 30);
    self.bg:setPosition(237, 60);
    self.bg:setAnchorPoint(0, 0);
    self:addChild(self.bg); 
    
    self.nameLabel = FacFont:getFontsBmp(FontType.FontYellowNoSide, self.mesData.from_username .. ":", 260, "L");
    self.nameLabel:setAnchorPoint(0, 0.5);
    self.nameLabel:setPosition(141, 120);
    self:addChild(self.nameLabel);
    
    local mesStr = self:getInboxMes();
    self.desLabel = FacFont:getFontsBmp(FontType.FontYellowNoSide, mesStr , 289, "L", -16);
    self.desLabel:setAnchorPoint(0, 0.5);
    self.desLabel:setPosition(136, 96);
    self:addChild(self.desLabel);
    
    local spr = cc.Layer:create()
    spr:setContentSize(130, 130)
    spr:setAnchorPoint(0.5, 0.5)
    spr:setPosition(53, 67);
    spr:setRotation(-10);
    self:addChild(spr);

    self.headIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/head6.png");
    self.headIcon:setContentSize(82, 82);
    self.headIcon:setPosition(-4, 20);
    self.headIcon:setScale(1.2);
    spr:addChild(self.headIcon);

    self.headFrame = NineGridTools.create("ui/ui/bgFrameS.png" , 110 , 110 , 32);
    spr:addChild(self.headFrame); 

    self.typeIcon = self:getTypeIcon();
    self.typeIcon:setPosition(43, -28);
    spr:addChild(self.typeIcon);
    
    self.receiveBtn = ccui.Button:create("ui/ui/btnBlue1.png", "ui/ui/btnBlue2.png","" ,1);
    self.receiveBtn:setScaleY(0.5)
    self.receiveBtn:setPosition(381, 47);
    self:addChild(self.receiveBtn);

    self.receiveBtnTxt = FacFont:getFontsBmp(FontType.FontWhite, "Accept");
    self.receiveBtnTxt:setScale(0.7)
    self.receiveBtnTxt:setPosition(380, 53);
    self:addChild(self.receiveBtnTxt);

    local function clickHandler(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            self:replyMessage();
            self.callBackData.updataFun(self.callBackData.selfObj);
        end
    end
    self.receiveBtn:addTouchEventListener(clickHandler)
        
    self:setContentSize(479, 138);
    self:setAnchorPoint(0, 1);
end


function InboxFreeCell:replyMessage()
    local function callBack()
        if self.mesData.cmd == self.CMD.FREE then
            if self.mesData._cmd == self._CMD.CASH then
                MainValue.dataManager.userManager:addCash(tonumber(self.mesData.param_num));
            elseif self.mesData._cmd == self._CMD.ENERGY then
                MainValue.dataManager.userManager:addHeart(tonumber(self.mesData.param_num));
            elseif self.mesData._cmd == self._CMD.ITEM then
                MainValue.dataManager.goodsManager:addGoods(self.mesData.param_id, tonumber(self.mesData.param_num))
            end
        end
        MainValue.fbManager:deleteMessage(self.mesData.request_id);
    end
    
    MainValue.fbManager:isLoginByCallback(callBack);
end

function InboxFreeCell:getInboxMes()
    local mesStr = nil;

    if self.mesData.cmd == self.CMD.FREE then
        if self.mesData._cmd == self._CMD.CASH then
            mesStr = FBInboxMessage.free_cash;
            mesStr = string.gsub(mesStr, "{cashNum}", tostring(self.mesData.param_num));
        elseif self.mesData._cmd == self._CMD.ENERGY then
            mesStr = FBInboxMessage.free_energy;
            mesStr = string.gsub(mesStr, "{energyNum}", tostring(self.mesData.param_num));
        elseif self.mesData._cmd == self._CMD.ITEM then
            mesStr = FBInboxMessage.free_item;
            mesStr = string.gsub(mesStr, "{itemNum}", tostring(self.mesData.param_num));
            
            local goodsName = MainValue.infosManager:getObjGoodsById(self.mesData.param_id).name;
            mesStr = string.gsub(mesStr, "{itemName}", goodsName);
        end
    end
    
    return mesStr;
end

function InboxFreeCell:getTypeIcon()
    local iconPic = nil;
    if self.mesData.cmd == self.CMD.FREE then
        if self.mesData._cmd == self._CMD.ENERGY then
            iconPic = cc.Sprite:createWithSpriteFrameName("ui/ui/iconHeart2.png");
            iconPic:setScale(0.8)
        elseif self.mesData._cmd == self._CMD.CASH then
            iconPic = cc.Sprite:createWithSpriteFrameName("ui/ui/iconCoin.png");
            iconPic:setScale(0.8)
        elseif self.mesData._cmd == self._CMD.ITEM then
            iconPic = cc.Sprite:create("ui/prop/big/".. self.mesData.param_id .. ".png");
            iconPic:setScale(0.5)
        end
    end
    return iconPic;
end

return InboxFreeCell;