local InboxPanel = class("InboxPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/Inbox.json")
end);

function InboxPanel:ctor()
    self.title = nil;
    self.closeBtn = nil;
    
    self.listView = nil;
    
    self.noMesDes = nil;
    
    self.isHaveMes = true;
    
    self.curClickIndex = nil;--本次点击项目索引
    
    self.mesList = nil; --所有Inbox信息
    
    self.sendList = {}; --好友送心给自己信息
    self.askList = {}; --好友请求送心信息
    self.giftList = {}; --补偿信息
    
    self.callBackData = {}; --各条项目点击事件回调
    
    self.acceptBlockIds = nil;--接受block请求好友id数组
    self.acceptHeartNum = 0;--接受好友送心数
    
    self.isClickInvite = false; --是否点击邀请好友
end

function InboxPanel.create(data)
    local temp = InboxPanel.new();
    temp.mesList = data;

    --------本地测试------
--    temp.mesList = 
--        {
--            {cmd = "energy", _cmd = "help",param_id = 30, from_id = "1423774147", from_username="xiaoming3", requset_id="754672827919806_583896511715508"},
--            {cmd = "energy", _cmd = "accept",param_id = 30, from_id = "1423774147", from_username="xiaoming4", requset_id="754672827919806_583896511715508"},
--            {cmd = "energy", _cmd = "send",param_id = 30, from_id = "1423774147", from_username="xiaoming7", requset_id="754672827919806_583896511715508"},
--            {cmd = "energy", _cmd = "help",param_id = 30, from_id = "1423774147", from_username="xiaoming3", requset_id="754672827919806_583896511715508"},
--            {cmd = "energy", _cmd = "accept",param_id = 30, from_id = "1423774147", from_username="xiaoming4", requset_id="754672827919806_583896511715508"},
--            {cmd = "energy", _cmd = "send",param_id = 30, from_id = "1423774147", from_username="xiaoming7", requset_id="754672827919806_583896511715508"},
--            {cmd = "energy", _cmd = "help",param_id = 30, from_id = "1423774147", from_username="xiaoming3", requset_id="754672827919806_583896511715508"},
--            {cmd = "energy", _cmd = "accept",param_id = 30, from_id = "1423774147", from_username="xiaoming4", requset_id="754672827919806_583896511715508"},
--            {cmd = "energy", _cmd = "send",param_id = 30, from_id = "1423774147", from_username="xiaoming7", requset_id="754672827919806_583896511715508"},
--            {cmd = "energy", _cmd = "help",param_id = 30, from_id = "1423774147", from_username="xiaoming3", requset_id="754672827919806_583896511715508"},
--            {cmd = "energy", _cmd = "help",param_id = 30, from_id = "1423774147", from_username="xiaoming3", requset_id="754672827919806_583896511715508"},
--            {cmd = "energy", _cmd = "help",param_id = 30, from_id = "1423774147", from_username="xiaoming3", requset_id="754672827919806_583896511715508"},
--            {cmd = "free", _cmd = "item",param_id = "1", from_id = "1423774147", param_num = "4",from_username="system", requset_id="754672827919806_583896511715508"},
--            {cmd = "free", _cmd = "energy",param_id = 30, from_id = "1423774147", param_num = "2",from_username="system", requset_id="754672827919806_583896511715508"},
--            {cmd = "free", _cmd = "cash",param_id = 30, from_id = "1423774147", param_num = "3",from_username="system", requset_id="754672827919806_583896511715508"}
--        }
        
    temp:initData();
    temp:init();
    return temp;
end

function InboxPanel:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);

    self.title = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,MainValue.infosManager:getObjMultilingualByKey("InboxPanel_title"))
    self.title:setPosition(0, 412)
    self:addChild(self.title)

    self.closeBtn = self:getChildByName("BtnClose");
    local function closeHandler( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:onClose();
        end
    end
    self.closeBtn:addTouchEventListener(closeHandler)
    
    self.listView = self:getChildByName("ListView");
    self.listView:setItemsMargin(-5)
--    self.listView:setDirection(ccui.ScrollViewDir.horizontal);

    local function listViewEvent(sender, eventType)
        if eventType == ccui.ListViewEventType.ONSELECTEDITEM_START then
            self.curClickIndex = sender:getCurSelectedIndex();
        end
    end
    
    self.listView:addEventListener(listViewEvent)
    
    self.callBackData.updataFun = self.updataListView;
    self.callBackData.selfObj = self;
    
    
    local len = table.getn(self.mesList);
    if len > 0 then
        local formatData = nil;
        if #self.sendList > 0 then
            formatData = self:getFormatData(self.sendList);
            
            for i = 1, #formatData do
                local cellCls = require("ui.inbox.InboxEnergyCell");
                local cell = cellCls.create(formatData[i], self.callBackData);
                self.listView:addChild(cell);
            end
        end
        
        if #self.askList > 0 then
            formatData = self:getFormatData(self.askList);

            for i = 1, #formatData do
                local cellCls = require("ui.inbox.InboxEnergyCell");
                local cell = cellCls.create(formatData[i], self.callBackData);
                self.listView:addChild(cell);
            end
        end
        
        if #self.giftList > 0 then
            for i = 1, #self.giftList do
                local cellCls = require("ui.inbox.InboxFreeCell");
                local cell = cellCls.create(self.giftList[i], self.callBackData);
                self.listView:addChild(cell);
            end
        end
    else
        local function clickInvite(isClickInvite)
            self.isClickInvite = isClickInvite;
            self:disapper();
        end
        local askCellCls = require("src.ui.inbox.InboxAskFriCell");
        local askCell = askCellCls.create(clickInvite);
        self.listView:addChild(askCell);
        
        if not MainValue.dataManager.expandManager:getIsSendInboxHearts() and MainValue.dataManager.friendManager:getFriends() ~= nil then
            local sendCellCls = require("src.ui.inbox.InboxSendCell"); --待完成
            local sendCell = sendCellCls.create(self.callBackData);
            self.listView:addChild(sendCell);
        end
    end
end

--初始化 处理信息数据
function InboxPanel:initData()

    local len = table.getn(self.mesList);
    
    for i = 1, len do
        local data = self.mesList[i];

        if data.cmd == "energy" then
        
            if data._cmd == "accept" or data._cmd == "send" then
                table.insert(self.sendList, data);
                
            elseif data._cmd == "help" then
                table.insert(self.askList, data);
            end
            
        elseif data.cmd == "free" then
        
            table.insert(self.giftList, data);
        end
    end
    
end

--将信息数据分为五个一组
function InboxPanel:getFormatData(argArr)
    local len = table.getn(argArr);
    if len <= 0 then return end;
    
    local formatArr = {};
    
    local index = math.ceil(len / 5);
    
    local count = 0;
    local groupData = {}; --将数据分成五个一组
    for i = 1, len do 
        count = count + 1;
        table.insert(groupData, argArr[i])
        
        if count == 5 then
            count = 0;
            table.insert(formatArr, groupData);
            
            groupData = {};
        end
    end
    
    if count > 0 and count < 5 then
        table.insert(formatArr, groupData);
    end
    
    return formatArr;
end

--消息处理完毕
function InboxPanel:changeNoMes()
    self.isHaveMes = false;
    
    self:disapper();
end

--[[点击子项目选中区域，删除该子项目（回调）]]--
function InboxPanel:updataListView()
    self.listView:removeItem(self.curClickIndex);
    
    if self.listView:getChildrenCount() <= 0 then
        self:changeNoMes();
    end
end

function InboxPanel:onClose()
    self:disapper();
end

function InboxPanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disapper);
end

function InboxPanel:appearComplete()

end

function InboxPanel:disapper()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_DOWN , self.disapperComplete)
end

function InboxPanel:disapperComplete()
    MainValue.mxUIManager:updataInboxMesNum();--更新地图上inbox的消息数量
    
    if self.isClickInvite then
        local inviteClz = require("ui.inviteFriends.InviteFriendsPanel")
        local inviteFrisPanel = inviteClz.create();
        inviteFrisPanel:appearAlone();
    end
    
    self:removeFromParent(true);
end

return InboxPanel