require "engine.uigridtools.NineGridTools"

---------------
-- 送多个好友体力信息
---------------
local InboxSendCell = class("InboxSendCell", function()
    return ccui.Layout:create();
end)

function InboxSendCell:ctor()
    self.bg = nil;
    
    self.desTxt = nil;
    
    self.sendBtn = nil;
    
    self.mesData = {};
    self.callBackData = nil;--取消选中回调数据
end

function InboxSendCell.create(callBackData)
    local temp = InboxSendCell.new();

    temp.callBackData = callBackData;
    
    temp:init();
    return temp;
end

function InboxSendCell:init()

    self.bg = NineGridTools.create("ui/ui/bgCell1.png" , 479 , 138 , 30);
    self.bg:setPosition(237, 60);
    self.bg:setAnchorPoint(0, 0);
    self:addChild(self.bg); 
    

    self.desTxt = FacFont:getFontsBmp(FontType.FontYellowNoSide, "Friends need your help!" , 401, "L", -14);
    self.desTxt:setAnchorPoint(0, 0.5);
    self.desTxt:setPosition(10, 46);
    self:addChild(self.desTxt);

    self.mesData =  MainValue.dataManager.friendManager:getRandomFiveFriendsIds(); --随机获取最多五名好友，送心
    
    for i = 1, #self.mesData do
        self.friId = self.mesData[i];
        self.friPicture = MainValue.dataManager.friendManager:getPictureById(self.friId);


        --------本地测试------
--        self.friId = "1562686467339959" 
--        self.friPicture = "https:\/\/fbcdn-profile-a.akamaihd.net\/hprofile-ak-xfa1\/v\/t1.0-1\/c22.0.100.100\/p100x100\/10574420_1445441729064434_8819031542387145715_n.jpg?oh=1775f4c537f7010be39a1eec08c15000&oe=562595C8&__gda__=1446168702_dbf9179b7097fb93c7fd2c3bb273bf06"

        local headIcon = cc.Sprite:create();
        headIcon:setContentSize(55, 55);
        headIcon:setPosition(-20 + i * 65, 101);
        headIcon:retain();
        self:addChild(headIcon);

        local function friHeadFunc(id, url)
            headIcon:release();
        end

        MainValue.platformManager:FBloadImage(self.friId, self.friPicture, headIcon, friHeadFunc);


        local headFrame = cc.Sprite:createWithSpriteFrameName("ui/ui/bgHeadInbox.png");
        headFrame:setPosition(-20 + i * 65, 100);
        self:addChild(headFrame); 

    end

    self.sendBtn = ccui.Button:create("ui/ui/btnGreen1.png", "ui/ui/btnGreen2.png","" ,1);
    self.sendBtn:setScaleY(0.5)
    self.sendBtn:setPosition(391, 47);
    self:addChild(self.sendBtn);

    self.sendBtnTxt = FacFont:getFontsBmp(FontType.FontWhite, "Send");
    self.sendBtnTxt:setScale(0.7)
    self.sendBtnTxt:setPosition(390, 53);
    self:addChild(self.sendBtnTxt);


    local function clickHandler(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
        
            self:replySendMessage();

            self.callBackData.updataFun(self.callBackData.selfObj);
        end
    end
    self.sendBtn:addTouchEventListener(clickHandler)
    
    self:setContentSize(509, 138);
    self:setAnchorPoint(0, 1);
end

function InboxSendCell:replySendMessage()
    local function callBack()
        MainValue.fbManager:sendHeart(self.mesData);
        
        print("Inbox Send Hearts Set")
        MainValue.dataManager.expandManager:setHasSendInboxHearts();
        
        print("Inbox Send Hearts Set Complete")
    end
    

    MainValue.fbManager:isLoginByCallback(callBack);
end

return InboxSendCell;