require "engine.uigridtools.ThreeLMRGridTools"
require "engine.uigridtools.NineGridTools"

local InviteFriendsPanel = class("InviteFriendsPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/AskForHelp.json");
end)

function InviteFriendsPanel:ctor()
    self.titleLab = nil;
    self.selLab = nil;
    self.inviteLab = nil;

    self.windowBg = nil;
    self.upBoundBg = nil;
    self.underBoundBg = nil;

    self.sendFriIds = nil;--发送请求的好友列表
    
    self.allListView = nil;
end

function InviteFriendsPanel.create()
    local temp = InviteFriendsPanel.new();
    temp:init();
    return temp;
end

function InviteFriendsPanel:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);

    self.upBoundBg = ThreeLMRGridTools.create("ui/ui/bgUpBound.png", 478, 33);
    self.upBoundBg:setPositionY(233);
    self:addChild(self.upBoundBg);

    self.underBoundBg = ThreeLMRGridTools.create("ui/ui/bgDownBound.png", 478, 33);
    self.underBoundBg:setPositionY(-258);
    self:addChild(self.underBoundBg);
    local titleStr = MainValue.infosManager:getObjMultilingualByKey("GlobeRank_panel_inviteFri");

    self.titleLab = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, titleStr)
    self.titleLab:setPositionY(396);
    self:addChild(self.titleLab);

    self.selLab = FacFont:getFontsBmp(FontType.FontRed, MainValue.infosManager:getObjMultilingualByKey("PanelFirst1_2"))
    self.selLab:setScale(0.8)
    self.selLab:setPosition(26, -310);
    self:addChild(self.selLab);

    local closebtn = self:getChildByName("BtnClose");
    local function closeTouchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            if self.isAloneShow then
                self:disapperAlone();
            else
                self:disapper();
            end
        end
    end
    closebtn:addTouchEventListener(closeTouchEvent);

    self.inviteBtn = self:getChildByName("BtnInvite");
    self.inviteLab = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("InviteFriends_btn"))
    self.inviteLab:setPosition(118, 64);
    self.inviteBtn:addChild(self.inviteLab);

    local function inviteTouchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            local function cf()
            end
            MainValue.actionManager:createJellyAction():run(sender,40,cf);

            self:sendMes();
        end
    end
    self.inviteBtn:addTouchEventListener(inviteTouchEvent);

    self.checkBox = self:getChildByName("CheckBoxAll");
    self.checkBox:setSelected(true);

    local function selectedEvent(sender, eventType)
        if eventType == ccui.CheckBoxEventType.selected then
            self:setCheckBoxSelect(true);
        elseif eventType == ccui.CheckBoxEventType.unselected then
            self:setCheckBoxSelect(false);
        end
    end
    self.checkBox:addEventListener(selectedEvent) 

    local function cellClickCallBack()
        self:setSelectState();
    end
    
    local inviteFriendsWindowClz = require("ui.inviteFriends.InviteFriendsWindow");
    self.allListView = inviteFriendsWindowClz.create(cellClickCallBack);
    self.allListView:setPosition(-254, -223)
    self:addChild(self.allListView);
end

--更新全选状态
function InviteFriendsPanel:setSelectState()
    if self.allListView:getSelectedState() == 0 then
        self:setBtnBright(false);
        self.checkBox:setSelected(false);

    elseif self.allListView:getSelectedState() == 1 then
        self:setBtnBright(true);
        self.checkBox:setSelected(true);

    elseif self.allListView:getSelectedState() == 2 then
        self:setBtnBright(true);
        self.checkBox:setSelected(false);
    end
end

function InviteFriendsPanel:setCheckBoxSelect(boo)
    self.allListView:setSelect(boo);
    self:setBtnBright(boo);
end

function InviteFriendsPanel:setBtnBright(boo)
    self.inviteBtn:setTouchEnabled(boo)
    self.inviteBtn:setBright(boo)
end

--发送请求消息
function InviteFriendsPanel:sendMes()
    self.sendFriIds = self.allListView:getSendFris();

    if self.sendFriIds ~= nil then
        local len = table.maxn(self.sendFriIds);

        if len > 50 then  --最多只能同时发送50个好友，做限制
            local sendTeamFifty = {};
            local friCount = 0;
            for i = 1, len do

                friCount = friCount + 1;

                if friCount <= 50 then
                    table.insert(sendTeamFifty, self.sendFriIds[i]);
                else

                    MainValue.fbManager:askHeart(sendTeamFifty);
                    sendTeamFifty = {};
                    friCount = 0;
                    i = i - 1;
                end
            end

            if sendTeamFifty ~= nil then
                MainValue.fbManager:askHeart(sendTeamFifty);
            end
        else
            MainValue.fbManager:askHeart(self.sendFriIds);
        end
    end

    self:disapperAlone();
end

function InviteFriendsPanel:appear()
    self.isAloneShow = false
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disapper);
end

function InviteFriendsPanel:appearAlone()
    self.isAloneShow = true
    MainValue.mxUIManager.panelManager:addPanelAlone(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disapperAlone);
end

function InviteFriendsPanel:appearComplete()
    self.allListView:showAllCell();
end

function InviteFriendsPanel:disapper()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_DOWN , self.disapperComplete)
end

function InviteFriendsPanel:disapperAlone()
    MainValue.mxUIManager.panelManager:removePanelAlone(self, PanelDisappearType.LEAVE_DOWN, self.disapperComplete)
end


function InviteFriendsPanel:disapperComplete()
    self:removeFromParent(true);
end

return InviteFriendsPanel;