local LoginPackagePanel = class("LoginPackagePanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/LoginPackage.json");
end);

function LoginPackagePanel:ctor()

end

function LoginPackagePanel.create()

    local loginPackagePanel = LoginPackagePanel.new()
    loginPackagePanel:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);


    local closebtn = loginPackagePanel:getChildByName("btnClose");
    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then

            if loginPackagePanel.flag == 1 then
                MainValue.mxUIManager.mapManager:getMap():upDateMission(MainValue.SELECTED_LEVEL)
            end
            loginPackagePanel:disAppear();
        end
    end
    closebtn:addTouchEventListener(touchEvent);

    --title文本替换
    local newTitle = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, MainValue.infosManager:getObjMultilingualByKey("Common_loginPackageTitle"));
    newTitle:setPosition(0,360);
    loginPackagePanel:addChild(newTitle);
    
    --设置天数
    local posNode = loginPackagePanel:getChildByName("posPanel");
    
    for var=1, 30 do
        local pos = posNode:getChildByName("p"..var);
        local posNum = nil;
        
        if var == 5 or var == 10 or var == 15 or var == 25 or var == 30 then
            local dayNunS = var.."day";
            posNum = FacFont:getFontsBmp(FontType.FontSmallWhiteBrownSide, dayNunS);
            local posX = pos:getPositionX();
            local posY = pos:getPositionY();
            posNum:setPosition(posX,posY-23);
        else
            posNum = FacFont:getFontsBmp(FontType.FontBigBrown, var);
            local posX = pos:getPositionX();
            local posY = pos:getPositionY();
            posNum:setScale(0.6)
            posNum:setPosition(posX,posY);
        end
       
        posNode:addChild(posNum);
    end
    
    --剩余天数
    local msg = MainValue.infosManager:getObjMultilingualByKey("Common_loginPackageMsg")
    msg = string.gsub(msg, "%b{}", 30)--todo
    
    local nodeMsg = FacFont:getFontsBmp(FontType.FontYellowNoSide, msg);
    nodeMsg:setPosition(90,-190);
    loginPackagePanel:addChild(nodeMsg);
    
    --签到按钮文字
    local btnSign = loginPackagePanel:getChildByName("btnSign");
    local signLable = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, MainValue.infosManager:getObjMultilingualByKey("Common_loginPackageSignLable"));
    local posX = btnSign:getPositionX();
    local posY = btnSign:getPositionY();
    signLable:setPosition(posX,posY);
    loginPackagePanel:addChild(signLable);
    local function btnSignTouchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(btnSign,40);
             --todo
        end
    end
    btnSign:addTouchEventListener(btnSignTouchEvent)
    
    --补签文字
    local btnPatch = loginPackagePanel:getChildByName("btnPatch");
    local patchLable = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, MainValue.infosManager:getObjMultilingualByKey("Common_loginPackagePatchLable"));
    posX = btnPatch:getPositionX() - 55;
    posY = btnPatch:getPositionY();
    patchLable:setScale(0.7)
    patchLable:setPosition(posX,posY);
    loginPackagePanel:addChild(patchLable);
    --补签金币
    local coinSp = cc.Sprite:createWithSpriteFrameName("ui/ui/iconCoin.png");
    posX = patchLable:getPositionX() + 60;
    posY = patchLable:getPositionY();
    coinSp:setScale(0.7)
    coinSp:setPosition(posX,posY);
    loginPackagePanel:addChild(coinSp);
    --补签金币数量
    local coinLable = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, 5, 110, "C");
    posX = coinSp:getPositionX() + 50;
    posY = coinSp:getPositionY();
    coinLable:setScale(0.7)
    coinLable:setPosition(posX,posY);
    loginPackagePanel:addChild(coinLable);
    local function btnPatchTouchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(btnPatch,40);
            --todo
        end
    end
    btnPatch:addTouchEventListener(btnPatchTouchEvent)

    
    

    return loginPackagePanel;
end

function LoginPackagePanel:init()
end


function LoginPackagePanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.POP_UP, self.appearComplete);
end

function LoginPackagePanel:disAppear()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.POP_UNDER , self.disAppearComplete)
end

function LoginPackagePanel:appearComplete()
end

function LoginPackagePanel:disAppearComplete()
    self:removeFromParent(true)
end

return LoginPackagePanel