require "ui.playGamePanel.PlayGamePanel"

LoseSettlementPanel = class("LoseSettlementPanel", function()
    return cc.Node:create();
end);

function LoseSettlementPanel:ctor()
    self.titleLabel = nil;
    

    self.buttonReplay = nil;

    self.isReplay = false;

    self.tarData = nil;
    
    self.rankPanel = nil;
    
    self.callBack = nil; --连接facebook融合数据后回调
    
    self.upPanel = nil;
    
    self.aniPic = nil;
    
    self.adsBtn = nil;
    self.adsBtnTxt = nil;
end

function LoseSettlementPanel.create()
    local temp = LoseSettlementPanel.new()
    temp:init();
    return temp;
end

function LoseSettlementPanel:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);
    
    self.upPanel = ccs.GUIReader:getInstance():widgetFromJsonFile("ui/LoseSettlement.json");
    self.upPanel:setPositionY(MainValue.winSize.height/ 2);
    self:addChild(self.upPanel)

    self.titleLabel = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, "19");
    self.upPanel:addChild(self.titleLabel);
    self.titleLabel:setPosition(3, 385);

    local failedLabel = FacFont:getFontsBmp(FontType.FontYellowWhiteSide, MainValue.infosManager:getObjMultilingualByKey("Common_fail"));
    self.upPanel:addChild(failedLabel);
    failedLabel:setPosition(0, -40);

    self.buttonReplay = self.upPanel:getChildByName("ButtonReplay")
    self.replayLabel = FacFont:getFontsBmp(FontType.FontWhite,  MainValue.infosManager:getObjMultilingualByKey("Common_Replay"));
    self.buttonReplay:addChild(self.replayLabel);
    self.replayLabel:setPosition(160 , 58);
    
    
    local function touchEvent( sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(sender,40);
            self.isReplay = true;
            self:onClose();
        end
    end
    self.buttonReplay:addTouchEventListener(touchEvent)

    local closeBtn = self.upPanel:getChildByName("ButtonClose");
    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:onClose();
        end
    end

    closeBtn:addTouchEventListener(touchEvent)

    self.rankPanel = FriendRankPanel.create();
    self:addChild(self.rankPanel);
end

function LoseSettlementPanel:setData(level, targetData)
    local levelS = MainValue.infosManager:getObjMultilingualByKey("Common_level")
    levelS = string.gsub(levelS, "%b{}", level)
    self.titleLabel:setText(levelS);
    
    if nil ~= targetData then
        self.tarData = {};
        for i, data in ipairs(targetData) do
            local luaData = {};

            if data.id2 > 0 then
                luaData.id = data.id .. "_" .. data.id2;
            elseif data.id2 == 0 then
                luaData.id = data.id;
            end

            luaData.curNum = data.n;
            luaData.tarNum = data.s;

            table.insert(self.tarData, luaData)
        end
    end

    ----------测试数据------
--    self.tarData = {{id = 100, curNum = 10, tarNum = 12}, {id = 200, curNum = 10, tarNum = 10}, {id = 300, curNum = 8, tarNum = 11}}
    
    local targetViewCls = require("ui.collectTarget.TargetListView")
    local targetView = targetViewCls:create(self.tarData, true, true)
    targetView:setScale(0.8)
    targetView:setPosition(-153, -111)
    self.upPanel:addChild(targetView)
    
    if MainValue.dataManager.adManager:getPopCount(MainValue.dataManager.adManager.VideoAD) < advertising.maxShowCount then --显示广告按钮条件
        self.buttonReplay:setScale9Enabled(true)
        self.buttonReplay:setContentSize(cc.size(220, 110))
        self.buttonReplay:setPosition(110, -232)
        
        self.replayLabel:setPosition(113 , 58);
        
        self.adsBtn = ccui.Button:create("ui/ui/btnYellow1.png","ui/ui/btnYellow2.png", nil ,1);
        self.adsBtn:setScale9Enabled(true)
        self.adsBtn:setContentSize(cc.size(220, 110))
        self.adsBtn:setPosition(-110, -232);
        self.upPanel:addChild(self.adsBtn)
        
        local function clickFree( sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                MainValue.actionManager:createJellyAction():run(sender,40);

                local adPanelCls = require("ui/advertisement/ADPanel");
                local adPanel = adPanelCls.create("BuyLifesMent");
                adPanel:appearAlone();
            end
        end
        self.adsBtn:addTouchEventListener(clickFree)
        
        self.adsBtnTxt = FacFont:getFontsBmp(FontType.FontWhite,  MainValue.infosManager:getObjMultilingualByKey("Free_btn"));
        self.adsBtnTxt:setScale(0.8)
        self.adsBtnTxt:setPosition(108 , 58);
        self.adsBtn:addChild(self.adsBtnTxt);
    end
    
    self.rankPanel:setData(level);
    local function updataRank()
        if self.rankPanel ~= nil then
            self.rankPanel:disappear();
        end

        self.rankPanel = FriendRankPanel.create();
        self.rankPanel:setData(level);
        self:addChild(self.rankPanel);

        self.rankPanel:appear();
    end

    self.callBack = updataRank;
    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_FRIENDS, updataRank);
end

function LoseSettlementPanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.NONE, self.appearComplete, self.onClose);
end
function LoseSettlementPanel:appearComplete()
    local winSizeHeight = MainValue.winSize.height / 2;

    local function action2(node)
        node:stopAllActions() --After this stop next action not working, if remove this stop everything is working

        local ac3 = nil;
        ac3 = cc.Sequence:create(cc.EaseOut:create(cc.MoveBy:create(0.1,cc.p(0, 10)), 0.3));
        node:runAction(ac3);
    end

    local ac = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.2,cc.p(0, - winSizeHeight - 10)), 0.3), cc.CallFunc:create(action2));
    self.upPanel:runAction(ac);

    self.rankPanel:appear();
end

function LoseSettlementPanel:onClose()
    local function callFun()
        self:disappear();
    end
    local winSizeHeight = MainValue.winSize.height;
    local disAc1 = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.15,cc.p(0, winSizeHeight)), 0.8),cc.CallFunc:create(callFun));
    self.upPanel:runAction(disAc1);

    self.rankPanel:disappear();
end

function LoseSettlementPanel:disappear()
    self.rankPanel:disappear();
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.NONE , self.disAppearComplete)
end

function LoseSettlementPanel:disAppearComplete()
    MainValue.eventDispatcher:removeEventListener(MainValue.eventDispatcher.eventType.EVENT_FRIENDS, self.callBack);

    if self.isReplay then
        if MainValue.dataManager.userManager:getHeart() >= 1 then
            local playGamePanel = PlayGamePanel.create(MainValue.SELECTED_LEVEL);
            playGamePanel:appear();

            self.isReplay = false;
        else
            if BuyFlowValue.buyLifeAry == nil or table.maxn(BuyFlowValue.buyLifeAry) == 0 then
                BuyFlowValue.buyLifeAry = {}

                local tmpBuyLifeData = BuyFlowData.new(BuyFlowValue.playGamePanel)
                tmpBuyLifeData:setLevelNum(MainValue.SELECTED_LEVEL)       
                BuyFlowValue.buyLifeAry[1] = tmpBuyLifeData      

                local tmpBuyLifeData = BuyFlowData.new(BuyFlowValue.buyLifeUI)            
                BuyFlowValue.buyLifeAry[2] = tmpBuyLifeData                                            
            end
            
            local notEnoughLifes = require("ui/NotEnoughLife")
            local notEnoughLife = notEnoughLifes.create()
            notEnoughLife:appearAlone()
        end
    elseif MainValue.dataManager.userManager:getHeart() == 0 then
        local loginClz = require("src/ui/FBConnect/FBLoginPanel")
        local loginPanel = loginClz.create();
        loginPanel:appearAlone()    
    end

    self:removeFromParent(true);
end

return LoseSettlementPanel