--[[
地图中的云
]]--

local CloudSprite = class("CloudSprite", function ()
    return cc.Node:create();
end);

function CloudSprite:ctor()
    self:setAnchorPoint(0.5,0);
end

function CloudSprite.create()
    return CloudSprite.new()
end

function CloudSprite:init()
    self.arrBg = {}
    self.arrYun = {}
    
    for cI=1, 6 do
        local cldYun
        local cldBg 
        if math.random(0,1) > .5 then
            cldYun = cc.Sprite:create("ui/other/bigYun.png")
            cldBg = cc.Sprite:create("ui/other/bigYing.png")
        else
            cldYun = cc.Sprite:create("ui/other/smlYun.png")
            cldBg = cc.Sprite:create("ui/other/smlYing.png")
        end
        table.insert(self.arrYun,cldYun)
        table.insert(self.arrBg,cldBg)
    end
    
    --先加背景 再加云 
    for cI=1, 6 do
        self:addChild(self.arrBg[cI])
    end
    for cI=1, 6 do
        self:addChild(self.arrYun[cI])
        local posX = math.random(1000,2000)
        local posY = math.random(200,3000)
        self.arrYun[cI]:setPosition(posX,posY)
        self.arrBg[cI]:setPosition(posX+20,posY-230)
        
        self.arrYun[cI].speed = math.random(10,30)*0.1
        self.arrBg[cI].speed = self.arrYun[cI].speed
    end
    
    local  function checkRun()
        if table.maxn(self.arrYun) == 0 then
            return
        end
        for dI=1, table.maxn(self.arrYun) do
            local cldYun = self.arrYun[dI]
            local cldBg = self.arrBg[dI]
            cldYun:setPositionX(cldYun:getPositionX()-cldYun.speed)
            cldBg:setPositionX(cldBg:getPositionX()-cldBg.speed)
            if   cldYun:getPositionX() <= -580 then
                local posX = math.random(1000,2000)
                cldYun:setPositionX(posX)
                cldBg:setPositionX(posX+20)
            end
        end
    end
    self.schedulerInstance = cc.Director:getInstance():getScheduler()
    self.schedulerObj = self.schedulerInstance:scheduleScriptFunc(checkRun, 0, false)
end

return CloudSprite