require "config.mapConfig";
require "ui.panelManager.PanelManager"

local Map = class("Map", function()
    local tempMap = cc.Node:create();
    return tempMap;
end);

function Map:ctor()

end



function Map:initCtor() --等待游戏外部资源加载完毕进行
    self.blockCanDrag = false;
    self.isCanDrag = false
    self.isTouch = true;
    self.mapID = 0;
    self.areaY = mapConfig.areaY;
    self.maxMissionCount = mapConfig.maxMissionCount;
    self.maxBlockerCount = mapConfig.maxBlockerCount;


    --movie动画
    --    self.moviePanel = cc.Node:create();
    --    self.moviePanel:setAnchorPoint(0.5,0.5);
    --    self:addChild(self.moviePanel, 3);
    --
    --    self.movieList = mapConfig.movie;
    --    self.movieObjList = {};
    --
    --    for index = 1, #self.movieList do
    --        local pos = self.movieList[index];
    --
    --        if pos.x ~= 0 and pos.y ~= 0 then
    --            local movieName = "movie"..index;
    --            self.movieObjList[index] = ccs.Armature:create(movieName);
    --            self.movieObjList[index]:retain();
    --        end
    --
    --    end

    self.allLevelData = nil;
    --关卡对象池
    self.missionsStarList = {};
    --当前用到的关卡对象
    self.missionsStarMap = {};

    self.missionsStarPanel = cc.Node:create();
    self.missionsStarPanel:setAnchorPoint(0.5,0.5);
    self.missionsStarPanel:setName("missionsStarPanel");
    self:addChild(self.missionsStarPanel, 3);

    local missionsStarClz = require("ui/map/MissionsStar");
    for index = 1,self.maxMissionCount do
        self.missionsStarList[index] = missionsStarClz.create();
        self.missionsStarList[index]:retain();
        self.missionsStarList[index]:initUI()
    end

    local index = 0;
    local function onTouchMissionsStarBeganTemp(touch, event)
        if self.isTouch then
            local target = event:getCurrentTarget();

            local touchP = self.missionsStarPanel:convertToNodeSpace(touch:getLocation());
            return self:onTouchMissionsStarBegan(touchP);
        end

        return false;
    end
    local function onTouchMissionsStarMovedTemp(touch, event)
        print("onTouchMoved" .. index);
        self:onTouchMissionsStarMoved(touch);
    end
    local function onTouchMissionsStarEndedTemp(touch, event)
        self:onTouchMissionsStarEnded();
    end

    local listener1 = cc.EventListenerTouchOneByOne:create();
    listener1:setSwallowTouches(true);
    listener1:registerScriptHandler(onTouchMissionsStarBeganTemp,cc.Handler.EVENT_TOUCH_BEGAN );
    listener1:registerScriptHandler(onTouchMissionsStarMovedTemp,cc.Handler.EVENT_TOUCH_MOVED );
    listener1:registerScriptHandler(onTouchMissionsStarEndedTemp,cc.Handler.EVENT_TOUCH_ENDED );
    local eventDispatcher = self.missionsStarPanel:getEventDispatcher();
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener1, self.missionsStarPanel);

    --water动画
    --    self.waterPanel = cc.Node:create();
    --    self.waterPanel:setAnchorPoint(0.5,0.5);
    --    self:addChild(self.waterPanel, 4);
    --
    --    self.waterList = mapConfig.water;
    --    self.waterObgList = {};
    --
    --    for index = 1, #self.waterList do
    --        local waterName = "water"..index;
    --        self.waterObgList[index] = ccs.Armature:create(waterName);
    --        self.waterObgList[index]:retain();
    --    end

    --blocker数据
    self.blockerData = nil;
    --blocker对象池
    self.blockerList = {};
    --当前用到的blocker对象
    self.blockerMap = {};

    self.blockerPanel = cc.Node:create();
    self.blockerPanel:setAnchorPoint(0.5,0.5);
    self.blockerPanel:setName("blockerPanel");
    self:addChild(self.blockerPanel, 4);

    local blockerClz = require("ui/map/Box");
    for index=1,self.maxBlockerCount do
        self.blockerList[index] = blockerClz.create();
        self.blockerList[index]:retain();
    end

    local function onTouchBlockerBegan(touch, event)
        local target = event:getCurrentTarget();

        local touchP = self.blockerPanel:convertToNodeSpace(touch:getLocation());

        for index, tempBlocker in pairs(self.blockerMap) do

            local tempBlockerSize = tempBlocker:getContentSize();
            local rect = cc.rect(tempBlocker:getPositionX()-(tempBlockerSize.width/2), tempBlocker:getPositionY()-(tempBlockerSize.height/2), tempBlockerSize.width, tempBlockerSize.height);

            if cc.rectContainsPoint(rect, touchP) then

                self.blockIndex = index;
                if self.blockCanDrag then
                    ----------定位测试------------------------ 
                    print("onTouchBegan : "..target:getPositionX() .. " = " .. target:getPositionY());
                    target:setOpacity(180)
                    return true;
                -------------------定位测试------------
                else
                    if self.isTouch and tempBlocker:isVisible() then --
                        self.clickBlocker = tempBlocker;
                        self.isBlocker = true;
                        return true;
                    else
                        return false;
                    end
                end
            end
        end

        return false;
    end
    local function onTouchBlockerMoved(touch, event)
        -----定位测试------------------------  

        if self.blockCanDrag then
            local tempblock = self.blockerMap[self.blockIndex];
            local posX,posY = tempblock:getPosition()
            local delta = touch:getDelta()
            tempblock:setPosition(cc.p(posX + delta.x, posY + delta.y))
            print("onTouchMoved : "..tempblock:getPositionX() .. " = " .. tempblock:getPositionY());
        ----------------定位测试------
        else
            if self.clickBlocker ~= nil then

                local tempStar = self.clickBlocker;
                local tempStarSize = tempStar:getContentSize();
                local rect = cc.rect(tempStar:getPositionX()-(tempStarSize.width/2), tempStar:getPositionY()-(tempStarSize.height/2), tempStarSize.width, tempStarSize.height);
                local touchP = self.blockerPanel:convertToNodeSpace(touch:getLocation());

                if cc.rectContainsPoint(rect, touchP) == false and self.isBlocker then
                    self.isBlocker = false;
                end

            end
        end

    end
    local function onTouchBlockerEnded(touch, event)

        ----------------定位测试------------------------   
        if self.blockCanDrag then   
            for index=1,9 do
                local id = (self.mapID-1)*10+index;
                local tempblock = self.blockerMap["p"..index];
                if tempblock ~= nil then
                    print("onTouchMoved : ["..id.."] = {x = "..math.ceil(tempblock:getPositionX())..", y = "..math.ceil(tempblock:getPositionY()).."},")
                end
            end
            ----------------定位测试-----------
        else
            if self.clickBlocker.pbc~=nil and self.isBlocker then -- and self.allLevelData[tostring(self.clickBlocker.pbc.act)] ~= nil 
                --打开blocker
                self:openBlockerPanel(self.clickBlocker.pbc);
            end

        end

    end

    local listener2 = cc.EventListenerTouchOneByOne:create();
    listener2:setSwallowTouches(true);
    listener2:registerScriptHandler(onTouchBlockerBegan,cc.Handler.EVENT_TOUCH_BEGAN );
    listener2:registerScriptHandler(onTouchBlockerMoved,cc.Handler.EVENT_TOUCH_MOVED );
    listener2:registerScriptHandler(onTouchBlockerEnded,cc.Handler.EVENT_TOUCH_ENDED );
    local eventDispatcher2 = self.blockerPanel:getEventDispatcher();
    eventDispatcher2:addEventListenerWithSceneGraphPriority(listener2, self.blockerPanel);

    self:setCascadeOpacityEnabled(true);
end

function Map.create()
    local map = Map.new()
    map:setPosition(MainValue.winSize.width / 2,MainValue.winSize.height / 2)
    return map;
end

function Map:init(tarPageNumPar)
    self.mapID = MainValue.mxUIManager.mapManager:getCurrentMapIDByY(tarPageNumPar);
    self.allLevelData = MainValue.dataManager.levelManager:getAllLevel();
    self.blockerData = MainValue.dataManager.levelManager:getAllBox();
    
    self:updataPst(tarPageNumPar);
end

--更新地图关卡点位置
function Map:updataPst(tarPageNumPar)
    self.allLevelData = MainValue.dataManager.levelManager:getAllLevel();
    local maxoffY = tarPageNumPar + self.areaY + 1024;
    local minoffY = tarPageNumPar - self.areaY;
    self.offsetX = (MainValue.winSize.width - 768) * 0.5        
    self.offsetY = -(MainValue.winSize.height - 1024) * 0.5
    
    --关卡点
--    for index, tempstar in pairs(self.missionsStarMap) do
--       local tempY = tempstar:getPositionY()
--        if tempY >= maxoffY or tempY <= minoffY then
--            tempstar:removeFromParent();
--            self.missionsStarMap[index] = nil;
--            print("delete point id = "..index);
--        end 
--    end
    
    local maxlevel = MainValue.dataManager.levelManager:getMaxLevel();
    local tempList = self:getAllTargetListBy(math.floor(tarPageNumPar),1);
    local length = table.maxn(tempList)
    
    if length >= self.maxMissionCount then
        length = self.maxMissionCount
    end 
    
    for index = 1,length do
        local id = "p"..tempList[index].id;
        local info = tempList[index].info;

        if self.missionsStarMap[id] == nil then
            self.missionsStarMap[id] = self:getFreeStar();
            
            info.x = info.x - self.offsetX
            info.y = info.y + self.offsetY
            
            self.missionsStarMap[id]:setPosition(info.x, info.y);
            self.missionsStarMap[id]:setMissionText(tempList[index].id);
            if tempList[index].id <= maxlevel then
                self.missionsStarMap[id]:showMissionText();
            end
            self.missionsStarPanel:addChild(self.missionsStarMap[id]);
            
            if info.ms ~= nil then
                self.missionsStarMap[id]:showMissionSign(info.ms);
            end
            
            local levelData = self.allLevelData[tostring(tempList[index].id)];
            self.missionsStarMap[id]:setMissionState(levelData,info);
            self.missionsStarMap[id]:setMissionStar(levelData,info);
            
            
            if tempList[index].id == maxlevel then
            
                if MainValue.SELECTED_LEVEL == 1 then
                    self:activtMaxLevel(1);
                else
                    MainValue.mxUIManager.mapManager:activtMaxLevel();
                end
            end
            
            print("add point id = "..id);
    	end
    end
    
    --blocker
--    for index, tempblocker in pairs(self.blockerMap) do
--        local tempY = tempblocker:getPositionY()
--        if tempY >= maxoffY or tempY <= minoffY then
--            tempblocker:removeFromParent();
--            self.blockerMap[index] = nil;
--            print("delete blocker id = "..index);
--        end 
--    end
    
    tempList = self:getAllTargetListBy(math.floor(tarPageNumPar),2);
    length = table.maxn(tempList);
    
    
     if length >= self.maxBlockerCount then
         length = self.maxBlockerCount
     end 
    
    for index = 1,length do
        local id = "p"..tempList[index].id;
        local info = tempList[index].info;

        if self.blockerMap[id] == nil then
            self.blockerMap[id] = self:getFreeBlocker();
            
            if self.blockerData[tostring(info.act)] == nil then
                local openBoxList = MainValue.dataManager.levelManager:getAllBox();
                
                if openBoxList[tostring(info.act)]  == nil then
                    self.blockerMap[id]:init(info);
                    
                    info.x = info.x - self.offsetX
                    info.y = info.y + self.offsetY
                    
                    self.blockerMap[id]:setPosition(info.x, info.y);
                    self.blockerPanel:addChild(self.blockerMap[id]);

                    self.blockerMap[id]:setBoxGetState();
                end
                
            end
            
            print("add blocker id = "..id);
        end
    end
    
    --water动画
--    for index = 1, #self.waterList do
--        local pos = self.waterList[index];
--        
--        pos.x = pos.x - self.offsetX
--        pos.y = pos.y + self.offsetY
--        
--        self.waterObgList[index]:setPosition(pos.x,pos.y);
--        self.waterObgList[index]:getAnimation():play("1",1);
--        self.waterPanel:addChild(self.waterObgList[index]);
--    end
--    --movie动画
--    for index = 1, #self.movieList do
--        local pos = self.movieList[index];
--        
--        if pos.x ~= 0 and pos.y ~= 0 then
--            pos.x = pos.x - self.offsetX
--            pos.y = pos.y + self.offsetY
--            
--            self.movieObjList[index]:setPosition(pos.x,pos.y);
--            self.movieObjList[index]:getAnimation():play("1",1);
--            self.moviePanel:addChild(self.movieObjList[index]);
--        end
--        
--    end
end

--取得当前Y点的
--tarPageNumPar:Y坐标
--flag：1：关卡点 ， 2：blocker

function Map:getAllTargetListBy(tarPageNumPar,flag)
    local tempList = {};
    
    local cp = nil;
    local cpLength
    if flag == 1 then
        cp = mapConfig.position;
        cpLength = mapConfig.maxMissionCount -- - 10;  -- 测试用！  后10关不显示
        
    elseif flag == 2 then
        cp = mapConfig.box;
        cpLength = mapConfig.maxBlockerCount-- - 1;
    end
    
    local maxoffY = tarPageNumPar + self.areaY + 1024;
    local minoffY = tarPageNumPar - self.areaY;
    
    
     
    local count = 1;
    local coefficient = 0;
    for index = 1, cpLength do
        if flag == 1 then
            if count ~= 80  then
                count = count%80;
                coefficient = math.floor(index/80)
            end
        else
--            coefficient = index
--            if count ~= 4  then
--                count = count%4;
--                coefficient = math.floor(index/4)
--            end
        end
        if cp[count] ~= nil then
            if cp[count].y >= minoffY  and cp[count].y <= maxoffY then
                tempList[index] = {};
                
                tempList[index].id = index;
                if flag == 1 then
                    tempList[index].info = {}
                   
                    tempList[index].info.x = cp[count].x -- - 50;
                    tempList[index].info.y = cp[count].y + coefficient*mapConfig.mapAloneHeight*mapConfig.mapCount;
                else
                    tempList[index].info = cp[count]
                    tempList[index].info.x = cp[count].x  -- - 30;
                end
                
                if cp[count].ms ~= nil then
                    tempList[index].info.ms = cp[count].ms;
                end
--                
--                if cp[count].path ~= nil then tempList[index].info.path = cp[count].path; end;
--                if cp[count].needStar ~= nil then tempList[index].info.needStar = cp[count].needStar; end;
                count = count + 1;
            end
            
--            if cp[count].y > maxoffY then
--                break;
--            end
        end
    end
    
    return tempList;
end

--取得空闲关卡点
function Map:getFreeStar()
    local length = #self.missionsStarList;
    for index = 1,length do
        if self.missionsStarList[index]:getParent() == nil then
            return self.missionsStarList[index];
        end
    end
    return nil;
end
--取得空闲blocker
function Map:getFreeBlocker()
    local length = #self.blockerList;
    for index = 1,length do
        if self.blockerList[index]:getParent() == nil then
            return self.blockerList[index];
        end
    end
    return nil;
end



--更新全部关卡状态和black状态
function Map:updataAllMissionInfo()
    self:setMission();
    self:setBlocker();
end

--根据关卡id 获取关卡点
function Map:getMissionByID(idPar)
    local itemMission = nil;
    
    for index, tempstar in pairs(self.missionsStarMap) do
        if tempstar.id == idPar then
            itemMission = tempstar;
            break;
        end
    end
    
    return itemMission;
end
-- 设置全部关卡
function Map:setMission()
    self.allLevelData = MainValue.dataManager.levelManager:getAllLevel();
    
    if self.allLevelData ~= nil then
        for index, tempstar in pairs(self.allLevelData) do
            local missionItem = self:getMissionByID(math.floor(index));
            if missionItem~=nil then
                missionItem:updateMissionState(self.allLevelData[tostring(missionItem.id)]);
                missionItem:updateMissionStar(self.allLevelData[tostring(missionItem.id)]);
                missionItem:showMissionText();
            end
        end
    end
    
end
--更新地图关卡数据
function Map:upDateMission(missionValue)
    self.allLevelData = MainValue.dataManager.levelManager:getAllLevel();
    self.missionValue = missionValue;

    local function setNextMissionState(touch, event)
        local nextMissionValue = self.missionValue + 1;
        local nextMissionItem = self:getMissionByID(nextMissionValue);
        local curMissionItem = self:getMissionByID(self.missionValue);

        if nextMissionItem ~=nil then
            local isNextBlocker = false;
            local offY = 0;
        
            if self.missionValue % 10 == 0 then
            
                local blockItem = self:getBlockerByIndex(self.missionValue)
                if blockItem ~= nil and blockItem:isVisible() and blockItem.isNext == false then
                    isNextBlocker = true
                    blockItem.isNext = true;
                    blockItem:setNextMissionState();
                    if blockItem:getPositionY() > 0 then
                        offY = blockItem:getPositionY()*-1 - 100;
                    end
                end
            end
            
            if isNextBlocker == false then
                nextMissionItem:setNextMissionState();
                curMissionItem:isShowMissionSign(true);
                
                if nextMissionItem:getPositionY() > 0 then
                    offY = nextMissionItem:getPositionY()*-1 - 100;
                end
            end

            MainValue.mxUIManager.mapManager:setBgY(offY);
        end
    end
    
    if missionValue < self.maxMissionCount then
        self:setIsTouch(false);
    end
    local missionItem = self:getMissionByID(self.missionValue);
    missionItem:updateMissionState(self.allLevelData[tostring(missionValue)], setNextMissionState);
    if  self.allLevelData[tostring(missionValue)] ~= nil then 
        missionItem:updateMissionStar(self.allLevelData[tostring(missionValue)])
        missionItem:showMissionText();
    end
end
--更新地图关卡星星数据
function Map:updateMissionStar(missionValue)
    self.allLevelData = MainValue.dataManager.levelManager:getAllLevel();
    
    if  self.allLevelData[tostring(missionValue)] ~= nil then 
        local missionItem = self:getMissionByID(missionValue);
        missionItem:updateMissionStar(self.allLevelData[tostring(missionValue)])
    end
    
end
-- 设置全部Blocker
function Map:setBlocker()
--    self.allLevelData = MainValue.dataManager.levelManager:getAllLevel();
--    
--    for index, tempBlocker in pairs(self.blockerMap) do
--        
--        if tempBlocker ~= nil then
        
--            if self.allLevelData[tostring(tempBlocker.pbc.act)] == nil then
--                tempBlocker:setBlockerState(1);
--            else
--                tempBlocker.isActiveBlocker = true;
--                MainValue.dataManager.levelManager:openBlockById(tempBlocker.pbc.act);
--                tempBlocker:setBlockerState(3);
--            end
--    
--            --是否开启blocker
--            if self.blockerData[tostring(tempBlocker.pbc.act)] ~= nil then
--                if self.blockerData[tostring(tempBlocker.pbc.act)].bk ~= nil then
--                    if self.blockerData[tostring(tempBlocker.pbc.act)].bk == 0 then
--                        tempBlocker.isActiveBlocker = true;
--                    elseif self.blockerData[tostring(tempBlocker.pbc.act)].bk == 1 then
--                        tempBlocker:setVisible(false);
--                    end
--                end
--            end
            
--        end
        
--    end
end
--更新地图Blocker数据
function Map:upDateBlocker(missionValue)
    local blockerFlag = nil;
    
    for var=1, #self.blockerList do
        if self.blockerList[var] ~= nil then
            local flag = self.blockerList[var]:setBoxGetState();
            
             if flag then
                blockerFlag = self.blockerList[var];
             end
             
        end
    end
end
-- Blocker是否完成
function Map:isSuccesBlocker(missionValue)
    local blockerIndex = self:getBlockerIndexByMissionID(missionValue);
    local pbc = mapConfig.blocker[blockerIndex];
    
    if pbc == nil then 
        return true; 
    end
    
    if MainValue.dataManager.levelManager:getAllBlock()[tostring(pbc.act)] ~= nil and 
       MainValue.dataManager.levelManager:getAllBlock()[tostring(pbc.act)].bk  == 1 then
        return true;
    else
        return false;
    end
end
--根据关卡id获取Blocker索引
function Map:getBlockerIndexByMissionID(missionID)
    local blockerIndex = math.floor(missionID / 10);
    return blockerIndex;
end
----Blocker解锁
function Map:succeedBlocker(blockerIndex)
    local itemBlocker = self:getBlockerByIndex(blockerIndex);

    if itemBlocker ~= nil then
        --MainValue.dataManager.levelManager:openBoxById(itemBlocker.pbc.act);
        itemBlocker:setVisible(false)
        itemBlocker:removeFromParent(true);
    end
end
--根据Blocker索引 获取Blocker对象
function Map:getBlockerByIndex(indexPar)
    local itemBlocker = nil;

    for index, tempBlocker in pairs(self.blockerMap) do
        if tempBlocker.pbc.act == indexPar then
            itemBlocker = tempBlocker;
            break;
        end
    end

    return itemBlocker;
end
--激活最大关卡点
function Map:activtMaxLevel(level)
    local maxlevel = level;
    if maxlevel == nil then
        maxlevel = MainValue.dataManager.levelManager:getMaxLevel();
        
        if maxlevel > self.maxMissionCount then
            maxlevel = self.maxMissionCount
        end
    end
    local itemMission = self:getMissionByID(maxlevel);
   
    if itemMission ~= nil then
        itemMission:setNextMissionState();
    end
    
    
--    local perblockerIndex = maxlevel - 1;
--    local perBlockerSucc = MainValue.mxUIManager.mapManager:isSuccesBlocker(perblockerIndex);
    
--    if itemMission~=nil and perBlockerSucc then
--        itemMission:setNextMissionState();
--    else
--        itemMission = self:getMissionByID(perblockerIndex);
--        perblockerIndex = perblockerIndex - 1;
--        perBlockerSucc = MainValue.mxUIManager.mapManager:isSuccesBlocker(perblockerIndex);
--        
--         if itemMission~=nil and perBlockerSucc then
--            itemMission:setNextMissionState();
--         end
--    end
end

-------------------------------------------------------------------------------------------------------------------------------------------

-- 关卡事件
function Map:onTouchMissionsStarBegan(touchP)
    self.lockMissions = nil;

    for index, tempStar in pairs(self.missionsStarMap) do
    
        local tempStarSize = tempStar:getContentSize();
        local rect = cc.rect(tempStar:getPositionX()-(tempStarSize.width/2), tempStar:getPositionY()-(tempStarSize.height/2), tempStarSize.width, tempStarSize.height);

        if cc.rectContainsPoint(rect, touchP) then

            self.index = tempStar.id;
            if self.isCanDrag then 
                ------------------定位测试----------------------  
                print("onTouchBegan : "..tempStar:getPositionX() .. " = " .. tempStar:getPositionY());
                tempStar:setOpacity(180);
                return true;
            -------------------定位测试------------------
            else
                local isTouchLength = MainValue.dataManager.levelManager:getMaxLevel();
                local perblockerIndex = tempStar.id - 1;
                if tempStar.id > isTouchLength then--or MainValue.mxUIManager.mapManager:isSuccesBlocker(perblockerIndex) == false
                    return false;
                end
                
                MainValue.actionManager:createJellyAction():press(tempStar.bgAnimation,10);
                self.lockMissions = tempStar;
                self.isMission = true;
                return true;
            end
        end
    end
    
    return false;
end

function Map:onTouchMissionsStarMoved(touch)
    -----------------定位测试------------------------  
    if self.isCanDrag then 
        local tempStar = self.missionsStarList[self.index];
        local posX,posY = tempStar:getPosition()
        local delta = touch:getDelta()
        tempStar:setPosition(cc.p(posX + delta.x, posY + delta.y))
        print("onTouchMoved : "..tempStar:getPositionX() .. " = " .. tempStar:getPositionY());
    ----------------定位测试-----------------
        
        print("onTouchMoved" .. self.index);
   else
    
        if self.lockMissions ~= nil then
            
            local tempStar = self.lockMissions;
            local tempStarSize = tempStar:getContentSize();
            local rect = cc.rect(tempStar:getPositionX()-(tempStarSize.width/2), tempStar:getPositionY()-(tempStarSize.height/2), tempStarSize.width, tempStarSize.height);
            local touchP = self.missionsStarPanel:convertToNodeSpace(touch:getLocation());
    
            if cc.rectContainsPoint(rect, touchP) == false and self.isMission then
                MainValue.actionManager:createJellyAction():run(tempStar.bgAnimation,10);
                self.isMission = false;
            end
            
        end
    end
    
end

function Map:onTouchMissionsStarEnded()
    print("onTouchEnded".. self.index);
     
    local tempStar = self:getMissionByID(self.index);
    ----------------定位测试-----------------------   
    if self.isCanDrag then 
        tempStar:setOpacity(255)
        
        for index=1,90 do
            local id = (self.mapID-1)*10+index;
            local tempStar = self.missionsStarList[index];
            if tempStar ~= nil then
                print("["..id.."] = {x = "..math.ceil(tempStar:getPositionX())..", y = "..math.ceil(tempStar:getPositionY()).."},")
            end
        end
    else
---------------------定位测试------------
    
    
        if self.isMission then
            MainValue.actionManager:createJellyAction():run(tempStar.bgAnimation,10);
            self:openPlayGamePanel(self.index);
        end
    end
    
end

--开启play面板
function Map:openPlayGamePanel(lvNum)
    if MainValue.dataManager.userManager:getHeart() <= 0 then
        
        if BuyFlowValue.buyLifeAry == nil or table.maxn(BuyFlowValue.buyLifeAry) == 0 then
            BuyFlowValue.buyLifeAry = {}
            
            local tmpBuyLifeData = BuyFlowData.new(BuyFlowValue.playGamePanel)
            tmpBuyLifeData:setLevelNum(lvNum)       
            BuyFlowValue.buyLifeAry[1] = tmpBuyLifeData      
            
            local tmpBuyLifeData = BuyFlowData.new(BuyFlowValue.buyLifeUI)            
            BuyFlowValue.buyLifeAry[2] = tmpBuyLifeData                                            
        end
        
        local notEnoughLifes = require("ui/NotEnoughLife")
        local notEnoughLife = notEnoughLifes.create()
        notEnoughLife:appearAlone()
        
        return;
    end
    
   
    
   
    
    
    
    --已经是新的关卡 判断是否有要解锁的道具 如果有就显示解锁道具面板  2015-1-8    
    local isUnlockingProp = MainValue.dataManager.goodsManager:havePropIsUnlockingByLv(lvNum)
    if isUnlockingProp ~= nil then
        --        填出解锁道具面板 2015-1-29 临时取消
--        local UnlockItemClz = require("ui/UnlockItemPanel")
--        local unlockItem = UnlockItemClz.new()
--        unlockItem:initData(isUnlockingProp)
--        unlockItem:appear();
    end
    --临时调用
    
    local playGamePanelClz = require("ui/playGamePanel/PlayGamePanel")
    local playGamePanel = playGamePanelClz.create(lvNum);
    playGamePanel:appear();
end
--开启Blocker面板
function Map:openBlockerPanel(pbcInfo, flag)
    local boxLockClz = require("ui/boxLock/BoxLockPanel")
    local boxLock = boxLockClz.create(pbcInfo,flag);
    boxLock:appear();
end

function Map:setIsTouch(value)
    self.isTouch = value
end
--销毁
function Map:destroy()
end

return Map