require "ui.map.MapUtils"
require "config.mapConfig"


-- 是否进入地图
local inMap = false;
-- 是否有数据同步
local isUpData = false;
--第一次进地图
local isFirst = true;
--最大关卡
local maxLevel = mapConfig.maxMissionCount;
--大地图高
local mapHeight = 8192;

local MapManager = class("MapManager", function()    
    return cc.Node:create();
end);

function MapManager:ctor()
    
end

function MapManager.create()
    local temp = MapManager.new();
    return temp;
end

function MapManager:mapInit()

    --更新频率
    self.timeSpend = 1;

    --是否显示小手动画
    self.isshowMouse = false;

    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/mouse/mouse.csb" );
    self.mouseAnimation = ccs.Armature:create("mouse");
    self.mouseAnimation:retain();

    local userHeadFrameClz = require("ui/map/HeadFrame");
    self.userHeadFrame = userHeadFrameClz.create();
    self.userHeadFrame:init(1);
    self.userHeadFrame:retain();

    local mapSprite = require("ui/map/MapSprite")
    self.bg = mapSprite.new()


    local function updatePage(tarPageNumPar)
        tarPageNumPar = math.abs(tarPageNumPar)
        --print("current mapY = " .. tarPageNumPar);
        tarPageNumPar = math.floor(tarPageNumPar - 512);


        if inMap  then
            self:updataSwitchMapList(tarPageNumPar);

        --        self.startT = os.clock()
        --        
        --        self.endT = os.clock();
        --        print(self.endT - self.startT);
        --        print("self.endT = " .. self.endT.. "self.startT = " .. self.startT)
        end
    end


    --云

    local cloudClz = require("ui/map/CloudSprite");
    self.cloud = cloudClz.create();
    self.cloud:init()
    self.cloud:retain()


    self.bg:initUpDatePageFun(updatePage)
    self.bg:setAnchorPoint(0,0);
    self.bg:retain();
    self.bg:init(maxLevel);


    local mapClz = require("ui/map/Map");
    self.currentMap = mapClz.create();
    self.currentMap:retain();

    --    self.offsetX = (MainValue.winSize.width - 768) * 0.5        
    --    self.offsetY = (MainValue.winSize.height - 1024) * 0.5
    --    self.currentMap:setPosition(cc.p(self.offsetX,self.offsetY))



    local function upDateMap()
        if inMap then
            self:upDateAllMission();
            self:activtMaxLevel();
            if self.mouseAnimation ~= nil then
                self.mouseAnimation:removeFromParent();
            end
        else
            isUpData = true;
        end
    end
    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_LEVEL, upDateMap);

    self.currentMap:initCtor()
end
function MapManager:updataSwitchMapList(tarPageNumPar)
--    self.timeSpend = self.timeSpend + 1;
--    if(self.timeSpend < 6) then
--        return;
--    end
--    self.timeSpend = 0;
--
--
--    self.currentMap:updataPst(tarPageNumPar);
end
--设置头像
function MapManager:setUserHeadFramePos(posX_, posY_, isshowMouse, isboxJoin)
    local posXT = posX_;
    local posYT = posY_;
    local posX = posXT + self.userHeadFrame.offX;
    local posY = posYT + self.userHeadFrame.offY + 65;
    
    self.isshowMouse = isshowMouse;
    
    if self.userHeadFrame.isChangePos == true then
        if self.userHeadFrame:getPositionX() ~= posX or self.userHeadFrame:getPositionY() ~= posY then
            local function callFun()
                self.currentMap:setIsTouch(true);
                
                if isboxJoin == true then
                    MainValue.mxGameManager:openChests();
                else
                    MainValue.mxGameManager:openNewLevel();
                end
                
                if self.isshowMouse then
                    self:showMouse(posX,(posY- 65));
                end
            end
            local ac = cc.Sequence:create(cc.EaseSineIn:create(cc.MoveTo:create(1, cc.p(posX, posY))),cc.DelayTime:create(1),cc.CallFunc:create(callFun));
            self.userHeadFrame:runAction(ac)
        else
            self.currentMap:setIsTouch(true);
        end
    else
        self.userHeadFrame:setPosition(posX,posY);
        self.userHeadFrame.isChangePos = true;
        if self.isshowMouse then
            self:showMouse(posX,(posY-65));
        end
    end
end

function MapManager:setDeltaPosY() --关卡点显示星星动画，头像上移
    self.userHeadFrame:setPositionY(self.userHeadFrame:getPositionY() + 30);
end

--显示小手
function MapManager:showMouse(posX_,posY_)
    self.mouseAnimation:getAnimation():play("2",1,1);
    self.mouseAnimation:setPosition(posX_,posY_);
    --self.mouseAnimation:setScale(0.8);
    
    if not MainValue.mxUIManager.panelManager:getIsPanelOnShow() then
        self.bg:addSpriteToDragSprite(self.mouseAnimation,false);
    end
end

function MapManager:redisplayObject()
    if self.isshowMouse then
        self.bg:addSpriteToDragSprite(self.mouseAnimation,false);
    end
end

function MapManager:hideObject()
    if self.mouseAnimation ~= nil and self.mouseAnimation:getParent() then
        self.mouseAnimation:removeFromParent();
    end
end

--进入地图
function MapManager:onEnterMap()
    MainValue.mxLoadingManager:removeLoading();  

    inMap = true;
    local tarPageNumPar = 1;
    
    if isFirst == true then
        tarPageNumPar = math.abs(self.bg:getDragSpriteY())
        tarPageNumPar = math.floor(tarPageNumPar - 512);

        self.currentMap:init(tarPageNumPar);
        
        if MainValue.SELECTED_LEVEL ~= 1 then
            self:activtMaxLevel();
        end
        
        isFirst = false;
    end
    if self.bg:getParent()~=nil then
        self.bg:getParent():removeChild(self.bg)
    end
    
    self:addChild(self.bg,0);
    self.bg:addSpriteToDragSprite(self.currentMap,true)
    self.bg:addSpriteToDragSprite(self.userHeadFrame,true)
    self.bg:addCloudToDragSprite(self.cloud)
    
    
    --同步数据
    if isUpData then
        self:upDateAllMission();
        self:activtMaxLevel();
        isUpData = false;
        if self.mouseAnimation ~= nil then
            self.mouseAnimation:removeFromParent();
            self.isshowMouse = false;
        end
    end
    
    --1.207
--    MainValue.mxFTUEManager:setTargetConfig(0,0);
--
--    if MainValue.dataManager.expandManager:getFtue() == nil then
--        if MainValue.mxFTUEManager ~= nil then 
--            MainValue.mxFTUEManager:showFtueById(0);
--        end
--    end
    MainValue.mxSplashManager:removeFirstLoading();
end

--退出地图
function MapManager:onExitMap()
    inMap = false;
    
    self.mouseAnimation:removeFromParent();
    self.isshowMouse = false;
    
    self.userHeadFrame:removeFromParent();

    self.currentMap:destroy();
    self.currentMap:removeFromParent();
    
    self.bg:removeFromParent();
end

--激活最大关卡
function MapManager:activtMaxLevel()
    self.currentMap:activtMaxLevel();
end
--更新地图数据
function MapManager:upDateAllMission()
    self.currentMap:updataAllMissionInfo();
end
--更新地图关卡数据
function MapManager:upDateMission(missionValue)
    self.currentMap:upDateMission(missionValue);
    self:upDateBlocker(missionValue);
end
function MapManager:getMap()
    return self.currentMap;
end
--更新地图关卡星星
function MapManager:updateMissionStar(missionValue)
    self.currentMap:updateMissionStar(missionValue);
end
--更新宝箱数据
function MapManager:upDateBlocker(missionValue)
    self.currentMap:upDateBlocker(missionValue);
end
--black是否成功开启
function MapManager:isSuccesBlocker(missionValue)
    return true;
end
--black成功开启动画
function MapManager:succeedBlocker(blockerIndex)
    self.currentMap:succeedBlocker(blockerIndex);
end
----BLOCK朋友帮助
--function MapManager:friendHelpBlock(bid,fids)
--    local isSucc =  MainValue.dataManager.levelManager:setBlockFID(bid,fids);
--    self.currentMap:refreshHelpBlocker(bid);
--end

------------------------------------------------------------------------------------------
--设置滚动背景Y值
function MapManager:setBgY(offY)
    self.bg:setBgY(offY);
end

----根据光卡id 返回 Blocker配置索引
--function MapManager:getBlockerIndexByMissionID(missionID)
--    return self.currentMap:getBlockerIndexByMissionID(missionID);
--end

--当前显示地图id根据地图Y值
function MapManager:getCurrentMapIDByY(tmpY)
    local mid = 1;
    local kd = math.abs(math.ceil(tmpY / mapHeight));
    
--    print("current page = ",kd)
    
    for index=1,#mapConfig.mapY do
        local gtl = math.abs(tmpY) - (kd * mapHeight);
    
        if gtl > mapConfig.mapY[index] then
            mid = (kd * 8) + index + 1;
        end
    end
    
    mid = (kd * 8) + mid;
    return mid;
end
--当前显示地图id
function MapManager:getCurrentMapID()
    return self:getCurrentMapIDByY(self.bg:getDragSpriteY());
end
--当前最大关卡所在地图id
function MapManager:getMaxMissionsMapID()
    local al = MainValue.dataManager.levelManager:getMaxLevel();
    local max_lv = al;
    local maxPageNum  = math.ceil(max_lv/10);
    return maxPageNum;
end
--最大关卡
function MapManager:getMaxLevel()
    return maxLevel;
end
-- 是否可以点击
function MapManager:getIsTouch()
    return self.currentMap.isTouch;
end
--是否在地图
function MapManager:isInMap()
    return inMap;
end

return MapManager;