local MissionsStar = class("MissionsStar", function ()
    return cc.Node:create();
end);

function MissionsStar:ctor()
   
end

function MissionsStar:initUI()
    self.id = 0;

    self:setAnchorPoint(0,0);

    self.bgAnimation = ccs.Armature:create("level");
    self.bgAnimation:setPosition(0,-5);
    self.bgAnimation:getAnimation():play("1",1);
    self:addChild(self.bgAnimation,0);

    self.starAnimation = ccs.Armature:create("levelStar");
    --self.starAnimation:getAnimation():play("1",1); 
    self.starAnimation:setPosition(0,-5);
    self.starAnimation:setVisible(false);
    self:addChild(self.starAnimation, 1);

    self.missionText = FacFont:getFontsBmp(FontType.FontLevelDotNum, "0");
    self.missionText:setScale(0.8)
    self.missionText:setPosition(-2,-22);
    self.missionText:setVisible(false);
    self:addChild(self.missionText, 2);

    self:setContentSize(60,60);
end

function MissionsStar.create()
    local temp = MissionsStar.new();

    return temp;
end

--设置初始关卡文本数
function MissionsStar:setMissionText(missionTextValue)
    self.id = missionTextValue;
    self.missionText:setText(self.id);
end
function MissionsStar:showMissionText()
    self.missionText:setVisible(true);
end
--设置关卡状态[nil:为开启关卡[1]，1：开启关卡动画[2,3], 2:未开启关卡[4]]
function MissionsStar:setMissionState(missionStatevalue,pst)

--    self.bgAnimation:getAnimation():play("2",1);
    

    
    if missionStatevalue == nil then
        if self.id < MainValue.mxUIManager.mapManager:getMaxLevel() then
            self.bgAnimation:getBone("4"):setPosition(4,10)  
        else
            self.bgAnimation:getAnimation():play("1",1);
        end
    else
--        print("sdfsdfsdf")
        self.bgAnimation:getAnimation():play("4",1);

    end
    


end
--设置初始关卡星星数
function MissionsStar:setMissionStar(missionStarValue,pst)
    if missionStarValue == nil then
        self.starAnimation:setVisible(false);
    else
        if self.signIcon ~= nil then
            self.signIcon:setPositionY(64);
        end
        
        self.starAnimation:setVisible(true);

        local animationIndex = 1;

        if missionStarValue.stars == 1 then
            animationIndex = 1;
        elseif missionStarValue.stars == 2 then
            animationIndex = 3;
        elseif missionStarValue.stars == 3 then
            animationIndex = 5;
        end

        self.starAnimation:getAnimation():play(tostring(animationIndex),1);
    end

end
--设置关卡状态[开启关卡动画[3]]
function MissionsStar:updateMissionState(missionStatevalue, callBackFun)

    local function animationEvent(armatureBack,movementType,movementID)
        local id = movementID
        if movementType == ccs.MovementEventType.complete then
            if id == "3" then
                if callBackFun~=nil then
                    callBackFun();
                end
            end
        end
    end

    self.bgAnimation:getAnimation():setMovementEventCallFunc(animationEvent);
    self.bgAnimation:getAnimation():play("3",1);
end
--设置关卡解锁状态[开启关卡动画[2]]
function MissionsStar:setNextMissionState(missionStatevalue)
    self:isShowMissionSign(false);
    
    self.bgAnimation:getAnimation():play("2",1);
    self.starAnimation:setVisible(true);
    
    if self.id < MainValue.mxUIManager.mapManager:getMaxLevel() then
        self.starAnimation:getAnimation():play("7",1);
    end
    
     local isShowMouse = false;
     if self.id > 1 and self.id <= 10 then
        isShowMouse = true
     end
        
    MainValue.mxUIManager.mapManager:setUserHeadFramePos(self:getPositionX(),self:getPositionY(),isShowMouse);
    self:showMissionText();
end

--设置关卡星星数
function MissionsStar:updateMissionStar(missionStarValue)
    local animationIndex = 1;
    
    if missionStarValue == nil then
        self.starAnimation:setVisible(false);
    else
        if self.signIcon ~= nil then
            self.signIcon:setPositionY(64);
        end
        
        self.starAnimation:setVisible(true);
        if missionStarValue.stars == 1 then
            animationIndex = 1;
        elseif missionStarValue.stars == 2 then
            animationIndex = 3;
        elseif missionStarValue.stars == 3 then
            animationIndex = 5;
        end

        self.starAnimation:getAnimation():play(tostring(animationIndex),1); 
    end

end

--设置显示关卡标识
function MissionsStar:showMissionSign(signId)
    local pathStr = "map/missionSign/sign" .. tostring(signId) .. ".png";
    
    self.signIcon = ccui.Button:create(pathStr, pathStr);
    self.signIcon:setPositionY(10);
    self.signIcon:setAnchorPoint(0.5,0)
    self:addChild(self.signIcon);
    
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
            print(sender:getWorldPosition())
            
            self:showTips(sender:getWorldPosition(), signId);
        elseif eventType == ccui.TouchEventType.canceled or eventType == ccui.TouchEventType.ended then
            self:hideTips();
        end
    end

    self.signIcon:addTouchEventListener(touchEvent);
end

function MissionsStar:showTips(showPos, signId)
    local dialogStr = nil;

    if signId == MainValue.mxTipsManager.ROLE_GIRL then
        dialogStr = MainValue.infosManager:getObjMultilingualByKey("Dialog_Girl");
    elseif signId == MainValue.mxTipsManager.ROLE_LION then
        dialogStr = MainValue.infosManager:getObjMultilingualByKey("Dialog_Lion");
    elseif signId == MainValue.mxTipsManager.ROLE_IRON then
        dialogStr = MainValue.infosManager:getObjMultilingualByKey("Dialog_Iron");
    elseif signId == MainValue.mxTipsManager.ROLE_STRAW then
        dialogStr = MainValue.infosManager:getObjMultilingualByKey("Dialog_Straw");
    end

    if self:getPositionX() < 0 then
        MainValue.mxTipsManager:showTips(dialogStr, showPos.x, showPos.y + 50, MainValue.mxTipsManager.DIRECTION_RIGHT, signId);
    else
        MainValue.mxTipsManager:showTips(dialogStr, showPos.x, showPos.y + 50, MainValue.mxTipsManager.DIRECTION_LEFT, signId);
    end
end

function MissionsStar:hideTips()
    MainValue.mxTipsManager:hideTips();
end

function MissionsStar:isShowMissionSign(boo)
    if self.signIcon ~= nil and type(boo) == "boolean" then
        if boo then
            MainValue.actionManager:createPopAction():PopUp(self.signIcon);
        else
            MainValue.actionManager:createPopAction():PopUnder(self.signIcon);
        end
    end
end

return MissionsStar;