local MapUI = class("MapUI", function ()
    return cc.Node:create();
end);

function MapUI:ctor()

    self.list = {};
    self:setPosition(60, MainValue.winSize.height - 120);
    
    self.mapUIListener = nil;

    --daily data
    self.dailyInfo = MainValue.dataManager.dailyManager:getSignInList();
    if self.dailyInfo ~= nil then
        self:addDailyIcon();
    end
    
    self.isLogin = MainValue.fbManager:getIsLogin();
    
    if self.isLogin == true then
       self:addRankIcon()
    end
 
    local function upDateEventDaily()
    
        self.dailyInfo = MainValue.dataManager.dailyManager:getSignInList();
        self:addDailyIcon();
    end
    
    local function upDateEventFB()
        self.isLogin = MainValue.fbManager:getIsLogin();
        if self.isLogin == true then
            self:addRankIcon()
        else
            self:removeRankIcon()
            
        end
    end
    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_DAILY, upDateEventDaily);
    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_FRIENDS, upDateEventFB);
    MainValue.eventDispatcher:addEventListener("AD_PRELOADED", function(event)
		-- 更新广告图标的显示状态
		self:updateIcons("ADVisible")
	end)
	MainValue.eventDispatcher:addEventListener("AD_STATE_CHANGED", function(event)
		if event.state == "EXIT" then
			-- 更新广告图标的显示状态
			self:updateIcons("ADVisible")
		end
	end)
    self:addADIcon();
    
    if not MainValue.dataManager.expandManager:getHasBuyStartPackage() then
        self:addStartPackageIcon();
    end
    
    --other
    self:addTouchEvent()
end

function MapUI.create()
    local temp = MapUI.new();
    return temp;
end



--添加daily图标
function MapUI:addDailyIcon()
    local data = MainValue.dataManager.dailyManager:getSignInList();
    if data.state == 1 then
        if self.daily == nil then
            self.daily = cc.Sprite:create("mapIcon/qiandao.png");--createWithSpriteFrameName
            table.insert(self.list,"daily");
            self:addChild(self.daily);
            self:updateIcons();
        end
        
    end

end

--添加排行榜图标
function MapUI:addRankIcon()

    local friendData = MainValue.dataManager.friendManager:getOrderlyFriends();
    if friendData == nil then return end;
    
    if self.rankPanel == nil then
        self.rankPanel = cc.Sprite:create("mapIcon/yaoqinghaoyou.png");
        table.insert(self.list,"rank");
        self:addChild(self.rankPanel);
        self:updateIcons();
    end

    
end

--添加广告图标
function MapUI:addADIcon()
    if self.ADIcon == nil then
        self.ADIcon = cc.Sprite:create("mapIcon/iconAD.png");
        table.insert(self.list,"AD");
        self:addChild(self.ADIcon);
        self:updateIcons();
    end
end

--添加首充礼包图标
function MapUI:addStartPackageIcon()
    if self.startPackageIcon == nil then
        self.startPackageIcon = cc.Sprite:create("mapIcon/libao.png");
        table.insert(self.list,"package");
        self:addChild(self.startPackageIcon);
        self:updateIcons();
    end
end

function MapUI:updateIcons(cate)
	if not cate then
		for i = #(self.list), 1, -1 do
			local y = (i-1)*(-100); 
			if self.list[i]=="rank" then
			    self.rankPanel:setPosition(0,y)
			elseif self.list[i]=="daily" then
			    self.daily:setPosition(0,y)
			elseif self.list[i]=="AD" then
			    self.ADIcon:setPosition(0,y)
            elseif self.list[i]=="package" then
                self.startPackageIcon:setPosition(0,y)
			end
		end
	elseif cate == "ADVisible" and self.ADIcon then
		local adv = advertising:getPlayableAdvertisingWithPlacement("MapIcon")
		self.ADIcon:setVisible(adv ~= nil)
	end
end

function MapUI:removeRankIcon()
    if self.rankPanel~= nil then
        self.rankPanel:removeFromParent(true);
        self.rankPanel = nil;
        self:removeIcon("rank");
    end
end

function MapUI:removeDailyIcon()
    if self.daily~= nil then
        self.daily:removeFromParent(true);
        self.daily = nil;
        self:removeIcon("daily");
        
    end
end

function MapUI:removeADIcon()
    if self.ADIcon~= nil then
        self.ADIcon:removeFromParent(true);
        self.ADIcon = nil;
        self:removeIcon("AD");

    end
end

function MapUI:removeStartPackageIcon()
    if self.startPackageIcon~= nil then
        self.startPackageIcon:removeFromParent(true);
        self.startPackageIcon = nil;
        self:removeIcon("package");

    end
end

--移出数组里面的数据 再刷新
function MapUI:removeIcon(str)
    for i = #(self.list), 1, -1 do
        if self.list[i]== str then
            table.remove((self.list), i)
        end

    end
    self:updateIcons();

end
--打开排行榜
function MapUI:openRankPanel()
    local eventDispatcher2 = self:getEventDispatcher();
    eventDispatcher2:removeEventListener(self.mapUIListener)
    
    local rankPanel = require("ui/rank/GlobelRankPanel");
    local rankUI = rankPanel.create();
    rankUI:appear();
    
    eventDispatcher2:addEventListenerWithSceneGraphPriority(self.mapUIListener, self);
end

function MapUI:showJelly()
    if self == nil or self.daily == nil then
        return;
    end
    
   
    local function cf()
        local function callBack()
            self:showJelly();
        end
        self.daily:runAction(cc.Sequence:create(cc.DelayTime:create(0.5),cc.CallFunc:create(callBack)))
    end

    MainValue.actionManager:createJellyAction():run(self.daily,40, cf);
    
end


--open daily面板
function MapUI:openDailyPanel()
    local dailyPanel = require("ui/dailyBonusMain/DailyBonusMainPanel");
    local dailyUI = dailyPanel.create(MainValue.dataManager.dailyManager:getSignInList());
    dailyUI:appear();
   
end

--open AD面板
function MapUI:openADPanel(ADPos)

    if MainValue.dataManager.adManager:getPopCount(MainValue.dataManager.adManager.VideoAD) >= advertising.maxShowCount then
        return;
    end
    
    MainValue.dataManager.adManager:popAdvertisement(ADPos);

--    local adPanelCls = require("ui/advertisement/ADPanel");
--    local adPanel = adPanelCls.create(ADPos);
--    adPanel:appearAlone();
--    
--    local adLoadingPanelCls = require("ui/advertisement/ADLoadingPanel");
--    local adLoadingPanel = adLoadingPanelCls.create();
--    adLoadingPanel:appearAlone();

--    local rewards ={[1] = {type = "cash", count = 3},[2] = {type = "heart", count = 1}};
--
--    local adRewardsPanelCls = require("ui/advertisement/ADRewardsPanel");
--    local adRewardsPanel = adRewardsPanelCls.create(rewards);
--    adRewardsPanel:appearAlone();
end

--open 首充面板
function MapUI:openStartPackagePanel()
    local startPackage = require("ui.startPackage.StartPackagePanel");
    local startPanel = startPackage.create();
    startPanel:appear();

end

function MapUI:addTouchEvent()

 local function onTouchBlockerBegan(touch, event)
 
--        self:openRankPanel();-- ----测试用的
        local target = event:getCurrentTarget();
        local touchP = self:convertToNodeSpace(touch:getLocation());

        --hit other
        if self.daily ~= nil then
            local dailySize = self.daily:getContentSize();
            local dailyRect = cc.rect(self.daily:getPositionX()-(dailySize.width/2), self.daily:getPositionY()-(dailySize.height/2), dailySize.width, dailySize.height);
            if cc.rectContainsPoint(dailyRect, touchP) then
                self.onTouchName = "daily";
                return true;
            end
        end
       
        if self.rankPanel ~= nil then
            local rankSize = self.rankPanel:getContentSize();
            local rankRect = cc.rect(self.rankPanel:getPositionX()-(rankSize.width/2), self.rankPanel:getPositionY()-(rankSize.height/2), rankSize.width, rankSize.height);
            if cc.rectContainsPoint(rankRect, touchP) then
                self.onTouchName = "rank";
                return true;
            end
        
        end
        
        if self.ADIcon ~= nil and self.ADIcon:isVisible() then
            local adSize = self.ADIcon:getContentSize();
            local adRect = cc.rect(self.ADIcon:getPositionX()-(adSize.width/2), self.ADIcon:getPositionY()-(adSize.height/2), adSize.width, adSize.height);
            if cc.rectContainsPoint(adRect, touchP) then
                self.onTouchName = "AD";
                return true;
            end

        end
        
        if self.startPackageIcon ~= nil and self.startPackageIcon:isVisible() then
            local adSize = self.startPackageIcon:getContentSize();
            local adRect = cc.rect(self.startPackageIcon:getPositionX()-(adSize.width/2), self.startPackageIcon:getPositionY()-(adSize.height/2), adSize.width, adSize.height);
            if cc.rectContainsPoint(adRect, touchP) then
                self.onTouchName = "package";
                return true;
            end

        end
        return false;
    end
    
    
    
    local function onTouchBlockerMoved(touch, event)
    end
    
    
    local function onTouchBlockerEnded(touch, event)
        if MainValue.mxUIManager.mapManager:getIsTouch() == false then
            return;
        end

        if self.onTouchName == "daily" then
            self:openDailyPanel();

        elseif self.onTouchName == "rank" then
            self:openRankPanel();

        elseif self.onTouchName == "AD" then
            self:openADPanel("MapIcon");

        elseif self.onTouchName == "package" then
            self:openStartPackagePanel();
        end
    end

    local listener2 = cc.EventListenerTouchOneByOne:create();
    listener2:setSwallowTouches(true);
    listener2:registerScriptHandler(onTouchBlockerBegan,cc.Handler.EVENT_TOUCH_BEGAN );
    listener2:registerScriptHandler(onTouchBlockerMoved,cc.Handler.EVENT_TOUCH_MOVED );
    listener2:registerScriptHandler(onTouchBlockerEnded,cc.Handler.EVENT_TOUCH_ENDED );
    local eventDispatcher2 = self:getEventDispatcher();
    eventDispatcher2:addEventListenerWithSceneGraphPriority(listener2, self);
    
    self.mapUIListener = listener2;

end

return MapUI;