local OpeningAnimation = class("OpeningAnimation",function()
    return cc.Layer:create();
end
)

local postions1 = {cc.p(670,507),cc.p(320,607),cc.p(462,910),cc.p(300,158),cc.p(510,774),cc.p(480,1070)};

local postions2 = {cc.p(760,290),cc.p(172,400),cc.p(674,700),cc.p(625,987),cc.p(450,1022)};

local postions3 = {cc.p(504,877),cc.p(412,422),cc.p(475,815)};

local gapTime  = 0

function OpeningAnimation:ctor()    
    self.playId = 0;    
    self:setContentSize(768,1214);

    local color4B = cc.c4b(0,0,0,102);
    self.maskBg = cc.LayerColor:create(color4B,768,1214);
    self:addChild(self.maskBg);

    self.bgOneLayer = cc.Sprite:create()
    self.bgOneLayer:setContentSize(768,1214)


    self.bgTwoLayer = cc.Sprite:create()
    self.bgTwoLayer:setContentSize(768,1214)


    self.bgThreeLayer = cc.Sprite:create()
    self.bgThreeLayer:setContentSize(768,1214)
    
    local offsetX = 0
    local offsetY = 0
    if MainValue.winSize.width <= 768 then
        offsetX = 768 - MainValue.winSize.width
    else
        offsetX = MainValue.winSize.width - 768
    end
    
    
    if MainValue.winSize.height <= 1214 then
        offsetY = 1214 - MainValue.winSize.height
    else
        offsetY = MainValue.winSize.height - 1214
    end
    


    self.bg1 = cc.Sprite:create("armature/openingAnimation/openingImg1.jpg");
    self.bg1:setPosition(VisibleRect:center().x+(offsetX)*0.5,VisibleRect:center().y+(offsetY)*0.5)
    self.bgOneLayer:addChild(self.bg1);


    self.animal_1_01 = ccs.Armature:create("pic1_01");    
    self.animal_1_01:getAnimation():play("1", -1, 1);
    self.animal_1_01:setPosition(postions1[1])
    self.bgOneLayer:addChild(self.animal_1_01)

    self.animal_1_02 = ccs.Armature:create("pic1_02");
    self.animal_1_02:getAnimation():play("1", -1, 1);
    self.animal_1_02:setPosition(postions1[2])
    self.bgOneLayer:addChild(self.animal_1_02)


    self.animal_1_03 = ccs.Armature:create("pic1_03");
    self.animal_1_03:getAnimation():play("1", -1, 1);
    self.animal_1_03:setPosition(postions1[3])
    self.bgOneLayer:addChild(self.animal_1_03)


    self.animal_1_04 = ccs.Armature:create("pic1_04");
    self.animal_1_04:getAnimation():play("1", -1, 1);
    self.animal_1_04:setPosition(postions1[4])
    self.bgOneLayer:addChild(self.animal_1_04)

    self.animal_1_05 = ccs.Armature:create("pic1_05");
    self.animal_1_05:getAnimation():play("1", -1, 1);
    self.animal_1_05:setPosition(postions1[5])
    self.bgOneLayer:addChild(self.animal_1_05)

    self.animal_1_06 = ccs.Armature:create("pic1_06");
    self.animal_1_06:getAnimation():play("1", -1, 1);
    self.animal_1_06:setPosition(postions1[6])
    self.bgOneLayer:addChild(self.animal_1_06)




    self.bg2 = cc.Sprite:create("armature/openingAnimation/openingImg2.jpg");
    self.bg2:setPosition(VisibleRect:center().x+(offsetX)*0.5,VisibleRect:center().y+(offsetY)*0.5)
    self.bgTwoLayer:addChild(self.bg2);

    self.animal_2_01 = ccs.Armature:create("pic2_01");
    self.animal_2_01:getAnimation():play("1", -1, 1);
    self.animal_2_01:setPosition(postions2[1])
    self.bgTwoLayer:addChild(self.animal_2_01)

    self.animal_2_02 = ccs.Armature:create("pic2_02");
    self.animal_2_02:getAnimation():play("1", -1, 1);
    self.animal_2_02:setPosition(postions2[2])
    self.bgTwoLayer:addChild(self.animal_2_02)

    self.animal_2_03 = ccs.Armature:create("pic2_03");
    self.animal_2_03:getAnimation():play("1", -1, 1);
    self.animal_2_03:setPosition(postions2[3])

    self.bgTwoLayer:addChild(self.animal_2_03)

    self.animal_2_04 = ccs.Armature:create("pic2_04");
    self.animal_2_04:getAnimation():play("1", -1, 1);
    self.animal_2_04:setPosition(postions2[4])
    self.bgTwoLayer:addChild(self.animal_2_04)

    self.animal_2_05 = ccs.Armature:create("pic2_05");
    self.animal_2_05:getAnimation():play("1", -1, 1);
    self.animal_2_05:setPosition(postions2[5])
    self.bgTwoLayer:addChild(self.animal_2_05) 



    self.bg3 = cc.Sprite:create("armature/openingAnimation/openingImg3.jpg");
    self.bg3:setPosition(VisibleRect:center().x+(offsetX)*0.5,VisibleRect:center().y+(offsetY)*0.5)
    self.bgThreeLayer:addChild(self.bg3);

    self.animal_3_01 = ccs.Armature:create("pic3_01");
    self.animal_3_01:getAnimation():play("1", -1, 1);
    self.animal_3_01:setPosition(postions3[1])
    self.bgThreeLayer:addChild(self.animal_3_01)

    self.animal_3_02 = ccs.Armature:create("pic3_02");
    self.animal_3_02:getAnimation():play("1", -1, 1);
    self.animal_3_02:setPosition(postions3[2])
    self.bgThreeLayer:addChild(self.animal_3_02)

    self.animal_3_03 = ccs.Armature:create("pic3_03");
    self.animal_3_03:getAnimation():play("1", -1, 1);
    self.animal_3_03:setPosition(postions3[3])
    self.bgThreeLayer:addChild(self.animal_3_03)

    self.bgThreeLayer:setPosition(VisibleRect:center().x+(offsetX)*0.5,VisibleRect:center().y+(offsetY)*0.5)
    self.bgTwoLayer:setPosition(VisibleRect:center().x+(offsetX)*0.5,VisibleRect:center().y+(offsetY)*0.5)
    self.bgOneLayer:setPosition(VisibleRect:center().x+(offsetX)*0.5,VisibleRect:center().y+(offsetY)*0.5)

    self:addChild(self.bgThreeLayer)
    self:addChild(self.bgTwoLayer)

    self.bgTwoLayer:setCascadeOpacityEnabled(true)
    self.bgTwoLayer:setOpacity(0)--//渐隐

    self.bgThreeLayer:setCascadeOpacityEnabled(true)
    self.bgThreeLayer:setOpacity(0)--//渐隐


    self.bgOneLayer:setCascadeOpacityEnabled(true)
    self.bgOneLayer:setOpacity(0)--//渐隐
    self:addChild(self.bgOneLayer)

    self:fadeIn(self.bgOneLayer)


    local function onTouchBgBegan(touch, event)
        if touch == nil or event == nil then
            return false
        end
        return true
    end



    self.layerEventListener = cc.EventListenerTouchOneByOne:create();
    self.layerEventListener:setSwallowTouches(true);
    self.layerEventListener:registerScriptHandler(onTouchBgBegan,cc.Handler.EVENT_TOUCH_BEGAN );
    self.layerEventListener:registerScriptHandler(function()
        if self.playId == 0 then   
            self.playId = 1
            self.bgOneLayer:removeFromParent(true)
            self:fadeIn(self.bgTwoLayer)
        elseif self.playId ==1 then
            self.playId =2
            self.bgTwoLayer:removeFromParent(true)
            self:fadeIn(self.bgThreeLayer)
        elseif self.playId==2 then
            self.playId =3
            self.bgThreeLayer:removeFromParent(true)
            --                self:GC()
            self.animationComplete()
        end        
        print("[OpeningAnimation]--onTouchBgEnded")
    end
    ,cc.Handler.EVENT_TOUCH_ENDED );

    self.eventDispatcher = self:getEventDispatcher();
    self.eventDispatcher:addEventListenerWithSceneGraphPriority(self.layerEventListener, self);

end;

function OpeningAnimation.create(animationComplete)
    local animation = OpeningAnimation.new();
    animation.animationComplete = animationComplete;
    return animation;
end;

function OpeningAnimation:play()

    local function tick(spendTime)
        gapTime = gapTime + spendTime;
        if gapTime >= 7 then
            if self.playId == 0 then   
                gapTime = 0
                self.playId = 1
                self.bgOneLayer:removeFromParent(true)
                self:fadeIn(self.bgTwoLayer)
            elseif self.playId ==1 then
                gapTime = 0
                self.playId =2
                self.bgTwoLayer:removeFromParent(true)
                self:fadeIn(self.bgThreeLayer)
            elseif self.playId==2 then
                gapTime = 0
                self.playId =3
                self.bgThreeLayer:removeFromParent(true)
                self.animationComplete()
            end 
        end
    end
    self.schedulerID = cc.Director:getInstance():getScheduler():scheduleScriptFunc(tick, 0, false)
end
function OpeningAnimation:fadeOut(uiNode)
    if uiNode == nil then return end;
    local function callFun()
        if uiNode == nil then return end;
        uiNode:removeFromParent();
    end
    local action = cc.FadeOut:create(1.2);
    uiNode:runAction(cc.Sequence:create(action, cc.CallFunc:create(callFun)));
end

function OpeningAnimation:fadeIn(uiNode)

    if uiNode == nil then return end;
    local function callFun()
        if self.playId == 0 then
            gapTime = 0     
            self:play()
        end
    end
    local action = cc.FadeIn:create(0.5);
    uiNode:runAction(cc.Sequence:create(action, cc.CallFunc:create(callFun)));
end

function OpeningAnimation:GC()
    self:stopAllActions();
    self:removeAllChildren();
    self:removeFromParent(true);
end;

return OpeningAnimation;