require "ui.threeStar.ThreeStar"
require "ui.panelManager.PanelManager"
require "ui.friendRank.FriendRankPanel"
require "ui.playGamePanel.frontprops.FrontPropsData"
require "ui.playGamePanel.frontprops.FrontPropsPanel"
require("data/buydata/BuyFlowData")
PlayGamePanel = class("PlayGamePanel", function()
    return cc.Node:create();
end);

function PlayGamePanel:ctor()
--    处理前置道具 2015 - 1 - 5
    self.frontPropsData = FrontPropsData.new()    
    
    local function closeSelf()
        self:onClose()
    end
    self.frontPropsPanel = FrontPropsPanel.new(closeSelf)    
    self.frontPropsPanel:setData(self.frontPropsData:getFrontPropsAry())

    self.level =  0;    
    self.threeStar = nil;
    self.curLvData = nil;
    
    self.rankPanel = nil;
    
    self.isPlay = false;
    
    self.callBack = nil; --连接  facebook 融合数据后回调
    
    self.upPanel = nil;
end

function PlayGamePanel.create(level)
    MainValue.SELECTED_LEVEL = level;
    
    local playGamePanel = PlayGamePanel.new();    
    playGamePanel.level = level;
    playGamePanel:init();
    return playGamePanel;
end

function PlayGamePanel:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height/ 2);
    
    self.upPanel = ccs.GUIReader:getInstance():widgetFromJsonFile("ui/PlayGamePanel.json");
    self.upPanel:setPositionY(MainValue.winSize.height/ 2);
    self:addChild(self.upPanel);
    
    local closebtn = self.upPanel:getChildByName("btnClose");

    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self.frontPropsPanel:recoverNum()
            self:onClose();
        end
    end

    closebtn:addTouchEventListener(touchEvent);
    
    local levelS = MainValue.infosManager:getObjMultilingualByKey("Common_level")
    levelS = string.gsub(levelS, "%b{}", self.level)

    local titleLab = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, levelS)
    self.upPanel:addChild(titleLab);
    titleLab:setPosition(3, 390);

    local btnPlay = self.upPanel:getChildByName("btnPlay");
    local playLab = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("Common_play"));
    btnPlay:addChild(playLab);
    playLab:setPosition(160, 60);
    

    -- touchEvent 触摸事件回调方法
    local function btnPlayTouchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(sender,40);
            self:onPlay();
        end
    end

    btnPlay:addTouchEventListener(btnPlayTouchEvent);

    local _panelStar = self.upPanel:getChildByName("panelStar")
    self.curLvData = MainValue.mxGameManager:getStarsStatus();
    
    self.threeStar = ThreeStar.create(2, self.curLvData)
    self.threeStar:setPositionY(59)
    _panelStar:addChild(self.threeStar)

    local _oldScore = nil;
    local _oldStarNum = nil;
    _oldScore, _oldStarNum = MainValue.dataManager.levelManager:getLevel(self.level); -- [[获取历史最好成绩]]
    self.threeStar:setData(_oldStarNum)


    self.rankPanel = FriendRankPanel.create();
    self.rankPanel:setData(self.level);
    self:addChild(self.rankPanel);
    
    self.frontPropsPanel:setPosition(-160,-75)
    self.upPanel:addChild(self.frontPropsPanel)
    self.frontPropsPanel:retain()
    
    local function updataRank()
        if self.rankPanel ~= nil then
            self.rankPanel:disappear();
        end

        self.rankPanel = FriendRankPanel.create();
        self.rankPanel:setData(self.level);
        self:addChild(self.rankPanel);

        self.rankPanel:appear();
    end

    self.callBack = updataRank;
    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_FRIENDS, updataRank);
end

function PlayGamePanel:onPlay()
    MainValue.mxFTUEManager:removeFtue();
    
    if MainValue.dataManager.userManager:getHeart() >= 1 then
        self.isPlay = true;
        self:onClose();
    else
        local notEnoughLifes = require("ui/NotEnoughLife")
        local notEnoughLife = notEnoughLifes.create()
        notEnoughLife:appearAlone()
    end
end

function PlayGamePanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.NONE, self.appearComplete, self.onClose);
end

function PlayGamePanel:appearComplete()
    local winSizeHeight = MainValue.winSize.height / 2;

    local function action2(node)
        node:stopAllActions() --After this stop next action not working, if remove this stop everything is working

        local ac3 = nil;
        ac3 = cc.Sequence:create(cc.EaseOut:create(cc.MoveBy:create(0.1,cc.p(0, 10)), 0.3));
        node:runAction(ac3);
    end

    local ac = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.2,cc.p(0, - winSizeHeight - 10)), 0.3), cc.CallFunc:create(action2));
    self.upPanel:runAction(ac);
    
    self.rankPanel:appear();

    if MainValue.SELECTED_LEVEL == 5 then
        
        MainValue.mxFTUEManager:showFtueById(51);
    elseif MainValue.SELECTED_LEVEL == 6 then
        MainValue.mxFTUEManager:showFtueById(61);
    elseif MainValue.SELECTED_LEVEL == 11 then
        MainValue.mxFTUEManager:showFtueById(111);
    elseif MainValue.SELECTED_LEVEL == 12 then
        MainValue.mxFTUEManager:showFtueById(121);
    elseif MainValue.SELECTED_LEVEL == 20 then
        MainValue.mxFTUEManager:showFtueById(201);
    end
end

function PlayGamePanel:onClose()
    local function callFun()
        self:disapper();
    end
    local winSizeHeight = MainValue.winSize.height;
    local disAc1 = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.15,cc.p(0, winSizeHeight)), 0.8),cc.CallFunc:create(callFun));
    self.upPanel:runAction(disAc1);
    
    self.rankPanel:disappear();
end

function PlayGamePanel:disapper()
    local tarTable = self.frontPropsPanel:getTarSelectedIds()
    if table.maxn(tarTable) ~= 0  and self.isPlay then
        MainValue.mxGameManager:palyGameSetFrontProps(self.frontPropsPanel:getTarSelectedIds());
        
        for index = 1,table.maxn(self.frontPropsPanel:getTarSelectedIds()) do
            self.good = MainValue.infosManager:getObjGoodsById(self.frontPropsPanel:getTarSelectedIds()[index]);
            
            MainValue.statisticsManager:consumeBuyPreItem(self.good.id, 1, 0, 0, MainValue.SELECTED_LEVEL, MainValue.dataManager.userManager:getHeart(), 0, MainValue.dataManager.userManager:getCash(), -1);
        end
       
        
    end
    
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.NONE , self.disapperComplete)
end

function PlayGamePanel:disapperComplete()
    MainValue.eventDispatcher:removeEventListener(MainValue.eventDispatcher.eventType.EVENT_FRIENDS, self.callBack);

    if self.isPlay then
    
        local function enterGame()
           -- 
           MainValue.statisticsManagerOG:Access(); --OG
            -- 2015-6-18 暂时注释  
            MainValue.statisticsManagerOG:levelStart(MainValue.dataManager.levelManager:getMaxLevel(), -1, -1, -1, -1); --OG
            -- 2015-6-18 暂时注释  
            MainValue.statisticsManagerOG:levelLife(MainValue.dataManager.userManager:getHeart(), -1); --OG
            -- 2015-6-18 暂时注释  
            MainValue.statisticsManagerOG:levelCurrency(MainValue.dataManager.userManager:getCash(), -1, -1); --OG
        
            MainStatus:onExitMap();
            MainStatus:onEnterGame();
        --TODO:::  --传给游戏内部选中的前置道具ids
           -- MainValue.mxGameManager:enterGame();
            MainValue.mxLoadingManager:removeLoading();
        end;
        MainValue.mxLoadingManager:addLoading();
        MainValue.mxLoadingManager:loadGame(MainValue.SELECTED_LEVEL,enterGame);
    end
    
  
    
    if self.isPlay == nil or self.isPlay == false then
       
        if BuyFlowValue.outBuyAry ~= nil and BuyFlowValue.outBuyAry[1]~=nil and BuyFlowValue.outBuyAry[1].typeId == BuyFlowValue.playGamePanel then
            self.frontPropsPanel:recoverNum()
            local isBuyItem = require("ui/inGame/IsBuyItemPanel")
            local isBuyItemPanel = isBuyItem.create(BuyFlowValue.outBuyAry[1]:getGoodsId())
            isBuyItemPanel:appear();    
            
            
            local tmpBuyFlowData = BuyFlowData.new(BuyFlowValue.buyItemPanel)
            tmpBuyFlowData:setGoodsId(BuyFlowValue.outBuyAry[1]:getGoodsId())
            BuyFlowValue.outBuyAry[2] = tmpBuyFlowData
            
            
            
        end
    end
    
    self:removeFromParent(true);
end

return PlayGamePanel