require("engine.uigridtools.NineGridTools")
local GlobelRankCell = class("GlobelRankCell",function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/GlobelRankCell.json")
end)
function GlobelRankCell:ctor()
    self.cellBg = nil;
    self.rank = 1;--名次
    self.fname = "wang xiaoxiao"--名字
    self.fstarNum = "288";--心数
    self.fLevel = "14";--级别
    self.headUrl = nil;--头像链接
    self.id = nil;
    
end

function GlobelRankCell.create(index,rankData,myRank)
        
    local rankCell = GlobelRankCell.new();
    rankCell.rankData = rankData;
    rankCell.fname = rankCell.rankData.name;
    rankCell.fstarNum = rankCell.rankData.maxStar;
    rankCell.headUrl = rankCell.rankData.picture;
    rankCell.fLevel = rankCell.rankData.maxLevel;
    rankCell.id =   rankCell.rankData.id;
    
    rankCell.fLevel = tonumber(rankCell.fLevel) - 1;
    if tonumber(rankCell.fLevel) < 0 then
        rankCell.fLevel = 0;
    end
    if MainValue.dataManager.userManager:getPID() == rankCell.id then
       rankCell.fname = "Me";
    end
    
    if index == 0 then
        rankCell.rank = myRank;
        rankCell.cellBg = NineGridTools.create("ui/ui/rankMeBg.png",468, 134,27);
    else
        rankCell.rank = index;
        if MainValue.dataManager.userManager:getPID() == rankCell.id then
            rankCell.cellBg = NineGridTools.create("ui/ui/rankBgUp.png",468, 128,27);
        else
            rankCell.cellBg = NineGridTools.create("ui/ui/bgCell2.png",468, 128,27);
        end
        
    end
    
    rankCell.cellBg:setPosition(539/2 - 34,60);
    rankCell:addProtectedChild(rankCell.cellBg,0);
    
    local headBg = rankCell:getChildByName("HeadBg");
    local headIcon = nil;
    local function headFunc(id, url)
        headIcon:release();
    end
    headIcon = cc.Sprite:create();
    headIcon:setContentSize(76, 76);
    headIcon:setPosition(95.5, 74);
    headIcon:retain();
    rankCell:addProtectedChild(headIcon,2)
    
    MainValue.platformManager:FBloadImage(rankCell.id, rankCell.headUrl, headIcon, headFunc)
    
    if rankCell.rank == 1 then
        local huangguan= cc.Sprite:createWithSpriteFrameName("ui/ui/rankFirst.png");
        huangguan:setPosition(-22+huangguan:getContentSize().width/2,57+huangguan:getContentSize().height/2);
       headBg:addChild(huangguan);
    end
    
    local rankOld = rankCell:getChildByName("rankText");
    local rankRes = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,rankCell.rank);
    rankRes:setScale(0.7);
    rankRes:setAnchorPoint(0,0.5);
    rankRes:setPosition(rankOld:getPosition());
    rankCell:addChild(rankRes);
    rankOld:removeFromParent(true);
    
    
    local nameOld = rankCell:getChildByName("fName");
    local fname = FacFont:getFontsBmp(FontType.FontRed,rankCell.fname);
    fname:setAnchorPoint(0,0.5);
    fname:setPosition(nameOld:getPosition());
    rankCell:addChild(fname);
    nameOld:removeFromParent(true);  
    
    local starNum = rankCell:getChildByName("starNum");
    local fStarNum = FacFont:getFontsBmp(FontType.FontYellowWhiteSide,rankCell.fstarNum);
    fStarNum:setAnchorPoint(0,0.5);
    fStarNum:setPosition(starNum:getPosition());
    rankCell:addChild(fStarNum);
    starNum:removeFromParent(true);  
    
    local rankIcon = rankCell:getChildByName("rankIcon");
    if index == 0 then
        rankIcon:setPosition(rankIcon:getPositionX(),rankIcon:getPositionY()+6);
    end
    local lv = rankIcon:getChildByName("lvText");
    local levelStr = "lv"..rankCell.fLevel;
    local lvNew = FacFont:getFontsBmp(FontType.FontWhite,levelStr);
    lvNew:setPosition(lv:getPosition());
    rankIcon:addChild(lvNew);  
    lv:removeFromParent(true);
    
    
    rankCell:setContentSize(500,129);
    return rankCell;

end

function GlobelRankCell:GC()
    if self.cellBg ~= nil then
        self.cellBg:removeFromParent(true);
        self.cellBg = nil;
    end
end


return GlobelRankCell  