require "ui.rank.GlobelRankCell";
local GlobelRankPanel = class("GlobelRankPanel",function()
   return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/GlobelRankPanel.json")
end)

function GlobelRankPanel:ctor()
    self.debug = false
    self.listView = nil;
    self.LISTVIEW_HEIGTH = nil;
    self.cellList = {};
end
function GlobelRankPanel.create()
   local rankPanel = GlobelRankPanel.new();
    rankPanel:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);
    
    local titleLB = rankPanel:getChildByName("title")
    local title = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,"Leaderboard")
    title:setPosition(titleLB:getPosition())
    rankPanel:addChild(title)
    titleLB:removeFromParent(true);
    
    rankPanel.rankData, rankPanel.myRank  = MainValue.dataManager.friendManager:getOrderlyFriends();
    
    if rankPanel.debug then
        rankPanel.myRank = 1;
        rankPanel.rankData  = {
            {name = "Lolly", maxStar = 100, picture = "head1.png",maxLevel = "56",id = "1"},
            {name = "Collin", maxStar = 80, picture = "head2.png",maxLevel = "54",id = "1"},
            {name = "Coco ", maxStar = 50, picture = "head3.png",maxLevel = "52",id = "1"},
            {name = "Richard", maxStar = 30, picture = "head4.png",maxLevel = "32",id = "1"},
            {name = "Douglas", maxStar = 20, picture = "head5.png",maxLevel = "22",id = "1"},
            {name = "Moai", maxStar = 10, picture = "head7.png",maxLevel = "1",id = "1"}
        }
        rankPanel.selfData = {name = "Me", maxStar = 80, picture = "head2.png",maxLevel = "54",id = "1"};
  
    else
        if rankPanel.rankData == nil then
            local notice = FacFont:getFontsBmp(FontType.FontRed,"Sorry, the connect failed");
            rankPanel:addChild(notice)            
        end
        if rankPanel.rankData ~= nil then
            rankPanel.selfData  = {
                ["id"]       = MainValue.dataManager.userManager:getPID(),
                ["name"]     = "Me",--MainValue.dataManager.userManager:getName(),
                ["username"] = MainValue.dataManager.userManager:getUserName(),
                ["picture"]  = MainValue.dataManager.userManager:getPicture(),
                ["maxLevel"] = MainValue.dataManager.levelManager.getMaxLevel(),
                ["maxStar"]  = MainValue.dataManager.levelManager.getMaxStar()
            }
        end
    end
    
    if rankPanel.rankData ~= nil then
        rankPanel.listView = rankPanel:getChildByName("ListView");
        for i in pairs(rankPanel.rankData) do
            local cellLz = require("ui/rank/GlobelRankCell");
            local cell = cellLz.create(i,rankPanel.rankData[i]);
            local layout = ccui.Layout:create();
            rankPanel.listView:addChild(cell);
            rankPanel.cellList[i] = cell;
        end
    
        
        local myRankCell = require("ui/rank/GlobelRankCell");
        local myCell = myRankCell.create(0,rankPanel.selfData,rankPanel.myRank);
        myCell:setPosition(-539/2 + 31,142*(-1)-211 - 16);
        rankPanel:addChild(myCell);
        
        
       
       --滚动条 
      
        rankPanel.LISTVIEW_HEIGTH = rankPanel.listView:getContentSize().height;
        rankPanel.listView:setBounceEnabled(false);
   end
    
    local closeBtn = tolua.cast(rankPanel:getChildByName("closeBtn"), "ccui.Button")
    closeBtn:getParent():removeChild(closeBtn)
    rankPanel:addChild(closeBtn,2)

    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            rankPanel:disapper();
        end
    end
    closeBtn:addTouchEventListener(touchEvent);
    
   return rankPanel;
end

function GlobelRankPanel:updata(pY)
    local curPage = math.floor(math.abs(pY / self.LISTVIEW_HEIGTH));

 --   self.pointIcon:setPositionX(self.pStartX + curPage * self.POINT_SPACE);

end

function GlobelRankPanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disapper);
    
end

function GlobelRankPanel:appearComplete()
    
end

function GlobelRankPanel:disapper()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_DOWN , self.disapperComplete)
end

function GlobelRankPanel:disapperComplete()
    self:GC();
    self:removeFromParent(true);
end

function GlobelRankPanel:GC()
    for i in pairs(self.cellList) do
        self.cellList[i]:GC();
    end
    self.cellList = nil;
    if self.listView ~= nil then
        self.listView:removeFromParent();
        self.listView = nil;
    end
    
end

return GlobelRankPanel