local StartPackagePanel = class("StartPackagePanel", function() 
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/StartPackage.json");
end)

function StartPackagePanel:ctor()
    self.isBuy = false;
    self.goodsIdsList = storeConfig.startpackage; --锤子、火箭（竖）、位置变换
end

function StartPackagePanel.create()
    local temp = StartPackagePanel.new()
    temp:init()
    return temp;
end

function StartPackagePanel:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);
    
    local closebtn = self:getChildByName("BtnClose");

    -- touchEvent 触摸事件回调方法
    local function onClose( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:disapper();
        end
    end
    closebtn:addTouchEventListener(onClose);
    
    local titleLab = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, MainValue.infosManager:getObjMultilingualByKey("StartPackage_Title"))
    self:addChild(titleLab);
    titleLab:setPosition(-5, 355);
    
    local getBtn = self:getChildByName("BtnGet");
    
    local function onGet( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self.isBuy = true;
            self:disapper();
        end
    end
    getBtn:addTouchEventListener(onGet);
    
    local getBtnTxt = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("StartPackage_Btn"))
    getBtnTxt:setPosition(176, 63);
    getBtn:addChild(getBtnTxt);
    
    for i = 1, #self.goodsIdsList do
        local goodsIcon = cc.Sprite:create("ui/prop/big/" .. tostring(self.goodsIdsList[i].id) ..".png");
        goodsIcon:setPosition(-133 + 145 * (i - 1) ,-78);
        goodsIcon:setScale(0.85)
        self:addChild(goodsIcon);
        
        local countTxt = FacFont:getFontsBmp(FontType.FontYellowWhiteSide, tostring(self.goodsIdsList[i].num) )
        countTxt:setPosition(-133 + 145 * (i - 1), -138);
        self:addChild(countTxt);
    end
    
    local plusLeft = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, "+")
    plusLeft:setPosition(-57, -43);
    self:addChild(plusLeft); 
    
    local plusRight = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, "+")
    plusRight:setPosition(82, -43);
    self:addChild(plusRight); 
end

function StartPackagePanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disapper);
end

function StartPackagePanel:disapper()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_DOWN , self.disapperComplete)
end

function StartPackagePanel:disapperComplete()
    if self.isBuy then
--        MainValue.dataManager.expandManager:setHasBuyStartPackage();
--        MainValue.mxUIManager.mapUI:removeStartPackageIcon();
        MainValue.iapEnManager:buy("6");
    end

    self:removeFromParent(true);
end

return StartPackagePanel;