

local StoreCell = class("StoreCell",function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/StoreCell.json")
end)

function StoreCell:ctor()
    self.id = nil;
    self.cash = nil;
    self.coin = nil;
    self.dollar = nil;
    self.fb = nil;
    self.rebate = nil;
    self.pos = nil;
    
    self.cashTitle = nil;--此物品包含多少cash
    self.cashNum = nil;--此物品的价格为多少cash
    self.offPrice = nil;--此物品打多少折
    self.extraText = nil;
    self.imgIcon = nil;
    self.cellBg = nil;
    
    self.choice = nil;
    self.bestDeal = nil;
end

function StoreCell.create(callBack,parent)
    local thisUI = StoreCell.new()
    thisUI.callBack = callBack;
    thisUI.parent = parent;
    thisUI:setContentSize(540,127);
    return thisUI
end

function StoreCell:init(info)

    
    self.id = info.id;
    self.cash = info.cash;
    self.coin = info.coin;
    self.dollar = info.dollar;
    self.fb = info.fb;
    self.rebate = info.rebate;
    self.pos = info.pos;
    self:initData();

end

function StoreCell:initData()
   local titleText = self:getChildByName("TitleLabel");
   local buyBtn = self:getChildByName("BuyBtn");
   local CostLabel = buyBtn:getChildByName("CostLabel");

   local LabelImg = self:getChildByName("LabelImg");
   local zhekouImg =  LabelImg:getChildByName("zhekou");
   local offImg = LabelImg:getChildByName("offText");
   
   
   self.cellBg = NineGridTools.create("ui/ui/bgCell2.png",480, 134,27);
   self.cellBg:setPosition(3,2);
   self.cellBg:setAnchorPoint(0.5,0.5);
   self:addProtectedChild(self.cellBg,0)
    
   if self.imgIcon == nil then
        local str = "ui/store/n_"..self.id..".png"-- string:format("store/s_%s.png",self.id);
        
        self.imgIcon = cc.Sprite:createWithSpriteFrameName(str);
        self.imgIcon:setPosition(-163,17);
        self.imgIcon:setScale(0.8,0.8)
        self:addChild(self.imgIcon);
   end
   
   if self.cashTitle == nil then
        self.cashTitle = FacFont:getFontsBmp(FontType.FontSmallWhiteBrownSide,self.cash)
        self.cashTitle:setPosition(titleText:getPosition());
        self.cashTitle:setPositionY(self.cashTitle:getPositionY()-8);
        titleText:getParent():addChild(self.cashTitle);
   end
   
   if self.cashNum == nil then
        local str = "$" ..self.dollar;
        self.cashNum = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,str);
        self.cashNum:setScale(0.8);
        self.cashNum:setPosition(CostLabel:getPosition());
        CostLabel:getParent():addChild(self.cashNum);

   end
   
   if self.rebate == "0" then
      LabelImg:setVisible(false);
   end
   
   if self.offPrice == nil then
        self.offPrice = FacFont:getFontsBmp(FontType.FontRed,self.rebate);
        self.offPrice:setScale(0.7,0.7);
        self.offPrice:setPosition(zhekouImg:getPosition());
        zhekouImg:getParent():addChild(self.offPrice);
        self.offPrice:setRotation(zhekouImg:getRotation());

   end
   
   if self.extraText == nil then
        self.extraText = FacFont:getFontsBmp(FontType.FontRed,"Extra");
        self.extraText:setScale(0.7,0.7);
        self.extraText:setPosition(offImg:getPosition());
        zhekouImg:getParent():addChild(self.extraText);
        self.extraText:setRotation(offImg:getRotation());
   end
   
   if self.id == "3" then
        self.choice = cc.Sprite:createWithSpriteFrameName("ui/store/Choice.png");
        self.choice:setPosition(-212,46);
        self.choice:setScale(0.9,0.9);
        self:addChild(self.choice);
   end
   if self.id == "1" then
        self.bestDeal = cc.Sprite:createWithSpriteFrameName("ui/store/bestdeal.png");
        self.bestDeal:setPosition(-212,48);
        self.bestDeal:setScale(0.9,0.9)
        self:addChild(self.bestDeal); 
   end
   
   
   
    local function onClick(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
             
           MainValue.iapEnManager:buy(self.id);
   
        end
        
        
    end
    buyBtn:addTouchEventListener(onClick);
   self:setTouchEnabled(false);
   
end


function StoreCell:GC()

    if self.cellBg ~= nil then
        self.cellBg:removeFromParent(true);
        self.cellBg = nil;
    end
    if self.choice ~= nil then
        self.choice:removeFromParent(true);
        self.choice = nil;
    end
    if self.bestDeal ~= nil then
        self.bestDeal:removeFromParent(true);
        self.bestDeal = nil;
    end
    
    if self.cashTitle ~= nil then
        self.cashTitle:removeFromParent(true);
        self.cashTitle = nil;
    end
    
    if self.cashNum ~= nil then
        self.cashNum:removeFromParent(true);
        self.cashNum = nil;
    end
    
    if self.offPrice ~= nil then
        self.offPrice:removeFromParent(true);
        self.offPrice = nil;
    end
    
    if self.extraText ~= nil then
        self.extraText:removeFromParent(true);
        self.extraText = nil;
    end
    
    if self.imgIcon ~= nil then
        self.imgIcon:removeFromParent(true);
        self.imgIcon = nil;
    end
    self:removeFromParent(true);
end

return StoreCell  