require "config.storeConfig"
require "data/buydata/BuyFlowData" 
require "ui.playGamePanel.PlayGamePanel"
local StoreUI = class("StoreUI",function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/StoreUI.json")
end)

function StoreUI:ctor()

  self.cellList = {};
  --触发类型 1：道具触发
 -- self.formType = nil;
  --触发类型所带数据
  --self.formData = nil;
  
-- self.isSuc = 0;
-- self.id = 0

    self.needBackOtherPanel = false; --关闭商城后是否需要回到其他面板（如果不需要，弹出广告面板）
   
end

function StoreUI.create()
    local thisUI = StoreUI.new();
    thisUI:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5);

    local titleLB = thisUI:getChildByName("title")
    local title = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide,MainValue.infosManager:getObjMultilingualByKey("Common_BuyGoldTitle"))
    title:setPosition(titleLB:getPositionX(),titleLB:getPositionY())
    thisUI:addChild(title)
    titleLB:removeFromParent(true);
    
    local cashPanel = thisUI:getChildByName("cashBar");
    local cashNumber = cashPanel:getChildByName("cashNumber");
    local cashPic = FacFont:getFontsBmp(FontType.FontWhite,MainValue.dataManager.userManager:getCash());
--    cashPic:setScale(0.8)
    cashPic:setPosition(-5, 3)
    cashNumber:addChild(cashPic);
--    local shopDes = thisUI:getChildByName("shopDes");
--    local shopDesc = FacFont:getFontsBmp(FontType.FontRed,"All purchases are in US Dollars");
--    shopDesc:setPosition(shopDes:getPosition())
--    thisUI:addChild(shopDesc)
--    shopDes:removeFromParent(true);
    
    local storeCellClz = require("ui.storeUI.StoreCell");
    for i in pairs(storeConfig.cash) do
        local cell = storeCellClz.create(thisUI.disapperAlone,thisUI);
        cell:init(storeConfig.cash[i]);
        cell:setPosition(0,(cell:getContentSize().height + 17)*(i-1) - 330);
        thisUI:addChild(cell,1);
        thisUI.cellList[i] = cell;
    end

    local closeBtn = tolua.cast(thisUI:getChildByName("CloseBtn"), "ccui.Button")
    closeBtn:getParent():removeChild(closeBtn)
    thisUI:addChild(closeBtn,2)
    
    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            if thisUI.isAloneShow then
                thisUI:disapperAlone();
            else
                thisUI:disapper();
            end
        end
    end

    closeBtn:addTouchEventListener(touchEvent);
    
    
    thisUI.updataCash = function()
        cashPic:setText(MainValue.dataManager.userManager:getCash());     
    end
    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_CASH, thisUI.updataCash);
    
    return thisUI;
end






function StoreUI:appear()
    self.isAloneShow = false
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disapper);
    if MainValue.mxUIManager.topbar ~= nil  then
        MainValue.mxUIManager.topbar:visible(false);
    end;
end

function StoreUI:appearAlone()
    self.isAloneShow = true
    MainValue.mxUIManager.panelManager:addPanelAlone(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disapperAlone);
    if MainValue.mxUIManager.topbar ~= nil  then
        MainValue.mxUIManager.topbar:visible(false);
    end;
end

function StoreUI:appearComplete()

end

function StoreUI:disapper()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_DOWN , self.disapperComplete)
     if MainValue.mxUIManager.topbar ~= nil  then
         MainValue.mxUIManager.topbar:visible(true);
    end;
end

function StoreUI:disapperAlone()
    MainValue.mxUIManager.panelManager:removePanelAlone(self,PanelDisappearType.LEAVE_DOWN , self.disapperComplete)
     if MainValue.mxUIManager.topbar ~= nil  then
        MainValue.mxUIManager.topbar:visible(true);
    end;
end


function StoreUI:disapperComplete()
    self:clear();
    self:removeFromParent(true);
  
    if BuyFlowValue.outBuyAry~=nil and table.maxn(BuyFlowValue.outBuyAry) == 3 then -- 说明是前置道具的购买流程
    
          table.remove(BuyFlowValue.outBuyAry,3)
          
          
        local isBuyItem = require("ui/inGame/IsBuyItemPanel");
          local isBuyItemPanel = isBuyItem.create(BuyFlowValue.outBuyAry[2]:getGoodsId())
          isBuyItemPanel:appear();
        table.remove(BuyFlowValue.outBuyAry,2)
        
        self.needBackOtherPanel = true;
    end
    
  

    if BuyFlowValue.buyLifeAry ~= nil and table.maxn(BuyFlowValue.buyLifeAry) == 3 then
        table.remove(BuyFlowValue.buyLifeAry,3)
        local notEnoughLifes = require("ui/NotEnoughLife")
        local notEnoughLife = notEnoughLifes.create()
        notEnoughLife:appearAlone()                  
                           
        self.needBackOtherPanel = true;
    end
    
    if BuyFlowValue.buyLifeTopAry ~= nil and table.maxn(BuyFlowValue.buyLifeTopAry) == 2 then
        table.remove(BuyFlowValue.buyLifeTopAry,2)
        local notEnoughLifes = require("ui/NotEnoughLife")
        local notEnoughLife = notEnoughLifes.create()
        notEnoughLife:appearAlone()       
                   
        self.needBackOtherPanel = true;
    end

    -- 买游戏内道具购买cash成功
    if BuyFlowValue.innerBuyAry ~= nil and table.maxn(BuyFlowValue.innerBuyAry) == 2 then
        table.remove(BuyFlowValue.innerBuyAry,2)
        local isBuyItem = require("ui/inGame/IsBuyItemPanel");
        local isBuyItemPanel = isBuyItem.create(BuyFlowValue.innerBuyAry[1]:getGoodsId())
        isBuyItemPanel:appear();
        
        self.needBackOtherPanel = true;
    end        
    
    
  
          
    if BuyFlowValue.buyStepsAry ~= nil and table.maxn(BuyFlowValue.buyStepsAry) == 2 then
        table.remove(BuyFlowValue.buyStepsAry,2)

        local notReachClz = require("ui/inGame/InGameFailedPanel")
        self.failedPanel = notReachClz.create();
        self.failedPanel:setData(BuyFlowValue.buyStepsAry[1]:getFailData());
        self.failedPanel:appear();
        
        self.needBackOtherPanel = true;
    end
    
    if self.needBackOtherPanel == false and MainValue.dataManager.adManager:getStoreShow() ~= 1 then
        MainValue.dataManager.adManager:setStoreShow()
        
--        MainValue.mxUIManager.mapUI:openADPanel("MapIcon");
        
        local adPanelCls = require("ui/advertisement/ADPanel");
        local adPanel = adPanelCls.create("BuyLifesMent");
        adPanel:appearAlone();
    end
    
end

function StoreUI:clear()
    for i in pairs(self.cellList) do
       self.cellList[i]:GC();
   end
    MainValue.eventDispatcher:removeEventListener(MainValue.eventDispatcher.eventType.EVENT_CASH, self.updataCash);
end

return StoreUI   