require "engine.uigridtools.NineGridTools"

TaskCell = class("TaskCell", function()
    return ccui.Layout:create();
end);

function TaskCell:ctor()
    self.rankData = nil;
    self.path = "ui/prop/big/";
end

function TaskCell.create(rankData)
    local cell = TaskCell.new();
    cell.rankData = rankData;
    cell:init();
    return cell;
end

function TaskCell:init()
   
    --背景
    self.cellBg = NineGridTools.create("ui/ui/bgCell2.png",454, 130, 27)
    self.cellBg:setPosition(0,0)
    self:addChild(self.cellBg,0)
    
    --奖励文字
    local rewardlable = FacFont:getFontsBmp(FontType.FontYellowWhiteSide, MainValue.infosManager:getObjMultilingualByKey("Common_taskReward"));
    rewardlable:setPosition(-185,55);
    self:addChild(rewardlable);
    
    --奖励道具
    local rewardsProp = self.rankData.rewardsProp;
    for dataI = 1, #rewardsProp do
        local prop = self:creatItemNode(rewardsProp[dataI][1],rewardsProp[dataI][2]);
        prop:setPosition((dataI-1)*80 -130,30)
        self:addChild(prop);
    end
    
    --领取按钮
    if self:checkCanGet() then
        self.getNode = cc.Node:create();
        self.getNode:setContentSize(100,75);
        self.getNode:setPosition(150,20);
        self:addChild(self.getNode);

        self.getBtn = ccui.Button:create();
        self.getBtn:loadTextures("res/home/btnBlue1.png", "res/home/btnBlue2.png")
        self.getBtn:setScale(0.7)
        self.getNode:addChild(self.getBtn)
        local getlable = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, MainValue.infosManager:getObjMultilingualByKey("Common_BoxlockBtnlockName"));
        getlable:setScale(0.7)
        self.getNode:addChild(getlable)
        
        
        local function btnGetTouchEvent( sender, eventType )
            if eventType == ccui.TouchEventType.began then
            elseif eventType == ccui.TouchEventType.ended then
                MainValue.actionManager:createJellyAction():run(self.getNode,40);

                --todo
            end
        end
        self.getBtn:addTouchEventListener(btnGetTouchEvent)
    end
    
    
    --条件
    local conditionlable = FacFont:getFontsBmp(FontType.FontYellowWhiteSide, self.rankData.condition,440,"L");
    conditionlable:setPosition(5,-30);
    self:addChild(conditionlable);
    
end
--检查条件
function TaskCell:checkCanGet()
    local ret = false;
    
    if self.rankData.type == 1 then
        ret = self:checkType1()
    elseif self.rankData.type == 2 then
        ret = self:checkType2()
    elseif self.rankData.type == 3 then
        ret = self:checkType3()
    end
    
    return ret;
end
function TaskCell:checkType1()
    local ret = false;
    
    if MainValue.dataManager.taskManager:getLevel() >= self.rankData.level then
        ret = true;
    end
    
    return ret;
end
function TaskCell:checkType2()
    local ret = false;
    
    if MainValue.dataManager.taskManager:getStar() >= self.rankData.star then
        ret = true;
    end
    
    return ret;
end
function TaskCell:checkType3()
    local ret = true;
    
    for var=1, #self.rankData.prop do
        local propID = self.rankData.prop[var][1];
        local needPropCount = self.rankData.prop[var][2];
    
        if needPropCount > MainValue.dataManager.taskManager:getAllUsePorpDataByID(propID) then
    	   ret = false;
    	   break;
    	end
    end
    
    return ret;
end


function TaskCell:creatItemNode(itemId,itemNum)
    local itemNode = cc.Node:create();

    --itemIcon
    local itemPath = self.path..itemId..".png";
    local itemIcon = cc.Sprite:create(itemPath);
    itemIcon:setScale(0.6)
    itemNode:addChild(itemIcon);

    --itemNum
    local itemNumS = itemNum;
    local itemNumTxt = FacFont:getFontsBmp(FontType.FontWhite, itemNumS, 100, "R");
    itemNumTxt:setScale(0.8);
    itemNumTxt:setPosition(0,-20);
    itemNode:addChild(itemNumTxt);

    itemNode:setContentSize(itemIcon:getContentSize().width,itemIcon:getContentSize().height);

    return itemNode;
end


return TaskCell;