require "ui.task.TaskCell"
require "config.taskConfig"

local TaskPanel = class("TaskPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/TaskPanel.json");
end);

function TaskPanel:ctor()

end

function TaskPanel.create()

    local taskPanel = TaskPanel.new()
    taskPanel:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);


    local closebtn = taskPanel:getChildByName("btnClose");
    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType )
        if eventType == ccui.TouchEventType.began then
        elseif eventType == ccui.TouchEventType.ended then

            if taskPanel.flag == 1 then
                MainValue.mxUIManager.mapManager:getMap():upDateMission(MainValue.SELECTED_LEVEL)
            end
            taskPanel:disAppear();
        end
    end
    closebtn:addTouchEventListener(touchEvent);

    --title文本替换
    local newTitle = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, MainValue.infosManager:getObjMultilingualByKey("Common_taskTitle"));
    newTitle:setPosition(0,390);
    taskPanel:addChild(newTitle);
    
    --星星数量
    local curAllStar = MainValue.dataManager.levelManager:getMaxStar();
    local allStar = MainValue.mxUIManager.mapManager:getMaxLevel() * 3;
    local starS = curAllStar.."/"..allStar;
    local starNumS = FacFont:getFontsBmp(FontType.FontBigBrown, starS);
    starNumS:setPosition(-95,293);
    starNumS:setScale(0.7)
    taskPanel:addChild(starNumS);
    
    --关卡
    local currentlevel = MainValue.dataManager.levelManager:getMaxLevel()-1;
    local levelS = MainValue.infosManager:getObjMultilingualByKey("Common_LevelLable")..currentlevel;
    local levelLable = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, levelS);
    levelLable:setPosition(180,293);
    taskPanel:addChild(levelLable);
    
    --任务列表
    local taskConfiglen = #taskConfig.task;
    
    taskPanel.listView = ccui.ScrollView:create();
    taskPanel.listView:setPosition(-240, -363);
    taskPanel.listView:setContentSize(cc.size(480, 626))   
    taskPanel.listView:setBounceEnabled(false);
    local innerHeight = 130*taskConfiglen
    taskPanel.listView:setInnerContainerSize(cc.size(454, innerHeight))
    taskPanel:addChild(taskPanel.listView);
   
    for dataI = 1, taskConfiglen do
        local cell = TaskCell.create(taskConfig.task[dataI]);
        cell:setPosition(240, taskPanel.listView:getInnerContainerSize().height-80-((dataI-1)*130))
        taskPanel.listView:addChild(cell);
    end
    
    

    return taskPanel;
end


function TaskPanel:init()
end


function TaskPanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.POP_UP, self.appearComplete);
end

function TaskPanel:disAppear()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.POP_UNDER , self.disAppearComplete)
end

function TaskPanel:appearComplete()
end

function TaskPanel:disAppearComplete()
    self:removeFromParent(true)
end

return TaskPanel