ThreeStar = class("ThreeStar", function()
    return cc.Node:create();
end);

function ThreeStar:ctor()
    self.curStar = 1;
    self.oldNum = 0;--历史最好成绩
    self.playNum = 0;--本次成绩

    self.starList = nil;
    self.coinList = nil;

    self.timerId = nil;

    self.TYPE_WIN = 1;
    self.TYPE_START = 2;
    self.ITERVAL_TIME = 0.2;--动画间隔时间
end

function ThreeStar.create(playType, awardData)
    local _threeStar = ThreeStar.new();
    
    _threeStar.m_playType = playType;
    _threeStar.m_awardData = awardData;
    
    _threeStar:init();
    
    return _threeStar;
end

function ThreeStar:init()

    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/star/star.ExportJson")

    self.starList = {};
    for i = 1,3 do
        local starBg = cc.Sprite:createWithSpriteFrameName("ui/ui/bgStar.png");
        starBg:setPosition(58 + (i - 1) * 152, 134 - (i % 2) * 20)
        starBg:setRotation((i - 2) * 15)
        local scaleNum = ((i % 2) * 0.84  > 0) and  (i % 2) * 0.84 or 1;
        starBg:setScale(scaleNum)
        self:addChild(starBg)
        
        local armature = ccs.Armature:create("star")
        armature:setPosition(56 + (i - 1) * 152, 136 - (i % 2) * 20)
        armature:setRotation((i - 2) * 15)
        local scaleNum = ((i % 2) * 1  > 0) and  (i % 2) * 1 or 1.24;
        armature:setScale(scaleNum)
        self:addChild(armature)
        table.insert(self.starList, armature)
    end
    
--    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/winCoin/winCoin.ExportJson")

--    self.coinList = {};
--    for i = 1,3 do
--        local armature = ccs.Armature:create("winCoin")
--        armature:setPosition(88 + (i - 1) * 130, -10)
--        
--        if self.m_awardData[i].coin > 0 then
--            self:addChild(armature);
--            table.insert(self.coinList, armature)
--        end
--        
--        
--        local coinNum = FacFont:getFontsBmp(FontType.FontYellowRedSide, tostring(self.m_awardData[i].coin))
--        local coinLayer = cc.Layer:create();
--        coinNum:setPositionX(5);
--        coinNum:setScale(0.9)
--        coinLayer:addChild(coinNum);
--        armature:getBone("20"):addDisplay(coinLayer, 0)
        
--        local function animationEvent(armatureBack,movementType,movementID)
--            local id = movementID
--            if movementType == ccs.MovementEventType.complete then
--                if id == "2" then
--                    for aniI, arm in ipairs( self.coinList) do
--                        if arm == armatureBack then
--                             --------增加金币
--                        end
--                    end
--                end
--            end
--        end
--
--        armature:getAnimation():setMovementEventCallFunc(animationEvent)
--    end
end

--[[oldNum:历史星星数， playNum：本次星星数]]--
function ThreeStar:setData(oldNum, playNum)
    self.oldNum = oldNum or 0;
    self.playNum = playNum or 0;
    
    --已获得金币奖励半透显示
    if self.m_playType == self.TYPE_WIN then 
--        for i = 1, self.oldNum do
--            if self.coinList[i] ~= nil then
--                self.coinList[i]:getAnimation():playWithIndex("2");
--                self.coinList[i]:setOpacity(400);--设置半透
--            end
--        end
    elseif self.m_playType == self.TYPE_START then 
        for j = 1, self.oldNum do
--            self.starList[j]:getAnimation():playWithIndex("1");

            local starIcon = cc.Sprite:createWithSpriteFrameName("ui/ui/iconStarL.png");
            starIcon:setPosition(56 + (j - 1) * 152, 138 - (j % 2) * 20)
            starIcon:setRotation((j - 2) * 15)
            local scaleNum = ((j % 2) * 0.84  > 0) and  (j % 2) * 0.84 or 1;
            starIcon:setScale(scaleNum)
            self:addChild(starIcon)
            
--            if self.coinList[i] ~= nil then
--                self.coinList[j]:getAnimation():playWithIndex("2");
--                self.coinList[j]:setOpacity(400);
--            end
        end
        return;
    end
    --
    
    local delayTime = 0;
    local function update(dt)
        delayTime =  delayTime + dt;

        if self.curStar <= 3 then 
            if delayTime > self.ITERVAL_TIME then 
                self:playActionMotion();
                delayTime = 0;
            end
        else
            delayTime = 0;
            self.curStar = 1;
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.timerId)
        end
    end
    
    self.timerId = cc.Director:getInstance():getScheduler():scheduleScriptFunc(update, 0, false)
end

--[[播放星星和金币动画]]
function ThreeStar:playActionMotion()
    
    if self.m_playType == self.TYPE_WIN then
        if self.curStar <= self.playNum then
            self.starList[self.curStar]:getAnimation():playWithIndex("0");
            
--            if self.curStar > self.oldNum and  self.coinList[self.curStar] ~= nil then
--                self.coinList[self.curStar]:getAnimation():playWithIndex("1");
--                MainValue.dataManager.userManager:addCash(self.m_awardData[self.curStar].coin);
--            end
        end
    end
    
    self.curStar = self.curStar + 1;
end

function ThreeStar:GC()
    cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.timerId)
    
    for i, armatureI in pairs(self.starList) do
        armatureI:cleanup();
    end
    self.starList = nil;
    
--    for j, armatureJ in pairs(self.coinList) do
--        armatureJ:cleanup();
--    end
--    self.coinList = nil;
    
    self.curStar = 1;
    
    self:removeFromParent();
end

return ThreeStar
