--require("engine.uigridtools.ThreeLMRGridTools")
--require("engine.uigridtools.NineGridTools")
require "tools.UtilHelp"

local TopBar = class("TopBar", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/TopBar.json");
end);

function TopBar:ctor()
    self.layerCash =  nil
    self.layerHeart = nil;
    
    self.btnAddCash = nil;
    self.btnAddHeart = nil;
    self.btnAddHeartBg =nil;
    
    self.textCoin =nil
    self.textCash =nil
    self.textHeart = nil;
    self.textTime = nil;
    
    self.curLifeNum = 0;
    self.maxLifeNum = 5;
    
    self.leftTime = 0;--剩余倒计时时间
    self.delayTime = 0;--倒计时经过时间
    
    self.timerId = nil;--心跳标识
    
    self.notEnoughLife = nil;
    self.needUpdate = false; --是否需要更新买心面板
    
    self.TIMER_LEFT = 1800;--恢复一颗心的时间
end

function TopBar.create()
    local temp = TopBar.new()
    temp:init();
    return temp;
end

function TopBar:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height);
    
    self.layerCash =  self:getChildByName("PanelCoins");
    self.layerHeart = self:getChildByName("PanelHeart");

    self.btnAddCash = ccui.Helper:seekWidgetByName(self.layerCash, "btnCoinBg")
    self.btnAddHeart = ccui.Helper:seekWidgetByName(self.layerHeart, "BtnPlus")
    self.btnAddHeartBg = ccui.Helper:seekWidgetByName(self.layerHeart, "btnHeartBg")


--    local function updataCoin()
--        local labelCoinTxt = ccui.Helper:seekWidgetByName(self.layerCoin, "LabelTxt")
--
--        if self.textCoin == nil then
--            self.textCoin = FacFont:getFontsBmp(FontType.FontWhiteBoldNum, MainValue.dataManager.userManager:getCoin());
--            self.textCoin:setPosition(labelCoinTxt:getPosition());     
--            self.layerCoin:addChild(self.textCoin);                
--
--        else
--            self.textCoin:setText(MainValue.dataManager.userManager:getCoin())  
--        end
--    end
    
    local function updataCash()
        local labelCashTxt = ccui.Helper:seekWidgetByName(self.layerCash, "LabelTxt")
        if self.textCash == nil then
            self.textCash = FacFont:getFontsBmp(FontType.FontYellowRedSide, MainValue.dataManager.userManager:getCash());
            self.layerCash:addChild(self.textCash);
        else
            self.textCash:setText(MainValue.dataManager.userManager:getCash())  
        end
        self.textCash:setScale(0.87)
        self.textCash:setPosition(labelCashTxt:getPositionX(), labelCashTxt:getPositionY() + 13);         
    end
    
   
    self:addHeart(); --退出后重新进入游戏，计算恢复体力数量
    
    local function updataHeart()
        self:updateHeartInfo();
    end

--    updataCoin();
    updataCash();
    self:updateHeartInfo();
    
    --更新数据
--    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_COIN, updataCoin);
    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_CASH, updataCash);
    MainValue.eventDispatcher:addEventListener(MainValue.eventDispatcher.eventType.EVENT_HEART, updataHeart);
    --MainValue.dataManager:registerCallBack(updataCoin,MainValue.dataManager.eventType.EVENT_COIN)
    --MainValue.dataManager:registerCallBack(updataCash,MainValue.dataManager.eventType.EVENT_CASH)
    --MainValue.dataManager:registerCallBack(updaHeart,MainValue.dataManager.eventType.EVENT_HEART)

    -- touchEvent 触摸事件回调方法
    local function btnCloseHandler( sender, eventType )
        local index = 0;

        if sender == self.btnAddCash then
            index = 2;
        elseif sender == self.btnAddHeartBg then
            index = 3;
        end
        if eventType == ccui.TouchEventType.began then
        --cclog("点击开始")
        elseif eventType == ccui.TouchEventType.moved then
        --cclog("移动")
        elseif eventType == ccui.TouchEventType.ended then
            --cclog("点击结束")
            
            if MainValue.mxUIManager.mapManager:getIsTouch() then
                self:showUI(index);
            end
              
        end
    end

    self.btnAddCash:addTouchEventListener(btnCloseHandler)
    self.btnAddHeartBg:addTouchEventListener(btnCloseHandler)
end

--更新体力以及倒计时等信息
function TopBar:updateHeartInfo()
    self:updataHeartTxt();
    self:updataTimeTxt();
    

    local function onTimerRunHandler(dt)
        self.delayTime =  self.delayTime + dt;
        self.leftTime = math.floor(self.TIMER_LEFT - self.delayTime);

        self:updataTimeTxt();

        if self.leftTime <= 0 then
            MainValue.dataManager.userManager:addHeart(1);--加心
            self.textHeart:setText(MainValue.dataManager.userManager:getHeart());
            self.delayTime = 0;
        end
    end

    if self.curLifeNum < self.maxLifeNum then
        if self.timerId == nil then
            self.timerId = cc.Director:getInstance():getScheduler():scheduleScriptFunc(onTimerRunHandler, 0, false)
        end
        
        self.btnAddHeartBg:setTouchEnabled(true);
        self.btnAddHeart:setBright(true);
    else
        if self.timerId ~= nil then
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.timerId)
            self.timerId = nil;
        end

        self.delayTime = 0;
        self.btnAddHeartBg:setTouchEnabled(false);
        self.btnAddHeart:setBright(false);
    end
end

--[[更新体力数量]]--
function TopBar:updataHeartTxt()
    self.curLifeNum = MainValue.dataManager.userManager:getHeart();

    if self.textHeart == nil then
        self.textHeart = FacFont:getFontsBmp(FontType.FontWhiteBoldNum, tostring(self.curLifeNum));
        self.layerHeart:addChild(self.textHeart);

    else
        self.textHeart:setText(MainValue.dataManager.userManager:getHeart())     
    end
    self.textHeart:setPosition(-91, 7);      
    
    
    ------如何买心界面打开，则更新买心界面-------
    if self.needUpdate then
        self.notEnoughLife:updataHeart();
    end
end

--[[更新倒计时时间]]--
function TopBar:updataTimeTxt()
    local labelHeartTxt = ccui.Helper:seekWidgetByName(self.layerHeart, "LabelTxt")
    if self.textTime == nil then
        self.textTime = FacFont:getFontsBmp(FontType.FontYellowRedSide, self:getShowTxt());
        self.layerHeart:addChild(self.textTime);
    else
        self.textTime:setText(self:getShowTxt())    
    end 
    self.textTime:setScale(0.87)
    self.textTime:setPosition(labelHeartTxt:getPositionX() - 4, labelHeartTxt:getPositionY()+13 );
end

--[[获取当前倒计时应该显示信息]]--
function TopBar:getShowTxt()
    if self.curLifeNum < self.maxLifeNum then
        return UtilHelp:formatTime(self.leftTime, false);
    elseif self.curLifeNum == self.maxLifeNum then
        return MainValue.infosManager:getObjMultilingualByKey("Common_FullLife");
    else
        return tostring(self.curLifeNum .. "/" .. self.maxLifeNum);
    end
end

--[[进入后台或退出游戏超过回复体力时间，更新体力]]--
function TopBar:addHeart()
    local timeStamp = MainValue.dataManager.expandManager:getEnergyTime();
    if timeStamp ~= nil then
        local nowTime = os.time();
        self.delayTime = nowTime - timeStamp;

        if self.delayTime >= self.TIMER_LEFT then
            -------获取保存的时间戳------
            local timeStamp = MainValue.dataManager.expandManager:getEnergyTime();

            --------增加心处理-----
            self.curLifeNum = MainValue.dataManager.userManager:getHeart();
            local addHeartNum = math.floor(self.delayTime / self.TIMER_LEFT);
            
            if self.curLifeNum + addHeartNum >= 5 then
                addHeartNum = 5 - self.curLifeNum;
            end
            MainValue.dataManager.userManager:addHeart(addHeartNum);

            -------增加心后重新保存时间戳-----
            MainValue.dataManager.expandManager:setEnergyTime(timeStamp + addHeartNum *  self.TIMER_LEFT);

            -------重新计算剩余时间-------
            timeStamp = MainValue.dataManager.expandManager:getEnergyTime();
            local nowTime = os.time();
            self.delayTime = nowTime - timeStamp;
        end 
    end
end

--[[从后台切回游戏]]--
function TopBar:gameEnterBack()
    self:addHeart();
end

function TopBar:showUI(index)
    if index == 1 then
        local notEnoughCoins = require("ui.storeUI.StoreUI")
        local notEnoughCoin = notEnoughCoins.create()
        notEnoughCoin:appear(false);

    elseif index == 2 then
        local notEnoughCashClz = require("ui.storeUI.StoreUI")
        local notEnoughCash = notEnoughCashClz.create();
        notEnoughCash:appearAlone();

    elseif index == 3 then
        if BuyFlowValue.buyLifeTopAry == nil or table.maxn(BuyFlowValue.buyLifeTopAry) == 0 then
            BuyFlowValue.buyLifeTopAry = {};
            
            local tmpBuyLifeData = BuyFlowData.new(BuyFlowValue.storeUI)            
            BuyFlowValue.buyLifeTopAry[1] = tmpBuyLifeData                                            
        end
    
        local notEnoughLifes = require("ui/NotEnoughLife")
        self.notEnoughLife = notEnoughLifes.create()
        self.notEnoughLife:appearAlone()
    end
end

--[[是否需要更新买新面板]]
function TopBar:setNeedUpdate(boo)
    self.needUpdate = boo;
end

--
function TopBar:visible(isShow)
    if MainValue.mxUIManager.state == 0 and isShow then --游戏内部不显示topbar
        return;
    end
    
    self:setVisible(isShow)
end

-------阿宝专用
function TopBar:getFullTime()
    if self.curLifeNum >= self.maxLifeNum then 
        return 0;
    else
        local fullTime = self.leftTime + (self.maxLifeNum - self.curLifeNum - 1) * self.TIMER_LEFT;
        return fullTime;
    end
end

return TopBar