require "platform.FBSharedType";

local WinAheadOfAnotherPanel = class("WinAheadOfAnotherPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/WinAheadOfAnother.json")
end)

function WinAheadOfAnotherPanel:ctor()
    self.continueBtn = nil;
    
    self.armature = nil;
    self.checkBox = nil;
    
    self.friHeadIcon = nil;
    self.myHeadIcon = nil;
    
    self.userId = nil;
    self.picture = nil;
    self.friId = nil;
    self.friPicture = nil;
    
    self.titleLable = nil;
    
    self.friData = nil;
end

function WinAheadOfAnotherPanel.create(friData)
    local layer = WinAheadOfAnotherPanel.new()
    layer:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height * 1.5)
    
    layer.friData = friData;
    layer:init();

    return layer
end

function WinAheadOfAnotherPanel:init()
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/Balloon2/Balloon2.ExportJson")

    self.armature = ccs.Armature:create("Balloon2");
    --    self.armature:setPositionY(503);
    self:addChild(self.armature)
    
    
    self.titleLable = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, "You Passed A Friend")
    self:addChild(self.titleLable)
    self.titleLable:setPositionY(MainValue.winSize.height / 2 - 137)
    
    self.continueBtn = self:getChildByName("ContinueBtn");
    self.continueBtn:setPositionY(-MainValue.winSize.height / 2 + 155);
    local btnText = FacFont:getFontsBmp(FontType.FontWhite, "Continue");
    self.continueBtn:addChild(btnText)
    btnText:setPosition(155, 60)

    -- touchEvent 触摸事件回调方法
    local function touchEvent( sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(sender,40);
            self:closePanel();
        end
    end
    self.continueBtn:addTouchEventListener(touchEvent)

    local desText = FacFont:getFontsBmp(FontType.FontRed, "Share with your friends!")
    self:addChild(desText)
    desText:setPosition(35, -MainValue.winSize.height / 2 + 77)
    
    self.checkBox  = self:getChildByName("CheckBox");
    self.checkBox:setPosition(-230, -MainValue.winSize.height / 2 + 65);
    self.checkBox:setSelected(true);
    
    ------load好友头像----
    local function friHeadFunc(id, url)
        cclog("id = "..id.." url = "..url);
        self.friHeadIcon:release();
    end
    
    if MainValue.fbManager:getIsLogin() then
        self.friId = self.friData.id
        self.friPicture = self.friData.picture
    else
        self.friId = "1423774147"
        self.friPicture = 'https://fbcdn-profile-a.akamaihd.net/hprofile-ak-xfa1/v/t1.0-1/c51.47.388.388/s100x100/302720_111435122294985_462937390_n.jpg?oh=ae71638d21da401ce743c4b63973cbcb&oe=550BE802&__gda__=1423774147_34b939227517bda679019c05b70534fb';
    end
    
    self.friHeadIcon = cc.Sprite:create();
    self.friHeadIcon:setContentSize(51,56);
    self.friHeadIcon:retain();
    MainValue.platformManager:FBloadImage(self.friId, self.friPicture, self.friHeadIcon, friHeadFunc);
    
    local friIconLayer = cc.Layer:create()    
    friIconLayer:addChild(self.friHeadIcon)
    self.armature:getBone("3"):addDisplay(friIconLayer, 0);
    
    ------load自己头像----
    local function myHeadFunc(id, url)
        cclog("id = "..id.." url = "..url);
        self.myHeadIcon:release();
    end
    
    if MainValue.fbManager:getIsLogin() then
        self.userId = MainValue.dataManager.userManager:getPID()
        self.picture = MainValue.dataManager.userManager:getPicture()
    else
        self.userId = "1508293926112547"
        self.picture = "https://fbcdn-profile-a.akamaihd.net/hprofile-ak-xfa1/v/t1.0-1/c22.0.100.100/p100x100/10574420_1445441729064434_8819031542387145715_n.jpg?oh=ac4277ec999d7c9b7c69a1dade357ad2&oe=5510BAC8&__gda__=1430616702_c4ceaeed368ee8ead67fc1cb70cc9480";
    end
    
    self.myHeadIcon = cc.Sprite:create();
    self.myHeadIcon:setContentSize(51,56);
    self.myHeadIcon:retain();
    MainValue.platformManager:FBloadImage(self.userId, self.picture, self.myHeadIcon, myHeadFunc)
    
    local myLayer = cc.Layer:create()    
    myLayer:addChild(self.myHeadIcon)
    self.armature:getBone("6"):addDisplay(myLayer, 0);
end

function WinAheadOfAnotherPanel:closePanel()
    self:disappear();
end

function WinAheadOfAnotherPanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.COME_DOWN, self.appearComplete,self.disappear);
end

function WinAheadOfAnotherPanel:appearComplete()
    self.armature:getAnimation():playWithIndex(0)
end

function WinAheadOfAnotherPanel:disappear()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.LEAVE_DOWN , self.closeComplete)
end

function WinAheadOfAnotherPanel:closeComplete()
    if self.checkBox:isSelected() then
        MainValue.fbManager:FBsharedDialog(FBSharedType.PASS_FRIEND_PROGRESS);
    end
    
    self:removeFromParent(true)
    
    MainValue.mxGameManager.gameStatusManager:setShowPanelCount(1);
end

return WinAheadOfAnotherPanel