require "platform.FBSharedType";

local WinRankUpPanel = class("WinRankUpPanel", function()
    return ccs.GUIReader:getInstance():widgetFromJsonFile("ui/WinRankUp.json")
end)

function WinRankUpPanel:ctor()
    self.bgLayer = nil;
    
    self.titleLab = nil;
    
    self.checkBox = nil;
    
    self.friHeadIcon = nil;
    self.myHeadIcon = nil;

    self.userId = nil;
    self.picture = nil;
    self.friId = nil;
    self.friPicture = nil;
    
    self.friData = nil;
end

function WinRankUpPanel.create(friData)
    local layer = WinRankUpPanel.new();
    
    layer.friData = friData;
    layer:init();
    return layer
end

function WinRankUpPanel:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);
    self:setOpacity(0);
    
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("armature/Balloon1/Balloon1.ExportJson")
    self.armature = ccs.Armature:create("Balloon1");
    self.armature:setVisible(false);
    self.armature:setPositionY(15);
    self:addChild(self.armature);
    
    self.titleLab = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, "Rank Up")
    self:addChild(self.titleLab)
    self.titleLab:setPositionY(MainValue.winSize.height / 2 - 107)
    
    local continueBtn = self:getChildByName("ContinueBtn")
    continueBtn:setPositionY(-MainValue.winSize.height / 2 + 155);
    local conLabel = FacFont:getFontsBmp(FontType.FontWhite, "Continue")
    continueBtn:addChild(conLabel)
    conLabel:setPosition(155, 60)

    -- touchEvent 触摸事件回调方法
    local function onContinue( sender, eventType )
       if eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(sender,40);
            self:closePanel();
        end
    end
    continueBtn:addTouchEventListener(onContinue)

    local shareLB = FacFont:getFontsBmp(FontType.FontRed, "Share with your friends!")
    self:addChild(shareLB)
    shareLB:setPosition(31, -MainValue.winSize.height / 2 + 77)
    
    self.checkBox  = self:getChildByName("CheckBox");
    self.checkBox:setPosition(-230, -MainValue.winSize.height / 2 + 65);
    self.checkBox:setSelected(true);
    
    local function animationEvent(armatureBack,movementType,movementID)
        local id = movementID
        if movementType == ccs.MovementEventType.complete then
            if id == "1" then
                self.armature:getAnimation():playWithIndex(1);
                
            elseif id == "3" then
                self.armature:cleanup();
                self.armature:removeFromParent(true);
                self:disappear();
            end
        end
    end
    
    self.armature:getAnimation():setMovementEventCallFunc( animationEvent)
    
    ------load好友头像----
    local function friHeadFunc(id, url)
        cclog("id = "..id.." url = "..url);
        self.friHeadIcon:release();
    end

    if MainValue.fbManager:getIsLogin() then
        self.friId = self.friData.id
        self.friPicture = self.friData.picture
    else
        self.friId = "1423774147"
        self.friPicture = 'https://fbcdn-profile-a.akamaihd.net/hprofile-ak-xfa1/v/t1.0-1/c51.47.388.388/s100x100/302720_111435122294985_462937390_n.jpg?oh=ae71638d21da401ce743c4b63973cbcb&oe=550BE802&__gda__=1423774147_34b939227517bda679019c05b70534fb';
    end

    self.friHeadIcon = cc.Sprite:create();
    self.friHeadIcon:setContentSize(60,60);
    self.friHeadIcon:retain();
    MainValue.platformManager:FBloadImage(self.friId, self.friPicture, self.friHeadIcon, friHeadFunc)
    
    local friIconLayer = cc.Layer:create()    
    friIconLayer:addChild(self.friHeadIcon)
    self.armature:getBone("3"):addDisplay(friIconLayer, 0);

    ------load自己头像----
    local function myHeadFunc(id, url)
        cclog("id = "..id.." url = "..url);
        self.myHeadIcon:release();
    end
    
    if MainValue.fbManager:getIsLogin() then
        self.userId = MainValue.dataManager.userManager:getPID()
        self.picture = MainValue.dataManager.userManager:getPicture()
    else
        self.userId = "1508293926112547"
        self.picture = "https://fbcdn-profile-a.akamaihd.net/hprofile-ak-xfa1/v/t1.0-1/c22.0.100.100/p100x100/10574420_1445441729064434_8819031542387145715_n.jpg?oh=ac4277ec999d7c9b7c69a1dade357ad2&oe=5510BAC8&__gda__=1430616702_c4ceaeed368ee8ead67fc1cb70cc9480";
    end

    self.myHeadIcon = cc.Sprite:create();
    self.myHeadIcon:setContentSize(60,60);
    self.myHeadIcon:retain();
    MainValue.platformManager:FBloadImage(self.userId, self.picture, self.myHeadIcon, myHeadFunc)

    local myLayer = cc.Layer:create()    
    myLayer:addChild(self.myHeadIcon)
    self.armature:getBone("6"):addDisplay(myLayer, 0);
end

function WinRankUpPanel:closePanel()
    self.armature:cleanup();
    self.armature:removeFromParent(true);
    self:disappear();
end

function WinRankUpPanel:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.FADE_IN, self.appearComplete,self.disappear);
end

function WinRankUpPanel:appearComplete()
    self.armature:setVisible(true);
    self.armature:getAnimation():playWithIndex(0)
end

function WinRankUpPanel:disappear()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.FADE_OUT , self.disappearComplete)
end

function WinRankUpPanel:disappearComplete()

    if self.checkBox:isSelected() then
        MainValue.fbManager:passFriendScore(FBSharedType.PASS_FRIEND_SCORE, MainValue.SELECTED_LEVEL);
    end
    
    self:removeFromParent(true)
    
    MainValue.mxGameManager.gameStatusManager:setShowPanelCount(1);
end

return WinRankUpPanel