require "engine.uigridtools.SpecialGridTools"
require "ui.threeStar.ThreeStar"
require "ui.panelManager.PanelManager"
require "ui.playGamePanel.PlayGamePanel"
require "ui.friendRank.FriendRankPanel"

WinSettlement = class("WinSettlement", function()
    return cc.Node:create();
end);

function WinSettlement:ctor()
    self.desBg = nil;

    self.panelStar = nil;
    self.threeStar = nil;

    self.level = nil;

    self.title = nil;
    self.newScoreLab = nil;
    self.bestScoreLab = nil;
    self.newNumLab = nil;
    self.bestNumLab = nil;

    self.btnContinue = nil;
    self.btnShare = nil;
    
    self.conLabel = nil;
    self.shareLabel = nil;

    self.bestScore = nil;--历史最好分数

    self.starNum = nil;--本次获得星星数
    self.oldStarNum = nil;--历史最好获得星星数

    self.isContinue = nil;
    
    self.shareType = -1;--分享信息类型
    
    self.rankPanel = nil;
    
    self.maxFriData = nil;--超越最大关卡好友信息
    self.scoreFriData = nil;--超越最高分数好友信息
    
    self.needShowNext = false;
    self.showPanelCount = 0;
    
    self.upPanel = nil;

    --[[对应关配置数据]]
    self.curLvData = nil;
    
    self.callBack = nil; --连接facebook融合数据后回调
end

function WinSettlement.create()
    local winSettlement = WinSettlement.new()
    winSettlement:init();
    return winSettlement;
end

function WinSettlement:init()
    self:setPosition(MainValue.winSize.width / 2, MainValue.winSize.height / 2);

    self.upPanel = ccs.GUIReader:getInstance():widgetFromJsonFile("ui/WinSettlement.json");
    self.upPanel:setPositionY(MainValue.winSize.height / 2);
    self:addChild(self.upPanel);

    local btnClose = self.upPanel:getChildByName("BtnClose");

    local function btnCloseHandler( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            self:onClose();
        end
    end
    btnClose:addTouchEventListener(btnCloseHandler);

    self.title = FacFont:getFontsBmp(FontType.FontBigYellowLightShadeSide, "19");
    self.title:setPosition(3, 360);
    self.upPanel:addChild(self.title);

    self.panelStar = self.upPanel:getChildByName("PanelStar");

    local panelScore = self.upPanel:getChildByName("PanelScore");

    self.desBg = SpecialGridTools.create("ui/ui/bgCooky.png",430,180,26)
    self.desBg:setPosition(230, 77)
    panelScore:addProtectedChild(self.desBg,0)

    self.newNumLab = FacFont:getFontsBmp(FontType.FontBigBrown, "9999999",380,"C");
    self.newNumLab:setPosition(226, 114);
    panelScore:addChild(self.newNumLab);

    self.bestNumLab = FacFont:getFontsBmp(FontType.FontYellowWhiteSide, "9999999",380,"C");
    self.bestNumLab:setPosition(228, 64);
    panelScore:addChild(self.bestNumLab);

    self.btnContinue = self.upPanel:getChildByName("BtnContinue");
    self.conLabel = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("Common_confirm"));
    self.conLabel:setPosition(126, 60);
    self.btnContinue:addChild(self.conLabel);
    
    self.btnShare = self.upPanel:getChildByName("BtnShare");
    self.shareLabel = FacFont:getFontsBmp(FontType.FontWhite, MainValue.infosManager:getObjMultilingualByKey("Win_settlement_button_3"));
    self.shareLabel:setPosition(136, 60);
    
    self.btnShare:addChild(self.shareLabel);
    
    if not MainValue.fbManager:getIsLogin() then
        self.btnContinue:setPosition(0, -240);
        self.btnShare:setVisible(false);
    end

    local function continueHanlder( sender, eventType )
        if eventType == ccui.TouchEventType.ended then
            MainValue.actionManager:createJellyAction():run(sender,40);
            self.isContinue = true;
            self:onClose();
        end
    end
    self.btnContinue:addTouchEventListener(continueHanlder)
    
    local function shareHandler( sender, eventType )
    	if eventType == ccui.TouchEventType.ended then
       		MainValue.actionManager:createJellyAction():run(sender,40);
--            MainValue.fbManager:reachNewLevel(self.shareType, self.level);

           
--            self.shareType = FBSharedType.MORE_STARS; --得到更多的星星
--            self.shareType = FBSharedType.MORE_SCORE; --新纪录
--            self.shareType = FBSharedType.REACH_NEW_LEVEL; 

            MainValue.fbManager:reachNewLevel(self.shareType, self.level);
            self.isContinue = true;
            self:onClose();
    	end
    end
    
    
    self.fbIconImg = cc.Sprite:createWithSpriteFrameName("iconFBR.png");
    self.fbIconImg:setScale(0.8)
    
    self.fbIconImg:setPosition(40, 57);
    self.btnShare:addChild(self.fbIconImg);
    self.btnShare:addTouchEventListener(shareHandler)
    
    self.rankPanel = FriendRankPanel.create();
    self:addChild(self.rankPanel);
end

--[[
level 胜利关卡; score  本次胜利分数;  bestScore 历史最好分数;  star 本关关卡数据
]]
function WinSettlement:setData(level, score, star, oldScore ,oldStars)
    self.level = level;

    self.bestScore  = oldScore;
    self.oldStarNum = oldStars;
    self.starNum = star;
    
    if MainValue.fbManager:getIsLogin() then
        self.maxFriData = MainValue.dataManager.friendManager:getBeyondMaxlvFriData(level);
        self.scoreFriData = MainValue.dataManager.friendManager:getBeyondScoreFriData(level, self.bestScore, score);
    end
    
    
    local levelS = MainValue.infosManager:getObjMultilingualByKey("Common_level")
    levelS = string.gsub(levelS, "%b{}", level)
    self.title:setText(levelS);

    if score > self.bestScore then
        if self.bestScore ~= 0 then
            if self.starNum > self.oldStarNum then
                self.shareType = FBSharedType.MORE_STARS; --得到更多的星星
            else
                self.shareType = FBSharedType.MORE_SCORE; --新纪录
            end
        else
            self.shareType = FBSharedType.REACH_NEW_LEVEL;
            
            self.needShowNext = true;
            
            if  not MainValue.fbManager:getIsLogin() and math.fmod(self.level, 5) == 0 then
                self.showFBLogin = true;
            end
        end
        
        self.bestScore = score;
    else
        self.btnContinue:setPosition(0, -240);
        self.btnShare:setVisible(false);    
    end
    
    self.newNumLab:setText(tostring(score));
    
    
    local bestScores = MainValue.infosManager:getObjMultilingualByKey("Common_BestScore")
    bestScores = string.gsub(bestScores, "%b{}", self.bestScore)
    self.bestNumLab:setText(bestScores);
    
    self.threeStar = ThreeStar.create(1)
    self.threeStar:setPositionY(-7);
    self.panelStar:addChild(self.threeStar)
    
    self.rankPanel:setData(level);
    
end

--[[获取分数对应星星数,以及是否奖励体力]]
function WinSettlement:getStarNum(score)
    local len = table.getn(self.curLvData)

    for i = len, 1, -1 do
        if score > self.curLvData[i].score then
            return self.curLvData[i].star;
        end
    end
    
    return 0,0;
end

function WinSettlement:appear()
    MainValue.mxUIManager.panelManager:addPanel(self, PanelAppearType.NONE, self.appearComplete, self.disappear);
end

function WinSettlement:appearComplete()
    local winSizeHeight = MainValue.winSize.height / 2;

    local function action2(node)
        node:stopAllActions() --After this stop next action not working, if remove this stop everything is working

        local ac3 = nil;
        ac3 = cc.Sequence:create(cc.EaseOut:create(cc.MoveBy:create(0.1,cc.p(0, 10)), 0.3));
        node:runAction(ac3);
    end

    local ac = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.2,cc.p(0, - winSizeHeight - 10)), 0.3), cc.CallFunc:create(action2));
    self.upPanel:runAction(ac);

    self.rankPanel:appear();
    
    self.threeStar:setData(self.oldStarNum, self.starNum)
end

function WinSettlement:onClose()
    local function callFun()
        self:disappear();
    end
    local winSizeHeight = MainValue.winSize.height;
    local disAc1 = cc.Sequence:create(cc.EaseIn:create(cc.MoveBy:create(0.15,cc.p(0, winSizeHeight)), 0.8),cc.CallFunc:create(callFun));
    self.upPanel:runAction(disAc1);
    
    if self.needShowNext then
        MainValue.mxUIManager.mapManager:setDeltaPosY(); --地图上头像在移动到下一关卡前向上偏移一点
    end

    self.rankPanel:disappear();
end

function WinSettlement:disappear()
    MainValue.mxUIManager.panelManager:removePanel(PanelDisappearType.NONE , self.disAppearComplete)
end

function WinSettlement:disAppearComplete()

    ---------------------------------------
    --过第七关第一次显示图片广告，之后每胜利五次显示一次广告
    if self.level == advertising:getPlacement("Settlement").minLV and self.needShowNext then
        MainValue.dataManager.adManager:popAdvertisement("Settlement");
    elseif MainValue.dataManager.levelManager:getMaxLevel() > advertising:getPlacement("Settlement").minLV then
        MainValue.dataManager.adManager:setWinCountForAD();
        
        if MainValue.dataManager.adManager:getWinCountForAD() == 5 then
            MainValue.dataManager.adManager:popAdvertisement("Settlement");
        end
    end
    ----------------------------------------

    if self.threeStar ~= nil then
        self.threeStar:GC();
    end
    self.desBg:removeFromParent(true)

    if self.needShowNext then
        self:checkNextPanel();
        
    elseif self.isContinue then
        
        if MainValue.SELECTED_LEVEL + 1 > MainValue.mxUIManager.mapManager:getMaxLevel() then
            return;
        end
    
        
        local playGamePanel2 = PlayGamePanel.create(MainValue.SELECTED_LEVEL + 1);
        playGamePanel2:appear();
        
        self.isContinue = false;
    end
    
    if self.starNum > self.oldStarNum then
        MainValue.mxUIManager.mapManager:updateMissionStar(self.level);
    end
    
    self:removeFromParent(true)
end

--[[检验胜利面板后是否显示其他面板]]
function WinSettlement:checkNextPanel()

    if self.maxFriData ~= nil then 
        local WinAheadOfAnotherCls = require("ui/winAheadOfAnother/WinAheadOfAnotherPanel")
        local WinAheadOfAnother = WinAheadOfAnotherCls.create(self.maxFriData);
        WinAheadOfAnother:appear();
        
        self.showPanelCount = self.showPanelCount + 1;
    end
    
    if self.scoreFriData ~= nil then
        local winkRankUpCls = require("ui/winRankUp/WinRankUpPanel")
        local winkRankUp = winkRankUpCls.create(self.scoreFriData);
        winkRankUp:appear();
        
        self.showPanelCount = self.showPanelCount + 1;
    end
    
    if self.showFBLogin == true then
        local loginClz = require("src/ui/FBConnect/FBLoginPanel")
        local loginPanel = loginClz.create("notLives");
        loginPanel:appearAlone();
        
        self.showPanelCount = self.showPanelCount + 1;
    end
    
    if self.showPanelCount == 0 then
        MainValue.mxGameManager.gameStatusManager:setShowPanelCount(0); --直接进入下一关
    else
        MainValue.mxGameManager.gameStatusManager:setShowPanelCount(self.showPanelCount, true);
    end
    
    self.showPanelCount = 0;
    self.needShowNext = false;
end

return WinSettlement